#include "precomp.h"
extern double exp (double __x ) __attribute__ ((__nothrow__ ) ) ; 
extern int __isinf (double __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
extern int __isnan (double __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
extern int __isinff (float __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
extern int __isnanf (float __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
extern int __isinfl (long double __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
extern int __isnanl (long double __value ) __attribute__ ((__nothrow__ ) ) __attribute__ ((__const__ ) ) ; 
enum {
  FP_NAN , FP_INFINITE , FP_ZERO , FP_SUBNORMAL , FP_NORMAL }
; 
typedef enum {
  _IEEE_ = - 1 , _SVID_ , _XOPEN_ , _POSIX_ , _ISOC_ }
_LIB_VERSION_TYPE ; 
struct exception {
  int type ; 
  char * name ; 
  double arg1 ; 
  double arg2 ; 
  double retval ; 
}
; 
static Scheme_Object * eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * zero_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * positive_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * negative_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_max (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_min (int argc , Scheme_Object * argv [] ) ; 
void scheme_init_numcomp (Scheme_Env * env ) {
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM1_COUNT (2)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  p = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (eq , "=" , 2 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("=" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (lt , "<" , 2 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("<" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (gt , ">" , 2 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant (">" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (lt_eq , "<=" , 2 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("<=" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (gt_eq , ">=" , 2 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant (">=" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (zero_p , "zero?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 16384 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("zero?" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (positive_p , "positive?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 16384 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("positive?" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (negative_p , "negative?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 16384 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("negative?" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (sch_max , "max" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_add_global_constant ("max" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (sch_min , "min" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= 1024 ; 
  FUNCCALL_EMPTY(scheme_add_global_constant ("min" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * force_rat (Scheme_Object * n , Small_Rational * sr ) ; 
static inline Scheme_Object * force_rat (Scheme_Object * n , Small_Rational * sr ) {
  Scheme_Type t = ((((long ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ; 
  if (t == scheme_rational_type )
    return n ; 
  else return scheme_make_small_bn_rational (n , sr ) ; 
}
static Scheme_Object * eq (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * eq__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {
  Scheme_Object * o ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM2_COUNT (3)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM8_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM2(x)
    o = argv [i ] ; 
    if (! ((((long ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) ) {
#     define XfOrM12_COUNT (0+XfOrM8_COUNT)
#     define SETUP_XfOrM12(x) SETUP_XfOrM8(x)
      FUNCCALL_EMPTY(scheme_wrong_type ("=" , "number" , i , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! FUNCCALL(SETUP_XfOrM8(_), scheme_bin_eq (p , o ) )) {
#     define XfOrM9_COUNT (0+XfOrM8_COUNT)
#     define SETUP_XfOrM9(x) SETUP_XfOrM8(x)
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM11_COUNT (0+XfOrM9_COUNT)
#       define SETUP_XfOrM11(x) SETUP_XfOrM9(x)
        if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) <= scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_type ("=" , "number" , i , argc , argv ) ); 
      }
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    p = o ; 
  }
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * eq__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */
  return (scheme_bin_eq (a , b ) ? scheme_true : scheme_false ) ; 
}
Scheme_Object * eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * p , * p2 ; 
  p = argv [0 ] ; 
  if (! ((((long ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) <= scheme_complex_type ) ) ) )
    scheme_wrong_type ("=" , "number" , 0 , argc , argv ) ; 
  if (argc == 2 ) {
    p2 = argv [1 ] ; 
    if (! ((((long ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) <= scheme_complex_type ) ) ) )
      scheme_wrong_type ("=" , "number" , 1 , argc , argv ) ; 
    return eq__bin (p , p2 ) ; 
  }
  else return eq__slow (p , argc , argv ) ; 
}
static Scheme_Object * lt (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * lt__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {
  Scheme_Object * o ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM16_COUNT (3)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM22_COUNT (0+XfOrM16_COUNT)
#   define SETUP_XfOrM22(x) SETUP_XfOrM16(x)
    o = argv [i ] ; 
    if (! ((((long ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM26_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM26(x) SETUP_XfOrM22(x)
      FUNCCALL_EMPTY(scheme_wrong_type ("<" , "real number" , i , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! FUNCCALL(SETUP_XfOrM22(_), scheme_bin_lt (p , o ) )) {
#     define XfOrM23_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM23(x) SETUP_XfOrM22(x)
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM25_COUNT (0+XfOrM23_COUNT)
#       define SETUP_XfOrM25(x) SETUP_XfOrM23(x)
        if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_type ("<" , "real number" , i , argc , argv ) ); 
      }
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    p = o ; 
  }
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * lt__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */
  return (scheme_bin_lt (a , b ) ? scheme_true : scheme_false ) ; 
}
Scheme_Object * lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * p , * p2 ; 
  p = argv [0 ] ; 
  if (! ((((long ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )
    scheme_wrong_type ("<" , "real number" , 0 , argc , argv ) ; 
  if (argc == 2 ) {
    p2 = argv [1 ] ; 
    if (! ((((long ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )
      scheme_wrong_type ("<" , "real number" , 1 , argc , argv ) ; 
    return lt__bin (p , p2 ) ; 
  }
  else return lt__slow (p , argc , argv ) ; 
}
static Scheme_Object * gt (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * gt__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {
  Scheme_Object * o ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM30_COUNT (3)
# define SETUP_XfOrM30(x) SETUP(XfOrM30_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM36_COUNT (0+XfOrM30_COUNT)
#   define SETUP_XfOrM36(x) SETUP_XfOrM30(x)
    o = argv [i ] ; 
    if (! ((((long ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM40_COUNT (0+XfOrM36_COUNT)
#     define SETUP_XfOrM40(x) SETUP_XfOrM36(x)
      FUNCCALL_EMPTY(scheme_wrong_type (">" , "real number" , i , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! FUNCCALL(SETUP_XfOrM36(_), scheme_bin_gt (p , o ) )) {
#     define XfOrM37_COUNT (0+XfOrM36_COUNT)
#     define SETUP_XfOrM37(x) SETUP_XfOrM36(x)
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM39_COUNT (0+XfOrM37_COUNT)
#       define SETUP_XfOrM39(x) SETUP_XfOrM37(x)
        if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_type (">" , "real number" , i , argc , argv ) ); 
      }
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    p = o ; 
  }
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * gt__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */
  return (scheme_bin_gt (a , b ) ? scheme_true : scheme_false ) ; 
}
Scheme_Object * gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * p , * p2 ; 
  p = argv [0 ] ; 
  if (! ((((long ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )
    scheme_wrong_type (">" , "real number" , 0 , argc , argv ) ; 
  if (argc == 2 ) {
    p2 = argv [1 ] ; 
    if (! ((((long ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )
      scheme_wrong_type (">" , "real number" , 1 , argc , argv ) ; 
    return gt__bin (p , p2 ) ; 
  }
  else return gt__slow (p , argc , argv ) ; 
}
static Scheme_Object * lt_eq (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * lt_eq__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {
  Scheme_Object * o ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM44_COUNT (3)
# define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM50_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM44(x)
    o = argv [i ] ; 
    if (! ((((long ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM54_COUNT (0+XfOrM50_COUNT)
#     define SETUP_XfOrM54(x) SETUP_XfOrM50(x)
      FUNCCALL_EMPTY(scheme_wrong_type ("<=" , "real number" , i , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! FUNCCALL(SETUP_XfOrM50(_), scheme_bin_lt_eq (p , o ) )) {
#     define XfOrM51_COUNT (0+XfOrM50_COUNT)
#     define SETUP_XfOrM51(x) SETUP_XfOrM50(x)
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM53_COUNT (0+XfOrM51_COUNT)
#       define SETUP_XfOrM53(x) SETUP_XfOrM51(x)
        if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_type ("<=" , "real number" , i , argc , argv ) ); 
      }
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    p = o ; 
  }
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * lt_eq__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */
  return (scheme_bin_lt_eq (a , b ) ? scheme_true : scheme_false ) ; 
}
Scheme_Object * lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * p , * p2 ; 
  p = argv [0 ] ; 
  if (! ((((long ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )
    scheme_wrong_type ("<=" , "real number" , 0 , argc , argv ) ; 
  if (argc == 2 ) {
    p2 = argv [1 ] ; 
    if (! ((((long ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )
      scheme_wrong_type ("<=" , "real number" , 1 , argc , argv ) ; 
    return lt_eq__bin (p , p2 ) ; 
  }
  else return lt_eq__slow (p , argc , argv ) ; 
}
static Scheme_Object * gt_eq (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * gt_eq__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {
  Scheme_Object * o ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM58_COUNT (3)
# define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM64_COUNT (0+XfOrM58_COUNT)
#   define SETUP_XfOrM64(x) SETUP_XfOrM58(x)
    o = argv [i ] ; 
    if (! ((((long ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM68_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM68(x) SETUP_XfOrM64(x)
      FUNCCALL_EMPTY(scheme_wrong_type (">=" , "real number" , i , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! FUNCCALL(SETUP_XfOrM64(_), scheme_bin_gt_eq (p , o ) )) {
#     define XfOrM65_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM65(x) SETUP_XfOrM64(x)
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM67_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM67(x) SETUP_XfOrM65(x)
        if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_type (">=" , "real number" , i , argc , argv ) ); 
      }
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    p = o ; 
  }
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * gt_eq__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */
  return (scheme_bin_gt_eq (a , b ) ? scheme_true : scheme_false ) ; 
}
Scheme_Object * gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * p , * p2 ; 
  p = argv [0 ] ; 
  if (! ((((long ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )
    scheme_wrong_type (">=" , "real number" , 0 , argc , argv ) ; 
  if (argc == 2 ) {
    p2 = argv [1 ] ; 
    if (! ((((long ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )
      scheme_wrong_type (">=" , "real number" , 1 , argc , argv ) ; 
    return gt_eq__bin (p , p2 ) ; 
  }
  else return gt_eq__slow (p , argc , argv ) ; 
}
int scheme_bin_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static int scheme_bin_eq__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM72_COUNT (3)
# define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM72(_), scheme_wrong_type ("=" , "number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_eq ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}
static inline int scheme_bin_eq__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Rational sr1 ; 
  ; 
  ; 
  return scheme_rational_eq ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) ; 
}
static inline int scheme_bin_eq__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM75_COUNT (2)
# define SETUP_XfOrM75(x) SETUP(XfOrM75_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM75(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg12 = NULLED_OUT ; 
  Scheme_Object * __funcarg11 = NULLED_OUT ; 
  Scheme_Object * __funcarg10 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg10, 0), PUSH(n2, 1), PUSH(sr4.num, 2), PUSH(sr4.denom, 3)));
# define XfOrM76_COUNT (4)
# define SETUP_XfOrM76(x) SETUP(XfOrM76_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg10 = (__funcarg12 = FUNCCALL(SETUP_XfOrM76(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg12 , & sr4 ) )) , __funcarg11 = FUNCCALL(SETUP_XfOrM76(_), scheme_integer_to_rational (n2 ) ), (scheme_rational_eq (__funcarg10 , __funcarg11 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg14 = NULLED_OUT ; 
  Scheme_Object * __funcarg13 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM77_COUNT (3)
# define SETUP_XfOrM77(x) SETUP(XfOrM77_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (d1 == 0.0 )
    RET_VALUE_START ((scheme_is_inexact (n2 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg13 = (__funcarg14 = FUNCCALL(SETUP_XfOrM77(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg14 , & sr5 ) )) , (scheme_rational_eq (__funcarg13 , (n2 ) ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM78_COUNT (2)
# define SETUP_XfOrM78(x) SETUP(XfOrM78_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM78(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_eq ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}
static inline int scheme_bin_eq__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg17 = NULLED_OUT ; 
  Scheme_Object * __funcarg16 = NULLED_OUT ; 
  Scheme_Object * __funcarg15 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr7.num, 0), PUSH(sr7.denom, 1), PUSH(__funcarg15, 2)));
# define XfOrM80_COUNT (3)
# define SETUP_XfOrM80(x) SETUP(XfOrM80_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg15 = FUNCCALL(SETUP_XfOrM80(_), scheme_integer_to_rational (n1 ) ), __funcarg16 = (__funcarg17 = FUNCCALL(SETUP_XfOrM80(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg17 , & sr7 ) )) , (scheme_rational_eq (__funcarg15 , __funcarg16 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg18 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM81_COUNT (1)
# define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg18 = FUNCCALL(SETUP_XfOrM81(_), scheme_integer_to_rational (n1 ) ), (scheme_rational_eq (__funcarg18 , (n2 ) ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM82_COUNT (2)
# define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM82(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Rational sr8 ; 
  ; 
  ; 
  return scheme_rational_eq ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) ; 
}
static inline int scheme_bin_eq__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg20 = NULLED_OUT ; 
  Scheme_Object * __funcarg19 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr10.num, 0), PUSH(sr10.denom, 1), PUSH(n1, 2)));
# define XfOrM84_COUNT (3)
# define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (d2 == 0.0 )
    RET_VALUE_START ((scheme_is_inexact (n1 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg19 = (__funcarg20 = FUNCCALL(SETUP_XfOrM84(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg20 , & sr10 ) )) , (scheme_rational_eq ((n1 ) , __funcarg19 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg21 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM85_COUNT (1)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg21 = FUNCCALL(SETUP_XfOrM85(_), scheme_integer_to_rational (n2 ) ), (scheme_rational_eq ((n1 ) , __funcarg21 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM86_COUNT (2)
# define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM86(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM87_COUNT (2)
# define SETUP_XfOrM87(x) SETUP(XfOrM87_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM87(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM88_COUNT (2)
# define SETUP_XfOrM88(x) SETUP(XfOrM88_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  if ((sizeof ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) == sizeof (float ) ? __isnanf ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) : sizeof ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) == sizeof (double ) ? __isnan ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) : __isnanl ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM88(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM89_COUNT (2)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM89(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_eq__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM90_COUNT (2)
# define SETUP_XfOrM90(x) SETUP(XfOrM90_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM90(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_bin_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((((long ) (n1 ) ) >> 1 ) == (((long ) (n2 ) ) >> 1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      ; 
      return ((((long ) (n1 ) ) >> 1 ) == d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return scheme_bin_eq__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return scheme_bin_eq__int_rat (n1 , n2 ) ; 
    }
    if ((t2 == scheme_complex_type ) ) {
      return scheme_bin_eq__int_comp (n1 , n2 ) ; 
    }
    return scheme_bin_eq__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        ; 
        return (d1 == (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        ; 
        ; 
        return (d1 == d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return scheme_bin_eq__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return scheme_bin_eq__dbl_rat (d1 , n1 , n2 ) ; 
      }
      if ((t2 == scheme_complex_type ) ) {
        return scheme_bin_eq__dbl_comp (d1 , n1 , n2 ) ; 
      }
      return scheme_bin_eq__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_eq__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_eq__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_eq ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return scheme_bin_eq__big_rat (n1 , n2 ) ; 
      if ((t2 == scheme_complex_type ) ) {
        return scheme_bin_eq__big_comp (n1 , n2 ) ; 
      }
      return scheme_bin_eq__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_eq__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_eq__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bin_eq__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_eq ((n1 ) , (n2 ) ) ; 
      if ((t2 == scheme_complex_type ) ) {
        return scheme_bin_eq__rat_comp (n1 , n2 ) ; 
      }
      return scheme_bin_eq__wrong_type (n2 ) ; 
    }
    else if ((t1 == scheme_complex_type ) ) {
      if ((((long ) (n2 ) ) & 0x1 ) )
        return scheme_bin_eq__comp_int (n1 , n2 ) ; 
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_eq__comp_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bin_eq__comp_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_bin_eq__comp_rat (n1 , n2 ) ; 
      if ((t2 == scheme_complex_type ) )
        return scheme_complex_eq ((n1 ) , (n2 ) ) ; 
      return scheme_bin_eq__wrong_type (n2 ) ; 
    }
    else return scheme_bin_eq__wrong_type (n1 ) ; 
  }
}
int scheme_bin_lt (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static int scheme_bin_lt__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM114_COUNT (3)
# define SETUP_XfOrM114(x) SETUP(XfOrM114_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM114(_), scheme_wrong_type ("<" , "real number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_lt ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}
static inline int scheme_bin_lt__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM116_COUNT (2)
# define SETUP_XfOrM116(x) SETUP(XfOrM116_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM116(_), scheme_rational_lt ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg24 = NULLED_OUT ; 
  Scheme_Object * __funcarg23 = NULLED_OUT ; 
  Scheme_Object * __funcarg22 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(n2, 0), PUSH(sr4.num, 1), PUSH(sr4.denom, 2), PUSH(__funcarg22, 3)));
# define XfOrM117_COUNT (4)
# define SETUP_XfOrM117(x) SETUP(XfOrM117_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg22 = (__funcarg24 = FUNCCALL(SETUP_XfOrM117(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg24 , & sr4 ) )) , __funcarg23 = FUNCCALL(SETUP_XfOrM117(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_lt (__funcarg22 , __funcarg23 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg26 = NULLED_OUT ; 
  Scheme_Object * __funcarg25 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM118_COUNT (3)
# define SETUP_XfOrM118(x) SETUP(XfOrM118_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (d1 == 0.0 )
    RET_VALUE_START ((scheme_is_positive (n2 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg25 = (__funcarg26 = FUNCCALL(SETUP_XfOrM118(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg26 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_lt (__funcarg25 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_lt ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}
static inline int scheme_bin_lt__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg29 = NULLED_OUT ; 
  Scheme_Object * __funcarg28 = NULLED_OUT ; 
  Scheme_Object * __funcarg27 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg27, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM120_COUNT (3)
# define SETUP_XfOrM120(x) SETUP(XfOrM120_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg27 = FUNCCALL(SETUP_XfOrM120(_), scheme_integer_to_rational (n1 ) ), __funcarg28 = (__funcarg29 = FUNCCALL(SETUP_XfOrM120(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg29 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_lt (__funcarg27 , __funcarg28 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg30 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM121_COUNT (1)
# define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg30 = FUNCCALL(SETUP_XfOrM121(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_lt (__funcarg30 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM122_COUNT (2)
# define SETUP_XfOrM122(x) SETUP(XfOrM122_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM122(_), scheme_bin_lt ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM123_COUNT (2)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM123(_), scheme_rational_lt ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg32 = NULLED_OUT ; 
  Scheme_Object * __funcarg31 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr10.num, 0), PUSH(sr10.denom, 1), PUSH(n1, 2)));
# define XfOrM124_COUNT (3)
# define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (d2 == 0.0 )
    RET_VALUE_START ((scheme_is_negative (n1 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg31 = (__funcarg32 = FUNCCALL(SETUP_XfOrM124(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg32 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_lt ((n1 ) , __funcarg31 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg33 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM125_COUNT (1)
# define SETUP_XfOrM125(x) SETUP(XfOrM125_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg33 = FUNCCALL(SETUP_XfOrM125(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_lt ((n1 ) , __funcarg33 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_bin_lt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((((long ) (n1 ) ) >> 1 ) < (((long ) (n2 ) ) >> 1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      ; 
      return ((((long ) (n1 ) ) >> 1 ) < d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return scheme_bin_lt__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return scheme_bin_lt__int_rat (n1 , n2 ) ; 
    }
    return scheme_bin_lt__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        ; 
        return (d1 < (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        ; 
        ; 
        return (d1 < d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return scheme_bin_lt__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return scheme_bin_lt__dbl_rat (d1 , n1 , n2 ) ; 
      }
      return scheme_bin_lt__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_lt__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_lt__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_lt ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return scheme_bin_lt__big_rat (n1 , n2 ) ; 
      return scheme_bin_lt__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_lt__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_lt__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bin_lt__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_lt ((n1 ) , (n2 ) ) ; 
      return scheme_bin_lt__wrong_type (n2 ) ; 
    }
    else return scheme_bin_lt__wrong_type (n1 ) ; 
  }
}
int scheme_bin_gt (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static int scheme_bin_gt__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM143_COUNT (3)
# define SETUP_XfOrM143(x) SETUP(XfOrM143_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM143(_), scheme_wrong_type (">" , "real number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_gt ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}
static inline int scheme_bin_gt__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM145(_), scheme_rational_gt ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg36 = NULLED_OUT ; 
  Scheme_Object * __funcarg35 = NULLED_OUT ; 
  Scheme_Object * __funcarg34 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg34, 0), PUSH(n2, 1), PUSH(sr4.num, 2), PUSH(sr4.denom, 3)));
# define XfOrM146_COUNT (4)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg34 = (__funcarg36 = FUNCCALL(SETUP_XfOrM146(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg36 , & sr4 ) )) , __funcarg35 = FUNCCALL(SETUP_XfOrM146(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_gt (__funcarg34 , __funcarg35 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg38 = NULLED_OUT ; 
  Scheme_Object * __funcarg37 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM147_COUNT (3)
# define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (d1 == 0.0 )
    RET_VALUE_START ((scheme_is_negative (n2 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg37 = (__funcarg38 = FUNCCALL(SETUP_XfOrM147(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg38 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_gt (__funcarg37 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_gt ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}
static inline int scheme_bin_gt__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg41 = NULLED_OUT ; 
  Scheme_Object * __funcarg40 = NULLED_OUT ; 
  Scheme_Object * __funcarg39 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg39, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM149_COUNT (3)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg39 = FUNCCALL(SETUP_XfOrM149(_), scheme_integer_to_rational (n1 ) ), __funcarg40 = (__funcarg41 = FUNCCALL(SETUP_XfOrM149(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg41 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_gt (__funcarg39 , __funcarg40 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg42 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM150_COUNT (1)
# define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg42 = FUNCCALL(SETUP_XfOrM150(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_gt (__funcarg42 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM151_COUNT (2)
# define SETUP_XfOrM151(x) SETUP(XfOrM151_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM151(_), scheme_bin_gt ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM152_COUNT (2)
# define SETUP_XfOrM152(x) SETUP(XfOrM152_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM152(_), scheme_rational_gt ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg44 = NULLED_OUT ; 
  Scheme_Object * __funcarg43 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr10.num, 0), PUSH(sr10.denom, 1), PUSH(n1, 2)));
# define XfOrM153_COUNT (3)
# define SETUP_XfOrM153(x) SETUP(XfOrM153_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (d2 == 0.0 )
    RET_VALUE_START ((scheme_is_positive (n1 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg43 = (__funcarg44 = FUNCCALL(SETUP_XfOrM153(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg44 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_gt ((n1 ) , __funcarg43 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg45 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM154_COUNT (1)
# define SETUP_XfOrM154(x) SETUP(XfOrM154_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg45 = FUNCCALL(SETUP_XfOrM154(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_gt ((n1 ) , __funcarg45 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_bin_gt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((((long ) (n1 ) ) >> 1 ) > (((long ) (n2 ) ) >> 1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      ; 
      return ((((long ) (n1 ) ) >> 1 ) > d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return scheme_bin_gt__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return scheme_bin_gt__int_rat (n1 , n2 ) ; 
    }
    return scheme_bin_gt__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        ; 
        return (d1 > (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        ; 
        ; 
        return (d1 > d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return scheme_bin_gt__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return scheme_bin_gt__dbl_rat (d1 , n1 , n2 ) ; 
      }
      return scheme_bin_gt__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_gt__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_gt__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_gt ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return scheme_bin_gt__big_rat (n1 , n2 ) ; 
      return scheme_bin_gt__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_gt__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_gt__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bin_gt__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_gt ((n1 ) , (n2 ) ) ; 
      return scheme_bin_gt__wrong_type (n2 ) ; 
    }
    else return scheme_bin_gt__wrong_type (n1 ) ; 
  }
}
int scheme_bin_lt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static int scheme_bin_lt_eq__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM172_COUNT (3)
# define SETUP_XfOrM172(x) SETUP(XfOrM172_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM172(_), scheme_wrong_type ("<=" , "real number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_le ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}
static inline int scheme_bin_lt_eq__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM174_COUNT (2)
# define SETUP_XfOrM174(x) SETUP(XfOrM174_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM174(_), scheme_rational_le ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg48 = NULLED_OUT ; 
  Scheme_Object * __funcarg47 = NULLED_OUT ; 
  Scheme_Object * __funcarg46 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg46, 0), PUSH(n2, 1), PUSH(sr4.num, 2), PUSH(sr4.denom, 3)));
# define XfOrM175_COUNT (4)
# define SETUP_XfOrM175(x) SETUP(XfOrM175_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg46 = (__funcarg48 = FUNCCALL(SETUP_XfOrM175(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg48 , & sr4 ) )) , __funcarg47 = FUNCCALL(SETUP_XfOrM175(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_le (__funcarg46 , __funcarg47 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg50 = NULLED_OUT ; 
  Scheme_Object * __funcarg49 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM176_COUNT (3)
# define SETUP_XfOrM176(x) SETUP(XfOrM176_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (d1 == 0.0 )
    RET_VALUE_START ((scheme_is_positive (n2 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg49 = (__funcarg50 = FUNCCALL(SETUP_XfOrM176(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg50 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_le (__funcarg49 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_le ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}
static inline int scheme_bin_lt_eq__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg53 = NULLED_OUT ; 
  Scheme_Object * __funcarg52 = NULLED_OUT ; 
  Scheme_Object * __funcarg51 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr7.num, 0), PUSH(sr7.denom, 1), PUSH(__funcarg51, 2)));
# define XfOrM178_COUNT (3)
# define SETUP_XfOrM178(x) SETUP(XfOrM178_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg51 = FUNCCALL(SETUP_XfOrM178(_), scheme_integer_to_rational (n1 ) ), __funcarg52 = (__funcarg53 = FUNCCALL(SETUP_XfOrM178(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg53 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_le (__funcarg51 , __funcarg52 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg54 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM179_COUNT (1)
# define SETUP_XfOrM179(x) SETUP(XfOrM179_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg54 = FUNCCALL(SETUP_XfOrM179(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_le (__funcarg54 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM180_COUNT (2)
# define SETUP_XfOrM180(x) SETUP(XfOrM180_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM180(_), scheme_bin_lt_eq ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM181_COUNT (2)
# define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM181(_), scheme_rational_le ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg56 = NULLED_OUT ; 
  Scheme_Object * __funcarg55 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr10.num, 0), PUSH(sr10.denom, 1), PUSH(n1, 2)));
# define XfOrM182_COUNT (3)
# define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (d2 == 0.0 )
    RET_VALUE_START ((scheme_is_negative (n1 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg55 = (__funcarg56 = FUNCCALL(SETUP_XfOrM182(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg56 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_le ((n1 ) , __funcarg55 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_lt_eq__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg57 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM183_COUNT (1)
# define SETUP_XfOrM183(x) SETUP(XfOrM183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg57 = FUNCCALL(SETUP_XfOrM183(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_le ((n1 ) , __funcarg57 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_bin_lt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((((long ) (n1 ) ) >> 1 ) <= (((long ) (n2 ) ) >> 1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      ; 
      return ((((long ) (n1 ) ) >> 1 ) <= d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return scheme_bin_lt_eq__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return scheme_bin_lt_eq__int_rat (n1 , n2 ) ; 
    }
    return scheme_bin_lt_eq__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        ; 
        return (d1 <= (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        ; 
        ; 
        return (d1 <= d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return scheme_bin_lt_eq__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return scheme_bin_lt_eq__dbl_rat (d1 , n1 , n2 ) ; 
      }
      return scheme_bin_lt_eq__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_lt_eq__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_lt_eq__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_le ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return scheme_bin_lt_eq__big_rat (n1 , n2 ) ; 
      return scheme_bin_lt_eq__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_lt_eq__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_lt_eq__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bin_lt_eq__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_le ((n1 ) , (n2 ) ) ; 
      return scheme_bin_lt_eq__wrong_type (n2 ) ; 
    }
    else return scheme_bin_lt_eq__wrong_type (n1 ) ; 
  }
}
int scheme_bin_gt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static int scheme_bin_gt_eq__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM201_COUNT (3)
# define SETUP_XfOrM201(x) SETUP(XfOrM201_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM201(_), scheme_wrong_type (">=" , "real number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_ge ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}
static inline int scheme_bin_gt_eq__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM203_COUNT (2)
# define SETUP_XfOrM203(x) SETUP(XfOrM203_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM203(_), scheme_rational_ge ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg58, 0), PUSH(n2, 1), PUSH(sr4.num, 2), PUSH(sr4.denom, 3)));
# define XfOrM204_COUNT (4)
# define SETUP_XfOrM204(x) SETUP(XfOrM204_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg58 = (__funcarg60 = FUNCCALL(SETUP_XfOrM204(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg60 , & sr4 ) )) , __funcarg59 = FUNCCALL(SETUP_XfOrM204(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_ge (__funcarg58 , __funcarg59 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM205_COUNT (3)
# define SETUP_XfOrM205(x) SETUP(XfOrM205_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 > 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (((sizeof (d1 ) == sizeof (float ) ? __isinff (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isinf (d1 ) : __isinfl (d1 ) ) && (d1 < 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (d1 == 0.0 )
    RET_VALUE_START ((scheme_is_negative (n2 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg61 = (__funcarg62 = FUNCCALL(SETUP_XfOrM205(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg62 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_ge (__funcarg61 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Small_Bignum sb ; 
  ; 
  ; 
  return scheme_bignum_ge ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}
static inline int scheme_bin_gt_eq__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg63, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM207_COUNT (3)
# define SETUP_XfOrM207(x) SETUP(XfOrM207_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg63 = FUNCCALL(SETUP_XfOrM207(_), scheme_integer_to_rational (n1 ) ), __funcarg64 = (__funcarg65 = FUNCCALL(SETUP_XfOrM207(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg65 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_ge (__funcarg63 , __funcarg64 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM208_COUNT (1)
# define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg66 = FUNCCALL(SETUP_XfOrM208(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_ge (__funcarg66 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM209_COUNT (2)
# define SETUP_XfOrM209(x) SETUP(XfOrM209_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM209(_), scheme_bin_gt_eq ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM210_COUNT (2)
# define SETUP_XfOrM210(x) SETUP(XfOrM210_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM210(_), scheme_rational_ge ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  double d2 ; 
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr10.num, 0), PUSH(sr10.denom, 1), PUSH(n1, 2)));
# define XfOrM211_COUNT (3)
# define SETUP_XfOrM211(x) SETUP(XfOrM211_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 > 0 ) ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((sizeof (d2 ) == sizeof (float ) ? __isinff (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isinf (d2 ) : __isinfl (d2 ) ) && (d2 < 0 ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if (d2 == 0.0 )
    RET_VALUE_START ((scheme_is_positive (n1 ) ) ) RET_VALUE_END ; 
  RET_VALUE_START ((__funcarg67 = (__funcarg68 = FUNCCALL(SETUP_XfOrM211(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg68 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_ge ((n1 ) , __funcarg67 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline int scheme_bin_gt_eq__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM212_COUNT (1)
# define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg69 = FUNCCALL(SETUP_XfOrM212(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_ge ((n1 ) , __funcarg69 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_bin_gt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((((long ) (n1 ) ) >> 1 ) >= (((long ) (n2 ) ) >> 1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      ; 
      return ((((long ) (n1 ) ) >> 1 ) >= d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return scheme_bin_gt_eq__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return scheme_bin_gt_eq__int_rat (n1 , n2 ) ; 
    }
    return scheme_bin_gt_eq__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        ; 
        return (d1 >= (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        ; 
        ; 
        return (d1 >= d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return scheme_bin_gt_eq__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return scheme_bin_gt_eq__dbl_rat (d1 , n1 , n2 ) ; 
      }
      return scheme_bin_gt_eq__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_gt_eq__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_gt_eq__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_ge ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return scheme_bin_gt_eq__big_rat (n1 , n2 ) ; 
      return scheme_bin_gt_eq__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return scheme_bin_gt_eq__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return scheme_bin_gt_eq__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bin_gt_eq__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_ge ((n1 ) , (n2 ) ) ; 
      return scheme_bin_gt_eq__wrong_type (n2 ) ; 
    }
    else return scheme_bin_gt_eq__wrong_type (n1 ) ; 
  }
}
int scheme_is_zero (const Scheme_Object * o ) {
  /* No conversion */
  Scheme_Type t ; 
  if ((((long ) (o ) ) & 0x1 ) )
    return o == ((Scheme_Object * ) (void * ) (long ) ((((long ) (0 ) ) << 1 ) | 0x1 ) ) ; 
  t = ((o ) -> type ) ; 
  if (t == scheme_double_type ) {
    return (((Scheme_Double * ) (o ) ) -> double_val ) == 0.0 ; 
  }
  if (t == scheme_complex_type ) {
    if (scheme_is_zero (scheme_complex_imaginary_part (o ) ) )
      return scheme_is_zero (scheme_complex_real_part (o ) ) ; 
    return 0 ; 
  }
  if ((t >= scheme_bignum_type ) && (t <= scheme_complex_type ) )
    return 0 ; 
  return - 1 ; 
}
Scheme_Object * zero_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  int v ; 
  v = scheme_is_zero (argv [0 ] ) ; 
  if (v < 0 ) {
    scheme_wrong_type ("zero?" , "real number" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return (v ? scheme_true : scheme_false ) ; 
}
int scheme_is_positive (const Scheme_Object * o ) {
  /* No conversion */
  Scheme_Type t ; 
  if ((((long ) (o ) ) & 0x1 ) )
    return (((long ) (o ) ) >> 1 ) > 0 ; 
  t = ((o ) -> type ) ; 
  if (t == scheme_double_type ) {
    double d = (((Scheme_Double * ) (o ) ) -> double_val ) ; 
    return d > 0 ; 
  }
  if (t == scheme_bignum_type )
    return ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  if (t == scheme_rational_type )
    return scheme_is_rational_positive (o ) ; 
  return - 1 ; 
}
Scheme_Object * positive_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  int v ; 
  v = scheme_is_positive (argv [0 ] ) ; 
  if (v < 0 ) {
    scheme_wrong_type ("positive?" , "real number" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return (v ? scheme_true : scheme_false ) ; 
}
int scheme_is_negative (const Scheme_Object * o ) {
  /* No conversion */
  Scheme_Type t ; 
  if ((((long ) (o ) ) & 0x1 ) )
    return (((long ) (o ) ) >> 1 ) < 0 ; 
  t = ((o ) -> type ) ; 
  if (t == scheme_double_type ) {
    double d = (((Scheme_Double * ) (o ) ) -> double_val ) ; 
    return d < 0 ; 
  }
  if (t == scheme_bignum_type )
    return ! ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  if (t == scheme_rational_type )
    return ! scheme_is_rational_positive (o ) ; 
  return - 1 ; 
}
Scheme_Object * negative_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  int v ; 
  v = scheme_is_negative (argv [0 ] ) ; 
  if (v < 0 ) {
    scheme_wrong_type ("negative?" , "real number" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return (v ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * bin_max (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static Scheme_Object * bin_max__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM243_COUNT (3)
# define SETUP_XfOrM243(x) SETUP(XfOrM243_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM243(_), scheme_wrong_type ("max" , "number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM244_COUNT (1)
# define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM244(_), scheme_bignum_max ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM245_COUNT (2)
# define SETUP_XfOrM245(x) SETUP(XfOrM245_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM245(_), scheme_rational_max ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM246_COUNT (2)
# define SETUP_XfOrM246(x) SETUP(XfOrM246_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM246(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((d1 > scheme_bignum_to_double (n2 ) ) ? d1 : scheme_bignum_to_double (n2 ) ) ; 
}
static inline Scheme_Object * bin_max__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((d1 > scheme_rational_to_double (n2 ) ) ? d1 : scheme_rational_to_double (n2 ) ) ; 
}
static inline Scheme_Object * bin_max__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM249_COUNT (2)
# define SETUP_XfOrM249(x) SETUP(XfOrM249_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM249(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM250_COUNT (1)
# define SETUP_XfOrM250(x) SETUP(XfOrM250_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM250(_), scheme_bignum_max ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  double d2 ; 
  ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((scheme_bignum_to_double (n1 ) > d2 ) ? scheme_bignum_to_double (n1 ) : d2 ) ; 
}
static inline Scheme_Object * bin_max__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM252_COUNT (1)
# define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg72 = FUNCCALL(SETUP_XfOrM252(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_max (__funcarg72 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM253_COUNT (2)
# define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM253(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM254_COUNT (2)
# define SETUP_XfOrM254(x) SETUP(XfOrM254_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM254(_), scheme_rational_max ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  double d2 ; 
  ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((scheme_rational_to_double (n1 ) > d2 ) ? scheme_rational_to_double (n1 ) : d2 ) ; 
}
static inline Scheme_Object * bin_max__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM256_COUNT (1)
# define SETUP_XfOrM256(x) SETUP(XfOrM256_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg73 = FUNCCALL(SETUP_XfOrM256(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_max ((n1 ) , __funcarg73 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM257_COUNT (2)
# define SETUP_XfOrM257(x) SETUP(XfOrM257_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM257(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM258_COUNT (2)
# define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM258(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM259_COUNT (2)
# define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  if ((sizeof ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) == sizeof (float ) ? __isnanf ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) : sizeof ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) == sizeof (double ) ? __isnan ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) : __isnanl ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) ) )
    RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM259(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM260_COUNT (2)
# define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM260(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_max__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM261_COUNT (2)
# define SETUP_XfOrM261(x) SETUP(XfOrM261_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM261(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * bin_max (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((Scheme_Object * ) (void * ) (long ) ((((long ) (((((long ) (n1 ) ) >> 1 ) > (((long ) (n2 ) ) >> 1 ) ) ? (((long ) (n1 ) ) >> 1 ) : (((long ) (n2 ) ) >> 1 ) ) ) << 1 ) | 0x1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      if ((sizeof (d ) == sizeof (float ) ? __isnanf (d ) : sizeof (d ) == sizeof (double ) ? __isnan (d ) : __isnanl (d ) ) )
        return scheme_nan_object ; 
      return scheme_make_double (((((long ) (n1 ) ) >> 1 ) > d ) ? (((long ) (n1 ) ) >> 1 ) : d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return bin_max__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return bin_max__int_rat (n1 , n2 ) ; 
    }
    if ((t2 == scheme_complex_type ) ) {
      return bin_max__int_comp (n1 , n2 ) ; 
    }
    return bin_max__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
          return scheme_nan_object ; 
        return scheme_make_double ((d1 > (((long ) (n2 ) ) >> 1 ) ) ? d1 : (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
          return scheme_nan_object ; 
        if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
          return scheme_nan_object ; 
        return scheme_make_double ((d1 > d2 ) ? d1 : d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return bin_max__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return bin_max__dbl_rat (d1 , n1 , n2 ) ; 
      }
      if ((t2 == scheme_complex_type ) ) {
        return bin_max__dbl_comp (d1 , n1 , n2 ) ; 
      }
      return bin_max__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return bin_max__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return bin_max__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_max ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return bin_max__big_rat (n1 , n2 ) ; 
      if ((t2 == scheme_complex_type ) ) {
        return bin_max__big_comp (n1 , n2 ) ; 
      }
      return bin_max__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return bin_max__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return bin_max__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return bin_max__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_max ((n1 ) , (n2 ) ) ; 
      if ((t2 == scheme_complex_type ) ) {
        return bin_max__rat_comp (n1 , n2 ) ; 
      }
      return bin_max__wrong_type (n2 ) ; 
    }
    else if ((t1 == scheme_complex_type ) ) {
      if ((((long ) (n2 ) ) & 0x1 ) )
        return bin_max__comp_int (n1 , n2 ) ; 
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return bin_max__comp_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return bin_max__comp_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return bin_max__comp_rat (n1 , n2 ) ; 
      if ((t2 == scheme_complex_type ) )
        return bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) ; 
      return bin_max__wrong_type (n2 ) ; 
    }
    else return bin_max__wrong_type (n1 ) ; 
  }
}
static Scheme_Object * bin_min (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 
static Scheme_Object * bin_min__wrong_type (const Scheme_Object * v ) {
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM285_COUNT (3)
# define SETUP_XfOrM285(x) SETUP(XfOrM285_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM285(_), scheme_wrong_type ("min" , "number" , - 1 , 0 , a ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM286_COUNT (1)
# define SETUP_XfOrM286(x) SETUP(XfOrM286_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM286(_), scheme_bignum_min ((scheme_make_small_bignum ((((long ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM287_COUNT (2)
# define SETUP_XfOrM287(x) SETUP(XfOrM287_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM287(_), scheme_rational_min ((scheme_make_small_rational ((((long ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM288_COUNT (2)
# define SETUP_XfOrM288(x) SETUP(XfOrM288_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM288(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((d1 < scheme_bignum_to_double (n2 ) ) ? d1 : scheme_bignum_to_double (n2 ) ) ; 
}
static inline Scheme_Object * bin_min__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((d1 < scheme_rational_to_double (n2 ) ) ? d1 : scheme_rational_to_double (n2 ) ) ; 
}
static inline Scheme_Object * bin_min__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM291_COUNT (2)
# define SETUP_XfOrM291(x) SETUP(XfOrM291_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
    RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM291(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM292_COUNT (1)
# define SETUP_XfOrM292(x) SETUP(XfOrM292_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM292(_), scheme_bignum_min ((n1 ) , (scheme_make_small_bignum ((((long ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  double d2 ; 
  ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((scheme_bignum_to_double (n1 ) < d2 ) ? scheme_bignum_to_double (n1 ) : d2 ) ; 
}
static inline Scheme_Object * bin_min__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM294_COUNT (1)
# define SETUP_XfOrM294(x) SETUP(XfOrM294_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg74 = FUNCCALL(SETUP_XfOrM294(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_min (__funcarg74 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM295_COUNT (2)
# define SETUP_XfOrM295(x) SETUP(XfOrM295_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM295(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM296_COUNT (2)
# define SETUP_XfOrM296(x) SETUP(XfOrM296_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM296(_), scheme_rational_min ((n1 ) , (scheme_make_small_rational ((((long ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  double d2 ; 
  ; 
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
  if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
    return scheme_nan_object ; 
  return scheme_make_double ((scheme_rational_to_double (n1 ) < d2 ) ? scheme_rational_to_double (n1 ) : d2 ) ; 
}
static inline Scheme_Object * bin_min__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM298_COUNT (1)
# define SETUP_XfOrM298(x) SETUP(XfOrM298_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg75 = FUNCCALL(SETUP_XfOrM298(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_min ((n1 ) , __funcarg75 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM299_COUNT (2)
# define SETUP_XfOrM299(x) SETUP(XfOrM299_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM299(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM300_COUNT (2)
# define SETUP_XfOrM300(x) SETUP(XfOrM300_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  ; 
  ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM300(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM301_COUNT (2)
# define SETUP_XfOrM301(x) SETUP(XfOrM301_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  if ((sizeof ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) == sizeof (float ) ? __isnanf ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) : sizeof ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) == sizeof (double ) ? __isnan ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) : __isnanl ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) ) )
    RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM301(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM302_COUNT (2)
# define SETUP_XfOrM302(x) SETUP(XfOrM302_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM302(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline Scheme_Object * bin_min__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM303_COUNT (2)
# define SETUP_XfOrM303(x) SETUP(XfOrM303_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM303(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * bin_min (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */
  Scheme_Type t1 , t2 ; 
  if ((((long ) (n1 ) ) & 0x1 ) ) {
    if ((((long ) (n2 ) ) & 0x1 ) )
      return ((Scheme_Object * ) (void * ) (long ) ((((long ) (((((long ) (n1 ) ) >> 1 ) < (((long ) (n2 ) ) >> 1 ) ) ? (((long ) (n1 ) ) >> 1 ) : (((long ) (n2 ) ) >> 1 ) ) ) << 1 ) | 0x1 ) ) ; 
    t2 = ((n2 ) -> type ) ; 
    if (t2 == scheme_double_type ) {
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
      if ((sizeof (d ) == sizeof (float ) ? __isnanf (d ) : sizeof (d ) == sizeof (double ) ? __isnan (d ) : __isnanl (d ) ) )
        return scheme_nan_object ; 
      return scheme_make_double (((((long ) (n1 ) ) >> 1 ) < d ) ? (((long ) (n1 ) ) >> 1 ) : d ) ; 
    }
    if (t2 == scheme_bignum_type ) {
      return bin_min__int_big (n1 , n2 ) ; 
    }
    if (t2 == scheme_rational_type ) {
      return bin_min__int_rat (n1 , n2 ) ; 
    }
    if ((t2 == scheme_complex_type ) ) {
      return bin_min__int_comp (n1 , n2 ) ; 
    }
    return bin_min__wrong_type (n2 ) ; 
  }
  else {
    t1 = ((n1 ) -> type ) ; 
    if (t1 == scheme_double_type ) {
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
          return scheme_nan_object ; 
        return scheme_make_double ((d1 < (((long ) (n2 ) ) >> 1 ) ) ? d1 : (((long ) (n2 ) ) >> 1 ) ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
        if ((sizeof (d1 ) == sizeof (float ) ? __isnanf (d1 ) : sizeof (d1 ) == sizeof (double ) ? __isnan (d1 ) : __isnanl (d1 ) ) )
          return scheme_nan_object ; 
        if ((sizeof (d2 ) == sizeof (float ) ? __isnanf (d2 ) : sizeof (d2 ) == sizeof (double ) ? __isnan (d2 ) : __isnanl (d2 ) ) )
          return scheme_nan_object ; 
        return scheme_make_double ((d1 < d2 ) ? d1 : d2 ) ; 
      }
      if (t2 == scheme_bignum_type ) {
        return bin_min__dbl_big (d1 , n1 , n2 ) ; 
      }
      if (t2 == scheme_rational_type ) {
        return bin_min__dbl_rat (d1 , n1 , n2 ) ; 
      }
      if ((t2 == scheme_complex_type ) ) {
        return bin_min__dbl_comp (d1 , n1 , n2 ) ; 
      }
      return bin_min__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_bignum_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return bin_min__big_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return bin_min__big_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return scheme_bignum_min ((n1 ) , (n2 ) ) ; 
      if (t2 == scheme_rational_type )
        return bin_min__big_rat (n1 , n2 ) ; 
      if ((t2 == scheme_complex_type ) ) {
        return bin_min__big_comp (n1 , n2 ) ; 
      }
      return bin_min__wrong_type (n2 ) ; 
    }
    else if (t1 == scheme_rational_type ) {
      if ((((long ) (n2 ) ) & 0x1 ) ) {
        return bin_min__rat_int (n1 , n2 ) ; 
      }
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return bin_min__rat_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return bin_min__rat_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return scheme_rational_min ((n1 ) , (n2 ) ) ; 
      if ((t2 == scheme_complex_type ) ) {
        return bin_min__rat_comp (n1 , n2 ) ; 
      }
      return bin_min__wrong_type (n2 ) ; 
    }
    else if ((t1 == scheme_complex_type ) ) {
      if ((((long ) (n2 ) ) & 0x1 ) )
        return bin_min__comp_int (n1 , n2 ) ; 
      t2 = ((n2 ) -> type ) ; 
      if (t2 == scheme_double_type ) {
        return bin_min__comp_dbl (n1 , n2 ) ; 
      }
      if (t2 == scheme_bignum_type )
        return bin_min__comp_big (n1 , n2 ) ; 
      if (t2 == scheme_rational_type )
        return bin_min__comp_rat (n1 , n2 ) ; 
      if ((t2 == scheme_complex_type ) )
        return bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) ; 
      return bin_min__wrong_type (n2 ) ; 
    }
    else return bin_min__wrong_type (n1 ) ; 
  }
}
static Scheme_Object * sch_max (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * sch_max__slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) {
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ret, 1)));
# define XfOrM327_COUNT (2)
# define SETUP_XfOrM327(x) SETUP(XfOrM327_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  for (i = 1 ; i < argc ; ++ i ) {
#   define XfOrM329_COUNT (0+XfOrM327_COUNT)
#   define SETUP_XfOrM329(x) SETUP_XfOrM327(x)
    if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_type ("max" , "real number" , i , argc , argv ) ); 
    ret = FUNCCALL(SETUP_XfOrM329(_), bin_max (ret , argv [i ] ) ); 
  }
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * sch_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * ret = argv [0 ] ; 
  if (! ((((long ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) < scheme_complex_type ) ) ) )
    scheme_wrong_type ("max" , "real number" , 0 , argc , argv ) ; 
  if (argc == 1 )
    return ret ; 
  if (argc == 2 ) {
    if (! ((((long ) (argv [1 ] ) ) & 0x1 ) || ((((argv [1 ] ) -> type ) >= scheme_bignum_type ) && (((argv [1 ] ) -> type ) < scheme_complex_type ) ) ) )
      scheme_wrong_type ("max" , "real number" , 1 , argc , argv ) ; 
    return bin_max (ret , argv [1 ] ) ; 
  }
  return sch_max__slow (ret , argc , argv ) ; 
}
static Scheme_Object * sch_min (int argc , Scheme_Object * argv [] ) ; 
static inline Scheme_Object * sch_min__slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) {
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ret, 1)));
# define XfOrM332_COUNT (2)
# define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  for (i = 1 ; i < argc ; ++ i ) {
#   define XfOrM334_COUNT (0+XfOrM332_COUNT)
#   define SETUP_XfOrM334(x) SETUP_XfOrM332(x)
    if (! ((((long ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_type ("min" , "real number" , i , argc , argv ) ); 
    ret = FUNCCALL(SETUP_XfOrM334(_), bin_min (ret , argv [i ] ) ); 
  }
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * sch_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  Scheme_Object * ret = argv [0 ] ; 
  if (! ((((long ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) < scheme_complex_type ) ) ) )
    scheme_wrong_type ("min" , "real number" , 0 , argc , argv ) ; 
  if (argc == 1 )
    return ret ; 
  if (argc == 2 ) {
    if (! ((((long ) (argv [1 ] ) ) & 0x1 ) || ((((argv [1 ] ) -> type ) >= scheme_bignum_type ) && (((argv [1 ] ) -> type ) < scheme_complex_type ) ) ) )
      scheme_wrong_type ("min" , "real number" , 1 , argc , argv ) ; 
    return bin_min (ret , argv [1 ] ) ; 
  }
  return sch_min__slow (ret , argc , argv ) ; 
}
