#include "precomp.h"
enum {
  CPT_ESCAPE , CPT_SYMBOL , CPT_SYMREF , CPT_WEIRD_SYMBOL , CPT_KEYWORD , CPT_BYTE_STRING , CPT_CHAR_STRING , CPT_CHAR , CPT_INT , CPT_NULL , CPT_TRUE , CPT_FALSE , CPT_VOID , CPT_BOX , CPT_PAIR , CPT_LIST , CPT_VECTOR , CPT_HASH_TABLE , CPT_STX , CPT_GSTX , CPT_MARSHALLED , CPT_QUOTE , CPT_REFERENCE , CPT_LOCAL , CPT_LOCAL_UNBOX , CPT_SVECTOR , CPT_APPLICATION , CPT_LET_ONE , CPT_BRANCH , CPT_MODULE_INDEX , CPT_MODULE_VAR , CPT_PATH , CPT_CLOSURE , CPT_DELAY_REF , CPT_PREFAB , _CPT_COUNT_ }
; 
enum {
  _ISupper = ((0 ) < 8 ? ((1 << (0 ) ) << 8 ) : ((1 << (0 ) ) >> 8 ) ) , _ISlower = ((1 ) < 8 ? ((1 << (1 ) ) << 8 ) : ((1 << (1 ) ) >> 8 ) ) , _ISalpha = ((2 ) < 8 ? ((1 << (2 ) ) << 8 ) : ((1 << (2 ) ) >> 8 ) ) , _ISdigit = ((3 ) < 8 ? ((1 << (3 ) ) << 8 ) : ((1 << (3 ) ) >> 8 ) ) , _ISxdigit = ((4 ) < 8 ? ((1 << (4 ) ) << 8 ) : ((1 << (4 ) ) >> 8 ) ) , _ISspace = ((5 ) < 8 ? ((1 << (5 ) ) << 8 ) : ((1 << (5 ) ) >> 8 ) ) , _ISprint = ((6 ) < 8 ? ((1 << (6 ) ) << 8 ) : ((1 << (6 ) ) >> 8 ) ) , _ISgraph = ((7 ) < 8 ? ((1 << (7 ) ) << 8 ) : ((1 << (7 ) ) >> 8 ) ) , _ISblank = ((8 ) < 8 ? ((1 << (8 ) ) << 8 ) : ((1 << (8 ) ) >> 8 ) ) , _IScntrl = ((9 ) < 8 ? ((1 << (9 ) ) << 8 ) : ((1 << (9 ) ) >> 8 ) ) , _ISpunct = ((10 ) < 8 ? ((1 << (10 ) ) << 8 ) : ((1 << (10 ) ) >> 8 ) ) , _ISalnum = ((11 ) < 8 ? ((1 << (11 ) ) << 8 ) : ((1 << (11 ) ) >> 8 ) ) }
; 
int (* scheme_check_print_is_obj ) (Scheme_Object * o ) ; 
static char * quick_buffer = ((void * ) 0 ) ; 
static char * quick_encode_buffer = ((void * ) 0 ) ; 
static Scheme_Type_Printer * printers ; 
static int printers_count ; 
static Scheme_Hash_Table * cache_ht ; 
static char compacts [_CPT_COUNT_ ] ; 
static Scheme_Hash_Table * global_constants_ht ; 
static Scheme_Object * quote_link_symbol = ((void * ) 0 ) ; 
typedef struct Scheme_Print_Params {
  Scheme_Type type ; 
  char print_struct ; 
  char print_graph ; 
  char print_box ; 
  char print_vec_shorthand ; 
  char print_hash_table ; 
  char print_unreadable ; 
  char print_pair_curly , print_mpair_curly ; 
  char can_read_pipe_quote ; 
  char case_sens ; 
  char honu_mode ; 
  Scheme_Object * inspector ; 
  char * print_buffer ; 
  long print_position ; 
  long print_allocated ; 
  long print_maxlen ; 
  long print_offset ; 
  Scheme_Object * print_port ; 
  mz_jmp_buf * print_escape ; 
}
PrintParams ; 
static void register_traversers (void ) ; 
static void print_to_port (char * name , Scheme_Object * obj , Scheme_Object * port , int notdisplay , long maxl , int check_honu ) ; 
static int print (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * p ) ; 
static void print_char_string (const char * s , int l , const mzchar * us , int delta , int ul , int notdisplay , int honu_char , PrintParams * pp ) ; 
static void print_byte_string (const char * s , int delta , int l , int notdisplay , PrintParams * pp ) ; 
static void print_pair (Scheme_Object * pair , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp , Scheme_Type type , int round_parens ) ; 
static void print_vector (Scheme_Object * vec , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp , int as_prefab ) ; 
static void print_char (Scheme_Object * chobj , int notdisplay , PrintParams * pp ) ; 
static char * print_to_string (Scheme_Object * obj , long * volatile len , int write , Scheme_Object * port , long maxl , int check_honu ) ; 
static void custom_write_struct (Scheme_Object * s , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp , int notdisplay ) ; 
static Scheme_Object * writable_struct_subs (Scheme_Object * s , int for_write , PrintParams * pp ) ; 
void scheme_init_print (Scheme_Env * env ) {
  /* No conversion */
  int i ; 
  scheme_register_static ((void * ) & quote_link_symbol , sizeof (quote_link_symbol ) ) ; 
  quote_link_symbol = scheme_intern_symbol ("-q" ) ; 
  for (i = 0 ; i < _CPT_COUNT_ ; i ++ ) {
    compacts [i ] = i ; 
  }
  register_traversers () ; 
  scheme_register_static ((void * ) & cache_ht , sizeof (cache_ht ) ) ; 
}
void scheme_init_print_buffers_places () {
  /* No conversion */
  scheme_register_static ((void * ) & quick_buffer , sizeof (quick_buffer ) ) ; 
  scheme_register_static ((void * ) & quick_encode_buffer , sizeof (quick_encode_buffer ) ) ; 
  quick_buffer = (char * ) GC_malloc_atomic (100 ) ; 
  quick_encode_buffer = (char * ) GC_malloc_atomic (256 ) ; 
}
Scheme_Object * scheme_make_svector (mzshort c , mzshort * a ) {
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(a, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM5(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_svector_type ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . len ) = c ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) = a ; 
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
PrintParams * copy_print_params (PrintParams * pp ) {
  PrintParams * pp2 ; 
  DECL_RET_SAVE (PrintParams * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp2, 0), PUSH(pp, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pp2 = NULLED_OUT ; 
  pp2 = ((PrintParams * ) FUNCCALL(SETUP_XfOrM6(_), GC_malloc_one_small_tagged ((((sizeof (PrintParams ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (pp2 , pp , sizeof (PrintParams ) ) ) ; 
  pp2 -> type = scheme_rt_print_params ; 
  RET_VALUE_START (pp2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_debug_print (Scheme_Object * obj ) {
  /* No conversion */
  scheme_write (obj , scheme_orig_stdout_port ) ; 
  fflush (stdout ) ; 
}
static void * print_to_port_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * obj , * port ; 
  port = (Scheme_Object * ) p -> ku . k . p1 ; 
  obj = (Scheme_Object * ) p -> ku . k . p2 ; 
  print_to_port (p -> ku . k . i2 ? "write" : "display" , obj , port , p -> ku . k . i2 , p -> ku . k . i1 , p -> ku . k . i3 ) ; 
  return ((void * ) 0 ) ; 
}
static void do_handled_print (Scheme_Object * obj , Scheme_Object * port , Scheme_Object * proc , long maxl ) {
  Scheme_Object * a [2 ] ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(port, 3)));
# define XfOrM9_COUNT (4)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a [0 ] = obj ; 
  if (maxl > 0 ) {
#   define XfOrM11_COUNT (0+XfOrM9_COUNT)
#   define SETUP_XfOrM11(x) SETUP_XfOrM9(x)
    a [1 ] = FUNCCALL(SETUP_XfOrM11(_), scheme_make_byte_string_output_port () ); 
  }
  else a [1 ] = port ; 
  FUNCCALL(SETUP_XfOrM9(_), scheme_apply_multi (scheme_write_proc , 2 , a ) ); 
  if (maxl > 0 ) {
    char * s ; 
    long len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM9_COUNT)));
#   define XfOrM10_COUNT (1+XfOrM9_COUNT)
#   define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
    s = NULLED_OUT ; 
    s = FUNCCALL(SETUP_XfOrM10(_), scheme_get_sized_byte_string_output (a [1 ] , & len ) ); 
    if (len > maxl )
      len = maxl ; 
    FUNCCALL(SETUP_XfOrM10(_), scheme_write_byte_string (s , len , port ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_write_w_max (Scheme_Object * obj , Scheme_Object * port , long maxl ) {
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(port, 1)));
# define XfOrM12_COUNT (2)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (((Scheme_Output_Port * ) port ) -> write_handler )
    FUNCCALL(SETUP_XfOrM12(_), do_handled_print (obj , port , scheme_write_proc , maxl ) ); 
  else {
    Scheme_Thread * p = scheme_current_thread ; 
#   define XfOrM13_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM12(x)
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 1 ; 
    p -> ku . k . i3 = 0 ; 
    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_write (Scheme_Object * obj , Scheme_Object * port ) {
  /* No conversion */
  scheme_write_w_max (obj , port , - 1 ) ; 
}
void scheme_display_w_max (Scheme_Object * obj , Scheme_Object * port , long maxl ) {
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(port, 1)));
# define XfOrM15_COUNT (2)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (((Scheme_Output_Port * ) port ) -> display_handler )
    FUNCCALL(SETUP_XfOrM15(_), do_handled_print (obj , port , scheme_display_proc , maxl ) ); 
  else {
    Scheme_Thread * p = scheme_current_thread ; 
#   define XfOrM16_COUNT (0+XfOrM15_COUNT)
#   define SETUP_XfOrM16(x) SETUP_XfOrM15(x)
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 0 ; 
    p -> ku . k . i3 = 0 ; 
    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_display (Scheme_Object * obj , Scheme_Object * port ) {
  /* No conversion */
  scheme_display_w_max (obj , port , - 1 ) ; 
}
void scheme_print_w_max (Scheme_Object * obj , Scheme_Object * port , long maxl ) {
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(port, 1)));
# define XfOrM18_COUNT (2)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (((Scheme_Output_Port * ) port ) -> print_handler )
    FUNCCALL(SETUP_XfOrM18(_), do_handled_print (obj , port , scheme_print_proc , maxl ) ); 
  else {
    Scheme_Thread * p = scheme_current_thread ; 
#   define XfOrM19_COUNT (0+XfOrM18_COUNT)
#   define SETUP_XfOrM19(x) SETUP_XfOrM18(x)
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 1 ; 
    p -> ku . k . i3 = 1 ; 
    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_print (Scheme_Object * obj , Scheme_Object * port ) {
  /* No conversion */
  scheme_print_w_max (obj , port , - 1 ) ; 
}
static void * print_to_string_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * obj ; 
  long * len , maxl ; 
  int iswrite , check_honu ; 
  obj = (Scheme_Object * ) p -> ku . k . p1 ; 
  len = (long * ) (void * ) p -> ku . k . p2 ; 
  maxl = p -> ku . k . i1 ; 
  iswrite = p -> ku . k . i2 ; 
  check_honu = p -> ku . k . i3 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  return (void * ) print_to_string (obj , len , iswrite , ((void * ) 0 ) , maxl , check_honu ) ; 
}
char * scheme_write_to_string_w_max (Scheme_Object * obj , long * len , long maxl ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 1 ; 
  p -> ku . k . i3 = 0 ; 
  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}
char * scheme_write_to_string (Scheme_Object * obj , long * len ) {
  /* No conversion */
  return scheme_write_to_string_w_max (obj , len , - 1 ) ; 
}
char * scheme_display_to_string_w_max (Scheme_Object * obj , long * len , long maxl ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 0 ; 
  p -> ku . k . i3 = 0 ; 
  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}
char * scheme_display_to_string (Scheme_Object * obj , long * len ) {
  /* No conversion */
  return scheme_display_to_string_w_max (obj , len , - 1 ) ; 
}
char * scheme_print_to_string_w_max (Scheme_Object * obj , long * len , long maxl ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 1 ; 
  p -> ku . k . i3 = 1 ; 
  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}
char * scheme_print_to_string (Scheme_Object * obj , long * len ) {
  /* No conversion */
  return scheme_print_to_string_w_max (obj , len , - 1 ) ; 
}
void scheme_internal_write (Scheme_Object * obj , Scheme_Object * port ) {
  /* No conversion */
  print_to_port ("write" , obj , port , 1 , - 1 , 0 ) ; 
}
void scheme_internal_display (Scheme_Object * obj , Scheme_Object * port ) {
  /* No conversion */
  print_to_port ("display" , obj , port , 0 , - 1 , 0 ) ; 
}
void scheme_internal_print (Scheme_Object * obj , Scheme_Object * port ) {
  /* No conversion */
  print_to_port ("print" , obj , port , 1 , - 1 , 1 ) ; 
}
static int check_cycles (Scheme_Object * , int , Scheme_Hash_Table * ht , PrintParams * ) ; 
static Scheme_Object * check_cycle_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p3 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  return check_cycles (o , p -> ku . k . i1 , ht , pp ) ? scheme_true : scheme_false ; 
}
static int check_cycles (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , PrintParams * pp ) {
  Scheme_Type t ; 
  Scheme_Object * __funcarg10 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(ht, 1), PUSH(pp, 2)));
# define XfOrM32_COUNT (3)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  {
    unsigned long _stk_pos ; 
#   define XfOrM60_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM32(x)
    _stk_pos = (unsigned long ) & _stk_pos ; 
    if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
#     define XfOrM61_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
      pp = FUNCCALL(SETUP_XfOrM61(_), copy_print_params (pp ) ); 
      scheme_current_thread -> ku . k . p1 = (void * ) obj ; 
      scheme_current_thread -> ku . k . p2 = (void * ) ht ; 
      scheme_current_thread -> ku . k . p3 = (void * ) pp ; 
      scheme_current_thread -> ku . k . i1 = for_write ; 
      RET_VALUE_START ((! (((FUNCCALL(SETUP_XfOrM61(_), scheme_handle_stack_overflow (check_cycle_k ) )) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
    }
  }
  {
#   define XfOrM58_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM58(x) SETUP_XfOrM32(x)
    if ((scheme_fuel_counter ) <= 0 ) {
#     define XfOrM59_COUNT (0+XfOrM58_COUNT)
#     define SETUP_XfOrM59(x) SETUP_XfOrM58(x)
      FUNCCALL(SETUP_XfOrM59(_), scheme_out_of_fuel () ); 
    }
  }
  ; 
  t = ((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ; 
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (pp -> print_box && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && ((pp -> print_struct && (FUNCCALL(SETUP_XfOrM32(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ) || FUNCCALL(SETUP_XfOrM32(_), scheme_is_writable_struct (obj ) )) ) || (pp -> print_hash_table && (((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) ) ) {
#   define XfOrM57_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM57(x) SETUP_XfOrM32(x)
    if (FUNCCALL(SETUP_XfOrM57(_), scheme_hash_get (ht , obj ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    FUNCCALL(SETUP_XfOrM57(_), scheme_hash_set (ht , obj , (Scheme_Object * ) 0x1 ) ); 
  }
  else RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
#   define XfOrM56_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM56(x) SETUP_XfOrM32(x)
    if (FUNCCALL(SETUP_XfOrM56(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , pp ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if (FUNCCALL(SETUP_XfOrM56(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , pp ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
#   define XfOrM55_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM55(x) SETUP_XfOrM32(x)
    if (FUNCCALL(SETUP_XfOrM55(_), check_cycles ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , for_write , ht , pp ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
    int i , len ; 
#   define XfOrM50_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM32(x)
    len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM53_COUNT (0+XfOrM50_COUNT)
#     define SETUP_XfOrM53(x) SETUP_XfOrM50(x)
      if (FUNCCALL(SETUP_XfOrM53(_), check_cycles ((((Scheme_Vector * ) (obj ) ) -> els ) [i ] , for_write , ht , pp ) )) {
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
    }
  }
  else if (((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) {
#   define XfOrM41_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM41(x) SETUP_XfOrM32(x)
    if (FUNCCALL(SETUP_XfOrM41(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM49_COUNT (0+XfOrM41_COUNT)
#     define SETUP_XfOrM49(x) SETUP_XfOrM41(x)
      if ((__funcarg10 = FUNCCALL(SETUP_XfOrM49(_), writable_struct_subs (obj , for_write , pp ) ), FUNCCALL_AGAIN(check_cycles (__funcarg10 , for_write , ht , pp ) )) )
        RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else {
      int i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 
#     define XfOrM42_COUNT (0+XfOrM41_COUNT)
#     define SETUP_XfOrM42(x) SETUP_XfOrM41(x)
      while (i -- ) {
#       define XfOrM46_COUNT (0+XfOrM42_COUNT)
#       define SETUP_XfOrM46(x) SETUP_XfOrM42(x)
        if (FUNCCALL(SETUP_XfOrM46(_), scheme_inspector_sees_part (obj , pp -> inspector , i ) )) {
#         define XfOrM47_COUNT (0+XfOrM46_COUNT)
#         define SETUP_XfOrM47(x) SETUP_XfOrM46(x)
          if (FUNCCALL(SETUP_XfOrM47(_), check_cycles (((Scheme_Structure * ) obj ) -> slots [i ] , for_write , ht , pp ) )) {
            RET_VALUE_START (1 ) RET_VALUE_END ; 
          }
        }
      }
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
    Scheme_Hash_Table * t ; 
    Scheme_Object * * keys , * * vals , * val ; 
    int i ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM32_COUNT), PUSH(vals, 1+XfOrM32_COUNT), PUSH(keys, 2+XfOrM32_COUNT), PUSH(t, 3+XfOrM32_COUNT)));
#   define XfOrM36_COUNT (4+XfOrM32_COUNT)
#   define SETUP_XfOrM36(x) SETUP(XfOrM36_COUNT)
    t = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    t = (Scheme_Hash_Table * ) obj ; 
    keys = t -> keys ; 
    vals = t -> vals ; 
    for (i = t -> size ; i -- ; ) {
#     define XfOrM39_COUNT (0+XfOrM36_COUNT)
#     define SETUP_XfOrM39(x) SETUP_XfOrM36(x)
      if (vals [i ] ) {
#       define XfOrM40_COUNT (0+XfOrM39_COUNT)
#       define SETUP_XfOrM40(x) SETUP_XfOrM39(x)
        val = vals [i ] ; 
        if (FUNCCALL(SETUP_XfOrM40(_), check_cycles (keys [i ] , for_write , ht , pp ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM40(_), check_cycles (val , for_write , ht , pp ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) {
    Scheme_Hash_Tree * t = (Scheme_Hash_Tree * ) obj ; 
    Scheme_Object * key , * val ; 
    int i ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM32_COUNT), PUSH(val, 1+XfOrM32_COUNT), PUSH(t, 2+XfOrM32_COUNT)));
#   define XfOrM33_COUNT (3+XfOrM32_COUNT)
#   define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    i = FUNCCALL(SETUP_XfOrM33(_), scheme_hash_tree_next (t , - 1 ) ); 
    while (i != - 1 ) {
#     define XfOrM35_COUNT (0+XfOrM33_COUNT)
#     define SETUP_XfOrM35(x) SETUP_XfOrM33(x)
      FUNCCALL(SETUP_XfOrM35(_), scheme_hash_tree_index (t , i , & key , & val ) ); 
      if (FUNCCALL(SETUP_XfOrM35(_), check_cycles (key , for_write , ht , pp ) ))
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      if (FUNCCALL(SETUP_XfOrM35(_), check_cycles (val , for_write , ht , pp ) ))
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      i = FUNCCALL(SETUP_XfOrM35(_), scheme_hash_tree_next (t , i ) ); 
    }
  }
  FUNCCALL_EMPTY(scheme_hash_set (ht , obj , ((void * ) 0 ) ) ); 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int check_cycles_fast (Scheme_Object * obj , PrintParams * pp , int * fast_checker_counter ) {
  Scheme_Type t ; 
  int cycle = 0 ; 
  t = ((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ; 
  if (t < 0 )
    return 1 ; 
  if ((* fast_checker_counter ) -- < 0 )
    return - 1 ; 
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
    obj -> type = - t ; 
    cycle = check_cycles_fast ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , pp , fast_checker_counter ) ; 
    if (! cycle )
      cycle = check_cycles_fast ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , pp , fast_checker_counter ) ; 
    obj -> type = t ; 
  }
  else if (pp -> print_box && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
    obj -> type = - t ; 
    cycle = check_cycles_fast ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , pp , fast_checker_counter ) ; 
    obj -> type = t ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
    int i , len ; 
    obj -> type = - t ; 
    len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    for (i = 0 ; i < len ; i ++ ) {
      cycle = check_cycles_fast ((((Scheme_Vector * ) (obj ) ) -> els ) [i ] , pp , fast_checker_counter ) ; 
      if (cycle )
        break ; 
    }
    obj -> type = t ; 
  }
  else if (((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) {
    if (scheme_is_writable_struct (obj ) ) {
      if (! pp -> print_unreadable )
        cycle = 0 ; 
      else cycle = - 1 ; 
    }
    else if (pp -> print_struct && (scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) ) ) {
      int i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 
      obj -> type = - t ; 
      while (i -- ) {
        if (scheme_inspector_sees_part (obj , pp -> inspector , i ) ) {
          cycle = check_cycles_fast (((Scheme_Structure * ) obj ) -> slots [i ] , pp , fast_checker_counter ) ; 
          if (cycle )
            break ; 
        }
      }
      obj -> type = t ; 
    }
    else cycle = 0 ; 
  }
  else if (pp -> print_hash_table && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
    if (! ((Scheme_Hash_Table * ) obj ) -> count )
      cycle = 0 ; 
    else cycle = - 1 ; 
  }
  else if (pp -> print_hash_table && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) {
    if (! ((Scheme_Hash_Tree * ) obj ) -> count )
      cycle = 0 ; 
    else cycle = - 1 ; 
  }
  else cycle = 0 ; 
  return cycle ; 
}
static void setup_graph_table (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , int * counter , PrintParams * pp ) ; 
static Scheme_Object * setup_graph_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  int * counter = (int * ) p -> ku . k . p3 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p4 ; 
  int for_write = p -> ku . k . i1 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  setup_graph_table (o , for_write , ht , counter , pp ) ; 
  return scheme_false ; 
}
static void setup_graph_table (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , int * counter , PrintParams * pp ) {
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(counter, 1), PUSH(pp, 2), PUSH(obj, 3)));
# define XfOrM63_COUNT (4)
# define SETUP_XfOrM63(x) SETUP(XfOrM63_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((pp ? pp -> print_box : 1 ) && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) || ((pp ? pp -> print_struct && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (FUNCCALL(SETUP_XfOrM63(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) : 0 ) ) || ((pp ? (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && FUNCCALL(SETUP_XfOrM63(_), scheme_is_writable_struct (obj ) ): 0 ) ) || ((pp ? pp -> print_hash_table : 1 ) && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) ) ) ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM63_COUNT)));
#   define XfOrM85_COUNT (1+XfOrM63_COUNT)
#   define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
    v = NULLED_OUT ; 
    {
      unsigned long _stk_pos ; 
#     define XfOrM88_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM85(x)
      _stk_pos = (unsigned long ) & _stk_pos ; 
      if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
#       define XfOrM89_COUNT (0+XfOrM88_COUNT)
#       define SETUP_XfOrM89(x) SETUP_XfOrM88(x)
        if (pp )
          pp = FUNCCALL(SETUP_XfOrM89(_), copy_print_params (pp ) ); 
        scheme_current_thread -> ku . k . p1 = (void * ) obj ; 
        scheme_current_thread -> ku . k . p2 = (void * ) ht ; 
        scheme_current_thread -> ku . k . p3 = (void * ) counter ; 
        scheme_current_thread -> ku . k . p4 = (void * ) pp ; 
        scheme_current_thread -> ku . k . i1 = for_write ; 
        FUNCCALL(SETUP_XfOrM89(_), scheme_handle_stack_overflow (setup_graph_k ) ); 
        RET_NOTHING ; 
      }
    }
    v = FUNCCALL(SETUP_XfOrM85(_), scheme_hash_get (ht , obj ) ); 
    if (! v )
      FUNCCALL(SETUP_XfOrM85(_), scheme_hash_set (ht , obj , (Scheme_Object * ) 0x1 ) ); 
    else {
#     define XfOrM86_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM86(x) SETUP_XfOrM85(x)
      if ((long ) v == 1 ) {
#       define XfOrM87_COUNT (0+XfOrM86_COUNT)
#       define SETUP_XfOrM87(x) SETUP_XfOrM86(x)
        (* counter ) += 2 ; 
        FUNCCALL(SETUP_XfOrM87(_), scheme_hash_set (ht , obj , (Scheme_Object * ) (long ) * counter ) ); 
      }
      RET_NOTHING ; 
    }
  }
  else RET_NOTHING ; 
  {
#   define XfOrM83_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM63(x)
    if ((scheme_fuel_counter ) <= 0 ) {
#     define XfOrM84_COUNT (0+XfOrM83_COUNT)
#     define SETUP_XfOrM84(x) SETUP_XfOrM83(x)
      FUNCCALL(SETUP_XfOrM84(_), scheme_out_of_fuel () ); 
    }
  }
  ; 
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
#   define XfOrM82_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM82(x) SETUP_XfOrM63(x)
    FUNCCALL(SETUP_XfOrM82(_), setup_graph_table ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , counter , pp ) ); 
    FUNCCALL(SETUP_XfOrM82(_), setup_graph_table ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , counter , pp ) ); 
  }
  else if ((! pp || pp -> print_box ) && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
#   define XfOrM81_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM81(x) SETUP_XfOrM63(x)
    FUNCCALL(SETUP_XfOrM81(_), setup_graph_table ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , for_write , ht , counter , pp ) ); 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
    int i , len ; 
#   define XfOrM78_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM78(x) SETUP_XfOrM63(x)
    len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM80_COUNT (0+XfOrM78_COUNT)
#     define SETUP_XfOrM80(x) SETUP_XfOrM78(x)
      FUNCCALL(SETUP_XfOrM80(_), setup_graph_table ((((Scheme_Vector * ) (obj ) ) -> els ) [i ] , for_write , ht , counter , pp ) ); 
    }
  }
  else if (pp && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
#   define XfOrM72_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM72(x) SETUP_XfOrM63(x)
    if (FUNCCALL(SETUP_XfOrM72(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM76_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM76(x) SETUP_XfOrM72(x)
      if (pp -> print_unreadable ) {
#       define XfOrM77_COUNT (0+XfOrM76_COUNT)
#       define SETUP_XfOrM77(x) SETUP_XfOrM76(x)
        obj = FUNCCALL(SETUP_XfOrM77(_), writable_struct_subs (obj , for_write , pp ) ); 
        FUNCCALL(SETUP_XfOrM77(_), setup_graph_table (obj , for_write , ht , counter , pp ) ); 
      }
    }
    else {
      int i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 
#     define XfOrM73_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM72(x)
      while (i -- ) {
#       define XfOrM75_COUNT (0+XfOrM73_COUNT)
#       define SETUP_XfOrM75(x) SETUP_XfOrM73(x)
        if (FUNCCALL(SETUP_XfOrM75(_), scheme_inspector_sees_part (obj , pp -> inspector , i ) ))
          FUNCCALL(SETUP_XfOrM75(_), setup_graph_table (((Scheme_Structure * ) obj ) -> slots [i ] , for_write , ht , counter , pp ) ); 
      }
    }
  }
  else if (pp && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
    Scheme_Hash_Table * t ; 
    Scheme_Object * * keys , * * vals , * val ; 
    int i ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM63_COUNT), PUSH(vals, 1+XfOrM63_COUNT), PUSH(keys, 2+XfOrM63_COUNT), PUSH(t, 3+XfOrM63_COUNT)));
#   define XfOrM67_COUNT (4+XfOrM63_COUNT)
#   define SETUP_XfOrM67(x) SETUP(XfOrM67_COUNT)
    t = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    t = (Scheme_Hash_Table * ) obj ; 
    keys = t -> keys ; 
    vals = t -> vals ; 
    for (i = t -> size ; i -- ; ) {
#     define XfOrM70_COUNT (0+XfOrM67_COUNT)
#     define SETUP_XfOrM70(x) SETUP_XfOrM67(x)
      if (vals [i ] ) {
#       define XfOrM71_COUNT (0+XfOrM70_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM70(x)
        val = vals [i ] ; 
        FUNCCALL(SETUP_XfOrM71(_), setup_graph_table (keys [i ] , for_write , ht , counter , pp ) ); 
        FUNCCALL_AGAIN(setup_graph_table (val , for_write , ht , counter , pp ) ); 
      }
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) {
    Scheme_Hash_Tree * t = (Scheme_Hash_Tree * ) obj ; 
    Scheme_Object * key , * val ; 
    int i ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM63_COUNT), PUSH(val, 1+XfOrM63_COUNT), PUSH(t, 2+XfOrM63_COUNT)));
#   define XfOrM64_COUNT (3+XfOrM63_COUNT)
#   define SETUP_XfOrM64(x) SETUP(XfOrM64_COUNT)
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    i = FUNCCALL(SETUP_XfOrM64(_), scheme_hash_tree_next (t , - 1 ) ); 
    while (i != - 1 ) {
#     define XfOrM66_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM66(x) SETUP_XfOrM64(x)
      FUNCCALL(SETUP_XfOrM66(_), scheme_hash_tree_index (t , i , & key , & val ) ); 
      FUNCCALL(SETUP_XfOrM66(_), setup_graph_table (key , for_write , ht , counter , pp ) ); 
      FUNCCALL_AGAIN(setup_graph_table (val , for_write , ht , counter , pp ) ); 
      i = FUNCCALL_AGAIN(scheme_hash_tree_next (t , i ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Hash_Table * setup_datum_graph (Scheme_Object * o , int for_write , void * for_print ) {
  Scheme_Hash_Table * ht ; 
  int counter = 1 ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(for_print, 0), PUSH(ht, 1), PUSH(o, 2)));
# define XfOrM90_COUNT (3)
# define SETUP_XfOrM90(x) SETUP(XfOrM90_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 
  if (cache_ht ) {
    ht = cache_ht ; 
    cache_ht = ((void * ) 0 ) ; 
  }
  else ht = FUNCCALL(SETUP_XfOrM90(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  FUNCCALL(SETUP_XfOrM90(_), setup_graph_table (o , for_write , ht , & counter , (PrintParams * ) for_print ) ); 
  if (counter > 1 )
    RET_VALUE_START (ht ) RET_VALUE_END ; 
  else {
    if (ht -> size < 32 ) {
      int i ; 
      for (i = 0 ; i < ht -> size ; i ++ ) {
        ht -> keys [i ] = ((void * ) 0 ) ; 
        ht -> vals [i ] = ((void * ) 0 ) ; 
      }
      cache_ht = ht ; 
    }
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static char * print_to_string (Scheme_Object * obj , long * volatile len , int write , Scheme_Object * port , long maxl , int check_honu ) {
  Scheme_Hash_Table * volatile ht ; 
  Scheme_Object * v ; 
  char * ca ; 
  int cycles ; 
  Scheme_Config * config ; 
  mz_jmp_buf escape ; 
  volatile PrintParams params ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(11);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(v, 1), PUSH(params.inspector, 2), PUSH(params.print_buffer, 3), PUSH(params.print_port, 4), PUSH(params.print_escape, 5), PUSH(config, 6), PUSH(obj, 7), PUSH(ca, 8), PUSH(len, 9), PUSH(port, 10)));
# define XfOrM96_COUNT (11)
# define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 
  v = NULLED_OUT ; 
  ca = NULLED_OUT ; 
  config = NULLED_OUT ; 
  params.inspector = NULLED_OUT ; 
  params.print_buffer = NULLED_OUT ; 
  params.print_port = NULLED_OUT ; 
  params.print_escape = NULLED_OUT ; 
  params . print_allocated = 50 ; 
  ca = (char * ) FUNCCALL(SETUP_XfOrM96(_), GC_malloc_atomic (params . print_allocated ) ); 
  params . print_buffer = ca ; 
  params . print_position = 0 ; 
  params . print_offset = 0 ; 
  params . print_maxlen = maxl ; 
  params . print_port = port ; 
  if (! write && (((((long ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) {
    params . print_graph = 0 ; 
    params . print_box = 0 ; 
    params . print_struct = 0 ; 
    params . print_vec_shorthand = 0 ; 
    params . print_hash_table = 0 ; 
    params . print_unreadable = 1 ; 
    params . print_pair_curly = 0 ; 
    params . print_mpair_curly = 1 ; 
    params . can_read_pipe_quote = 1 ; 
    params . case_sens = 1 ; 
    params . honu_mode = 0 ; 
    params . inspector = scheme_false ; 
  }
  else {
#   define XfOrM99_COUNT (0+XfOrM96_COUNT)
#   define SETUP_XfOrM99(x) SETUP_XfOrM96(x)
    config = FUNCCALL(SETUP_XfOrM99(_), scheme_current_config () ); 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_GRAPH ) ); 
    params . print_graph = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_BOX ) ); 
    params . print_box = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_STRUCT ) ); 
    params . print_struct = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_VEC_SHORTHAND ) ); 
    params . print_vec_shorthand = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_HASH_TABLE ) ); 
    params . print_hash_table = (! (((v ) ) == (scheme_false ) ) ) ; 
    if (write ) {
#     define XfOrM101_COUNT (0+XfOrM99_COUNT)
#     define SETUP_XfOrM101(x) SETUP_XfOrM99(x)
      if (maxl > 0 )
        params . print_unreadable = 1 ; 
      else {
#       define XfOrM102_COUNT (0+XfOrM101_COUNT)
#       define SETUP_XfOrM102(x) SETUP_XfOrM101(x)
        v = FUNCCALL(SETUP_XfOrM102(_), scheme_get_param (config , MZCONFIG_PRINT_UNREADABLE ) ); 
        params . print_unreadable = (! (((v ) ) == (scheme_false ) ) ) ; 
      }
    }
    else params . print_unreadable = 1 ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_PAIR_CURLY ) ); 
    params . print_pair_curly = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_PRINT_MPAIR_CURLY ) ); 
    params . print_mpair_curly = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_CAN_READ_PIPE_QUOTE ) ); 
    params . can_read_pipe_quote = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_CASE_SENS ) ); 
    params . case_sens = (! (((v ) ) == (scheme_false ) ) ) ; 
    if (check_honu ) {
#     define XfOrM100_COUNT (0+XfOrM99_COUNT)
#     define SETUP_XfOrM100(x) SETUP_XfOrM99(x)
      v = FUNCCALL(SETUP_XfOrM100(_), scheme_get_param (config , MZCONFIG_HONU_MODE ) ); 
      params . honu_mode = (! (((v ) ) == (scheme_false ) ) ) ; 
    }
    else params . honu_mode = 0 ; 
    v = FUNCCALL(SETUP_XfOrM99(_), scheme_get_param (config , MZCONFIG_INSPECTOR ) ); 
    params . inspector = v ; 
  }
  if (params . print_graph )
    cycles = 1 ; 
  else {
    int fast_checker_counter = 50 ; 
#   define XfOrM97_COUNT (0+XfOrM96_COUNT)
#   define SETUP_XfOrM97(x) SETUP_XfOrM96(x)
    cycles = FUNCCALL(SETUP_XfOrM97(_), check_cycles_fast (obj , (PrintParams * ) & params , & fast_checker_counter ) ); 
    if (cycles == - 1 ) {
#     define XfOrM98_COUNT (0+XfOrM97_COUNT)
#     define SETUP_XfOrM98(x) SETUP_XfOrM97(x)
      ht = FUNCCALL(SETUP_XfOrM98(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      cycles = FUNCCALL(SETUP_XfOrM98(_), check_cycles (obj , write , ht , (PrintParams * ) & params ) ); 
    }
  }
  if (cycles )
    ht = FUNCCALL(SETUP_XfOrM96(_), setup_datum_graph (obj , write , (PrintParams * ) & params ) ); 
  else ht = ((void * ) 0 ) ; 
  if (maxl > 0 )
    params . print_escape = & escape ; 
  else params . print_escape = ((void * ) 0 ) ; 
  if ((maxl <= 3 ) || ! ((escape ) . gcvs = (long ) __gc_var_stack__ , (escape ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((escape ) . jb ) , (_setjmp (((escape ) . jb ) -> jb ) ) ) ) )
    FUNCCALL(SETUP_XfOrM96(_), print (obj , write , 0 , ht , ((void * ) 0 ) , (PrintParams * ) & params ) ); 
  params . print_buffer [params . print_position ] = '\0' ; 
  if (len )
    * len = params . print_position ; 
  params . inspector = ((void * ) 0 ) ; 
  RET_VALUE_START (params . print_buffer ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_to_port (char * name , Scheme_Object * obj , Scheme_Object * port , int notdisplay , long maxl , int check_honu ) {
  Scheme_Output_Port * op ; 
  char * str ; 
  long len ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(port, 1), PUSH(str, 2), PUSH(name, 3), PUSH(op, 4)));
# define XfOrM104_COUNT (5)
# define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 
  str = NULLED_OUT ; 
  op = FUNCCALL(SETUP_XfOrM104(_), scheme_output_port_record (port ) ); 
  if (op -> closed )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL , "%s: output port is closed" , name ) ); 
  str = FUNCCALL(SETUP_XfOrM104(_), print_to_string (obj , & len , notdisplay , port , maxl , check_honu ) ); 
  FUNCCALL_EMPTY(scheme_write_byte_string (str , len , port ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_this_string (PrintParams * pp , const char * str , int offset , int autolen ) {
  long len ; 
  char * oldstr ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(oldstr, 0), PUSH(pp, 1), PUSH(str, 2)));
# define XfOrM105_COUNT (3)
# define SETUP_XfOrM105(x) SETUP(XfOrM105_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  oldstr = NULLED_OUT ; 
  if (! autolen ) {
    if (! str )
      len = 0 ; 
    else RET_NOTHING ; 
  }
  else if (autolen > 0 )
    len = autolen ; 
  else len = strlen (str XFORM_OK_PLUS offset ) ; 
  if (! pp -> print_buffer ) {
    pp -> print_position += len ; 
    pp -> print_offset += len ; 
    RET_NOTHING ; 
  }
  if (len + pp -> print_position + 1 > pp -> print_allocated ) {
#   define XfOrM112_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM112(x) SETUP_XfOrM105(x)
    if (len + 1 >= pp -> print_allocated )
      pp -> print_allocated = 2 * pp -> print_allocated + len + 1 ; 
    else pp -> print_allocated = 2 * pp -> print_allocated ; 
    oldstr = pp -> print_buffer ; 
    {
      char * ca ; 
      BLOCK_SETUP((PUSH(ca, 0+XfOrM112_COUNT)));
#     define XfOrM113_COUNT (1+XfOrM112_COUNT)
#     define SETUP_XfOrM113(x) SETUP(XfOrM113_COUNT)
      ca = NULLED_OUT ; 
      ca = (char * ) FUNCCALL(SETUP_XfOrM113(_), GC_malloc_atomic (pp -> print_allocated ) ); 
      pp -> print_buffer = ca ; 
    }
    (memcpy (pp -> print_buffer , oldstr , pp -> print_position ) ) ; 
  }
  (memcpy (pp -> print_buffer + pp -> print_position , str + offset , len ) ) ; 
  pp -> print_position += len ; 
  pp -> print_offset += len ; 
  {
#   define XfOrM110_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM110(x) SETUP_XfOrM105(x)
    if ((scheme_fuel_counter ) <= 0 ) {
#     define XfOrM111_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM111(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM111(_), scheme_out_of_fuel () ); 
    }
  }
  ; 
  if (pp -> print_maxlen > 3 ) {
    if (pp -> print_position > pp -> print_maxlen ) {
      long l = pp -> print_maxlen ; 
      pp -> print_buffer [l ] = 0 ; 
      pp -> print_buffer [l - 1 ] = '.' ; 
      pp -> print_buffer [l - 2 ] = '.' ; 
      pp -> print_buffer [l - 3 ] = '.' ; 
      pp -> print_position = l ; 
      (((long * ) (void * ) ((* pp -> print_escape ) . gcvs ) ) [1 ] = (* pp -> print_escape ) . gcvs_cnt , GC_variable_stack = (void * * ) (void * ) (* pp -> print_escape ) . gcvs , scheme_jit_longjmp ((* pp -> print_escape ) . jb , 1 ) ) ; 
    }
  }
  else if ((pp -> print_position > 500 ) || ! str ) {
#   define XfOrM106_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM106(x) SETUP_XfOrM105(x)
    if (pp -> print_port ) {
#     define XfOrM107_COUNT (0+XfOrM106_COUNT)
#     define SETUP_XfOrM107(x) SETUP_XfOrM106(x)
      pp -> print_buffer [pp -> print_position ] = 0 ; 
      FUNCCALL(SETUP_XfOrM107(_), scheme_write_byte_string (pp -> print_buffer , pp -> print_position , pp -> print_port ) ); 
      pp -> print_position = 0 ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_utf8_string (PrintParams * pp , const char * str , int offset , int autolen ) {
  /* No conversion */
  print_this_string (pp , str , offset , autolen ) ; 
}
void scheme_print_bytes (Scheme_Print_Params * pp , const char * str , int offset , int len ) {
  /* No conversion */
  print_this_string (pp , str , offset , len ) ; 
}
void scheme_print_utf8 (Scheme_Print_Params * pp , const char * str , int offset , int len ) {
  /* No conversion */
  print_utf8_string (pp , str , offset , len ) ; 
}
static void print_number (PrintParams * pp , long n ) {
  /* No conversion */
  unsigned char s [4 ] ; 
  s [0 ] = (unsigned char ) (n & 0xFF ) ; 
  s [1 ] = (unsigned char ) ((n >> 8 ) & 0xFF ) ; 
  s [2 ] = (unsigned char ) ((n >> 16 ) & 0xFF ) ; 
  s [3 ] = (unsigned char ) ((n >> 24 ) & 0xFF ) ; 
  print_this_string (pp , (char * ) s , 0 , 4 ) ; 
}
static void print_short_number (PrintParams * pp , long n ) {
  /* No conversion */
  unsigned char s [2 ] ; 
  s [0 ] = (unsigned char ) (n & 0xFF ) ; 
  s [1 ] = (unsigned char ) ((n >> 8 ) & 0xFF ) ; 
  print_this_string (pp , (char * ) s , 0 , 2 ) ; 
}
static void print_one_byte (PrintParams * pp , int n ) {
  /* No conversion */
  unsigned char s [1 ] ; 
  s [0 ] = n ; 
  print_this_string (pp , (char * ) s , 0 , 1 ) ; 
}
static void print_compact_number (PrintParams * pp , long n ) {
  unsigned char s [2 ] ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM122_COUNT (1)
# define SETUP_XfOrM122(x) SETUP(XfOrM122_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (n < 0 ) {
#   define XfOrM126_COUNT (0+XfOrM122_COUNT)
#   define SETUP_XfOrM126(x) SETUP_XfOrM122(x)
    if (n > - 32 ) {
#     define XfOrM128_COUNT (0+XfOrM126_COUNT)
#     define SETUP_XfOrM128(x) SETUP_XfOrM126(x)
      s [0 ] = (unsigned char ) (0xC0 | (- n ) ) ; 
      FUNCCALL(SETUP_XfOrM128(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      RET_NOTHING ; 
    }
    else {
      n = - n ; 
      s [0 ] = 0xE0 ; 
    }
  }
  else if (n < 128 ) {
#   define XfOrM125_COUNT (0+XfOrM122_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM122(x)
    s [0 ] = (unsigned char ) n ; 
    FUNCCALL(SETUP_XfOrM125(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    RET_NOTHING ; 
  }
  else if (n < 0x4000 ) {
#   define XfOrM124_COUNT (0+XfOrM122_COUNT)
#   define SETUP_XfOrM124(x) SETUP_XfOrM122(x)
    s [0 ] = (unsigned char ) (0x80 | (n & 0x3F ) ) ; 
    s [1 ] = (unsigned char ) ((n >> 6 ) & 0xFF ) ; 
    FUNCCALL(SETUP_XfOrM124(_), print_this_string (pp , (char * ) s , 0 , 2 ) ); 
    RET_NOTHING ; 
  }
  else {
    s [0 ] = 0xF0 ; 
  }
  FUNCCALL(SETUP_XfOrM122(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
  FUNCCALL_EMPTY(print_number (pp , n ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void do_print_string (int compact , int notdisplay , Scheme_Print_Params * pp , const mzchar * s , int offset , int l ) {
  int el , reset ; 
  char * buf ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(buf, 1), PUSH(pp, 2)));
# define XfOrM129_COUNT (3)
# define SETUP_XfOrM129(x) SETUP(XfOrM129_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buf = NULLED_OUT ; 
  el = l * 6 ; 
  if (el <= 256 ) {
#   define XfOrM133_COUNT (0+XfOrM129_COUNT)
#   define SETUP_XfOrM133(x) SETUP_XfOrM129(x)
    if (quick_encode_buffer ) {
      buf = quick_encode_buffer ; 
      quick_encode_buffer = ((void * ) 0 ) ; 
    }
    else buf = (char * ) FUNCCALL(SETUP_XfOrM133(_), GC_malloc_atomic (256 ) ); 
    reset = 1 ; 
  }
  else {
#   define XfOrM132_COUNT (0+XfOrM129_COUNT)
#   define SETUP_XfOrM132(x) SETUP_XfOrM129(x)
    buf = (char * ) FUNCCALL(SETUP_XfOrM132(_), GC_malloc_atomic (el ) ); 
    reset = 0 ; 
  }
  el = FUNCCALL(SETUP_XfOrM129(_), scheme_utf8_encode (s , offset , offset + l , (unsigned char * ) buf , 0 , 0 ) ); 
  if (compact ) {
#   define XfOrM131_COUNT (0+XfOrM129_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM129(x)
    FUNCCALL(SETUP_XfOrM131(_), print_this_string (pp , & compacts [CPT_CHAR_STRING ] , 0 , 1 ) ); 
    FUNCCALL(SETUP_XfOrM131(_), print_compact_number (pp , el ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , l ) ); 
    FUNCCALL_AGAIN(print_this_string (pp , buf , 0 , el ) ); 
  }
  else {
#   define XfOrM130_COUNT (0+XfOrM129_COUNT)
#   define SETUP_XfOrM130(x) SETUP_XfOrM129(x)
    FUNCCALL(SETUP_XfOrM130(_), print_char_string (buf , el , s , offset , l , notdisplay , 0 , pp ) ); 
  }
  if (reset )
    quick_encode_buffer = buf ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_print_string (Scheme_Print_Params * pp , const mzchar * s , int offset , int l ) {
  /* No conversion */
  do_print_string (0 , 0 , pp , s , offset , l ) ; 
}
static void print_string_in_angle (PrintParams * pp , const char * start , const char * prefix , int slen ) {
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(start, 0), PUSH(pp, 1)));
# define XfOrM136_COUNT (2)
# define SETUP_XfOrM136(x) SETUP(XfOrM136_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM136(_), print_utf8_string (pp , prefix , 0 , - 1 ) ); 
  FUNCCALL_EMPTY(print_utf8_string (pp , start , 0 , slen ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * print_k (void ) {
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p -> ku . k . p3 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p5 ; 
  mz_jmp_buf * volatile save ; 
  mz_jmp_buf newbuf ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(mt, 1), PUSH(save, 2), PUSH(pp, 3), PUSH(p, 4), PUSH(o, 5)));
# define XfOrM137_COUNT (6)
# define SETUP_XfOrM137(x) SETUP(XfOrM137_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  save = NULLED_OUT ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 
  save = pp -> print_escape ; 
  pp -> print_escape = & newbuf ; 
  if (((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#   define XfOrM139_COUNT (0+XfOrM137_COUNT)
#   define SETUP_XfOrM139(x) SETUP_XfOrM137(x)
    FUNCCALL(SETUP_XfOrM139(_), scheme_make_pair (scheme_void , scheme_void ) ); 
    pp -> print_escape = save ; 
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
  else {
#   define XfOrM138_COUNT (0+XfOrM137_COUNT)
#   define SETUP_XfOrM138(x) SETUP_XfOrM137(x)
    RET_VALUE_START (FUNCCALL_EMPTY(print (o , p -> ku . k . i1 , p -> ku . k . i2 , ht , mt , pp ) )? scheme_true : scheme_false ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int compare_keys (const void * a , const void * b ) {
  /* No conversion */
  Scheme_Object * av , * bv ; 
  av = ((Scheme_Object * * ) a ) [0 ] ; 
  bv = ((Scheme_Object * * ) b ) [0 ] ; 
  if ((((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((Scheme_Type ) (((((long ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_module_index_type ) ) ) ) {
    if (! (((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_module_index_type ) ) ) )
      return - 1 ; 
  }
  else if ((((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((Scheme_Type ) (((((long ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_module_index_type ) ) ) )
    return 1 ; 
  return ((long * ) a ) [1 ] - ((long * ) b ) [1 ] ; 
}
static void sort_referenced_keys (Scheme_Marshal_Tables * mt ) {
  long j , size , pos = 0 ; 
  Scheme_Object * * keys ; 
  Scheme_Hash_Table * key_map ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(key_map, 1), PUSH(keys, 2)));
# define XfOrM142_COUNT (3)
# define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  keys = NULLED_OUT ; 
  key_map = NULLED_OUT ; 
  size = mt -> st_refs -> count ; 
  keys = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM142(_), GC_malloc (sizeof (Scheme_Object * ) * ((2 * size ) ) ) )) ; 
  for (j = 0 ; j < mt -> st_refs -> size ; j ++ ) {
    if (mt -> st_refs -> vals [j ] ) {
      keys [pos ] = mt -> st_refs -> keys [j ] ; 
      keys [pos + 1 ] = mt -> st_refs -> vals [j ] ; 
      pos += 2 ; 
    }
  }
  FUNCCALL(SETUP_XfOrM142(_), qsort (keys , size , 2 * sizeof (Scheme_Object * ) , compare_keys ) ); 
  key_map = FUNCCALL(SETUP_XfOrM142(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  for (j = 0 ; j < size ; j ++ ) {
#   define XfOrM144_COUNT (0+XfOrM142_COUNT)
#   define SETUP_XfOrM144(x) SETUP_XfOrM142(x)
    FUNCCALL(SETUP_XfOrM144(_), scheme_hash_set (key_map , keys [(j << 1 ) + 1 ] , ((Scheme_Object * ) (void * ) (long ) ((((long ) (j + 1 ) ) << 1 ) | 0x1 ) ) ) ); 
  }
  mt -> key_map = key_map ; 
  mt -> sorted_keys = keys ; 
  mt -> sorted_keys_count = size ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_table_keys (int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp ) {
  long j , size , offset ; 
  Scheme_Object * * keys , * key , * obj ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(obj, 1), PUSH(key, 2), PUSH(mt, 3), PUSH(pp, 4), PUSH(keys, 5)));
# define XfOrM149_COUNT (6)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  keys = NULLED_OUT ; 
  key = NULLED_OUT ; 
  obj = NULLED_OUT ; 
  size = mt -> sorted_keys_count ; 
  keys = mt -> sorted_keys ; 
  for (j = 0 ; j < size ; j ++ ) {
#   define XfOrM153_COUNT (0+XfOrM149_COUNT)
#   define SETUP_XfOrM153(x) SETUP_XfOrM149(x)
    offset = pp -> print_offset ; 
    mt -> shared_offsets [j ] = offset ; 
    key = keys [j << 1 ] ; 
    if (mt -> rn_saved ) {
#     define XfOrM155_COUNT (0+XfOrM153_COUNT)
#     define SETUP_XfOrM155(x) SETUP_XfOrM153(x)
      obj = FUNCCALL(SETUP_XfOrM155(_), scheme_hash_get (mt -> rn_saved , key ) ); 
    }
    else {
      obj = ((void * ) 0 ) ; 
    }
    if (! obj )
      obj = key ; 
    mt -> print_now = j + 1 ; 
    FUNCCALL(SETUP_XfOrM153(_), print (obj ? obj : key , notdisplay , compact , ht , mt , pp ) ); 
    mt -> print_now = 0 ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int print_substring (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp , char * * result , long * rlen , int print_keys , long * klen ) {
  int closed ; 
  long save_alloc , save_pos , save_off , save_maxl ; 
  char * save_buf ; 
  Scheme_Object * save_port ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(mt, 1), PUSH(save_port, 2), PUSH(save_buf, 3), PUSH(obj, 4), PUSH(klen, 5), PUSH(rlen, 6), PUSH(result, 7), PUSH(pp, 8)));
# define XfOrM156_COUNT (9)
# define SETUP_XfOrM156(x) SETUP(XfOrM156_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  save_buf = NULLED_OUT ; 
  save_port = NULLED_OUT ; 
  save_alloc = pp -> print_allocated ; 
  save_buf = pp -> print_buffer ; 
  save_pos = pp -> print_position ; 
  save_off = pp -> print_offset ; 
  save_maxl = pp -> print_maxlen ; 
  save_port = pp -> print_port ; 
  if (result ) {
    char * ca ; 
    BLOCK_SETUP((PUSH(ca, 0+XfOrM156_COUNT)));
#   define XfOrM160_COUNT (1+XfOrM156_COUNT)
#   define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
    ca = NULLED_OUT ; 
    pp -> print_allocated = 50 ; 
    ca = (char * ) FUNCCALL(SETUP_XfOrM160(_), GC_malloc_atomic (pp -> print_allocated ) ); 
    pp -> print_buffer = ca ; 
  }
  else {
    pp -> print_allocated = 0 ; 
    pp -> print_buffer = ((void * ) 0 ) ; 
  }
  pp -> print_position = 0 ; 
  pp -> print_offset = 0 ; 
  pp -> print_port = ((void * ) 0 ) ; 
  if (print_keys < 0 ) {
#   define XfOrM158_COUNT (0+XfOrM156_COUNT)
#   define SETUP_XfOrM158(x) SETUP_XfOrM156(x)
    FUNCCALL(SETUP_XfOrM158(_), print_table_keys (notdisplay , compact , ht , mt , pp ) ); 
    * klen = pp -> print_offset ; 
  }
  closed = FUNCCALL(SETUP_XfOrM156(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 
  if (print_keys > 0 ) {
#   define XfOrM157_COUNT (0+XfOrM156_COUNT)
#   define SETUP_XfOrM157(x) SETUP_XfOrM156(x)
    FUNCCALL(SETUP_XfOrM157(_), print_table_keys (notdisplay , compact , ht , mt , pp ) ); 
    * klen = pp -> print_offset ; 
  }
  if (result )
    * result = pp -> print_buffer ; 
  * rlen = pp -> print_position ; 
  pp -> print_allocated = save_alloc ; 
  pp -> print_buffer = save_buf ; 
  pp -> print_position = save_pos ; 
  pp -> print_offset = save_off ; 
  pp -> print_maxlen = save_maxl ; 
  pp -> print_port = save_port ; 
  RET_VALUE_START (closed ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * get_symtab_idx (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  Scheme_Object * idx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(idx, 1), PUSH(obj, 2)));
# define XfOrM161_COUNT (3)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  idx = NULLED_OUT ; 
  idx = FUNCCALL(SETUP_XfOrM161(_), scheme_hash_get (mt -> symtab , obj ) ); 
  if (idx ) {
#   define XfOrM165_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM165(x) SETUP_XfOrM161(x)
    if (! mt -> pass ) {
#     define XfOrM166_COUNT (0+XfOrM165_COUNT)
#     define SETUP_XfOrM166(x) SETUP_XfOrM165(x)
      FUNCCALL(SETUP_XfOrM166(_), scheme_hash_set (mt -> st_refs , obj , idx ) ); 
    }
  }
  else {
#   define XfOrM162_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM162(x) SETUP_XfOrM161(x)
    if (mt -> pass && mt -> print_now ) {
#     define XfOrM163_COUNT (0+XfOrM162_COUNT)
#     define SETUP_XfOrM163(x) SETUP_XfOrM162(x)
      idx = FUNCCALL(SETUP_XfOrM163(_), scheme_hash_get (mt -> st_refs , obj ) ); 
      if (idx ) {
#       define XfOrM164_COUNT (0+XfOrM163_COUNT)
#       define SETUP_XfOrM164(x) SETUP_XfOrM163(x)
        idx = FUNCCALL(SETUP_XfOrM164(_), scheme_hash_get (mt -> key_map , idx ) ); 
        if ((((long ) (idx ) ) >> 1 ) != mt -> print_now )
          RET_VALUE_START (idx ) RET_VALUE_END ; 
        idx = ((void * ) 0 ) ; 
      }
    }
  }
  RET_VALUE_START (idx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void set_symtab_shared (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  /* No conversion */
  (void ) get_symtab_idx (mt , obj ) ; 
}
static void print_general_symtab_ref (PrintParams * pp , Scheme_Object * idx , int cpt_id ) {
  int l ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(idx, 0), PUSH(pp, 1)));
# define XfOrM168_COUNT (2)
# define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM168(_), print_this_string (pp , & compacts [cpt_id ] , 0 , 1 ) ); 
  l = (((long ) (idx ) ) >> 1 ) ; 
  FUNCCALL_EMPTY(print_compact_number (pp , l ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_symtab_ref (PrintParams * pp , Scheme_Object * idx ) {
  /* No conversion */
  print_general_symtab_ref (pp , idx , CPT_SYMREF ) ; 
}
static int add_symtab (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(mt, 1)));
# define XfOrM170_COUNT (2)
# define SETUP_XfOrM170(x) SETUP(XfOrM170_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (! mt -> pass ) {
    int l ; 
#   define XfOrM175_COUNT (0+XfOrM170_COUNT)
#   define SETUP_XfOrM175(x) SETUP_XfOrM170(x)
    l = mt -> symtab -> count + 1 ; 
    FUNCCALL(SETUP_XfOrM175(_), scheme_hash_set (mt -> symtab , obj , ((Scheme_Object * ) (void * ) (long ) ((((long ) (l ) ) << 1 ) | 0x1 ) ) ) ); 
    RET_VALUE_START (l ) RET_VALUE_END ; 
  }
  else {
    Scheme_Object * key , * l ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM170_COUNT), PUSH(key, 1+XfOrM170_COUNT)));
#   define XfOrM171_COUNT (2+XfOrM170_COUNT)
#   define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)
    key = NULLED_OUT ; 
    l = NULLED_OUT ; 
    key = FUNCCALL(SETUP_XfOrM171(_), scheme_hash_get (mt -> st_refs , obj ) ); 
    for (l = mt -> st_ref_stack ; ! key && ((Scheme_Type ) (((((long ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM174_COUNT (0+XfOrM171_COUNT)
#     define SETUP_XfOrM174(x) SETUP_XfOrM171(x)
      key = FUNCCALL(SETUP_XfOrM174(_), scheme_hash_get ((Scheme_Hash_Table * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , obj ) ); 
    }
    if (! key ) {
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    key = FUNCCALL(SETUP_XfOrM171(_), scheme_hash_get (mt -> key_map , key ) ); 
    FUNCCALL(SETUP_XfOrM171(_), scheme_hash_set (mt -> symtab , obj , key ) ); 
    RET_VALUE_START ((((long ) (key ) ) >> 1 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void symtab_set (PrintParams * pp , Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  /* No conversion */
  (void ) add_symtab (mt , obj ) ; 
}
static void print_symtab_set (PrintParams * pp , Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  int l ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM177_COUNT (1)
# define SETUP_XfOrM177(x) SETUP(XfOrM177_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = FUNCCALL(SETUP_XfOrM177(_), add_symtab (mt , obj ) ); 
  FUNCCALL_EMPTY(print_compact_number (pp , l ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_marshal_wrap_set (Scheme_Marshal_Tables * mt , Scheme_Object * obj , Scheme_Object * val ) {
  int l ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(val, 1), PUSH(obj, 2)));
# define XfOrM178_COUNT (3)
# define SETUP_XfOrM178(x) SETUP(XfOrM178_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = FUNCCALL(SETUP_XfOrM178(_), add_symtab (mt , obj ) ); 
  if (l ) {
#   define XfOrM179_COUNT (0+XfOrM178_COUNT)
#   define SETUP_XfOrM179(x) SETUP_XfOrM178(x)
    if (! mt -> rn_saved ) {
      Scheme_Hash_Table * rn_saved ; 
      BLOCK_SETUP((PUSH(rn_saved, 0+XfOrM179_COUNT)));
#     define XfOrM181_COUNT (1+XfOrM179_COUNT)
#     define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
      rn_saved = NULLED_OUT ; 
      rn_saved = FUNCCALL(SETUP_XfOrM181(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> rn_saved = rn_saved ; 
    }
    if (mt -> pass >= 2 ) {
    }
    else FUNCCALL(SETUP_XfOrM179(_), scheme_hash_set (mt -> rn_saved , obj , val ) ); 
    if (mt -> pass )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (long ) ((((long ) (l ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  }
  RET_VALUE_START (val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_marshal_lookup (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  /* No conversion */
  return get_symtab_idx (mt , obj ) ; 
}
void scheme_marshal_using_key (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) {
  /* No conversion */
  set_symtab_shared (mt , obj ) ; 
}
void scheme_marshal_push_refs (Scheme_Marshal_Tables * mt ) {
  Scheme_Object * p ; 
  Scheme_Hash_Table * st_refs ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(st_refs, 1), PUSH(p, 2)));
# define XfOrM184_COUNT (3)
# define SETUP_XfOrM184(x) SETUP(XfOrM184_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  st_refs = NULLED_OUT ; 
  p = FUNCCALL(SETUP_XfOrM184(_), scheme_make_pair ((Scheme_Object * ) mt -> st_refs , mt -> st_ref_stack ) ); 
  mt -> st_ref_stack = p ; 
  st_refs = FUNCCALL(SETUP_XfOrM184(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  mt -> st_refs = st_refs ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_marshal_pop_refs (Scheme_Marshal_Tables * mt , int keep ) {
  Scheme_Hash_Table * st_refs = mt -> st_refs ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(st_refs, 0), PUSH(mt, 1)));
# define XfOrM185_COUNT (2)
# define SETUP_XfOrM185(x) SETUP(XfOrM185_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  mt -> st_refs = (Scheme_Hash_Table * ) (((Scheme_Simple_Object * ) (mt -> st_ref_stack ) ) -> u . pair_val . car ) ; 
  mt -> st_ref_stack = (((Scheme_Simple_Object * ) (mt -> st_ref_stack ) ) -> u . pair_val . cdr ) ; 
  if (keep ) {
#   define XfOrM186_COUNT (0+XfOrM185_COUNT)
#   define SETUP_XfOrM186(x) SETUP_XfOrM185(x)
    if (! mt -> st_refs -> count )
      mt -> st_refs = st_refs ; 
    else {
      long i ; 
#     define XfOrM187_COUNT (0+XfOrM186_COUNT)
#     define SETUP_XfOrM187(x) SETUP_XfOrM186(x)
      for (i = 0 ; i < st_refs -> size ; i ++ ) {
#       define XfOrM190_COUNT (0+XfOrM187_COUNT)
#       define SETUP_XfOrM190(x) SETUP_XfOrM187(x)
        if (st_refs -> vals [i ] ) {
#         define XfOrM191_COUNT (0+XfOrM190_COUNT)
#         define SETUP_XfOrM191(x) SETUP_XfOrM190(x)
          FUNCCALL(SETUP_XfOrM191(_), scheme_hash_set (mt -> st_refs , st_refs -> keys [i ] , st_refs -> vals [i ] ) ); 
        }
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_escaped (PrintParams * pp , int notdisplay , Scheme_Object * obj , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , int shared ) {
  char * r ; 
  long len ; 
  Scheme_Object * idx ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(mt, 1), PUSH(idx, 2), PUSH(obj, 3), PUSH(r, 4), PUSH(pp, 5)));
# define XfOrM192_COUNT (6)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  idx = NULLED_OUT ; 
  if (shared ) {
#   define XfOrM194_COUNT (0+XfOrM192_COUNT)
#   define SETUP_XfOrM194(x) SETUP_XfOrM192(x)
    idx = FUNCCALL(SETUP_XfOrM194(_), get_symtab_idx (mt , obj ) ); 
    if (idx ) {
#     define XfOrM195_COUNT (0+XfOrM194_COUNT)
#     define SETUP_XfOrM195(x) SETUP_XfOrM194(x)
      FUNCCALL(SETUP_XfOrM195(_), print_symtab_ref (pp , idx ) ); 
      RET_NOTHING ; 
    }
  }
  FUNCCALL(SETUP_XfOrM192(_), print_substring (obj , notdisplay , 0 , ht , ((void * ) 0 ) , pp , & r , & len , 0 , ((void * ) 0 ) ) ); 
  FUNCCALL(SETUP_XfOrM192(_), print_this_string (pp , & compacts [CPT_ESCAPE ] , 0 , 1 ) ); 
  FUNCCALL_AGAIN(print_compact_number (pp , len ) ); 
  FUNCCALL_AGAIN(print_this_string (pp , r , 0 , len ) ); 
  if (mt ) {
#   define XfOrM193_COUNT (0+XfOrM192_COUNT)
#   define SETUP_XfOrM193(x) SETUP_XfOrM192(x)
    FUNCCALL(SETUP_XfOrM193(_), symtab_set (pp , mt , obj ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void cannot_print (PrintParams * pp , int notdisplay , Scheme_Object * obj , Scheme_Hash_Table * ht , int compact ) {
  /* No conversion */
  scheme_raise_exn (MZEXN_FAIL , (compact ? "%s: cannot marshal constant that is embedded in compiled code: %V" : "%s: printing disabled for unreadable value: %V" ) , notdisplay ? "write" : "display" , obj ) ; 
}
static void print_named (Scheme_Object * obj , const char * kind , const char * s , int len , PrintParams * pp ) {
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(pp, 1), PUSH(kind, 2)));
# define XfOrM197_COUNT (3)
# define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM197(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
  FUNCCALL(SETUP_XfOrM197(_), print_utf8_string (pp , kind , 0 , - 1 ) ); 
  if (s ) {
#   define XfOrM198_COUNT (0+XfOrM197_COUNT)
#   define SETUP_XfOrM198(x) SETUP_XfOrM197(x)
    FUNCCALL(SETUP_XfOrM198(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
    FUNCCALL(SETUP_XfOrM198(_), print_utf8_string (pp , s , 0 , len ) ); 
  }
  ; 
  FUNCCALL_EMPTY(print_utf8_string (pp , ">" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void always_scheme (PrintParams * pp , int reset ) {
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM199_COUNT (1)
# define SETUP_XfOrM199(x) SETUP(XfOrM199_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (pp -> honu_mode ) {
#   define XfOrM200_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM200(x) SETUP_XfOrM199(x)
    FUNCCALL(SETUP_XfOrM200(_), print_utf8_string (pp , "#sx" , 0 , 3 ) ); 
    if (reset )
      pp -> honu_mode = 0 ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int print (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp ) {
  int closed = 0 ; 
  int save_honu_mode ; 
  char * __funcarg33 = NULLED_OUT ; 
  char * __funcarg32 = NULLED_OUT ; 
  Scheme_Object * __funcarg31 = NULLED_OUT ; 
  Scheme_Config * __funcarg30 = NULLED_OUT ; 
  char * __funcarg29 = NULLED_OUT ; 
  char * __funcarg28 = NULLED_OUT ; 
  char * __funcarg27 = NULLED_OUT ; 
  char * __funcarg26 = NULLED_OUT ; 
  char * __funcarg25 = NULLED_OUT ; 
  char * __funcarg24 = NULLED_OUT ; 
  Scheme_Object * __funcarg23 = NULLED_OUT ; 
  Scheme_Object * __funcarg22 = NULLED_OUT ; 
  Scheme_Object * __funcarg20 = NULLED_OUT ; 
  Scheme_Object * __funcarg19 = NULLED_OUT ; 
  Scheme_Object * __funcarg18 = NULLED_OUT ; 
  Scheme_Object * __funcarg17 = NULLED_OUT ; 
  Scheme_Object * __funcarg16 = NULLED_OUT ; 
  Scheme_Object * __funcarg15 = NULLED_OUT ; 
  Scheme_Object * __funcarg14 = NULLED_OUT ; 
  Scheme_Object * __funcarg13 = NULLED_OUT ; 
  Scheme_Object * __funcarg12 = NULLED_OUT ; 
  Scheme_Object * __funcarg11 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(ht, 1), PUSH(pp, 2), PUSH(mt, 3)));
# define XfOrM201_COUNT (4)
# define SETUP_XfOrM201(x) SETUP(XfOrM201_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  {
    static int check_counter = 20 ; 
#   define XfOrM428_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM428(x) SETUP_XfOrM201(x)
    if (! -- check_counter ) {
#     define XfOrM429_COUNT (0+XfOrM428_COUNT)
#     define SETUP_XfOrM429(x) SETUP_XfOrM428(x)
      check_counter = 20 ; 
      {
        unsigned long _stk_pos ; 
#       define XfOrM430_COUNT (0+XfOrM429_COUNT)
#       define SETUP_XfOrM430(x) SETUP_XfOrM429(x)
        _stk_pos = (unsigned long ) & _stk_pos ; 
        if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
          Scheme_Thread * p = scheme_current_thread ; 
          PrintParams * pp2 ; 
          BLOCK_SETUP((PUSH(pp2, 0+XfOrM430_COUNT), PUSH(p, 1+XfOrM430_COUNT)));
#         define XfOrM431_COUNT (2+XfOrM430_COUNT)
#         define SETUP_XfOrM431(x) SETUP(XfOrM431_COUNT)
          pp2 = NULLED_OUT ; 
          pp2 = FUNCCALL(SETUP_XfOrM431(_), copy_print_params (pp ) ); 
          p -> ku . k . p1 = (void * ) obj ; 
          p -> ku . k . i1 = notdisplay ; 
          p -> ku . k . i2 = compact ; 
          p -> ku . k . p2 = (void * ) ht ; 
          p -> ku . k . p3 = mt ; 
          p -> ku . k . p5 = pp2 ; 
          obj = FUNCCALL(SETUP_XfOrM431(_), scheme_handle_stack_overflow (print_k ) ); 
          (memcpy (pp , pp2 , sizeof (PrintParams ) ) ) ; 
          if ((((obj ) ) == (scheme_void ) ) ) {
            (((long * ) (void * ) ((* pp -> print_escape ) . gcvs ) ) [1 ] = (* pp -> print_escape ) . gcvs_cnt , GC_variable_stack = (void * * ) (void * ) (* pp -> print_escape ) . gcvs , scheme_jit_longjmp ((* pp -> print_escape ) . jb , 1 ) ) ; 
          }
          RET_VALUE_START (closed ) RET_VALUE_END ; 
        }
      }
    }
  }
  if (scheme_check_print_is_obj && ! FUNCCALL(SETUP_XfOrM201(_), scheme_check_print_is_obj (obj ) )) {
#   define XfOrM427_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM427(x) SETUP_XfOrM201(x)
    FUNCCALL(SETUP_XfOrM427(_), print_utf8_string (pp , "#<" "???" ">" , 0 , 6 ) ); 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  if (compact && ((! (((long ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_native_closure_type ) ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) || (((obj ) ) == (scheme_eof ) ) || ((Scheme_Type ) (scheme_always_evt_type ) == (Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) || ((Scheme_Type ) (scheme_never_evt_type ) == (Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) || ((Scheme_Type ) (scheme_struct_property_type ) == (Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ) ) {
    Scheme_Object * val ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM201_COUNT)));
#   define XfOrM425_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM425(x) SETUP(XfOrM425_COUNT)
    val = NULLED_OUT ; 
    val = FUNCCALL(SETUP_XfOrM425(_), scheme_hash_get (global_constants_ht , obj ) ); 
    if (val ) {
      obj = val ; 
    }
  }
  save_honu_mode = pp -> honu_mode ; 
  if (ht && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || (pp -> print_box && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) || (pp -> print_struct && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (FUNCCALL(SETUP_XfOrM201(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ) || ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && FUNCCALL(SETUP_XfOrM201(_), scheme_is_writable_struct (obj ) )) || (pp -> print_hash_table && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) ) ) ) {
    long val ; 
#   define XfOrM418_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM418(x) SETUP_XfOrM201(x)
    val = (long ) FUNCCALL(SETUP_XfOrM418(_), scheme_hash_get (ht , obj ) ); 
    if (val ) {
#     define XfOrM419_COUNT (0+XfOrM418_COUNT)
#     define SETUP_XfOrM419(x) SETUP_XfOrM418(x)
      if (val != 1 ) {
#       define XfOrM420_COUNT (0+XfOrM419_COUNT)
#       define SETUP_XfOrM420(x) SETUP_XfOrM419(x)
        if (compact ) {
#         define XfOrM424_COUNT (0+XfOrM420_COUNT)
#         define SETUP_XfOrM424(x) SETUP_XfOrM420(x)
          FUNCCALL(SETUP_XfOrM424(_), print_escaped (pp , notdisplay , obj , ht , mt , 0 ) ); 
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        }
        else {
#         define XfOrM421_COUNT (0+XfOrM420_COUNT)
#         define SETUP_XfOrM421(x) SETUP_XfOrM420(x)
          if (val > 0 ) {
#           define XfOrM423_COUNT (0+XfOrM421_COUNT)
#           define SETUP_XfOrM423(x) SETUP_XfOrM421(x)
            FUNCCALL(SETUP_XfOrM423(_), always_scheme (pp , 1 ) ); 
            (sprintf (quick_buffer , "#%ld=" , (val - 3 ) >> 1 ) ) ; 
            FUNCCALL(SETUP_XfOrM423(_), print_utf8_string (pp , quick_buffer , 0 , - 1 ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , obj , (Scheme_Object * ) (- val ) ) ); 
          }
          else {
#           define XfOrM422_COUNT (0+XfOrM421_COUNT)
#           define SETUP_XfOrM422(x) SETUP_XfOrM421(x)
            FUNCCALL(SETUP_XfOrM422(_), always_scheme (pp , 0 ) ); 
            (sprintf (quick_buffer , "#%ld#" , ((- val ) - 3 ) >> 1 ) ) ; 
            FUNCCALL(SETUP_XfOrM422(_), print_utf8_string (pp , quick_buffer , 0 , - 1 ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
      }
    }
  }
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ) {
    int l ; 
    Scheme_Object * idx ; 
    int is_kw ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM201_COUNT)));
#   define XfOrM403_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM403(x) SETUP(XfOrM403_COUNT)
    idx = NULLED_OUT ; 
    is_kw = ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ; 
    if (compact )
      idx = FUNCCALL(SETUP_XfOrM403(_), get_symtab_idx (mt , obj ) ); 
    else idx = ((void * ) 0 ) ; 
    if (idx ) {
#     define XfOrM417_COUNT (0+XfOrM403_COUNT)
#     define SETUP_XfOrM417(x) SETUP_XfOrM403(x)
      FUNCCALL(SETUP_XfOrM417(_), print_symtab_ref (pp , idx ) ); 
    }
    else if (compact ) {
      int weird ; 
#     define XfOrM413_COUNT (0+XfOrM403_COUNT)
#     define SETUP_XfOrM413(x) SETUP_XfOrM403(x)
      weird = ((& ((Scheme_Symbol * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
      l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ; 
      if (! weird && ! is_kw && (l < (80 - 60 ) ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM416_COUNT (0+XfOrM413_COUNT)
#       define SETUP_XfOrM416(x) SETUP_XfOrM413(x)
        s [0 ] = l + 60 ; 
        FUNCCALL(SETUP_XfOrM416(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }
      else {
#       define XfOrM414_COUNT (0+XfOrM413_COUNT)
#       define SETUP_XfOrM414(x) SETUP_XfOrM413(x)
        FUNCCALL(SETUP_XfOrM414(_), print_this_string (pp , & compacts [(is_kw ? CPT_KEYWORD : (weird ? CPT_WEIRD_SYMBOL : CPT_SYMBOL ) ) ] , 0 , 1 ) ); 
        if (weird ) {
#         define XfOrM415_COUNT (0+XfOrM414_COUNT)
#         define SETUP_XfOrM415(x) SETUP_XfOrM414(x)
          FUNCCALL(SETUP_XfOrM415(_), print_compact_number (pp , ((& ((Scheme_Symbol * ) (obj ) ) -> iso ) -> so . keyex & 0x1 ) ? 1 : 0 ) ); 
        }
        FUNCCALL(SETUP_XfOrM414(_), print_compact_number (pp , l ) ); 
      }
      (__funcarg33 = FUNCCALL(SETUP_XfOrM413(_), scheme_symbol_val (obj ) ), FUNCCALL_AGAIN(print_this_string (pp , __funcarg33 , 0 , l ) )) ; 
      FUNCCALL(SETUP_XfOrM413(_), symtab_set (pp , mt , obj ) ); 
    }
    else if (notdisplay ) {
#     define XfOrM405_COUNT (0+XfOrM403_COUNT)
#     define SETUP_XfOrM405(x) SETUP_XfOrM403(x)
      if (pp -> honu_mode ) {
#       define XfOrM407_COUNT (0+XfOrM405_COUNT)
#       define SETUP_XfOrM407(x) SETUP_XfOrM405(x)
        if (is_kw )
          FUNCCALL(SETUP_XfOrM407(_), print_utf8_string (pp , "key(" , 0 , 4 ) ); 
        else FUNCCALL(SETUP_XfOrM407(_), print_utf8_string (pp , "sym(" , 0 , 4 ) ); 
        {
          int i ; 
#         define XfOrM408_COUNT (0+XfOrM407_COUNT)
#         define SETUP_XfOrM408(x) SETUP_XfOrM407(x)
          for (i = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ; i -- ; ) {
            if (((unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> s ) ) [i ] > 127 )
              break ; 
          }
          if (i < 0 ) {
#           define XfOrM410_COUNT (0+XfOrM408_COUNT)
#           define SETUP_XfOrM410(x) SETUP_XfOrM408(x)
            FUNCCALL(SETUP_XfOrM410(_), print_byte_string ((char * ) obj , ((unsigned long ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> s ) - (unsigned long ) (obj ) ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) , notdisplay , pp ) ); 
          }
          else {
            Scheme_Object * s ; 
            BLOCK_SETUP((PUSH(s, 0+XfOrM408_COUNT)));
#           define XfOrM409_COUNT (1+XfOrM408_COUNT)
#           define SETUP_XfOrM409(x) SETUP(XfOrM409_COUNT)
            s = NULLED_OUT ; 
            s = FUNCCALL(SETUP_XfOrM409(_), scheme_make_sized_offset_utf8_string ((char * ) obj , ((unsigned long ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> s ) - (unsigned long ) (obj ) ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ) ); 
            FUNCCALL_AGAIN(do_print_string (0 , notdisplay , pp , (((Scheme_Simple_Object * ) (s ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (s ) ) -> u . char_str_val . tag_val ) ) ); 
          }
        }
        FUNCCALL(SETUP_XfOrM407(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
      }
      else {
        const char * s ; 
        BLOCK_SETUP((PUSH(s, 0+XfOrM405_COUNT)));
#       define XfOrM406_COUNT (1+XfOrM405_COUNT)
#       define SETUP_XfOrM406(x) SETUP(XfOrM406_COUNT)
        s = NULLED_OUT ; 
        if (is_kw )
          FUNCCALL(SETUP_XfOrM406(_), print_utf8_string (pp , "#:" , 0 , 2 ) ); 
        s = FUNCCALL(SETUP_XfOrM406(_), scheme_symbol_name_and_size (obj , (unsigned int * ) & l , ((pp -> can_read_pipe_quote ? 0x2 : 0x4 ) | (pp -> case_sens ? 0 : 0x8 ) | (is_kw ? 0x10 : 0 ) ) ) ); 
        FUNCCALL_AGAIN(print_utf8_string (pp , s , 0 , l ) ); 
      }
    }
    else {
#     define XfOrM404_COUNT (0+XfOrM403_COUNT)
#     define SETUP_XfOrM404(x) SETUP_XfOrM403(x)
      if (is_kw )
        FUNCCALL(SETUP_XfOrM404(_), print_utf8_string (pp , "#:" , 0 , 2 ) ); 
      FUNCCALL(SETUP_XfOrM404(_), print_utf8_string (pp , (char * ) obj , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> s ) ) ) - ((char * ) obj ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ) {
#   define XfOrM397_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM397(x) SETUP_XfOrM201(x)
    if (compact ) {
      int l ; 
      Scheme_Object * idx ; 
      BLOCK_SETUP((PUSH(idx, 0+XfOrM397_COUNT)));
#     define XfOrM400_COUNT (1+XfOrM397_COUNT)
#     define SETUP_XfOrM400(x) SETUP(XfOrM400_COUNT)
      idx = NULLED_OUT ; 
      idx = FUNCCALL(SETUP_XfOrM400(_), get_symtab_idx (mt , obj ) ); 
      if (idx ) {
#       define XfOrM402_COUNT (0+XfOrM400_COUNT)
#       define SETUP_XfOrM402(x) SETUP_XfOrM400(x)
        FUNCCALL(SETUP_XfOrM402(_), print_symtab_ref (pp , idx ) ); 
      }
      else {
#       define XfOrM401_COUNT (0+XfOrM400_COUNT)
#       define SETUP_XfOrM401(x) SETUP_XfOrM400(x)
        FUNCCALL(SETUP_XfOrM401(_), print_this_string (pp , & compacts [CPT_BYTE_STRING ] , 0 , 1 ) ); 
        l = (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) ; 
        FUNCCALL(SETUP_XfOrM401(_), print_compact_number (pp , l ) ); 
        FUNCCALL_AGAIN(print_this_string (pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
        FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) ); 
      }
    }
    else {
#     define XfOrM398_COUNT (0+XfOrM397_COUNT)
#     define SETUP_XfOrM398(x) SETUP_XfOrM397(x)
      if (notdisplay ) {
#       define XfOrM399_COUNT (0+XfOrM398_COUNT)
#       define SETUP_XfOrM399(x) SETUP_XfOrM398(x)
        FUNCCALL(SETUP_XfOrM399(_), always_scheme (pp , 0 ) ); 
        FUNCCALL(SETUP_XfOrM399(_), print_utf8_string (pp , "#" , 0 , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM398(_), print_byte_string ((((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) , notdisplay , pp ) ); 
      closed = 1 ; 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM201_COUNT)));
#   define XfOrM394_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM394(x) SETUP(XfOrM394_COUNT)
    idx = NULLED_OUT ; 
    if (compact )
      idx = FUNCCALL(SETUP_XfOrM394(_), get_symtab_idx (mt , obj ) ); 
    else idx = ((void * ) 0 ) ; 
    if (idx ) {
#     define XfOrM396_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM396(x) SETUP_XfOrM394(x)
      FUNCCALL(SETUP_XfOrM396(_), print_symtab_ref (pp , idx ) ); 
    }
    else {
#     define XfOrM395_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM395(x) SETUP_XfOrM394(x)
      FUNCCALL(SETUP_XfOrM395(_), do_print_string (compact , notdisplay , pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . tag_val ) ) ); 
      if (compact )
        FUNCCALL(SETUP_XfOrM395(_), symtab_set (pp , mt , obj ) ); 
    }
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) ) {
#   define XfOrM391_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM391(x) SETUP_XfOrM201(x)
    if (compact ) {
      int cv ; 
#     define XfOrM393_COUNT (0+XfOrM391_COUNT)
#     define SETUP_XfOrM393(x) SETUP_XfOrM391(x)
      FUNCCALL(SETUP_XfOrM393(_), print_this_string (pp , & compacts [CPT_CHAR ] , 0 , 1 ) ); 
      cv = (((Scheme_Small_Object * ) (obj ) ) -> u . char_val ) ; 
      FUNCCALL(SETUP_XfOrM393(_), print_compact_number (pp , cv ) ); 
    }
    else if (notdisplay && pp -> honu_mode ) {
      char s [6 ] ; 
      mzchar us [1 ] ; 
      int l ; 
#     define XfOrM392_COUNT (0+XfOrM391_COUNT)
#     define SETUP_XfOrM392(x) SETUP_XfOrM391(x)
      us [0 ] = (((Scheme_Small_Object * ) (obj ) ) -> u . char_val ) ; 
      l = FUNCCALL(SETUP_XfOrM392(_), scheme_utf8_encode (us , 0 , 1 , (unsigned char * ) s , 0 , 0 ) ); 
      FUNCCALL_AGAIN(print_char_string (s , l , us , 0 , 1 , notdisplay , 1 , pp ) ); 
    }
    else FUNCCALL(SETUP_XfOrM391(_), print_char (obj , notdisplay , pp ) ); 
  }
  else if ((((long ) (obj ) ) & 0x1 ) ) {
#   define XfOrM384_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM384(x) SETUP_XfOrM201(x)
    if (compact ) {
      long v = (((long ) (obj ) ) >> 1 ) ; 
#     define XfOrM386_COUNT (0+XfOrM384_COUNT)
#     define SETUP_XfOrM386(x) SETUP_XfOrM384(x)
      if (v >= 0 && v < (60 - 35 ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM390_COUNT (0+XfOrM386_COUNT)
#       define SETUP_XfOrM390(x) SETUP_XfOrM386(x)
        s [0 ] = (unsigned char ) (v + 35 ) ; 
        FUNCCALL(SETUP_XfOrM390(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }
      else {
#       define XfOrM387_COUNT (0+XfOrM386_COUNT)
#       define SETUP_XfOrM387(x) SETUP_XfOrM386(x)
        if ((v >= - 1073741824 ) && (v <= 1073741823 ) ) {
#         define XfOrM389_COUNT (0+XfOrM387_COUNT)
#         define SETUP_XfOrM389(x) SETUP_XfOrM387(x)
          FUNCCALL(SETUP_XfOrM389(_), print_this_string (pp , & compacts [CPT_INT ] , 0 , 1 ) ); 
          FUNCCALL(SETUP_XfOrM389(_), print_compact_number (pp , v ) ); 
        }
        else {
#         define XfOrM388_COUNT (0+XfOrM387_COUNT)
#         define SETUP_XfOrM388(x) SETUP_XfOrM387(x)
          FUNCCALL(SETUP_XfOrM388(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) ); 
        }
      }
    }
    else {
#     define XfOrM385_COUNT (0+XfOrM384_COUNT)
#     define SETUP_XfOrM385(x) SETUP_XfOrM384(x)
      (sprintf (quick_buffer , "%ld" , (((long ) (obj ) ) >> 1 ) ) ) ; 
      FUNCCALL(SETUP_XfOrM385(_), print_utf8_string (pp , quick_buffer , 0 , - 1 ) ); 
    }
  }
  else if (((((long ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) ) {
#   define XfOrM381_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM381(x) SETUP_XfOrM201(x)
    if (compact ) {
#     define XfOrM383_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM383(x) SETUP_XfOrM381(x)
      FUNCCALL(SETUP_XfOrM383(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) ); 
      closed = 1 ; 
    }
    else {
#     define XfOrM382_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM382(x) SETUP_XfOrM381(x)
      if ((! (((long ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) == scheme_complex_type ) ) ) )
        FUNCCALL(SETUP_XfOrM382(_), always_scheme (pp , 0 ) ); 
      (__funcarg32 = FUNCCALL(SETUP_XfOrM382(_), scheme_number_to_string (10 , obj ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg32 , 0 , - 1 ) )) ; 
    }
  }
  else if (((obj ) == (scheme_null ) ) ) {
#   define XfOrM378_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM378(x) SETUP_XfOrM201(x)
    if (compact ) {
#     define XfOrM380_COUNT (0+XfOrM378_COUNT)
#     define SETUP_XfOrM380(x) SETUP_XfOrM378(x)
      FUNCCALL(SETUP_XfOrM380(_), print_this_string (pp , & compacts [CPT_NULL ] , 0 , 1 ) ); 
    }
    else {
#     define XfOrM379_COUNT (0+XfOrM378_COUNT)
#     define SETUP_XfOrM379(x) SETUP_XfOrM378(x)
      if (pp -> honu_mode )
        FUNCCALL(SETUP_XfOrM379(_), print_utf8_string (pp , "null" , 0 , 4 ) ); 
      else FUNCCALL(SETUP_XfOrM379(_), print_utf8_string (pp , "()" , 0 , 2 ) ); 
      closed = 1 ; 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM377_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM377(x) SETUP_XfOrM201(x)
    FUNCCALL(SETUP_XfOrM377(_), print_pair (obj , notdisplay , compact , ht , mt , pp , scheme_pair_type , ! pp -> print_pair_curly ) ); 
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
#   define XfOrM376_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM376(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM376(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    FUNCCALL(SETUP_XfOrM376(_), print_pair (obj , notdisplay , compact , ht , mt , pp , scheme_mutable_pair_type , ! pp -> print_mpair_curly ) ); 
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#   define XfOrM375_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM375(x) SETUP_XfOrM201(x)
    FUNCCALL(SETUP_XfOrM375(_), print_vector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((compact || pp -> print_box ) && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
#   define XfOrM371_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM371(x) SETUP_XfOrM201(x)
    if (compact && ! pp -> print_box ) {
#     define XfOrM374_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM374(x) SETUP_XfOrM371(x)
      closed = (__funcarg31 = FUNCCALL(SETUP_XfOrM374(_), scheme_protect_quote (obj ) ), FUNCCALL_AGAIN(print (__funcarg31 , notdisplay , compact , ht , mt , pp ) )) ; 
    }
    else {
#     define XfOrM372_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM372(x) SETUP_XfOrM371(x)
      if (compact )
        FUNCCALL(SETUP_XfOrM372(_), print_this_string (pp , & compacts [CPT_BOX ] , 0 , 1 ) ); 
      else {
#       define XfOrM373_COUNT (0+XfOrM372_COUNT)
#       define SETUP_XfOrM373(x) SETUP_XfOrM372(x)
        FUNCCALL(SETUP_XfOrM373(_), always_scheme (pp , 1 ) ); 
        FUNCCALL(SETUP_XfOrM373(_), print_utf8_string (pp , "#&" , 0 , 2 ) ); 
      }
      closed = FUNCCALL(SETUP_XfOrM372(_), print ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , notdisplay , compact , ht , mt , pp ) ); 
    }
  }
  else if ((compact || pp -> print_hash_table ) && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) ) {
    Scheme_Hash_Table * t ; 
    Scheme_Hash_Tree * tr ; 
    Scheme_Object * * keys , * * vals , * val , * key ; 
    int i , size , did_one = 0 ; 
    BLOCK_SETUP((PUSH(tr, 0+XfOrM201_COUNT), PUSH(vals, 1+XfOrM201_COUNT), PUSH(val, 2+XfOrM201_COUNT), PUSH(key, 3+XfOrM201_COUNT), PUSH(keys, 4+XfOrM201_COUNT), PUSH(t, 5+XfOrM201_COUNT)));
#   define XfOrM350_COUNT (6+XfOrM201_COUNT)
#   define SETUP_XfOrM350(x) SETUP(XfOrM350_COUNT)
    t = NULLED_OUT ; 
    tr = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 
    if (compact ) {
#     define XfOrM370_COUNT (0+XfOrM350_COUNT)
#     define SETUP_XfOrM370(x) SETUP_XfOrM350(x)
      FUNCCALL(SETUP_XfOrM370(_), print_this_string (pp , & compacts [CPT_HASH_TABLE ] , 0 , 1 ) ); 
      if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM370(_), scheme_is_hash_table_equal (obj ) )) || (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) && FUNCCALL(SETUP_XfOrM370(_), scheme_is_hash_tree_equal (obj ) )) )
        FUNCCALL(SETUP_XfOrM370(_), print_compact_number (pp , 1 ) ); 
      else if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM370(_), scheme_is_hash_table_eqv (obj ) )) || (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) && FUNCCALL(SETUP_XfOrM370(_), scheme_is_hash_tree_eqv (obj ) )) )
        FUNCCALL(SETUP_XfOrM370(_), print_compact_number (pp , 2 ) ); 
      else FUNCCALL(SETUP_XfOrM370(_), print_compact_number (pp , 0 ) ); 
    }
    else {
#     define XfOrM365_COUNT (0+XfOrM350_COUNT)
#     define SETUP_XfOrM365(x) SETUP_XfOrM350(x)
      FUNCCALL(SETUP_XfOrM365(_), always_scheme (pp , 1 ) ); 
      FUNCCALL(SETUP_XfOrM365(_), print_utf8_string (pp , "#hash" , 0 , 5 ) ); 
      if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
#       define XfOrM368_COUNT (0+XfOrM365_COUNT)
#       define SETUP_XfOrM368(x) SETUP_XfOrM365(x)
        if (! FUNCCALL(SETUP_XfOrM368(_), scheme_is_hash_table_equal (obj ) )) {
#         define XfOrM369_COUNT (0+XfOrM368_COUNT)
#         define SETUP_XfOrM369(x) SETUP_XfOrM368(x)
          if (FUNCCALL(SETUP_XfOrM369(_), scheme_is_hash_table_eqv (obj ) ))
            FUNCCALL(SETUP_XfOrM369(_), print_utf8_string (pp , "eqv" , 0 , 3 ) ); 
          else FUNCCALL(SETUP_XfOrM369(_), print_utf8_string (pp , "eq" , 0 , 2 ) ); 
        }
      }
      else {
#       define XfOrM366_COUNT (0+XfOrM365_COUNT)
#       define SETUP_XfOrM366(x) SETUP_XfOrM365(x)
        if (! FUNCCALL(SETUP_XfOrM366(_), scheme_is_hash_tree_equal (obj ) )) {
#         define XfOrM367_COUNT (0+XfOrM366_COUNT)
#         define SETUP_XfOrM367(x) SETUP_XfOrM366(x)
          if (FUNCCALL(SETUP_XfOrM367(_), scheme_is_hash_tree_eqv (obj ) ))
            FUNCCALL(SETUP_XfOrM367(_), print_utf8_string (pp , "eqv" , 0 , 3 ) ); 
          else FUNCCALL(SETUP_XfOrM367(_), print_utf8_string (pp , "eq" , 0 , 2 ) ); 
        }
      }
      FUNCCALL(SETUP_XfOrM365(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
    }
    if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
      t = (Scheme_Hash_Table * ) obj ; 
      tr = ((void * ) 0 ) ; 
    }
    else {
      t = ((void * ) 0 ) ; 
      tr = (Scheme_Hash_Tree * ) obj ; 
    }
    if (compact )
      FUNCCALL(SETUP_XfOrM350(_), print_compact_number (pp , t ? t -> count : tr -> count ) ); 
    if (t ) {
      keys = t -> keys ; 
      vals = t -> vals ; 
      size = t -> size ; 
    }
    else {
      keys = ((void * ) 0 ) ; 
      vals = ((void * ) 0 ) ; 
      size = tr -> count ; 
    }
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM356_COUNT (0+XfOrM350_COUNT)
#     define SETUP_XfOrM356(x) SETUP_XfOrM350(x)
      if (! vals || vals [i ] ) {
#       define XfOrM357_COUNT (0+XfOrM356_COUNT)
#       define SETUP_XfOrM357(x) SETUP_XfOrM356(x)
        if (! vals ) {
#         define XfOrM360_COUNT (0+XfOrM357_COUNT)
#         define SETUP_XfOrM360(x) SETUP_XfOrM357(x)
          FUNCCALL(SETUP_XfOrM360(_), scheme_hash_tree_index (tr , i , & key , & val ) ); 
        }
        else {
          val = vals [i ] ; 
          key = keys [i ] ; 
        }
        if (! compact ) {
#         define XfOrM358_COUNT (0+XfOrM357_COUNT)
#         define SETUP_XfOrM358(x) SETUP_XfOrM357(x)
          if (did_one )
            FUNCCALL(SETUP_XfOrM358(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
          FUNCCALL(SETUP_XfOrM358(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
        }
        FUNCCALL(SETUP_XfOrM357(_), print (key , notdisplay , compact , ht , mt , pp ) ); 
        if (! compact )
          FUNCCALL(SETUP_XfOrM357(_), print_utf8_string (pp , " . " , 0 , 3 ) ); 
        FUNCCALL(SETUP_XfOrM357(_), print (val , notdisplay , compact , ht , mt , pp ) ); 
        if (! compact )
          FUNCCALL(SETUP_XfOrM357(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
        did_one ++ ; 
      }
    }
    if (! compact )
      FUNCCALL(SETUP_XfOrM350(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    closed = 1 ; 
  }
  else if (((obj ) == (scheme_true ) ) ) {
#   define XfOrM349_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM349(x) SETUP_XfOrM201(x)
    if (compact )
      FUNCCALL(SETUP_XfOrM349(_), print_this_string (pp , & compacts [CPT_TRUE ] , 0 , 1 ) ); 
    else if (pp -> honu_mode )
      FUNCCALL(SETUP_XfOrM349(_), print_utf8_string (pp , "true" , 0 , 4 ) ); 
    else FUNCCALL(SETUP_XfOrM349(_), print_utf8_string (pp , "#t" , 0 , 2 ) ); 
  }
  else if (((obj ) == (scheme_false ) ) ) {
#   define XfOrM348_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM348(x) SETUP_XfOrM201(x)
    if (compact )
      FUNCCALL(SETUP_XfOrM348(_), print_this_string (pp , & compacts [CPT_FALSE ] , 0 , 1 ) ); 
    else if (pp -> honu_mode )
      FUNCCALL(SETUP_XfOrM348(_), print_utf8_string (pp , "false" , 0 , 5 ) ); 
    else FUNCCALL(SETUP_XfOrM348(_), print_utf8_string (pp , "#f" , 0 , 2 ) ); 
  }
  else if (compact && ((obj ) == (scheme_void ) ) ) {
#   define XfOrM347_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM347(x) SETUP_XfOrM201(x)
    FUNCCALL(SETUP_XfOrM347(_), print_this_string (pp , & compacts [CPT_VOID ] , 0 , 1 ) ); 
  }
  else if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
#   define XfOrM335_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM335(x) SETUP_XfOrM201(x)
    if (compact && (((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) {
      Scheme_Object * vec , * prefab ; 
      BLOCK_SETUP((PUSH(prefab, 0+XfOrM335_COUNT), PUSH(vec, 1+XfOrM335_COUNT)));
#     define XfOrM346_COUNT (2+XfOrM335_COUNT)
#     define SETUP_XfOrM346(x) SETUP(XfOrM346_COUNT)
      vec = NULLED_OUT ; 
      prefab = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM346(_), print_this_string (pp , & compacts [CPT_PREFAB ] , 0 , 1 ) ); 
      prefab = ((Scheme_Structure * ) obj ) -> stype -> prefab_key ; 
      vec = FUNCCALL(SETUP_XfOrM346(_), scheme_struct_to_vector (obj , ((void * ) 0 ) , pp -> inspector ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (((Scheme_Simple_Object * ) (prefab ) ) -> u . pair_val . cdr ) ; 
      FUNCCALL(SETUP_XfOrM346(_), print_vector (vec , notdisplay , compact , ht , mt , pp , 1 ) ); 
    }
    else if (compact || ! pp -> print_unreadable ) {
#     define XfOrM345_COUNT (0+XfOrM335_COUNT)
#     define SETUP_XfOrM345(x) SETUP_XfOrM335(x)
      FUNCCALL(SETUP_XfOrM345(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else if (FUNCCALL(SETUP_XfOrM335(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM344_COUNT (0+XfOrM335_COUNT)
#     define SETUP_XfOrM344(x) SETUP_XfOrM335(x)
      FUNCCALL(SETUP_XfOrM344(_), custom_write_struct (obj , ht , mt , pp , notdisplay ) ); 
    }
    else {
      int pb ; 
#     define XfOrM336_COUNT (0+XfOrM335_COUNT)
#     define SETUP_XfOrM336(x) SETUP_XfOrM335(x)
      pb = pp -> print_struct && (FUNCCALL(SETUP_XfOrM336(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ; 
      if (pb ) {
        Scheme_Object * vec , * prefab ; 
        BLOCK_SETUP((PUSH(prefab, 0+XfOrM336_COUNT), PUSH(vec, 1+XfOrM336_COUNT)));
#       define XfOrM342_COUNT (2+XfOrM336_COUNT)
#       define SETUP_XfOrM342(x) SETUP(XfOrM342_COUNT)
        vec = NULLED_OUT ; 
        prefab = NULLED_OUT ; 
        prefab = ((Scheme_Structure * ) obj ) -> stype -> prefab_key ; 
        vec = FUNCCALL(SETUP_XfOrM342(_), scheme_struct_to_vector (obj , ((void * ) 0 ) , pp -> inspector ) ); 
        if (prefab ) {
          (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (((Scheme_Simple_Object * ) (prefab ) ) -> u . pair_val . cdr ) ; 
        }
        FUNCCALL(SETUP_XfOrM342(_), print_vector (vec , notdisplay , compact , ht , mt , pp , ! ! prefab ) ); 
        closed = 1 ; 
      }
      else {
        Scheme_Object * src ; 
        BLOCK_SETUP((PUSH(src, 0+XfOrM336_COUNT)));
#       define XfOrM337_COUNT (1+XfOrM336_COUNT)
#       define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
        src = NULLED_OUT ; 
        if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) {
#         define XfOrM341_COUNT (0+XfOrM337_COUNT)
#         define SETUP_XfOrM341(x) SETUP_XfOrM337(x)
          src = FUNCCALL(SETUP_XfOrM341(_), scheme_proc_struct_name_source (obj ) ); 
        }
        else src = obj ; 
        if (((src ) == (obj ) ) ) {
#         define XfOrM339_COUNT (0+XfOrM337_COUNT)
#         define SETUP_XfOrM339(x) SETUP_XfOrM337(x)
          FUNCCALL(SETUP_XfOrM339(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
          {
            int l ; 
            const char * s ; 
            Scheme_Object * name = ((((Scheme_Structure * ) obj ) -> stype ) -> name ) ; 
            BLOCK_SETUP((PUSH(s, 0+XfOrM339_COUNT)));
#           define XfOrM340_COUNT (1+XfOrM339_COUNT)
#           define SETUP_XfOrM340(x) SETUP(XfOrM340_COUNT)
            s = NULLED_OUT ; 
            s = FUNCCALL(SETUP_XfOrM340(_), scheme_symbol_name_and_size (name , (unsigned int * ) & l , (pp -> print_struct ? 0x1 : (pp -> can_read_pipe_quote ? 0x2 : 0x4 ) ) ) ); 
            FUNCCALL_AGAIN(print_utf8_string (pp , s , 0 , l ) ); 
          }
          ; 
          FUNCCALL(SETUP_XfOrM339(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
        }
        else {
#         define XfOrM338_COUNT (0+XfOrM337_COUNT)
#         define SETUP_XfOrM338(x) SETUP_XfOrM337(x)
          closed = FUNCCALL(SETUP_XfOrM338(_), print (src , notdisplay , compact , ht , mt , pp ) ); 
        }
      }
    }
    closed = 1 ; 
  }
  else if (((((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_unix_path_type ) && (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_windows_path_type ) ) ) {
#   define XfOrM322_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM322(x) SETUP_XfOrM201(x)
    if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
      Scheme_Object * idx ; 
      int l ; 
      BLOCK_SETUP((PUSH(idx, 0+XfOrM322_COUNT)));
#     define XfOrM331_COUNT (1+XfOrM322_COUNT)
#     define SETUP_XfOrM331(x) SETUP(XfOrM331_COUNT)
      idx = NULLED_OUT ; 
      idx = FUNCCALL(SETUP_XfOrM331(_), get_symtab_idx (mt , obj ) ); 
      if (idx ) {
#       define XfOrM334_COUNT (0+XfOrM331_COUNT)
#       define SETUP_XfOrM334(x) SETUP_XfOrM331(x)
        FUNCCALL(SETUP_XfOrM334(_), print_symtab_ref (pp , idx ) ); 
      }
      else {
        Scheme_Object * orig_obj = obj , * dir ; 
        BLOCK_SETUP((PUSH(dir, 0+XfOrM331_COUNT), PUSH(orig_obj, 1+XfOrM331_COUNT)));
#       define XfOrM332_COUNT (2+XfOrM331_COUNT)
#       define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
        dir = NULLED_OUT ; 
        dir = (__funcarg30 = FUNCCALL(SETUP_XfOrM332(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg30 , MZCONFIG_WRITE_DIRECTORY ) )) ; 
        if (((Scheme_Type ) (((((long ) (dir ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (dir ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM333_COUNT (0+XfOrM332_COUNT)
#         define SETUP_XfOrM333(x) SETUP_XfOrM332(x)
          obj = FUNCCALL(SETUP_XfOrM333(_), scheme_extract_relative_to (obj , dir ) ); 
        }
        FUNCCALL(SETUP_XfOrM332(_), print_this_string (pp , & compacts [CPT_PATH ] , 0 , 1 ) ); 
        l = (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) ; 
        FUNCCALL(SETUP_XfOrM332(_), print_compact_number (pp , l ) ); 
        FUNCCALL_AGAIN(print_this_string (pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
        FUNCCALL_AGAIN(symtab_set (pp , mt , orig_obj ) ); 
      }
    }
    else if (! pp -> print_unreadable ) {
#     define XfOrM330_COUNT (0+XfOrM322_COUNT)
#     define SETUP_XfOrM330(x) SETUP_XfOrM322(x)
      FUNCCALL(SETUP_XfOrM330(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
#     define XfOrM323_COUNT (0+XfOrM322_COUNT)
#     define SETUP_XfOrM323(x) SETUP_XfOrM322(x)
      if (notdisplay ) {
#       define XfOrM326_COUNT (0+XfOrM323_COUNT)
#       define SETUP_XfOrM326(x) SETUP_XfOrM323(x)
        if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM329_COUNT (0+XfOrM326_COUNT)
#         define SETUP_XfOrM329(x) SETUP_XfOrM326(x)
          FUNCCALL(SETUP_XfOrM329(_), print_utf8_string (pp , "#<path:" , 0 , 7 ) ); 
        }
        else {
#         define XfOrM327_COUNT (0+XfOrM326_COUNT)
#         define SETUP_XfOrM327(x) SETUP_XfOrM326(x)
          switch (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) {
#           define XfOrM328_COUNT (0+XfOrM327_COUNT)
#           define SETUP_XfOrM328(x) SETUP_XfOrM327(x)
            case scheme_windows_path_type : FUNCCALL(SETUP_XfOrM328(_), print_utf8_string (pp , "#<windows-path:" , 0 , 15 ) ); 
            break ; 
            default : case scheme_unix_path_type : FUNCCALL(SETUP_XfOrM328(_), print_utf8_string (pp , "#<unix-path:" , 0 , 12 ) ); 
            break ; 
          }
        }
      }
      {
        Scheme_Object * str ; 
        BLOCK_SETUP((PUSH(str, 0+XfOrM323_COUNT)));
#       define XfOrM325_COUNT (1+XfOrM323_COUNT)
#       define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
        str = NULLED_OUT ; 
        str = FUNCCALL(SETUP_XfOrM325(_), scheme_path_to_char_string (obj ) ); 
        FUNCCALL_AGAIN(print (str , 0 , 0 , ht , mt , pp ) ); 
      }
      if (notdisplay ) {
#       define XfOrM324_COUNT (0+XfOrM323_COUNT)
#       define SETUP_XfOrM324(x) SETUP_XfOrM323(x)
        ; 
        FUNCCALL(SETUP_XfOrM324(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_resolved_module_path_type ) ) ) {
#   define XfOrM319_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM319(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM321_COUNT (0+XfOrM319_COUNT)
#     define SETUP_XfOrM321(x) SETUP_XfOrM319(x)
      FUNCCALL(SETUP_XfOrM321(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
      int is_sym ; 
#     define XfOrM320_COUNT (0+XfOrM319_COUNT)
#     define SETUP_XfOrM320(x) SETUP_XfOrM319(x)
      if (notdisplay )
        FUNCCALL(SETUP_XfOrM320(_), print_utf8_string (pp , "#<resolved-module-path:" , 0 , 23 ) ); 
      is_sym = ((Scheme_Type ) (((((long ) ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ; 
      FUNCCALL(SETUP_XfOrM320(_), print_utf8_string (pp , (is_sym ? "'" : "\"" ) , 0 , 1 ) ); 
      FUNCCALL_AGAIN(print ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , 0 , 0 , ht , mt , pp ) ); 
      ; 
      if (! is_sym )
        FUNCCALL(SETUP_XfOrM320(_), print_utf8_string (pp , "\"" , 0 , 1 ) ); 
      if (notdisplay )
        FUNCCALL(SETUP_XfOrM320(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
    closed = notdisplay ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((Scheme_Primitive_Proc * ) obj ) -> name ) {
#   define XfOrM316_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM316(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM318_COUNT (0+XfOrM316_COUNT)
#     define SETUP_XfOrM318(x) SETUP_XfOrM316(x)
      FUNCCALL(SETUP_XfOrM318(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
#     define XfOrM317_COUNT (0+XfOrM316_COUNT)
#     define SETUP_XfOrM317(x) SETUP_XfOrM316(x)
      FUNCCALL(SETUP_XfOrM317(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
      FUNCCALL(SETUP_XfOrM317(_), print_string_in_angle (pp , ((Scheme_Primitive_Proc * ) obj ) -> name , "procedure:" , - 1 ) ); 
      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) && ((Scheme_Closed_Primitive_Proc * ) obj ) -> name ) {
#   define XfOrM312_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM312(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM312(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    else {
#     define XfOrM313_COUNT (0+XfOrM312_COUNT)
#     define SETUP_XfOrM313(x) SETUP_XfOrM312(x)
      if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && (((Scheme_Primitive_Proc * ) (obj ) ) -> pp . flags & (8 | 16 | 64 ) ) ) ) {
#       define XfOrM315_COUNT (0+XfOrM313_COUNT)
#       define SETUP_XfOrM315(x) SETUP_XfOrM313(x)
        FUNCCALL(SETUP_XfOrM315(_), print_named (obj , "struct-procedure" , ((Scheme_Closed_Primitive_Proc * ) obj ) -> name , - 1 , pp ) ); 
      }
      else {
#       define XfOrM314_COUNT (0+XfOrM313_COUNT)
#       define SETUP_XfOrM314(x) SETUP_XfOrM313(x)
        FUNCCALL(SETUP_XfOrM314(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
        FUNCCALL(SETUP_XfOrM314(_), print_string_in_angle (pp , ((Scheme_Closed_Primitive_Proc * ) obj ) -> name , "procedure:" , - 1 ) ); 
        ; 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
    }
    closed = 1 ; 
  }
  else if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) ) {
#   define XfOrM302_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM302(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
      int done = 0 ; 
#     define XfOrM304_COUNT (0+XfOrM302_COUNT)
#     define SETUP_XfOrM304(x) SETUP_XfOrM302(x)
      if (compact ) {
#       define XfOrM305_COUNT (0+XfOrM304_COUNT)
#       define SETUP_XfOrM305(x) SETUP_XfOrM304(x)
        if (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) == scheme_closure_type ) {
          Scheme_Closure * closure = (Scheme_Closure * ) obj ; 
          BLOCK_SETUP((PUSH(closure, 0+XfOrM305_COUNT)));
#         define XfOrM308_COUNT (1+XfOrM305_COUNT)
#         define SETUP_XfOrM308(x) SETUP(XfOrM308_COUNT)
          if (! (closure -> code -> closure_size ) ) {
            Scheme_Object * idx ; 
            BLOCK_SETUP((PUSH(idx, 0+XfOrM308_COUNT)));
#           define XfOrM309_COUNT (1+XfOrM308_COUNT)
#           define SETUP_XfOrM309(x) SETUP(XfOrM309_COUNT)
            idx = NULLED_OUT ; 
            idx = FUNCCALL(SETUP_XfOrM309(_), get_symtab_idx (mt , obj ) ); 
            if (idx ) {
#             define XfOrM311_COUNT (0+XfOrM309_COUNT)
#             define SETUP_XfOrM311(x) SETUP_XfOrM309(x)
              FUNCCALL(SETUP_XfOrM311(_), print_symtab_ref (pp , idx ) ); 
            }
            else {
#             define XfOrM310_COUNT (0+XfOrM309_COUNT)
#             define SETUP_XfOrM310(x) SETUP_XfOrM309(x)
              FUNCCALL(SETUP_XfOrM310(_), print_this_string (pp , & compacts [CPT_CLOSURE ] , 0 , 1 ) ); 
              FUNCCALL(SETUP_XfOrM310(_), print_symtab_set (pp , mt , obj ) ); 
              FUNCCALL_AGAIN(print ((Scheme_Object * ) ((Scheme_Closure * ) closure ) -> code , notdisplay , compact , ht , mt , pp ) ); 
            }
            compact = 1 ; 
            done = 1 ; 
          }
        }
        else if (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) == scheme_case_closure_type ) {
#         define XfOrM306_COUNT (0+XfOrM305_COUNT)
#         define SETUP_XfOrM306(x) SETUP_XfOrM305(x)
          obj = FUNCCALL(SETUP_XfOrM306(_), scheme_unclose_case_lambda (obj , 0 ) ); 
          if (! (! (((long ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_native_closure_type ) ) ) ) {
#           define XfOrM307_COUNT (0+XfOrM306_COUNT)
#           define SETUP_XfOrM307(x) SETUP_XfOrM306(x)
            compact = FUNCCALL(SETUP_XfOrM307(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 
            done = 1 ; 
          }
        }
      }
      if (! done )
        FUNCCALL(SETUP_XfOrM304(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
      int len ; 
      const char * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM302_COUNT)));
#     define XfOrM303_COUNT (1+XfOrM302_COUNT)
#     define SETUP_XfOrM303(x) SETUP(XfOrM303_COUNT)
      s = NULLED_OUT ; 
      s = FUNCCALL(SETUP_XfOrM303(_), scheme_get_proc_name (obj , & len , 0 ) ); 
      FUNCCALL_AGAIN(print_named (obj , "procedure" , s , len , pp ) ); 
    }
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) {
#   define XfOrM299_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM299(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM301_COUNT (0+XfOrM299_COUNT)
#     define SETUP_XfOrM301(x) SETUP_XfOrM299(x)
      FUNCCALL(SETUP_XfOrM301(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
#     define XfOrM300_COUNT (0+XfOrM299_COUNT)
#     define SETUP_XfOrM300(x) SETUP_XfOrM299(x)
      FUNCCALL(SETUP_XfOrM300(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
      (__funcarg29 = FUNCCALL(SETUP_XfOrM300(_), scheme_symbol_val (((Scheme_Struct_Type * ) obj ) -> name ) ), FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg29 , "struct-type:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((Scheme_Struct_Type * ) obj ) -> name ) ) ) -> len ) ) )) ; 
      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) ) {
#   define XfOrM296_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM296(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM298_COUNT (0+XfOrM296_COUNT)
#     define SETUP_XfOrM298(x) SETUP_XfOrM296(x)
      FUNCCALL(SETUP_XfOrM298(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
#     define XfOrM297_COUNT (0+XfOrM296_COUNT)
#     define SETUP_XfOrM297(x) SETUP_XfOrM296(x)
      FUNCCALL(SETUP_XfOrM297(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
      (__funcarg28 = FUNCCALL(SETUP_XfOrM297(_), scheme_symbol_val (((Scheme_Struct_Property * ) obj ) -> name ) ), FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg28 , "struct-type-property:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((Scheme_Struct_Property * ) obj ) -> name ) ) ) -> len ) ) )) ; 
      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) && (((Scheme_Thread * ) obj ) -> name ) ) {
#   define XfOrM293_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM293(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM295_COUNT (0+XfOrM293_COUNT)
#     define SETUP_XfOrM295(x) SETUP_XfOrM293(x)
      FUNCCALL(SETUP_XfOrM295(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
      Scheme_Thread * t = (Scheme_Thread * ) obj ; 
      BLOCK_SETUP((PUSH(t, 0+XfOrM293_COUNT)));
#     define XfOrM294_COUNT (1+XfOrM293_COUNT)
#     define SETUP_XfOrM294(x) SETUP(XfOrM294_COUNT)
      FUNCCALL(SETUP_XfOrM294(_), print_utf8_string (pp , "#<thread:" , 0 , 9 ) ); 
      (__funcarg27 = FUNCCALL(SETUP_XfOrM294(_), scheme_symbol_val (t -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg27 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (t -> name ) ) ) -> len ) ) )) ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_namespace_type ) ) ) {
#   define XfOrM289_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM289(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM292_COUNT (0+XfOrM289_COUNT)
#     define SETUP_XfOrM292(x) SETUP_XfOrM289(x)
      FUNCCALL(SETUP_XfOrM292(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
      char s [10 ] ; 
#     define XfOrM290_COUNT (0+XfOrM289_COUNT)
#     define SETUP_XfOrM290(x) SETUP_XfOrM289(x)
      FUNCCALL(SETUP_XfOrM290(_), print_utf8_string (pp , "#<namespace:" , 0 , 12 ) ); 
      if (((Scheme_Env * ) obj ) -> module ) {
        Scheme_Object * modname ; 
        int is_sym ; 
        BLOCK_SETUP((PUSH(modname, 0+XfOrM290_COUNT)));
#       define XfOrM291_COUNT (1+XfOrM290_COUNT)
#       define SETUP_XfOrM291(x) SETUP(XfOrM291_COUNT)
        modname = NULLED_OUT ; 
        modname = ((Scheme_Env * ) obj ) -> module -> modname ; 
        is_sym = ((Scheme_Type ) (((((long ) ((((Scheme_Small_Object * ) (modname ) ) -> u . ptr_val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Small_Object * ) (modname ) ) -> u . ptr_val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ; 
        FUNCCALL(SETUP_XfOrM291(_), print_utf8_string (pp , (is_sym ? "'" : "\"" ) , 0 , 1 ) ); 
        FUNCCALL_AGAIN(print ((((Scheme_Small_Object * ) (modname ) ) -> u . ptr_val ) , 0 , 0 , ht , mt , pp ) ); 
        ; 
        if (! is_sym )
          FUNCCALL(SETUP_XfOrM291(_), print_utf8_string (pp , "\"" , 0 , 1 ) ); 
        FUNCCALL(SETUP_XfOrM291(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
      }
      (sprintf (s , "%ld" , ((Scheme_Env * ) obj ) -> phase ) ) ; 
      FUNCCALL(SETUP_XfOrM290(_), print_utf8_string (pp , s , 0 , - 1 ) ); 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) ) {
#   define XfOrM283_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM283(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM288_COUNT (0+XfOrM283_COUNT)
#     define SETUP_XfOrM288(x) SETUP_XfOrM283(x)
      FUNCCALL(SETUP_XfOrM288(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
      Scheme_Input_Port * ip ; 
      BLOCK_SETUP((PUSH(ip, 0+XfOrM283_COUNT)));
#     define XfOrM284_COUNT (1+XfOrM283_COUNT)
#     define SETUP_XfOrM284(x) SETUP(XfOrM284_COUNT)
      ip = NULLED_OUT ; 
      ip = (Scheme_Input_Port * ) obj ; 
      FUNCCALL(SETUP_XfOrM284(_), print_utf8_string (pp , "#<input-port" , 0 , 12 ) ); 
      if (ip -> name ) {
#       define XfOrM285_COUNT (0+XfOrM284_COUNT)
#       define SETUP_XfOrM285(x) SETUP_XfOrM284(x)
        if (((Scheme_Type ) (((((long ) (ip -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ip -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM287_COUNT (0+XfOrM285_COUNT)
#         define SETUP_XfOrM287(x) SETUP_XfOrM285(x)
          FUNCCALL(SETUP_XfOrM287(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
          FUNCCALL(SETUP_XfOrM287(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (ip -> name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (ip -> name ) ) -> u . byte_str_val . tag_val ) ) ); 
        }
        else if (((Scheme_Type ) (((((long ) (ip -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ip -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#         define XfOrM286_COUNT (0+XfOrM285_COUNT)
#         define SETUP_XfOrM286(x) SETUP_XfOrM285(x)
          FUNCCALL(SETUP_XfOrM286(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
          (__funcarg26 = FUNCCALL(SETUP_XfOrM286(_), scheme_symbol_val (ip -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg26 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (ip -> name ) ) ) -> len ) ) )) ; 
        }
      }
      FUNCCALL(SETUP_XfOrM284(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) ) ) {
#   define XfOrM279_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM279(x) SETUP_XfOrM201(x)
    if (compact ) {
#     define XfOrM282_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM282(x) SETUP_XfOrM279(x)
      FUNCCALL(SETUP_XfOrM282(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) ); 
    }
    else {
      Scheme_Object * src ; 
      BLOCK_SETUP((PUSH(src, 0+XfOrM279_COUNT)));
#     define XfOrM280_COUNT (1+XfOrM279_COUNT)
#     define SETUP_XfOrM280(x) SETUP(XfOrM280_COUNT)
      src = NULLED_OUT ; 
      src = FUNCCALL(SETUP_XfOrM280(_), scheme_regexp_source (obj ) ); 
      if (src ) {
#       define XfOrM281_COUNT (0+XfOrM280_COUNT)
#       define SETUP_XfOrM281(x) SETUP_XfOrM280(x)
        if (FUNCCALL(SETUP_XfOrM281(_), scheme_is_pregexp (obj ) ))
          FUNCCALL(SETUP_XfOrM281(_), print_utf8_string (pp , "#px" , 0 , 3 ) ); 
        else FUNCCALL(SETUP_XfOrM281(_), print_utf8_string (pp , "#rx" , 0 , 3 ) ); 
        FUNCCALL(SETUP_XfOrM281(_), print (src , 1 , 0 , ht , mt , pp ) ); 
      }
      else if (compact || ! pp -> print_unreadable )
        FUNCCALL(SETUP_XfOrM280(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
      else FUNCCALL(SETUP_XfOrM280(_), print_utf8_string (pp , "#<regexp>" , 0 , 9 ) ); 
      closed = 1 ; 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) ) ) {
#   define XfOrM273_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM273(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM278_COUNT (0+XfOrM273_COUNT)
#     define SETUP_XfOrM278(x) SETUP_XfOrM273(x)
      FUNCCALL(SETUP_XfOrM278(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else {
      Scheme_Output_Port * op ; 
      BLOCK_SETUP((PUSH(op, 0+XfOrM273_COUNT)));
#     define XfOrM274_COUNT (1+XfOrM273_COUNT)
#     define SETUP_XfOrM274(x) SETUP(XfOrM274_COUNT)
      op = NULLED_OUT ; 
      op = (Scheme_Output_Port * ) obj ; 
      FUNCCALL(SETUP_XfOrM274(_), print_utf8_string (pp , "#<output-port" , 0 , 13 ) ); 
      if (op -> name ) {
#       define XfOrM275_COUNT (0+XfOrM274_COUNT)
#       define SETUP_XfOrM275(x) SETUP_XfOrM274(x)
        if (((Scheme_Type ) (((((long ) (op -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (op -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM277_COUNT (0+XfOrM275_COUNT)
#         define SETUP_XfOrM277(x) SETUP_XfOrM275(x)
          FUNCCALL(SETUP_XfOrM277(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
          FUNCCALL(SETUP_XfOrM277(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (op -> name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (op -> name ) ) -> u . byte_str_val . tag_val ) ) ); 
        }
        else if (((Scheme_Type ) (((((long ) (op -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (op -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#         define XfOrM276_COUNT (0+XfOrM275_COUNT)
#         define SETUP_XfOrM276(x) SETUP_XfOrM275(x)
          FUNCCALL(SETUP_XfOrM276(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
          (__funcarg25 = FUNCCALL(SETUP_XfOrM276(_), scheme_symbol_val (op -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg25 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (op -> name ) ) ) -> len ) ) )) ; 
        }
      }
      FUNCCALL(SETUP_XfOrM274(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) && (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) && ! (compact || ! pp -> print_unreadable ) ) {
#   define XfOrM272_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM272(x) SETUP_XfOrM201(x)
    FUNCCALL(SETUP_XfOrM272(_), print_utf8_string (pp , "#<" , 0 , 2 ) ); 
    (__funcarg24 = FUNCCALL(SETUP_XfOrM272(_), scheme_symbol_val ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) ), FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg24 , "continuation-prompt-tag:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) ) ) -> len ) ) )) ; 
    ; 
    FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
  }
  else if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_cpointer_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_offset_cpointer_type ) ) ) ) {
    Scheme_Object * tag = (((Scheme_Cptr * ) (obj ) ) -> type ) ; 
    BLOCK_SETUP((PUSH(tag, 0+XfOrM201_COUNT)));
#   define XfOrM264_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM264(x) SETUP(XfOrM264_COUNT)
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM271_COUNT (0+XfOrM264_COUNT)
#     define SETUP_XfOrM271(x) SETUP_XfOrM264(x)
      FUNCCALL(SETUP_XfOrM271(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
    else if (tag == ((void * ) 0 ) ) {
#     define XfOrM270_COUNT (0+XfOrM264_COUNT)
#     define SETUP_XfOrM270(x) SETUP_XfOrM264(x)
      FUNCCALL(SETUP_XfOrM270(_), print_utf8_string (pp , "#<cpointer>" , 0 , 11 ) ); 
    }
    else {
      Scheme_Object * name = tag ; 
      BLOCK_SETUP((PUSH(name, 0+XfOrM264_COUNT)));
#     define XfOrM265_COUNT (1+XfOrM264_COUNT)
#     define SETUP_XfOrM265(x) SETUP(XfOrM265_COUNT)
      if (((Scheme_Type ) (((((long ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
        name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
      FUNCCALL(SETUP_XfOrM265(_), print_utf8_string (pp , "#<cpointer:" , 0 , 11 ) ); 
      if (((Scheme_Type ) (((((long ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#       define XfOrM269_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM269(x) SETUP_XfOrM265(x)
        FUNCCALL(SETUP_XfOrM269(_), print_this_string (pp , (char * ) name , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) ) ) - ((char * ) name ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ) ); 
      }
      else if (((Scheme_Type ) (((((long ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ) {
#       define XfOrM268_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM268(x) SETUP_XfOrM265(x)
        FUNCCALL(SETUP_XfOrM268(_), print_byte_string ((((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . tag_val ) , 0 , pp ) ); 
      }
      else if (((Scheme_Type ) (((((long ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
#       define XfOrM267_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM267(x) SETUP_XfOrM265(x)
        FUNCCALL(SETUP_XfOrM267(_), scheme_print_string (pp , (((Scheme_Simple_Object * ) (name ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . char_str_val . tag_val ) ) ); 
      }
      else {
#       define XfOrM266_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM266(x) SETUP_XfOrM265(x)
        FUNCCALL(SETUP_XfOrM266(_), print_utf8_string (pp , "#" , 0 , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM265(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
      closed = 1 ; 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) {
#   define XfOrM258_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM258(x) SETUP_XfOrM201(x)
    if (compact ) {
#     define XfOrM263_COUNT (0+XfOrM258_COUNT)
#     define SETUP_XfOrM263(x) SETUP_XfOrM258(x)
      FUNCCALL(SETUP_XfOrM263(_), print_this_string (pp , & compacts [CPT_STX ] , 0 , 1 ) ); 
      closed = (__funcarg23 = FUNCCALL(SETUP_XfOrM263(_), scheme_syntax_to_datum (obj , 2 , mt ) ), FUNCCALL_AGAIN(print (__funcarg23 , notdisplay , 1 , ht , mt , pp ) )) ; 
    }
    else if (pp -> print_unreadable ) {
      Scheme_Stx * stx = (Scheme_Stx * ) obj ; 
      BLOCK_SETUP((PUSH(stx, 0+XfOrM258_COUNT)));
#     define XfOrM260_COUNT (1+XfOrM258_COUNT)
#     define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
      if ((stx -> srcloc -> line >= 0 ) || (stx -> srcloc -> pos >= 0 ) ) {
#       define XfOrM261_COUNT (0+XfOrM260_COUNT)
#       define SETUP_XfOrM261(x) SETUP_XfOrM260(x)
        FUNCCALL(SETUP_XfOrM261(_), print_utf8_string (pp , "#<syntax:" , 0 , 9 ) ); 
        if (stx -> srcloc -> src && ((Scheme_Type ) (((((long ) (stx -> srcloc -> src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stx -> srcloc -> src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM262_COUNT (0+XfOrM261_COUNT)
#         define SETUP_XfOrM262(x) SETUP_XfOrM261(x)
          FUNCCALL(SETUP_XfOrM262(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (stx -> srcloc -> src ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (stx -> srcloc -> src ) ) -> u . byte_str_val . tag_val ) ) ); 
          FUNCCALL(SETUP_XfOrM262(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
        }
        if (stx -> srcloc -> line >= 0 )
          (sprintf (quick_buffer , "%ld:%ld" , stx -> srcloc -> line , stx -> srcloc -> col - 1 ) ) ; 
        else (sprintf (quick_buffer , ":%ld" , stx -> srcloc -> pos ) ) ; 
        FUNCCALL(SETUP_XfOrM261(_), print_utf8_string (pp , quick_buffer , 0 , - 1 ) ); 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
      else FUNCCALL(SETUP_XfOrM260(_), print_utf8_string (pp , "#<syntax>" , 0 , 9 ) ); 
    }
    else {
#     define XfOrM259_COUNT (0+XfOrM258_COUNT)
#     define SETUP_XfOrM259(x) SETUP_XfOrM258(x)
      FUNCCALL(SETUP_XfOrM259(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_module_index_type ) ) ) {
    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM201_COUNT)));
#   define XfOrM255_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM255(x) SETUP(XfOrM255_COUNT)
    idx = NULLED_OUT ; 
    idx = FUNCCALL(SETUP_XfOrM255(_), get_symtab_idx (mt , obj ) ); 
    if (idx ) {
#     define XfOrM257_COUNT (0+XfOrM255_COUNT)
#     define SETUP_XfOrM257(x) SETUP_XfOrM255(x)
      FUNCCALL(SETUP_XfOrM257(_), print_symtab_ref (pp , idx ) ); 
    }
    else {
#     define XfOrM256_COUNT (0+XfOrM255_COUNT)
#     define SETUP_XfOrM256(x) SETUP_XfOrM255(x)
      FUNCCALL(SETUP_XfOrM256(_), print_this_string (pp , & compacts [CPT_MODULE_INDEX ] , 0 , 1 ) ); 
      FUNCCALL(SETUP_XfOrM256(_), print (((Scheme_Modidx * ) obj ) -> path , notdisplay , 1 , ht , mt , pp ) ); 
      FUNCCALL_AGAIN(print (((Scheme_Modidx * ) obj ) -> base , notdisplay , 1 , ht , mt , pp ) ); 
      FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_module_variable_type ) ) && ! ((Module_Variable * ) obj ) -> mod_phase ) {
    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM201_COUNT)));
#   define XfOrM250_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM250(x) SETUP(XfOrM250_COUNT)
    idx = NULLED_OUT ; 
    idx = FUNCCALL(SETUP_XfOrM250(_), get_symtab_idx (mt , obj ) ); 
    if (idx ) {
#     define XfOrM254_COUNT (0+XfOrM250_COUNT)
#     define SETUP_XfOrM254(x) SETUP_XfOrM250(x)
      FUNCCALL(SETUP_XfOrM254(_), print_symtab_ref (pp , idx ) ); 
    }
    else {
      Module_Variable * mv ; 
      BLOCK_SETUP((PUSH(mv, 0+XfOrM250_COUNT)));
#     define XfOrM251_COUNT (1+XfOrM250_COUNT)
#     define SETUP_XfOrM251(x) SETUP(XfOrM251_COUNT)
      mv = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM251(_), print_this_string (pp , & compacts [CPT_MODULE_VAR ] , 0 , 1 ) ); 
      mv = (Module_Variable * ) obj ; 
      if (((Scheme_Type ) (((((long ) (mv -> modidx ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (mv -> modidx ) ) -> type ) ) == (Scheme_Type ) (scheme_resolved_module_path_type ) ) && ((Scheme_Type ) (((((long ) ((((Scheme_Small_Object * ) (mv -> modidx ) ) -> u . ptr_val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Small_Object * ) (mv -> modidx ) ) -> u . ptr_val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#       define XfOrM253_COUNT (0+XfOrM251_COUNT)
#       define SETUP_XfOrM253(x) SETUP_XfOrM251(x)
        FUNCCALL(SETUP_XfOrM253(_), print ((((Scheme_Small_Object * ) (mv -> modidx ) ) -> u . ptr_val ) , notdisplay , 1 , ht , mt , pp ) ); 
      }
      else {
#       define XfOrM252_COUNT (0+XfOrM251_COUNT)
#       define SETUP_XfOrM252(x) SETUP_XfOrM251(x)
        FUNCCALL(SETUP_XfOrM252(_), print (mv -> modidx , notdisplay , 1 , ht , mt , pp ) ); 
      }
      FUNCCALL(SETUP_XfOrM251(_), print (mv -> sym , notdisplay , 1 , ht , mt , pp ) ); 
      FUNCCALL(SETUP_XfOrM251(_), print_compact_number (pp , mv -> pos ) ); 
      FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_variable_type ) ) && (((Scheme_Bucket_With_Flags * ) obj ) -> flags & 16 ) ) {
    int pos ; 
#   define XfOrM249_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM249(x) SETUP_XfOrM201(x)
    pos = ((Scheme_Bucket_With_Ref_Id * ) obj ) -> id ; 
    FUNCCALL(SETUP_XfOrM249(_), print_this_string (pp , & compacts [CPT_REFERENCE ] , 0 , 1 ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , pos ) ); 
  }
  else if (compact && (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_unbox_type ) ) ) ) {
    int unbox = ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_unbox_type ) ) ; 
    Scheme_Local * loc = (Scheme_Local * ) obj ; 
    BLOCK_SETUP((PUSH(loc, 0+XfOrM201_COUNT)));
#   define XfOrM245_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM245(x) SETUP(XfOrM245_COUNT)
    if ((loc -> position < (207 - 192 ) ) && ! ((& ((Scheme_Local * ) (loc ) ) -> iso ) -> so . keyex & 0x3 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM248_COUNT (0+XfOrM245_COUNT)
#     define SETUP_XfOrM248(x) SETUP_XfOrM245(x)
      s [0 ] = loc -> position + (unbox ? 207 : 192 ) ; 
      FUNCCALL(SETUP_XfOrM248(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }
    else {
      int flags ; 
#     define XfOrM246_COUNT (0+XfOrM245_COUNT)
#     define SETUP_XfOrM246(x) SETUP_XfOrM245(x)
      FUNCCALL(SETUP_XfOrM246(_), print_this_string (pp , & compacts [unbox ? CPT_LOCAL_UNBOX : CPT_LOCAL ] , 0 , 1 ) ); 
      flags = (& ((Scheme_Local * ) (loc ) ) -> iso ) -> so . keyex & 0x3 ; 
      if (flags ) {
#       define XfOrM247_COUNT (0+XfOrM246_COUNT)
#       define SETUP_XfOrM247(x) SETUP_XfOrM246(x)
        FUNCCALL(SETUP_XfOrM247(_), print_compact_number (pp , - (loc -> position + 1 ) ) ); 
        FUNCCALL(SETUP_XfOrM247(_), print_compact_number (pp , flags ) ); 
      }
      else FUNCCALL(SETUP_XfOrM246(_), print_compact_number (pp , loc -> position ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application_type ) ) ) {
    Scheme_App_Rec * app ; 
    int i ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM201_COUNT)));
#   define XfOrM240_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM240(x) SETUP(XfOrM240_COUNT)
    app = NULLED_OUT ; 
    app = (Scheme_App_Rec * ) obj ; 
    if (app -> num_args < (255 - 247 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM244_COUNT (0+XfOrM240_COUNT)
#     define SETUP_XfOrM244(x) SETUP_XfOrM240(x)
      s [0 ] = 247 + app -> num_args ; 
      FUNCCALL(SETUP_XfOrM244(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }
    else {
#     define XfOrM243_COUNT (0+XfOrM240_COUNT)
#     define SETUP_XfOrM243(x) SETUP_XfOrM240(x)
      FUNCCALL(SETUP_XfOrM243(_), print_this_string (pp , & compacts [CPT_APPLICATION ] , 0 , 1 ) ); 
      FUNCCALL(SETUP_XfOrM243(_), print_compact_number (pp , app -> num_args ) ); 
    }
    for (i = 0 ; i < app -> num_args + 1 ; i ++ ) {
#     define XfOrM242_COUNT (0+XfOrM240_COUNT)
#     define SETUP_XfOrM242(x) SETUP_XfOrM240(x)
      closed = (__funcarg22 = FUNCCALL(SETUP_XfOrM242(_), scheme_protect_quote (app -> args [i ] ) ), FUNCCALL_AGAIN(print (__funcarg22 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application2_type ) ) ) {
    Scheme_App2_Rec * app ; 
    unsigned char s [1 ] ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM201_COUNT)));
#   define XfOrM239_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM239(x) SETUP(XfOrM239_COUNT)
    app = NULLED_OUT ; 
    app = (Scheme_App2_Rec * ) obj ; 
    s [0 ] = 247 + 1 ; 
    FUNCCALL(SETUP_XfOrM239(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    (__funcarg20 = FUNCCALL(SETUP_XfOrM239(_), scheme_protect_quote (app -> rator ) ), FUNCCALL_AGAIN(print (__funcarg20 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg19 = FUNCCALL(SETUP_XfOrM239(_), scheme_protect_quote (app -> rand ) ), FUNCCALL_AGAIN(print (__funcarg19 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application3_type ) ) ) {
    Scheme_App3_Rec * app ; 
    unsigned char s [1 ] ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM201_COUNT)));
#   define XfOrM238_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)
    app = NULLED_OUT ; 
    app = (Scheme_App3_Rec * ) obj ; 
    s [0 ] = 247 + 2 ; 
    FUNCCALL(SETUP_XfOrM238(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    (__funcarg18 = FUNCCALL(SETUP_XfOrM238(_), scheme_protect_quote (app -> rator ) ), FUNCCALL_AGAIN(print (__funcarg18 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg17 = FUNCCALL(SETUP_XfOrM238(_), scheme_protect_quote (app -> rand1 ) ), FUNCCALL_AGAIN(print (__funcarg17 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg16 = FUNCCALL(SETUP_XfOrM238(_), scheme_protect_quote (app -> rand2 ) ), FUNCCALL_AGAIN(print (__funcarg16 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_one_type ) ) ) {
    Scheme_Let_One * lo ; 
    BLOCK_SETUP((PUSH(lo, 0+XfOrM201_COUNT)));
#   define XfOrM237_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM237(x) SETUP(XfOrM237_COUNT)
    lo = NULLED_OUT ; 
    lo = (Scheme_Let_One * ) obj ; 
    FUNCCALL(SETUP_XfOrM237(_), print_this_string (pp , & compacts [CPT_LET_ONE ] , 0 , 1 ) ); 
    (__funcarg15 = FUNCCALL(SETUP_XfOrM237(_), scheme_protect_quote (lo -> value ) ), FUNCCALL_AGAIN(print (__funcarg15 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg14 = FUNCCALL(SETUP_XfOrM237(_), scheme_protect_quote (lo -> body ) ), FUNCCALL_AGAIN(print (__funcarg14 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_branch_type ) ) ) {
    Scheme_Branch_Rec * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM201_COUNT)));
#   define XfOrM236_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM236(x) SETUP(XfOrM236_COUNT)
    b = NULLED_OUT ; 
    b = (Scheme_Branch_Rec * ) obj ; 
    FUNCCALL(SETUP_XfOrM236(_), print_this_string (pp , & compacts [CPT_BRANCH ] , 0 , 1 ) ); 
    (__funcarg13 = FUNCCALL(SETUP_XfOrM236(_), scheme_protect_quote (b -> test ) ), FUNCCALL_AGAIN(print (__funcarg13 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg12 = FUNCCALL(SETUP_XfOrM236(_), scheme_protect_quote (b -> tbranch ) ), FUNCCALL_AGAIN(print (__funcarg12 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg11 = FUNCCALL(SETUP_XfOrM236(_), scheme_protect_quote (b -> fbranch ) ), FUNCCALL_AGAIN(print (__funcarg11 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_quote_compilation_type ) ) ) {
    Scheme_Hash_Table * q_ht ; 
    Scheme_Object * v ; 
    int counter = 1 , qpht , qpb ; 
    BLOCK_SETUP((PUSH(q_ht, 0+XfOrM201_COUNT), PUSH(v, 1+XfOrM201_COUNT)));
#   define XfOrM234_COUNT (2+XfOrM201_COUNT)
#   define SETUP_XfOrM234(x) SETUP(XfOrM234_COUNT)
    q_ht = NULLED_OUT ; 
    v = NULLED_OUT ; 
    v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
    qpht = pp -> print_hash_table ; 
    qpb = pp -> print_box ; 
    pp -> print_hash_table = 1 ; 
    pp -> print_box = 1 ; 
    q_ht = FUNCCALL(SETUP_XfOrM234(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    FUNCCALL_AGAIN(setup_graph_table (v , notdisplay , q_ht , & counter , pp ) ); 
    if (compact )
      FUNCCALL(SETUP_XfOrM234(_), print_this_string (pp , & compacts [CPT_QUOTE ] , 0 , 1 ) ); 
    else {
#     define XfOrM235_COUNT (0+XfOrM234_COUNT)
#     define SETUP_XfOrM235(x) SETUP_XfOrM234(x)
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: non-compact quote compilation" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    compact = FUNCCALL(SETUP_XfOrM234(_), print (v , notdisplay , 1 , q_ht , mt , pp ) ); 
    pp -> print_hash_table = qpht ; 
    pp -> print_box = qpb ; 
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_svector_type ) ) ) {
    mzshort l , * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM201_COUNT)));
#   define XfOrM229_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM229(x) SETUP(XfOrM229_COUNT)
    v = NULLED_OUT ; 
    l = (((Scheme_Simple_Object * ) (obj ) ) -> u . svector_val . len ) ; 
    v = (mzshort * ) (((Scheme_Simple_Object * ) (obj ) ) -> u . svector_val . vec ) ; 
    if (l < (247 - 222 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM233_COUNT (0+XfOrM229_COUNT)
#     define SETUP_XfOrM233(x) SETUP_XfOrM229(x)
      s [0 ] = l + 222 ; 
      FUNCCALL(SETUP_XfOrM233(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }
    else {
#     define XfOrM232_COUNT (0+XfOrM229_COUNT)
#     define SETUP_XfOrM232(x) SETUP_XfOrM229(x)
      FUNCCALL(SETUP_XfOrM232(_), print_this_string (pp , & compacts [CPT_SVECTOR ] , 0 , 1 ) ); 
      FUNCCALL(SETUP_XfOrM232(_), print_compact_number (pp , l ) ); 
    }
    while (l -- ) {
      int n = v [l ] ; 
#     define XfOrM231_COUNT (0+XfOrM229_COUNT)
#     define SETUP_XfOrM231(x) SETUP_XfOrM229(x)
      FUNCCALL(SETUP_XfOrM231(_), print_compact_number (pp , n ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_delay_syntax_type ) ) ) {
    Scheme_Object * idx , * key ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM201_COUNT), PUSH(key, 1+XfOrM201_COUNT)));
#   define XfOrM222_COUNT (2+XfOrM201_COUNT)
#   define SETUP_XfOrM222(x) SETUP(XfOrM222_COUNT)
    idx = NULLED_OUT ; 
    key = NULLED_OUT ; 
    if ((& ((Scheme_Small_Object * ) obj ) -> iso ) -> so . keyex & 0x1 ) {
    }
    else {
#     define XfOrM225_COUNT (0+XfOrM222_COUNT)
#     define SETUP_XfOrM225(x) SETUP_XfOrM222(x)
      key = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      if (! mt -> pass ) {
#       define XfOrM226_COUNT (0+XfOrM225_COUNT)
#       define SETUP_XfOrM226(x) SETUP_XfOrM225(x)
        if (! mt -> delay_map ) {
          Scheme_Hash_Table * delay_map ; 
          BLOCK_SETUP((PUSH(delay_map, 0+XfOrM226_COUNT)));
#         define XfOrM227_COUNT (1+XfOrM226_COUNT)
#         define SETUP_XfOrM227(x) SETUP(XfOrM227_COUNT)
          delay_map = NULLED_OUT ; 
          delay_map = FUNCCALL(SETUP_XfOrM227(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          mt -> delay_map = delay_map ; 
        }
        FUNCCALL(SETUP_XfOrM226(_), scheme_hash_set (mt -> delay_map , key , obj ) ); 
      }
      else obj = FUNCCALL(SETUP_XfOrM225(_), scheme_hash_get (mt -> delay_map , key ) ); 
    }
    idx = FUNCCALL(SETUP_XfOrM222(_), get_symtab_idx (mt , obj ) ); 
    if (idx ) {
#     define XfOrM224_COUNT (0+XfOrM222_COUNT)
#     define SETUP_XfOrM224(x) SETUP_XfOrM222(x)
      FUNCCALL(SETUP_XfOrM224(_), print_general_symtab_ref (pp , idx , CPT_DELAY_REF ) ); 
    }
    else {
#     define XfOrM223_COUNT (0+XfOrM222_COUNT)
#     define SETUP_XfOrM223(x) SETUP_XfOrM222(x)
      FUNCCALL(SETUP_XfOrM223(_), print ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , notdisplay , 1 , ht , mt , pp ) ); 
      FUNCCALL(SETUP_XfOrM223(_), symtab_set (pp , mt , obj ) ); 
      FUNCCALL_AGAIN(set_symtab_shared (mt , obj ) ); 
    }
  }
  else if (scheme_type_writers [((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] && (compact || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_compilation_top_type ) ) ) ) {
    Scheme_Type t = ((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ; 
    Scheme_Object * v ; 
    long slen ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM201_COUNT)));
#   define XfOrM207_COUNT (1+XfOrM201_COUNT)
#   define SETUP_XfOrM207(x) SETUP(XfOrM207_COUNT)
    v = NULLED_OUT ; 
    if (t >= _scheme_last_type_ ) {
#     define XfOrM221_COUNT (0+XfOrM207_COUNT)
#     define SETUP_XfOrM221(x) SETUP_XfOrM207(x)
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: bad type with writer" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    if (! global_constants_ht ) {
#     define XfOrM220_COUNT (0+XfOrM207_COUNT)
#     define SETUP_XfOrM220(x) SETUP_XfOrM207(x)
      FUNCCALL(SETUP_XfOrM220(_), scheme_register_static ((void * ) & global_constants_ht , sizeof (global_constants_ht ) ) ); 
      global_constants_ht = FUNCCALL(SETUP_XfOrM220(_), scheme_map_constants_to_globals () ); 
    }
    if (compact ) {
#     define XfOrM217_COUNT (0+XfOrM207_COUNT)
#     define SETUP_XfOrM217(x) SETUP_XfOrM207(x)
      if (t < (92 - 80 ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM219_COUNT (0+XfOrM217_COUNT)
#       define SETUP_XfOrM219(x) SETUP_XfOrM217(x)
        s [0 ] = t + 80 ; 
        FUNCCALL(SETUP_XfOrM219(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }
      else {
#       define XfOrM218_COUNT (0+XfOrM217_COUNT)
#       define SETUP_XfOrM218(x) SETUP_XfOrM217(x)
        FUNCCALL(SETUP_XfOrM218(_), print_this_string (pp , & compacts [CPT_MARSHALLED ] , 0 , 1 ) ); 
        FUNCCALL(SETUP_XfOrM218(_), print_compact_number (pp , t ) ); 
      }
    }
    else {
#     define XfOrM216_COUNT (0+XfOrM207_COUNT)
#     define SETUP_XfOrM216(x) SETUP_XfOrM207(x)
      FUNCCALL(SETUP_XfOrM216(_), print_this_string (pp , "#~" , 0 , 2 ) ); 
    }
    {
      Scheme_Type_Writer writer ; 
#     define XfOrM215_COUNT (0+XfOrM207_COUNT)
#     define SETUP_XfOrM215(x) SETUP_XfOrM207(x)
      writer = scheme_type_writers [t ] ; 
      v = FUNCCALL(SETUP_XfOrM215(_), writer (obj ) ); 
    }
    if (compact )
      closed = FUNCCALL(SETUP_XfOrM207(_), print (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    else {
      Scheme_Hash_Table * st_refs , * symtab , * rns , * tht ; 
      long * shared_offsets ; 
      long st_len , j , shared_offset , start_offset ; 
      BLOCK_SETUP((PUSH(shared_offsets, 0+XfOrM207_COUNT), PUSH(symtab, 1+XfOrM207_COUNT), PUSH(rns, 2+XfOrM207_COUNT), PUSH(st_refs, 3+XfOrM207_COUNT), PUSH(tht, 4+XfOrM207_COUNT)));
#     define XfOrM208_COUNT (5+XfOrM207_COUNT)
#     define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
      st_refs = NULLED_OUT ; 
      symtab = NULLED_OUT ; 
      rns = NULLED_OUT ; 
      tht = NULLED_OUT ; 
      shared_offsets = NULLED_OUT ; 
      mt = ((Scheme_Marshal_Tables * ) FUNCCALL(SETUP_XfOrM208(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Marshal_Tables ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      mt -> type = scheme_rt_marshal_info ; 
      scheme_current_thread -> current_mt = mt ; 
      st_refs = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> st_refs = st_refs ; 
      mt -> st_ref_stack = scheme_null ; 
      symtab = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> symtab = symtab ; 
      rns = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> rns = rns ; 
      tht = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table_equal () ); 
      mt -> cert_lists = tht ; 
      tht = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> shift_map = tht ; 
      mt -> reverse_map = ((void * ) 0 ) ; 
      mt -> pass = 0 ; 
      FUNCCALL(SETUP_XfOrM208(_), scheme_hash_set (symtab , scheme_void , scheme_true ) ); 
      FUNCCALL_AGAIN(print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , 0 , ((void * ) 0 ) ) ); 
      FUNCCALL_AGAIN(sort_referenced_keys (mt ) ); 
      mt -> rn_saved = ((void * ) 0 ) ; 
      shared_offsets = ((long * ) FUNCCALL(SETUP_XfOrM208(_), GC_malloc_atomic (sizeof (long ) * (mt -> st_refs -> count ) ) )) ; 
      mt -> shared_offsets = shared_offsets ; 
      symtab = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> symtab = symtab ; 
      rns = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> rns = rns ; 
      mt -> reverse_map = ((void * ) 0 ) ; 
      mt -> top_map = ((void * ) 0 ) ; 
      mt -> pass = 1 ; 
      FUNCCALL(SETUP_XfOrM208(_), print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , 1 , & st_len ) ); 
      symtab = FUNCCALL_AGAIN(scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> symtab = symtab ; 
      rns = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> rns = rns ; 
      mt -> reverse_map = ((void * ) 0 ) ; 
      mt -> top_map = ((void * ) 0 ) ; 
      mt -> pass = 2 ; 
      FUNCCALL(SETUP_XfOrM208(_), print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , - 1 , & st_len ) ); 
      FUNCCALL_AGAIN(print_one_byte (pp , strlen ("4.1.2" ) ) ); 
      FUNCCALL_AGAIN(print_this_string (pp , "4.1.2" , 0 , - 1 ) ); 
      if (mt -> st_refs -> count != mt -> sorted_keys_count )
        FUNCCALL_EMPTY(scheme_signal_error ("shared key count somehow changed" ) ); 
      FUNCCALL(SETUP_XfOrM208(_), print_number (pp , mt -> st_refs -> count + 1 ) ); 
      if (mt -> st_refs -> count ) {
        int all_short = shared_offsets [mt -> st_refs -> count - 1 ] < 0xFFFF ; 
#       define XfOrM212_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM212(x) SETUP_XfOrM208(x)
        FUNCCALL(SETUP_XfOrM212(_), print_one_byte (pp , all_short ) ); 
        for (j = 0 ; j < mt -> st_refs -> count ; j ++ ) {
#         define XfOrM214_COUNT (0+XfOrM212_COUNT)
#         define SETUP_XfOrM214(x) SETUP_XfOrM212(x)
          if (all_short )
            FUNCCALL(SETUP_XfOrM214(_), print_short_number (pp , shared_offsets [j ] ) ); 
          else FUNCCALL(SETUP_XfOrM214(_), print_number (pp , shared_offsets [j ] ) ); 
        }
      }
      else {
#       define XfOrM211_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM211(x) SETUP_XfOrM208(x)
        FUNCCALL(SETUP_XfOrM211(_), print_one_byte (pp , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM208(_), print_number (pp , st_len ) ); 
      FUNCCALL(SETUP_XfOrM208(_), print_number (pp , slen ) ); 
      symtab = FUNCCALL_AGAIN(scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> symtab = symtab ; 
      rns = FUNCCALL(SETUP_XfOrM208(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> rns = rns ; 
      mt -> reverse_map = ((void * ) 0 ) ; 
      mt -> top_map = ((void * ) 0 ) ; 
      mt -> pass = 3 ; 
      start_offset = pp -> print_offset ; 
      FUNCCALL(SETUP_XfOrM208(_), print_table_keys (notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
      shared_offset = pp -> print_offset ; 
      closed = FUNCCALL(SETUP_XfOrM208(_), print (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
      if (shared_offset - start_offset != st_len ) {
#       define XfOrM210_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM210(x) SETUP_XfOrM208(x)
        FUNCCALL_EMPTY(scheme_signal_error ("compiled code shared printed size changed on third pass:" " %ld versus %ld (total %ld)" , st_len , shared_offset - start_offset , slen ) ); 
      }
      if (pp -> print_offset - start_offset != slen ) {
#       define XfOrM209_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM209(x) SETUP_XfOrM208(x)
        FUNCCALL_EMPTY(scheme_signal_error ("compiled code printed size changed on third pass:" " %ld versus %ld" , slen , pp -> print_offset - start_offset ) ); 
      }
      scheme_current_thread -> current_mt = ((void * ) 0 ) ; 
      mt = ((void * ) 0 ) ; 
    }
  }
  else {
#   define XfOrM202_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM202(x) SETUP_XfOrM201(x)
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM202(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    else if ((((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) < printers_count ) && printers [((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] ) {
      Scheme_Type_Printer printer ; 
#     define XfOrM206_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM206(x) SETUP_XfOrM202(x)
      printer = printers [((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] ; 
      FUNCCALL(SETUP_XfOrM206(_), printer (obj , ! notdisplay , pp ) ); 
    }
    else {
      char * s ; 
      long len = - 1 ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM202_COUNT)));
#     define XfOrM203_COUNT (1+XfOrM202_COUNT)
#     define SETUP_XfOrM203(x) SETUP(XfOrM203_COUNT)
      s = NULLED_OUT ; 
      s = FUNCCALL(SETUP_XfOrM203(_), scheme_get_type_name ((((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ); 
      FUNCCALL_AGAIN(print_utf8_string (pp , "#" , 0 , 1 ) ); 
      if (! s ) {
        char s [8 ] ; 
#       define XfOrM205_COUNT (0+XfOrM203_COUNT)
#       define SETUP_XfOrM205(x) SETUP_XfOrM203(x)
        FUNCCALL(SETUP_XfOrM205(_), print_utf8_string (pp , "<???:" , 0 , 5 ) ); 
        (sprintf (s , "%d" , ((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ; 
        FUNCCALL(SETUP_XfOrM205(_), print_utf8_string (pp , s , 0 , - 1 ) ); 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
      else {
#       define XfOrM204_COUNT (0+XfOrM203_COUNT)
#       define SETUP_XfOrM204(x) SETUP_XfOrM203(x)
        FUNCCALL(SETUP_XfOrM204(_), print_utf8_string (pp , s , 0 , len ) ); 
      }
    }
    closed = 1 ; 
  }
  if (save_honu_mode != pp -> honu_mode )
    pp -> honu_mode = save_honu_mode ; 
  RET_VALUE_START ((closed || compact ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_char_string (const char * str , int len , const mzchar * ustr , int delta , int ulen , int notdisplay , int honu_char , PrintParams * pp ) {
  char minibuf [12 ] , * esc ; 
  int a , i , v , ui , cont_utf8 = 0 , isize ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(ustr, 1), PUSH(esc, 2), PUSH(pp, 3)));
# define XfOrM433_COUNT (4)
# define SETUP_XfOrM433(x) SETUP(XfOrM433_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  esc = NULLED_OUT ; 
  if (notdisplay ) {
#   define XfOrM435_COUNT (0+XfOrM433_COUNT)
#   define SETUP_XfOrM435(x) SETUP_XfOrM433(x)
    FUNCCALL(SETUP_XfOrM435(_), print_utf8_string (pp , honu_char ? "'" : "\"" , 0 , 1 ) ); 
    for (a = i = ui = 0 ; i < len ; i += isize , ui ++ ) {
#     define XfOrM448_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM448(x) SETUP_XfOrM435(x)
      v = ((unsigned char * ) str ) [i ] ; 
      isize = 1 ; 
      switch (v ) {
#       define XfOrM452_COUNT (0+XfOrM448_COUNT)
#       define SETUP_XfOrM452(x) SETUP_XfOrM448(x)
        case '\"' : if (honu_char )
          esc = ((void * ) 0 ) ; 
        else esc = "\\\"" ; 
        break ; 
        case '\'' : if (honu_char )
          esc = "\\'" ; 
        else esc = ((void * ) 0 ) ; 
        break ; 
        case '\\' : esc = "\\\\" ; 
        break ; 
        case '\a' : esc = "\\a" ; 
        break ; 
        case '\b' : esc = "\\b" ; 
        break ; 
        case 27 : esc = "\\e" ; 
        break ; 
        case '\f' : esc = "\\f" ; 
        break ; 
        case '\n' : esc = "\\n" ; 
        break ; 
        case '\r' : esc = "\\r" ; 
        break ; 
        case '\t' : esc = "\\t" ; 
        break ; 
        case '\v' : esc = "\\v" ; 
        break ; 
        default : if (v > 127 ) {
#         define XfOrM455_COUNT (0+XfOrM452_COUNT)
#         define SETUP_XfOrM455(x) SETUP_XfOrM452(x)
          if (cont_utf8 ) {
            cont_utf8 -- ; 
            ui -- ; 
            esc = ((void * ) 0 ) ; 
          }
          else {
            int clen ; 
#           define XfOrM456_COUNT (0+XfOrM455_COUNT)
#           define SETUP_XfOrM456(x) SETUP_XfOrM455(x)
            clen = FUNCCALL(SETUP_XfOrM456(_), scheme_utf8_encode (ustr , ui + delta , ui + delta + 1 , ((void * ) 0 ) , 0 , 0 ) ); 
            if ((((scheme_uchar_table [(ustr [ui + delta ] >> 8 ) & 0x1FFF ] [ustr [ui + delta ] & 0xFF ] ) ) & 0x800 ) || (((scheme_uchar_table [(ustr [ui + delta ] >> 8 ) & 0x1FFF ] [ustr [ui + delta ] & 0xFF ] ) ) & 0x1 ) ) {
              cont_utf8 = clen - 1 ; 
              esc = ((void * ) 0 ) ; 
            }
            else {
              esc = minibuf ; 
              isize = clen ; 
            }
          }
        }
        else if ((((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x800 ) || (((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1 ) ) {
          esc = ((void * ) 0 ) ; 
        }
        else {
          esc = minibuf ; 
        }
        break ; 
      }
      if (esc ) {
#       define XfOrM449_COUNT (0+XfOrM448_COUNT)
#       define SETUP_XfOrM449(x) SETUP_XfOrM448(x)
        if (esc == minibuf ) {
#         define XfOrM450_COUNT (0+XfOrM449_COUNT)
#         define SETUP_XfOrM450(x) SETUP_XfOrM449(x)
          if (ustr [ui + delta ] > 0xFFFF ) {
#           define XfOrM451_COUNT (0+XfOrM450_COUNT)
#           define SETUP_XfOrM451(x) SETUP_XfOrM450(x)
            (sprintf (minibuf , "\\U%.8X" , ustr [ui + delta ] ) ) ; 
          }
          else (sprintf (minibuf , "\\u%.4X" , ustr [ui + delta ] ) ) ; 
        }
        if (a < i )
          FUNCCALL(SETUP_XfOrM449(_), print_utf8_string (pp , str , a , i - a ) ); 
        FUNCCALL(SETUP_XfOrM449(_), print_utf8_string (pp , esc , 0 , - 1 ) ); 
        a = i + isize ; 
      }
    }
    if (a < i )
      FUNCCALL(SETUP_XfOrM435(_), print_utf8_string (pp , str , a , i - a ) ); 
    FUNCCALL(SETUP_XfOrM435(_), print_utf8_string (pp , honu_char ? "'" : "\"" , 0 , 1 ) ); 
  }
  else if (len ) {
#   define XfOrM434_COUNT (0+XfOrM433_COUNT)
#   define SETUP_XfOrM434(x) SETUP_XfOrM433(x)
    FUNCCALL_EMPTY(print_utf8_string (pp , str , 0 , len ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_byte_string (const char * str , int delta , int len , int notdisplay , PrintParams * pp ) {
  char minibuf [8 ] , * esc ; 
  int a , i , v ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(esc, 1), PUSH(pp, 2)));
# define XfOrM460_COUNT (3)
# define SETUP_XfOrM460(x) SETUP(XfOrM460_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  esc = NULLED_OUT ; 
  if (notdisplay ) {
#   define XfOrM462_COUNT (0+XfOrM460_COUNT)
#   define SETUP_XfOrM462(x) SETUP_XfOrM460(x)
    FUNCCALL(SETUP_XfOrM462(_), print_utf8_string (pp , "\"" , 0 , 1 ) ); 
    for (a = i = delta ; i < delta + len ; i ++ ) {
#     define XfOrM470_COUNT (0+XfOrM462_COUNT)
#     define SETUP_XfOrM470(x) SETUP_XfOrM462(x)
      switch (((unsigned char * ) str ) [i ] ) {
        case '\"' : esc = "\\\"" ; 
        break ; 
        case '\\' : esc = "\\\\" ; 
        break ; 
        case '\a' : esc = "\\a" ; 
        break ; 
        case '\b' : esc = "\\b" ; 
        break ; 
        case 27 : esc = "\\e" ; 
        break ; 
        case '\f' : esc = "\\f" ; 
        break ; 
        case '\n' : esc = "\\n" ; 
        break ; 
        case '\r' : esc = "\\r" ; 
        break ; 
        case '\t' : esc = "\\t" ; 
        break ; 
        case '\v' : esc = "\\v" ; 
        break ; 
        default : v = ((unsigned char * ) str ) [i ] ; 
        if (v > 127 ) {
          esc = minibuf ; 
        }
        else if ((((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x800 ) || (((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1 ) ) {
          esc = ((void * ) 0 ) ; 
        }
        else {
          esc = minibuf ; 
        }
        break ; 
      }
      if (esc ) {
#       define XfOrM471_COUNT (0+XfOrM470_COUNT)
#       define SETUP_XfOrM471(x) SETUP_XfOrM470(x)
        if (esc == minibuf ) {
#         define XfOrM472_COUNT (0+XfOrM471_COUNT)
#         define SETUP_XfOrM472(x) SETUP_XfOrM471(x)
          (sprintf (minibuf , ((i + 1 >= len ) || (str [i + 1 ] < '0' ) || (str [i + 1 ] > '7' ) ) ? "\\%o" : "\\%03o" , ((unsigned char * ) str ) [i ] ) ) ; 
        }
        if (a < i )
          FUNCCALL(SETUP_XfOrM471(_), print_utf8_string (pp , str , a , i - a ) ); 
        FUNCCALL(SETUP_XfOrM471(_), print_utf8_string (pp , esc , 0 , - 1 ) ); 
        a = i + 1 ; 
      }
    }
    if (a < i )
      FUNCCALL(SETUP_XfOrM462(_), print_utf8_string (pp , str , a , i - a ) ); 
    FUNCCALL(SETUP_XfOrM462(_), print_utf8_string (pp , "\"" , 0 , 1 ) ); 
  }
  else if (len ) {
#   define XfOrM461_COUNT (0+XfOrM460_COUNT)
#   define SETUP_XfOrM461(x) SETUP_XfOrM460(x)
    FUNCCALL_EMPTY(print_this_string (pp , str , delta , len ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_pair (Scheme_Object * pair , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp , Scheme_Type pair_type , int round_parens ) {
  Scheme_Object * cdr ; 
  int super_compact = 0 ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(ht, 1), PUSH(pp, 2), PUSH(cdr, 3), PUSH(pair, 4)));
# define XfOrM477_COUNT (5)
# define SETUP_XfOrM477(x) SETUP(XfOrM477_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cdr = NULLED_OUT ; 
  if (compact ) {
    int c = 0 ; 
    Scheme_Object * pr ; 
    BLOCK_SETUP((PUSH(pr, 0+XfOrM477_COUNT)));
#   define XfOrM509_COUNT (1+XfOrM477_COUNT)
#   define SETUP_XfOrM509(x) SETUP(XfOrM509_COUNT)
    pr = NULLED_OUT ; 
    pr = pair ; 
    while (((Scheme_Type ) (((((long ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#     define XfOrM515_COUNT (0+XfOrM509_COUNT)
#     define SETUP_XfOrM515(x) SETUP_XfOrM509(x)
      if (ht )
        if ((long ) FUNCCALL(SETUP_XfOrM515(_), scheme_hash_get (ht , pr ) )!= 1 ) {
        c = - 1 ; 
        break ; 
      }
      c ++ ; 
      pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
    }
    if (c > - 1 ) {
#     define XfOrM510_COUNT (0+XfOrM509_COUNT)
#     define SETUP_XfOrM510(x) SETUP_XfOrM509(x)
      super_compact = 1 ; 
      if (c < (((92 + 65 ) + 65 ) - (92 + 65 ) ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM512_COUNT (0+XfOrM510_COUNT)
#       define SETUP_XfOrM512(x) SETUP_XfOrM510(x)
        s [0 ] = c + (((pr ) == (scheme_null ) ) ? 92 : (92 + 65 ) ) ; 
        FUNCCALL(SETUP_XfOrM512(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }
      else {
#       define XfOrM511_COUNT (0+XfOrM510_COUNT)
#       define SETUP_XfOrM511(x) SETUP_XfOrM510(x)
        FUNCCALL(SETUP_XfOrM511(_), print_this_string (pp , & compacts [CPT_LIST ] , 0 , 1 ) ); 
        FUNCCALL(SETUP_XfOrM511(_), print_compact_number (pp , c ) ); 
        super_compact = - 1 ; 
      }
    }
  }
  else if (pp -> honu_mode ) {
#   define XfOrM490_COUNT (0+XfOrM477_COUNT)
#   define SETUP_XfOrM490(x) SETUP_XfOrM477(x)
    cdr = (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ; 
    while (((Scheme_Type ) (((((long ) (cdr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cdr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#     define XfOrM506_COUNT (0+XfOrM490_COUNT)
#     define SETUP_XfOrM506(x) SETUP_XfOrM490(x)
      if (ht ) {
#       define XfOrM507_COUNT (0+XfOrM506_COUNT)
#       define SETUP_XfOrM507(x) SETUP_XfOrM506(x)
        if ((long ) FUNCCALL(SETUP_XfOrM507(_), scheme_hash_get (ht , cdr ) )!= 1 ) {
          break ; 
        }
      }
      cdr = (((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . cdr ) ; 
    }
    if (((cdr ) == (scheme_null ) ) ) {
#     define XfOrM500_COUNT (0+XfOrM490_COUNT)
#     define SETUP_XfOrM500(x) SETUP_XfOrM490(x)
      FUNCCALL(SETUP_XfOrM500(_), print_utf8_string (pp , "list(" , 0 , 5 ) ); 
      (void ) FUNCCALL(SETUP_XfOrM500(_), print ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
      cdr = (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ; 
      while (((Scheme_Type ) (((((long ) (cdr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cdr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#       define XfOrM502_COUNT (0+XfOrM500_COUNT)
#       define SETUP_XfOrM502(x) SETUP_XfOrM500(x)
        FUNCCALL(SETUP_XfOrM502(_), print_utf8_string (pp , ", " , 0 , 2 ) ); 
        (void ) FUNCCALL(SETUP_XfOrM502(_), print ((((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
        cdr = (((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . cdr ) ; 
      }
      FUNCCALL(SETUP_XfOrM500(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    }
    else {
      int cnt = 1 ; 
#     define XfOrM491_COUNT (0+XfOrM490_COUNT)
#     define SETUP_XfOrM491(x) SETUP_XfOrM490(x)
      FUNCCALL(SETUP_XfOrM491(_), print_utf8_string (pp , "cons(" , 0 , 5 ) ); 
      (void ) FUNCCALL(SETUP_XfOrM491(_), print ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
      cdr = (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ; 
      while (((Scheme_Type ) (((((long ) (cdr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cdr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#       define XfOrM497_COUNT (0+XfOrM491_COUNT)
#       define SETUP_XfOrM497(x) SETUP_XfOrM491(x)
        FUNCCALL(SETUP_XfOrM497(_), print_utf8_string (pp , ", " , 0 , 2 ) ); 
        if (ht ) {
#         define XfOrM498_COUNT (0+XfOrM497_COUNT)
#         define SETUP_XfOrM498(x) SETUP_XfOrM497(x)
          if ((long ) FUNCCALL(SETUP_XfOrM498(_), scheme_hash_get (ht , cdr ) )!= 1 ) {
#           define XfOrM499_COUNT (0+XfOrM498_COUNT)
#           define SETUP_XfOrM499(x) SETUP_XfOrM498(x)
            (void ) FUNCCALL(SETUP_XfOrM499(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
            break ; 
          }
        }
        FUNCCALL(SETUP_XfOrM497(_), print_utf8_string (pp , "cons(" , 0 , 5 ) ); 
        (void ) FUNCCALL(SETUP_XfOrM497(_), print ((((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
        cnt ++ ; 
        cdr = (((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . cdr ) ; 
      }
      FUNCCALL(SETUP_XfOrM491(_), print_utf8_string (pp , ", " , 0 , 2 ) ); 
      (void ) FUNCCALL(SETUP_XfOrM491(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
      while (cnt -- ) {
#       define XfOrM493_COUNT (0+XfOrM491_COUNT)
#       define SETUP_XfOrM493(x) SETUP_XfOrM491(x)
        FUNCCALL(SETUP_XfOrM493(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
      }
    }
    RET_NOTHING ; 
  }
  if (compact ) {
#   define XfOrM489_COUNT (0+XfOrM477_COUNT)
#   define SETUP_XfOrM489(x) SETUP_XfOrM477(x)
    if (! super_compact )
      FUNCCALL(SETUP_XfOrM489(_), print_this_string (pp , & compacts [CPT_PAIR ] , 0 , 1 ) ); 
  }
  else {
#   define XfOrM488_COUNT (0+XfOrM477_COUNT)
#   define SETUP_XfOrM488(x) SETUP_XfOrM477(x)
    if (round_parens )
      FUNCCALL(SETUP_XfOrM488(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
    else FUNCCALL(SETUP_XfOrM488(_), print_utf8_string (pp , "{" , 0 , 1 ) ); 
  }
  FUNCCALL(SETUP_XfOrM477(_), print ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
  cdr = (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ; 
  while (((Scheme_Type ) (((((long ) (cdr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cdr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#   define XfOrM484_COUNT (0+XfOrM477_COUNT)
#   define SETUP_XfOrM484(x) SETUP_XfOrM477(x)
    if (ht && ! super_compact ) {
#     define XfOrM485_COUNT (0+XfOrM484_COUNT)
#     define SETUP_XfOrM485(x) SETUP_XfOrM484(x)
      if ((long ) FUNCCALL(SETUP_XfOrM485(_), scheme_hash_get (ht , cdr ) )!= 1 ) {
#       define XfOrM486_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM486(x) SETUP_XfOrM485(x)
        if (! compact )
          FUNCCALL(SETUP_XfOrM486(_), print_utf8_string (pp , " . " , 0 , 3 ) ); 
        (void ) FUNCCALL(SETUP_XfOrM486(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
        if (! compact ) {
#         define XfOrM487_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM487(x) SETUP_XfOrM486(x)
          if (round_parens )
            FUNCCALL(SETUP_XfOrM487(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
          else FUNCCALL(SETUP_XfOrM487(_), print_utf8_string (pp , "}" , 0 , 1 ) ); 
        }
        RET_NOTHING ; 
      }
    }
    if (compact && ! super_compact )
      FUNCCALL(SETUP_XfOrM484(_), print_this_string (pp , & compacts [CPT_PAIR ] , 0 , 1 ) ); 
    if (! compact )
      FUNCCALL(SETUP_XfOrM484(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    FUNCCALL(SETUP_XfOrM484(_), print ((((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
    cdr = (((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . cdr ) ; 
  }
  if (! ((cdr ) == (scheme_null ) ) ) {
#   define XfOrM479_COUNT (0+XfOrM477_COUNT)
#   define SETUP_XfOrM479(x) SETUP_XfOrM477(x)
    if (! compact )
      FUNCCALL(SETUP_XfOrM479(_), print_utf8_string (pp , " . " , 0 , 3 ) ); 
    FUNCCALL(SETUP_XfOrM479(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
  }
  else if (compact && (super_compact < 1 ) )
    FUNCCALL(SETUP_XfOrM477(_), print_this_string (pp , & compacts [CPT_NULL ] , 0 , 1 ) ); 
  if (! compact ) {
#   define XfOrM478_COUNT (0+XfOrM477_COUNT)
#   define SETUP_XfOrM478(x) SETUP_XfOrM477(x)
    if (round_parens )
      FUNCCALL(SETUP_XfOrM478(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    else FUNCCALL_EMPTY(print_utf8_string (pp , "}" , 0 , 1 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_vector (Scheme_Object * vec , int notdisplay , int compact , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * pp , int as_prefab ) {
  int i , size , common = 0 ; 
  Scheme_Object * * elems ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(vec, 0), PUSH(ht, 1), PUSH(mt, 2), PUSH(pp, 3), PUSH(elems, 4)));
# define XfOrM517_COUNT (5)
# define SETUP_XfOrM517(x) SETUP(XfOrM517_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 
  size = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
  if (compact ) {
#   define XfOrM531_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM531(x) SETUP_XfOrM517(x)
    FUNCCALL(SETUP_XfOrM531(_), print_this_string (pp , & compacts [CPT_VECTOR ] , 0 , 1 ) ); 
    FUNCCALL(SETUP_XfOrM531(_), print_compact_number (pp , size ) ); 
  }
  else {
#   define XfOrM524_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM524(x) SETUP_XfOrM517(x)
    elems = (((Scheme_Vector * ) (vec ) ) -> els ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 
    if (as_prefab ) {
#     define XfOrM528_COUNT (0+XfOrM524_COUNT)
#     define SETUP_XfOrM528(x) SETUP_XfOrM524(x)
      FUNCCALL(SETUP_XfOrM528(_), print_utf8_string (pp , "#s(" , 0 , 3 ) ); 
    }
    else if (notdisplay && pp -> print_vec_shorthand ) {
#     define XfOrM525_COUNT (0+XfOrM524_COUNT)
#     define SETUP_XfOrM525(x) SETUP_XfOrM524(x)
      if (size == 0 ) {
#       define XfOrM527_COUNT (0+XfOrM525_COUNT)
#       define SETUP_XfOrM527(x) SETUP_XfOrM525(x)
        if (pp -> honu_mode )
          FUNCCALL(SETUP_XfOrM527(_), print_utf8_string (pp , "vectorN(0" , 0 , 7 ) ); 
        else FUNCCALL(SETUP_XfOrM527(_), print_utf8_string (pp , "#0(" , 0 , 3 ) ); 
      }
      else {
        char buffer [100 ] ; 
#       define XfOrM526_COUNT (0+XfOrM525_COUNT)
#       define SETUP_XfOrM526(x) SETUP_XfOrM525(x)
        (sprintf (buffer , pp -> honu_mode ? "vectorN(%d, " : "#%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM526(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }
    else if (pp -> honu_mode )
      FUNCCALL(SETUP_XfOrM524(_), print_utf8_string (pp , "vector(" , 0 , 7 ) ); 
    else FUNCCALL(SETUP_XfOrM524(_), print_utf8_string (pp , "#(" , 0 , 2 ) ); 
  }
  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM521_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM521(x) SETUP_XfOrM517(x)
    FUNCCALL(SETUP_XfOrM521(_), print ((((Scheme_Vector * ) (vec ) ) -> els ) [i ] , notdisplay , compact , ht , mt , pp ) ); 
    if (i < (size - 1 ) ) {
#     define XfOrM522_COUNT (0+XfOrM521_COUNT)
#     define SETUP_XfOrM522(x) SETUP_XfOrM521(x)
      if (! compact ) {
#       define XfOrM523_COUNT (0+XfOrM522_COUNT)
#       define SETUP_XfOrM523(x) SETUP_XfOrM522(x)
        if (pp -> honu_mode )
          FUNCCALL(SETUP_XfOrM523(_), print_utf8_string (pp , ", " , 0 , 2 ) ); 
        else FUNCCALL(SETUP_XfOrM523(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
      }
    }
  }
  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void print_char (Scheme_Object * charobj , int notdisplay , PrintParams * pp ) {
  int ch ; 
  char minibuf [10 + 6 ] , * str ; 
  int len = - 1 ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(pp, 1)));
# define XfOrM532_COUNT (2)
# define SETUP_XfOrM532(x) SETUP(XfOrM532_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  str = NULLED_OUT ; 
  ch = (((Scheme_Small_Object * ) (charobj ) ) -> u . char_val ) ; 
  if (notdisplay ) {
#   define XfOrM534_COUNT (0+XfOrM532_COUNT)
#   define SETUP_XfOrM534(x) SETUP_XfOrM532(x)
    switch (ch ) {
#     define XfOrM535_COUNT (0+XfOrM534_COUNT)
#     define SETUP_XfOrM535(x) SETUP_XfOrM534(x)
      case '\0' : str = "#\\nul" ; 
      break ; 
      case '\n' : str = "#\\newline" ; 
      break ; 
      case '\t' : str = "#\\tab" ; 
      break ; 
      case 0xb : str = "#\\vtab" ; 
      break ; 
      case ' ' : str = "#\\space" ; 
      break ; 
      case '\r' : str = "#\\return" ; 
      break ; 
      case '\f' : str = "#\\page" ; 
      break ; 
      case '\b' : str = "#\\backspace" ; 
      break ; 
      case 0x7f : str = "#\\rubout" ; 
      break ; 
      default : if ((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x800 ) ) {
#       define XfOrM537_COUNT (0+XfOrM535_COUNT)
#       define SETUP_XfOrM537(x) SETUP_XfOrM535(x)
        minibuf [0 ] = '#' ; 
        minibuf [1 ] = '\\' ; 
        ch = FUNCCALL(SETUP_XfOrM537(_), scheme_utf8_encode ((unsigned int * ) & ch , 0 , 1 , (unsigned char * ) minibuf , 2 , 0 ) ); 
        minibuf [2 + ch ] = 0 ; 
      }
      else {
#       define XfOrM536_COUNT (0+XfOrM535_COUNT)
#       define SETUP_XfOrM536(x) SETUP_XfOrM535(x)
        if (ch > 0xFFFF )
          (sprintf (minibuf , "#\\U%.8X" , ch ) ) ; 
        else (sprintf (minibuf , "#\\u%.4X" , ch ) ) ; 
      }
      str = minibuf ; 
      break ; 
    }
  }
  else {
#   define XfOrM533_COUNT (0+XfOrM532_COUNT)
#   define SETUP_XfOrM533(x) SETUP_XfOrM532(x)
    len = FUNCCALL(SETUP_XfOrM533(_), scheme_utf8_encode ((unsigned int * ) & ch , 0 , 1 , (unsigned char * ) minibuf , 0 , 0 ) ); 
    minibuf [len ] = 0 ; 
    str = minibuf ; 
  }
  FUNCCALL_EMPTY(print_utf8_string (pp , str , 0 , len ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_protect_quote (Scheme_Object * expr ) {
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(expr, 0)));
# define XfOrM538_COUNT (1)
# define SETUP_XfOrM538(x) SETUP(XfOrM538_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if ((((Scheme_Type ) (((((long ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((long ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || ((Scheme_Type ) (((((long ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || (1 && ((Scheme_Type ) (((((long ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) || (0 ) || (0 ) || (1 && (((Scheme_Type ) (((((long ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((Scheme_Type ) (((((long ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) ) ) ) {
    Scheme_Object * q ; 
    BLOCK_SETUP((PUSH(q, 0+XfOrM538_COUNT)));
#   define XfOrM539_COUNT (1+XfOrM538_COUNT)
#   define SETUP_XfOrM539(x) SETUP(XfOrM539_COUNT)
    q = NULLED_OUT ; 
    q = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM539(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    q -> type = scheme_quote_compilation_type ; 
    (((Scheme_Small_Object * ) (q ) ) -> u . ptr_val ) = expr ; 
    RET_VALUE_START (q ) RET_VALUE_END ; 
  }
  else RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_set_type_printer (Scheme_Type stype , Scheme_Type_Printer printer ) {
  PREPARE_VAR_STACK(1);
# define XfOrM540_COUNT (0)
# define SETUP_XfOrM540(x) SETUP(XfOrM540_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (! printers ) {
#   define XfOrM542_COUNT (0+XfOrM540_COUNT)
#   define SETUP_XfOrM542(x) SETUP_XfOrM540(x)
    FUNCCALL(SETUP_XfOrM542(_), scheme_register_static ((void * ) & printers , sizeof (printers ) ) ); 
  }
  if (stype >= printers_count ) {
    Scheme_Type_Printer * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM540_COUNT)));
#   define XfOrM541_COUNT (1+XfOrM540_COUNT)
#   define SETUP_XfOrM541(x) SETUP(XfOrM541_COUNT)
    naya = NULLED_OUT ; 
    naya = ((Scheme_Type_Printer * ) FUNCCALL(SETUP_XfOrM541(_), GC_malloc (sizeof (Scheme_Type_Printer ) * (stype + 10 ) ) )) ; 
    (memset (naya , 0 , sizeof (Scheme_Type_Printer ) * (stype + 10 ) ) ) ; 
    (memcpy (naya , printers , sizeof (Scheme_Type_Printer ) * printers_count ) ) ; 
    printers_count = stype + 10 ; 
    printers = naya ; 
  }
  printers [stype ] = printer ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * accum_write (void * _b , int argc , Scheme_Object * * argv ) {
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(_b, 0)));
# define XfOrM543_COUNT (1)
# define SETUP_XfOrM543(x) SETUP(XfOrM543_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if ((((Scheme_Small_Object * ) (_b ) ) -> u . ptr_val ) ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM543_COUNT)));
#   define XfOrM544_COUNT (1+XfOrM543_COUNT)
#   define SETUP_XfOrM544(x) SETUP(XfOrM544_COUNT)
    v = NULLED_OUT ; 
    v = FUNCCALL(SETUP_XfOrM544(_), scheme_make_pair (argv [0 ] , (((Scheme_Small_Object * ) (_b ) ) -> u . ptr_val ) ) ); 
    (((Scheme_Small_Object * ) (_b ) ) -> u . ptr_val ) = v ; 
  }
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * writable_struct_subs (Scheme_Object * s , int for_write , PrintParams * pp ) {
  Scheme_Object * v , * o , * a [3 ] , * b , * accum_proc ; 
  Scheme_Output_Port * op ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(v, 1), PUSH(o, 2), PUSH(s, 3), PUSH(accum_proc, 4), PUSHARRAY(a, 3, 5), PUSH(op, 8), PUSH(pp, 9)));
# define XfOrM545_COUNT (10)
# define SETUP_XfOrM545(x) SETUP(XfOrM545_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  o = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  b = NULLED_OUT ; 
  accum_proc = NULLED_OUT ; 
  op = NULLED_OUT ; 
  v = FUNCCALL(SETUP_XfOrM545(_), scheme_is_writable_struct (s ) ); 
  o = FUNCCALL_AGAIN(scheme_make_null_output_port (pp -> print_port && ((Scheme_Output_Port * ) pp -> print_port ) -> write_special_fun ) ); 
  op = (Scheme_Output_Port * ) o ; 
  b = FUNCCALL(SETUP_XfOrM545(_), scheme_box (scheme_null ) ); 
  accum_proc = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (accum_write , b , "custom-write-recur-handler" , 2 , 2 ) ); 
  op -> display_handler = accum_proc ; 
  op -> write_handler = accum_proc ; 
  op -> print_handler = accum_proc ; 
  a [0 ] = s ; 
  a [1 ] = o ; 
  a [2 ] = (for_write ? scheme_true : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM545(_), scheme_apply_multi (v , 3 , a ) ); 
  FUNCCALL_AGAIN(scheme_close_output_port (o ) ); 
  v = (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
  (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void flush_from_byte_port (Scheme_Object * orig_port , PrintParams * pp ) {
  char * bytes ; 
  long len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(bytes, 0), PUSH(pp, 1)));
# define XfOrM546_COUNT (2)
# define SETUP_XfOrM546(x) SETUP(XfOrM546_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bytes = NULLED_OUT ; 
  bytes = FUNCCALL(SETUP_XfOrM546(_), scheme_get_sized_byte_string_output (orig_port , & len ) ); 
  FUNCCALL_EMPTY(print_this_string (pp , bytes , 0 , len ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * custom_recur (int notdisplay , void * _vec , int argc , Scheme_Object * * argv ) {
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [0 ] ; 
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [1 ] ; 
  PrintParams * volatile pp = (PrintParams * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [2 ] ; 
  Scheme_Object * volatile save_port ; 
  mz_jmp_buf escape , * volatile save ; 
  volatile long save_max ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(save_port, 1), PUSH(argv, 2), PUSH(pp, 3), PUSH(mt, 4), PUSH(save, 5), PUSH(_vec, 6)));
# define XfOrM547_COUNT (7)
# define SETUP_XfOrM547(x) SETUP(XfOrM547_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  save_port = NULLED_OUT ; 
  save = NULLED_OUT ; 
  if (! ((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) ) ) {
#   define XfOrM554_COUNT (0+XfOrM547_COUNT)
#   define SETUP_XfOrM554(x) SETUP_XfOrM547(x)
    FUNCCALL_EMPTY(scheme_wrong_type (notdisplay ? "write/recusrive" : "display/recursive" , "output-port" , 1 , argc , argv ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if ((((Scheme_Vector * ) (_vec ) ) -> els ) [3 ] ) {
#   define XfOrM548_COUNT (0+XfOrM547_COUNT)
#   define SETUP_XfOrM548(x) SETUP_XfOrM547(x)
    {
#     define XfOrM549_COUNT (0+XfOrM548_COUNT)
#     define SETUP_XfOrM549(x) SETUP_XfOrM548(x)
      if (pp -> print_escape ) {
        save = pp -> print_escape ; 
        pp -> print_escape = & escape ; 
      }
      else save = ((void * ) 0 ) ; 
      save_port = pp -> print_port ; 
      save_max = pp -> print_maxlen ; 
      if (! pp -> print_escape || ! ((escape ) . gcvs = (long ) __gc_var_stack__ , (escape ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((escape ) . jb ) , (_setjmp (((escape ) . jb ) -> jb ) ) ) ) ) {
        Scheme_Object * sp ; 
        BLOCK_SETUP((PUSH(sp, 0+XfOrM549_COUNT)));
#       define XfOrM550_COUNT (1+XfOrM549_COUNT)
#       define SETUP_XfOrM550(x) SETUP(XfOrM550_COUNT)
        sp = NULLED_OUT ; 
        sp = (((Scheme_Vector * ) (_vec ) ) -> els ) [4 ] ; 
        if (sp ) {
#         define XfOrM552_COUNT (0+XfOrM550_COUNT)
#         define SETUP_XfOrM552(x) SETUP_XfOrM550(x)
          FUNCCALL(SETUP_XfOrM552(_), flush_from_byte_port (sp , pp ) ); 
          sp = FUNCCALL(SETUP_XfOrM552(_), scheme_make_byte_string_output_port () ); 
          ((Scheme_Output_Port * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [5 ] ) -> port_data = sp ; 
          (((Scheme_Vector * ) (_vec ) ) -> els ) [4 ] = sp ; 
        }
        if (! ((save_port ) == (argv [1 ] ) ) ) {
#         define XfOrM551_COUNT (0+XfOrM550_COUNT)
#         define SETUP_XfOrM551(x) SETUP_XfOrM550(x)
          FUNCCALL(SETUP_XfOrM551(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 
          pp -> print_maxlen = 0 ; 
        }
        pp -> print_port = argv [1 ] ; 
        FUNCCALL(SETUP_XfOrM550(_), print (argv [0 ] , notdisplay , 0 , ht , mt , pp ) ); 
        FUNCCALL_AGAIN(print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 
      }
      pp -> print_port = save_port ; 
      pp -> print_escape = save ; 
      pp -> print_maxlen = save_max ; 
    }
  }
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * custom_write_recur (void * _vec , int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return custom_recur (1 , _vec , argc , argv ) ; 
}
static Scheme_Object * custom_display_recur (void * _vec , int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return custom_recur (0 , _vec , argc , argv ) ; 
}
static void custom_write_struct (Scheme_Object * s , Scheme_Hash_Table * ht , Scheme_Marshal_Tables * mt , PrintParams * orig_pp , int notdisplay ) {
  Scheme_Object * v , * a [3 ] , * o , * vec , * orig_port ; 
  Scheme_Output_Port * op ; 
  Scheme_Object * recur_write , * recur_display ; 
  PrintParams * pp ; 
  PREPARE_VAR_STACK_ONCE(15);
  BLOCK_SETUP_TOP((PUSH(orig_port, 0), PUSH(o, 1), PUSH(ht, 2), PUSHARRAY(a, 3, 3), PUSH(recur_write, 6), PUSH(s, 7), PUSH(v, 8), PUSH(recur_display, 9), PUSH(pp, 10), PUSH(mt, 11), PUSH(vec, 12), PUSH(orig_pp, 13), PUSH(op, 14)));
# define XfOrM557_COUNT (15)
# define SETUP_XfOrM557(x) SETUP(XfOrM557_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  o = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  orig_port = NULLED_OUT ; 
  op = NULLED_OUT ; 
  recur_write = NULLED_OUT ; 
  recur_display = NULLED_OUT ; 
  pp = NULLED_OUT ; 
  v = FUNCCALL(SETUP_XfOrM557(_), scheme_is_writable_struct (s ) ); 
  pp = FUNCCALL_AGAIN(copy_print_params (orig_pp ) ); 
  if (pp -> print_port )
    orig_port = pp -> print_port ; 
  else orig_port = FUNCCALL(SETUP_XfOrM557(_), scheme_make_byte_string_output_port () ); 
  o = FUNCCALL(SETUP_XfOrM557(_), scheme_make_redirect_output_port (orig_port ) ); 
  op = (Scheme_Output_Port * ) o ; 
  vec = FUNCCALL(SETUP_XfOrM557(_), scheme_make_vector (6 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (Scheme_Object * ) ht ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (Scheme_Object * ) mt ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (Scheme_Object * ) pp ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = scheme_true ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = (pp -> print_port ? ((void * ) 0 ) : orig_port ) ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = o ; 
  recur_write = FUNCCALL(SETUP_XfOrM557(_), scheme_make_closed_prim_w_arity (custom_write_recur , vec , "custom-write-recur-handler" , 2 , 2 ) ); 
  recur_display = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (custom_display_recur , vec , "custom-display-recur-handler" , 2 , 2 ) ); 
  op -> write_handler = recur_write ; 
  op -> display_handler = recur_display ; 
  op -> print_handler = recur_write ; 
  if (pp -> print_port )
    FUNCCALL(SETUP_XfOrM557(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 
  a [0 ] = s ; 
  a [1 ] = o ; 
  a [2 ] = (notdisplay ? scheme_true : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM557(_), scheme_apply_multi (v , 3 , a ) ); 
  FUNCCALL_AGAIN(scheme_close_output_port (o ) ); 
  (memcpy (orig_pp , pp , sizeof (PrintParams ) ) ) ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = ((void * ) 0 ) ; 
  if (! orig_pp -> print_port )
    FUNCCALL(SETUP_XfOrM557(_), flush_from_byte_port ((((Scheme_Vector * ) (vec ) ) -> els ) [4 ] , orig_pp ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int mark_print_params_SIZE (void * p ) {
  return ((sizeof (PrintParams ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_print_params_MARK (void * p ) {
  PrintParams * pp = (PrintParams * ) p ; 
  GC_mark (pp -> inspector ) ; 
  GC_mark (pp -> print_port ) ; 
  GC_mark (pp -> print_buffer ) ; 
  return ((sizeof (PrintParams ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_print_params_FIXUP (void * p ) {
  PrintParams * pp = (PrintParams * ) p ; 
  GC_fixup (& (pp -> inspector ) ) ; 
  GC_fixup (& (pp -> print_port ) ) ; 
  GC_fixup (& (pp -> print_buffer ) ) ; 
  return ((sizeof (PrintParams ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_marshal_tables_SIZE (void * p ) {
  return ((sizeof (Scheme_Marshal_Tables ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_marshal_tables_MARK (void * p ) {
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p ; 
  GC_mark (mt -> symtab ) ; 
  GC_mark (mt -> rns ) ; 
  GC_mark (mt -> rn_refs ) ; 
  GC_mark (mt -> st_refs ) ; 
  GC_mark (mt -> st_ref_stack ) ; 
  GC_mark (mt -> reverse_map ) ; 
  GC_mark (mt -> same_map ) ; 
  GC_mark (mt -> cert_lists ) ; 
  GC_mark (mt -> shift_map ) ; 
  GC_mark (mt -> top_map ) ; 
  GC_mark (mt -> key_map ) ; 
  GC_mark (mt -> delay_map ) ; 
  GC_mark (mt -> cdata_map ) ; 
  GC_mark (mt -> rn_saved ) ; 
  GC_mark (mt -> shared_offsets ) ; 
  GC_mark (mt -> sorted_keys ) ; 
  return ((sizeof (Scheme_Marshal_Tables ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_marshal_tables_FIXUP (void * p ) {
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p ; 
  GC_fixup (& (mt -> symtab ) ) ; 
  GC_fixup (& (mt -> rns ) ) ; 
  GC_fixup (& (mt -> rn_refs ) ) ; 
  GC_fixup (& (mt -> st_refs ) ) ; 
  GC_fixup (& (mt -> st_ref_stack ) ) ; 
  GC_fixup (& (mt -> reverse_map ) ) ; 
  GC_fixup (& (mt -> same_map ) ) ; 
  GC_fixup (& (mt -> cert_lists ) ) ; 
  GC_fixup (& (mt -> shift_map ) ) ; 
  GC_fixup (& (mt -> top_map ) ) ; 
  GC_fixup (& (mt -> key_map ) ) ; 
  GC_fixup (& (mt -> delay_map ) ) ; 
  GC_fixup (& (mt -> cdata_map ) ) ; 
  GC_fixup (& (mt -> rn_saved ) ) ; 
  GC_fixup (& (mt -> shared_offsets ) ) ; 
  GC_fixup (& (mt -> sorted_keys ) ) ; 
  return ((sizeof (Scheme_Marshal_Tables ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static void register_traversers (void ) {
  GC_register_traversers (scheme_rt_print_params , mark_print_params_SIZE , mark_print_params_MARK , mark_print_params_FIXUP , 1 , 0 ) ; 
  GC_register_traversers (scheme_rt_marshal_info , mark_marshal_tables_SIZE , mark_marshal_tables_MARK , mark_marshal_tables_FIXUP , 1 , 0 ) ; 
}
