#include "precomp.h"
extern Scheme_Object * scheme_eval_compiled_sized_string (const char * str , int len , Scheme_Env * env ) ; 
enum {
  CPT_ESCAPE , CPT_SYMBOL , CPT_SYMREF , CPT_WEIRD_SYMBOL , CPT_KEYWORD , CPT_BYTE_STRING , CPT_CHAR_STRING , CPT_CHAR , CPT_INT , CPT_NULL , CPT_TRUE , CPT_FALSE , CPT_VOID , CPT_BOX , CPT_PAIR , CPT_LIST , CPT_VECTOR , CPT_HASH_TABLE , CPT_STX , CPT_GSTX , CPT_MARSHALLED , CPT_QUOTE , CPT_REFERENCE , CPT_LOCAL , CPT_LOCAL_UNBOX , CPT_SVECTOR , CPT_APPLICATION , CPT_LET_ONE , CPT_BRANCH , CPT_MODULE_INDEX , CPT_MODULE_VAR , CPT_PATH , CPT_CLOSURE , CPT_DELAY_REF , CPT_PREFAB , _CPT_COUNT_ }
; 
enum {
  _ISupper = ((0 ) < 8 ? ((1 << (0 ) ) << 8 ) : ((1 << (0 ) ) >> 8 ) ) , _ISlower = ((1 ) < 8 ? ((1 << (1 ) ) << 8 ) : ((1 << (1 ) ) >> 8 ) ) , _ISalpha = ((2 ) < 8 ? ((1 << (2 ) ) << 8 ) : ((1 << (2 ) ) >> 8 ) ) , _ISdigit = ((3 ) < 8 ? ((1 << (3 ) ) << 8 ) : ((1 << (3 ) ) >> 8 ) ) , _ISxdigit = ((4 ) < 8 ? ((1 << (4 ) ) << 8 ) : ((1 << (4 ) ) >> 8 ) ) , _ISspace = ((5 ) < 8 ? ((1 << (5 ) ) << 8 ) : ((1 << (5 ) ) >> 8 ) ) , _ISprint = ((6 ) < 8 ? ((1 << (6 ) ) << 8 ) : ((1 << (6 ) ) >> 8 ) ) , _ISgraph = ((7 ) < 8 ? ((1 << (7 ) ) << 8 ) : ((1 << (7 ) ) >> 8 ) ) , _ISblank = ((8 ) < 8 ? ((1 << (8 ) ) << 8 ) : ((1 << (8 ) ) >> 8 ) ) , _IScntrl = ((9 ) < 8 ? ((1 << (9 ) ) << 8 ) : ((1 << (9 ) ) >> 8 ) ) , _ISpunct = ((10 ) < 8 ? ((1 << (10 ) ) << 8 ) : ((1 << (10 ) ) >> 8 ) ) , _ISalnum = ((11 ) < 8 ? ((1 << (11 ) ) << 8 ) : ((1 << (11 ) ) >> 8 ) ) }
; 
int scheme_square_brackets_are_parens = 1 ; 
int scheme_curly_braces_are_parens = 1 ; 
int scheme_num_read_syntax_objects ; 
static int use_perma_cache = 1 ; 
static char * builtin_fast ; 
static unsigned char delim [128 ] ; 
static Scheme_Object * * variable_references ; 
static Scheme_Object * quote_symbol ; 
static Scheme_Object * quasiquote_symbol ; 
static Scheme_Object * unquote_symbol ; 
static Scheme_Object * unquote_splicing_symbol ; 
static Scheme_Object * syntax_symbol ; 
static Scheme_Object * unsyntax_symbol ; 
static Scheme_Object * unsyntax_splicing_symbol ; 
static Scheme_Object * quasisyntax_symbol ; 
static Scheme_Object * paren_shape_symbol ; 
static Scheme_Object * terminating_macro_symbol ; 
static Scheme_Object * non_terminating_macro_symbol ; 
static Scheme_Object * dispatch_macro_symbol ; 
static Scheme_Object * honu_comma ; 
static Scheme_Object * honu_semicolon ; 
static Scheme_Object * honu_parens ; 
static Scheme_Object * honu_braces ; 
static Scheme_Object * honu_brackets ; 
static Scheme_Object * honu_angles ; 
static Scheme_Object * honu_angle_open ; 
static Scheme_Object * honu_angle_close ; 
static Scheme_Object * unresolved_uninterned_symbol ; 
static Scheme_Object * tainted_uninterned_symbol ; 
static Scheme_Object * read_case_sensitive (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_bracket_as_paren (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_brace_as_paren (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_graph (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_compiled (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_box (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_pipe_quote (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_decimal_as_inexact (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_dot (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_infix_dot (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_quasi (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_reader (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_delay_load (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_graph (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_struct (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_box (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_vec_shorthand (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_hash_table (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_unreadable (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_pair_curly (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_mpair_curly (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_honu (int , Scheme_Object * [] ) ; 
static inline long SPAN (Scheme_Object * port , long pos ) {
  /* No conversion */
  long cpos ; 
  scheme_tell_all (port , ((void * ) 0 ) , ((void * ) 0 ) , & cpos ) ; 
  return cpos - pos + 1 ; 
}
typedef struct Readtable {
  Scheme_Object so ; 
  Scheme_Hash_Table * mapping ; 
  char * fast_mapping ; 
  Scheme_Object * symbol_parser ; 
  char * * names ; 
}
Readtable ; 
typedef struct ReadParams {
  Scheme_Type type ; 
  int can_read_compiled ; 
  int can_read_pipe_quote ; 
  int can_read_box ; 
  int can_read_graph ; 
  int can_read_reader ; 
  int case_sensitive ; 
  int square_brackets_are_parens ; 
  int curly_braces_are_parens ; 
  int read_decimal_inexact ; 
  int can_read_dot ; 
  int can_read_infix_dot ; 
  int can_read_quasi ; 
  int honu_mode ; 
  int skip_zo_vers_check ; 
  Readtable * table ; 
  Scheme_Object * magic_sym , * magic_val ; 
  Scheme_Object * delay_load_info ; 
}
ReadParams ; 
static Scheme_Object * read_list (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int opener , int closer , int shape , int use_stack , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_string (int is_byte , int is_honu_char , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int err_ok ) ; 
static Scheme_Object * read_here_string (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_quote (char * who , Scheme_Object * quote_symbol , int len , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_vector (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int opener , char closer , long reqLen , const mzchar * reqBuffer , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_number (int init_ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int , int , int , int , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) ; 
static Scheme_Object * read_symbol (int init_ch , int skip_rt , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) ; 
static Scheme_Object * read_keyword (int init_ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) ; 
static Scheme_Object * read_character (Scheme_Object * port , Scheme_Object * stcsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_box (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_hash (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int opener , char closer , int kind , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_reader (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * read_lang (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int get_info , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int init_ch ) ; 
static Scheme_Object * read_compiled (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , ReadParams * params ) ; 
static void unexpected_closer (int ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * expected_lang (const char * prefix , int ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int get_info ) ; 
static void pop_indentation (Scheme_Object * indentation ) ; 
static int skip_whitespace_comments (Scheme_Object * port , Scheme_Object * stxsrc , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) ; 
static Scheme_Object * readtable_call (int w_char , int ch , Scheme_Object * proc , ReadParams * params , Scheme_Object * port , Scheme_Object * src , long line , long col , long pos , int get_info , Scheme_Hash_Table * * ht , Scheme_Object * modpath_stx ) ; 
static int readtable_kind (Readtable * t , int ch , ReadParams * params ) ; 
static Scheme_Object * readtable_handle (Readtable * t , int * _ch , int * _use_default , ReadParams * params , Scheme_Object * port , Scheme_Object * src , long line , long col , long pos , Scheme_Hash_Table * * ht ) ; 
static Scheme_Object * readtable_handle_hash (Readtable * t , int ch , int * _use_default , ReadParams * params , Scheme_Object * port , Scheme_Object * src , long line , long col , long pos , Scheme_Hash_Table * * ht ) ; 
static int readtable_effective_char (Readtable * t , int ch ) ; 
static Scheme_Object * make_readtable (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * readtable_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * readtable_mapping (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_readtable (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_reader_guard (int argc , Scheme_Object * * argv ) ; 
static void register_traversers (void ) ; 
typedef struct {
  Scheme_Type type ; 
  char closer ; 
  char suspicious_closer ; 
  char multiline ; 
  char quote_for_char ; 
  long start_line ; 
  long last_line ; 
  long suspicious_line ; 
  long max_indent ; 
  long suspicious_quote ; 
}
Scheme_Indent ; 
void scheme_init_read (Scheme_Env * env ) {
  Scheme_Object * __funcarg37 = NULLED_OUT ; 
  Scheme_Object * __funcarg36 = NULLED_OUT ; 
  Scheme_Object * __funcarg35 = NULLED_OUT ; 
  Scheme_Object * __funcarg34 = NULLED_OUT ; 
  Scheme_Object * __funcarg33 = NULLED_OUT ; 
  Scheme_Object * __funcarg32 = NULLED_OUT ; 
  Scheme_Object * __funcarg31 = NULLED_OUT ; 
  Scheme_Object * __funcarg30 = NULLED_OUT ; 
  Scheme_Object * __funcarg29 = NULLED_OUT ; 
  Scheme_Object * __funcarg28 = NULLED_OUT ; 
  Scheme_Object * __funcarg27 = NULLED_OUT ; 
  Scheme_Object * __funcarg26 = NULLED_OUT ; 
  Scheme_Object * __funcarg25 = NULLED_OUT ; 
  Scheme_Object * __funcarg24 = NULLED_OUT ; 
  Scheme_Object * __funcarg23 = NULLED_OUT ; 
  Scheme_Object * __funcarg22 = NULLED_OUT ; 
  Scheme_Object * __funcarg21 = NULLED_OUT ; 
  Scheme_Object * __funcarg20 = NULLED_OUT ; 
  Scheme_Object * __funcarg19 = NULLED_OUT ; 
  Scheme_Object * __funcarg18 = NULLED_OUT ; 
  Scheme_Object * __funcarg17 = NULLED_OUT ; 
  Scheme_Object * __funcarg16 = NULLED_OUT ; 
  Scheme_Object * __funcarg15 = NULLED_OUT ; 
  Scheme_Object * __funcarg14 = NULLED_OUT ; 
  Scheme_Object * __funcarg13 = NULLED_OUT ; 
  Scheme_Object * __funcarg12 = NULLED_OUT ; 
  Scheme_Object * __funcarg11 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM2_COUNT (1)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & variable_references , sizeof (variable_references ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & quote_symbol , sizeof (quote_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & quasiquote_symbol , sizeof (quasiquote_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unquote_symbol , sizeof (unquote_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unquote_splicing_symbol , sizeof (unquote_splicing_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & syntax_symbol , sizeof (syntax_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unsyntax_symbol , sizeof (unsyntax_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unsyntax_splicing_symbol , sizeof (unsyntax_splicing_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & quasisyntax_symbol , sizeof (quasisyntax_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & paren_shape_symbol , sizeof (paren_shape_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unresolved_uninterned_symbol , sizeof (unresolved_uninterned_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & tainted_uninterned_symbol , sizeof (tainted_uninterned_symbol ) ) ); 
  quote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quote" ) ); 
  quasiquote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quasiquote" ) ); 
  unquote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unquote" ) ); 
  unquote_splicing_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unquote-splicing" ) ); 
  syntax_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("syntax" ) ); 
  unsyntax_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unsyntax" ) ); 
  unsyntax_splicing_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unsyntax-splicing" ) ); 
  quasisyntax_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quasisyntax" ) ); 
  paren_shape_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("paren-shape" ) ); 
  unresolved_uninterned_symbol = FUNCCALL_AGAIN(scheme_make_symbol ("unresolved" ) ); 
  tainted_uninterned_symbol = FUNCCALL_AGAIN(scheme_make_symbol ("tainted" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_comma , sizeof (honu_comma ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_semicolon , sizeof (honu_semicolon ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_parens , sizeof (honu_parens ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_braces , sizeof (honu_braces ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_brackets , sizeof (honu_brackets ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_angles , sizeof (honu_angles ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_angle_open , sizeof (honu_angle_open ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & honu_angle_close , sizeof (honu_angle_close ) ) ); 
  honu_comma = FUNCCALL_AGAIN(scheme_intern_symbol ("," ) ); 
  honu_semicolon = FUNCCALL_AGAIN(scheme_intern_symbol (";" ) ); 
  honu_parens = FUNCCALL_AGAIN(scheme_intern_symbol ("#%parens" ) ); 
  honu_braces = FUNCCALL_AGAIN(scheme_intern_symbol ("#%braces" ) ); 
  honu_brackets = FUNCCALL_AGAIN(scheme_intern_symbol ("#%brackets" ) ); 
  honu_angles = FUNCCALL_AGAIN(scheme_intern_symbol ("#%angles" ) ); 
  honu_angle_open = FUNCCALL_AGAIN(scheme_make_symbol ("<" ) ); 
  honu_angle_close = FUNCCALL_AGAIN(scheme_make_symbol (">" ) ); 
  {
    int i ; 
    for (i = 0 ; i < 128 ; i ++ ) {
      delim [i ] = 0x1 ; 
    }
    for (i = 'A' ; i <= 'Z' ; i ++ ) {
      delim [i ] |= 0x2 ; 
      delim [i + ('a' - 'A' ) ] |= 0x2 ; 
    }
    for (i = '0' ; i <= '9' ; i ++ ) {
      delim [i ] |= (0x2 | 0x8 ) ; 
    }
    delim ['(' ] -= 0x1 ; 
    delim [')' ] -= 0x1 ; 
    delim ['[' ] -= 0x1 ; 
    delim [']' ] -= 0x1 ; 
    delim ['{' ] -= 0x1 ; 
    delim ['}' ] -= 0x1 ; 
    delim ['"' ] -= 0x1 ; 
    delim ['\'' ] -= 0x1 ; 
    delim [',' ] -= 0x1 ; 
    delim [';' ] -= 0x1 ; 
    delim ['`' ] -= 0x1 ; 
    delim ['_' ] |= 0x2 ; 
    {
      GC_CAN_IGNORE const char * syms = "+-_=?:<>.!%^&*/~|" ; 
      for (i = 0 ; syms [i ] ; i ++ ) {
        delim [(int ) syms [i ] ] |= 0x4 ; 
      }
    }
    delim ['.' ] |= 0x8 ; 
    delim ['e' ] |= 0x10 ; 
    delim ['E' ] |= 0x10 ; 
    delim ['d' ] |= 0x10 ; 
    delim ['D' ] |= 0x10 ; 
    delim ['f' ] |= 0x10 ; 
    delim ['F' ] |= 0x10 ; 
    delim ['+' ] |= 0x20 ; 
    delim ['-' ] |= 0x20 ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), register_traversers () ); 
  (__funcarg37 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_readtable , "current-readtable" , MZCONFIG_READTABLE ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("current-readtable" , __funcarg37 , env ) )) ; 
  (__funcarg36 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_reader_guard , "current-reader-guard" , MZCONFIG_READER_GUARD ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("current-reader-guard" , __funcarg36 , env ) )) ; 
  (__funcarg35 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_case_sensitive , "read-case-sensitive" , MZCONFIG_CASE_SENS ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-case-sensitive" , __funcarg35 , env ) )) ; 
  (__funcarg34 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_bracket_as_paren , "read-square-bracket-as-paren" , MZCONFIG_SQUARE_BRACKETS_ARE_PARENS ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-square-bracket-as-paren" , __funcarg34 , env ) )) ; 
  (__funcarg33 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_brace_as_paren , "read-curly-brace-as-paren" , MZCONFIG_CURLY_BRACES_ARE_PARENS ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-curly-brace-as-paren" , __funcarg33 , env ) )) ; 
  (__funcarg32 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_graph , "read-accept-graph" , MZCONFIG_CAN_READ_GRAPH ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-graph" , __funcarg32 , env ) )) ; 
  (__funcarg31 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_compiled , "read-accept-compiled" , MZCONFIG_CAN_READ_COMPILED ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-compiled" , __funcarg31 , env ) )) ; 
  (__funcarg30 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_box , "read-accept-box" , MZCONFIG_CAN_READ_BOX ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-box" , __funcarg30 , env ) )) ; 
  (__funcarg29 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_pipe_quote , "read-accept-bar-quote" , MZCONFIG_CAN_READ_PIPE_QUOTE ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-bar-quote" , __funcarg29 , env ) )) ; 
  (__funcarg28 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_decimal_as_inexact , "read-decimal-as-inexact" , MZCONFIG_READ_DECIMAL_INEXACT ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-decimal-as-inexact" , __funcarg28 , env ) )) ; 
  (__funcarg27 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_dot , "read-accept-dot" , MZCONFIG_CAN_READ_DOT ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-dot" , __funcarg27 , env ) )) ; 
  (__funcarg26 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_infix_dot , "read-accept-infix-dot" , MZCONFIG_CAN_READ_INFIX_DOT ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-infix-dot" , __funcarg26 , env ) )) ; 
  (__funcarg25 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_quasi , "read-accept-quasiquote" , MZCONFIG_CAN_READ_QUASI ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-quasiquote" , __funcarg25 , env ) )) ; 
  (__funcarg24 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_accept_reader , "read-accept-reader" , MZCONFIG_CAN_READ_READER ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-accept-reader" , __funcarg24 , env ) )) ; 
  (__funcarg23 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (read_delay_load , "read-on-demand-source" , MZCONFIG_DELAY_LOAD_INFO ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("read-on-demand-source" , __funcarg23 , env ) )) ; 
  (__funcarg22 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_graph , "print-graph" , MZCONFIG_PRINT_GRAPH ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-graph" , __funcarg22 , env ) )) ; 
  (__funcarg21 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_struct , "print-struct" , MZCONFIG_PRINT_STRUCT ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-struct" , __funcarg21 , env ) )) ; 
  (__funcarg20 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_box , "print-box" , MZCONFIG_PRINT_BOX ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-box" , __funcarg20 , env ) )) ; 
  (__funcarg19 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_vec_shorthand , "print-vector-length" , MZCONFIG_PRINT_VEC_SHORTHAND ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-vector-length" , __funcarg19 , env ) )) ; 
  (__funcarg18 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_hash_table , "print-hash-table" , MZCONFIG_PRINT_HASH_TABLE ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-hash-table" , __funcarg18 , env ) )) ; 
  (__funcarg17 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_unreadable , "print-unreadable" , MZCONFIG_PRINT_UNREADABLE ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-unreadable" , __funcarg17 , env ) )) ; 
  (__funcarg16 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_pair_curly , "print-pair-curly-braces" , MZCONFIG_PRINT_PAIR_CURLY ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-pair-curly-braces" , __funcarg16 , env ) )) ; 
  (__funcarg15 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_mpair_curly , "print-mpair-curly-braces" , MZCONFIG_PRINT_MPAIR_CURLY ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-mpair-curly-braces" , __funcarg15 , env ) )) ; 
  (__funcarg14 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (print_honu , "print-honu" , MZCONFIG_HONU_MODE ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("print-honu" , __funcarg14 , env ) )) ; 
  (__funcarg13 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_readtable , "make-readtable" , 1 , - 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("make-readtable" , __funcarg13 , env ) )) ; 
  (__funcarg12 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (readtable_p , "readtable?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("readtable?" , __funcarg12 , env ) )) ; 
  (__funcarg11 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (readtable_mapping , 1 , "readtable-mapping" , 2 , 2 , 0 , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("readtable-mapping" , __funcarg11 , env ) )) ; 
  if (FUNCCALL_EMPTY(getenv ("PLT_DELAY_FROM_ZO" ) )) {
    use_perma_cache = 0 ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Simple_Object * malloc_list_stack () {
  long sz = sizeof (Scheme_Simple_Object ) * 500 ; 
  Scheme_Simple_Object * r ; 
  DECL_RET_SAVE (Scheme_Simple_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(r, 0)));
# define XfOrM14_COUNT (1)
# define SETUP_XfOrM14(x) SETUP(XfOrM14_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  if (sz < FUNCCALL(SETUP_XfOrM14(_), GC_malloc_stays_put_threshold () )) {
#   define XfOrM15_COUNT (0+XfOrM14_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM14(x)
    sz = FUNCCALL(SETUP_XfOrM15(_), GC_malloc_stays_put_threshold () ); 
    while (sz % sizeof (Scheme_Simple_Object ) ) {
      sz ++ ; 
    }
  }
  r = (Scheme_Simple_Object * ) FUNCCALL(SETUP_XfOrM14(_), GC_malloc_array_tagged (sz ) ); 
  r [0 ] . iso . so . type = scheme_pair_type ; 
  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_alloc_list_stack (Scheme_Thread * p ) {
  Scheme_Simple_Object * sa ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(sa, 1)));
# define XfOrM18_COUNT (2)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sa = NULLED_OUT ; 
  p -> list_stack_pos = 0 ; 
  sa = FUNCCALL(SETUP_XfOrM18(_), malloc_list_stack () ); 
  p -> list_stack = sa ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
/* this far 522 */
void scheme_clean_list_stack (Scheme_Thread * p ) {
  /* No conversion */
  if (p -> list_stack ) {
    memset (p -> list_stack + p -> list_stack_pos , 0 , (500 - p -> list_stack_pos ) * sizeof (Scheme_Simple_Object ) ) ; 
    if (! p -> list_stack_pos ) {
      p -> list_stack [0 ] . iso . so . type = scheme_pair_type ; 
    }
  }
}
static void track_indentation (Scheme_Object * indentation , int line , int col ) {
  /* No conversion */
  if (! ((indentation ) == (scheme_null ) ) ) {
    Scheme_Indent * indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
    if (line > indt -> last_line ) {
      indt -> last_line = line ; 
      indt -> multiline = 1 ; 
      if (col >= indt -> max_indent )
        indt -> max_indent = col ; 
      else if (! indt -> suspicious_line ) {
        indt -> suspicious_closer = indt -> closer ; 
        indt -> suspicious_line = line ; 
      }
    }
  }
}
static Scheme_Object * read_case_sensitive (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-case-sensitive" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CASE_SENS ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_bracket_as_paren (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-square-bracket-as-paren" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_SQUARE_BRACKETS_ARE_PARENS ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_brace_as_paren (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-curly-brace-as-paren" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CURLY_BRACES_ARE_PARENS ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_graph (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-graph" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_GRAPH ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_compiled (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-compiled" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_COMPILED ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_box (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-box" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_BOX ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_pipe_quote (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-pipe-quote" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_PIPE_QUOTE ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_decimal_as_inexact (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-decimal-as-inexact" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_READ_DECIMAL_INEXACT ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_dot (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-dot" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_DOT ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_infix_dot (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-infix-dot" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_INFIX_DOT ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_quasi (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-quasiquote" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_QUASI ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * read_accept_reader (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-accept-reader" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_CAN_READ_READER ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_graph (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-graph" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_GRAPH ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_struct (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-struct" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_STRUCT ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_box (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-box" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_BOX ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_vec_shorthand (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-vector-length" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_VEC_SHORTHAND ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_hash_table (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-hash-table" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_HASH_TABLE ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_unreadable (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-unreadable" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_UNREADABLE ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_pair_curly (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-pair-curly" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_PAIR_CURLY ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_mpair_curly (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-mpair-curly" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_PRINT_MPAIR_CURLY ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * print_honu (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("print-honu" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_HONU_MODE ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}
static Scheme_Object * rdl_check (int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return argv [0 ] ; 
}
static Scheme_Object * read_delay_load (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return scheme_param_config ("read-on-demand-source" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_DELAY_LOAD_INFO ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , rdl_check , "complete path or string, optionally paired with an exact integer" , 1 ) ; 
}
static Scheme_Object * read_inner_inner (Scheme_Object * port , Scheme_Object * stxsrc , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int comment_mode , int pre_char , Readtable * init_readtable , int get_info ) ; 
static Scheme_Object * read_inner (Scheme_Object * port , Scheme_Object * stxsrc , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int comment_mode ) ; 
static void set_need_copy (Scheme_Hash_Table * * ht ) {
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0)));
# define XfOrM49_COUNT (1)
# define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (! * ht ) {
    Scheme_Hash_Table * tht ; 
    BLOCK_SETUP((PUSH(tht, 0+XfOrM49_COUNT)));
#   define XfOrM50_COUNT (1+XfOrM49_COUNT)
#   define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
    tht = NULLED_OUT ; 
    tht = FUNCCALL(SETUP_XfOrM50(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    * ht = tht ; 
  }
  FUNCCALL_EMPTY(scheme_hash_set (* ht , tainted_uninterned_symbol , scheme_true ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_inner_inner_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * * ht = (Scheme_Hash_Table * * ) p -> ku . k . p2 ; 
  Scheme_Object * stxsrc = (Scheme_Object * ) p -> ku . k . p3 ; 
  Scheme_Object * indentation = (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . car ) ; 
  ReadParams * params = (ReadParams * ) (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . cdr ) ; 
  Readtable * table = (Readtable * ) p -> ku . k . p5 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 
  return read_inner_inner (o , stxsrc , ht , indentation , params , p -> ku . k . i1 , p -> ku . k . i2 , table , p -> ku . k . i3 ) ; 
}
static Scheme_Object * read_inner_inner (Scheme_Object * port , Scheme_Object * stxsrc , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int comment_mode , int pre_char , Readtable * table , int get_info ) {
  int ch , ch2 , depth , dispatch_ch , special_value_need_copy = 0 ; 
  long line = 0 , col = 0 , pos = 0 ; 
  Scheme_Object * special_value ; 
  long __funcarg58 ; 
  long __funcarg57 ; 
  long __funcarg56 ; 
  long __funcarg55 ; 
  long __funcarg54 ; 
  long __funcarg53 ; 
  long __funcarg52 ; 
  long __funcarg51 ; 
  long __funcarg50 ; 
  long __funcarg49 ; 
  long __funcarg48 ; 
  long __funcarg47 ; 
  long __funcarg46 ; 
  long __funcarg45 ; 
  long __funcarg44 ; 
  long __funcarg43 ; 
  long __funcarg42 ; 
  long __funcarg41 ; 
  long __funcarg40 ; 
  long __funcarg39 ; 
  long __funcarg38 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(special_value, 0), PUSH(stxsrc, 1), PUSH(indentation, 2), PUSH(params, 3), PUSH(table, 4), PUSH(ht, 5), PUSH(port, 6)));
# define XfOrM52_COUNT (7)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  special_value = NULLED_OUT ; 
  {
    unsigned long _stk_pos ; 
#   define XfOrM243_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM243(x) SETUP_XfOrM52(x)
    _stk_pos = (unsigned long ) & _stk_pos ; 
    if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
      Scheme_Thread * p = scheme_current_thread ; 
      Scheme_Object * pr ; 
      ReadParams * params2 ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM243_COUNT), PUSH(params2, 1+XfOrM243_COUNT), PUSH(pr, 2+XfOrM243_COUNT)));
#     define XfOrM244_COUNT (3+XfOrM243_COUNT)
#     define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
      pr = NULLED_OUT ; 
      params2 = NULLED_OUT ; 
      params2 = ((ReadParams * ) FUNCCALL(SETUP_XfOrM244(_), GC_malloc_one_small_tagged ((((sizeof (ReadParams ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      (memcpy (params2 , params , sizeof (ReadParams ) ) ) ; 
      params2 -> type = scheme_rt_read_params ; 
      p -> ku . k . p1 = (void * ) port ; 
      p -> ku . k . p2 = (void * ) ht ; 
      p -> ku . k . p3 = (void * ) stxsrc ; 
      pr = FUNCCALL(SETUP_XfOrM244(_), scheme_make_pair (indentation , (Scheme_Object * ) params2 ) ); 
      p -> ku . k . p4 = (void * ) pr ; 
      p -> ku . k . p5 = (void * ) table ; 
      p -> ku . k . i1 = comment_mode ; 
      p -> ku . k . i2 = pre_char ; 
      p -> ku . k . i3 = get_info ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (read_inner_inner_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }
  start_over : {
#   define XfOrM241_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM241(x) SETUP_XfOrM52(x)
    if ((scheme_fuel_counter ) <= 0 ) {
#     define XfOrM242_COUNT (0+XfOrM241_COUNT)
#     define SETUP_XfOrM242(x) SETUP_XfOrM241(x)
      FUNCCALL(SETUP_XfOrM242(_), scheme_out_of_fuel () ); 
    }
  }
  ; 
  while (1 ) {
#   define XfOrM237_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM237(x) SETUP_XfOrM52(x)
    if (pre_char >= 0 ) {
      ch = pre_char ; 
      pre_char = - 1 ; 
    }
    else ch = FUNCCALL(SETUP_XfOrM237(_), scheme_getc_special_ok (port ) ); 
    if (((ch ) >= 0 ) ) {
#     define XfOrM238_COUNT (0+XfOrM237_COUNT)
#     define SETUP_XfOrM238(x) SETUP_XfOrM237(x)
      if (table ) {
#       define XfOrM239_COUNT (0+XfOrM238_COUNT)
#       define SETUP_XfOrM239(x) SETUP_XfOrM238(x)
        if (! (FUNCCALL(SETUP_XfOrM239(_), readtable_kind (table , ch , params ) )& 0x1 ) )
          break ; 
      }
      else if (! (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) )
        break ; 
    }
    else break ; 
  }
  start_over_with_ch : FUNCCALL(SETUP_XfOrM52(_), scheme_tell_all (port , & line , & col , & pos ) ); 
  if (col >= 0 ) {
#   define XfOrM230_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM230(x) SETUP_XfOrM52(x)
    if (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      int effective_ch ; 
#     define XfOrM231_COUNT (0+XfOrM230_COUNT)
#     define SETUP_XfOrM231(x) SETUP_XfOrM230(x)
      effective_ch = FUNCCALL(SETUP_XfOrM231(_), readtable_effective_char (table , ch ) ); 
      if ((effective_ch != ';' ) && ! ((effective_ch == '#' ) && (FUNCCALL(SETUP_XfOrM231(_), scheme_peekc_special_ok (port ) )== '|' ) ) && (effective_ch != ')' ) && ((effective_ch != '}' ) || ! params -> curly_braces_are_parens ) && ((effective_ch != ']' ) || ! params -> square_brackets_are_parens ) ) {
#       define XfOrM232_COUNT (0+XfOrM231_COUNT)
#       define SETUP_XfOrM232(x) SETUP_XfOrM231(x)
        FUNCCALL(SETUP_XfOrM232(_), track_indentation (indentation , line , col ) ); 
      }
    }
  }
  special_value = ((void * ) 0 ) ; 
  if (table && ((ch ) >= 0 ) ) {
    Scheme_Object * v ; 
    int use_default , ch2 = ch ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM52_COUNT)));
#   define XfOrM228_COUNT (1+XfOrM52_COUNT)
#   define SETUP_XfOrM228(x) SETUP(XfOrM228_COUNT)
    v = NULLED_OUT ; 
    v = FUNCCALL(SETUP_XfOrM228(_), readtable_handle (table , & ch2 , & use_default , params , port , stxsrc , line , col , pos , ht ) ); 
    if (! use_default ) {
      dispatch_ch = (- 2 ) ; 
      special_value = v ; 
    }
    else dispatch_ch = ch2 ; 
  }
  else dispatch_ch = ch ; 
  if (get_info && (dispatch_ch != '#' ) && (dispatch_ch != ';' ) ) {
#   define XfOrM227_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM227(x) SETUP_XfOrM52(x)
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(expected_lang ("" , ch , port , stxsrc , line , col , pos , get_info ) )) RET_VALUE_EMPTY_END ; 
  }
  switch (dispatch_ch ) {
#   define XfOrM59_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM59(x) SETUP_XfOrM52(x)
    case (- 1 ) : RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 
    case (- 2 ) : {
#     define XfOrM225_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM225(x) SETUP_XfOrM59(x)
      if (! special_value ) {
#       define XfOrM226_COUNT (0+XfOrM225_COUNT)
#       define SETUP_XfOrM226(x) SETUP_XfOrM225(x)
        special_value = FUNCCALL(SETUP_XfOrM226(_), scheme_get_special (port , stxsrc , line , col , pos , 0 , ht ) ); 
        special_value_need_copy = 1 ; 
      }
      break ; 
    }
    case ']' : if (! params -> square_brackets_are_parens ) {
#     define XfOrM224_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM224(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal use of close square bracket" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else {
#     define XfOrM223_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM223(x) SETUP_XfOrM59(x)
      FUNCCALL(SETUP_XfOrM223(_), unexpected_closer (ch , port , stxsrc , line , col , pos , indentation , params ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    case '}' : if (! params -> curly_braces_are_parens ) {
#     define XfOrM222_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM222(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal use of close curly brace" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else {
#     define XfOrM221_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM221(x) SETUP_XfOrM59(x)
      FUNCCALL(SETUP_XfOrM221(_), unexpected_closer (ch , port , stxsrc , line , col , pos , indentation , params ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    case ')' : FUNCCALL(SETUP_XfOrM59(_), unexpected_closer (ch , port , stxsrc , line , col , pos , indentation , params ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    case '(' : RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_list (port , stxsrc , line , col , pos , ch , ')' , 0 , 0 , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
    case '[' : if (! params -> square_brackets_are_parens ) {
#     define XfOrM220_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM220(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal use of open square bracket" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_list (port , stxsrc , line , col , pos , ch , ']' , 0 , 0 , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
    case '{' : if (! params -> curly_braces_are_parens ) {
#     define XfOrM219_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM219(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal use of open curly brace" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_list (port , stxsrc , line , col , pos , ch , '}' , 0 , 0 , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
    case '|' : special_value = FUNCCALL(SETUP_XfOrM59(_), read_symbol (ch , 1 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
    break ; 
    case '"' : RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_string (0 , 0 , port , stxsrc , line , col , pos , ht , indentation , params , 1 ) )) RET_VALUE_EMPTY_END ; 
    case '\'' : if (params -> honu_mode ) {
#     define XfOrM218_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM218(x) SETUP_XfOrM59(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_string (0 , 1 , port , stxsrc , line , col , pos , ht , indentation , params , 1 ) )) RET_VALUE_EMPTY_END ; 
    }
    else {
#     define XfOrM217_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM217(x) SETUP_XfOrM59(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quoting '" , quote_symbol , 1 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
    }
    case '`' : if (params -> honu_mode ) {
#     define XfOrM216_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM216(x) SETUP_XfOrM59(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_symbol (ch , 1 , port , stxsrc , line , col , pos , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
    }
    else if (! params -> can_read_quasi ) {
#     define XfOrM215_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM215(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal use of backquote" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quasiquoting `" , quasiquote_symbol , 1 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
    case ',' : if (params -> honu_mode ) {
#     define XfOrM214_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM214(x) SETUP_XfOrM59(x)
      if (stxsrc )
        RET_VALUE_START ((__funcarg58 = FUNCCALL(SETUP_XfOrM214(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_make_stx_w_offset (honu_comma , line , col , pos , __funcarg58 , stxsrc , scheme_false ) )) ) RET_VALUE_END ; 
      else RET_VALUE_START (honu_comma ) RET_VALUE_END ; 
    }
    else if (! params -> can_read_quasi ) {
#     define XfOrM213_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM213(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal use of comma" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else {
#     define XfOrM211_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM211(x) SETUP_XfOrM59(x)
      if (FUNCCALL(SETUP_XfOrM211(_), scheme_peekc_special_ok (port ) )== '@' ) {
#       define XfOrM212_COUNT (0+XfOrM211_COUNT)
#       define SETUP_XfOrM212(x) SETUP_XfOrM211(x)
        ch = FUNCCALL(SETUP_XfOrM212(_), scheme_getc (port ) ); 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting ,@" , unquote_splicing_symbol , 2 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting ," , unquote_symbol , 1 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
    }
    case ';' : if (params -> honu_mode ) {
#     define XfOrM210_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM210(x) SETUP_XfOrM59(x)
      if (stxsrc )
        RET_VALUE_START ((__funcarg57 = FUNCCALL(SETUP_XfOrM210(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_make_stx_w_offset (honu_semicolon , line , col , pos , __funcarg57 , stxsrc , scheme_false ) )) ) RET_VALUE_END ; 
      else RET_VALUE_START (honu_semicolon ) RET_VALUE_END ; 
    }
    else {
#     define XfOrM205_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM205(x) SETUP_XfOrM59(x)
      while (((ch = FUNCCALL(SETUP_XfOrM205(_), scheme_getc_special_ok (port ) )) != '\n' ) && ! ((ch == '\n' ) || (ch == '\r' ) || (ch == 0x85 ) || (ch == 0x2028 ) || (ch == 0x2029 ) ) ) {
#       define XfOrM208_COUNT (0+XfOrM205_COUNT)
#       define SETUP_XfOrM208(x) SETUP_XfOrM205(x)
        if (ch == (- 1 ) ) {
          if (comment_mode & 0x8 )
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 
        }
        if (ch == (- 2 ) )
          FUNCCALL(SETUP_XfOrM208(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
      }
      if ((table && (comment_mode & 0x1 ) ) || (comment_mode & 0x8 ) )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      goto start_over ; 
    }
    case '+' : case '-' : if (params -> honu_mode ) {
#     define XfOrM204_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM204(x) SETUP_XfOrM59(x)
      special_value = FUNCCALL(SETUP_XfOrM204(_), read_symbol (ch , 1 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
      break ; 
    }
    case '.' : ch2 = FUNCCALL(SETUP_XfOrM59(_), scheme_peekc_special_ok (port ) ); 
    if ((((ch2 ) >= 0 ) && ((ch2 >= '0' ) && (ch2 <= '9' ) ) ) || (ch2 == '.' ) || (! params -> honu_mode && ((ch2 == 'i' ) || (ch2 == 'I' ) || (ch2 == 'n' ) || (ch2 == 'N' ) ) ) ) {
#     define XfOrM203_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM203(x) SETUP_XfOrM59(x)
      special_value = FUNCCALL(SETUP_XfOrM203(_), read_number (ch , port , stxsrc , line , col , pos , 0 , 0 , 10 , 0 , ht , indentation , params , table ) ); 
    }
    else {
#     define XfOrM202_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM202(x) SETUP_XfOrM59(x)
      special_value = FUNCCALL(SETUP_XfOrM202(_), read_symbol (ch , 0 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
    }
    break ; 
    case '#' : ch = FUNCCALL(SETUP_XfOrM59(_), scheme_getc_special_ok (port ) ); 
    if (get_info && (ch != '|' ) && (ch != '!' ) && (ch != 'l' ) && (ch != ';' ) ) {
#     define XfOrM201_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM201(x) SETUP_XfOrM59(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(expected_lang ("#" , ch , port , stxsrc , line , col , pos , get_info ) )) RET_VALUE_EMPTY_END ; 
    }
    if (table ) {
      Scheme_Object * v ; 
      int use_default ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM59_COUNT)));
#     define XfOrM199_COUNT (1+XfOrM59_COUNT)
#     define SETUP_XfOrM199(x) SETUP(XfOrM199_COUNT)
      v = NULLED_OUT ; 
      v = FUNCCALL(SETUP_XfOrM199(_), readtable_handle_hash (table , ch , & use_default , params , port , stxsrc , line , col , pos , ht ) ); 
      if (! use_default ) {
        if (v )
          RET_VALUE_START (v ) RET_VALUE_END ; 
        if (comment_mode & 0x1 )
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        goto start_over ; 
      }
    }
    special_value = ((void * ) 0 ) ; 
    switch (ch ) {
#     define XfOrM65_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM65(x) SETUP_XfOrM59(x)
      case (- 1 ) : case (- 2 ) : FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , ch , indentation , "read: bad syntax `#'" ) ); 
      break ; 
      case ';' : {
        Scheme_Object * skipped ; 
        BLOCK_SETUP((PUSH(skipped, 0+XfOrM65_COUNT)));
#       define XfOrM197_COUNT (1+XfOrM65_COUNT)
#       define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
        skipped = NULLED_OUT ; 
        skipped = FUNCCALL(SETUP_XfOrM197(_), read_inner (port , stxsrc , ht , indentation , params , 0 ) ); 
        if ((((skipped ) ) == (scheme_eof ) ) )
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (2 ) , (- 1 ) , indentation , "read: expected a commented-out element for `#;' (found end-of-file)" ) ); 
        if (* ht ) {
          Scheme_Object * v ; 
          BLOCK_SETUP((PUSH(v, 0+XfOrM197_COUNT)));
#         define XfOrM198_COUNT (1+XfOrM197_COUNT)
#         define SETUP_XfOrM198(x) SETUP(XfOrM198_COUNT)
          v = NULLED_OUT ; 
          v = FUNCCALL(SETUP_XfOrM198(_), scheme_hash_get (* ht , unresolved_uninterned_symbol ) ); 
          if (! v )
            v = scheme_null ; 
          v = FUNCCALL(SETUP_XfOrM198(_), scheme_make_pair (skipped , v ) ); 
          FUNCCALL_AGAIN(scheme_hash_set (* ht , unresolved_uninterned_symbol , v ) ); 
        }
        if ((comment_mode & 0x2 ) || (table && (comment_mode & 0x1 ) ) || (comment_mode & 0x8 ) )
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        goto start_over ; 
      }
      break ; 
      case '%' : if (! params -> honu_mode ) {
#       define XfOrM196_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM196(x) SETUP_XfOrM65(x)
        FUNCCALL(SETUP_XfOrM196(_), scheme_ungetc ('%' , port ) ); 
        special_value = FUNCCALL(SETUP_XfOrM196(_), read_symbol ('#' , 1 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
      }
      break ; 
      case ':' : if (! params -> honu_mode ) {
#       define XfOrM195_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM195(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_keyword (- 1 , port , stxsrc , line , col , pos , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '(' : if (! params -> honu_mode ) {
#       define XfOrM194_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM194(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , stxsrc , line , col , pos , ch , ')' , - 1 , ((void * ) 0 ) , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '[' : if (! params -> honu_mode ) {
#       define XfOrM192_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM192(x) SETUP_XfOrM65(x)
        if (! params -> square_brackets_are_parens ) {
#         define XfOrM193_COUNT (0+XfOrM192_COUNT)
#         define SETUP_XfOrM193(x) SETUP_XfOrM192(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: bad syntax `#['" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , stxsrc , line , col , pos , ch , ']' , - 1 , ((void * ) 0 ) , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '{' : if (! params -> honu_mode ) {
#       define XfOrM190_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM190(x) SETUP_XfOrM65(x)
        if (! params -> curly_braces_are_parens ) {
#         define XfOrM191_COUNT (0+XfOrM190_COUNT)
#         define SETUP_XfOrM191(x) SETUP_XfOrM190(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: bad syntax `#{'" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , stxsrc , line , col , pos , ch , '}' , - 1 , ((void * ) 0 ) , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '\\' : if (! params -> honu_mode ) {
        Scheme_Object * chr ; 
        BLOCK_SETUP((PUSH(chr, 0+XfOrM65_COUNT)));
#       define XfOrM189_COUNT (1+XfOrM65_COUNT)
#       define SETUP_XfOrM189(x) SETUP(XfOrM189_COUNT)
        chr = NULLED_OUT ; 
        chr = FUNCCALL(SETUP_XfOrM189(_), read_character (port , stxsrc , line , col , pos , ht , indentation , params ) ); 
        if (stxsrc )
          chr = (__funcarg56 = FUNCCALL(SETUP_XfOrM189(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (chr , line , col , pos , __funcarg56 , stxsrc , scheme_false ) )) ; 
        RET_VALUE_START (chr ) RET_VALUE_END ; 
      }
      break ; 
      case 'T' : case 't' : if (! params -> honu_mode ) {
#       define XfOrM188_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM188(x) SETUP_XfOrM65(x)
        RET_VALUE_START ((stxsrc ? FUNCCALL(SETUP_XfOrM188(_), scheme_make_stx_w_offset (scheme_true , line , col , pos , 2 , stxsrc , scheme_false ) ): scheme_true ) ) RET_VALUE_END ; 
      }
      case 'F' : case 'f' : if (! params -> honu_mode ) {
#       define XfOrM187_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM187(x) SETUP_XfOrM65(x)
        RET_VALUE_START ((stxsrc ? FUNCCALL(SETUP_XfOrM187(_), scheme_make_stx_w_offset (scheme_false , line , col , pos , 2 , stxsrc , scheme_false ) ): scheme_false ) ) RET_VALUE_END ; 
      }
      case 'c' : case 'C' : if (! params -> honu_mode ) {
        Scheme_Object * v ; 
        int sens = 0 ; 
        int save_sens ; 
        BLOCK_SETUP((PUSH(v, 0+XfOrM65_COUNT)));
#       define XfOrM184_COUNT (1+XfOrM65_COUNT)
#       define SETUP_XfOrM184(x) SETUP(XfOrM184_COUNT)
        v = NULLED_OUT ; 
        ch = FUNCCALL(SETUP_XfOrM184(_), scheme_getc_special_ok (port ) ); 
        switch (ch ) {
#         define XfOrM186_COUNT (0+XfOrM184_COUNT)
#         define SETUP_XfOrM186(x) SETUP_XfOrM184(x)
          case 'i' : case 'I' : sens = 0 ; 
          break ; 
          case 's' : case 'S' : sens = 1 ; 
          break ; 
          default : FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , ch , indentation , "read: expected `s' or `i' after #c" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        save_sens = params -> case_sensitive ; 
        params -> case_sensitive = sens ; 
        v = FUNCCALL(SETUP_XfOrM184(_), read_inner (port , stxsrc , ht , indentation , params , 0 ) ); 
        params -> case_sensitive = save_sens ; 
        if ((((v ) ) == (scheme_eof ) ) ) {
#         define XfOrM185_COUNT (0+XfOrM184_COUNT)
#         define SETUP_XfOrM185(x) SETUP_XfOrM184(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , (- 1 ) , indentation , "read: end-of-file after #c%c" , sens ? 's' : 'i' ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        RET_VALUE_START (v ) RET_VALUE_END ; 
      }
      break ; 
      case 's' : case 'S' : {
        int orig_ch = ch , effective_ch ; 
#       define XfOrM176_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM176(x) SETUP_XfOrM65(x)
        ch = FUNCCALL(SETUP_XfOrM176(_), scheme_getc_special_ok (port ) ); 
        if (((ch ) >= 0 ) )
          effective_ch = FUNCCALL(SETUP_XfOrM176(_), readtable_effective_char (params -> table , ch ) ); 
        else effective_ch = ch ; 
        if ((orig_ch == 's' ) && ((effective_ch == '(' ) || (effective_ch == '[' && params -> square_brackets_are_parens ) || (effective_ch == '{' && params -> curly_braces_are_parens ) ) ) {
          Scheme_Object * v ; 
          Scheme_Struct_Type * st ; 
          BLOCK_SETUP((PUSH(v, 0+XfOrM176_COUNT), PUSH(st, 1+XfOrM176_COUNT)));
#         define XfOrM180_COUNT (2+XfOrM176_COUNT)
#         define SETUP_XfOrM180(x) SETUP(XfOrM180_COUNT)
          v = NULLED_OUT ; 
          st = NULLED_OUT ; 
          if (effective_ch == '(' )
            ch = ')' ; 
          else if (effective_ch == '[' )
            ch = ']' ; 
          else if (effective_ch == '{' )
            ch = '}' ; 
          v = FUNCCALL(SETUP_XfOrM180(_), read_vector (port , stxsrc , line , col , pos , orig_ch , ch , - 1 , ((void * ) 0 ) , ht , indentation , params ) ); 
          if (stxsrc )
            v = ((Scheme_Stx * ) v ) -> val ; 
          if ((((Scheme_Vector * ) (v ) ) -> size ) ) {
            Scheme_Object * key ; 
            BLOCK_SETUP((PUSH(key, 0+XfOrM180_COUNT)));
#           define XfOrM183_COUNT (1+XfOrM180_COUNT)
#           define SETUP_XfOrM183(x) SETUP(XfOrM183_COUNT)
            key = NULLED_OUT ; 
            key = (((Scheme_Vector * ) (v ) ) -> els ) [0 ] ; 
            if (stxsrc )
              key = FUNCCALL(SETUP_XfOrM183(_), scheme_syntax_to_datum (key , 0 , ((void * ) 0 ) ) ); 
            st = FUNCCALL(SETUP_XfOrM183(_), scheme_lookup_prefab_type (key , (((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ); 
          }
          else st = ((void * ) 0 ) ; 
          if (! st || (st -> num_slots != ((((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ) ) {
#           define XfOrM182_COUNT (0+XfOrM180_COUNT)
#           define SETUP_XfOrM182(x) SETUP_XfOrM180(x)
            (__funcarg55 = FUNCCALL(SETUP_XfOrM182(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_read_err (port , stxsrc , line , col , pos , __funcarg55 , (- 1 ) , indentation , ((((Scheme_Vector * ) (v ) ) -> size ) ? (st ? ("read: mismatch between structure description" " and number of provided field values in `#s' form" ) : "read: invalid structure description in `#s' form" ) : "read: missing structure description in `#s' form" ) ) )) ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          if (stxsrc && ! ((& st -> iso ) -> so . keyex & 0x1 ) ) {
#           define XfOrM181_COUNT (0+XfOrM180_COUNT)
#           define SETUP_XfOrM181(x) SETUP_XfOrM180(x)
            (__funcarg54 = FUNCCALL(SETUP_XfOrM181(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_read_err (port , stxsrc , line , col , pos , __funcarg54 , (- 1 ) , indentation , "read: cannot read mutable `#s' form as syntax" ) )) ; 
          }
          v = FUNCCALL(SETUP_XfOrM180(_), scheme_make_prefab_struct_instance (st , v ) ); 
          if (stxsrc )
            v = (__funcarg53 = FUNCCALL(SETUP_XfOrM180(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (v , line , col , pos , __funcarg53 , stxsrc , scheme_false ) )) ; 
          RET_VALUE_START (v ) RET_VALUE_END ; 
        }
        else if ((ch == 'x' ) || (ch == 'X' ) ) {
          ReadParams params_copy ; 
          Scheme_Object * v ; 
          BLOCK_SETUP((PUSH(v, 0+XfOrM176_COUNT), PUSH(params_copy.table, 1+XfOrM176_COUNT), PUSH(params_copy.magic_sym, 2+XfOrM176_COUNT), PUSH(params_copy.magic_val, 3+XfOrM176_COUNT), PUSH(params_copy.delay_load_info, 4+XfOrM176_COUNT)));
#         define XfOrM178_COUNT (5+XfOrM176_COUNT)
#         define SETUP_XfOrM178(x) SETUP(XfOrM178_COUNT)
          params_copy.table = NULLED_OUT ; 
          params_copy.magic_sym = NULLED_OUT ; 
          params_copy.magic_val = NULLED_OUT ; 
          params_copy.delay_load_info = NULLED_OUT ; 
          v = NULLED_OUT ; 
          (memcpy (& params_copy , params , sizeof (ReadParams ) ) ) ; 
          params_copy . honu_mode = 0 ; 
          v = FUNCCALL(SETUP_XfOrM178(_), read_inner (port , stxsrc , ht , indentation , & params_copy , 0 ) ); 
          if ((((v ) ) == (scheme_eof ) ) ) {
#           define XfOrM179_COUNT (0+XfOrM178_COUNT)
#           define SETUP_XfOrM179(x) SETUP_XfOrM178(x)
            FUNCCALL(SETUP_XfOrM179(_), scheme_read_err (port , stxsrc , line , col , pos , 2 , (- 1 ) , indentation , "read: end-of-file after #sx" ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          RET_VALUE_START (v ) RET_VALUE_END ; 
        }
        else {
#         define XfOrM177_COUNT (0+XfOrM176_COUNT)
#         define SETUP_XfOrM177(x) SETUP_XfOrM176(x)
          (__funcarg52 = FUNCCALL(SETUP_XfOrM177(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg52 , ch , indentation , "read: expected `x'%s after `#%c'" , (orig_ch == 's' ? "or `('" : "" ) , orig_ch ) )) ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      case 'X' : case 'x' : if (! params -> honu_mode ) {
#       define XfOrM175_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM175(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , stxsrc , line , col , pos , 0 , 0 , 16 , 1 , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 'B' : case 'b' : if (! params -> honu_mode ) {
#       define XfOrM174_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM174(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , stxsrc , line , col , pos , 0 , 0 , 2 , 1 , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 'O' : case 'o' : if (! params -> honu_mode ) {
#       define XfOrM173_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM173(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , stxsrc , line , col , pos , 0 , 0 , 8 , 1 , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 'D' : case 'd' : if (! params -> honu_mode ) {
#       define XfOrM172_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM172(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , stxsrc , line , col , pos , 0 , 0 , 10 , 1 , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 'E' : case 'e' : if (! params -> honu_mode ) {
#       define XfOrM171_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM171(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , stxsrc , line , col , pos , 0 , 1 , 10 , 0 , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 'I' : case 'i' : if (! params -> honu_mode ) {
#       define XfOrM170_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM170(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , stxsrc , line , col , pos , 1 , 0 , 10 , 0 , ht , indentation , params , table ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '\'' : if (! params -> honu_mode ) {
#       define XfOrM169_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM169(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quoting #'" , syntax_symbol , 2 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '`' : if (! params -> honu_mode ) {
#       define XfOrM168_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM168(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quasiquoting #`" , quasisyntax_symbol , 2 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case ',' : if (! params -> honu_mode ) {
#       define XfOrM166_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM166(x) SETUP_XfOrM65(x)
        if (FUNCCALL(SETUP_XfOrM166(_), scheme_peekc_special_ok (port ) )== '@' ) {
#         define XfOrM167_COUNT (0+XfOrM166_COUNT)
#         define SETUP_XfOrM167(x) SETUP_XfOrM166(x)
          ch = FUNCCALL(SETUP_XfOrM167(_), scheme_getc (port ) ); 
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting #`@" , unsyntax_splicing_symbol , 3 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
        }
        else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting #`" , unsyntax_symbol , 2 , port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '~' : if (! params -> honu_mode ) {
#       define XfOrM163_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM163(x) SETUP_XfOrM65(x)
        if (params -> can_read_compiled ) {
          Scheme_Object * cpld ; 
          BLOCK_SETUP((PUSH(cpld, 0+XfOrM163_COUNT)));
#         define XfOrM165_COUNT (1+XfOrM163_COUNT)
#         define SETUP_XfOrM165(x) SETUP(XfOrM165_COUNT)
          cpld = NULLED_OUT ; 
          cpld = FUNCCALL(SETUP_XfOrM165(_), read_compiled (port , stxsrc , line , col , pos , ht , params ) ); 
          if (stxsrc )
            cpld = (__funcarg51 = FUNCCALL(SETUP_XfOrM165(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (cpld , line , col , pos , __funcarg51 , stxsrc , scheme_false ) )) ; 
          RET_VALUE_START (cpld ) RET_VALUE_END ; 
        }
        else {
#         define XfOrM164_COUNT (0+XfOrM163_COUNT)
#         define SETUP_XfOrM164(x) SETUP_XfOrM163(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: #~ compiled expressions not currently enabled" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
      case '|' : if (! params -> honu_mode ) {
#       define XfOrM154_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM154(x) SETUP_XfOrM65(x)
        depth = 0 ; 
        ch2 = 0 ; 
        do {
#         define XfOrM159_COUNT (0+XfOrM154_COUNT)
#         define SETUP_XfOrM159(x) SETUP_XfOrM154(x)
          ch = FUNCCALL(SETUP_XfOrM159(_), scheme_getc_special_ok (port ) ); 
          if (ch == (- 1 ) )
            FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (2 ) , (- 1 ) , indentation , "read: end of file in #| comment" ) ); 
          else if (ch == (- 2 ) )
            FUNCCALL(SETUP_XfOrM159(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
          if ((ch2 == '|' ) && (ch == '#' ) ) {
            if (! (depth -- ) ) {
              if ((table && (comment_mode & 0x1 ) ) || (comment_mode & 0x8 ) )
                RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
              goto start_over ; 
            }
            ch = 0 ; 
          }
          else if ((ch2 == '#' ) && (ch == '|' ) ) {
            depth ++ ; 
            ch = 0 ; 
          }
          ch2 = ch ; 
        }
        while (1 ) ; 
      }
      break ; 
      case '&' : if (! params -> honu_mode ) {
#       define XfOrM152_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM152(x) SETUP_XfOrM65(x)
        if (params -> can_read_box )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_box (port , stxsrc , line , col , pos , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
        else {
#         define XfOrM153_COUNT (0+XfOrM152_COUNT)
#         define SETUP_XfOrM153(x) SETUP_XfOrM152(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: #& expressions not currently enabled" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
      case 'l' : {
        mzchar found [5 ] ; 
        int fl = 1 ; 
#       define XfOrM144_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM144(x) SETUP_XfOrM65(x)
        found [0 ] = 'l' ; 
        ch = FUNCCALL(SETUP_XfOrM144(_), scheme_getc_special_ok (port ) ); 
        found [fl ++ ] = ch ; 
        if (ch == 'a' ) {
#         define XfOrM145_COUNT (0+XfOrM144_COUNT)
#         define SETUP_XfOrM145(x) SETUP_XfOrM144(x)
          ch = FUNCCALL(SETUP_XfOrM145(_), scheme_getc_special_ok (port ) ); 
          found [fl ++ ] = ch ; 
          if (ch == 'n' ) {
#           define XfOrM146_COUNT (0+XfOrM145_COUNT)
#           define SETUP_XfOrM146(x) SETUP_XfOrM145(x)
            ch = FUNCCALL(SETUP_XfOrM146(_), scheme_getc_special_ok (port ) ); 
            found [fl ++ ] = ch ; 
            if (ch == 'g' ) {
#             define XfOrM147_COUNT (0+XfOrM146_COUNT)
#             define SETUP_XfOrM147(x) SETUP_XfOrM146(x)
              ch = FUNCCALL(SETUP_XfOrM147(_), scheme_getc_special_ok (port ) ); 
              found [fl ++ ] = ch ; 
              if (ch == ' ' ) {
                Scheme_Object * v ; 
                BLOCK_SETUP((PUSH(v, 0+XfOrM147_COUNT)));
#               define XfOrM149_COUNT (1+XfOrM147_COUNT)
#               define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
                v = NULLED_OUT ; 
                if (! params -> can_read_reader ) {
#                 define XfOrM151_COUNT (0+XfOrM149_COUNT)
#                 define SETUP_XfOrM151(x) SETUP_XfOrM149(x)
                  FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 6 , 0 , indentation , "read: #lang expressions not currently enabled" ) ); 
                  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
                }
                v = FUNCCALL(SETUP_XfOrM149(_), read_lang (port , stxsrc , line , col , pos , get_info , ht , indentation , params , 0 ) ); 
                if (! v ) {
                  if (comment_mode & 0x1 )
                    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
                  goto start_over ; 
                }
                RET_VALUE_START (v ) RET_VALUE_END ; 
              }
              else {
#               define XfOrM148_COUNT (0+XfOrM147_COUNT)
#               define SETUP_XfOrM148(x) SETUP_XfOrM147(x)
                FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 6 , ch , indentation , "read: expected a single space after `#lang'" , found , fl ) ); 
                RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
              }
            }
          }
        }
        FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , fl , ch , indentation , "read: bad input: `#%u'" , found , fl ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      break ; 
      case 'r' : case 'p' : if (! params -> honu_mode ) {
        int orig_ch = ch ; 
        int cnt = 0 , is_byte = 0 ; 
        char * expect ; 
        BLOCK_SETUP((PUSH(expect, 0+XfOrM65_COUNT)));
#       define XfOrM129_COUNT (1+XfOrM65_COUNT)
#       define SETUP_XfOrM129(x) SETUP(XfOrM129_COUNT)
        expect = NULLED_OUT ; 
        ch = FUNCCALL(SETUP_XfOrM129(_), scheme_getc_special_ok (port ) ); 
        if (ch == 'x' ) {
#         define XfOrM140_COUNT (0+XfOrM129_COUNT)
#         define SETUP_XfOrM140(x) SETUP_XfOrM129(x)
          expect = "x#" ; 
          ch = FUNCCALL(SETUP_XfOrM140(_), scheme_getc_special_ok (port ) ); 
          cnt ++ ; 
          if (ch == '#' ) {
#           define XfOrM143_COUNT (0+XfOrM140_COUNT)
#           define SETUP_XfOrM143(x) SETUP_XfOrM140(x)
            is_byte = 1 ; 
            cnt ++ ; 
            ch = FUNCCALL(SETUP_XfOrM143(_), scheme_getc_special_ok (port ) ); 
          }
          if (ch == '"' ) {
            Scheme_Object * str ; 
            int is_err ; 
            long sline = 0 , scol = 0 , spos = 0 ; 
            BLOCK_SETUP((PUSH(str, 0+XfOrM140_COUNT)));
#           define XfOrM141_COUNT (1+XfOrM140_COUNT)
#           define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
            str = NULLED_OUT ; 
            FUNCCALL(SETUP_XfOrM141(_), scheme_tell_all (port , & sline , & scol , & spos ) ); 
            str = FUNCCALL_AGAIN(read_string (is_byte , 0 , port , stxsrc , sline , scol , spos , ht , indentation , params , 1 ) ); 
            if (stxsrc )
              str = ((Scheme_Stx * ) str ) -> val ; 
            str = FUNCCALL(SETUP_XfOrM141(_), scheme_make_regexp (str , is_byte , (orig_ch == 'p' ) , & is_err ) ); 
            if (is_err ) {
#             define XfOrM142_COUNT (0+XfOrM141_COUNT)
#             define SETUP_XfOrM142(x) SETUP_XfOrM141(x)
              FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , sline , scol , spos , 2 , 0 , indentation , "read: bad %sregexp string: %s" , (orig_ch == 'r' ) ? "" : "p" , (char * ) str ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            if (stxsrc )
              str = (__funcarg50 = FUNCCALL(SETUP_XfOrM141(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (str , line , col , pos , __funcarg50 , stxsrc , scheme_false ) )) ; 
            RET_VALUE_START (str ) RET_VALUE_END ; 
          }
        }
        else if ((orig_ch == 'r' ) && (ch == 'e' ) ) {
#         define XfOrM134_COUNT (0+XfOrM129_COUNT)
#         define SETUP_XfOrM134(x) SETUP_XfOrM129(x)
          expect = "eader" ; 
          cnt ++ ; 
          while (expect [cnt ] ) {
#           define XfOrM139_COUNT (0+XfOrM134_COUNT)
#           define SETUP_XfOrM139(x) SETUP_XfOrM134(x)
            ch = FUNCCALL(SETUP_XfOrM139(_), scheme_getc_special_ok (port ) ); 
            if (ch != expect [cnt ] )
              break ; 
            cnt ++ ; 
          }
          if (! expect [cnt ] ) {
            Scheme_Object * v ; 
            BLOCK_SETUP((PUSH(v, 0+XfOrM134_COUNT)));
#           define XfOrM135_COUNT (1+XfOrM134_COUNT)
#           define SETUP_XfOrM135(x) SETUP(XfOrM135_COUNT)
            v = NULLED_OUT ; 
            if (! params -> can_read_reader ) {
#             define XfOrM137_COUNT (0+XfOrM135_COUNT)
#             define SETUP_XfOrM137(x) SETUP_XfOrM135(x)
              FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 7 , 0 , indentation , "read: #reader expressions not currently enabled" ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            v = FUNCCALL(SETUP_XfOrM135(_), read_reader (port , stxsrc , line , col , pos , ht , indentation , params ) ); 
            if (! v ) {
              if (comment_mode & 0x1 )
                RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
              goto start_over ; 
            }
            RET_VALUE_START (v ) RET_VALUE_END ; 
          }
        }
        else expect = "" ; 
        {
          mzchar a [6 ] ; 
          int i ; 
#         define XfOrM130_COUNT (0+XfOrM129_COUNT)
#         define SETUP_XfOrM130(x) SETUP_XfOrM129(x)
          for (i = 0 ; i < cnt ; i ++ ) {
            a [i ] = expect [i ] ; 
          }
          if (((ch ) >= 0 ) ) {
            a [cnt ++ ] = ch ; 
          }
          (__funcarg49 = FUNCCALL(SETUP_XfOrM130(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg49 , ch , indentation , "read: bad syntax `#%c%u'" , orig_ch , a , cnt ) )) ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
      case 'h' : {
        int honu = 0 ; 
#       define XfOrM111_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM111(x) SETUP_XfOrM65(x)
        ch = FUNCCALL(SETUP_XfOrM111(_), scheme_getc_special_ok (port ) ); 
        switch (ch ) {
#         define XfOrM127_COUNT (0+XfOrM111_COUNT)
#         define SETUP_XfOrM127(x) SETUP_XfOrM111(x)
          case 'a' : honu = 0 ; 
          break ; 
          case 'x' : honu = 1 ; 
          break ; 
          default : if (! params -> honu_mode ) {
#           define XfOrM128_COUNT (0+XfOrM127_COUNT)
#           define SETUP_XfOrM128(x) SETUP_XfOrM127(x)
            FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , ch , indentation , "read: expected `a' or `x' after #h" ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          honu = 0 ; 
          break ; 
        }
        if (params -> honu_mode && (honu != 1 ) ) {
#         define XfOrM126_COUNT (0+XfOrM111_COUNT)
#         define SETUP_XfOrM126(x) SETUP_XfOrM111(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , ch , indentation , "read: expected `x' after #h" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        if (honu ) {
          ReadParams params_copy ; 
          Scheme_Object * v ; 
          BLOCK_SETUP((PUSH(v, 0+XfOrM111_COUNT), PUSH(params_copy.table, 1+XfOrM111_COUNT), PUSH(params_copy.magic_sym, 2+XfOrM111_COUNT), PUSH(params_copy.magic_val, 3+XfOrM111_COUNT), PUSH(params_copy.delay_load_info, 4+XfOrM111_COUNT)));
#         define XfOrM124_COUNT (5+XfOrM111_COUNT)
#         define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
          params_copy.table = NULLED_OUT ; 
          params_copy.magic_sym = NULLED_OUT ; 
          params_copy.magic_val = NULLED_OUT ; 
          params_copy.delay_load_info = NULLED_OUT ; 
          v = NULLED_OUT ; 
          (memcpy (& params_copy , params , sizeof (ReadParams ) ) ) ; 
          params_copy . honu_mode = 1 ; 
          v = FUNCCALL(SETUP_XfOrM124(_), read_inner (port , stxsrc , ht , indentation , & params_copy , 0 ) ); 
          if ((((v ) ) == (scheme_eof ) ) ) {
#           define XfOrM125_COUNT (0+XfOrM124_COUNT)
#           define SETUP_XfOrM125(x) SETUP_XfOrM124(x)
            FUNCCALL(SETUP_XfOrM125(_), scheme_read_err (port , stxsrc , line , col , pos , 2 , (- 1 ) , indentation , "read: end-of-file after #hx" ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          RET_VALUE_START (v ) RET_VALUE_END ; 
        }
        else {
          GC_CAN_IGNORE const mzchar str [] = {
            's' , 'h' , 'e' , 'q' , 'v' , 0 }
          ; 
          int scanpos = 0 , failed = 0 ; 
#         define XfOrM112_COUNT (0+XfOrM111_COUNT)
#         define SETUP_XfOrM112(x) SETUP_XfOrM111(x)
          do {
#           define XfOrM120_COUNT (0+XfOrM112_COUNT)
#           define SETUP_XfOrM120(x) SETUP_XfOrM112(x)
            ch = FUNCCALL(SETUP_XfOrM120(_), scheme_getc_special_ok (port ) ); 
            if ((mzchar ) ch == str [scanpos ] ) {
              scanpos ++ ; 
            }
            else {
#             define XfOrM121_COUNT (0+XfOrM120_COUNT)
#             define SETUP_XfOrM121(x) SETUP_XfOrM120(x)
              if ((scanpos == 2 ) || (scanpos == 4 ) ) {
                int effective_ch ; 
#               define XfOrM122_COUNT (0+XfOrM121_COUNT)
#               define SETUP_XfOrM122(x) SETUP_XfOrM121(x)
                effective_ch = FUNCCALL(SETUP_XfOrM122(_), readtable_effective_char (table , ch ) ); 
                if (! (effective_ch == '(' ) && ! (effective_ch == '[' && params -> square_brackets_are_parens ) && ! (effective_ch == '{' && params -> curly_braces_are_parens ) )
                  failed = 1 ; 
              }
              else failed = 1 ; 
              break ; 
            }
          }
          while (str [scanpos ] ) ; 
          if (! failed ) {
            int effective_ch , kind ; 
#           define XfOrM115_COUNT (0+XfOrM112_COUNT)
#           define SETUP_XfOrM115(x) SETUP_XfOrM112(x)
            if (scanpos > 4 )
              ch = FUNCCALL(SETUP_XfOrM115(_), scheme_getc_special_ok (port ) ); 
            effective_ch = FUNCCALL(SETUP_XfOrM115(_), readtable_effective_char (table , ch ) ); 
            if (scanpos == 4 )
              kind = 0 ; 
            else if (scanpos == 2 )
              kind = 1 ; 
            else kind = 2 ; 
            if (effective_ch == '(' )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_hash (port , stxsrc , line , col , pos , ch , ')' , kind , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
            if (effective_ch == '[' && params -> square_brackets_are_parens )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_hash (port , stxsrc , line , col , pos , ch , ']' , kind , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
            if (effective_ch == '{' && params -> curly_braces_are_parens )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_hash (port , stxsrc , line , col , pos , ch , '}' , kind , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
          }
          {
            mzchar str_part [7 ] , one_more [2 ] ; 
#           define XfOrM113_COUNT (0+XfOrM112_COUNT)
#           define SETUP_XfOrM113(x) SETUP_XfOrM112(x)
            (memcpy (str_part , str , scanpos * sizeof (mzchar ) ) ) ; 
            str_part [scanpos ] = 0 ; 
            if (((ch ) >= 0 ) ) {
              one_more [0 ] = ch ; 
              one_more [1 ] = 0 ; 
            }
            else one_more [0 ] = 0 ; 
            (__funcarg48 = FUNCCALL(SETUP_XfOrM113(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg48 , ch , indentation , "read: bad syntax `#ha%5%u'" , str_part , one_more , ((ch ) >= 0 ) ? 1 : 0 ) )) ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }
      }
      break ; 
      case '"' : if (! params -> honu_mode ) {
#       define XfOrM110_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM110(x) SETUP_XfOrM65(x)
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_string (1 , 0 , port , stxsrc , line , col , pos , ht , indentation , params , 1 ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case '<' : if (! params -> honu_mode ) {
#       define XfOrM107_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM107(x) SETUP_XfOrM65(x)
        if (FUNCCALL(SETUP_XfOrM107(_), scheme_peekc_special_ok (port ) )== '<' ) {
#         define XfOrM109_COUNT (0+XfOrM107_COUNT)
#         define SETUP_XfOrM109(x) SETUP_XfOrM107(x)
          ch = FUNCCALL(SETUP_XfOrM109(_), scheme_getc_special_ok (port ) ); 
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_here_string (port , stxsrc , line , col , pos , indentation , params ) )) RET_VALUE_EMPTY_END ; 
        }
        else {
#         define XfOrM108_COUNT (0+XfOrM107_COUNT)
#         define SETUP_XfOrM108(x) SETUP_XfOrM107(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: bad syntax `#<'" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
      case '!' : ch = FUNCCALL(SETUP_XfOrM65(_), scheme_getc_special_ok (port ) ); 
      if ((ch == ' ' ) || (ch == '/' ) ) {
        int was_backslash = 0 , was_backslash_cr = 0 , prev_backslash_cr ; 
#       define XfOrM94_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM94(x) SETUP_XfOrM65(x)
        while (1 ) {
#         define XfOrM101_COUNT (0+XfOrM94_COUNT)
#         define SETUP_XfOrM101(x) SETUP_XfOrM94(x)
          prev_backslash_cr = was_backslash_cr ; 
          was_backslash_cr = 0 ; 
          ch = FUNCCALL(SETUP_XfOrM101(_), scheme_getc_special_ok (port ) ); 
          if (ch == (- 1 ) ) {
            break ; 
          }
          else if (ch == (- 2 ) ) {
#           define XfOrM105_COUNT (0+XfOrM101_COUNT)
#           define SETUP_XfOrM105(x) SETUP_XfOrM101(x)
            FUNCCALL(SETUP_XfOrM105(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
          }
          else if (ch == '\r' ) {
            if (was_backslash ) {
              was_backslash_cr = 1 ; 
            }
            else break ; 
          }
          else if (ch == '\n' ) {
            if (! was_backslash && ! was_backslash_cr )
              break ; 
          }
          was_backslash = (ch == '\\' ) ; 
        }
        if (comment_mode & 0x8 )
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        goto start_over ; 
      }
      else if ((ch < 128 ) && ((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x80 ) || (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x40 ) || ((ch ) == '-' ) || ((ch ) == '+' ) || ((ch ) == '_' ) ) ) {
        Scheme_Object * v ; 
        BLOCK_SETUP((PUSH(v, 0+XfOrM65_COUNT)));
#       define XfOrM91_COUNT (1+XfOrM65_COUNT)
#       define SETUP_XfOrM91(x) SETUP(XfOrM91_COUNT)
        v = NULLED_OUT ; 
        if (! params -> can_read_reader ) {
#         define XfOrM93_COUNT (0+XfOrM91_COUNT)
#         define SETUP_XfOrM93(x) SETUP_XfOrM91(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: #! reader expressions not currently enabled" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        v = FUNCCALL(SETUP_XfOrM91(_), read_lang (port , stxsrc , line , col , pos , get_info , ht , indentation , params , ch ) ); 
        if (! v ) {
          if (comment_mode & 0x1 )
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          goto start_over ; 
        }
        RET_VALUE_START (v ) RET_VALUE_END ; 
      }
      else {
#       define XfOrM90_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM90(x) SETUP_XfOrM65(x)
        if (((ch ) >= 0 ) )
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 3 , ch , indentation , "read: bad syntax `#!%c'" , ch ) ); 
        else FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , ch , indentation , "read: bad syntax `#!'" , ch ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      break ; 
      default : if (! params -> honu_mode ) {
        int vector_length = - 1 ; 
        int i = 0 , j = 0 , overflow = 0 , digits = 0 , effective_ch ; 
        mzchar tagbuf [64 ] , vecbuf [64 ] ; 
#       define XfOrM66_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM66(x) SETUP_XfOrM65(x)
        while (((ch ) >= 0 ) && ((ch >= '0' ) && (ch <= '9' ) ) ) {
#         define XfOrM82_COUNT (0+XfOrM66_COUNT)
#         define SETUP_XfOrM82(x) SETUP_XfOrM66(x)
          if (digits <= 8 )
            digits ++ ; 
          if (j || (ch != '0' ) ) {
            if (j < 60 ) {
              vecbuf [j ++ ] = ch ; 
            }
            else if (j == 60 ) {
              vecbuf [j ++ ] = '.' ; 
              vecbuf [j ++ ] = '.' ; 
              vecbuf [j ++ ] = '.' ; 
              vecbuf [j ] = 0 ; 
            }
          }
          if (i < 60 ) {
            tagbuf [i ++ ] = ch ; 
          }
          else if (i == 60 ) {
            tagbuf [i ++ ] = '.' ; 
            tagbuf [i ++ ] = '.' ; 
            tagbuf [i ++ ] = '.' ; 
            tagbuf [i ] = 0 ; 
          }
          if (! overflow ) {
            long old_len ; 
            if (vector_length < 0 )
              vector_length = 0 ; 
            old_len = vector_length ; 
            vector_length = (vector_length * 10 ) + (ch - 48 ) ; 
            if ((vector_length < 0 ) || ((vector_length / 10 ) != old_len ) ) {
              overflow = 1 ; 
            }
          }
          ch = FUNCCALL(SETUP_XfOrM82(_), scheme_getc_special_ok (port ) ); 
        }
        if (overflow )
          vector_length = - 2 ; 
        vecbuf [j ] = 0 ; 
        tagbuf [i ] = 0 ; 
        effective_ch = FUNCCALL(SETUP_XfOrM66(_), readtable_effective_char (table , ch ) ); 
        if (effective_ch == '(' )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , stxsrc , line , col , pos , ch , ')' , vector_length , vecbuf , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
        if (effective_ch == '[' && params -> square_brackets_are_parens )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , stxsrc , line , col , pos , ch , ']' , vector_length , vecbuf , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
        if (effective_ch == '{' && params -> curly_braces_are_parens )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , stxsrc , line , col , pos , ch , '}' , vector_length , vecbuf , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
        if (ch == '#' && (vector_length != - 1 ) ) {
          Scheme_Object * ph ; 
          BLOCK_SETUP((PUSH(ph, 0+XfOrM66_COUNT)));
#         define XfOrM72_COUNT (1+XfOrM66_COUNT)
#         define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
          ph = NULLED_OUT ; 
          if (stxsrc )
            (__funcarg47 = FUNCCALL(SETUP_XfOrM72(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg47 , 0 , indentation , "read: #..# expressions not allowed in read-syntax mode" ) )) ; 
          if (! params -> can_read_graph )
            (__funcarg46 = FUNCCALL(SETUP_XfOrM72(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg46 , 0 , indentation , "read: #..# expressions not currently enabled" ) )) ; 
          if (digits > 8 )
            (__funcarg45 = FUNCCALL(SETUP_XfOrM72(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg45 , 0 , indentation , "read: graph id too long in #%5#" , tagbuf ) )) ; 
          if (* ht )
            ph = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM72(_), scheme_hash_get (* ht , ((Scheme_Object * ) (void * ) (long ) ((((long ) (vector_length ) ) << 1 ) | 0x1 ) ) ) ); 
          else ph = ((void * ) 0 ) ; 
          if (! ph ) {
#           define XfOrM73_COUNT (0+XfOrM72_COUNT)
#           define SETUP_XfOrM73(x) SETUP_XfOrM72(x)
            (__funcarg44 = FUNCCALL(SETUP_XfOrM73(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg44 , 0 , indentation , "read: no #%ld= preceding #%ld#" , vector_length , vector_length ) )) ; 
            RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
          }
          RET_VALUE_START (ph ) RET_VALUE_END ; 
        }
        if (ch == '=' && (vector_length != - 1 ) ) {
          Scheme_Object * v , * ph ; 
          long in_pos ; 
          BLOCK_SETUP((PUSH(ph, 0+XfOrM66_COUNT), PUSH(v, 1+XfOrM66_COUNT)));
#         define XfOrM68_COUNT (2+XfOrM66_COUNT)
#         define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
          v = NULLED_OUT ; 
          ph = NULLED_OUT ; 
          if (stxsrc )
            (__funcarg43 = FUNCCALL(SETUP_XfOrM68(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg43 , 0 , indentation , "read: #..= expressions not allowed in read-syntax mode" ) )) ; 
          if (! params -> can_read_graph )
            (__funcarg42 = FUNCCALL(SETUP_XfOrM68(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg42 , 0 , indentation , "read: #..= expressions not currently enabled" ) )) ; 
          if (digits > 8 )
            (__funcarg41 = FUNCCALL(SETUP_XfOrM68(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg41 , 0 , indentation , "read: graph id too long in #%s=" , tagbuf ) )) ; 
          if (* ht ) {
#           define XfOrM70_COUNT (0+XfOrM68_COUNT)
#           define SETUP_XfOrM70(x) SETUP_XfOrM68(x)
            if (FUNCCALL(SETUP_XfOrM70(_), scheme_hash_get (* ht , ((Scheme_Object * ) (void * ) (long ) ((((long ) (vector_length ) ) << 1 ) | 0x1 ) ) ) )) {
#             define XfOrM71_COUNT (0+XfOrM70_COUNT)
#             define SETUP_XfOrM71(x) SETUP_XfOrM70(x)
              (__funcarg40 = FUNCCALL(SETUP_XfOrM71(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg40 , 0 , indentation , "read: multiple #%ld= tags" , vector_length ) )) ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }
          else {
            Scheme_Hash_Table * tht ; 
            BLOCK_SETUP((PUSH(tht, 0+XfOrM68_COUNT)));
#           define XfOrM69_COUNT (1+XfOrM68_COUNT)
#           define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
            tht = NULLED_OUT ; 
            tht = FUNCCALL(SETUP_XfOrM69(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            * ht = tht ; 
          }
          ph = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM68(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          ph -> type = scheme_placeholder_type ; 
          FUNCCALL(SETUP_XfOrM68(_), scheme_hash_set (* ht , ((Scheme_Object * ) (void * ) (long ) ((((long ) (vector_length ) ) << 1 ) | 0x1 ) ) , (void * ) ph ) ); 
          FUNCCALL_AGAIN(scheme_tell_all (port , ((void * ) 0 ) , ((void * ) 0 ) , & in_pos ) ); 
          v = FUNCCALL_AGAIN(read_inner (port , stxsrc , ht , indentation , params , 0 ) ); 
          if ((((v ) ) == (scheme_eof ) ) )
            FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (in_pos - pos ) , (- 1 ) , indentation , "read: expected an element for graph (found end-of-file)" ) ); 
          (((Scheme_Small_Object * ) (ph ) ) -> u . ptr_val ) = v ; 
          RET_VALUE_START (v ) RET_VALUE_END ; 
        }
        {
          char * lbuffer ; 
          int pch = ch , ulen , blen ; 
          BLOCK_SETUP((PUSH(lbuffer, 0+XfOrM66_COUNT)));
#         define XfOrM67_COUNT (1+XfOrM66_COUNT)
#         define SETUP_XfOrM67(x) SETUP(XfOrM67_COUNT)
          lbuffer = NULLED_OUT ; 
          if ((pch == (- 1 ) ) || (pch == (- 2 ) ) )
            pch = 0 ; 
          ulen = FUNCCALL(SETUP_XfOrM67(_), scheme_char_strlen (tagbuf ) ); 
          blen = FUNCCALL_AGAIN(scheme_utf8_encode_all (tagbuf , ulen , ((void * ) 0 ) ) ); 
          lbuffer = (char * ) FUNCCALL(SETUP_XfOrM67(_), GC_malloc_atomic (blen + 6 + 1 ) ); 
          FUNCCALL(SETUP_XfOrM67(_), scheme_utf8_encode_all (tagbuf , ulen , (unsigned char * ) lbuffer ) ); 
          blen += FUNCCALL(SETUP_XfOrM67(_), scheme_utf8_encode ((mzchar * ) & pch , 0 , 1 , (unsigned char * ) lbuffer , blen , 0 ) ); 
          lbuffer [blen ] = 0 ; 
          (__funcarg39 = FUNCCALL(SETUP_XfOrM67(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg39 , ch , indentation , "read: bad syntax `#%s'" , lbuffer ) )) ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
    }
    if (! special_value ) {
#     define XfOrM64_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM64(x) SETUP_XfOrM59(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , ch , indentation , "read: bad syntax `#%c'" , ch ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    break ; 
    case '/' : if (params -> honu_mode ) {
      int ch2 ; 
#     define XfOrM62_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM62(x) SETUP_XfOrM59(x)
      ch2 = FUNCCALL(SETUP_XfOrM62(_), scheme_peekc_special_ok (port ) ); 
      if ((ch2 == '/' ) || (ch2 == '*' ) ) {
#       define XfOrM63_COUNT (0+XfOrM62_COUNT)
#       define SETUP_XfOrM63(x) SETUP_XfOrM62(x)
        FUNCCALL(SETUP_XfOrM63(_), scheme_ungetc ('/' , port ) ); 
        ch = FUNCCALL(SETUP_XfOrM63(_), skip_whitespace_comments (port , stxsrc , ht , indentation , params ) ); 
        goto start_over_with_ch ; 
      }
    }
    special_value = FUNCCALL(SETUP_XfOrM59(_), read_symbol (ch , 0 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
    break ; 
    case '>' : case '<' : if ((params -> honu_mode ) && (comment_mode & 0x10 ) ) {
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM59_COUNT)));
#     define XfOrM60_COUNT (1+XfOrM59_COUNT)
#     define SETUP_XfOrM60(x) SETUP(XfOrM60_COUNT)
      v = NULLED_OUT ; 
      v = FUNCCALL(SETUP_XfOrM60(_), read_symbol (ch , 0 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
      special_value = v ; 
      if (((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
        v = ((Scheme_Stx * ) v ) -> val ; 
      if (((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (v ) ) ) -> len ) == 1 ) && (((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (v ) ) ) -> s ) [0 ] == '>' ) || ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (v ) ) ) -> s ) [0 ] == '<' ) ) ) {
#       define XfOrM61_COUNT (0+XfOrM60_COUNT)
#       define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
        if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (v ) ) ) -> s ) [0 ] == '<' )
          v = honu_angle_open ; 
        else v = honu_angle_close ; 
        if (((Scheme_Type ) (((((long ) (special_value ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (special_value ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
          special_value = FUNCCALL(SETUP_XfOrM61(_), scheme_datum_to_syntax (v , scheme_false , special_value , 0 , 1 ) ); 
        else special_value = v ; 
      }
    }
    else special_value = FUNCCALL(SETUP_XfOrM59(_), read_symbol (ch , 0 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
    break ; 
    default : if (((ch >= '0' ) && (ch <= '9' ) ) )
      special_value = FUNCCALL(SETUP_XfOrM59(_), read_number (ch , port , stxsrc , line , col , pos , 0 , 0 , 10 , 0 , ht , indentation , params , table ) ); 
    else special_value = FUNCCALL(SETUP_XfOrM59(_), read_symbol (ch , 0 , port , stxsrc , line , col , pos , ht , indentation , params , table ) ); 
    break ; 
  }
  {
    Scheme_Object * v = special_value ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM52_COUNT)));
#   define XfOrM53_COUNT (1+XfOrM52_COUNT)
#   define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
    if (FUNCCALL(SETUP_XfOrM53(_), scheme_special_comment_value (v ) )) {
      if (comment_mode & 0x1 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      else {
        special_value_need_copy = 0 ; 
        goto start_over ; 
      }
    }
    else if (((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) {
#     define XfOrM56_COUNT (0+XfOrM53_COUNT)
#     define SETUP_XfOrM56(x) SETUP_XfOrM53(x)
      if (! stxsrc )
        v = FUNCCALL(SETUP_XfOrM56(_), scheme_syntax_to_datum (v , 0 , ((void * ) 0 ) ) ); 
    }
    else if (stxsrc ) {
      Scheme_Object * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM53_COUNT)));
#     define XfOrM55_COUNT (1+XfOrM53_COUNT)
#     define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
      s = NULLED_OUT ; 
      s = (__funcarg38 = FUNCCALL(SETUP_XfOrM55(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (scheme_false , line , col , pos , __funcarg38 , stxsrc , scheme_false ) )) ; 
      v = FUNCCALL_AGAIN(scheme_datum_to_syntax (v , s , scheme_false , 1 , 0 ) ); 
    }
    if (special_value_need_copy && ! stxsrc ) {
#     define XfOrM54_COUNT (0+XfOrM53_COUNT)
#     define SETUP_XfOrM54(x) SETUP_XfOrM53(x)
      FUNCCALL(SETUP_XfOrM54(_), set_need_copy (ht ) ); 
    }
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_inner (Scheme_Object * port , Scheme_Object * stxsrc , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int comment_mode ) {
  /* No conversion */
  return read_inner_inner (port , stxsrc , ht , indentation , params , comment_mode , - 1 , params -> table , 0 ) ; 
}
static Scheme_Object * resolve_references (Scheme_Object * obj , Scheme_Object * port , Scheme_Object * top , Scheme_Hash_Table * dht , Scheme_Hash_Table * tht , int clone , int tail_depth ) ; 
static Scheme_Object * resolve_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * port = (Scheme_Object * ) p -> ku . k . p2 ; 
  Scheme_Object * top = (Scheme_Object * ) p -> ku . k . p5 ; 
  Scheme_Hash_Table * dht = (Scheme_Hash_Table * ) p -> ku . k . p3 ; 
  Scheme_Hash_Table * tht = (Scheme_Hash_Table * ) p -> ku . k . p4 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 
  return resolve_references (o , port , top , dht , tht , p -> ku . k . i1 , p -> ku . k . i2 ) ; 
}
static Scheme_Object * resolve_references (Scheme_Object * obj , Scheme_Object * port , Scheme_Object * top , Scheme_Hash_Table * dht , Scheme_Hash_Table * tht , int clone , int tail_depth ) {
  Scheme_Object * result ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(top, 1), PUSH(result, 2), PUSH(tht, 3), PUSH(dht, 4), PUSH(port, 5)));
# define XfOrM247_COUNT (6)
# define SETUP_XfOrM247(x) SETUP(XfOrM247_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  result = NULLED_OUT ; 
  {
    unsigned long _stk_pos ; 
#   define XfOrM295_COUNT (0+XfOrM247_COUNT)
#   define SETUP_XfOrM295(x) SETUP_XfOrM247(x)
    _stk_pos = (unsigned long ) & _stk_pos ; 
    if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
      Scheme_Thread * p = scheme_current_thread ; 
#     define XfOrM296_COUNT (0+XfOrM295_COUNT)
#     define SETUP_XfOrM296(x) SETUP_XfOrM295(x)
      p -> ku . k . p1 = (void * ) obj ; 
      p -> ku . k . p2 = (void * ) port ; 
      p -> ku . k . p5 = (void * ) top ; 
      p -> ku . k . p3 = (void * ) dht ; 
      p -> ku . k . p4 = (void * ) tht ; 
      p -> ku . k . i1 = clone ; 
      p -> ku . k . i2 = tail_depth ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (resolve_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }
  {
#   define XfOrM293_COUNT (0+XfOrM247_COUNT)
#   define SETUP_XfOrM293(x) SETUP_XfOrM247(x)
    if ((scheme_fuel_counter ) <= 0 ) {
#     define XfOrM294_COUNT (0+XfOrM293_COUNT)
#     define SETUP_XfOrM294(x) SETUP_XfOrM293(x)
      FUNCCALL(SETUP_XfOrM294(_), scheme_out_of_fuel () ); 
    }
  }
  ; 
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) ) ) {
    Scheme_Object * start = obj ; 
    BLOCK_SETUP((PUSH(start, 0+XfOrM247_COUNT)));
#   define XfOrM286_COUNT (1+XfOrM247_COUNT)
#   define SETUP_XfOrM286(x) SETUP(XfOrM286_COUNT)
    while (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) ) ) {
#     define XfOrM290_COUNT (0+XfOrM286_COUNT)
#     define SETUP_XfOrM290(x) SETUP_XfOrM286(x)
      obj = (Scheme_Object * ) (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      if (((start ) == (obj ) ) ) {
#       define XfOrM291_COUNT (0+XfOrM290_COUNT)
#       define SETUP_XfOrM291(x) SETUP_XfOrM290(x)
        if (port )
          FUNCCALL_EMPTY(scheme_read_err (port , ((void * ) 0 ) , - 1 , - 1 , - 1 , - 1 , 0 , ((void * ) 0 ) , "read: illegal placeholder cycle" ) ); 
        else {
#         define XfOrM292_COUNT (0+XfOrM291_COUNT)
#         define SETUP_XfOrM292(x) SETUP_XfOrM291(x)
          FUNCCALL(SETUP_XfOrM292(_), scheme_arg_mismatch ("make-reader-graph" , "illegal placeholder cycle in value: " , top ) ); 
        }
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
  }
  result = FUNCCALL(SETUP_XfOrM247(_), scheme_hash_get (dht , obj ) ); 
  if (result ) {
#   define XfOrM284_COUNT (0+XfOrM247_COUNT)
#   define SETUP_XfOrM284(x) SETUP_XfOrM247(x)
    if (((Scheme_Type ) (((((long ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM285_COUNT (0+XfOrM284_COUNT)
#     define SETUP_XfOrM285(x) SETUP_XfOrM284(x)
      obj = FUNCCALL(SETUP_XfOrM285(_), scheme_hash_get (tht , result ) ); 
      if (obj && ((((long ) (obj ) ) >> 1 ) == tail_depth ) )
        (& ((Scheme_Simple_Object * ) result ) -> iso ) -> so . keyex |= 0x2 ; 
    }
    RET_VALUE_START (result ) RET_VALUE_END ; 
  }
  result = obj ; 
  if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    Scheme_Object * rr ; 
    BLOCK_SETUP((PUSH(rr, 0+XfOrM247_COUNT)));
#   define XfOrM282_COUNT (1+XfOrM247_COUNT)
#   define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
    rr = NULLED_OUT ; 
    if (clone )
      result = FUNCCALL(SETUP_XfOrM282(_), scheme_make_pair (scheme_false , scheme_false ) ); 
    FUNCCALL(SETUP_XfOrM282(_), scheme_hash_set (dht , obj , result ) ); 
    rr = FUNCCALL_AGAIN(resolve_references ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , port , top , dht , tht , clone , tail_depth + 1 ) ); 
    (((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . car ) = rr ; 
    FUNCCALL(SETUP_XfOrM282(_), scheme_hash_set (tht , result , ((Scheme_Object * ) (void * ) (long ) ((((long ) (tail_depth ) ) << 1 ) | 0x1 ) ) ) ); 
    rr = FUNCCALL_AGAIN(resolve_references ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , port , top , dht , tht , clone , tail_depth ) ); 
    (((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . cdr ) = rr ; 
    FUNCCALL(SETUP_XfOrM282(_), scheme_hash_set (tht , result , ((void * ) 0 ) ) ); 
    if (clone && (((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) ) == ((((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . car ) ) ) && (((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) == ((((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . cdr ) ) ) ) {
#     define XfOrM283_COUNT (0+XfOrM282_COUNT)
#     define SETUP_XfOrM283(x) SETUP_XfOrM282(x)
      result = obj ; 
      FUNCCALL(SETUP_XfOrM283(_), scheme_hash_set (dht , obj , result ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
    Scheme_Object * rr ; 
    BLOCK_SETUP((PUSH(rr, 0+XfOrM247_COUNT)));
#   define XfOrM279_COUNT (1+XfOrM247_COUNT)
#   define SETUP_XfOrM279(x) SETUP(XfOrM279_COUNT)
    rr = NULLED_OUT ; 
    if (clone ) {
#     define XfOrM281_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM281(x) SETUP_XfOrM279(x)
      result = FUNCCALL(SETUP_XfOrM281(_), scheme_box (scheme_false ) ); 
      if ((((Scheme_Inclhash_Object * ) (obj ) ) -> so . keyex & 0x1 ) )
        ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
    }
    FUNCCALL(SETUP_XfOrM279(_), scheme_hash_set (dht , obj , result ) ); 
    rr = FUNCCALL(SETUP_XfOrM279(_), resolve_references ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , port , top , dht , tht , clone , tail_depth + 1 ) ); 
    (((Scheme_Small_Object * ) (result ) ) -> u . ptr_val ) = rr ; 
    if (clone && (((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ) == ((((Scheme_Small_Object * ) (result ) ) -> u . ptr_val ) ) ) ) {
#     define XfOrM280_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM280(x) SETUP_XfOrM279(x)
      result = obj ; 
      FUNCCALL(SETUP_XfOrM280(_), scheme_hash_set (dht , obj , result ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
    int i , len , diff = 0 ; 
    Scheme_Object * prev_rr , * prev_v ; 
    BLOCK_SETUP((PUSH(prev_v, 0+XfOrM247_COUNT), PUSH(prev_rr, 1+XfOrM247_COUNT)));
#   define XfOrM270_COUNT (2+XfOrM247_COUNT)
#   define SETUP_XfOrM270(x) SETUP(XfOrM270_COUNT)
    prev_rr = NULLED_OUT ; 
    prev_v = NULLED_OUT ; 
    len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    if (clone ) {
#     define XfOrM278_COUNT (0+XfOrM270_COUNT)
#     define SETUP_XfOrM278(x) SETUP_XfOrM270(x)
      result = FUNCCALL(SETUP_XfOrM278(_), scheme_make_vector (len , scheme_false ) ); 
      if ((((Scheme_Inclhash_Object * ) (obj ) ) -> so . keyex & 0x1 ) )
        ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
    }
    FUNCCALL(SETUP_XfOrM270(_), scheme_hash_set (dht , obj , result ) ); 
    prev_v = prev_rr = ((void * ) 0 ) ; 
    for (i = 0 ; i < len ; i ++ ) {
      Scheme_Object * rr ; 
      BLOCK_SETUP((PUSH(rr, 0+XfOrM270_COUNT)));
#     define XfOrM275_COUNT (1+XfOrM270_COUNT)
#     define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)
      rr = NULLED_OUT ; 
      if ((((Scheme_Vector * ) (obj ) ) -> els ) [i ] == prev_v ) {
        rr = prev_rr ; 
      }
      else {
#       define XfOrM276_COUNT (0+XfOrM275_COUNT)
#       define SETUP_XfOrM276(x) SETUP_XfOrM275(x)
        prev_v = (((Scheme_Vector * ) (obj ) ) -> els ) [i ] ; 
        rr = FUNCCALL(SETUP_XfOrM276(_), resolve_references (prev_v , port , top , dht , tht , clone , tail_depth + 1 ) ); 
        if (! ((prev_v ) == (rr ) ) )
          diff = 1 ; 
        prev_rr = rr ; 
      }
      (((Scheme_Vector * ) (result ) ) -> els ) [i ] = rr ; 
    }
    if (clone && ! diff ) {
#     define XfOrM271_COUNT (0+XfOrM270_COUNT)
#     define SETUP_XfOrM271(x) SETUP_XfOrM270(x)
      result = obj ; 
      FUNCCALL(SETUP_XfOrM271(_), scheme_hash_set (dht , obj , result ) ); 
    }
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_table_placeholder_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) {
    Scheme_Hash_Tree * t , * base ; 
    Scheme_Object * a , * key , * val , * lst ; 
    int kind ; 
    BLOCK_SETUP((PUSH(lst, 0+XfOrM247_COUNT), PUSH(t, 1+XfOrM247_COUNT), PUSH(key, 2+XfOrM247_COUNT), PUSH(val, 3+XfOrM247_COUNT), PUSH(a, 4+XfOrM247_COUNT), PUSH(base, 5+XfOrM247_COUNT)));
#   define XfOrM263_COUNT (6+XfOrM247_COUNT)
#   define SETUP_XfOrM263(x) SETUP(XfOrM263_COUNT)
    t = NULLED_OUT ; 
    base = NULLED_OUT ; 
    a = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    lst = NULLED_OUT ; 
    if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_type ) ) ) {
      int i ; 
#     define XfOrM267_COUNT (0+XfOrM263_COUNT)
#     define SETUP_XfOrM267(x) SETUP_XfOrM263(x)
      if (FUNCCALL(SETUP_XfOrM267(_), scheme_is_hash_tree_equal (obj ) ))
        kind = 1 ; 
      else if (FUNCCALL(SETUP_XfOrM267(_), scheme_is_hash_tree_equal (obj ) ))
        kind = 2 ; 
      else kind = 0 ; 
      t = (Scheme_Hash_Tree * ) obj ; 
      lst = scheme_null ; 
      for (i = t -> count ; i -- ; ) {
#       define XfOrM269_COUNT (0+XfOrM267_COUNT)
#       define SETUP_XfOrM269(x) SETUP_XfOrM267(x)
        FUNCCALL(SETUP_XfOrM269(_), scheme_hash_tree_index (t , i , & key , & val ) ); 
        lst = (__funcarg62 = FUNCCALL(SETUP_XfOrM269(_), scheme_make_pair (key , val ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg62 , lst ) )) ; 
      }
    }
    else {
      kind = (((Scheme_Simple_Object * ) (obj ) ) -> u . ptr_int_val . pint ) ; 
      lst = (((Scheme_Simple_Object * ) (obj ) ) -> u . ptr_int_val . ptr ) ; 
    }
    t = FUNCCALL(SETUP_XfOrM263(_), scheme_make_hash_tree (kind ) ); 
    base = FUNCCALL(SETUP_XfOrM263(_), scheme_make_hash_tree (kind ) ); 
    result = (Scheme_Object * ) t ; 
    FUNCCALL(SETUP_XfOrM263(_), scheme_hash_set (dht , obj , result ) ); 
    lst = FUNCCALL_AGAIN(resolve_references (lst , port , top , dht , tht , clone , tail_depth + 1 ) ); 
    for (; ((Scheme_Type ) (((((long ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; lst = (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM265_COUNT (0+XfOrM263_COUNT)
#     define SETUP_XfOrM265(x) SETUP_XfOrM263(x)
      a = (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . car ) ; 
      key = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      val = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
      base = FUNCCALL(SETUP_XfOrM265(_), scheme_hash_tree_set (base , key , val ) ); 
    }
    t -> count = base -> count ; 
    t -> root = base -> root ; 
    t -> elems_box = base -> elems_box ; 
  }
  else if (((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
    int i ; 
    Scheme_Object * key , * val , * l = scheme_null , * orig_l ; 
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) obj , * t2 ; 
    BLOCK_SETUP((PUSH(t2, 0+XfOrM247_COUNT), PUSH(t, 1+XfOrM247_COUNT), PUSH(key, 2+XfOrM247_COUNT), PUSH(val, 3+XfOrM247_COUNT), PUSH(l, 4+XfOrM247_COUNT), PUSH(orig_l, 5+XfOrM247_COUNT)));
#   define XfOrM254_COUNT (6+XfOrM247_COUNT)
#   define SETUP_XfOrM254(x) SETUP(XfOrM254_COUNT)
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    orig_l = NULLED_OUT ; 
    t2 = NULLED_OUT ; 
    t2 = FUNCCALL(SETUP_XfOrM254(_), scheme_clone_hash_table (t ) ); 
    FUNCCALL_AGAIN(scheme_reset_hash_table (t2 , ((void * ) 0 ) ) ); 
    result = (Scheme_Object * ) t2 ; 
    FUNCCALL(SETUP_XfOrM254(_), scheme_hash_set (dht , obj , (Scheme_Object * ) t2 ) ); 
    for (i = t -> size ; i -- ; ) {
#     define XfOrM261_COUNT (0+XfOrM254_COUNT)
#     define SETUP_XfOrM261(x) SETUP_XfOrM254(x)
      if (t -> vals [i ] ) {
#       define XfOrM262_COUNT (0+XfOrM261_COUNT)
#       define SETUP_XfOrM262(x) SETUP_XfOrM261(x)
        key = t -> keys [i ] ; 
        val = t -> vals [i ] ; 
        l = (__funcarg60 = FUNCCALL(SETUP_XfOrM262(_), scheme_make_pair (key , val ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg60 , l ) )) ; 
      }
    }
    orig_l = l ; 
    l = FUNCCALL(SETUP_XfOrM254(_), resolve_references (l , port , top , dht , tht , clone , tail_depth + 1 ) ); 
    if (((l ) == (orig_l ) ) ) {
#     define XfOrM258_COUNT (0+XfOrM254_COUNT)
#     define SETUP_XfOrM258(x) SETUP_XfOrM254(x)
      result = obj ; 
      FUNCCALL(SETUP_XfOrM258(_), scheme_hash_set (dht , obj , result ) ); 
    }
    else {
#     define XfOrM255_COUNT (0+XfOrM254_COUNT)
#     define SETUP_XfOrM255(x) SETUP_XfOrM254(x)
      for (; ((Scheme_Type ) (((((long ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM257_COUNT (0+XfOrM255_COUNT)
#       define SETUP_XfOrM257(x) SETUP_XfOrM255(x)
        val = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        key = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
        val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . cdr ) ; 
        FUNCCALL(SETUP_XfOrM257(_), scheme_hash_set (t2 , key , val ) ); 
      }
    }
  }
  else if ((((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((long ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
    Scheme_Structure * s = (Scheme_Structure * ) obj ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM247_COUNT)));
#   define XfOrM248_COUNT (1+XfOrM247_COUNT)
#   define SETUP_XfOrM248(x) SETUP(XfOrM248_COUNT)
    if (s -> stype -> prefab_key ) {
      int c , i , diff ; 
      Scheme_Object * prev_v , * v ; 
      BLOCK_SETUP((PUSH(prev_v, 0+XfOrM248_COUNT), PUSH(v, 1+XfOrM248_COUNT)));
#     define XfOrM249_COUNT (2+XfOrM248_COUNT)
#     define SETUP_XfOrM249(x) SETUP(XfOrM249_COUNT)
      prev_v = NULLED_OUT ; 
      v = NULLED_OUT ; 
      if (clone ) {
#       define XfOrM253_COUNT (0+XfOrM249_COUNT)
#       define SETUP_XfOrM253(x) SETUP_XfOrM249(x)
        result = FUNCCALL(SETUP_XfOrM253(_), scheme_clone_prefab_struct_instance (s ) ); 
      }
      FUNCCALL(SETUP_XfOrM249(_), scheme_hash_set (dht , obj , result ) ); 
      c = s -> stype -> num_slots ; 
      diff = 0 ; 
      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM252_COUNT (0+XfOrM249_COUNT)
#       define SETUP_XfOrM252(x) SETUP_XfOrM249(x)
        prev_v = s -> slots [i ] ; 
        v = FUNCCALL(SETUP_XfOrM252(_), resolve_references (prev_v , port , top , dht , tht , clone , tail_depth + 1 ) ); 
        if (! ((prev_v ) == (v ) ) )
          diff = 1 ; 
        ((Scheme_Structure * ) result ) -> slots [i ] = v ; 
      }
      if (clone && ! diff ) {
#       define XfOrM250_COUNT (0+XfOrM249_COUNT)
#       define SETUP_XfOrM250(x) SETUP_XfOrM249(x)
        result = obj ; 
        FUNCCALL(SETUP_XfOrM250(_), scheme_hash_set (dht , obj , result ) ); 
      }
    }
  }
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * _internal_read (Scheme_Object * port , Scheme_Object * stxsrc , int crc , int cant_fail , int honu_mode , int recur , int expose_comment , int extra_char , Scheme_Object * init_readtable , Scheme_Object * magic_sym , Scheme_Object * magic_val , Scheme_Object * delay_load_info , int get_info ) {
  Scheme_Object * v , * v2 ; 
  Scheme_Config * config ; 
  Scheme_Hash_Table * * ht = ((void * ) 0 ) ; 
  ReadParams params ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(v2, 0), PUSH(magic_val, 1), PUSH(stxsrc, 2), PUSH(init_readtable, 3), PUSH(port, 4), PUSH(delay_load_info, 5), PUSH(params.table, 6), PUSH(params.magic_sym, 7), PUSH(params.magic_val, 8), PUSH(params.delay_load_info, 9), PUSH(v, 10), PUSH(magic_sym, 11), PUSH(ht, 12), PUSH(config, 13)));
# define XfOrM297_COUNT (14)
# define SETUP_XfOrM297(x) SETUP(XfOrM297_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  v2 = NULLED_OUT ; 
  config = NULLED_OUT ; 
  params.table = NULLED_OUT ; 
  params.magic_sym = NULLED_OUT ; 
  params.magic_val = NULLED_OUT ; 
  params.delay_load_info = NULLED_OUT ; 
  config = FUNCCALL(SETUP_XfOrM297(_), scheme_current_config () ); 
  if (get_info ) {
    params . table = ((void * ) 0 ) ; 
  }
  else {
#   define XfOrM309_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM309(x) SETUP_XfOrM297(x)
    v = FUNCCALL(SETUP_XfOrM309(_), scheme_get_param (config , MZCONFIG_READTABLE ) ); 
    if ((! (((v ) ) == (scheme_false ) ) ) )
      params . table = (Readtable * ) v ; 
    else params . table = ((void * ) 0 ) ; 
  }
  params . can_read_compiled = crc ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CAN_READ_PIPE_QUOTE ) ); 
  params . can_read_pipe_quote = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CAN_READ_BOX ) ); 
  params . can_read_box = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CAN_READ_GRAPH ) ); 
  params . can_read_graph = (! (((v ) ) == (scheme_false ) ) ) ; 
  if (crc || get_info ) {
    params . can_read_reader = 1 ; 
  }
  else {
#   define XfOrM307_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM307(x) SETUP_XfOrM297(x)
    v = FUNCCALL(SETUP_XfOrM307(_), scheme_get_param (config , MZCONFIG_CAN_READ_READER ) ); 
    params . can_read_reader = (! (((v ) ) == (scheme_false ) ) ) ; 
  }
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CASE_SENS ) ); 
  params . case_sensitive = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_SQUARE_BRACKETS_ARE_PARENS ) ); 
  params . square_brackets_are_parens = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CURLY_BRACES_ARE_PARENS ) ); 
  params . curly_braces_are_parens = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_READ_DECIMAL_INEXACT ) ); 
  params . read_decimal_inexact = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CAN_READ_QUASI ) ); 
  params . can_read_quasi = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CAN_READ_DOT ) ); 
  params . can_read_dot = (! (((v ) ) == (scheme_false ) ) ) ; 
  v = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_CAN_READ_INFIX_DOT ) ); 
  params . can_read_infix_dot = (! (((v ) ) == (scheme_false ) ) ) ; 
  if (! delay_load_info )
    delay_load_info = FUNCCALL(SETUP_XfOrM297(_), scheme_get_param (config , MZCONFIG_DELAY_LOAD_INFO ) ); 
  if ((! (((delay_load_info ) ) == (scheme_false ) ) ) )
    params . delay_load_info = delay_load_info ; 
  else params . delay_load_info = ((void * ) 0 ) ; 
  params . honu_mode = honu_mode ; 
  if (honu_mode )
    params . table = ((void * ) 0 ) ; 
  params . skip_zo_vers_check = cant_fail ; 
  params . magic_sym = magic_sym ; 
  params . magic_val = magic_val ; 
  ht = ((void * ) 0 ) ; 
  if (recur ) {
#   define XfOrM305_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM305(x) SETUP_XfOrM297(x)
    v = FUNCCALL(SETUP_XfOrM305(_), scheme_extract_one_cc_mark (((void * ) 0 ) , unresolved_uninterned_symbol ) ); 
    if (v && ((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ) {
      if (((((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) ) == (scheme_false ) ) == ! stxsrc )
        ht = (Scheme_Hash_Table * * ) (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    }
  }
  if (! ht ) {
#   define XfOrM304_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM304(x) SETUP_XfOrM297(x)
    ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM304(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 
    recur = 0 ; 
  }
  do {
#   define XfOrM301_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM301(x) SETUP_XfOrM297(x)
    v = FUNCCALL(SETUP_XfOrM301(_), read_inner_inner (port , stxsrc , ht , scheme_null , & params , (0x2 | (expose_comment ? (0x8 | 0x1 ) : 0 ) ) , extra_char , (init_readtable ? ((((init_readtable ) ) == (scheme_false ) ) ? ((void * ) 0 ) : (Readtable * ) init_readtable ) : params . table ) , get_info ) ); 
    extra_char = - 1 ; 
    if (* ht && ! recur ) {
      int clone = 0 ; 
      Scheme_Hash_Table * dht , * tht ; 
      BLOCK_SETUP((PUSH(tht, 0+XfOrM301_COUNT), PUSH(dht, 1+XfOrM301_COUNT)));
#     define XfOrM303_COUNT (2+XfOrM301_COUNT)
#     define SETUP_XfOrM303(x) SETUP(XfOrM303_COUNT)
      dht = NULLED_OUT ; 
      tht = NULLED_OUT ; 
      if (stxsrc )
        FUNCCALL(SETUP_XfOrM303(_), scheme_signal_error ("internal error: read-syntax has graph references" ) ); 
      if (FUNCCALL(SETUP_XfOrM303(_), scheme_hash_get (* ht , tainted_uninterned_symbol ) ))
        clone = 1 ; 
      dht = FUNCCALL(SETUP_XfOrM303(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      tht = FUNCCALL_AGAIN(scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      if (v )
        v = FUNCCALL(SETUP_XfOrM303(_), resolve_references (v , port , ((void * ) 0 ) , dht , tht , clone , 0 ) ); 
      v2 = FUNCCALL(SETUP_XfOrM303(_), scheme_hash_get (* ht , unresolved_uninterned_symbol ) ); 
      if (v2 )
        FUNCCALL(SETUP_XfOrM303(_), resolve_references (v2 , port , ((void * ) 0 ) , dht , tht , clone , 0 ) ); 
      if (! v )
        * ht = ((void * ) 0 ) ; 
    }
    if (! v && expose_comment ) {
#     define XfOrM302_COUNT (0+XfOrM301_COUNT)
#     define SETUP_XfOrM302(x) SETUP_XfOrM301(x)
      v = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM302(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      v -> type = scheme_special_comment_type ; 
      (((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) = scheme_false ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }
  }
  while (! v ) ; 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void * scheme_internal_read_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Object * port = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * stxsrc = (Scheme_Object * ) p -> ku . k . p2 ; 
  Scheme_Object * init_readtable = (Scheme_Object * ) p -> ku . k . p3 ; 
  Scheme_Object * magic_sym = (Scheme_Object * ) p -> ku . k . p4 ; 
  Scheme_Object * magic_val = ((void * ) 0 ) ; 
  Scheme_Object * delay_load_info = (Scheme_Object * ) p -> ku . k . p5 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 
  if (magic_sym ) {
    magic_val = (((Scheme_Simple_Object * ) (magic_sym ) ) -> u . pair_val . cdr ) ; 
    magic_sym = (((Scheme_Simple_Object * ) (magic_sym ) ) -> u . pair_val . car ) ; 
  }
  return (void * ) _internal_read (port , stxsrc , p -> ku . k . i1 , 0 , p -> ku . k . i2 , p -> ku . k . i3 & 0x2 , p -> ku . k . i3 & 0x1 , p -> ku . k . i4 , init_readtable , magic_sym , magic_val , delay_load_info , 0 ) ; 
}
Scheme_Object * scheme_internal_read (Scheme_Object * port , Scheme_Object * stxsrc , int crc , int cantfail , int honu_mode , int recur , int expose_comment , int pre_char , Scheme_Object * init_readtable , Scheme_Object * magic_sym , Scheme_Object * magic_val , Scheme_Object * delay_load_info ) {
  Scheme_Thread * p = scheme_current_thread ; 
  Scheme_Config * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(stxsrc, 0), PUSH(magic_val, 1), PUSH(init_readtable, 2), PUSH(delay_load_info, 3), PUSH(p, 4), PUSH(magic_sym, 5), PUSH(port, 6)));
# define XfOrM313_COUNT (7)
# define SETUP_XfOrM313(x) SETUP(XfOrM313_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (crc < 0 )
    crc = (! ((((__funcarg63 = FUNCCALL(SETUP_XfOrM313(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg63 , MZCONFIG_CAN_READ_COMPILED ) )) ) ) == (scheme_false ) ) ) ; 
  if (cantfail ) {
#   define XfOrM315_COUNT (0+XfOrM313_COUNT)
#   define SETUP_XfOrM315(x) SETUP_XfOrM313(x)
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(_internal_read (port , stxsrc , crc , cantfail , honu_mode , recur , expose_comment , - 1 , ((void * ) 0 ) , magic_sym , magic_val , delay_load_info , 0 ) )) RET_VALUE_EMPTY_END ; 
  }
  else {
#   define XfOrM314_COUNT (0+XfOrM313_COUNT)
#   define SETUP_XfOrM314(x) SETUP_XfOrM313(x)
    if (magic_sym )
      magic_sym = FUNCCALL(SETUP_XfOrM314(_), scheme_make_pair (magic_sym , magic_val ) ); 
    p -> ku . k . p1 = (void * ) port ; 
    p -> ku . k . p2 = (void * ) stxsrc ; 
    p -> ku . k . i1 = crc ; 
    p -> ku . k . i2 = honu_mode ; 
    p -> ku . k . i3 = ((recur ? 0x2 : 0 ) | (expose_comment ? 0x1 : 0 ) ) ; 
    p -> ku . k . i4 = pre_char ; 
    p -> ku . k . p3 = (void * ) init_readtable ; 
    p -> ku . k . p4 = (void * ) magic_sym ; 
    p -> ku . k . p5 = (void * ) delay_load_info ; 
    RET_VALUE_START ((Scheme_Object * ) FUNCCALL_EMPTY(scheme_top_level_do (scheme_internal_read_k , 0 ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_read (Scheme_Object * port ) {
  /* No conversion */
  return scheme_internal_read (port , ((void * ) 0 ) , - 1 , 0 , 0 , 0 , 0 , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}
Scheme_Object * scheme_read_syntax (Scheme_Object * port , Scheme_Object * stxsrc ) {
  /* No conversion */
  return scheme_internal_read (port , stxsrc , - 1 , 0 , 0 , 0 , 0 , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}
Scheme_Object * scheme_resolve_placeholders (Scheme_Object * obj ) {
  Scheme_Hash_Table * __funcarg65 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg64 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(__funcarg64, 0), PUSH(obj, 1)));
# define XfOrM318_COUNT (2)
# define SETUP_XfOrM318(x) SETUP(XfOrM318_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  RET_VALUE_START ((__funcarg64 = FUNCCALL(SETUP_XfOrM318(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), __funcarg65 = FUNCCALL(SETUP_XfOrM318(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), FUNCCALL_EMPTY(resolve_references (obj , ((void * ) 0 ) , obj , __funcarg64 , __funcarg65 , 1 , 0 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * attach_shape_property (Scheme_Object * list , Scheme_Object * stxsrc , ReadParams * params , int closer ) ; 
static int next_is_delim (Scheme_Object * port , ReadParams * params , int brackets , int braces ) {
  int next ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(params, 0)));
# define XfOrM319_COUNT (1)
# define SETUP_XfOrM319(x) SETUP(XfOrM319_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  next = FUNCCALL(SETUP_XfOrM319(_), scheme_peekc_special_ok (port ) ); 
  RET_VALUE_START (((next == (- 1 ) ) || (next == (- 2 ) ) || (! params -> table && ((((scheme_uchar_table [(next >> 8 ) & 0x1FFF ] [next & 0xFF ] ) ) & 0x10 ) || (next == '(' ) || (next == ')' ) || (next == '"' ) || (next == ';' ) || (next == '\'' ) || (next == '`' ) || (next == ',' ) || ((next == '[' ) && brackets ) || ((next == '{' ) && braces ) || ((next == ']' ) && brackets ) || ((next == '}' ) && braces ) ) ) || (params -> table && (FUNCCALL_EMPTY(readtable_kind (params -> table , next , params ) )& (0x1 | 0x4 ) ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static const char * mapping_name (ReadParams * params , int ch , const char * def , int name_pos ) {
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(params, 0), PUSH(def, 1)));
# define XfOrM320_COUNT (2)
# define SETUP_XfOrM320(x) SETUP(XfOrM320_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (params -> table ) {
    int i ; 
    char * buf = "" ; 
    Scheme_Object * v ; 
    Scheme_Hash_Table * mapping ; 
    BLOCK_SETUP((PUSH(mapping, 0+XfOrM320_COUNT), PUSH(v, 1+XfOrM320_COUNT), PUSH(buf, 2+XfOrM320_COUNT)));
#   define XfOrM321_COUNT (3+XfOrM320_COUNT)
#   define SETUP_XfOrM321(x) SETUP(XfOrM321_COUNT)
    v = NULLED_OUT ; 
    mapping = NULLED_OUT ; 
    if (params -> table -> names ) {
      if (params -> table -> names [name_pos ] )
        RET_VALUE_START (params -> table -> names [name_pos ] ) RET_VALUE_END ; 
    }
    mapping = params -> table -> mapping ; 
    if (! FUNCCALL(SETUP_XfOrM321(_), scheme_hash_get (mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) ) )) {
#     define XfOrM331_COUNT (0+XfOrM321_COUNT)
#     define SETUP_XfOrM331(x) SETUP_XfOrM321(x)
      buf = (char * ) FUNCCALL(SETUP_XfOrM331(_), GC_malloc_atomic (4 ) ); 
      (sprintf (buf , "`%c'" , ch ) ) ; 
    }
    for (i = mapping -> size ; i -- ; ) {
#     define XfOrM327_COUNT (0+XfOrM321_COUNT)
#     define SETUP_XfOrM327(x) SETUP_XfOrM321(x)
      if (mapping -> vals [i ] ) {
#       define XfOrM328_COUNT (0+XfOrM327_COUNT)
#       define SETUP_XfOrM328(x) SETUP_XfOrM327(x)
        v = mapping -> vals [i ] ; 
        if (((((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) >> 1 ) == 0x20 ) && ((((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) ) >> 1 ) == ch ) ) {
          int len ; 
          mzchar a [2 ] ; 
          char * naya , utf8_buf [6 + 1 ] ; 
          BLOCK_SETUP((PUSH(naya, 0+XfOrM328_COUNT)));
#         define XfOrM329_COUNT (1+XfOrM328_COUNT)
#         define SETUP_XfOrM329(x) SETUP(XfOrM329_COUNT)
          naya = NULLED_OUT ; 
          v = mapping -> keys [i ] ; 
          a [0 ] = (mzchar ) (((long ) (v ) ) >> 1 ) ; 
          len = FUNCCALL(SETUP_XfOrM329(_), scheme_utf8_encode_all (a , 1 , (unsigned char * ) utf8_buf ) ); 
          utf8_buf [len ] = 0 ; 
          naya = (char * ) FUNCCALL(SETUP_XfOrM329(_), GC_malloc_atomic (len + 5 + strlen (buf ) ) ); 
          (sprintf (naya , "`%s'" , utf8_buf ) ) ; 
          if (* buf ) {
#           define XfOrM330_COUNT (0+XfOrM329_COUNT)
#           define SETUP_XfOrM330(x) SETUP_XfOrM329(x)
            (sprintf (naya XFORM_OK_PLUS len + 2 , " or %s" , buf ) ) ; 
          }
          buf = naya ; 
        }
      }
    }
    if (! params -> table -> names ) {
      char * * a ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM321_COUNT)));
#     define XfOrM322_COUNT (1+XfOrM321_COUNT)
#     define SETUP_XfOrM322(x) SETUP(XfOrM322_COUNT)
      a = NULLED_OUT ; 
      a = ((char * * ) FUNCCALL(SETUP_XfOrM322(_), GC_malloc (sizeof (char * ) * (7 ) ) )) ; 
      params -> table -> names = a ; 
    }
    params -> table -> names [name_pos ] = buf ; 
    RET_VALUE_START (buf ) RET_VALUE_END ; 
  }
  else RET_VALUE_START (def ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static const char * closer_name (ReadParams * params , int closer ) {
  /* No conversion */
  int pos ; 
  const char * def ; 
  switch (closer ) {
    case ')' : pos = 0 ; 
    def = "`)'" ; 
    break ; 
    case ']' : pos = 1 ; 
    def = "`]'" ; 
    break ; 
    case '}' : default : pos = 2 ; 
    def = "`}'" ; 
    break ; 
  }
  return mapping_name (params , closer , def , pos ) ; 
}
static const char * opener_name (ReadParams * params , int opener ) {
  /* No conversion */
  int pos ; 
  const char * def ; 
  switch (opener ) {
    case '(' : pos = 3 ; 
    def = "`('" ; 
    break ; 
    case '[' : pos = 4 ; 
    def = "`['" ; 
    break ; 
    case '{' : default : pos = 5 ; 
    def = "`{'" ; 
    break ; 
  }
  return mapping_name (params , opener , def , pos ) ; 
}
static const char * dot_name (ReadParams * params ) {
  /* No conversion */
  return mapping_name (params , '.' , "`.'" , 6 ) ; 
}
static Scheme_Object * combine_angle_brackets (Scheme_Object * list ) ; 
static Scheme_Object * read_list (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int opener , int closer , int shape , int use_stack , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * list = ((void * ) 0 ) , * last = ((void * ) 0 ) , * car , * cdr , * pair , * infixed = ((void * ) 0 ) , * prefetched = ((void * ) 0 ) ; 
  int ch = 0 , got_ch_already = 0 , effective_ch ; 
  int brackets = params -> square_brackets_are_parens ; 
  int braces = params -> curly_braces_are_parens ; 
  long start , startcol , startline , dotpos , dotcol , dotline , dot2pos , dot2line , dot2col , init_span ; 
  const char * __funcarg95 = NULLED_OUT ; 
  const char * __funcarg94 = NULLED_OUT ; 
  const char * __funcarg93 = NULLED_OUT ; 
  long __funcarg92 ; 
  long __funcarg91 ; 
  long __funcarg90 ; 
  const char * __funcarg89 = NULLED_OUT ; 
  const char * __funcarg88 = NULLED_OUT ; 
  long __funcarg87 ; 
  long __funcarg86 ; 
  const char * __funcarg85 = NULLED_OUT ; 
  long __funcarg84 ; 
  long __funcarg83 ; 
  const char * __funcarg82 = NULLED_OUT ; 
  long __funcarg81 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(car, 0), PUSH(stxsrc, 1), PUSH(pair, 2), PUSH(indentation, 3), PUSH(last, 4), PUSH(list, 5), PUSH(infixed, 6), PUSH(prefetched, 7), PUSH(params, 8), PUSH(cdr, 9), PUSH(ht, 10), PUSH(port, 11)));
# define XfOrM338_COUNT (12)
# define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  car = NULLED_OUT ; 
  cdr = NULLED_OUT ; 
  pair = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM338(_), scheme_tell_all (port , & startline , & startcol , & start ) ); 
  init_span = 1 ; 
  if (stxsrc ) {
    Scheme_Indent * indt ; 
    BLOCK_SETUP((PUSH(indt, 0+XfOrM338_COUNT)));
#   define XfOrM403_COUNT (1+XfOrM338_COUNT)
#   define SETUP_XfOrM403(x) SETUP(XfOrM403_COUNT)
    indt = NULLED_OUT ; 
    indt = (Scheme_Indent * ) FUNCCALL(SETUP_XfOrM403(_), GC_malloc_one_tagged (sizeof (Scheme_Indent ) ) ); 
    indt -> type = scheme_indent_type ; 
    indt -> closer = closer ; 
    indt -> max_indent = startcol + 1 ; 
    indt -> multiline = 0 ; 
    indt -> suspicious_line = 0 ; 
    indt -> suspicious_quote = 0 ; 
    indt -> start_line = startline ; 
    indt -> last_line = startline ; 
    indentation = FUNCCALL(SETUP_XfOrM403(_), scheme_make_pair ((Scheme_Object * ) indt , indentation ) ); 
  }
  while (1 ) {
#   define XfOrM371_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM371(x) SETUP_XfOrM338(x)
    if (prefetched )
      ch = 0 ; 
    else if (got_ch_already )
      got_ch_already = 0 ; 
    else ch = FUNCCALL(SETUP_XfOrM371(_), skip_whitespace_comments (port , stxsrc , ht , indentation , params ) ); 
    if ((ch == (- 1 ) ) && (closer != (- 1 ) ) ) {
      char * suggestion = "" ; 
      BLOCK_SETUP((PUSH(suggestion, 0+XfOrM371_COUNT)));
#     define XfOrM400_COUNT (1+XfOrM371_COUNT)
#     define SETUP_XfOrM400(x) SETUP(XfOrM400_COUNT)
      if (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
        Scheme_Indent * indt ; 
        BLOCK_SETUP((PUSH(indt, 0+XfOrM400_COUNT)));
#       define XfOrM401_COUNT (1+XfOrM400_COUNT)
#       define SETUP_XfOrM401(x) SETUP(XfOrM401_COUNT)
        indt = NULLED_OUT ; 
        indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
        if (indt -> suspicious_line ) {
#         define XfOrM402_COUNT (0+XfOrM401_COUNT)
#         define SETUP_XfOrM402(x) SETUP_XfOrM401(x)
          suggestion = FUNCCALL(SETUP_XfOrM402(_), GC_malloc_atomic (100 ) ); 
          (__funcarg95 = FUNCCALL(SETUP_XfOrM402(_), closer_name (params , indt -> suspicious_closer ) ), (sprintf (suggestion , "; indentation suggests a missing %s before line %ld" , __funcarg95 , indt -> suspicious_line ) ) ) ; 
        }
      }
      (__funcarg94 = FUNCCALL(SETUP_XfOrM400(_), closer_name (params , closer ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , startline , startcol , start , (init_span ) , (- 1 ) , indentation , "read: expected a %s to close `%c'%s" , __funcarg94 , opener , suggestion ) )) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    effective_ch = FUNCCALL(SETUP_XfOrM371(_), readtable_effective_char (params -> table , ch ) ); 
    if (effective_ch == closer ) {
#     define XfOrM394_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM394(x) SETUP_XfOrM371(x)
      if (shape == 3 ) {
#       define XfOrM399_COUNT (0+XfOrM394_COUNT)
#       define SETUP_XfOrM399(x) SETUP_XfOrM394(x)
        (__funcarg92 = FUNCCALL(SETUP_XfOrM399(_), SPAN (port , start ) ), __funcarg93 = FUNCCALL(SETUP_XfOrM399(_), dot_name (params ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , startline , startcol , start , __funcarg92 , ch , indentation , "read: expected hash pair (with key and value separated by %s) before `%c'" , __funcarg93 , ch ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      if (params -> honu_mode ) {
#       define XfOrM397_COUNT (0+XfOrM394_COUNT)
#       define SETUP_XfOrM397(x) SETUP_XfOrM394(x)
        if (! list )
          list = scheme_null ; 
        if (closer == ')' )
          car = honu_parens ; 
        else if (closer == ']' )
          car = honu_brackets ; 
        else if (closer == '}' )
          car = honu_braces ; 
        else car = ((void * ) 0 ) ; 
        if (car ) {
#         define XfOrM398_COUNT (0+XfOrM397_COUNT)
#         define SETUP_XfOrM398(x) SETUP_XfOrM397(x)
          if (stxsrc )
            car = (__funcarg91 = FUNCCALL(SETUP_XfOrM398(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (car , line , col , pos , __funcarg91 , stxsrc , scheme_false ) )) ; 
          list = FUNCCALL(SETUP_XfOrM398(_), scheme_make_pair (car , list ) ); 
        }
      }
      else {
        if (! list ) {
          list = scheme_null ; 
        }
      }
      FUNCCALL(SETUP_XfOrM394(_), pop_indentation (indentation ) ); 
      list = FUNCCALL(SETUP_XfOrM394(_), combine_angle_brackets (list ) ); 
      list = (stxsrc ? (__funcarg90 = FUNCCALL(SETUP_XfOrM394(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (list , line , col , pos , __funcarg90 , stxsrc , scheme_false ) )) : list ) ; 
      list = FUNCCALL(SETUP_XfOrM394(_), attach_shape_property (list , stxsrc , params , closer ) ); 
      RET_VALUE_START (list ) RET_VALUE_END ; 
    }
    if (shape == 2 ) {
#     define XfOrM391_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM391(x) SETUP_XfOrM371(x)
      if (! (effective_ch == '(' ) && ! (effective_ch == '[' && params -> square_brackets_are_parens ) && ! (effective_ch == '{' && params -> curly_braces_are_parens ) ) {
        long xl , xc , xp ; 
        const char * sbname , * cbname ; 
        BLOCK_SETUP((PUSH(sbname, 0+XfOrM391_COUNT), PUSH(cbname, 1+XfOrM391_COUNT)));
#       define XfOrM393_COUNT (2+XfOrM391_COUNT)
#       define SETUP_XfOrM393(x) SETUP(XfOrM393_COUNT)
        sbname = NULLED_OUT ; 
        cbname = NULLED_OUT ; 
        FUNCCALL(SETUP_XfOrM393(_), scheme_ungetc (ch , port ) ); 
        prefetched = FUNCCALL_AGAIN(read_inner (port , stxsrc , ht , indentation , params , 0x1 | 0x10 ) ); 
        if (! prefetched )
          continue ; 
        sbname = (params -> square_brackets_are_parens ? FUNCCALL(SETUP_XfOrM393(_), opener_name (params , '[' ) ): "" ) ; 
        cbname = (params -> curly_braces_are_parens ? FUNCCALL(SETUP_XfOrM393(_), opener_name (params , '{' ) ): "" ) ; 
        FUNCCALL(SETUP_XfOrM393(_), scheme_tell_all (port , & xl , & xc , & xp ) ); 
        (__funcarg89 = FUNCCALL(SETUP_XfOrM393(_), opener_name (params , '(' ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , xl , xc , xp , 1 , ch , indentation , "read: expected %s%s%s%s%s to start a hash pair" , __funcarg89 , params -> square_brackets_are_parens ? " or " : "" , sbname , params -> curly_braces_are_parens ? " or " : "" , cbname ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      else {
        long xl , xc , xp ; 
#       define XfOrM392_COUNT (0+XfOrM391_COUNT)
#       define SETUP_XfOrM392(x) SETUP_XfOrM391(x)
        FUNCCALL(SETUP_XfOrM392(_), scheme_tell_all (port , & xl , & xc , & xp ) ); 
        car = FUNCCALL(SETUP_XfOrM392(_), read_list (port , stxsrc , xl , xc , xp , ch , ((effective_ch == '(' ) ? ')' : ((effective_ch == '[' ) ? ']' : '}' ) ) , 3 , use_stack , ht , indentation , params ) ); 
      }
    }
    else {
#     define XfOrM388_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM388(x) SETUP_XfOrM371(x)
      if (prefetched ) {
        car = prefetched ; 
        prefetched = ((void * ) 0 ) ; 
      }
      else {
#       define XfOrM389_COUNT (0+XfOrM388_COUNT)
#       define SETUP_XfOrM389(x) SETUP_XfOrM388(x)
        FUNCCALL(SETUP_XfOrM389(_), scheme_ungetc (ch , port ) ); 
        car = FUNCCALL(SETUP_XfOrM389(_), read_inner (port , stxsrc , ht , indentation , params , 0x1 | 0x10 ) ); 
        if (! car )
          continue ; 
      }
    }
    pair = FUNCCALL(SETUP_XfOrM371(_), scheme_make_pair (car , scheme_null ) ); 
    retry_before_dot : ch = FUNCCALL(SETUP_XfOrM371(_), skip_whitespace_comments (port , stxsrc , ht , indentation , params ) ); 
    effective_ch = FUNCCALL(SETUP_XfOrM371(_), readtable_effective_char (params -> table , ch ) ); 
    if ((effective_ch == closer ) && ! params -> honu_mode ) {
#     define XfOrM385_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM385(x) SETUP_XfOrM371(x)
      if (shape == 3 ) {
#       define XfOrM387_COUNT (0+XfOrM385_COUNT)
#       define SETUP_XfOrM387(x) SETUP_XfOrM385(x)
        (__funcarg87 = FUNCCALL(SETUP_XfOrM387(_), SPAN (port , start ) ), __funcarg88 = FUNCCALL(SETUP_XfOrM387(_), dot_name (params ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , startline , startcol , start , __funcarg87 , ch , indentation , "read: expected %s and value for hash before `%c'" , __funcarg88 , ch ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      cdr = pair ; 
      if (! list )
        list = cdr ; 
      else (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = cdr ; 
      if (infixed ) {
#       define XfOrM386_COUNT (0+XfOrM385_COUNT)
#       define SETUP_XfOrM386(x) SETUP_XfOrM385(x)
        list = FUNCCALL(SETUP_XfOrM386(_), scheme_make_pair (infixed , list ) ); 
      }
      FUNCCALL(SETUP_XfOrM385(_), pop_indentation (indentation ) ); 
      if (params -> honu_mode )
        list = FUNCCALL(SETUP_XfOrM385(_), combine_angle_brackets (list ) ); 
      list = (stxsrc ? (__funcarg86 = FUNCCALL(SETUP_XfOrM385(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (list , line , col , pos , __funcarg86 , stxsrc , scheme_false ) )) : list ) ; 
      list = FUNCCALL(SETUP_XfOrM385(_), attach_shape_property (list , stxsrc , params , closer ) ); 
      RET_VALUE_START (list ) RET_VALUE_END ; 
    }
    else if (! params -> honu_mode && params -> can_read_dot && (effective_ch == '.' ) && FUNCCALL(SETUP_XfOrM371(_), next_is_delim (port , params , brackets , braces ) )) {
      int dot_ch = ch ; 
#     define XfOrM376_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM376(x) SETUP_XfOrM371(x)
      FUNCCALL(SETUP_XfOrM376(_), scheme_tell_all (port , & dotline , & dotcol , & dotpos ) ); 
      FUNCCALL(SETUP_XfOrM376(_), track_indentation (indentation , dotline , dotcol ) ); 
      if (((shape != 0 ) && (shape != 3 ) ) || infixed ) {
#       define XfOrM384_COUNT (0+XfOrM376_COUNT)
#       define SETUP_XfOrM384(x) SETUP_XfOrM376(x)
        FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , dotline , dotcol , dotpos , 1 , 0 , indentation , "read: illegal use of `%c'" , dot_ch ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      cdr = FUNCCALL(SETUP_XfOrM376(_), read_inner (port , stxsrc , ht , indentation , params , 0x10 ) ); 
      ch = FUNCCALL(SETUP_XfOrM376(_), skip_whitespace_comments (port , stxsrc , ht , indentation , params ) ); 
      effective_ch = FUNCCALL_AGAIN(readtable_effective_char (params -> table , ch ) ); 
      if (effective_ch != closer ) {
#       define XfOrM378_COUNT (0+XfOrM376_COUNT)
#       define SETUP_XfOrM378(x) SETUP_XfOrM376(x)
        if (params -> can_read_infix_dot && (effective_ch == '.' ) && FUNCCALL(SETUP_XfOrM378(_), next_is_delim (port , params , brackets , braces ) )) {
#         define XfOrM380_COUNT (0+XfOrM378_COUNT)
#         define SETUP_XfOrM380(x) SETUP_XfOrM378(x)
          if (shape == 3 ) {
#           define XfOrM383_COUNT (0+XfOrM380_COUNT)
#           define SETUP_XfOrM383(x) SETUP_XfOrM380(x)
            (__funcarg84 = FUNCCALL(SETUP_XfOrM383(_), SPAN (port , start ) ), __funcarg85 = FUNCCALL(SETUP_XfOrM383(_), closer_name (params , closer ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , startline , startcol , start , __funcarg84 , ch , indentation , "read: expected %s after hash value" , __funcarg85 ) )) ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          {
#           define XfOrM382_COUNT (0+XfOrM380_COUNT)
#           define SETUP_XfOrM382(x) SETUP_XfOrM380(x)
            FUNCCALL(SETUP_XfOrM382(_), scheme_tell_all (port , & dot2line , & dot2col , & dot2pos ) ); 
            FUNCCALL(SETUP_XfOrM382(_), track_indentation (indentation , dot2line , dot2col ) ); 
          }
          infixed = cdr ; 
          if (! list )
            list = pair ; 
          else (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pair ; 
          last = pair ; 
          ch = FUNCCALL(SETUP_XfOrM380(_), skip_whitespace_comments (port , stxsrc , ht , indentation , params ) ); 
          effective_ch = FUNCCALL_AGAIN(readtable_effective_char (params -> table , ch ) ); 
          if ((effective_ch == closer ) || (ch == (- 1 ) ) ) {
#           define XfOrM381_COUNT (0+XfOrM380_COUNT)
#           define SETUP_XfOrM381(x) SETUP_XfOrM380(x)
            FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , dotline , dotcol , dotpos , 1 , (ch == (- 1 ) ) ? (- 1 ) : 0 , indentation , "read: illegal use of `%c'" , ch ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          got_ch_already = 1 ; 
        }
        else {
#         define XfOrM379_COUNT (0+XfOrM378_COUNT)
#         define SETUP_XfOrM379(x) SETUP_XfOrM378(x)
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , dotline , dotcol , dotpos , 1 , (ch == (- 1 ) ) ? (- 1 ) : 0 , indentation , "read: illegal use of `%c'" , dot_ch ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      else {
#       define XfOrM377_COUNT (0+XfOrM376_COUNT)
#       define SETUP_XfOrM377(x) SETUP_XfOrM376(x)
        (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) = cdr ; 
        cdr = pair ; 
        if (! list )
          list = cdr ; 
        else (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = cdr ; 
        FUNCCALL(SETUP_XfOrM377(_), pop_indentation (indentation ) ); 
        if (params -> honu_mode )
          list = FUNCCALL(SETUP_XfOrM377(_), combine_angle_brackets (list ) ); 
        list = (stxsrc ? (__funcarg83 = FUNCCALL(SETUP_XfOrM377(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (list , line , col , pos , __funcarg83 , stxsrc , scheme_false ) )) : list ) ; 
        list = FUNCCALL(SETUP_XfOrM377(_), attach_shape_property (list , stxsrc , params , closer ) ); 
        RET_VALUE_START (list ) RET_VALUE_END ; 
      }
    }
    else {
#     define XfOrM372_COUNT (0+XfOrM371_COUNT)
#     define SETUP_XfOrM372(x) SETUP_XfOrM371(x)
      if ((ch == (- 2 ) ) || (params -> table && (ch != (- 1 ) ) && (shape != 2 ) ) ) {
#       define XfOrM375_COUNT (0+XfOrM372_COUNT)
#       define SETUP_XfOrM375(x) SETUP_XfOrM372(x)
        FUNCCALL(SETUP_XfOrM375(_), scheme_ungetc (ch , port ) ); 
        prefetched = FUNCCALL(SETUP_XfOrM375(_), read_inner (port , stxsrc , ht , indentation , params , 0x1 | 0x10 ) ); 
        if (! prefetched )
          goto retry_before_dot ; 
      }
      else {
        got_ch_already = 1 ; 
      }
      if (shape == 3 ) {
#       define XfOrM373_COUNT (0+XfOrM372_COUNT)
#       define SETUP_XfOrM373(x) SETUP_XfOrM372(x)
        (__funcarg81 = FUNCCALL(SETUP_XfOrM373(_), SPAN (port , start ) ), __funcarg82 = FUNCCALL(SETUP_XfOrM373(_), dot_name (params ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , startline , startcol , start , __funcarg81 , ch , indentation , "read: expected %s and value for hash" , __funcarg82 ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      cdr = pair ; 
      if (! list )
        list = cdr ; 
      else (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = cdr ; 
      last = cdr ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * combine_angle_brackets (Scheme_Object * list ) {
  Scheme_Object * l , * a , * open_stack = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int i , ch ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(open_stack, 0), PUSH(list, 1), PUSH(a, 2), PUSH(l, 3), PUSH(prev, 4)));
# define XfOrM404_COUNT (5)
# define SETUP_XfOrM404(x) SETUP(XfOrM404_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  a = NULLED_OUT ; 
  for (l = list ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM419_COUNT (0+XfOrM404_COUNT)
#   define SETUP_XfOrM419(x) SETUP_XfOrM404(x)
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (((Scheme_Type ) (((((long ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
      a = ((Scheme_Stx * ) a ) -> val ; 
    if (((a ) == (honu_angle_open ) ) ) {
#     define XfOrM432_COUNT (0+XfOrM419_COUNT)
#     define SETUP_XfOrM432(x) SETUP_XfOrM419(x)
      open_stack = (__funcarg97 = FUNCCALL(SETUP_XfOrM432(_), scheme_make_raw_pair (l , prev ) ), FUNCCALL_AGAIN(scheme_make_raw_pair (__funcarg97 , open_stack ) )) ; 
      a = FUNCCALL(SETUP_XfOrM432(_), scheme_intern_symbol ("<" ) ); 
      if (((Scheme_Type ) (((((long ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
        a = FUNCCALL(SETUP_XfOrM432(_), scheme_datum_to_syntax (a , scheme_false , (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , 0 , 1 ) ); 
      (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) = a ; 
    }
    else if (((a ) == (honu_angle_close ) ) ) {
#     define XfOrM425_COUNT (0+XfOrM419_COUNT)
#     define SETUP_XfOrM425(x) SETUP_XfOrM419(x)
      if (open_stack ) {
        Scheme_Object * open , * open_prev ; 
        Scheme_Object * naya , * ang , * seq ; 
        BLOCK_SETUP((PUSH(ang, 0+XfOrM425_COUNT), PUSH(open_prev, 1+XfOrM425_COUNT), PUSH(naya, 2+XfOrM425_COUNT), PUSH(open, 3+XfOrM425_COUNT), PUSH(seq, 4+XfOrM425_COUNT)));
#       define XfOrM427_COUNT (5+XfOrM425_COUNT)
#       define SETUP_XfOrM427(x) SETUP(XfOrM427_COUNT)
        open = NULLED_OUT ; 
        open_prev = NULLED_OUT ; 
        naya = NULLED_OUT ; 
        ang = NULLED_OUT ; 
        seq = NULLED_OUT ; 
        open = (((Scheme_Simple_Object * ) (open_stack ) ) -> u . pair_val . car ) ; 
        open_prev = (((Scheme_Simple_Object * ) (open ) ) -> u . pair_val . cdr ) ; 
        open = (((Scheme_Simple_Object * ) (open ) ) -> u . pair_val . car ) ; 
        open_stack = (((Scheme_Simple_Object * ) (open_stack ) ) -> u . pair_val . cdr ) ; 
        ang = honu_angles ; 
        if (((Scheme_Type ) (((((long ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) {
          Scheme_Stx * o , * c ; 
          int span ; 
#         define XfOrM431_COUNT (0+XfOrM427_COUNT)
#         define SETUP_XfOrM431(x) SETUP_XfOrM427(x)
          o = NULLED_OUT ; 
          c = NULLED_OUT ; 
          o = (Scheme_Stx * ) (((Scheme_Simple_Object * ) (open ) ) -> u . pair_val . car ) ; 
          c = (Scheme_Stx * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          if ((o -> srcloc -> pos >= 0 ) && (c -> srcloc -> pos >= 0 ) )
            span = (c -> srcloc -> pos - o -> srcloc -> pos ) + c -> srcloc -> span ; 
          else span = - 1 ; 
          ang = FUNCCALL(SETUP_XfOrM431(_), scheme_make_stx_w_offset (ang , o -> srcloc -> line , o -> srcloc -> col , o -> srcloc -> pos , span , o -> srcloc -> src , scheme_false ) ); 
        }
        seq = FUNCCALL(SETUP_XfOrM427(_), scheme_make_pair (ang , (((Scheme_Simple_Object * ) (open ) ) -> u . pair_val . cdr ) ) ); 
        (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = scheme_null ; 
        if (((Scheme_Type ) (((((long ) (ang ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ang ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) {
#         define XfOrM430_COUNT (0+XfOrM427_COUNT)
#         define SETUP_XfOrM430(x) SETUP_XfOrM427(x)
          seq = FUNCCALL(SETUP_XfOrM430(_), scheme_datum_to_syntax (seq , scheme_false , ang , 0 , 1 ) ); 
        }
        naya = FUNCCALL(SETUP_XfOrM427(_), scheme_make_pair (seq , (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) ); 
        if (open_prev ) {
          (((Scheme_Simple_Object * ) (open_prev ) ) -> u . pair_val . cdr ) = naya ; 
        }
        else {
          list = naya ; 
        }
        l = naya ; 
      }
      else {
#       define XfOrM426_COUNT (0+XfOrM425_COUNT)
#       define SETUP_XfOrM426(x) SETUP_XfOrM425(x)
        a = FUNCCALL(SETUP_XfOrM426(_), scheme_intern_symbol (">" ) ); 
        if (((Scheme_Type ) (((((long ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
          a = FUNCCALL(SETUP_XfOrM426(_), scheme_datum_to_syntax (a , scheme_false , (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , 0 , 1 ) ); 
        (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) = a ; 
      }
    }
    else if (open_stack && ((Scheme_Type ) (((((long ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
      for (i = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a ) ) ) -> len ) ; i -- ; ) {
        ch = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a ) ) ) -> s ) [i ] ; 
        if ((ch == '=' ) || (ch == '|' ) || (ch == '&' ) ) {
          open_stack = ((void * ) 0 ) ; 
          break ; 
        }
      }
    }
    prev = l ; 
  }
  RET_VALUE_START (list ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * attach_shape_property (Scheme_Object * list , Scheme_Object * stxsrc , ReadParams * params , int closer ) {
  /* No conversion */
  if ((closer != ')' ) && stxsrc && ! params -> honu_mode ) {
    Scheme_Object * opener ; 
    opener = ((closer == '}' ) ? scheme_char_constants [(unsigned char ) ('{' ) ] : scheme_char_constants [(unsigned char ) ('[' ) ] ) ; 
    return scheme_stx_property (list , paren_shape_symbol , opener ) ; 
  }
  return list ; 
}
/* this far 3108 */
/* this far 3108 */
static Scheme_Object * read_string (int is_byte , int is_honu_char , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int err_ok ) {
  mzchar * buf , * oldbuf , onstack [32 ] ; 
  int i , j , n , n1 , ch , closer = (is_honu_char ? '\'' : '"' ) ; 
  long size = 31 , oldsize , in_pos , init_span ; 
  Scheme_Object * result ; 
  long __funcarg114 ; 
  long __funcarg113 ; 
  long __funcarg112 ; 
  long __funcarg111 ; 
  long __funcarg110 ; 
  long __funcarg108 ; 
  long __funcarg107 ; 
  long __funcarg98 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(stxsrc, 0), PUSH(indentation, 1), PUSH(port, 2), PUSH(oldbuf, 3), PUSH(result, 4), PUSH(buf, 5), PUSH(ht, 6)));
# define XfOrM435_COUNT (7)
# define SETUP_XfOrM435(x) SETUP(XfOrM435_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buf = NULLED_OUT ; 
  oldbuf = NULLED_OUT ; 
  result = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM435(_), scheme_tell_all (port , ((void * ) 0 ) , ((void * ) 0 ) , & in_pos ) ); 
  init_span = in_pos - pos + 1 ; 
  i = 0 ; 
  buf = onstack ; 
  while ((ch = FUNCCALL(SETUP_XfOrM435(_), scheme_getc_special_ok (port ) )) != closer ) {
#   define XfOrM478_COUNT (0+XfOrM435_COUNT)
#   define SETUP_XfOrM478(x) SETUP_XfOrM435(x)
    if ((ch == (- 1 ) ) || (is_honu_char && (i > 0 ) ) ) {
#     define XfOrM514_COUNT (0+XfOrM478_COUNT)
#     define SETUP_XfOrM514(x) SETUP_XfOrM478(x)
      if (err_ok )
        FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (init_span ) , ch , indentation , "read: expected a closing %s%s" , is_honu_char ? "'" : "'\"'" , (ch == (- 1 ) ) ? "" : " after one character" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else if (ch == (- 2 ) ) {
#     define XfOrM513_COUNT (0+XfOrM478_COUNT)
#     define SETUP_XfOrM513(x) SETUP_XfOrM478(x)
      FUNCCALL(SETUP_XfOrM513(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
      if (err_ok )
        (__funcarg114 = FUNCCALL(SETUP_XfOrM513(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg114 , (- 2 ) , indentation , "read: found non-character while reading a %s" , is_honu_char ? "character constant" : "string" ) )) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (ch == '\\' ) {
#     define XfOrM485_COUNT (0+XfOrM478_COUNT)
#     define SETUP_XfOrM485(x) SETUP_XfOrM478(x)
      ch = FUNCCALL(SETUP_XfOrM485(_), scheme_getc_special_ok (port ) ); 
      if (ch == (- 1 ) ) {
#       define XfOrM512_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM512(x) SETUP_XfOrM485(x)
        if (err_ok )
          FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (init_span ) , (- 1 ) , indentation , "read: expected a closing %s" , is_honu_char ? "'" : "'\"'" ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      else if (ch == (- 2 ) ) {
#       define XfOrM511_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM511(x) SETUP_XfOrM485(x)
        FUNCCALL(SETUP_XfOrM511(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
        if (err_ok )
          (__funcarg113 = FUNCCALL(SETUP_XfOrM511(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg113 , (- 2 ) , indentation , "read: found non-character while reading a %s" , is_honu_char ? "character constant" : "string" ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      switch (ch ) {
#       define XfOrM486_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM486(x) SETUP_XfOrM485(x)
        case '\\' : case '\"' : case '\'' : break ; 
        case 'a' : ch = '\a' ; 
        break ; 
        case 'b' : ch = '\b' ; 
        break ; 
        case 'e' : ch = 27 ; 
        break ; 
        case 'f' : ch = '\f' ; 
        break ; 
        case 'n' : ch = '\n' ; 
        break ; 
        case 'r' : ch = '\r' ; 
        break ; 
        case 't' : ch = '\t' ; 
        break ; 
        case 'v' : ch = '\v' ; 
        break ; 
        case '\r' : if (FUNCCALL(SETUP_XfOrM486(_), scheme_peekc_special_ok (port ) )== '\n' )
          FUNCCALL(SETUP_XfOrM486(_), scheme_getc (port ) ); 
        continue ; 
        case '\n' : continue ; 
        case 'x' : ch = FUNCCALL(SETUP_XfOrM486(_), scheme_getc_special_ok (port ) ); 
        if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#         define XfOrM509_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM509(x) SETUP_XfOrM486(x)
          n = ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ; 
          ch = FUNCCALL(SETUP_XfOrM509(_), scheme_peekc_special_ok (port ) ); 
          if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#           define XfOrM510_COUNT (0+XfOrM509_COUNT)
#           define SETUP_XfOrM510(x) SETUP_XfOrM509(x)
            n = n * 16 + (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
            FUNCCALL(SETUP_XfOrM510(_), scheme_getc (port ) ); 
          }
          ch = n ; 
        }
        else {
#         define XfOrM508_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM508(x) SETUP_XfOrM486(x)
          if (ch == (- 2 ) )
            FUNCCALL(SETUP_XfOrM508(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
          if (err_ok )
            (__funcarg112 = FUNCCALL(SETUP_XfOrM508(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg112 , ch , indentation , "read: no hex digit following \\x in %s" , is_honu_char ? "character constant" : "string" ) )) ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        break ; 
        case 'u' : case 'U' : if (! is_byte ) {
          int maxc = ((ch == 'u' ) ? 4 : 8 ) ; 
#         define XfOrM499_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM499(x) SETUP_XfOrM486(x)
          ch = FUNCCALL(SETUP_XfOrM499(_), scheme_getc_special_ok (port ) ); 
          if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
            int count = 1 ; 
#           define XfOrM501_COUNT (0+XfOrM499_COUNT)
#           define SETUP_XfOrM501(x) SETUP_XfOrM499(x)
            n = ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ; 
            while (count < maxc ) {
#             define XfOrM506_COUNT (0+XfOrM501_COUNT)
#             define SETUP_XfOrM506(x) SETUP_XfOrM501(x)
              ch = FUNCCALL(SETUP_XfOrM506(_), scheme_peekc_special_ok (port ) ); 
              if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#               define XfOrM507_COUNT (0+XfOrM506_COUNT)
#               define SETUP_XfOrM507(x) SETUP_XfOrM506(x)
                n = n * 16 + (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
                FUNCCALL(SETUP_XfOrM507(_), scheme_getc (port ) ); 
                count ++ ; 
              }
              else break ; 
            }
            if (((n >= 0xD800 ) && (n <= 0xDFFF ) ) || (n > 0x10FFFF ) ) {
              ch = - 1 ; 
            }
            else {
              ch = n ; 
            }
          }
          else {
#           define XfOrM500_COUNT (0+XfOrM499_COUNT)
#           define SETUP_XfOrM500(x) SETUP_XfOrM499(x)
            if (ch == (- 2 ) )
              FUNCCALL(SETUP_XfOrM500(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
            if (err_ok )
              (__funcarg111 = FUNCCALL(SETUP_XfOrM500(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg111 , ch , indentation , "read: no hex digit following \\%c in %s" , ((maxc == 4 ) ? 'u' : 'U' ) , is_honu_char ? "character constant" : "string" ) )) ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          break ; 
        }
        default : if ((ch >= '0' ) && (ch <= '7' ) ) {
#         define XfOrM488_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM488(x) SETUP_XfOrM486(x)
          for (n = j = 0 ; j < 3 ; j ++ ) {
#           define XfOrM494_COUNT (0+XfOrM488_COUNT)
#           define SETUP_XfOrM494(x) SETUP_XfOrM488(x)
            n1 = 8 * n + ch - '0' ; 
            if (n1 > 255 ) {
#             define XfOrM498_COUNT (0+XfOrM494_COUNT)
#             define SETUP_XfOrM498(x) SETUP_XfOrM494(x)
              if (err_ok )
                (__funcarg110 = FUNCCALL(SETUP_XfOrM498(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg110 , 0 , indentation , "read: escape sequence \\%o out of range in %s" , n1 , is_honu_char ? "character constant" : "string" ) )) ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            n = n1 ; 
            if (j < 2 ) {
#             define XfOrM495_COUNT (0+XfOrM494_COUNT)
#             define SETUP_XfOrM495(x) SETUP_XfOrM494(x)
              ch = FUNCCALL(SETUP_XfOrM495(_), scheme_peekc_special_ok (port ) ); 
              if (! ((ch >= '0' ) && (ch <= '7' ) ) ) {
                break ; 
              }
              else {
#               define XfOrM496_COUNT (0+XfOrM495_COUNT)
#               define SETUP_XfOrM496(x) SETUP_XfOrM495(x)
                FUNCCALL(SETUP_XfOrM496(_), scheme_getc (port ) ); 
              }
            }
          }
          ch = n ; 
        }
        else {
#         define XfOrM487_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM487(x) SETUP_XfOrM486(x)
          if (err_ok )
            (__funcarg108 = FUNCCALL(SETUP_XfOrM487(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg108 , 0 , indentation , "read: unknown escape sequence \\%c in %s%s" , ch , is_byte ? "byte " : "" , is_honu_char ? "character constant" : "string" ) )) ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        break ; 
      }
    }
    else if ((ch == '\n' ) || (ch == '\r' ) ) {
      if (line > 0 ) {
        if (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
          Scheme_Indent * indt ; 
          indt = NULLED_OUT ; 
          indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
          if (! indt -> suspicious_quote ) {
            indt -> suspicious_quote = line ; 
            indt -> quote_for_char = is_honu_char ; 
          }
        }
      }
    }
    if (ch < 0 ) {
#     define XfOrM480_COUNT (0+XfOrM478_COUNT)
#     define SETUP_XfOrM480(x) SETUP_XfOrM478(x)
      if (err_ok )
        (__funcarg107 = FUNCCALL(SETUP_XfOrM480(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg107 , 0 , indentation , "read: out-of-range character in %s%s" , is_byte ? "byte " : "" , is_honu_char ? "character constant" : "string" ) )) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (i >= size ) {
#     define XfOrM479_COUNT (0+XfOrM478_COUNT)
#     define SETUP_XfOrM479(x) SETUP_XfOrM478(x)
      oldsize = size ; 
      oldbuf = buf ; 
      size *= 2 ; 
      buf = (mzchar * ) FUNCCALL(SETUP_XfOrM479(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
      (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
    }
    buf [i ++ ] = ch ; 
  }
  buf [i ] = '\0' ; 
  if (is_honu_char ) {
#   define XfOrM439_COUNT (0+XfOrM435_COUNT)
#   define SETUP_XfOrM439(x) SETUP_XfOrM435(x)
    if (i )
      result = ((((mzchar ) buf [0 ] ) < 256 ) ? scheme_char_constants [(unsigned char ) (buf [0 ] ) ] : FUNCCALL(SETUP_XfOrM439(_), scheme_make_char (buf [0 ] ) )) ; 
    else {
#     define XfOrM440_COUNT (0+XfOrM439_COUNT)
#     define SETUP_XfOrM440(x) SETUP_XfOrM439(x)
      if (err_ok )
        FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , 0 , indentation , "read: expected one character before closing '" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
  else if (! is_byte )
    result = FUNCCALL(SETUP_XfOrM435(_), scheme_make_immutable_sized_char_string (buf , i , i <= 31 ) ); 
  else {
    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM435_COUNT)));
#   define XfOrM436_COUNT (1+XfOrM435_COUNT)
#   define SETUP_XfOrM436(x) SETUP(XfOrM436_COUNT)
    s = NULLED_OUT ; 
    s = (char * ) FUNCCALL(SETUP_XfOrM436(_), GC_malloc_atomic (i + 1 ) ); 
    for (j = 0 ; j < i ; j ++ ) {
      ((unsigned char * ) s ) [j ] = buf [j ] ; 
    }
    s [i ] = 0 ; 
    result = FUNCCALL(SETUP_XfOrM436(_), scheme_make_immutable_sized_byte_string (s , i , 0 ) ); 
  }
  if (stxsrc )
    result = (__funcarg98 = FUNCCALL(SETUP_XfOrM435(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (result , line , col , pos , __funcarg98 , stxsrc , scheme_false ) )) ; 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_read_byte_string (Scheme_Object * port ) {
  /* No conversion */
  return read_string (1 , 0 , port , ((void * ) 0 ) , 0 , 0 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}
static Scheme_Object * read_here_string (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Object * indentation , ReadParams * params ) {
  int tlen = 0 , len = 0 , size = 12 ; 
  mzchar * tag , * naya , * s , buf [12 ] , c ; 
  long in_pos , init_span ; 
  Scheme_Object * str ; 
  long __funcarg115 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(stxsrc, 0), PUSH(indentation, 1), PUSH(port, 2), PUSH(naya, 3), PUSH(s, 4), PUSH(str, 5), PUSH(tag, 6)));
# define XfOrM516_COUNT (7)
# define SETUP_XfOrM516(x) SETUP(XfOrM516_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  tag = NULLED_OUT ; 
  naya = NULLED_OUT ; 
  s = NULLED_OUT ; 
  str = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM516(_), scheme_tell_all (port , ((void * ) 0 ) , ((void * ) 0 ) , & in_pos ) ); 
  init_span = in_pos - pos + 1 ; 
  tag = buf ; 
  while (1 ) {
#   define XfOrM531_COUNT (0+XfOrM516_COUNT)
#   define SETUP_XfOrM531(x) SETUP_XfOrM516(x)
    c = FUNCCALL(SETUP_XfOrM531(_), scheme_getc (port ) ); 
    if (c == '\n' ) {
      break ; 
    }
    else if (c == (- 1 ) ) {
#     define XfOrM534_COUNT (0+XfOrM531_COUNT)
#     define SETUP_XfOrM534(x) SETUP_XfOrM531(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 3 + tlen , (- 1 ) , indentation , "read: found end-of-file after #<< and before first and-of-line" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else {
#     define XfOrM532_COUNT (0+XfOrM531_COUNT)
#     define SETUP_XfOrM532(x) SETUP_XfOrM531(x)
      if (tlen >= size ) {
        size *= 2 ; 
#       define XfOrM533_COUNT (0+XfOrM532_COUNT)
#       define SETUP_XfOrM533(x) SETUP_XfOrM532(x)
        naya = (mzchar * ) FUNCCALL(SETUP_XfOrM533(_), GC_malloc_atomic (size * sizeof (mzchar ) ) ); 
        (memcpy (naya , tag , tlen * sizeof (mzchar ) ) ) ; 
        tag = naya ; 
      }
      tag [tlen ++ ] = c ; 
    }
  }
  if (! tlen ) {
#   define XfOrM525_COUNT (0+XfOrM516_COUNT)
#   define SETUP_XfOrM525(x) SETUP_XfOrM516(x)
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 3 , 0 , indentation , "read: no characters after #<< before and-of-line" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  size = 10 + tlen ; 
  s = (mzchar * ) FUNCCALL(SETUP_XfOrM516(_), GC_malloc_atomic (size * sizeof (mzchar ) ) ); 
  while (1 ) {
#   define XfOrM521_COUNT (0+XfOrM516_COUNT)
#   define SETUP_XfOrM521(x) SETUP_XfOrM516(x)
    c = FUNCCALL(SETUP_XfOrM521(_), scheme_getc (port ) ); 
    if (c == (- 1 ) ) {
#     define XfOrM524_COUNT (0+XfOrM521_COUNT)
#     define SETUP_XfOrM524(x) SETUP_XfOrM521(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (init_span ) , (- 1 ) , indentation , "read: found end-of-file before terminating %u%s" , tag , (tlen > 50 ) ? 50 : tlen , (tlen > 50 ) ? "..." : "" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (len >= size ) {
      size *= 2 ; 
#     define XfOrM523_COUNT (0+XfOrM521_COUNT)
#     define SETUP_XfOrM523(x) SETUP_XfOrM521(x)
      naya = (mzchar * ) FUNCCALL(SETUP_XfOrM523(_), GC_malloc_atomic (size * sizeof (mzchar ) ) ); 
      (memcpy (naya , s , len * sizeof (mzchar ) ) ) ; 
      s = naya ; 
    }
    s [len ++ ] = c ; 
    if ((len >= tlen ) && ((len == tlen ) || (s [len - tlen - 1 ] == '\n' ) ) && ! (memcmp (s XFORM_OK_PLUS (len - tlen ) , tag , sizeof (mzchar ) * tlen ) ) ) {
#     define XfOrM522_COUNT (0+XfOrM521_COUNT)
#     define SETUP_XfOrM522(x) SETUP_XfOrM521(x)
      c = FUNCCALL(SETUP_XfOrM522(_), scheme_peekc (port ) ); 
      if ((c == '\r' ) || (c == '\n' ) || (c == (- 1 ) ) )
        break ; 
    }
  }
  len -= (tlen + 1 ) ; 
  if (len < 0 )
    len = 0 ; 
  str = FUNCCALL(SETUP_XfOrM516(_), scheme_make_sized_char_string (s , len , 1 ) ); 
  if (stxsrc )
    str = (__funcarg115 = FUNCCALL(SETUP_XfOrM516(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (str , line , col , pos , __funcarg115 , stxsrc , scheme_false ) )) ; 
  RET_VALUE_START (str ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
char * scheme_extract_indentation_suggestions (Scheme_Object * indentation ) {
  long suspicious_quote = 0 ; 
  int is_honu_char = 0 ; 
  char * suspicions = "" ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(suspicions, 0)));
# define XfOrM536_COUNT (1)
# define SETUP_XfOrM536(x) SETUP(XfOrM536_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  while (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    Scheme_Indent * indt ; 
    indt = NULLED_OUT ; 
    indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
    indentation = (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . cdr ) ; 
    if (indt -> suspicious_quote ) {
      suspicious_quote = indt -> suspicious_quote ; 
      is_honu_char = indt -> quote_for_char ; 
    }
  }
  if (suspicious_quote ) {
#   define XfOrM537_COUNT (0+XfOrM536_COUNT)
#   define SETUP_XfOrM537(x) SETUP_XfOrM536(x)
    suspicions = (char * ) FUNCCALL(SETUP_XfOrM537(_), GC_malloc_atomic (64 ) ); 
    (sprintf (suspicions , "; newline within %s suggests a missing %s on line %ld" , is_honu_char ? "character" : "string" , is_honu_char ? "'" : "'\"'" , suspicious_quote ) ) ; 
  }
  RET_VALUE_START (suspicions ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_vector (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int opener , char closer , long requestLength , const mzchar * reqBuffer , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * lresult , * obj , * vec , * * els ; 
  int len , i ; 
  long __funcarg117 ; 
  long __funcarg116 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(stxsrc, 1), PUSH(reqBuffer, 2), PUSH(els, 3), PUSH(indentation, 4), PUSH(vec, 5), PUSH(lresult, 6), PUSH(port, 7)));
# define XfOrM542_COUNT (8)
# define SETUP_XfOrM542(x) SETUP(XfOrM542_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lresult = NULLED_OUT ; 
  obj = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  els = NULLED_OUT ; 
  lresult = FUNCCALL(SETUP_XfOrM542(_), read_list (port , stxsrc , line , col , pos , opener , closer , 1 , 1 , ht , indentation , params ) ); 
  if (requestLength == - 2 ) {
#   define XfOrM551_COUNT (0+XfOrM542_COUNT)
#   define SETUP_XfOrM551(x) SETUP_XfOrM542(x)
    FUNCCALL_EMPTY(scheme_raise_out_of_memory ("read" , "making vector of size %5" , reqBuffer ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (stxsrc )
    obj = ((Scheme_Stx * ) lresult ) -> val ; 
  else obj = lresult ; 
  len = FUNCCALL(SETUP_XfOrM542(_), scheme_list_length (obj ) ); 
  if (requestLength >= 0 && len > requestLength ) {
    char buffer [20 ] ; 
#   define XfOrM550_COUNT (0+XfOrM542_COUNT)
#   define SETUP_XfOrM550(x) SETUP_XfOrM542(x)
    (sprintf (buffer , "%ld" , requestLength ) ) ; 
    (__funcarg117 = FUNCCALL(SETUP_XfOrM550(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg117 , 0 , indentation , "read: vector length %ld is too small, " "%d values provided" , requestLength , len ) )) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (requestLength < 0 )
    requestLength = len ; 
  vec = FUNCCALL(SETUP_XfOrM542(_), scheme_make_vector (requestLength , ((void * ) 0 ) ) ); 
  els = (((Scheme_Vector * ) (vec ) ) -> els ) ; 
  for (i = 0 ; i < len ; i ++ ) {
    els [i ] = (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) ; 
    obj = (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ; 
  }
  els = ((void * ) 0 ) ; 
  if (i < requestLength ) {
#   define XfOrM544_COUNT (0+XfOrM542_COUNT)
#   define SETUP_XfOrM544(x) SETUP_XfOrM542(x)
    if (len )
      obj = (((Scheme_Vector * ) (vec ) ) -> els ) [len - 1 ] ; 
    else {
#     define XfOrM547_COUNT (0+XfOrM544_COUNT)
#     define SETUP_XfOrM547(x) SETUP_XfOrM544(x)
      obj = ((Scheme_Object * ) (void * ) (long ) ((((long ) (0 ) ) << 1 ) | 0x1 ) ) ; 
      if (stxsrc )
        obj = (__funcarg116 = FUNCCALL(SETUP_XfOrM547(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (obj , line , col , pos , __funcarg116 , stxsrc , scheme_false ) )) ; 
    }
    els = (((Scheme_Vector * ) (vec ) ) -> els ) ; 
    for (; i < requestLength ; i ++ ) {
      els [i ] = obj ; 
    }
    els = ((void * ) 0 ) ; 
  }
  if (stxsrc ) {
    if ((((Scheme_Vector * ) (vec ) ) -> size ) > 0 )
      ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 
    ((Scheme_Stx * ) lresult ) -> val = vec ; 
    RET_VALUE_START (lresult ) RET_VALUE_END ; 
  }
  else RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int check_honu_num (mzchar * buf , int i ) ; 
typedef int (* Getc_Fun_r ) (Scheme_Object * port ) ; 
/* this far 3602 */
/* this far 3549 */
/* this far 3502 */
/* this far 3483 */
/* this far 3502 */
/* this far 3483 */
static Scheme_Object * read_number_or_symbol (int init_ch , int skip_rt , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int is_float , int is_not_float , int radix , int radix_set , int is_symbol , int is_kw , int pipe_quote , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) {
  mzchar * buf , * oldbuf , onstack [64 ] ; 
  int size , oldsize ; 
  int i , ch , quoted , quoted_ever = 0 , running_quote = 0 ; 
  int running_quote_ch = 0 ; 
  long rq_pos = 0 , rq_col = 0 , rq_line = 0 ; 
  int case_sens = params -> case_sensitive ; 
  int decimal_inexact = params -> read_decimal_inexact ; 
  Scheme_Object * o ; 
  int delim_ok ; 
  int ungetc_ok ; 
  int honu_mode , e_ok = 0 ; 
  int far_char_ok ; 
  int single_escape , multiple_escape , norm_count = 0 ; 
  Getc_Fun_r getc_special_ok_fun ; 
  long __funcarg127 ; 
  long __funcarg126 ; 
  long __funcarg123 ; 
  long __funcarg122 ; 
  long __funcarg121 ; 
  long __funcarg120 ; 
  long __funcarg119 ; 
  long __funcarg118 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(buf, 0), PUSH(stxsrc, 1), PUSH(indentation, 2), PUSH(port, 3), PUSH(oldbuf, 4), PUSH(params, 5), PUSH(table, 6), PUSH(o, 7), PUSH(ht, 8)));
# define XfOrM552_COUNT (9)
# define SETUP_XfOrM552(x) SETUP(XfOrM552_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buf = NULLED_OUT ; 
  oldbuf = NULLED_OUT ; 
  o = NULLED_OUT ; 
  if (! skip_rt && table ) {
#   define XfOrM606_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM606(x) SETUP_XfOrM552(x)
    if (table -> symbol_parser ) {
#     define XfOrM607_COUNT (0+XfOrM606_COUNT)
#     define SETUP_XfOrM607(x) SETUP_XfOrM606(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(readtable_call (1 , init_ch , table -> symbol_parser , params , port , stxsrc , line , col , pos , 0 , ht , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
    }
  }
  ungetc_ok = FUNCCALL(SETUP_XfOrM552(_), scheme_peekc_is_ungetc (port ) ); 
  if (ungetc_ok ) {
    getc_special_ok_fun = scheme_getc_special_ok ; 
  }
  else {
    getc_special_ok_fun = scheme_peekc_special_ok ; 
  }
  i = 0 ; 
  size = 64 - 1 ; 
  buf = onstack ; 
  if (init_ch < 0 )
    ch = FUNCCALL(SETUP_XfOrM552(_), getc_special_ok_fun (port ) ); 
  else {
    ch = init_ch ; 
  }
  if (is_float || is_not_float || radix_set )
    honu_mode = 0 ; 
  else honu_mode = params -> honu_mode ; 
  if (table ) {
    far_char_ok = 0 ; 
    delim_ok = 0 ; 
  }
  else if (! honu_mode ) {
    delim_ok = 0x1 ; 
    far_char_ok = 1 ; 
  }
  else {
    pipe_quote = 0 ; 
    if (! is_symbol ) {
      delim_ok = (0x8 | 0x10 ) ; 
      e_ok = 1 ; 
      far_char_ok = 0 ; 
    }
    else if (delim [ch ] & 0x4 ) {
      delim_ok = 0x4 ; 
      far_char_ok = 0 ; 
    }
    else {
      delim_ok = 0x2 ; 
      far_char_ok = 1 ; 
    }
  }
  while (((ch ) >= 0 ) && (running_quote || (! table && ! (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) && (((ch < 128 ) && (delim [ch ] & delim_ok ) ) || ((ch >= 128 ) && far_char_ok ) ) ) || table ) ) {
#   define XfOrM583_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM583(x) SETUP_XfOrM552(x)
    if (table ) {
      int v ; 
#     define XfOrM596_COUNT (0+XfOrM583_COUNT)
#     define SETUP_XfOrM596(x) SETUP_XfOrM583(x)
      v = FUNCCALL(SETUP_XfOrM596(_), readtable_kind (table , ch , params ) ); 
      if (! running_quote && (v & (0x4 | 0x1 ) ) )
        break ; 
      single_escape = (v & 0x8 ) ; 
      multiple_escape = (v & 0x10 ) ; 
    }
    else {
      single_escape = (ch == '\\' ) ; 
      multiple_escape = ((ch == '|' ) && pipe_quote ) ; 
    }
    if (! ungetc_ok ) {
#     define XfOrM594_COUNT (0+XfOrM583_COUNT)
#     define SETUP_XfOrM594(x) SETUP_XfOrM583(x)
      if (init_ch < 0 )
        FUNCCALL(SETUP_XfOrM594(_), scheme_getc (port ) ); 
      else init_ch = - 1 ; 
    }
    if (single_escape && ! running_quote ) {
      int esc_ch = ch ; 
#     define XfOrM591_COUNT (0+XfOrM583_COUNT)
#     define SETUP_XfOrM591(x) SETUP_XfOrM583(x)
      ch = FUNCCALL(SETUP_XfOrM591(_), scheme_getc_special_ok (port ) ); 
      if (ch == (- 1 ) ) {
#       define XfOrM593_COUNT (0+XfOrM591_COUNT)
#       define SETUP_XfOrM593(x) SETUP_XfOrM591(x)
        (__funcarg127 = FUNCCALL(SETUP_XfOrM593(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg127 , (- 1 ) , indentation , "read: EOF following `%c' in %s" , esc_ch , is_kw ? "keyword" : "symbol" ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      else if (ch == (- 2 ) ) {
#       define XfOrM592_COUNT (0+XfOrM591_COUNT)
#       define SETUP_XfOrM592(x) SETUP_XfOrM591(x)
        FUNCCALL(SETUP_XfOrM592(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
        (__funcarg126 = FUNCCALL(SETUP_XfOrM592(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg126 , (- 2 ) , indentation , "read: non-character following `%c' in %s" , esc_ch , is_kw ? "keyword" : "symbol" ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      quoted = 1 ; 
      quoted_ever = 1 ; 
    }
    else if (multiple_escape && (! running_quote || (ch == running_quote_ch ) ) ) {
#     define XfOrM590_COUNT (0+XfOrM583_COUNT)
#     define SETUP_XfOrM590(x) SETUP_XfOrM583(x)
      quoted_ever = 1 ; 
      running_quote = ! running_quote ; 
      running_quote_ch = ch ; 
      quoted = 0 ; 
      FUNCCALL(SETUP_XfOrM590(_), scheme_tell_all (port , & rq_line , & rq_col , & rq_pos ) ); 
      ch = FUNCCALL_AGAIN(getc_special_ok_fun (port ) ); 
      continue ; 
    }
    else quoted = 0 ; 
    if (i >= size ) {
#     define XfOrM589_COUNT (0+XfOrM583_COUNT)
#     define SETUP_XfOrM589(x) SETUP_XfOrM583(x)
      oldsize = size ; 
      oldbuf = buf ; 
      size *= 2 ; 
      buf = (mzchar * ) FUNCCALL(SETUP_XfOrM589(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
      (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
    }
    if (! case_sens && ! quoted && ! running_quote )
      norm_count ++ ; 
    else if (norm_count ) {
      mzchar * s ; 
      int newlen ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM583_COUNT)));
#     define XfOrM586_COUNT (1+XfOrM583_COUNT)
#     define SETUP_XfOrM586(x) SETUP(XfOrM586_COUNT)
      s = NULLED_OUT ; 
      s = FUNCCALL(SETUP_XfOrM586(_), scheme_string_recase (buf , i - norm_count , norm_count , 3 , 1 , & newlen ) ); 
      if (s != buf ) {
#       define XfOrM587_COUNT (0+XfOrM586_COUNT)
#       define SETUP_XfOrM587(x) SETUP_XfOrM586(x)
        if ((i + newlen - norm_count ) >= size ) {
#         define XfOrM588_COUNT (0+XfOrM587_COUNT)
#         define SETUP_XfOrM588(x) SETUP_XfOrM587(x)
          oldsize = size ; 
          oldbuf = buf ; 
          size *= 2 ; 
          if (size <= (i + newlen - norm_count ) )
            size = 2 * (i + (newlen - norm_count ) ) ; 
          buf = (mzchar * ) FUNCCALL(SETUP_XfOrM588(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
          (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
        }
        (memcpy (buf + i - norm_count , s , sizeof (mzchar ) * newlen ) ) ; 
      }
      i += (newlen - norm_count ) ; 
      norm_count = 0 ; 
    }
    buf [i ++ ] = ch ; 
    if (delim_ok & 0x10 ) {
      if ((ch == 'e' ) || (ch == 'E' ) ) {
        delim_ok = (0x8 | 0x10 | 0x20 ) ; 
      }
      else delim_ok = (0x8 | 0x10 ) ; 
    }
    ch = FUNCCALL(SETUP_XfOrM583(_), getc_special_ok_fun (port ) ); 
  }
  if (running_quote && (ch == (- 2 ) ) ) {
#   define XfOrM568_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM568(x) SETUP_XfOrM552(x)
    FUNCCALL(SETUP_XfOrM568(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
    (__funcarg123 = FUNCCALL(SETUP_XfOrM568(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg123 , (- 2 ) , indentation , "read: non-character following `%c' in %s" , running_quote_ch , is_kw ? "keyword" : "symbol" ) )) ; 
  }
  if (ungetc_ok )
    FUNCCALL(SETUP_XfOrM552(_), scheme_ungetc (ch , port ) ); 
  if (running_quote ) {
#   define XfOrM567_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM567(x) SETUP_XfOrM552(x)
    (__funcarg122 = FUNCCALL(SETUP_XfOrM567(_), SPAN (port , rq_pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , rq_line , rq_col , rq_pos , __funcarg122 , (- 1 ) , indentation , "read: unbalanced `%c'" , running_quote_ch ) )) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (norm_count ) {
    mzchar * s ; 
    int newlen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM552_COUNT)));
#   define XfOrM565_COUNT (1+XfOrM552_COUNT)
#   define SETUP_XfOrM565(x) SETUP(XfOrM565_COUNT)
    s = NULLED_OUT ; 
    s = FUNCCALL(SETUP_XfOrM565(_), scheme_string_recase (buf , i - norm_count , norm_count , 3 , 1 , & newlen ) ); 
    if (s != buf ) {
#     define XfOrM566_COUNT (0+XfOrM565_COUNT)
#     define SETUP_XfOrM566(x) SETUP_XfOrM565(x)
      oldsize = size ; 
      oldbuf = buf ; 
      size = i + (newlen - norm_count ) + 1 ; 
      buf = (mzchar * ) FUNCCALL(SETUP_XfOrM566(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
      (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
      (memcpy (buf + i - norm_count , s , sizeof (mzchar ) * newlen ) ) ; 
    }
    i += (newlen - norm_count ) ; 
  }
  buf [i ] = '\0' ; 
  if (! quoted_ever && (i == 1 ) && (FUNCCALL(SETUP_XfOrM552(_), readtable_effective_char (params -> table , buf [0 ] ) )== '.' ) && ! honu_mode ) {
    long xl , xc , xp ; 
#   define XfOrM564_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM564(x) SETUP_XfOrM552(x)
    FUNCCALL(SETUP_XfOrM564(_), scheme_tell_all (port , & xl , & xc , & xp ) ); 
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , xl , xc , xp , 1 , 0 , indentation , "read: illegal use of \".\"" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (! i && honu_mode ) {
#   define XfOrM563_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM563(x) SETUP_XfOrM552(x)
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: illegal character: %c" , ch ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (honu_mode && ! is_symbol ) {
    int found_e ; 
#   define XfOrM557_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM557(x) SETUP_XfOrM552(x)
    found_e = FUNCCALL(SETUP_XfOrM557(_), check_honu_num (buf , i ) ); 
    if (found_e < 0 ) {
#     define XfOrM562_COUNT (0+XfOrM557_COUNT)
#     define SETUP_XfOrM562(x) SETUP_XfOrM557(x)
      (__funcarg121 = FUNCCALL(SETUP_XfOrM562(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg121 , 0 , indentation , "read: bad number: %5" , buf ) )) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (delim [buf [i - 1 ] ] & 0x10 ) {
#     define XfOrM558_COUNT (0+XfOrM557_COUNT)
#     define SETUP_XfOrM558(x) SETUP_XfOrM557(x)
      if (found_e ) {
        buf [found_e ] = buf [i - 1 ] ; 
        i -- ; 
      }
      else {
#       define XfOrM559_COUNT (0+XfOrM558_COUNT)
#       define SETUP_XfOrM559(x) SETUP_XfOrM558(x)
        if (i >= size ) {
#         define XfOrM560_COUNT (0+XfOrM559_COUNT)
#         define SETUP_XfOrM560(x) SETUP_XfOrM559(x)
          oldsize = size ; 
          oldbuf = buf ; 
          size *= 2 ; 
          buf = (mzchar * ) FUNCCALL(SETUP_XfOrM560(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
          (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
        }
        buf [i ++ ] = '0' ; 
        buf [i ] = 0 ; 
      }
    }
  }
  if ((is_symbol || quoted_ever ) && ! is_float && ! is_not_float && ! radix_set )
    o = scheme_false ; 
  else {
#   define XfOrM556_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM556(x) SETUP_XfOrM552(x)
    o = (__funcarg120 = FUNCCALL(SETUP_XfOrM556(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_read_number (buf , i , is_float , is_not_float , decimal_inexact , radix , radix_set , port , ((void * ) 0 ) , 0 , stxsrc , line , col , pos , __funcarg120 , indentation ) )) ; 
  }
  if (((o ) == (scheme_false ) ) ) {
#   define XfOrM553_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM553(x) SETUP_XfOrM552(x)
    if (honu_mode && ! is_symbol ) {
#     define XfOrM555_COUNT (0+XfOrM553_COUNT)
#     define SETUP_XfOrM555(x) SETUP_XfOrM553(x)
      (__funcarg119 = FUNCCALL(SETUP_XfOrM555(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg119 , 0 , indentation , "read: bad number: %5" , buf ) )) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (is_kw ) {
#     define XfOrM554_COUNT (0+XfOrM553_COUNT)
#     define SETUP_XfOrM554(x) SETUP_XfOrM553(x)
      o = FUNCCALL(SETUP_XfOrM554(_), scheme_intern_exact_char_keyword (buf , i ) ); 
    }
    else o = FUNCCALL(SETUP_XfOrM553(_), scheme_intern_exact_char_symbol (buf , i ) ); 
  }
  if (stxsrc )
    o = (__funcarg118 = FUNCCALL(SETUP_XfOrM552(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (o , line , col , pos , __funcarg118 , stxsrc , scheme_false ) )) ; 
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_number (int init_ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int is_float , int is_not_float , int radix , int radix_set , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) {
  /* No conversion */
  return read_number_or_symbol (init_ch , init_ch < 0 , port , stxsrc , line , col , pos , is_float , is_not_float , radix , radix_set , 0 , 0 , params -> can_read_pipe_quote , ht , indentation , params , table ) ; 
}
static Scheme_Object * read_symbol (int init_ch , int skip_rt , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) {
  /* No conversion */
  return read_number_or_symbol (init_ch , skip_rt , port , stxsrc , line , col , pos , 0 , 0 , 10 , 0 , 1 , 0 , params -> can_read_pipe_quote , ht , indentation , params , table ) ; 
}
static Scheme_Object * read_keyword (int init_ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , Readtable * table ) {
  /* No conversion */
  return read_number_or_symbol (init_ch , 1 , port , stxsrc , line , col , pos , 0 , 0 , 10 , 0 , 1 , 1 , params -> can_read_pipe_quote , ht , indentation , params , table ) ; 
}
static int check_honu_num (mzchar * buf , int i ) {
  /* No conversion */
  int j , found_e = 0 , found_dot = 0 ; 
  for (j = 0 ; j < i ; j ++ ) {
    if (buf [j ] == '.' ) {
      if (found_dot ) {
        j = 0 ; 
        break ; 
      }
      found_dot = 1 ; 
    }
    else if ((buf [j ] == 'e' ) || (buf [j ] == 'E' ) ) {
      if (! j )
        break ; 
      found_e = j ; 
      j ++ ; 
      if ((buf [j ] == '+' ) || (buf [j ] == '-' ) )
        j ++ ; 
      if (! ((buf [j ] >= '0' ) && (buf [j ] <= '9' ) ) ) {
        j = 0 ; 
        break ; 
      }
      while (((buf [j ] >= '0' ) && (buf [j ] <= '9' ) ) ) {
        j ++ ; 
      }
      if (! buf [j ] )
        break ; 
      if (buf [j + 1 ] ) {
        j = 0 ; 
        break ; 
      }
      switch (buf [j ] ) {
        case 'd' : case 'D' : case 'f' : case 'F' : break ; 
        default : j = 0 ; 
        break ; 
      }
      break ; 
    }
    else if (delim [buf [j ] ] & 0x10 ) {
      if (j + 1 == i ) {
      }
      else {
        j = 0 ; 
        break ; 
      }
    }
  }
  if (! j ) {
    return - 1 ; 
  }
  return found_e ; 
}
static int u_strcmp (mzchar * s , const char * _t ) {
  /* No conversion */
  int i ; 
  unsigned char * t = (unsigned char * ) _t ; 
  for (i = 0 ; s [i ] && ((s [i ] + scheme_uchar_downs [(scheme_uchar_cases_table [(s [i ] >> 8 ) & 0x1FFF ] [s [i ] & 0xFF ] ) ] ) == ((mzchar ) ((unsigned char * ) t ) [i ] + scheme_uchar_downs [(scheme_uchar_cases_table [((mzchar ) ((unsigned char * ) t ) [i ] >> 8 ) & 0x1FFF ] [(mzchar ) ((unsigned char * ) t ) [i ] & 0xFF ] ) ] ) ) ; i ++ ) {
  }
  if (s [i ] || t [i ] )
    return 1 ; 
  return 0 ; 
}
/* this far 3841 */
/* this far 3841 */
static Scheme_Object * read_character (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  int ch , next ; 
  long __funcarg129 ; 
  long __funcarg128 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(stxsrc, 0), PUSH(indentation, 1), PUSH(port, 2), PUSH(ht, 3)));
# define XfOrM640_COUNT (4)
# define SETUP_XfOrM640(x) SETUP(XfOrM640_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ch = FUNCCALL(SETUP_XfOrM640(_), scheme_getc_special_ok (port ) ); 
  if (ch == (- 2 ) ) {
#   define XfOrM657_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM657(x) SETUP_XfOrM640(x)
    FUNCCALL(SETUP_XfOrM657(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
    (__funcarg129 = FUNCCALL(SETUP_XfOrM657(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg129 , (- 2 ) , indentation , "read: found non-character after #\\" ) )) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  next = FUNCCALL(SETUP_XfOrM640(_), scheme_peekc_special_ok (port ) ); 
  if ((ch >= '0' && ch <= '7' ) && (next >= '0' && next <= '7' ) ) {
    int last ; 
#   define XfOrM655_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM655(x) SETUP_XfOrM640(x)
    last = (FUNCCALL(SETUP_XfOrM655(_), scheme_getc (port ) ), FUNCCALL(SETUP_XfOrM655(_), scheme_peekc_special_ok (port ) )) ; 
    if (last != (- 2 ) )
      FUNCCALL(SETUP_XfOrM655(_), scheme_getc (port ) ); 
    if (last < '0' || last > '7' || ch > '3' ) {
#     define XfOrM656_COUNT (0+XfOrM655_COUNT)
#     define SETUP_XfOrM656(x) SETUP_XfOrM655(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , ((last == (- 1 ) ) || (last == (- 2 ) ) ) ? 3 : 4 , last , indentation , "read: bad character constant #\\%c%c%c" , ch , next , ((last == (- 1 ) ) || (last == (- 2 ) ) ) ? ' ' : last ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    ch = ((ch - '0' ) << 6 ) + ((next - '0' ) << 3 ) + (last - '0' ) ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (ch ) )) RET_VALUE_EMPTY_END ; 
  }
  if (((ch == 'u' ) || (ch == 'U' ) ) && ((next ) >= 0 ) && (((next >= '0' ) && (next <= '9' ) ) || ((next >= 'a' ) && (next <= 'f' ) ) || ((next >= 'A' ) && (next <= 'F' ) ) ) ) {
    int count = 0 , n = 0 , nbuf [10 ] , maxc = ((ch == 'u' ) ? 4 : 8 ) ; 
#   define XfOrM648_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM648(x) SETUP_XfOrM640(x)
    while (count < maxc ) {
#     define XfOrM653_COUNT (0+XfOrM648_COUNT)
#     define SETUP_XfOrM653(x) SETUP_XfOrM648(x)
      ch = FUNCCALL(SETUP_XfOrM653(_), scheme_peekc_special_ok (port ) ); 
      if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#       define XfOrM654_COUNT (0+XfOrM653_COUNT)
#       define SETUP_XfOrM654(x) SETUP_XfOrM653(x)
        nbuf [count ] = ch ; 
        n = n * 16 + (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
        FUNCCALL(SETUP_XfOrM654(_), scheme_getc (port ) ); 
        count ++ ; 
      }
      else break ; 
    }
    if ((n < 0 ) || ((n >= 0xD800 ) && (n <= 0xDFFF ) ) || (n > 0x10FFFF ) ) {
#     define XfOrM650_COUNT (0+XfOrM648_COUNT)
#     define SETUP_XfOrM650(x) SETUP_XfOrM648(x)
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , count + 2 , 0 , indentation , "read: bad character constant #\\%c%u" , (maxc == 4 ) ? 'u' : 'U' , nbuf , count ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else {
      ch = n ; 
    }
  }
  else if ((ch != (- 1 ) ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x80 ) && ((next ) >= 0 ) && (((scheme_uchar_table [(next >> 8 ) & 0x1FFF ] [next & 0xFF ] ) ) & 0x80 ) ) {
    mzchar * buf , * oldbuf , onstack [32 ] ; 
    int i ; 
    long size = 31 , oldsize ; 
    BLOCK_SETUP((PUSH(buf, 0+XfOrM640_COUNT), PUSH(oldbuf, 1+XfOrM640_COUNT)));
#   define XfOrM642_COUNT (2+XfOrM640_COUNT)
#   define SETUP_XfOrM642(x) SETUP(XfOrM642_COUNT)
    buf = NULLED_OUT ; 
    oldbuf = NULLED_OUT ; 
    i = 1 ; 
    buf = onstack ; 
    buf [0 ] = ch ; 
    while ((ch = FUNCCALL(SETUP_XfOrM642(_), scheme_peekc_special_ok (port ) ), ((ch ) >= 0 ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x80 ) ) ) {
#     define XfOrM646_COUNT (0+XfOrM642_COUNT)
#     define SETUP_XfOrM646(x) SETUP_XfOrM642(x)
      FUNCCALL(SETUP_XfOrM646(_), scheme_getc (port ) ); 
      if (i >= size ) {
#       define XfOrM647_COUNT (0+XfOrM646_COUNT)
#       define SETUP_XfOrM647(x) SETUP_XfOrM646(x)
        oldsize = size ; 
        oldbuf = buf ; 
        size *= 2 ; 
        buf = (mzchar * ) FUNCCALL(SETUP_XfOrM647(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
        (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
      }
      buf [i ++ ] = ch ; 
    }
    buf [i ] = '\0' ; 
    switch ((buf [0 ] + scheme_uchar_downs [(scheme_uchar_cases_table [(buf [0 ] >> 8 ) & 0x1FFF ] [buf [0 ] & 0xFF ] ) ] ) ) {
#     define XfOrM643_COUNT (0+XfOrM642_COUNT)
#     define SETUP_XfOrM643(x) SETUP_XfOrM642(x)
      case 'n' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "newline" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\n' ) )) RET_VALUE_EMPTY_END ; 
      if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "null" ) )|| ! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "nul" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\0' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 's' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "space" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (' ' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'r' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "rubout" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (0x7f ) )) RET_VALUE_EMPTY_END ; 
      if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "return" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\r' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'p' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "page" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\f' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 't' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "tab" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\t' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'v' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "vtab" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (0xb ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'b' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "backspace" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\b' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'l' : if (! FUNCCALL(SETUP_XfOrM643(_), u_strcmp (buf , "linefeed" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\n' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      default : break ; 
    }
    (__funcarg128 = FUNCCALL(SETUP_XfOrM642(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg128 , 0 , indentation , "read: bad character constant: #\\%5" , buf ) )) ; 
  }
  if (ch == (- 1 ) ) {
#   define XfOrM641_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM641(x) SETUP_XfOrM640(x)
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , (- 1 ) , indentation , "read: expected a character after #\\" ) ); 
  }
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (ch ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_quote (char * who , Scheme_Object * quote_symbol , int len , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * obj , * ret ; 
  Scheme_Object * __funcarg131 = NULLED_OUT ; 
  long __funcarg130 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(stxsrc, 1), PUSH(indentation, 2), PUSH(port, 3), PUSH(quote_symbol, 4), PUSH(ret, 5), PUSH(who, 6)));
# define XfOrM658_COUNT (7)
# define SETUP_XfOrM658(x) SETUP(XfOrM658_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  obj = NULLED_OUT ; 
  ret = NULLED_OUT ; 
  obj = FUNCCALL(SETUP_XfOrM658(_), read_inner (port , stxsrc , ht , indentation , params , 0 ) ); 
  if ((((obj ) ) == (scheme_eof ) ) )
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , len , (- 1 ) , indentation , "read: expected an element for %s (found end-of-file)" , who ) ); 
  ret = (stxsrc ? FUNCCALL(SETUP_XfOrM658(_), scheme_make_stx_w_offset (quote_symbol , line , col , pos , len , stxsrc , scheme_false ) ): quote_symbol ) ; 
  ret = (__funcarg131 = FUNCCALL(SETUP_XfOrM658(_), scheme_make_pair (obj , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (ret , __funcarg131 ) )) ; 
  if (stxsrc ) {
#   define XfOrM659_COUNT (0+XfOrM658_COUNT)
#   define SETUP_XfOrM659(x) SETUP_XfOrM658(x)
    ret = (__funcarg130 = FUNCCALL(SETUP_XfOrM659(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (ret , line , col , pos , __funcarg130 , stxsrc , scheme_false ) )) ; 
  }
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_box (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * o , * bx ; 
  long __funcarg132 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(bx, 0), PUSH(o, 1), PUSH(stxsrc, 2), PUSH(indentation, 3), PUSH(port, 4)));
# define XfOrM660_COUNT (5)
# define SETUP_XfOrM660(x) SETUP(XfOrM660_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  bx = NULLED_OUT ; 
  o = FUNCCALL(SETUP_XfOrM660(_), read_inner (port , stxsrc , ht , indentation , params , 0 ) ); 
  if ((((o ) ) == (scheme_eof ) ) )
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 2 , (- 1 ) , indentation , "read: expected an element for #& box (found end-of-file)" ) ); 
  bx = FUNCCALL(SETUP_XfOrM660(_), scheme_box (o ) ); 
  if (stxsrc ) {
#   define XfOrM661_COUNT (0+XfOrM660_COUNT)
#   define SETUP_XfOrM661(x) SETUP_XfOrM660(x)
    ((((Scheme_Inclhash_Object * ) (bx ) ) -> so . keyex |= 0x1 ) ) ; 
    bx = (__funcarg132 = FUNCCALL(SETUP_XfOrM661(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (bx , line , col , pos , __funcarg132 , stxsrc , scheme_false ) )) ; 
  }
  RET_VALUE_START (bx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_hash (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int opener , char closer , int kind , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * l ; 
  long __funcarg133 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(stxsrc, 0), PUSH(ht, 1), PUSH(l, 2), PUSH(port, 3)));
# define XfOrM662_COUNT (4)
# define SETUP_XfOrM662(x) SETUP(XfOrM662_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  l = FUNCCALL(SETUP_XfOrM662(_), read_list (port , stxsrc , line , col , pos , opener , closer , 2 , 0 , ht , indentation , params ) ); 
  if (stxsrc ) {
    Scheme_Object * key , * val ; 
    Scheme_Hash_Tree * t ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM662_COUNT), PUSH(key, 1+XfOrM662_COUNT), PUSH(val, 2+XfOrM662_COUNT)));
#   define XfOrM665_COUNT (3+XfOrM662_COUNT)
#   define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    t = NULLED_OUT ; 
    t = FUNCCALL(SETUP_XfOrM665(_), scheme_make_hash_tree (kind ) ); 
    l = FUNCCALL_AGAIN(scheme_syntax_to_datum (l , 0 , ((void * ) 0 ) ) ); 
    for (; ((Scheme_Type ) (((((long ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM667_COUNT (0+XfOrM665_COUNT)
#     define SETUP_XfOrM667(x) SETUP_XfOrM665(x)
      val = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      key = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
      val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . cdr ) ; 
      t = FUNCCALL(SETUP_XfOrM667(_), scheme_hash_tree_set (t , key , val ) ); 
    }
    RET_VALUE_START ((__funcarg133 = FUNCCALL(SETUP_XfOrM665(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_make_stx_w_offset ((Scheme_Object * ) t , line , col , pos , __funcarg133 , stxsrc , scheme_false ) )) ) RET_VALUE_END ; 
  }
  else {
    Scheme_Object * ph ; 
    BLOCK_SETUP((PUSH(ph, 0+XfOrM662_COUNT)));
#   define XfOrM663_COUNT (1+XfOrM662_COUNT)
#   define SETUP_XfOrM663(x) SETUP(XfOrM663_COUNT)
    ph = NULLED_OUT ; 
    ph = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM663(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    ph -> type = scheme_table_placeholder_type ; 
    (((Scheme_Simple_Object * ) (ph ) ) -> u . ptr_int_val . ptr ) = l ; 
    (((Scheme_Simple_Object * ) (ph ) ) -> u . ptr_int_val . pint ) = kind ; 
    if (! * ht ) {
      Scheme_Hash_Table * tht ; 
      BLOCK_SETUP((PUSH(tht, 0+XfOrM663_COUNT)));
#     define XfOrM664_COUNT (1+XfOrM663_COUNT)
#     define SETUP_XfOrM664(x) SETUP(XfOrM664_COUNT)
      tht = NULLED_OUT ; 
      tht = FUNCCALL(SETUP_XfOrM664(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      * ht = tht ; 
    }
    RET_VALUE_START (ph ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int skip_whitespace_comments (Scheme_Object * port , Scheme_Object * stxsrc , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  int ch ; 
  int blockc_1 , blockc_2 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(params, 0), PUSH(stxsrc, 1), PUSH(indentation, 2), PUSH(ht, 3), PUSH(port, 4)));
# define XfOrM668_COUNT (5)
# define SETUP_XfOrM668(x) SETUP(XfOrM668_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (params -> honu_mode ) {
    blockc_1 = '/' ; 
    blockc_2 = '*' ; 
  }
  else {
    blockc_1 = '#' ; 
    blockc_2 = '|' ; 
  }
  start_over : if (params -> table ) {
#   define XfOrM684_COUNT (0+XfOrM668_COUNT)
#   define SETUP_XfOrM684(x) SETUP_XfOrM668(x)
    while ((ch = FUNCCALL(SETUP_XfOrM684(_), scheme_getc_special_ok (port ) ), ((ch ) >= 0 ) ) ) {
#     define XfOrM686_COUNT (0+XfOrM684_COUNT)
#     define SETUP_XfOrM686(x) SETUP_XfOrM684(x)
      if (! (FUNCCALL(SETUP_XfOrM686(_), readtable_kind (params -> table , ch , params ) )& 0x1 ) )
        break ; 
    }
    RET_VALUE_START (ch ) RET_VALUE_END ; 
  }
  else {
#   define XfOrM681_COUNT (0+XfOrM668_COUNT)
#   define SETUP_XfOrM681(x) SETUP_XfOrM668(x)
    while ((ch = FUNCCALL(SETUP_XfOrM681(_), scheme_getc_special_ok (port ) ), ((ch ) >= 0 ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) ) ) {
    }
  }
  if ((! params -> honu_mode && (ch == ';' ) ) || (params -> honu_mode && (ch == '/' ) && (FUNCCALL(SETUP_XfOrM668(_), scheme_peekc_special_ok (port ) )== '/' ) ) ) {
#   define XfOrM678_COUNT (0+XfOrM668_COUNT)
#   define SETUP_XfOrM678(x) SETUP_XfOrM668(x)
    do {
#     define XfOrM680_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM680(x) SETUP_XfOrM678(x)
      ch = FUNCCALL(SETUP_XfOrM680(_), scheme_getc_special_ok (port ) ); 
      if (ch == (- 2 ) )
        FUNCCALL(SETUP_XfOrM680(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
    }
    while (! ((ch == '\n' ) || (ch == '\r' ) || (ch == 0x85 ) || (ch == 0x2028 ) || (ch == 0x2029 ) ) && ch != (- 1 ) ) ; 
    goto start_over ; 
  }
  if (ch == blockc_1 && (FUNCCALL(SETUP_XfOrM668(_), scheme_peekc_special_ok (port ) )== blockc_2 ) ) {
    int depth = 0 ; 
    int ch2 = 0 ; 
    long col , pos , line ; 
#   define XfOrM671_COUNT (0+XfOrM668_COUNT)
#   define SETUP_XfOrM671(x) SETUP_XfOrM668(x)
    FUNCCALL(SETUP_XfOrM671(_), scheme_tell_all (port , & line , & col , & pos ) ); 
    (void ) FUNCCALL(SETUP_XfOrM671(_), scheme_getc (port ) ); 
    do {
#     define XfOrM675_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM675(x) SETUP_XfOrM671(x)
      ch = FUNCCALL(SETUP_XfOrM675(_), scheme_getc_special_ok (port ) ); 
      if (ch == (- 1 ) )
        FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (2 ) , (- 1 ) , indentation , "read: end of file in #| comment" ) ); 
      else if (ch == (- 2 ) )
        FUNCCALL(SETUP_XfOrM675(_), scheme_get_ready_read_special (port , stxsrc , ht ) ); 
      if ((ch2 == blockc_2 ) && (ch == blockc_1 ) ) {
        if (! (depth -- ) )
          goto start_over ; 
        ch = 0 ; 
      }
      else if ((ch2 == blockc_1 ) && (ch == blockc_2 ) ) {
        depth ++ ; 
        ch = 0 ; 
      }
      ch2 = ch ; 
    }
    while (1 ) ; 
    goto start_over ; 
  }
  if (ch == '#' && (FUNCCALL(SETUP_XfOrM668(_), scheme_peekc_special_ok (port ) )== ';' ) ) {
    Scheme_Object * skipped ; 
    long col , pos , line ; 
    BLOCK_SETUP((PUSH(skipped, 0+XfOrM668_COUNT)));
#   define XfOrM669_COUNT (1+XfOrM668_COUNT)
#   define SETUP_XfOrM669(x) SETUP(XfOrM669_COUNT)
    skipped = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM669(_), scheme_tell_all (port , & line , & col , & pos ) ); 
    FUNCCALL_AGAIN(track_indentation (indentation , line , col ) ); 
    (void ) FUNCCALL(SETUP_XfOrM669(_), scheme_getc (port ) ); 
    skipped = FUNCCALL(SETUP_XfOrM669(_), read_inner (port , stxsrc , ht , indentation , params , 0 ) ); 
    if ((((skipped ) ) == (scheme_eof ) ) )
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , (2 ) , (- 1 ) , indentation , "read: expected a commented-out element for `#;' (found end-of-file)" ) ); 
    if (* ht ) {
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM669_COUNT)));
#     define XfOrM670_COUNT (1+XfOrM669_COUNT)
#     define SETUP_XfOrM670(x) SETUP(XfOrM670_COUNT)
      v = NULLED_OUT ; 
      v = FUNCCALL(SETUP_XfOrM670(_), scheme_hash_get (* ht , unresolved_uninterned_symbol ) ); 
      if (! v )
        v = scheme_null ; 
      v = FUNCCALL(SETUP_XfOrM670(_), scheme_make_pair (skipped , v ) ); 
      FUNCCALL_AGAIN(scheme_hash_set (* ht , unresolved_uninterned_symbol , v ) ); 
    }
    goto start_over ; 
  }
  RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void unexpected_closer (int ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Object * indentation , ReadParams * params ) {
  char * suggestion = "" , * found = "unexpected" ; 
  const char * __funcarg138 = NULLED_OUT ; 
  const char * __funcarg137 = NULLED_OUT ; 
  const char * __funcarg136 = NULLED_OUT ; 
  const char * __funcarg135 = NULLED_OUT ; 
  const char * __funcarg134 = NULLED_OUT ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(params, 0), PUSH(stxsrc, 1), PUSH(indentation, 2), PUSH(__funcarg137, 3), PUSH(suggestion, 4), PUSH(found, 5), PUSH(__funcarg135, 6), PUSH(port, 7)));
# define XfOrM689_COUNT (8)
# define SETUP_XfOrM689(x) SETUP(XfOrM689_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  if (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    Scheme_Indent * indt ; 
    int opener ; 
    char * missing ; 
    BLOCK_SETUP((PUSH(indt, 0+XfOrM689_COUNT), PUSH(missing, 1+XfOrM689_COUNT)));
#   define XfOrM690_COUNT (2+XfOrM689_COUNT)
#   define SETUP_XfOrM690(x) SETUP(XfOrM690_COUNT)
    indt = NULLED_OUT ; 
    missing = NULLED_OUT ; 
    indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
    found = FUNCCALL(SETUP_XfOrM690(_), GC_malloc_atomic (100 ) ); 
    if (indt -> closer == '}' )
      opener = '{' ; 
    else if (indt -> closer == ']' )
      opener = '[' ; 
    else opener = '(' ; 
    {
      Scheme_Object * l ; 
      Scheme_Indent * indt2 ; 
      l = NULLED_OUT ; 
      indt2 = NULLED_OUT ; 
      missing = "expected" ; 
      for (l = (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . cdr ) ; ((Scheme_Type ) (((((long ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
        indt2 = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        if (indt2 -> closer == ch ) {
          missing = "missing" ; 
        }
      }
    }
    if (ch == indt -> closer ) {
#     define XfOrM694_COUNT (0+XfOrM690_COUNT)
#     define SETUP_XfOrM694(x) SETUP_XfOrM690(x)
      (sprintf (found , "unexpected" ) ) ; 
    }
    else if (indt -> multiline ) {
#     define XfOrM693_COUNT (0+XfOrM690_COUNT)
#     define SETUP_XfOrM693(x) SETUP_XfOrM690(x)
      (__funcarg137 = FUNCCALL(SETUP_XfOrM693(_), closer_name (params , indt -> closer ) ), __funcarg138 = FUNCCALL(SETUP_XfOrM693(_), opener_name (params , opener ) ), (sprintf (found , "%s %s to close %s on line %ld, found instead" , missing , __funcarg137 , __funcarg138 , indt -> start_line ) ) ) ; 
    }
    else {
#     define XfOrM692_COUNT (0+XfOrM690_COUNT)
#     define SETUP_XfOrM692(x) SETUP_XfOrM690(x)
      (__funcarg135 = FUNCCALL(SETUP_XfOrM692(_), closer_name (params , indt -> closer ) ), __funcarg136 = FUNCCALL(SETUP_XfOrM692(_), opener_name (params , opener ) ), (sprintf (found , "%s %s to close preceding %s, found instead" , missing , __funcarg135 , __funcarg136 ) ) ) ; 
    }
    if (indt -> suspicious_line ) {
#     define XfOrM691_COUNT (0+XfOrM690_COUNT)
#     define SETUP_XfOrM691(x) SETUP_XfOrM690(x)
      suggestion = FUNCCALL(SETUP_XfOrM691(_), GC_malloc_atomic (100 ) ); 
      (__funcarg134 = FUNCCALL(SETUP_XfOrM691(_), closer_name (params , indt -> suspicious_closer ) ), (sprintf (suggestion , "; indentation suggests a missing %s before line %ld" , __funcarg134 , indt -> suspicious_line ) ) ) ; 
    }
  }
  FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , indentation , "read: %s `%c'%s" , found , ch , suggestion ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void pop_indentation (Scheme_Object * indentation ) {
  /* No conversion */
  if (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    Scheme_Indent * indt ; 
    indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
    indentation = (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . cdr ) ; 
    if (((Scheme_Type ) (((((long ) (indentation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (indentation ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      Scheme_Indent * old_indt ; 
      old_indt = (Scheme_Indent * ) (((Scheme_Simple_Object * ) (indentation ) ) -> u . pair_val . car ) ; 
      if (! old_indt -> suspicious_line ) {
        if (indt -> suspicious_line ) {
          old_indt -> suspicious_line = indt -> suspicious_line ; 
          old_indt -> suspicious_closer = indt -> suspicious_closer ; 
        }
      }
      if (! old_indt -> suspicious_quote ) {
        if (indt -> suspicious_quote ) {
          old_indt -> suspicious_quote = indt -> suspicious_quote ; 
          old_indt -> quote_for_char = indt -> quote_for_char ; 
        }
      }
    }
  }
}
typedef struct Scheme_Load_Delay {
  Scheme_Type type ; 
  Scheme_Object * path ; 
  long file_offset , size ; 
  unsigned long symtab_size ; 
  Scheme_Object * * symtab ; 
  long * shared_offsets ; 
  Scheme_Object * insp ; 
  Scheme_Object * relto ; 
  Scheme_Unmarshal_Tables * ut ; 
  struct CPort * current_rp ; 
  int perma_cache ; 
  unsigned char * cached ; 
  Scheme_Object * cached_port ; 
  struct Scheme_Load_Delay * clear_bytes_prev , * clear_bytes_next ; 
}
Scheme_Load_Delay ; 
typedef struct CPort {
  Scheme_Type type ; 
  unsigned long pos , size ; 
  unsigned char * start ; 
  unsigned long symtab_size ; 
  long base ; 
  Scheme_Object * orig_port ; 
  Scheme_Hash_Table * * ht ; 
  Scheme_Unmarshal_Tables * ut ; 
  Scheme_Object * * symtab ; 
  Scheme_Object * insp ; 
  Scheme_Object * magic_sym , * magic_val ; 
  Scheme_Object * relto ; 
  long * shared_offsets ; 
  Scheme_Load_Delay * delay_info ; 
}
CPort ; 
static Scheme_Object * read_marshalled (int type , CPort * port ) ; 
static Scheme_Object * read_compact_list (int c , int proper , int use_stack , CPort * port ) ; 
static Scheme_Object * read_compact_quote (CPort * port , int embedded ) ; 
void scheme_ill_formed (struct CPort * port , const char * file , int line ) {
  /* No conversion */
  scheme_read_err (port ? port -> orig_port : ((void * ) 0 ) , ((void * ) 0 ) , - 1 , - 1 , port ? (port -> pos + port -> base ) : 0 , - 1 , 0 , ((void * ) 0 ) , "read (compiled): ill-formed code" " [%s:%d]" , file , line ) ; 
}
__xform_nongcing__ static long read_compact_number (CPort * port ) {
  /* No conversion */
  long flag , v , a , b , c , d ; 
  if (! (port -> pos < port -> size ) )
    return 0 ; 
  ; 
  flag = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  if (flag < 128 )
    return flag ; 
  else if (! (flag & 0x40 ) ) {
    if (! (port -> pos < port -> size ) )
      return 0 ; 
    ; 
    a = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
    v = (flag & 0x3F ) + (a << 6 ) ; 
    return v ; 
  }
  else if (! (flag & 0x20 ) ) {
    return - (flag & 0x1F ) ; 
  }
  if (! (port -> pos + 3 < port -> size ) )
    return 0 ; 
  ; 
  a = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  b = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  c = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  d = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  v = a + (b << 8 ) + (c << 16 ) + (d << 24 ) ; 
  if (flag & 0x10 )
    return v ; 
  else return - v ; 
}
static char * read_compact_chars (CPort * port , char * buffer , int bsize , int l ) {
  char * s ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(port, 1)));
# define XfOrM711_COUNT (2)
# define SETUP_XfOrM711(x) SETUP(XfOrM711_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  if (l < bsize )
    s = buffer ; 
  else s = (char * ) FUNCCALL(SETUP_XfOrM711(_), GC_malloc_atomic (l + 1 ) ); 
  (memcpy (s , port -> start + port -> pos , l ) ) ; 
  port -> pos += l ; 
  s [l ] = 0 ; 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_compact_svector (CPort * port , int l ) {
  Scheme_Object * o ; 
  mzshort * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(o, 1), PUSH(port, 2)));
# define XfOrM712_COUNT (3)
# define SETUP_XfOrM712(x) SETUP(XfOrM712_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  v = NULLED_OUT ; 
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM712(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_svector_type ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . len ) = l ; 
  if (l )
    v = ((mzshort * ) FUNCCALL(SETUP_XfOrM712(_), GC_malloc_atomic (sizeof (mzshort ) * (l ) ) )) ; 
  else v = ((void * ) 0 ) ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) = v ; 
  while (l -- ) {
    mzshort cn ; 
#   define XfOrM714_COUNT (0+XfOrM712_COUNT)
#   define SETUP_XfOrM714(x) SETUP_XfOrM712(x)
    cn = (read_compact_number (port ) ) ; 
    v [l ] = cn ; 
  }
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int cpt_branch [256 ] ; 
static Scheme_Object * read_compact (CPort * port , int use_stack ) ; 
static Scheme_Object * read_compact_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  CPort * port = (CPort * ) p -> ku . k . p1 ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  return read_compact (port , p -> ku . k . i1 ) ; 
}
/* this far 4503 */
/* this far 4503 */
static Scheme_Object * read_compact (CPort * port , int use_stack ) {
  unsigned int l ; 
  char * s , buffer [32 ] ; 
  int ch ; 
  int need_car = 0 , proper = 0 ; 
  Scheme_Object * v , * first = ((void * ) 0 ) , * last = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg147 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg146 = NULLED_OUT ; 
  long __funcarg145 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(s, 1), PUSH(first, 2), PUSH(__funcarg146, 3), PUSH(last, 4), PUSH(port, 5)));
# define XfOrM716_COUNT (6)
# define SETUP_XfOrM716(x) SETUP(XfOrM716_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  v = NULLED_OUT ; 
  {
    unsigned long _stk_pos ; 
#   define XfOrM843_COUNT (0+XfOrM716_COUNT)
#   define SETUP_XfOrM843(x) SETUP_XfOrM716(x)
    _stk_pos = (unsigned long ) & _stk_pos ; 
    if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
      Scheme_Thread * p = scheme_current_thread ; 
#     define XfOrM844_COUNT (0+XfOrM843_COUNT)
#     define SETUP_XfOrM844(x) SETUP_XfOrM843(x)
      p -> ku . k . p1 = (void * ) port ; 
      p -> ku . k . i1 = use_stack ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (read_compact_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }
  while (1 ) {
#   define XfOrM780_COUNT (0+XfOrM716_COUNT)
#   define SETUP_XfOrM780(x) SETUP_XfOrM716(x)
    if (! (port -> pos < port -> size ) )
      FUNCCALL(SETUP_XfOrM780(_), scheme_ill_formed (port , "./../src/read.c" , 4396 ) ); 
    ; 
    ch = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
    switch (cpt_branch [ch ] ) {
#     define XfOrM783_COUNT (0+XfOrM780_COUNT)
#     define SETUP_XfOrM783(x) SETUP_XfOrM780(x)
      case CPT_ESCAPE : {
        int len ; 
        Scheme_Object * ep ; 
        char * s ; 
        ReadParams params ; 
        BLOCK_SETUP((PUSH(params.table, 0+XfOrM783_COUNT), PUSH(params.magic_sym, 1+XfOrM783_COUNT), PUSH(params.magic_val, 2+XfOrM783_COUNT), PUSH(params.delay_load_info, 3+XfOrM783_COUNT), PUSH(ep, 4+XfOrM783_COUNT), PUSH(s, 5+XfOrM783_COUNT)));
#       define XfOrM842_COUNT (6+XfOrM783_COUNT)
#       define SETUP_XfOrM842(x) SETUP(XfOrM842_COUNT)
        ep = NULLED_OUT ; 
        s = NULLED_OUT ; 
        params.table = NULLED_OUT ; 
        params.magic_sym = NULLED_OUT ; 
        params.magic_val = NULLED_OUT ; 
        params.delay_load_info = NULLED_OUT ; 
        len = (read_compact_number (port ) ) ; 
        if (! ((unsigned ) len <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM842(_), scheme_ill_formed (port , "./../src/read.c" , 4409 ) ); 
        ; 
        s = FUNCCALL(SETUP_XfOrM842(_), read_compact_chars (port , buffer , 32 , len ) ); 
        if (s != buffer )
          len = - len ; 
        ep = FUNCCALL(SETUP_XfOrM842(_), scheme_make_sized_byte_string_input_port (s , len ) ); 
        params . can_read_compiled = 1 ; 
        params . can_read_pipe_quote = 1 ; 
        params . can_read_box = 1 ; 
        params . can_read_graph = 1 ; 
        params . case_sensitive = scheme_case_sensitive ; 
        params . square_brackets_are_parens = 1 ; 
        params . curly_braces_are_parens = 1 ; 
        params . read_decimal_inexact = 1 ; 
        params . can_read_dot = 1 ; 
        params . can_read_infix_dot = 1 ; 
        params . can_read_quasi = 1 ; 
        params . honu_mode = 0 ; 
        params . skip_zo_vers_check = 0 ; 
        params . table = ((void * ) 0 ) ; 
        v = FUNCCALL(SETUP_XfOrM842(_), read_inner (ep , ((void * ) 0 ) , port -> ht , scheme_null , & params , 0 ) ); 
      }
      break ; 
      case CPT_SYMBOL : l = (read_compact_number (port ) ) ; 
      if (! (l <= port -> size - port -> pos ) )
        FUNCCALL(SETUP_XfOrM783(_), scheme_ill_formed (port , "./../src/read.c" , 4444 ) ); 
      ; 
      s = FUNCCALL(SETUP_XfOrM783(_), read_compact_chars (port , buffer , 32 , l ) ); 
      v = FUNCCALL_AGAIN(scheme_intern_exact_symbol (s , l ) ); 
      if (((v ) == (port -> magic_sym ) ) )
        v = port -> magic_val ; 
      break ; 
      case CPT_SYMREF : l = (read_compact_number (port ) ) ; 
      if (! (l < port -> symtab_size ) )
        FUNCCALL(SETUP_XfOrM783(_), scheme_ill_formed (port , "./../src/read.c" , 4453 ) ); 
      ; 
      v = port -> symtab [l ] ; 
      if (! v ) {
        long save_pos = port -> pos ; 
#       define XfOrM841_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM841(x) SETUP_XfOrM783(x)
        port -> pos = port -> shared_offsets [l - 1 ] ; 
        v = FUNCCALL(SETUP_XfOrM841(_), read_compact (port , 0 ) ); 
        port -> pos = save_pos ; 
        port -> symtab [l ] = v ; 
      }
      break ; 
      case CPT_WEIRD_SYMBOL : {
        int uninterned ; 
#       define XfOrM840_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM840(x) SETUP_XfOrM783(x)
        uninterned = (read_compact_number (port ) ) ; 
        l = (read_compact_number (port ) ) ; 
        if (! (l <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM840(_), scheme_ill_formed (port , "./../src/read.c" , 4470 ) ); 
        ; 
        s = FUNCCALL(SETUP_XfOrM840(_), read_compact_chars (port , buffer , 32 , l ) ); 
        if (uninterned )
          v = FUNCCALL(SETUP_XfOrM840(_), scheme_make_exact_symbol (s , l ) ); 
        else v = FUNCCALL(SETUP_XfOrM840(_), scheme_intern_exact_parallel_symbol (s , l ) ); 
      }
      break ; 
      case CPT_KEYWORD : l = (read_compact_number (port ) ) ; 
      if (! (l <= port -> size - port -> pos ) )
        FUNCCALL(SETUP_XfOrM783(_), scheme_ill_formed (port , "./../src/read.c" , 4485 ) ); 
      ; 
      s = FUNCCALL(SETUP_XfOrM783(_), read_compact_chars (port , buffer , 32 , l ) ); 
      v = FUNCCALL_AGAIN(scheme_intern_exact_keyword (s , l ) ); 
      break ; 
      case CPT_BYTE_STRING : l = (read_compact_number (port ) ) ; 
      if (! (l <= port -> size - port -> pos ) )
        FUNCCALL(SETUP_XfOrM783(_), scheme_ill_formed (port , "./../src/read.c" , 4491 ) ); 
      ; 
      s = FUNCCALL(SETUP_XfOrM783(_), read_compact_chars (port , buffer , 32 , l ) ); 
      v = FUNCCALL_AGAIN(scheme_make_immutable_sized_byte_string (s , l , l < 32 ) ); 
      break ; 
      case CPT_CHAR_STRING : {
        unsigned int el ; 
        mzchar * us ; 
        BLOCK_SETUP((PUSH(us, 0+XfOrM783_COUNT)));
#       define XfOrM839_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM839(x) SETUP(XfOrM839_COUNT)
        us = NULLED_OUT ; 
        el = (read_compact_number (port ) ) ; 
        l = (read_compact_number (port ) ) ; 
        if (! (el <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM839(_), scheme_ill_formed (port , "./../src/read.c" , 4501 ) ); 
        ; 
        s = FUNCCALL(SETUP_XfOrM839(_), read_compact_chars (port , buffer , 32 , el ) ); 
        us = (mzchar * ) FUNCCALL(SETUP_XfOrM839(_), GC_malloc_atomic ((l + 1 ) * sizeof (mzchar ) ) ); 
        FUNCCALL(SETUP_XfOrM839(_), scheme_utf8_decode_all ((const unsigned char * ) s , el , us , 0 ) ); 
        us [l ] = 0 ; 
        v = FUNCCALL(SETUP_XfOrM839(_), scheme_make_immutable_sized_char_string (us , l , 0 ) ); 
      }
      break ; 
      case CPT_CHAR : l = (read_compact_number (port ) ) ; 
      v = ((((mzchar ) l ) < 256 ) ? scheme_char_constants [(unsigned char ) (l ) ] : FUNCCALL(SETUP_XfOrM783(_), scheme_make_char (l ) )) ; 
      break ; 
      case CPT_INT : v = ((Scheme_Object * ) (void * ) (long ) ((((long ) ((read_compact_number (port ) ) ) ) << 1 ) | 0x1 ) ) ; 
      break ; 
      case CPT_NULL : v = scheme_null ; 
      break ; 
      case CPT_TRUE : v = scheme_true ; 
      break ; 
      case CPT_FALSE : v = scheme_false ; 
      break ; 
      case CPT_VOID : v = scheme_void ; 
      break ; 
      case CPT_BOX : v = (__funcarg150 = FUNCCALL(SETUP_XfOrM783(_), read_compact (port , 0 ) ), FUNCCALL_AGAIN(scheme_box (__funcarg150 ) )) ; 
      ((((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex |= 0x1 ) ) ; 
      break ; 
      case CPT_PAIR : if (need_car ) {
        Scheme_Object * car , * cdr ; 
        BLOCK_SETUP((PUSH(car, 0+XfOrM783_COUNT), PUSH(cdr, 1+XfOrM783_COUNT)));
#       define XfOrM838_COUNT (2+XfOrM783_COUNT)
#       define SETUP_XfOrM838(x) SETUP(XfOrM838_COUNT)
        car = NULLED_OUT ; 
        cdr = NULLED_OUT ; 
        car = FUNCCALL(SETUP_XfOrM838(_), read_compact (port , 0 ) ); 
        cdr = FUNCCALL_AGAIN(read_compact (port , 0 ) ); 
        v = FUNCCALL_AGAIN(scheme_make_pair (car , cdr ) ); 
      }
      else {
        need_car = 1 ; 
        continue ; 
      }
      break ; 
      case CPT_LIST : l = (read_compact_number (port ) ) ; 
      if (need_car ) {
#       define XfOrM835_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM835(x) SETUP_XfOrM783(x)
        if (l == 1 ) {
          Scheme_Object * car , * cdr ; 
          BLOCK_SETUP((PUSH(car, 0+XfOrM835_COUNT), PUSH(cdr, 1+XfOrM835_COUNT)));
#         define XfOrM836_COUNT (2+XfOrM835_COUNT)
#         define SETUP_XfOrM836(x) SETUP(XfOrM836_COUNT)
          car = NULLED_OUT ; 
          cdr = NULLED_OUT ; 
          car = FUNCCALL(SETUP_XfOrM836(_), read_compact (port , 0 ) ); 
          cdr = FUNCCALL_AGAIN(read_compact (port , 0 ) ); 
          v = FUNCCALL_AGAIN(scheme_make_pair (car , cdr ) ); 
        }
        else v = FUNCCALL(SETUP_XfOrM835(_), read_compact_list (l , 0 , 0 , port ) ); 
      }
      else {
        need_car = l ; 
        continue ; 
      }
      break ; 
      case CPT_VECTOR : {
        Scheme_Object * vec ; 
        unsigned int i ; 
        BLOCK_SETUP((PUSH(vec, 0+XfOrM783_COUNT)));
#       define XfOrM831_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM831(x) SETUP(XfOrM831_COUNT)
        vec = NULLED_OUT ; 
        l = (read_compact_number (port ) ) ; 
        vec = FUNCCALL(SETUP_XfOrM831(_), scheme_make_vector (l , ((void * ) 0 ) ) ); 
        for (i = 0 ; i < l ; i ++ ) {
          Scheme_Object * cv ; 
          BLOCK_SETUP((PUSH(cv, 0+XfOrM831_COUNT)));
#         define XfOrM833_COUNT (1+XfOrM831_COUNT)
#         define SETUP_XfOrM833(x) SETUP(XfOrM833_COUNT)
          cv = NULLED_OUT ; 
          cv = FUNCCALL(SETUP_XfOrM833(_), read_compact (port , 0 ) ); 
          (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = cv ; 
        }
        ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 
        v = vec ; 
      }
      break ; 
      case CPT_HASH_TABLE : {
        Scheme_Object * l ; 
        int kind , len ; 
        BLOCK_SETUP((PUSH(l, 0+XfOrM783_COUNT)));
#       define XfOrM827_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM827(x) SETUP(XfOrM827_COUNT)
        l = NULLED_OUT ; 
        kind = (read_compact_number (port ) ) ; 
        len = (read_compact_number (port ) ) ; 
        l = scheme_null ; 
        while (len -- ) {
          Scheme_Object * k , * v ; 
          BLOCK_SETUP((PUSH(k, 0+XfOrM827_COUNT), PUSH(v, 1+XfOrM827_COUNT)));
#         define XfOrM830_COUNT (2+XfOrM827_COUNT)
#         define SETUP_XfOrM830(x) SETUP(XfOrM830_COUNT)
          k = NULLED_OUT ; 
          v = NULLED_OUT ; 
          k = FUNCCALL(SETUP_XfOrM830(_), read_compact (port , 0 ) ); 
          v = FUNCCALL_AGAIN(read_compact (port , 0 ) ); 
          l = (__funcarg149 = FUNCCALL(SETUP_XfOrM830(_), scheme_make_pair (k , v ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg149 , l ) )) ; 
        }
        if (! (* port -> ht ) ) {
          Scheme_Hash_Table * tht ; 
          BLOCK_SETUP((PUSH(tht, 0+XfOrM827_COUNT)));
#         define XfOrM828_COUNT (1+XfOrM827_COUNT)
#         define SETUP_XfOrM828(x) SETUP(XfOrM828_COUNT)
          tht = NULLED_OUT ; 
          tht = FUNCCALL(SETUP_XfOrM828(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          * (port -> ht ) = tht ; 
        }
        v = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM827(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        v -> type = scheme_table_placeholder_type ; 
        (((Scheme_Simple_Object * ) (v ) ) -> u . ptr_int_val . pint ) = kind ; 
        (((Scheme_Simple_Object * ) (v ) ) -> u . ptr_int_val . ptr ) = l ; 
      }
      break ; 
      case CPT_STX : case CPT_GSTX : {
#       define XfOrM824_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM824(x) SETUP_XfOrM783(x)
        if (! port -> ut ) {
          Scheme_Unmarshal_Tables * ut ; 
          Scheme_Hash_Table * rht ; 
          char * decoded ; 
          BLOCK_SETUP((PUSH(rht, 0+XfOrM824_COUNT), PUSH(ut, 1+XfOrM824_COUNT), PUSH(decoded, 2+XfOrM824_COUNT)));
#         define XfOrM826_COUNT (3+XfOrM824_COUNT)
#         define SETUP_XfOrM826(x) SETUP(XfOrM826_COUNT)
          ut = NULLED_OUT ; 
          rht = NULLED_OUT ; 
          decoded = NULLED_OUT ; 
          ut = ((Scheme_Unmarshal_Tables * ) FUNCCALL(SETUP_XfOrM826(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Unmarshal_Tables ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          ut -> type = scheme_rt_unmarshal_info ; 
          port -> ut = ut ; 
          ut -> rp = port ; 
          if (port -> delay_info )
            port -> delay_info -> ut = ut ; 
          decoded = (char * ) FUNCCALL(SETUP_XfOrM826(_), GC_malloc_atomic (port -> symtab_size ) ); 
          (memset (decoded , 0 , port -> symtab_size ) ) ; 
          ut -> decoded = decoded ; 
          rht = FUNCCALL(SETUP_XfOrM826(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          port -> ut -> rns = rht ; 
        }
        if (* port -> ht )
          FUNCCALL(SETUP_XfOrM824(_), scheme_ill_formed (port , "./../src/read.c" , 4633 ) ); 
        v = FUNCCALL(SETUP_XfOrM824(_), read_compact (port , 1 ) ); 
        if (* port -> ht ) {
#         define XfOrM825_COUNT (0+XfOrM824_COUNT)
#         define SETUP_XfOrM825(x) SETUP_XfOrM824(x)
          * port -> ht = ((void * ) 0 ) ; 
          v = (__funcarg146 = FUNCCALL(SETUP_XfOrM825(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), __funcarg147 = FUNCCALL(SETUP_XfOrM825(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), FUNCCALL_AGAIN(resolve_references (v , port -> orig_port , ((void * ) 0 ) , __funcarg146 , __funcarg147 , 0 , 0 ) )) ; 
        }
        v = FUNCCALL(SETUP_XfOrM824(_), scheme_unmarshal_datum_to_syntax (v , port -> ut , ch == CPT_GSTX ) ); 
        scheme_num_read_syntax_objects ++ ; 
        if (! v )
          FUNCCALL(SETUP_XfOrM824(_), scheme_ill_formed (port , "./../src/read.c" , 4648 ) ); 
      }
      break ; 
      case CPT_MARSHALLED : v = (__funcarg145 = (read_compact_number (port ) ) , FUNCCALL(SETUP_XfOrM783(_), read_marshalled (__funcarg145 , port ) )) ; 
      break ; 
      case CPT_QUOTE : v = FUNCCALL(SETUP_XfOrM783(_), read_compact_quote (port , 1 ) ); 
      break ; 
      case CPT_REFERENCE : l = (read_compact_number (port ) ) ; 
      if (! (l < 936 ) )
        FUNCCALL(SETUP_XfOrM783(_), scheme_ill_formed (port , "./../src/read.c" , 4659 ) ); 
      ; 
      v = variable_references [l ] ; 
      break ; 
      case CPT_LOCAL : {
        int p , flags ; 
#       define XfOrM822_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM822(x) SETUP_XfOrM783(x)
        p = (read_compact_number (port ) ) ; 
        if (p < 0 ) {
#         define XfOrM823_COUNT (0+XfOrM822_COUNT)
#         define SETUP_XfOrM823(x) SETUP_XfOrM822(x)
          p = - (p + 1 ) ; 
          flags = (read_compact_number (port ) ) ; 
        }
        else flags = 0 ; 
        v = FUNCCALL(SETUP_XfOrM822(_), scheme_make_local (scheme_local_type , p , flags ) ); 
      }
      break ; 
      case CPT_LOCAL_UNBOX : {
        int p , flags ; 
#       define XfOrM820_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM820(x) SETUP_XfOrM783(x)
        p = (read_compact_number (port ) ) ; 
        if (p < 0 ) {
#         define XfOrM821_COUNT (0+XfOrM820_COUNT)
#         define SETUP_XfOrM821(x) SETUP_XfOrM820(x)
          p = - (p + 1 ) ; 
          flags = (read_compact_number (port ) ) ; 
        }
        else flags = 0 ; 
        v = FUNCCALL(SETUP_XfOrM820(_), scheme_make_local (scheme_local_unbox_type , p , flags ) ); 
      }
      break ; 
      case CPT_SVECTOR : {
        int l ; 
#       define XfOrM819_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM819(x) SETUP_XfOrM783(x)
        l = (read_compact_number (port ) ) ; 
        v = FUNCCALL(SETUP_XfOrM819(_), read_compact_svector (port , l ) ); 
      }
      break ; 
      case CPT_APPLICATION : {
        int c , i ; 
        Scheme_App_Rec * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM783_COUNT)));
#       define XfOrM816_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM816(x) SETUP(XfOrM816_COUNT)
        a = NULLED_OUT ; 
        c = (read_compact_number (port ) ) + 1 ; 
        a = FUNCCALL(SETUP_XfOrM816(_), scheme_malloc_application (c ) ); 
        for (i = 0 ; i < c ; i ++ ) {
#         define XfOrM818_COUNT (0+XfOrM816_COUNT)
#         define SETUP_XfOrM818(x) SETUP_XfOrM816(x)
          v = FUNCCALL(SETUP_XfOrM818(_), read_compact (port , 1 ) ); 
          a -> args [i ] = v ; 
        }
        FUNCCALL(SETUP_XfOrM816(_), scheme_finish_application (a ) ); 
        v = (Scheme_Object * ) a ; 
      }
      break ; 
      case CPT_LET_ONE : {
        Scheme_Let_One * lo ; 
        int et ; 
        BLOCK_SETUP((PUSH(lo, 0+XfOrM783_COUNT)));
#       define XfOrM815_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM815(x) SETUP(XfOrM815_COUNT)
        lo = NULLED_OUT ; 
        lo = (Scheme_Let_One * ) FUNCCALL(SETUP_XfOrM815(_), GC_malloc_one_tagged (sizeof (Scheme_Let_One ) ) ); 
        lo -> iso . so . type = scheme_let_one_type ; 
        v = FUNCCALL(SETUP_XfOrM815(_), read_compact (port , 1 ) ); 
        lo -> value = v ; 
        v = FUNCCALL(SETUP_XfOrM815(_), read_compact (port , 1 ) ); 
        lo -> body = v ; 
        et = FUNCCALL(SETUP_XfOrM815(_), scheme_get_eval_type (lo -> value ) ); 
        (& lo -> iso ) -> so . keyex = et ; 
        v = (Scheme_Object * ) lo ; 
      }
      break ; 
      case CPT_BRANCH : {
        Scheme_Object * test , * tbranch , * fbranch ; 
        BLOCK_SETUP((PUSH(test, 0+XfOrM783_COUNT), PUSH(tbranch, 1+XfOrM783_COUNT), PUSH(fbranch, 2+XfOrM783_COUNT)));
#       define XfOrM814_COUNT (3+XfOrM783_COUNT)
#       define SETUP_XfOrM814(x) SETUP(XfOrM814_COUNT)
        test = NULLED_OUT ; 
        tbranch = NULLED_OUT ; 
        fbranch = NULLED_OUT ; 
        test = FUNCCALL(SETUP_XfOrM814(_), read_compact (port , 1 ) ); 
        tbranch = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 
        fbranch = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 
        v = FUNCCALL_AGAIN(scheme_make_branch (test , tbranch , fbranch ) ); 
      }
      break ; 
      case CPT_MODULE_INDEX : {
        Scheme_Object * path , * base ; 
        BLOCK_SETUP((PUSH(base, 0+XfOrM783_COUNT), PUSH(path, 1+XfOrM783_COUNT)));
#       define XfOrM813_COUNT (2+XfOrM783_COUNT)
#       define SETUP_XfOrM813(x) SETUP(XfOrM813_COUNT)
        path = NULLED_OUT ; 
        base = NULLED_OUT ; 
        path = FUNCCALL(SETUP_XfOrM813(_), read_compact (port , 0 ) ); 
        base = FUNCCALL_AGAIN(read_compact (port , 0 ) ); 
        v = FUNCCALL_AGAIN(scheme_make_modidx (path , base , scheme_false ) ); 
      }
      break ; 
      case CPT_MODULE_VAR : {
        Module_Variable * mv ; 
        Scheme_Object * mod , * var ; 
        int pos ; 
        BLOCK_SETUP((PUSH(mod, 0+XfOrM783_COUNT), PUSH(mv, 1+XfOrM783_COUNT), PUSH(var, 2+XfOrM783_COUNT)));
#       define XfOrM812_COUNT (3+XfOrM783_COUNT)
#       define SETUP_XfOrM812(x) SETUP(XfOrM812_COUNT)
        mv = NULLED_OUT ; 
        mod = NULLED_OUT ; 
        var = NULLED_OUT ; 
        mod = FUNCCALL(SETUP_XfOrM812(_), read_compact (port , 0 ) ); 
        var = FUNCCALL_AGAIN(read_compact (port , 0 ) ); 
        pos = (read_compact_number (port ) ) ; 
        mv = ((Module_Variable * ) FUNCCALL(SETUP_XfOrM812(_), GC_malloc_one_small_tagged ((((sizeof (Module_Variable ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        mv -> so . type = scheme_module_variable_type ; 
        if (((Scheme_Type ) (((((long ) (mod ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (mod ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
          mod = FUNCCALL(SETUP_XfOrM812(_), scheme_intern_resolved_module_path (mod ) ); 
        mv -> modidx = mod ; 
        mv -> insp = port -> insp ; 
        mv -> sym = var ; 
        mv -> pos = pos ; 
        v = (Scheme_Object * ) mv ; 
      }
      break ; 
      case CPT_PATH : {
#       define XfOrM809_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM809(x) SETUP_XfOrM783(x)
        l = (read_compact_number (port ) ) ; 
        if (! (l <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM809(_), scheme_ill_formed (port , "./../src/read.c" , 4772 ) ); 
        ; 
        s = FUNCCALL(SETUP_XfOrM809(_), read_compact_chars (port , buffer , 32 , l ) ); 
        v = FUNCCALL_AGAIN(scheme_make_sized_path (s , l , l < 32 ) ); 
        if (FUNCCALL(SETUP_XfOrM809(_), scheme_is_relative_path ((((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . tag_val ) , scheme_unix_path_type ) )) {
#         define XfOrM810_COUNT (0+XfOrM809_COUNT)
#         define SETUP_XfOrM810(x) SETUP_XfOrM809(x)
          if (((Scheme_Type ) (((((long ) (port -> relto ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port -> relto ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
            Scheme_Object * a [2 ] ; 
            BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM810_COUNT)));
#           define XfOrM811_COUNT (3+XfOrM810_COUNT)
#           define SETUP_XfOrM811(x) SETUP(XfOrM811_COUNT)
            a[0] = NULLED_OUT ; 
            a[1] = NULLED_OUT ; 
            a [0 ] = port -> relto ; 
            a [1 ] = v ; 
            v = FUNCCALL(SETUP_XfOrM811(_), scheme_build_path (2 , a ) ); 
          }
        }
      }
      break ; 
      case CPT_CLOSURE : {
        Scheme_Closure * cl ; 
        BLOCK_SETUP((PUSH(cl, 0+XfOrM783_COUNT)));
#       define XfOrM807_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM807(x) SETUP(XfOrM807_COUNT)
        cl = NULLED_OUT ; 
        l = (read_compact_number (port ) ) ; 
        if (! (l < port -> symtab_size ) )
          FUNCCALL(SETUP_XfOrM807(_), scheme_ill_formed (port , "./../src/read.c" , 4791 ) ); 
        ; 
        cl = FUNCCALL(SETUP_XfOrM807(_), scheme_malloc_empty_closure () ); 
        port -> symtab [l ] = (Scheme_Object * ) cl ; 
        v = FUNCCALL(SETUP_XfOrM807(_), read_compact (port , 0 ) ); 
        if (! ((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) || ((Scheme_Closure * ) v ) -> code -> closure_size ) {
#         define XfOrM808_COUNT (0+XfOrM807_COUNT)
#         define SETUP_XfOrM808(x) SETUP_XfOrM807(x)
          FUNCCALL(SETUP_XfOrM808(_), scheme_ill_formed (port , "./../src/read.c" , 4797 ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        cl -> code = ((Scheme_Closure * ) v ) -> code ; 
        v = (Scheme_Object * ) cl ; 
        break ; 
      }
      case CPT_DELAY_REF : {
#       define XfOrM803_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM803(x) SETUP_XfOrM783(x)
        l = (read_compact_number (port ) ) ; 
        if (! (l < port -> symtab_size ) )
          FUNCCALL(SETUP_XfOrM803(_), scheme_ill_formed (port , "./../src/read.c" , 4807 ) ); 
        ; 
        v = port -> symtab [l ] ; 
        if (! v ) {
#         define XfOrM804_COUNT (0+XfOrM803_COUNT)
#         define SETUP_XfOrM804(x) SETUP_XfOrM803(x)
          if (port -> delay_info ) {
#           define XfOrM806_COUNT (0+XfOrM804_COUNT)
#           define SETUP_XfOrM806(x) SETUP_XfOrM804(x)
            v = FUNCCALL(SETUP_XfOrM806(_), scheme_make_raw_pair (((Scheme_Object * ) (void * ) (long ) ((((long ) (l ) ) << 1 ) | 0x1 ) ) , (Scheme_Object * ) port -> delay_info ) ); 
          }
          else {
            long save_pos = port -> pos ; 
#           define XfOrM805_COUNT (0+XfOrM804_COUNT)
#           define SETUP_XfOrM805(x) SETUP_XfOrM804(x)
            port -> pos = port -> shared_offsets [l - 1 ] ; 
            v = FUNCCALL(SETUP_XfOrM805(_), read_compact (port , 0 ) ); 
            port -> pos = save_pos ; 
            port -> symtab [l ] = v ; 
          }
        }
        break ; 
      }
      case CPT_PREFAB : {
        Scheme_Struct_Type * st ; 
        BLOCK_SETUP((PUSH(st, 0+XfOrM783_COUNT)));
#       define XfOrM800_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM800(x) SETUP(XfOrM800_COUNT)
        st = NULLED_OUT ; 
        v = FUNCCALL(SETUP_XfOrM800(_), read_compact (port , 0 ) ); 
        if (! ((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ! (((Scheme_Vector * ) (v ) ) -> size ) )
          v = ((void * ) 0 ) ; 
        else {
#         define XfOrM801_COUNT (0+XfOrM800_COUNT)
#         define SETUP_XfOrM801(x) SETUP_XfOrM800(x)
          st = FUNCCALL(SETUP_XfOrM801(_), scheme_lookup_prefab_type ((((Scheme_Vector * ) (v ) ) -> els ) [0 ] , (((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ); 
          if (! st || (st -> num_slots != ((((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ) )
            v = ((void * ) 0 ) ; 
          else {
#           define XfOrM802_COUNT (0+XfOrM801_COUNT)
#           define SETUP_XfOrM802(x) SETUP_XfOrM801(x)
            v = FUNCCALL(SETUP_XfOrM802(_), scheme_make_prefab_struct_instance (st , v ) ); 
          }
        }
        break ; 
      }
      case 192 : case 207 : {
        Scheme_Type type ; 
#       define XfOrM797_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM797(x) SETUP_XfOrM783(x)
        if (((ch >= 207 ) && (ch < 222 ) ) ) {
          type = scheme_local_unbox_type ; 
          ch -= 207 ; 
        }
        else {
          type = scheme_local_type ; 
          ch -= 192 ; 
        }
        v = FUNCCALL(SETUP_XfOrM797(_), scheme_make_local (type , ch , 0 ) ); 
      }
      break ; 
      case 80 : {
#       define XfOrM796_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM796(x) SETUP_XfOrM783(x)
        l = ch - 80 ; 
        v = FUNCCALL(SETUP_XfOrM796(_), read_marshalled (l , port ) ); 
      }
      break ; 
      case 60 : {
#       define XfOrM795_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM795(x) SETUP_XfOrM783(x)
        l = ch - 60 ; 
        if (! (l <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM795(_), scheme_ill_formed (port , "./../src/read.c" , 4865 ) ); 
        ; 
        s = FUNCCALL(SETUP_XfOrM795(_), read_compact_chars (port , buffer , 32 , l ) ); 
        v = FUNCCALL_AGAIN(scheme_intern_exact_symbol (s , l ) ); 
        if (((v ) == (port -> magic_sym ) ) )
          v = port -> magic_val ; 
      }
      break ; 
      case 35 : {
        l = ch - 35 ; 
        v = ((Scheme_Object * ) (void * ) (long ) ((((long ) (l ) ) << 1 ) | 0x1 ) ) ; 
      }
      break ; 
      case 222 : {
#       define XfOrM793_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM793(x) SETUP_XfOrM783(x)
        l = ch - 222 ; 
        v = FUNCCALL(SETUP_XfOrM793(_), read_compact_svector (port , l ) ); 
      }
      break ; 
      case 92 : case (92 + 65 ) : {
        int ppr = ((ch >= 92 ) && (ch < (92 + 65 ) ) ) ; 
#       define XfOrM789_COUNT (0+XfOrM783_COUNT)
#       define SETUP_XfOrM789(x) SETUP_XfOrM783(x)
        l = ch - (ppr ? 92 : (92 + 65 ) ) ; 
        if (need_car ) {
#         define XfOrM791_COUNT (0+XfOrM789_COUNT)
#         define SETUP_XfOrM791(x) SETUP_XfOrM789(x)
          if (l == 1 ) {
            Scheme_Object * car , * cdr ; 
            BLOCK_SETUP((PUSH(car, 0+XfOrM791_COUNT), PUSH(cdr, 1+XfOrM791_COUNT)));
#           define XfOrM792_COUNT (2+XfOrM791_COUNT)
#           define SETUP_XfOrM792(x) SETUP(XfOrM792_COUNT)
            car = NULLED_OUT ; 
            cdr = NULLED_OUT ; 
            car = FUNCCALL(SETUP_XfOrM792(_), read_compact (port , 0 ) ); 
            cdr = (ppr ? scheme_null : FUNCCALL(SETUP_XfOrM792(_), read_compact (port , 0 ) )) ; 
            v = FUNCCALL(SETUP_XfOrM792(_), scheme_make_pair (car , cdr ) ); 
          }
          else v = FUNCCALL(SETUP_XfOrM791(_), read_compact_list (l , ppr , 0 , port ) ); 
        }
        else {
          proper = ppr ; 
          need_car = l ; 
          continue ; 
        }
      }
      break ; 
      case 247 : {
        int c , i ; 
        Scheme_App_Rec * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM783_COUNT)));
#       define XfOrM786_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM786(x) SETUP(XfOrM786_COUNT)
        a = NULLED_OUT ; 
        c = (ch - 247 ) + 1 ; 
        a = FUNCCALL(SETUP_XfOrM786(_), scheme_malloc_application (c ) ); 
        for (i = 0 ; i < c ; i ++ ) {
#         define XfOrM788_COUNT (0+XfOrM786_COUNT)
#         define SETUP_XfOrM788(x) SETUP_XfOrM786(x)
          v = FUNCCALL(SETUP_XfOrM788(_), read_compact (port , 1 ) ); 
          a -> args [i ] = v ; 
        }
        FUNCCALL(SETUP_XfOrM786(_), scheme_finish_application (a ) ); 
        v = (Scheme_Object * ) a ; 
      }
      break ; 
      case 248 : {
        short et ; 
        Scheme_App2_Rec * app ; 
        BLOCK_SETUP((PUSH(app, 0+XfOrM783_COUNT)));
#       define XfOrM785_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM785(x) SETUP(XfOrM785_COUNT)
        app = NULLED_OUT ; 
        app = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM785(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        app -> iso . so . type = scheme_application2_type ; 
        v = FUNCCALL(SETUP_XfOrM785(_), read_compact (port , 1 ) ); 
        app -> rator = v ; 
        v = FUNCCALL(SETUP_XfOrM785(_), read_compact (port , 1 ) ); 
        app -> rand = v ; 
        et = FUNCCALL(SETUP_XfOrM785(_), scheme_get_eval_type (app -> rand ) ); 
        et = et << 3 ; 
        et += FUNCCALL(SETUP_XfOrM785(_), scheme_get_eval_type (app -> rator ) ); 
        (& app -> iso ) -> so . keyex = et ; 
        v = (Scheme_Object * ) app ; 
      }
      break ; 
      case 249 : {
        short et ; 
        Scheme_App3_Rec * app ; 
        BLOCK_SETUP((PUSH(app, 0+XfOrM783_COUNT)));
#       define XfOrM784_COUNT (1+XfOrM783_COUNT)
#       define SETUP_XfOrM784(x) SETUP(XfOrM784_COUNT)
        app = NULLED_OUT ; 
        app = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM784(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        app -> iso . so . type = scheme_application3_type ; 
        v = FUNCCALL(SETUP_XfOrM784(_), read_compact (port , 1 ) ); 
        app -> rator = v ; 
        v = FUNCCALL(SETUP_XfOrM784(_), read_compact (port , 1 ) ); 
        app -> rand1 = v ; 
        v = FUNCCALL(SETUP_XfOrM784(_), read_compact (port , 1 ) ); 
        app -> rand2 = v ; 
        et = FUNCCALL(SETUP_XfOrM784(_), scheme_get_eval_type (app -> rand2 ) ); 
        et = et << 3 ; 
        et += FUNCCALL(SETUP_XfOrM784(_), scheme_get_eval_type (app -> rand1 ) ); 
        et = et << 3 ; 
        et += FUNCCALL(SETUP_XfOrM784(_), scheme_get_eval_type (app -> rator ) ); 
        (& app -> iso ) -> so . keyex = et ; 
        v = (Scheme_Object * ) app ; 
      }
      break ; 
      default : v = ((void * ) 0 ) ; 
      break ; 
    }
    if (! v )
      FUNCCALL(SETUP_XfOrM780(_), scheme_ill_formed (port , "./../src/read.c" , 4977 ) ); 
    if (need_car ) {
      Scheme_Object * pair ; 
      BLOCK_SETUP((PUSH(pair, 0+XfOrM780_COUNT)));
#     define XfOrM782_COUNT (1+XfOrM780_COUNT)
#     define SETUP_XfOrM782(x) SETUP(XfOrM782_COUNT)
      pair = NULLED_OUT ; 
      pair = FUNCCALL(SETUP_XfOrM782(_), scheme_make_pair (v , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pair ; 
      else first = pair ; 
      last = pair ; 
      -- need_car ; 
      if (! need_car && proper )
        break ; 
    }
    else {
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
      break ; 
    }
  }
  RET_VALUE_START (first ? first : v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_compact_list (int c , int proper , int use_stack , CPort * port ) {
  Scheme_Object * v , * first , * last , * pair ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(first, 1), PUSH(last, 2), PUSH(port, 3), PUSH(pair, 4)));
# define XfOrM845_COUNT (5)
# define SETUP_XfOrM845(x) SETUP(XfOrM845_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  first = NULLED_OUT ; 
  last = NULLED_OUT ; 
  pair = NULLED_OUT ; 
  v = FUNCCALL(SETUP_XfOrM845(_), read_compact (port , 0 ) ); 
  last = FUNCCALL_AGAIN(scheme_make_pair (v , scheme_null ) ); 
  first = last ; 
  while (-- c ) {
#   define XfOrM848_COUNT (0+XfOrM845_COUNT)
#   define SETUP_XfOrM848(x) SETUP_XfOrM845(x)
    v = FUNCCALL(SETUP_XfOrM848(_), read_compact (port , 0 ) ); 
    pair = FUNCCALL(SETUP_XfOrM848(_), scheme_make_pair (v , scheme_null ) ); 
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pair ; 
    last = pair ; 
  }
  if (! proper ) {
#   define XfOrM846_COUNT (0+XfOrM845_COUNT)
#   define SETUP_XfOrM846(x) SETUP_XfOrM845(x)
    v = FUNCCALL(SETUP_XfOrM846(_), read_compact (port , 0 ) ); 
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
  }
  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_compact_quote (CPort * port , int embedded ) {
  Scheme_Hash_Table * * q_ht , * * old_ht ; 
  Scheme_Object * v ; 
  Scheme_Hash_Table * __funcarg152 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg151 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(__funcarg151, 0), PUSH(q_ht, 1), PUSH(v, 2), PUSH(port, 3), PUSH(old_ht, 4)));
# define XfOrM849_COUNT (5)
# define SETUP_XfOrM849(x) SETUP(XfOrM849_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  q_ht = NULLED_OUT ; 
  old_ht = NULLED_OUT ; 
  v = NULLED_OUT ; 
  q_ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM849(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 
  * q_ht = ((void * ) 0 ) ; 
  old_ht = port -> ht ; 
  port -> ht = q_ht ; 
  v = FUNCCALL(SETUP_XfOrM849(_), read_compact (port , 0 ) ); 
  port -> ht = old_ht ; 
  if (* q_ht )
    v = (__funcarg151 = FUNCCALL(SETUP_XfOrM849(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), __funcarg152 = FUNCCALL(SETUP_XfOrM849(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), FUNCCALL_AGAIN(resolve_references (v , port -> orig_port , ((void * ) 0 ) , __funcarg151 , __funcarg152 , 0 , 0 ) )) ; 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_marshalled (int type , CPort * port ) {
  Scheme_Object * l ; 
  Scheme_Type_Reader reader ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(port, 1)));
# define XfOrM850_COUNT (2)
# define SETUP_XfOrM850(x) SETUP(XfOrM850_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  l = FUNCCALL(SETUP_XfOrM850(_), read_compact (port , 1 ) ); 
  if ((type < 0 ) || (type >= _scheme_last_type_ ) ) {
#   define XfOrM852_COUNT (0+XfOrM850_COUNT)
#   define SETUP_XfOrM852(x) SETUP_XfOrM850(x)
    FUNCCALL(SETUP_XfOrM852(_), scheme_ill_formed (port , "./../src/read.c" , 5062 ) ); 
  }
  reader = scheme_type_readers [type ] ; 
  if (! reader ) {
#   define XfOrM851_COUNT (0+XfOrM850_COUNT)
#   define SETUP_XfOrM851(x) SETUP_XfOrM850(x)
    FUNCCALL(SETUP_XfOrM851(_), scheme_ill_formed (port , "./../src/read.c" , 5068 ) ); 
  }
  l = FUNCCALL(SETUP_XfOrM850(_), reader (l ) ); 
  if (! l )
    FUNCCALL(SETUP_XfOrM850(_), scheme_ill_formed (port , "./../src/read.c" , 5074 ) ); 
  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static long read_simple_number_from_port (Scheme_Object * port ) {
  long a , b , c , d ; 
  DECL_RET_SAVE (long ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM853_COUNT (1)
# define SETUP_XfOrM853(x) SETUP(XfOrM853_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = (unsigned char ) FUNCCALL(SETUP_XfOrM853(_), scheme_get_byte (port ) ); 
  b = (unsigned char ) FUNCCALL(SETUP_XfOrM853(_), scheme_get_byte (port ) ); 
  c = (unsigned char ) FUNCCALL(SETUP_XfOrM853(_), scheme_get_byte (port ) ); 
  d = (unsigned char ) FUNCCALL_EMPTY(scheme_get_byte (port ) ); 
  RET_VALUE_START ((a + (b << 8 ) + (c << 16 ) + (d << 24 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_compiled (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , ReadParams * params ) {
  Scheme_Object * result , * insp ; 
  long size , shared_size , got , offset = 0 ; 
  CPort * rp ; 
  long symtabsize ; 
  Scheme_Object * * symtab ; 
  long * so ; 
  Scheme_Load_Delay * delay_info ; 
  Scheme_Hash_Table * * local_ht ; 
  int all_short ; 
  int perma_cache = use_perma_cache ; 
  Scheme_Object * dir ; 
  Scheme_Config * config ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(symtab, 0), PUSH(dir, 1), PUSH(result, 2), PUSH(params, 3), PUSH(insp, 4), PUSH(port, 5), PUSH(delay_info, 6), PUSH(stxsrc, 7), PUSH(config, 8), PUSH(so, 9), PUSH(local_ht, 10), PUSH(rp, 11), PUSH(ht, 12)));
# define XfOrM854_COUNT (13)
# define SETUP_XfOrM854(x) SETUP(XfOrM854_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  result = NULLED_OUT ; 
  insp = NULLED_OUT ; 
  rp = NULLED_OUT ; 
  symtab = NULLED_OUT ; 
  so = NULLED_OUT ; 
  delay_info = NULLED_OUT ; 
  local_ht = NULLED_OUT ; 
  dir = NULLED_OUT ; 
  config = NULLED_OUT ; 
  if (! cpt_branch [1 ] ) {
    int i ; 
    for (i = 0 ; i < 256 ; i ++ ) {
      cpt_branch [i ] = i ; 
    }
    for (i = 35 ; i < 60 ; i ++ ) {
      cpt_branch [i ] = 35 ; 
    }
    ; 
    for (i = 60 ; i < 80 ; i ++ ) {
      cpt_branch [i ] = 60 ; 
    }
    ; 
    for (i = 80 ; i < 92 ; i ++ ) {
      cpt_branch [i ] = 80 ; 
    }
    ; 
    for (i = (92 + 65 ) ; i < ((92 + 65 ) + 65 ) ; i ++ ) {
      cpt_branch [i ] = (92 + 65 ) ; 
    }
    ; 
    for (i = 92 ; i < (92 + 65 ) ; i ++ ) {
      cpt_branch [i ] = 92 ; 
    }
    ; 
    for (i = 192 ; i < 207 ; i ++ ) {
      cpt_branch [i ] = 192 ; 
    }
    ; 
    for (i = 207 ; i < 222 ; i ++ ) {
      cpt_branch [i ] = 207 ; 
    }
    ; 
    for (i = 222 ; i < 247 ; i ++ ) {
      cpt_branch [i ] = 222 ; 
    }
    ; 
    for (i = 247 ; i < 255 ; i ++ ) {
      cpt_branch [i ] = 247 ; 
    }
    ; 
    cpt_branch [248 ] = 248 ; 
    cpt_branch [249 ] = 249 ; 
  }
  if (! variable_references )
    variable_references = FUNCCALL(SETUP_XfOrM854(_), scheme_make_builtin_references_table () ); 
  if (params -> delay_load_info ) {
#   define XfOrM877_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM877(x) SETUP_XfOrM854(x)
    delay_info = ((Scheme_Load_Delay * ) FUNCCALL(SETUP_XfOrM877(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Load_Delay ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    delay_info -> type = scheme_rt_delay_load_info ; 
    delay_info -> path = params -> delay_load_info ; 
  }
  else delay_info = ((void * ) 0 ) ; 
  size = FUNCCALL(SETUP_XfOrM854(_), scheme_get_byte (port ) ); 
  {
    char buf [64 ] ; 
#   define XfOrM876_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM876(x) SETUP_XfOrM854(x)
    if (size < 0 )
      size = 0 ; 
    if (size > 63 )
      size = 63 ; 
    got = FUNCCALL(SETUP_XfOrM876(_), scheme_get_bytes (port , size , buf , 0 ) ); 
    buf [got ] = 0 ; 
    if (! params -> skip_zo_vers_check )
      if ((strcmp (buf , "4.1.2" ) ) )
      FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , got , 0 , ((void * ) 0 ) , "read (compiled): code compiled for version %s, not %s" , (buf [0 ] ? buf : "???" ) , "4.1.2" ) ); 
  }
  offset += size + 1 ; 
  symtabsize = FUNCCALL(SETUP_XfOrM854(_), read_simple_number_from_port (port ) ); 
  offset += 4 ; 
  all_short = FUNCCALL(SETUP_XfOrM854(_), scheme_get_byte (port ) ); 
  so = (long * ) FUNCCALL(SETUP_XfOrM854(_), scheme_malloc_fail_ok (GC_malloc_atomic , sizeof (long ) * symtabsize ) ); 
  if ((got = FUNCCALL(SETUP_XfOrM854(_), scheme_get_bytes (port , (all_short ? 2 : 4 ) * (symtabsize - 1 ) , (char * ) so , 0 ) )) != ((all_short ? 2 : 4 ) * (symtabsize - 1 ) ) )
    FUNCCALL_EMPTY(scheme_read_err (port , ((void * ) 0 ) , - 1 , - 1 , - 1 , - 1 , 0 , ((void * ) 0 ) , "read (compiled): ill-formed code (bad table count: %ld != %ld)" , got , (all_short ? 2 : 4 ) * (symtabsize - 1 ) ) ); 
  offset += got ; 
  {
    long j , v ; 
    unsigned char * so_c = (unsigned char * ) so ; 
    for (j = symtabsize - 1 ; j -- ; ) {
      if (all_short ) {
        v = so_c [j * 2 ] + (so_c [j * 2 + 1 ] << 8 ) ; 
      }
      else {
        v = so_c [j * 4 ] + (so_c [j * 4 + 1 ] << 8 ) + (so_c [j * 4 + 2 ] << 16 ) + (so_c [j * 4 + 3 ] << 24 ) ; 
      }
      so [j ] = v ; 
    }
  }
  shared_size = FUNCCALL(SETUP_XfOrM854(_), read_simple_number_from_port (port ) ); 
  size = FUNCCALL(SETUP_XfOrM854(_), read_simple_number_from_port (port ) ); 
  if (shared_size >= size ) {
#   define XfOrM868_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM868(x) SETUP_XfOrM854(x)
    FUNCCALL_EMPTY(scheme_read_err (port , ((void * ) 0 ) , - 1 , - 1 , - 1 , - 1 , 0 , ((void * ) 0 ) , "read (compiled): ill-formed code (shared size %ld >= total size %ld)" , shared_size , size ) ); 
  }
  offset += 8 ; 
  rp = ((CPort * ) FUNCCALL(SETUP_XfOrM854(_), GC_malloc_one_small_tagged ((((sizeof (CPort ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  rp -> type = scheme_rt_compact_port ; 
  {
    unsigned char * st ; 
    BLOCK_SETUP((PUSH(st, 0+XfOrM854_COUNT)));
#   define XfOrM867_COUNT (1+XfOrM854_COUNT)
#   define SETUP_XfOrM867(x) SETUP(XfOrM867_COUNT)
    st = NULLED_OUT ; 
    st = (unsigned char * ) FUNCCALL(SETUP_XfOrM867(_), scheme_malloc_fail_ok (GC_malloc_atomic , size + 1 ) ); 
    rp -> start = st ; 
  }
  rp -> pos = 0 ; 
  {
    long base ; 
#   define XfOrM866_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM866(x) SETUP_XfOrM854(x)
    FUNCCALL(SETUP_XfOrM866(_), scheme_tell_all (port , ((void * ) 0 ) , ((void * ) 0 ) , & base ) ); 
    rp -> base = base ; 
  }
  rp -> orig_port = port ; 
  rp -> size = size ; 
  if ((got = FUNCCALL(SETUP_XfOrM854(_), scheme_get_bytes (port , size , (char * ) rp -> start , 0 ) )) != size )
    FUNCCALL_EMPTY(scheme_read_err (port , ((void * ) 0 ) , - 1 , - 1 , - 1 , - 1 , 0 , ((void * ) 0 ) , "read (compiled): ill-formed code (bad count: %ld != %ld, started at %ld)" , got , size , rp -> base ) ); 
  local_ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM854(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 
  symtab = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM854(_), GC_malloc (sizeof (Scheme_Object * ) * (symtabsize ) ) )) ; 
  rp -> symtab_size = symtabsize ; 
  rp -> ht = local_ht ; 
  rp -> symtab = symtab ; 
  config = FUNCCALL(SETUP_XfOrM854(_), scheme_current_config () ); 
  insp = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_CODE_INSPECTOR ) ); 
  rp -> insp = insp ; 
  dir = FUNCCALL(SETUP_XfOrM854(_), scheme_get_param (config , MZCONFIG_LOAD_DIRECTORY ) ); 
  rp -> relto = dir ; 
  rp -> magic_sym = params -> magic_sym ; 
  rp -> magic_val = params -> magic_val ; 
  rp -> shared_offsets = so ; 
  rp -> delay_info = delay_info ; 
  if (! delay_info ) {
    long j , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM854_COUNT)));
#   define XfOrM859_COUNT (1+XfOrM854_COUNT)
#   define SETUP_XfOrM859(x) SETUP(XfOrM859_COUNT)
    v = NULLED_OUT ; 
    len = symtabsize ; 
    for (j = 1 ; j < len ; j ++ ) {
#     define XfOrM863_COUNT (0+XfOrM859_COUNT)
#     define SETUP_XfOrM863(x) SETUP_XfOrM859(x)
      if (! symtab [j ] ) {
#       define XfOrM865_COUNT (0+XfOrM863_COUNT)
#       define SETUP_XfOrM865(x) SETUP_XfOrM863(x)
        v = FUNCCALL(SETUP_XfOrM865(_), read_compact (rp , 0 ) ); 
        symtab [j ] = v ; 
      }
      else {
        if (j + 1 < len )
          rp -> pos = so [j ] ; 
        else rp -> pos = shared_size ; 
      }
    }
  }
  else {
#   define XfOrM857_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM857(x) SETUP_XfOrM854(x)
    FUNCCALL(SETUP_XfOrM857(_), scheme_reserve_file_descriptor () ); 
    rp -> pos = shared_size ; 
    delay_info -> file_offset = offset + 2 + 1 ; 
    delay_info -> size = shared_size ; 
    delay_info -> symtab_size = rp -> symtab_size ; 
    delay_info -> symtab = rp -> symtab ; 
    delay_info -> shared_offsets = rp -> shared_offsets ; 
    delay_info -> insp = rp -> insp ; 
    delay_info -> relto = rp -> relto ; 
    if (perma_cache ) {
      unsigned char * cache ; 
      BLOCK_SETUP((PUSH(cache, 0+XfOrM857_COUNT)));
#     define XfOrM858_COUNT (1+XfOrM857_COUNT)
#     define SETUP_XfOrM858(x) SETUP(XfOrM858_COUNT)
      cache = NULLED_OUT ; 
      cache = (unsigned char * ) FUNCCALL(SETUP_XfOrM858(_), GC_malloc_atomic (shared_size ) ); 
      (memcpy (cache , rp -> start , shared_size ) ) ; 
      delay_info -> cached = cache ; 
      delay_info -> cached_port = port ; 
      delay_info -> perma_cache = 1 ; 
    }
  }
  result = FUNCCALL(SETUP_XfOrM854(_), read_marshalled (scheme_compilation_top_type , rp ) ); 
  if (* local_ht ) {
#   define XfOrM856_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM856(x) SETUP_XfOrM854(x)
    FUNCCALL_EMPTY(scheme_read_err (port , ((void * ) 0 ) , - 1 , - 1 , - 1 , - 1 , 0 , ((void * ) 0 ) , "read (compiled): ill-formed code (unexpected graph structure)" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (((Scheme_Type ) (((((long ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_compilation_top_type ) ) ) {
    Scheme_Compilation_Top * top = (Scheme_Compilation_Top * ) result ; 
#   define XfOrM855_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM855(x) SETUP_XfOrM854(x)
    FUNCCALL(SETUP_XfOrM855(_), scheme_validate_code (rp , top -> code , top -> max_let_depth , top -> prefix -> num_toplevels , top -> prefix -> num_stxes , top -> prefix -> num_lifts , 0 ) ); 
  }
  else FUNCCALL(SETUP_XfOrM854(_), scheme_ill_formed (rp , "./../src/read.c" , 5314 ) ); 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Load_Delay * clear_bytes_chain ; 
void scheme_clear_delayed_load_cache () {
  /* No conversion */
  Scheme_Load_Delay * next ; 
  while (clear_bytes_chain ) {
    next = clear_bytes_chain -> clear_bytes_next ; 
    clear_bytes_chain -> cached = ((void * ) 0 ) ; 
    clear_bytes_chain -> cached_port = ((void * ) 0 ) ; 
    clear_bytes_chain -> clear_bytes_next = ((void * ) 0 ) ; 
    clear_bytes_chain -> clear_bytes_prev = ((void * ) 0 ) ; 
    clear_bytes_chain = next ; 
  }
}
Scheme_Object * scheme_load_delayed_code (int _which , Scheme_Load_Delay * _delay_info ) {
  Scheme_Load_Delay * volatile delay_info = _delay_info ; 
  CPort * rp ; 
  CPort * volatile old_rp ; 
  volatile int which = _which ; 
  long size , got ; 
  unsigned char * st ; 
  Scheme_Object * volatile port ; 
  Scheme_Object * volatile v ; 
  Scheme_Hash_Table * * volatile ht ; 
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Hash_Table * __funcarg154 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg153 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(rp, 0), PUSH(savebuf, 1), PUSH(v, 2), PUSH(port, 3), PUSH(__funcarg153, 4), PUSH(old_rp, 5), PUSH(delay_info, 6), PUSH(ht, 7), PUSH(st, 8)));
# define XfOrM902_COUNT (9)
# define SETUP_XfOrM902(x) SETUP(XfOrM902_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  rp = NULLED_OUT ; 
  old_rp = NULLED_OUT ; 
  st = NULLED_OUT ; 
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 
  ht = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 
  if (! delay_info -> perma_cache ) {
    if (delay_info -> clear_bytes_prev )
      delay_info -> clear_bytes_prev -> clear_bytes_next = delay_info -> clear_bytes_next ; 
    else if (clear_bytes_chain == delay_info )
      clear_bytes_chain = delay_info -> clear_bytes_next ; 
    if (delay_info -> clear_bytes_next )
      delay_info -> clear_bytes_next -> clear_bytes_prev = delay_info -> clear_bytes_prev ; 
    delay_info -> clear_bytes_prev = ((void * ) 0 ) ; 
    delay_info -> clear_bytes_next = ((void * ) 0 ) ; 
  }
  size = delay_info -> size ; 
  if (! delay_info -> cached ) {
    Scheme_Object * a [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM902_COUNT)));
#   define XfOrM910_COUNT (3+XfOrM902_COUNT)
#   define SETUP_XfOrM910(x) SETUP(XfOrM910_COUNT)
    a[0] = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM910(_), scheme_start_atomic () ); 
    FUNCCALL_AGAIN(scheme_release_file_descriptor () ); 
    a [0 ] = delay_info -> path ; 
    port = FUNCCALL(SETUP_XfOrM910(_), scheme_do_open_input_file ("on-demand-loader" , 0 , 1 , a , 0 ) ); 
    savebuf = scheme_current_thread -> error_buf ; 
    scheme_current_thread -> error_buf = & newbuf ; 
    if (((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#     define XfOrM912_COUNT (0+XfOrM910_COUNT)
#     define SETUP_XfOrM912(x) SETUP_XfOrM910(x)
      FUNCCALL(SETUP_XfOrM912(_), scheme_end_atomic_no_swap () ); 
      FUNCCALL(SETUP_XfOrM912(_), scheme_close_input_port (port ) ); 
      scheme_current_thread -> error_buf = savebuf ; 
      (((long * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , GC_variable_stack = (void * * ) (void * ) (* savebuf ) . gcvs , scheme_jit_longjmp ((* savebuf ) . jb , 1 ) ) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else {
#     define XfOrM911_COUNT (0+XfOrM910_COUNT)
#     define SETUP_XfOrM911(x) SETUP_XfOrM910(x)
      st = (unsigned char * ) FUNCCALL(SETUP_XfOrM911(_), GC_malloc_atomic (size + 1 ) ); 
      FUNCCALL(SETUP_XfOrM911(_), scheme_set_file_position (port , delay_info -> file_offset ) ); 
      if ((got = FUNCCALL(SETUP_XfOrM911(_), scheme_get_bytes (port , size , (char * ) st , 0 ) )) != size )
        FUNCCALL(SETUP_XfOrM911(_), scheme_read_err (port , ((void * ) 0 ) , - 1 , - 1 , - 1 , - 1 , 0 , ((void * ) 0 ) , "on-demand load: ill-formed code (bad count: %ld != %ld, started at %ld)" , got , size , 0 ) ); 
    }
    scheme_current_thread -> error_buf = savebuf ; 
    FUNCCALL(SETUP_XfOrM910(_), scheme_close_input_port (port ) ); 
    FUNCCALL_AGAIN(scheme_reserve_file_descriptor () ); 
    FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
    delay_info -> cached = st ; 
    delay_info -> cached_port = port ; 
  }
  else {
    port = delay_info -> cached_port ; 
  }
  FUNCCALL(SETUP_XfOrM902(_), scheme_start_atomic () ); 
  old_rp = delay_info -> current_rp ; 
  rp = ((CPort * ) FUNCCALL(SETUP_XfOrM902(_), GC_malloc_one_small_tagged ((((sizeof (CPort ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  rp -> type = scheme_rt_compact_port ; 
  rp -> start = delay_info -> cached ; 
  rp -> pos = 0 ; 
  rp -> base = 0 ; 
  rp -> orig_port = port ; 
  rp -> size = size ; 
  rp -> ut = delay_info -> ut ; 
  if (delay_info -> ut )
    delay_info -> ut -> rp = rp ; 
  ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM902(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 
  rp -> symtab_size = delay_info -> symtab_size ; 
  rp -> ht = ht ; 
  rp -> symtab = delay_info -> symtab ; 
  rp -> insp = delay_info -> insp ; 
  rp -> relto = delay_info -> relto ; 
  rp -> shared_offsets = delay_info -> shared_offsets ; 
  rp -> delay_info = delay_info ; 
  rp -> pos = delay_info -> shared_offsets [which - 1 ] ; 
  savebuf = scheme_current_thread -> error_buf ; 
  scheme_current_thread -> error_buf = & newbuf ; 
  if (((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
    v = ((void * ) 0 ) ; 
  }
  else {
#   define XfOrM907_COUNT (0+XfOrM902_COUNT)
#   define SETUP_XfOrM907(x) SETUP_XfOrM902(x)
    v = FUNCCALL(SETUP_XfOrM907(_), read_compact (rp , 0 ) ); 
  }
  scheme_current_thread -> error_buf = savebuf ; 
  delay_info -> current_rp = old_rp ; 
  if (delay_info -> ut )
    delay_info -> ut -> rp = old_rp ; 
  if (! old_rp && ! delay_info -> perma_cache ) {
    delay_info -> clear_bytes_next = clear_bytes_chain ; 
    if (clear_bytes_chain )
      clear_bytes_chain -> clear_bytes_prev = delay_info ; 
    clear_bytes_chain = delay_info ; 
  }
  FUNCCALL(SETUP_XfOrM902(_), scheme_end_atomic_no_swap () ); 
  if (v ) {
#   define XfOrM904_COUNT (0+XfOrM902_COUNT)
#   define SETUP_XfOrM904(x) SETUP_XfOrM902(x)
    if (* ht ) {
#     define XfOrM905_COUNT (0+XfOrM904_COUNT)
#     define SETUP_XfOrM905(x) SETUP_XfOrM904(x)
      v = (__funcarg153 = FUNCCALL(SETUP_XfOrM905(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), __funcarg154 = FUNCCALL(SETUP_XfOrM905(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), FUNCCALL_AGAIN(resolve_references (v , port , ((void * ) 0 ) , __funcarg153 , __funcarg154 , 0 , 0 ) )) ; 
    }
    delay_info -> symtab [which ] = v ; 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
  else {
    (((long * ) (void * ) ((* scheme_current_thread -> error_buf ) . gcvs ) ) [1 ] = (* scheme_current_thread -> error_buf ) . gcvs_cnt , GC_variable_stack = (void * * ) (void * ) (* scheme_current_thread -> error_buf ) . gcvs , scheme_jit_longjmp ((* scheme_current_thread -> error_buf ) . jb , 1 ) ) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_unmarshal_wrap_get (Scheme_Unmarshal_Tables * ut , Scheme_Object * wraps_key , int * _decoded ) {
  long l ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(_decoded, 0), PUSH(ut, 1)));
# define XfOrM914_COUNT (2)
# define SETUP_XfOrM914(x) SETUP(XfOrM914_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = (((long ) (wraps_key ) ) >> 1 ) ; 
  if ((l < 0 ) || ((unsigned long ) l >= ut -> rp -> symtab_size ) )
    FUNCCALL(SETUP_XfOrM914(_), scheme_ill_formed (ut -> rp , "./../src/read.c" , 5488 ) ); 
  if (! ut -> rp -> symtab [l ] ) {
    Scheme_Object * v ; 
    long save_pos ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM914_COUNT)));
#   define XfOrM915_COUNT (1+XfOrM914_COUNT)
#   define SETUP_XfOrM915(x) SETUP(XfOrM915_COUNT)
    v = NULLED_OUT ; 
    if (! ut -> rp -> delay_info )
      FUNCCALL(SETUP_XfOrM915(_), scheme_ill_formed (ut -> rp , "./../src/read.c" , 5495 ) ); 
    save_pos = ut -> rp -> pos ; 
    ut -> rp -> pos = ut -> rp -> shared_offsets [l - 1 ] ; 
    v = FUNCCALL(SETUP_XfOrM915(_), read_compact (ut -> rp , 0 ) ); 
    ut -> rp -> pos = save_pos ; 
    ut -> rp -> symtab [l ] = v ; 
  }
  * _decoded = ut -> decoded [l ] ; 
  RET_VALUE_START (ut -> rp -> symtab [l ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_unmarshal_wrap_set (Scheme_Unmarshal_Tables * ut , Scheme_Object * wraps_key , Scheme_Object * v ) {
  /* No conversion */
  long l ; 
  l = (((long ) (wraps_key ) ) >> 1 ) ; 
  ut -> rp -> symtab [l ] = v ; 
  ut -> decoded [l ] = 1 ; 
}
Scheme_Object * scheme_make_default_readtable () {
  /* No conversion */
  return scheme_false ; 
}
static int readtable_kind (Readtable * t , int ch , ReadParams * params ) {
  int k ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(params, 0), PUSH(t, 1), PUSH(v, 2)));
# define XfOrM918_COUNT (3)
# define SETUP_XfOrM918(x) SETUP(XfOrM918_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  if (ch < 128 )
    k = t -> fast_mapping [ch ] ; 
  else {
#   define XfOrM921_COUNT (0+XfOrM918_COUNT)
#   define SETUP_XfOrM921(x) SETUP_XfOrM918(x)
    v = FUNCCALL(SETUP_XfOrM921(_), scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) ) ); 
    if (! v ) {
      if ((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) )
        k = 0x1 ; 
      else k = 0x2 ; 
    }
    else k = (((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  }
  if (k == 0x20 ) {
#   define XfOrM920_COUNT (0+XfOrM918_COUNT)
#   define SETUP_XfOrM920(x) SETUP_XfOrM918(x)
    v = FUNCCALL(SETUP_XfOrM920(_), scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) ) ); 
    ch = (((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) ) >> 1 ) ; 
    if (ch < 128 )
      k = builtin_fast [ch ] ; 
    else if ((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) )
      k = 0x1 ; 
    else k = 0x2 ; 
  }
  if (k == 0x10 ) {
    if (! params -> can_read_pipe_quote )
      RET_VALUE_START (0x2 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (k ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * readtable_call (int w_char , int ch , Scheme_Object * proc , ReadParams * params , Scheme_Object * port , Scheme_Object * src , long line , long col , long pos , int get_info , Scheme_Hash_Table * * ht , Scheme_Object * modpath_stx ) {
  int cnt , add_srcloc = 0 ; 
  Scheme_Object * a [6 ] , * v ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Hash_Table * __funcarg157 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg156 = NULLED_OUT ; 
  long __funcarg155 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(src, 0), PUSH(v, 1), PUSH(modpath_stx, 2), PUSH(port, 3), PUSH(proc, 4), PUSHARRAY(a, 6, 5), PUSH(cframe.cache, 8), PUSH(ht, 9), PUSH(__funcarg156, 10)));
# define XfOrM923_COUNT (11)
# define SETUP_XfOrM923(x) SETUP(XfOrM923_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  NULL_OUT_ARRAY (a ) ; 
  v = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  if (w_char ) {
#   define XfOrM939_COUNT (0+XfOrM923_COUNT)
#   define SETUP_XfOrM939(x) SETUP_XfOrM923(x)
    a [0 ] = ((((mzchar ) ch ) < 256 ) ? scheme_char_constants [(unsigned char ) (ch ) ] : FUNCCALL(SETUP_XfOrM939(_), scheme_make_char (ch ) )) ; 
    a [1 ] = port ; 
    a [2 ] = proc ; 
    if (! src && FUNCCALL(SETUP_XfOrM939(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 2 , 3 , a ) )) {
      cnt = 2 ; 
    }
    else {
      cnt = 6 ; 
      a [2 ] = (src ? src : scheme_false ) ; 
      add_srcloc = 3 ; 
    }
  }
  else {
    if (src ) {
      a [0 ] = src ; 
      a [1 ] = port ; 
      if (modpath_stx ) {
        a [2 ] = modpath_stx ; 
        add_srcloc = 3 ; 
        cnt = 6 ; 
      }
      else cnt = 2 ; 
    }
    else {
      a [0 ] = port ; 
      if (modpath_stx ) {
        a [1 ] = modpath_stx ; 
        add_srcloc = 2 ; 
        cnt = 5 ; 
      }
      else cnt = 1 ; 
    }
  }
  if (add_srcloc ) {
    a [add_srcloc + 0 ] = (line > 0 ) ? ((Scheme_Object * ) (void * ) (long ) ((((long ) (line ) ) << 1 ) | 0x1 ) ) : scheme_false ; 
    a [add_srcloc + 1 ] = (col > 0 ) ? ((Scheme_Object * ) (void * ) (long ) ((((long ) (col - 1 ) ) << 1 ) | 0x1 ) ) : scheme_false ; 
    a [add_srcloc + 2 ] = (pos > 0 ) ? ((Scheme_Object * ) (void * ) (long ) ((((long ) (pos ) ) << 1 ) | 0x1 ) ) : scheme_false ; 
  }
  if (src ) {
#   define XfOrM932_COUNT (0+XfOrM923_COUNT)
#   define SETUP_XfOrM932(x) SETUP_XfOrM923(x)
    ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM932(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 
  }
  if (! get_info ) {
#   define XfOrM931_COUNT (0+XfOrM923_COUNT)
#   define SETUP_XfOrM931(x) SETUP_XfOrM923(x)
    FUNCCALL(SETUP_XfOrM931(_), scheme_push_continuation_frame (& cframe ) ); 
    FUNCCALL(SETUP_XfOrM931(_), scheme_set_in_read_mark (src , ht ) ); 
  }
  v = FUNCCALL(SETUP_XfOrM923(_), scheme_apply (proc , cnt , a ) ); 
  if (get_info ) {
#   define XfOrM929_COUNT (0+XfOrM923_COUNT)
#   define SETUP_XfOrM929(x) SETUP_XfOrM923(x)
    a [0 ] = v ; 
    if (! FUNCCALL(SETUP_XfOrM929(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , a ) )) {
#     define XfOrM930_COUNT (0+XfOrM929_COUNT)
#     define SETUP_XfOrM930(x) SETUP_XfOrM929(x)
      FUNCCALL(SETUP_XfOrM930(_), scheme_wrong_type ("read-language" , "procedure (arity 1)" , - 1 , - 1 , a ) ); 
    }
  }
  if (! get_info ) {
#   define XfOrM928_COUNT (0+XfOrM923_COUNT)
#   define SETUP_XfOrM928(x) SETUP_XfOrM923(x)
    FUNCCALL(SETUP_XfOrM928(_), scheme_pop_continuation_frame (& cframe ) ); 
  }
  if (! get_info && ! FUNCCALL(SETUP_XfOrM923(_), scheme_special_comment_value (v ) )) {
#   define XfOrM924_COUNT (0+XfOrM923_COUNT)
#   define SETUP_XfOrM924(x) SETUP_XfOrM923(x)
    if (((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) {
#     define XfOrM927_COUNT (0+XfOrM924_COUNT)
#     define SETUP_XfOrM927(x) SETUP_XfOrM924(x)
      if (! src )
        v = FUNCCALL(SETUP_XfOrM927(_), scheme_syntax_to_datum (v , 0 , ((void * ) 0 ) ) ); 
    }
    else if (src ) {
      Scheme_Object * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM924_COUNT)));
#     define XfOrM925_COUNT (1+XfOrM924_COUNT)
#     define SETUP_XfOrM925(x) SETUP(XfOrM925_COUNT)
      s = NULLED_OUT ; 
      if (* ht ) {
#       define XfOrM926_COUNT (0+XfOrM925_COUNT)
#       define SETUP_XfOrM926(x) SETUP_XfOrM925(x)
        v = (__funcarg156 = FUNCCALL(SETUP_XfOrM926(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), __funcarg157 = FUNCCALL(SETUP_XfOrM926(_), scheme_make_hash_table (SCHEME_hash_ptr ) ), FUNCCALL_AGAIN(resolve_references (v , port , ((void * ) 0 ) , __funcarg156 , __funcarg157 , 1 , 0 ) )) ; 
      }
      s = (__funcarg155 = FUNCCALL(SETUP_XfOrM925(_), SPAN (port , pos ) ), FUNCCALL_AGAIN(scheme_make_stx_w_offset (scheme_false , line , col , pos , __funcarg155 , src , scheme_false ) )) ; 
      v = FUNCCALL(SETUP_XfOrM925(_), scheme_datum_to_syntax (v , s , scheme_false , 1 , 1 ) ); 
    }
    if (! src )
      FUNCCALL(SETUP_XfOrM924(_), set_need_copy (ht ) ); 
  }
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_set_in_read_mark (Scheme_Object * src , Scheme_Hash_Table * * ht ) {
  Scheme_Object * v ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM942_COUNT (1)
# define SETUP_XfOrM942(x) SETUP(XfOrM942_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  if (ht )
    v = FUNCCALL(SETUP_XfOrM942(_), scheme_make_raw_pair ((Scheme_Object * ) ht , (src ? scheme_true : scheme_false ) ) ); 
  else v = scheme_false ; 
  FUNCCALL_EMPTY(scheme_set_cont_mark (unresolved_uninterned_symbol , v ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * readtable_handle (Readtable * t , int * _ch , int * _use_default , ReadParams * params , Scheme_Object * port , Scheme_Object * src , long line , long col , long pos , Scheme_Hash_Table * * ht ) {
  int ch = * _ch ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(src, 0), PUSH(_ch, 1), PUSH(_use_default, 2), PUSH(params, 3), PUSH(v, 4), PUSH(ht, 5), PUSH(port, 6)));
# define XfOrM943_COUNT (7)
# define SETUP_XfOrM943(x) SETUP(XfOrM943_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  v = FUNCCALL(SETUP_XfOrM943(_), scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) ) ); 
  if (! v ) {
    * _use_default = 1 ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if ((((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) >> 1 ) == 0x20 ) {
    * _ch = (((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) ) >> 1 ) ; 
    * _use_default = 1 ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  * _use_default = 0 ; 
  v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
  v = FUNCCALL(SETUP_XfOrM943(_), readtable_call (1 , ch , v , params , port , src , line , col , pos , 0 , ht , ((void * ) 0 ) ) ); 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int readtable_effective_char (Readtable * t , int ch ) {
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM946_COUNT (1)
# define SETUP_XfOrM946(x) SETUP(XfOrM946_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  if (! t )
    RET_VALUE_START (ch ) RET_VALUE_END ; 
  v = FUNCCALL(SETUP_XfOrM946(_), scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) ) ); 
  if (v ) {
    if ((((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) >> 1 ) == 0x20 )
      RET_VALUE_START ((((long ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) ) >> 1 ) ) RET_VALUE_END ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  else RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * readtable_handle_hash (Readtable * t , int ch , int * _use_default , ReadParams * params , Scheme_Object * port , Scheme_Object * src , long line , long col , long pos , Scheme_Hash_Table * * ht ) {
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(src, 0), PUSH(params, 1), PUSH(v, 2), PUSH(ht, 3), PUSH(port, 4), PUSH(_use_default, 5)));
# define XfOrM948_COUNT (6)
# define SETUP_XfOrM948(x) SETUP(XfOrM948_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  v = FUNCCALL(SETUP_XfOrM948(_), scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (- ch ) ) << 1 ) | 0x1 ) ) ) ); 
  if (! v ) {
    * _use_default = 1 ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  * _use_default = 0 ; 
  v = FUNCCALL(SETUP_XfOrM948(_), readtable_call (1 , ch , v , params , port , src , line , col , pos , 0 , ht , ((void * ) 0 ) ) ); 
  if (FUNCCALL(SETUP_XfOrM948(_), scheme_special_comment_value (v ) ))
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  else RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * make_readtable (int argc , Scheme_Object * * argv ) {
  Scheme_Object * sym , * val ; 
  Readtable * t , * orig_t ; 
  Scheme_Hash_Table * ht ; 
  char * fast ; 
  int i , ch ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(sym, 1), PUSH(t, 2), PUSH(orig_t, 3), PUSH(fast, 4), PUSH(argv, 5), PUSH(ht, 6)));
# define XfOrM950_COUNT (7)
# define SETUP_XfOrM950(x) SETUP(XfOrM950_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sym = NULLED_OUT ; 
  val = NULLED_OUT ; 
  t = NULLED_OUT ; 
  orig_t = NULLED_OUT ; 
  ht = NULLED_OUT ; 
  fast = NULLED_OUT ; 
  if ((((argv [0 ] ) ) == (scheme_false ) ) )
    orig_t = ((void * ) 0 ) ; 
  else {
#   define XfOrM986_COUNT (0+XfOrM950_COUNT)
#   define SETUP_XfOrM986(x) SETUP_XfOrM950(x)
    if (! ((Scheme_Type ) (scheme_readtable_type ) == (Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) ) {
#     define XfOrM987_COUNT (0+XfOrM986_COUNT)
#     define SETUP_XfOrM987(x) SETUP_XfOrM986(x)
      FUNCCALL_EMPTY(scheme_wrong_type ("make-readtable" , "readtable or #f" , 0 , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    orig_t = (Readtable * ) argv [0 ] ; 
  }
  if (! terminating_macro_symbol ) {
#   define XfOrM983_COUNT (0+XfOrM950_COUNT)
#   define SETUP_XfOrM983(x) SETUP_XfOrM950(x)
    FUNCCALL(SETUP_XfOrM983(_), scheme_register_static ((void * ) & terminating_macro_symbol , sizeof (terminating_macro_symbol ) ) ); 
    FUNCCALL(SETUP_XfOrM983(_), scheme_register_static ((void * ) & non_terminating_macro_symbol , sizeof (non_terminating_macro_symbol ) ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & dispatch_macro_symbol , sizeof (dispatch_macro_symbol ) ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & builtin_fast , sizeof (builtin_fast ) ) ); 
    terminating_macro_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("terminating-macro" ) ); 
    non_terminating_macro_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("non-terminating-macro" ) ); 
    dispatch_macro_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("dispatch-macro" ) ); 
    fast = FUNCCALL_AGAIN(GC_malloc_atomic (128 ) ); 
    (memset (fast , 0x2 , 128 ) ) ; 
    for (i = 0 ; i < 128 ; i ++ ) {
      if ((((scheme_uchar_table [(i >> 8 ) & 0x1FFF ] [i & 0xFF ] ) ) & 0x10 ) )
        fast [i ] = 0x1 ; 
    }
    fast [';' ] = 0x4 ; 
    fast ['\'' ] = 0x4 ; 
    fast [',' ] = 0x4 ; 
    fast ['"' ] = 0x4 ; 
    fast ['|' ] = 0x10 ; 
    fast ['\\' ] = 0x8 ; 
    fast ['(' ] = 0x4 ; 
    fast ['[' ] = 0x4 ; 
    fast ['{' ] = 0x4 ; 
    fast [')' ] = 0x4 ; 
    fast [']' ] = 0x4 ; 
    fast ['}' ] = 0x4 ; 
    builtin_fast = fast ; 
  }
  t = ((Readtable * ) FUNCCALL(SETUP_XfOrM950(_), GC_malloc_one_small_tagged ((((sizeof (Readtable ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  t -> so . type = scheme_readtable_type ; 
  if (orig_t )
    ht = FUNCCALL(SETUP_XfOrM950(_), scheme_clone_hash_table (orig_t -> mapping ) ); 
  else ht = FUNCCALL(SETUP_XfOrM950(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  t -> mapping = ht ; 
  fast = FUNCCALL(SETUP_XfOrM950(_), GC_malloc_atomic (128 ) ); 
  (memcpy (fast , (orig_t ? orig_t -> fast_mapping : builtin_fast ) , 128 ) ) ; 
  t -> fast_mapping = fast ; 
  t -> symbol_parser = (orig_t ? orig_t -> symbol_parser : ((void * ) 0 ) ) ; 
  for (i = 1 ; i < argc ; i += 3 ) {
#   define XfOrM967_COUNT (0+XfOrM950_COUNT)
#   define SETUP_XfOrM967(x) SETUP_XfOrM950(x)
    if (! (((argv [i ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((long ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) ) {
#     define XfOrM982_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM982(x) SETUP_XfOrM967(x)
      FUNCCALL_EMPTY(scheme_wrong_type ("make-readtable" , "character or #f" , i , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (i + 1 >= argc ) {
#     define XfOrM981_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM981(x) SETUP_XfOrM967(x)
      if ((((argv [i ] ) ) == (scheme_false ) ) )
        FUNCCALL(SETUP_XfOrM981(_), scheme_arg_mismatch ("make-readtable" , "expected 'non-terminating-macro after #f" , ((void * ) 0 ) ) ); 
      else FUNCCALL(SETUP_XfOrM981(_), scheme_arg_mismatch ("make-readtable" , "expected 'terminating-macro, 'non-terminating-macro, 'dispatch-macro," " or character argument after character argument: " , argv [i ] ) ); 
    }
    sym = argv [i + 1 ] ; 
    if (! ((sym ) == (terminating_macro_symbol ) ) && ! ((sym ) == (non_terminating_macro_symbol ) ) && ! ((sym ) == (dispatch_macro_symbol ) ) && ! ((Scheme_Type ) (((((long ) (sym ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sym ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) ) {
#     define XfOrM980_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM980(x) SETUP_XfOrM967(x)
      FUNCCALL_EMPTY(scheme_wrong_type ("make-readtable" , "'terminating-macro, 'non-terminating-macro, 'dispatch-macro, or character" , i + 1 , argc , argv ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if ((((argv [i ] ) ) == (scheme_false ) ) && ! ((sym ) == (non_terminating_macro_symbol ) ) ) {
#     define XfOrM979_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM979(x) SETUP_XfOrM967(x)
      FUNCCALL(SETUP_XfOrM979(_), scheme_arg_mismatch ("make-readtable" , "expected 'non-terminating-macro after #f, given: " , sym ) ); 
    }
    if (i + 2 >= argc ) {
#     define XfOrM978_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM978(x) SETUP_XfOrM967(x)
      FUNCCALL(SETUP_XfOrM978(_), scheme_arg_mismatch ("make-readtable" , (((Scheme_Type ) (((((long ) (sym ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sym ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) ? "expected readtable or #f argument after character argument, given: " : "expected procedure argument after symbol argument, given: " ) , argv [i + 1 ] ) ); 
    }
    if ((((argv [i ] ) ) == (scheme_false ) ) ) {
#     define XfOrM977_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM977(x) SETUP_XfOrM967(x)
      FUNCCALL(SETUP_XfOrM977(_), scheme_check_proc_arity ("make-readtable" , 6 , i + 2 , argc , argv ) ); 
      t -> symbol_parser = argv [i + 2 ] ; 
    }
    else if (((sym ) == (dispatch_macro_symbol ) ) ) {
#     define XfOrM976_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM976(x) SETUP_XfOrM967(x)
      ch = (((Scheme_Small_Object * ) (argv [i ] ) ) -> u . char_val ) ; 
      FUNCCALL(SETUP_XfOrM976(_), scheme_check_proc_arity ("make-readtable" , 6 , i + 2 , argc , argv ) ); 
      FUNCCALL_AGAIN(scheme_hash_set (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (- ch ) ) << 1 ) | 0x1 ) ) , argv [i + 2 ] ) ); 
    }
    else {
#     define XfOrM968_COUNT (0+XfOrM967_COUNT)
#     define SETUP_XfOrM968(x) SETUP_XfOrM967(x)
      if (((Scheme_Type ) (((((long ) (sym ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sym ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) ) {
        Readtable * src ; 
        int sch ; 
#       define XfOrM972_COUNT (0+XfOrM968_COUNT)
#       define SETUP_XfOrM972(x) SETUP_XfOrM968(x)
        src = NULLED_OUT ; 
        if ((((argv [i + 2 ] ) ) == (scheme_false ) ) ) {
          src = ((void * ) 0 ) ; 
        }
        else {
#         define XfOrM973_COUNT (0+XfOrM972_COUNT)
#         define SETUP_XfOrM973(x) SETUP_XfOrM972(x)
          if (! ((Scheme_Type ) (scheme_readtable_type ) == (Scheme_Type ) (((((long ) (argv [i + 2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + 2 ] ) ) -> type ) ) ) ) {
#           define XfOrM974_COUNT (0+XfOrM973_COUNT)
#           define SETUP_XfOrM974(x) SETUP_XfOrM973(x)
            FUNCCALL_EMPTY(scheme_wrong_type ("make-readtable" , "readtable or #f" , i + 2 , argc , argv ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          src = (Readtable * ) (argv [i + 2 ] ) ; 
        }
        sch = (((Scheme_Small_Object * ) (argv [i + 1 ] ) ) -> u . char_val ) ; 
        if (! src )
          val = ((void * ) 0 ) ; 
        else val = FUNCCALL(SETUP_XfOrM972(_), scheme_hash_get (src -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (sch ) ) << 1 ) | 0x1 ) ) ) ); 
        if (! val )
          val = FUNCCALL(SETUP_XfOrM972(_), scheme_make_pair (((Scheme_Object * ) (void * ) (long ) ((((long ) (0x20 ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (long ) ((((long ) (sch ) ) << 1 ) | 0x1 ) ) ) ); 
      }
      else {
        int kind ; 
#       define XfOrM971_COUNT (0+XfOrM968_COUNT)
#       define SETUP_XfOrM971(x) SETUP_XfOrM968(x)
        FUNCCALL(SETUP_XfOrM971(_), scheme_check_proc_arity ("make-readtable" , 6 , i + 2 , argc , argv ) ); 
        kind = (((sym ) == (non_terminating_macro_symbol ) ) ? 0x2 : 0x4 ) ; 
        val = FUNCCALL(SETUP_XfOrM971(_), scheme_make_pair (((Scheme_Object * ) (void * ) (long ) ((((long ) (kind ) ) << 1 ) | 0x1 ) ) , argv [i + 2 ] ) ); 
      }
      ch = (((Scheme_Small_Object * ) (argv [i ] ) ) -> u . char_val ) ; 
      if (! val ) {
#       define XfOrM970_COUNT (0+XfOrM968_COUNT)
#       define SETUP_XfOrM970(x) SETUP_XfOrM968(x)
        FUNCCALL(SETUP_XfOrM970(_), scheme_hash_set (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) ); 
        if (ch < 128 )
          t -> fast_mapping [ch ] = 0 ; 
      }
      else {
#       define XfOrM969_COUNT (0+XfOrM968_COUNT)
#       define SETUP_XfOrM969(x) SETUP_XfOrM968(x)
        FUNCCALL(SETUP_XfOrM969(_), scheme_hash_set (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) , val ) ); 
        if (ch < 128 )
          t -> fast_mapping [ch ] = (char ) (((long ) ((((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
      }
    }
  }
  RET_VALUE_START ((Scheme_Object * ) t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * readtable_mapping (int argc , Scheme_Object * * argv ) {
  Scheme_Object * v1 , * v2 , * a [3 ] ; 
  Readtable * t ; 
  int ch ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(v2, 0), PUSH(v1, 1), PUSH(t, 2), PUSHARRAY(a, 3, 3), PUSH(argv, 6)));
# define XfOrM988_COUNT (7)
# define SETUP_XfOrM988(x) SETUP(XfOrM988_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v1 = NULLED_OUT ; 
  v2 = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  t = NULLED_OUT ; 
  if (! ((Scheme_Type ) (scheme_readtable_type ) == (Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) ) {
#   define XfOrM995_COUNT (0+XfOrM988_COUNT)
#   define SETUP_XfOrM995(x) SETUP_XfOrM988(x)
    FUNCCALL(SETUP_XfOrM995(_), scheme_wrong_type ("readtable-mapping" , "readtable" , 0 , argc , argv ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (! ((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) ) {
#   define XfOrM994_COUNT (0+XfOrM988_COUNT)
#   define SETUP_XfOrM994(x) SETUP_XfOrM988(x)
    FUNCCALL(SETUP_XfOrM994(_), scheme_wrong_type ("readtable-mapping" , "character" , 1 , argc , argv ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  t = (Readtable * ) argv [0 ] ; 
  ch = (((Scheme_Small_Object * ) (argv [1 ] ) ) -> u . char_val ) ; 
  v1 = FUNCCALL(SETUP_XfOrM988(_), scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (ch ) ) << 1 ) | 0x1 ) ) ) ); 
  v2 = FUNCCALL_AGAIN(scheme_hash_get (t -> mapping , ((Scheme_Object * ) (void * ) (long ) ((((long ) (- ch ) ) << 1 ) | 0x1 ) ) ) ); 
  a [0 ] = argv [1 ] ; 
  a [1 ] = scheme_false ; 
  if (v1 ) {
    int v ; 
#   define XfOrM990_COUNT (0+XfOrM988_COUNT)
#   define SETUP_XfOrM990(x) SETUP_XfOrM988(x)
    v = (((long ) ((((Scheme_Simple_Object * ) (v1 ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
    if (v & 0x20 ) {
#     define XfOrM993_COUNT (0+XfOrM990_COUNT)
#     define SETUP_XfOrM993(x) SETUP_XfOrM990(x)
      v = (((long ) ((((Scheme_Simple_Object * ) (v1 ) ) -> u . pair_val . cdr ) ) ) >> 1 ) ; 
      a [0 ] = ((((mzchar ) v ) < 256 ) ? scheme_char_constants [(unsigned char ) (v ) ] : FUNCCALL(SETUP_XfOrM993(_), scheme_make_char (v ) )) ; 
      a [1 ] = scheme_false ; 
    }
    else if (v & 0x2 ) {
      a [0 ] = non_terminating_macro_symbol ; 
      a [1 ] = (((Scheme_Simple_Object * ) (v1 ) ) -> u . pair_val . cdr ) ; 
    }
    else if (v & 0x4 ) {
      a [0 ] = terminating_macro_symbol ; 
      a [1 ] = (((Scheme_Simple_Object * ) (v1 ) ) -> u . pair_val . cdr ) ; 
    }
  }
  a [2 ] = scheme_false ; 
  if (v2 ) {
    a [2 ] = v2 ; 
  }
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM988(_), scheme_values (3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * readtable_p (int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return (((Scheme_Type ) (scheme_readtable_type ) == (Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * readtable_or_false_p (int argc , Scheme_Object * * argv ) {
  /* No conversion */
  if ((((argv [0 ] ) ) == (scheme_false ) ) )
    return scheme_true ; 
  return readtable_p (argc , argv ) ; 
}
static Scheme_Object * current_readtable (int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return scheme_param_config ("current-readtable" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_READTABLE ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , readtable_or_false_p , "readtable" , 0 ) ; 
}
static Scheme_Object * current_reader_guard (int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return scheme_param_config ("current-reader-guard" , ((Scheme_Object * ) (void * ) (long ) ((((long ) (MZCONFIG_READER_GUARD ) ) << 1 ) | 0x1 ) ) , argc , argv , 1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}
static Scheme_Object * no_val_thunk (void * d , int argc , Scheme_Object * * argv ) {
  /* No conversion */
  return (Scheme_Object * ) d ; 
}
static Scheme_Object * do_reader (Scheme_Object * modpath_stx , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int get_info , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * modpath , * name , * a [3 ] , * proc , * v , * no_val ; 
  int num_a ; 
  Scheme_Config * __funcarg158 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(13);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(name, 1), PUSH(stxsrc, 2), PUSH(modpath_stx, 3), PUSH(modpath, 4), PUSHARRAY(a, 3, 5), PUSH(params, 8), PUSH(v, 9), PUSH(no_val, 10), PUSH(ht, 11), PUSH(port, 12)));
# define XfOrM1001_COUNT (13)
# define SETUP_XfOrM1001(x) SETUP(XfOrM1001_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  modpath = NULLED_OUT ; 
  name = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  v = NULLED_OUT ; 
  no_val = NULLED_OUT ; 
  if (stxsrc )
    modpath = FUNCCALL(SETUP_XfOrM1001(_), scheme_syntax_to_datum (modpath_stx , 0 , ((void * ) 0 ) ) ); 
  else modpath = modpath_stx ; 
  proc = (__funcarg158 = FUNCCALL(SETUP_XfOrM1001(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg158 , MZCONFIG_READER_GUARD ) )) ; 
  a [0 ] = modpath ; 
  modpath = FUNCCALL(SETUP_XfOrM1001(_), scheme_apply (proc , 1 , a ) ); 
  a [0 ] = modpath ; 
  if (get_info )
    name = FUNCCALL(SETUP_XfOrM1001(_), scheme_intern_symbol ("get-info" ) ); 
  else if (stxsrc )
    name = FUNCCALL(SETUP_XfOrM1001(_), scheme_intern_symbol ("read-syntax" ) ); 
  else name = FUNCCALL(SETUP_XfOrM1001(_), scheme_intern_symbol ("read" ) ); 
  a [1 ] = name ; 
  if (get_info ) {
#   define XfOrM1007_COUNT (0+XfOrM1001_COUNT)
#   define SETUP_XfOrM1007(x) SETUP_XfOrM1001(x)
    no_val = FUNCCALL(SETUP_XfOrM1007(_), scheme_make_pair (scheme_false , scheme_false ) ); 
    a [2 ] = FUNCCALL(SETUP_XfOrM1007(_), scheme_make_closed_prim (no_val_thunk , no_val ) ); 
    num_a = 3 ; 
  }
  else {
    no_val = ((void * ) 0 ) ; 
    num_a = 2 ; 
  }
  proc = FUNCCALL(SETUP_XfOrM1001(_), scheme_dynamic_require (num_a , a ) ); 
  if (get_info ) {
#   define XfOrM1005_COUNT (0+XfOrM1001_COUNT)
#   define SETUP_XfOrM1005(x) SETUP_XfOrM1001(x)
    proc = FUNCCALL(SETUP_XfOrM1005(_), scheme_force_value (proc ) ); 
  }
  if (get_info && ((proc ) == (no_val ) ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  a [0 ] = proc ; 
  if (FUNCCALL(SETUP_XfOrM1001(_), scheme_check_proc_arity (((void * ) 0 ) , stxsrc ? 6 : 5 , 0 , 1 , a ) )) {
  }
  else if (! get_info && FUNCCALL(SETUP_XfOrM1001(_), scheme_check_proc_arity (((void * ) 0 ) , stxsrc ? 2 : 1 , 0 , 1 , a ) )) {
    modpath_stx = ((void * ) 0 ) ; 
  }
  else {
#   define XfOrM1002_COUNT (0+XfOrM1001_COUNT)
#   define SETUP_XfOrM1002(x) SETUP_XfOrM1001(x)
    FUNCCALL(SETUP_XfOrM1002(_), scheme_wrong_type ("#reader" , (stxsrc ? "procedure (arity 2 or 6)" : (get_info ? "procedure (arity 5)" : "procedure (arity 1 or 5)" ) ) , - 1 , - 1 , a ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  v = FUNCCALL(SETUP_XfOrM1001(_), readtable_call (0 , 0 , proc , params , port , stxsrc , line , col , pos , get_info , ht , modpath_stx ) ); 
  if (! get_info && FUNCCALL(SETUP_XfOrM1001(_), scheme_special_comment_value (v ) ))
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  else RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_reader (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params ) {
  Scheme_Object * modpath ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(indentation, 0), PUSH(params, 1), PUSH(stxsrc, 2), PUSH(ht, 3), PUSH(port, 4), PUSH(modpath, 5)));
# define XfOrM1008_COUNT (6)
# define SETUP_XfOrM1008(x) SETUP(XfOrM1008_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  modpath = NULLED_OUT ; 
  if (stxsrc )
    modpath = FUNCCALL(SETUP_XfOrM1008(_), scheme_read_syntax (port , stxsrc ) ); 
  else modpath = FUNCCALL(SETUP_XfOrM1008(_), scheme_read (port ) ); 
  if ((((modpath ) ) == (scheme_eof ) ) ) {
#   define XfOrM1009_COUNT (0+XfOrM1008_COUNT)
#   define SETUP_XfOrM1009(x) SETUP_XfOrM1008(x)
    FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , 1 , (- 1 ) , indentation , "read: expected a datum after #reader, found end-of-file" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_reader (modpath , port , stxsrc , line , col , pos , 0 , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * read_lang (Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int get_info , Scheme_Hash_Table * * ht , Scheme_Object * indentation , ReadParams * params , int init_ch ) {
  int size , len ; 
  GC_CAN_IGNORE char * sfx ; 
  char * buf , * naya ; 
  int ch = 0 ; 
  Scheme_Object * modpath ; 
  long name_line = - 1 , name_col = - 1 , name_pos = - 1 ; 
  long __funcarg165 ; 
  long __funcarg164 ; 
  long __funcarg161 ; 
  long __funcarg160 ; 
  long __funcarg159 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(stxsrc, 0), PUSH(indentation, 1), PUSH(naya, 2), PUSH(modpath, 3), PUSH(params, 4), PUSH(buf, 5), PUSH(ht, 6), PUSH(port, 7)));
# define XfOrM1010_COUNT (8)
# define SETUP_XfOrM1010(x) SETUP(XfOrM1010_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buf = NULLED_OUT ; 
  naya = NULLED_OUT ; 
  modpath = NULLED_OUT ; 
  size = 32 ; 
  buf = ((char * ) FUNCCALL(SETUP_XfOrM1010(_), GC_malloc_atomic (sizeof (char ) * (size ) ) )) ; 
  len = 0 ; 
  while (1 ) {
#   define XfOrM1027_COUNT (0+XfOrM1010_COUNT)
#   define SETUP_XfOrM1027(x) SETUP_XfOrM1010(x)
    if (! len && init_ch ) {
      ch = init_ch ; 
    }
    else ch = FUNCCALL(SETUP_XfOrM1027(_), scheme_getc_special_ok (port ) ); 
    if (! len )
      FUNCCALL(SETUP_XfOrM1027(_), scheme_tell_all (port , & name_line , & name_col , & name_pos ) ); 
    if (ch == (- 1 ) ) {
      break ; 
    }
    else if (ch == (- 2 ) ) {
#     define XfOrM1033_COUNT (0+XfOrM1027_COUNT)
#     define SETUP_XfOrM1033(x) SETUP_XfOrM1027(x)
      (__funcarg165 = FUNCCALL(SETUP_XfOrM1033(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg165 , ch , indentation , "read: found non-character while reading `#lang'" ) )) ; 
    }
    else if ((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) ) {
      break ; 
    }
    else {
#     define XfOrM1028_COUNT (0+XfOrM1027_COUNT)
#     define SETUP_XfOrM1028(x) SETUP_XfOrM1027(x)
      if ((ch < 128 ) && (((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x80 ) || (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x40 ) || ((ch ) == '-' ) || ((ch ) == '+' ) || ((ch ) == '_' ) ) || (ch == '/' ) ) ) {
#       define XfOrM1030_COUNT (0+XfOrM1028_COUNT)
#       define SETUP_XfOrM1030(x) SETUP_XfOrM1028(x)
        if (len + 1 >= size ) {
          size *= 2 ; 
#         define XfOrM1031_COUNT (0+XfOrM1030_COUNT)
#         define SETUP_XfOrM1031(x) SETUP_XfOrM1030(x)
          naya = ((char * ) FUNCCALL(SETUP_XfOrM1031(_), GC_malloc_atomic (sizeof (char ) * (size ) ) )) ; 
          (memcpy (naya , buf , len * sizeof (char ) ) ) ; 
          buf = naya ; 
        }
        buf [len ++ ] = ch ; 
      }
      else {
#       define XfOrM1029_COUNT (0+XfOrM1028_COUNT)
#       define SETUP_XfOrM1029(x) SETUP_XfOrM1028(x)
        (__funcarg164 = FUNCCALL(SETUP_XfOrM1029(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg164 , ch , indentation , "read: expected only alphanumberic, `-', `+', `_', or `/'" " characters for `#%s', found %c" , init_ch ? "!" : "lang" , ch ) )) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
  }
  if (! len ) {
#   define XfOrM1017_COUNT (0+XfOrM1010_COUNT)
#   define SETUP_XfOrM1017(x) SETUP_XfOrM1010(x)
    (__funcarg161 = FUNCCALL(SETUP_XfOrM1017(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg161 , ch , indentation , (((ch == ' ' ) && ! init_ch ) ? "read: expected a single space after `#lang'" : "read: expected a non-empty sequence of alphanumberic, `-', `+', `_', or `/' after `#%s'" ) , init_ch ? "!" : "lang " ) )) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (buf [0 ] == '/' ) {
#   define XfOrM1016_COUNT (0+XfOrM1010_COUNT)
#   define SETUP_XfOrM1016(x) SETUP_XfOrM1010(x)
    (__funcarg160 = FUNCCALL(SETUP_XfOrM1016(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg160 , ch , indentation , "read: expected a name that does not start `/' after `#lang'" ) )) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (buf [len - 1 ] == '/' ) {
#   define XfOrM1015_COUNT (0+XfOrM1010_COUNT)
#   define SETUP_XfOrM1015(x) SETUP_XfOrM1010(x)
    (__funcarg159 = FUNCCALL(SETUP_XfOrM1015(_), SPAN (port , pos ) ), FUNCCALL_EMPTY(scheme_read_err (port , stxsrc , line , col , pos , __funcarg159 , ch , indentation , "read: expected a name that does not end `/' after `#%s'" , init_ch ? "!" : "lang" ) )) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (len + 16 >= size ) {
#   define XfOrM1014_COUNT (0+XfOrM1010_COUNT)
#   define SETUP_XfOrM1014(x) SETUP_XfOrM1010(x)
    size += 16 ; 
    naya = ((char * ) FUNCCALL(SETUP_XfOrM1014(_), GC_malloc_atomic (sizeof (char ) * (size * sizeof (char ) ) ) )) ; 
    (memcpy (naya , buf , len * sizeof (char ) ) ) ; 
    buf = naya ; 
  }
  sfx = "/lang/reader" ; 
  while (* sfx ) {
    buf [len ++ ] = * (sfx ++ ) ; 
  }
  buf [len ] = 0 ; 
  modpath = FUNCCALL(SETUP_XfOrM1010(_), scheme_intern_symbol (buf ) ); 
  if (stxsrc ) {
    long span ; 
#   define XfOrM1011_COUNT (0+XfOrM1010_COUNT)
#   define SETUP_XfOrM1011(x) SETUP_XfOrM1010(x)
    span = FUNCCALL(SETUP_XfOrM1011(_), SPAN (port , name_pos ) ); 
    modpath = FUNCCALL(SETUP_XfOrM1011(_), scheme_make_stx_w_offset (modpath , name_line , name_col , name_pos , span - ((ch == (- 1 ) ) ? 0 : 1 ) , stxsrc , scheme_false ) ); 
  }
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_reader (modpath , port , stxsrc , line , col , pos , get_info , ht , indentation , params ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_read_language (Scheme_Object * port , int nonlang_ok ) {
  /* No conversion */
  return _internal_read (port , ((void * ) 0 ) , 0 , 0 , 0 , 0 , 0 , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , nonlang_ok ? 2 : 1 ) ; 
}
static Scheme_Object * expected_lang (const char * prefix , int ch , Scheme_Object * port , Scheme_Object * stxsrc , long line , long col , long pos , int get_lang ) {
  /* No conversion */
  if (get_lang > 1 ) {
    return scheme_void ; 
  }
  else {
    scheme_read_err (port , stxsrc , line , col , pos , 1 , 0 , ((void * ) 0 ) , "read-language: expected `#lang' or `#!', found `%s%c'" , prefix , ch ) ; 
    return ((void * ) 0 ) ; 
  }
}
static int mark_indent_SIZE (void * p ) {
  return ((sizeof (Scheme_Indent ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_indent_MARK (void * p ) {
  return ((sizeof (Scheme_Indent ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_indent_FIXUP (void * p ) {
  return ((sizeof (Scheme_Indent ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_cport_SIZE (void * p ) {
  return ((sizeof (CPort ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_cport_MARK (void * p ) {
  CPort * cp = (CPort * ) p ; 
  GC_mark (cp -> start ) ; 
  GC_mark (cp -> orig_port ) ; 
  GC_mark (cp -> ht ) ; 
  GC_mark (cp -> ut ) ; 
  GC_mark (cp -> symtab ) ; 
  GC_mark (cp -> insp ) ; 
  GC_mark (cp -> relto ) ; 
  GC_mark (cp -> magic_sym ) ; 
  GC_mark (cp -> magic_val ) ; 
  GC_mark (cp -> shared_offsets ) ; 
  GC_mark (cp -> delay_info ) ; 
  return ((sizeof (CPort ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_cport_FIXUP (void * p ) {
  CPort * cp = (CPort * ) p ; 
  GC_fixup (& (cp -> start ) ) ; 
  GC_fixup (& (cp -> orig_port ) ) ; 
  GC_fixup (& (cp -> ht ) ) ; 
  GC_fixup (& (cp -> ut ) ) ; 
  GC_fixup (& (cp -> symtab ) ) ; 
  GC_fixup (& (cp -> insp ) ) ; 
  GC_fixup (& (cp -> relto ) ) ; 
  GC_fixup (& (cp -> magic_sym ) ) ; 
  GC_fixup (& (cp -> magic_val ) ) ; 
  GC_fixup (& (cp -> shared_offsets ) ) ; 
  GC_fixup (& (cp -> delay_info ) ) ; 
  return ((sizeof (CPort ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_readtable_SIZE (void * p ) {
  return ((sizeof (Readtable ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_readtable_MARK (void * p ) {
  Readtable * t = (Readtable * ) p ; 
  GC_mark (t -> mapping ) ; 
  GC_mark (t -> fast_mapping ) ; 
  GC_mark (t -> symbol_parser ) ; 
  GC_mark (t -> names ) ; 
  return ((sizeof (Readtable ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_readtable_FIXUP (void * p ) {
  Readtable * t = (Readtable * ) p ; 
  GC_fixup (& (t -> mapping ) ) ; 
  GC_fixup (& (t -> fast_mapping ) ) ; 
  GC_fixup (& (t -> symbol_parser ) ) ; 
  GC_fixup (& (t -> names ) ) ; 
  return ((sizeof (Readtable ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_read_params_SIZE (void * p ) {
  return ((sizeof (ReadParams ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_read_params_MARK (void * p ) {
  ReadParams * rp = (ReadParams * ) p ; 
  GC_mark (rp -> table ) ; 
  GC_mark (rp -> magic_sym ) ; 
  GC_mark (rp -> magic_val ) ; 
  GC_mark (rp -> delay_load_info ) ; 
  return ((sizeof (ReadParams ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_read_params_FIXUP (void * p ) {
  ReadParams * rp = (ReadParams * ) p ; 
  GC_fixup (& (rp -> table ) ) ; 
  GC_fixup (& (rp -> magic_sym ) ) ; 
  GC_fixup (& (rp -> magic_val ) ) ; 
  GC_fixup (& (rp -> delay_load_info ) ) ; 
  return ((sizeof (ReadParams ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_delay_load_SIZE (void * p ) {
  return ((sizeof (Scheme_Load_Delay ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_delay_load_MARK (void * p ) {
  Scheme_Load_Delay * ld = (Scheme_Load_Delay * ) p ; 
  GC_mark (ld -> path ) ; 
  GC_mark (ld -> symtab ) ; 
  GC_mark (ld -> shared_offsets ) ; 
  GC_mark (ld -> insp ) ; 
  GC_mark (ld -> relto ) ; 
  GC_mark (ld -> ut ) ; 
  GC_mark (ld -> current_rp ) ; 
  GC_mark (ld -> cached ) ; 
  GC_mark (ld -> cached_port ) ; 
  return ((sizeof (Scheme_Load_Delay ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_delay_load_FIXUP (void * p ) {
  Scheme_Load_Delay * ld = (Scheme_Load_Delay * ) p ; 
  GC_fixup (& (ld -> path ) ) ; 
  GC_fixup (& (ld -> symtab ) ) ; 
  GC_fixup (& (ld -> shared_offsets ) ) ; 
  GC_fixup (& (ld -> insp ) ) ; 
  GC_fixup (& (ld -> relto ) ) ; 
  GC_fixup (& (ld -> ut ) ) ; 
  GC_fixup (& (ld -> current_rp ) ) ; 
  GC_fixup (& (ld -> cached ) ) ; 
  GC_fixup (& (ld -> cached_port ) ) ; 
  return ((sizeof (Scheme_Load_Delay ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_unmarshal_tables_SIZE (void * p ) {
  return ((sizeof (Scheme_Unmarshal_Tables ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_unmarshal_tables_MARK (void * p ) {
  Scheme_Unmarshal_Tables * ut = (Scheme_Unmarshal_Tables * ) p ; 
  GC_mark (ut -> rns ) ; 
  GC_mark (ut -> rp ) ; 
  GC_mark (ut -> decoded ) ; 
  return ((sizeof (Scheme_Unmarshal_Tables ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_unmarshal_tables_FIXUP (void * p ) {
  Scheme_Unmarshal_Tables * ut = (Scheme_Unmarshal_Tables * ) p ; 
  GC_fixup (& (ut -> rns ) ) ; 
  GC_fixup (& (ut -> rp ) ) ; 
  GC_fixup (& (ut -> decoded ) ) ; 
  return ((sizeof (Scheme_Unmarshal_Tables ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static void register_traversers (void ) {
  GC_register_traversers (scheme_indent_type , mark_indent_SIZE , mark_indent_MARK , mark_indent_FIXUP , 1 , 1 ) ; 
  GC_register_traversers (scheme_rt_compact_port , mark_cport_SIZE , mark_cport_MARK , mark_cport_FIXUP , 1 , 0 ) ; 
  GC_register_traversers (scheme_readtable_type , mark_readtable_SIZE , mark_readtable_MARK , mark_readtable_FIXUP , 1 , 0 ) ; 
  GC_register_traversers (scheme_rt_read_params , mark_read_params_SIZE , mark_read_params_MARK , mark_read_params_FIXUP , 1 , 0 ) ; 
  GC_register_traversers (scheme_rt_delay_load_info , mark_delay_load_SIZE , mark_delay_load_MARK , mark_delay_load_FIXUP , 1 , 0 ) ; 
  GC_register_traversers (scheme_rt_unmarshal_info , mark_unmarshal_tables_SIZE , mark_unmarshal_tables_MARK , mark_unmarshal_tables_FIXUP , 1 , 0 ) ; 
}
