#include "precomp.h"
enum {
  mzu_Cn , mzu_Cc , mzu_Cf , mzu_Cs , mzu_Co , mzu_Ll , mzu_Lu , mzu_Lt , mzu_Lm , mzu_Lo , mzu_Nd , mzu_Nl , mzu_No , mzu_Ps , mzu_Pe , mzu_Pi , mzu_Pf , mzu_Pc , mzu_Pd , mzu_Po , mzu_Mn , mzu_Mc , mzu_Me , mzu_Sc , mzu_Sk , mzu_Sm , mzu_So , mzu_Zl , mzu_Zp , mzu_Zs }
; 
typedef long rxpos ; 
struct Regwork ; 
typedef int (* Scheme_Regexp_Matcher ) (struct Regwork * rw ) ; 
typedef struct regexp {
  Scheme_Type type ; 
  short keyex ; 
  Scheme_Object * source ; 
  long nsubexp , ncounter , maxlookback ; 
  long regsize ; 
  short flags ; 
  unsigned char * regstart ; 
  long regmust ; 
  long regmlen ; 
  char program [1 ] ; 
}
regexp ; 
typedef struct Regwork {
  Scheme_Type type ; 
  char * str ; 
  char * instr ; 
  Scheme_Object * port ; 
  Scheme_Object * unless_evt ; 
  short nonblock , aborted ; 
  rxpos instr_size ; 
  rxpos input_maxend ; 
  rxpos input , input_end , input_start ; 
  rxpos boi , bol ; 
  rxpos * startp ; 
  rxpos * maybep ; 
  rxpos * endp ; 
  int * counters ; 
  Scheme_Object * peekskip ; 
}
Regwork ; 
static regexp * regcomp (char * , rxpos , int , int ) ; 
static char * regstr ; 
static char * regparsestr ; 
static int regmatchmin ; 
static int regmatchmax ; 
static int regmaxbackposn ; 
static int regsavepos ; 
static Scheme_Hash_Table * regbackknown ; 
static Scheme_Hash_Table * regbackdepends ; 
static rxpos regparse ; 
static rxpos regparse_end ; 
static int regnpar ; 
static int regncounter ; 
static rxpos regcode ; 
static rxpos regcodesize ; 
static rxpos regcodemax ; 
static long regmaxlookback ; 
static long rx_buffer_size ; 
static rxpos * startp_buffer_cache ; 
static rxpos * endp_buffer_cache ; 
static rxpos * maybep_buffer_cache ; 
static rxpos reg (int , int * , int , int , int ) ; 
static rxpos regbranch (int * , int , int ) ; 
static rxpos regpiece (int * , int , int ) ; 
static rxpos regatom (int * , int , int ) ; 
static rxpos regranges (int parse_flags , int at_start ) ; 
static rxpos regunicode (int invert ) ; 
static int regdigit () ; 
static rxpos regnode (char ) ; 
static void regarg (int ) ; 
static rxpos regnext (rxpos ) ; 
static void regc (char ) ; 
static void reginsert (char , rxpos ) ; 
static rxpos reginsertwithop (char , rxpos , int ) ; 
static rxpos reginsertwithopop (char , rxpos , int , int ) ; 
static void regtail (rxpos , rxpos ) ; 
static void regoptail (rxpos , rxpos ) ; 
static int regstrcspn (char * , char * , char * ) ; 
static unsigned char * extract_regstart (rxpos scan , int * _anch ) ; 
static int check_and_propagate_depends (void ) ; 
static int merge_tables (Scheme_Hash_Table * dest , Scheme_Hash_Table * src ) ; 
static void regerror (char * s ) {
  /* No conversion */
  scheme_raise_exn (MZEXN_FAIL_CONTRACT , "regexp: %s" , s ) ; 
}
const char * failure_msg_for_read ; 
static void regcomperror (char * s ) {
  /* No conversion */
  if (failure_msg_for_read ) {
    failure_msg_for_read = s ; 
    (((long * ) (void * ) ((* (scheme_current_thread -> error_buf ) ) . gcvs ) ) [1 ] = (* (scheme_current_thread -> error_buf ) ) . gcvs_cnt , GC_variable_stack = (void * * ) (void * ) (* (scheme_current_thread -> error_buf ) ) . gcvs , scheme_jit_longjmp ((* (scheme_current_thread -> error_buf ) ) . jb , 1 ) ) ; 
  }
  else regerror (s ) ; 
}
static regexp * regcomp (char * expstr , rxpos exp , int explen , int pcre ) {
  regexp * r ; 
  rxpos scan , next ; 
  rxpos longest ; 
  int len , longest_is_ci ; 
  int flags ; 
  DECL_RET_SAVE (regexp * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(r, 0)));
# define XfOrM4_COUNT (1)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 
  regstr = ((void * ) 0 ) ; 
  regparsestr = expstr ; 
  regparse = exp ; 
  regparse_end = exp + explen ; 
  regnpar = 1 ; 
  regncounter = 0 ; 
  regmaxlookback = 0 ; 
  regcode = 1 ; 
  regcodesize = 0 ; 
  regcodemax = 0 ; 
  regmaxbackposn = 0 ; 
  regbackknown = ((void * ) 0 ) ; 
  regbackdepends = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM4(_), regc (156 ) ); 
  if (FUNCCALL(SETUP_XfOrM4(_), reg (0 , & flags , 0 , 0 , 0x1 | 0x4 | (pcre ? 0x2 : 0 ) ) )== 0 ) {
#   define XfOrM53_COUNT (0+XfOrM4_COUNT)
#   define SETUP_XfOrM53(x) SETUP_XfOrM4(x)
    {
#     define XfOrM54_COUNT (0+XfOrM53_COUNT)
#     define SETUP_XfOrM54(x) SETUP_XfOrM53(x)
      FUNCCALL(SETUP_XfOrM54(_), regcomperror ("unknown regexp failure" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
  }
  if (regcodemax >= 32767L ) {
#   define XfOrM52_COUNT (0+XfOrM4_COUNT)
#   define SETUP_XfOrM52(x) SETUP_XfOrM4(x)
    FUNCCALL(SETUP_XfOrM52(_), regcomperror ("regexp too big" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  if (regmaxbackposn >= regnpar ) {
#   define XfOrM51_COUNT (0+XfOrM4_COUNT)
#   define SETUP_XfOrM51(x) SETUP_XfOrM4(x)
    FUNCCALL(SETUP_XfOrM51(_), regcomperror ("backreference number is larger than the highest-numbered cluster" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  r = (regexp * ) FUNCCALL(SETUP_XfOrM4(_), GC_malloc_one_tagged (sizeof (regexp ) + (unsigned ) regcodemax ) ); 
  r -> type = scheme_regexp_type ; 
  r -> regsize = regcodemax ; 
  r -> nsubexp = regnpar ; 
  r -> ncounter = regncounter ; 
  r -> maxlookback = regmaxlookback ; 
  regparse = exp ; 
  regparse_end = exp + explen ; 
  regnpar = 1 ; 
  regncounter = 0 ; 
  regcodesize = regcodemax ; 
  regstr = (char * ) r ; 
  regcode = (char * ) r -> program - (char * ) r ; 
  regcodesize += regcode ; 
  regcodemax = 0 ; 
  regbackknown = ((void * ) 0 ) ; 
  regbackdepends = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM4(_), regc (156 ) ); 
  if (FUNCCALL(SETUP_XfOrM4(_), reg (0 , & flags , 0 , 0 , 0x1 | 0x4 | (pcre ? 0x2 : 0 ) ) )== 0 ) {
#   define XfOrM49_COUNT (0+XfOrM4_COUNT)
#   define SETUP_XfOrM49(x) SETUP_XfOrM4(x)
    {
#     define XfOrM50_COUNT (0+XfOrM49_COUNT)
#     define SETUP_XfOrM50(x) SETUP_XfOrM49(x)
      FUNCCALL(SETUP_XfOrM50(_), regcomperror ("unknown regexp failure (late)" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
  }
  if (regcode >= regcodesize ) {
#   define XfOrM47_COUNT (0+XfOrM4_COUNT)
#   define SETUP_XfOrM47(x) SETUP_XfOrM4(x)
    {
#     define XfOrM48_COUNT (0+XfOrM47_COUNT)
#     define SETUP_XfOrM48(x) SETUP_XfOrM47(x)
      FUNCCALL(SETUP_XfOrM48(_), regcomperror ("wrote too far" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
  }
  r -> regstart = ((void * ) 0 ) ; 
  r -> regmust = - 1 ; 
  r -> regmlen = 0 ; 
  scan = ((r -> program + 1 ) - (char * ) r ) ; 
  {
    unsigned char * rs ; 
    int anch = 0 ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM4_COUNT)));
#   define XfOrM46_COUNT (1+XfOrM4_COUNT)
#   define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
    rs = NULLED_OUT ; 
    rs = FUNCCALL(SETUP_XfOrM46(_), extract_regstart (scan , & anch ) ); 
    r -> regstart = rs ; 
    if (anch )
      r -> flags |= 0x04 ; 
  }
  next = FUNCCALL(SETUP_XfOrM4(_), regnext (scan ) ); 
  if ((regstr [next ] ) == 0 ) {
#   define XfOrM5_COUNT (0+XfOrM4_COUNT)
#   define SETUP_XfOrM5(x) SETUP_XfOrM4(x)
    scan = ((scan ) + 3 ) ; 
    if (flags & 0x04 ) {
      int prev_op = 0 ; 
#     define XfOrM6_COUNT (0+XfOrM5_COUNT)
#     define SETUP_XfOrM6(x) SETUP_XfOrM5(x)
      longest = 0 ; 
      longest_is_ci = 0 ; 
      len = 0 ; 
      for (; scan != 0 ; scan = FUNCCALL(SETUP_XfOrM6(_), regnext (scan ) )) {
        int mscan = scan ; 
        while (1 ) {
          int mop ; 
          mop = (regstr [mscan ] ) ; 
          if (((mop == 11 ) || (mop == 12 ) ) && ((int ) (((unsigned char * ) regstr ) [((mscan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((mscan ) + 3 ) + 1 ] ) ) >= len ) {
            rxpos ls = (((mscan ) + 3 ) + 2 ) ; 
            int ll = ((int ) (((unsigned char * ) regstr ) [((mscan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((mscan ) + 3 ) + 1 ] ) ) , i ; 
            for (i = 0 ; i < ll ; i ++ ) {
              if (! regstr [ls + i ] )
                break ; 
            }
            if (i >= ll ) {
              longest = ls ; 
              len = ll ; 
              longest_is_ci = ((regstr [mscan ] ) == 12 ) ; 
            }
            break ; 
          }
          else if ((mop == 6 ) && (1 >= len ) ) {
            if (regstr [((mscan ) + 3 ) ] ) {
              longest = ((mscan ) + 3 ) ; 
              len = 1 ; 
              longest_is_ci = 0 ; 
            }
            break ; 
          }
          else if ((mop == 9 ) && (prev_op != 9 ) ) {
            int mnext ; 
            mnext = (mscan + (((((unsigned char * ) regstr ) [(mscan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(mscan ) + 2 ] & 255 ) ) ) ; 
            if ((regstr [mnext ] ) != 9 ) {
              mscan = ((mscan ) + 3 ) ; 
            }
            else break ; 
          }
          else break ; 
        }
        prev_op = (regstr [scan ] ) ; 
      }
      if (longest ) {
        r -> regmust = longest ; 
        if (longest_is_ci )
          r -> flags |= 0x08 ; 
        r -> regmlen = len ; 
      }
    }
  }
  RET_VALUE_START ((r ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * map_create (unsigned char * map ) {
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM55_COUNT (1)
# define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (! map ) {
#   define XfOrM56_COUNT (0+XfOrM55_COUNT)
#   define SETUP_XfOrM56(x) SETUP_XfOrM55(x)
    map = (unsigned char * ) FUNCCALL(SETUP_XfOrM56(_), GC_malloc_atomic (32 ) ); 
    (memset (map , 0 , 32 ) ) ; 
  }
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * map_start (unsigned char * map , int c ) {
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM57_COUNT (1)
# define SETUP_XfOrM57(x) SETUP(XfOrM57_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  map = FUNCCALL(SETUP_XfOrM57(_), map_create (map ) ); 
  map [c >> 3 ] |= ((unsigned char ) 1 << (c & 0x7 ) ) ; 
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * map_copy (unsigned char * map , char * s , int pos ) {
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(map, 0), PUSH(s, 1)));
# define XfOrM58_COUNT (2)
# define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  map = FUNCCALL(SETUP_XfOrM58(_), map_create (map ) ); 
  (memcpy (map , s XFORM_OK_PLUS pos , 32 ) ) ; 
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * map_range (unsigned char * map , char * s , int pos , int invert ) {
  int rs , re ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM59_COUNT (1)
# define SETUP_XfOrM59(x) SETUP(XfOrM59_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rs = ((unsigned char ) (s [pos ++ ] ) ) ; 
  re = ((unsigned char ) (s [pos ++ ] ) ) ; 
  if (! invert ) {
#   define XfOrM65_COUNT (0+XfOrM59_COUNT)
#   define SETUP_XfOrM65(x) SETUP_XfOrM59(x)
    while (rs <= re ) {
#     define XfOrM67_COUNT (0+XfOrM65_COUNT)
#     define SETUP_XfOrM67(x) SETUP_XfOrM65(x)
      map = FUNCCALL(SETUP_XfOrM67(_), map_start (map , rs ) ); 
      rs ++ ; 
    }
  }
  else {
#   define XfOrM60_COUNT (0+XfOrM59_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM59(x)
    while (rs > 0 ) {
#     define XfOrM64_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM64(x) SETUP_XfOrM60(x)
      map = FUNCCALL(SETUP_XfOrM64(_), map_start (map , rs - 1 ) ); 
      -- rs ; 
    }
    while (re < 255 ) {
#     define XfOrM62_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM62(x) SETUP_XfOrM60(x)
      map = FUNCCALL(SETUP_XfOrM62(_), map_start (map , re + 1 ) ); 
      re ++ ; 
    }
  }
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * extract_regstart (rxpos scan , int * _anch ) {
  rxpos next ; 
  int retry , the_op ; 
  unsigned char * map = ((void * ) 0 ) ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(map, 0), PUSH(_anch, 1)));
# define XfOrM68_COUNT (2)
# define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  do {
#   define XfOrM75_COUNT (0+XfOrM68_COUNT)
#   define SETUP_XfOrM75(x) SETUP_XfOrM68(x)
    retry = 0 ; 
    the_op = (regstr [scan ] ) ; 
    switch (the_op ) {
#     define XfOrM76_COUNT (0+XfOrM75_COUNT)
#     define SETUP_XfOrM76(x) SETUP_XfOrM75(x)
      case 39 : case 40 : case 13 : case 35 : case 36 : case 30 : case 31 : case 32 : scan = FUNCCALL(SETUP_XfOrM76(_), regnext (scan ) ); 
      retry = 1 ; 
      break ; 
      case 22 : case 23 : case 25 : case 26 : scan += ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
      scan = FUNCCALL(SETUP_XfOrM76(_), regnext (scan ) ); 
      retry = 1 ; 
      break ; 
      case 24 : scan = FUNCCALL(SETUP_XfOrM76(_), regnext (scan ) ); 
      retry = 1 ; 
      break ; 
      case 15 : case 17 : scan = ((scan ) + 3 ) ; 
      retry = 1 ; 
      break ; 
      case 18 : case 19 : if (((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) > 0 ) {
        scan = ((scan ) + 7 ) ; 
        retry = 1 ; 
      }
      break ; 
      case 11 : map = FUNCCALL(SETUP_XfOrM76(_), map_start (map , ((unsigned char ) (regstr [(((scan ) + 3 ) + 2 ) ] ) ) ) ); 
      break ; 
      case 12 : {
        int c = ((unsigned char ) (regstr [(((scan ) + 3 ) + 2 ) ] ) ) ; 
#       define XfOrM79_COUNT (0+XfOrM76_COUNT)
#       define SETUP_XfOrM79(x) SETUP_XfOrM76(x)
        map = FUNCCALL(SETUP_XfOrM79(_), map_start (map , c ) ); 
        map = FUNCCALL(SETUP_XfOrM79(_), map_start (map , (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ) ); 
      }
      break ; 
      case 5 : map = FUNCCALL(SETUP_XfOrM76(_), map_copy (map , regstr , ((scan ) + 3 ) ) ); 
      break ; 
      case 6 : map = FUNCCALL(SETUP_XfOrM76(_), map_start (map , ((unsigned char ) (regstr [((scan ) + 3 ) ] ) ) ) ); 
      break ; 
      case 43 : map = FUNCCALL(SETUP_XfOrM76(_), map_start (map , ((unsigned char ) (regstr [((scan ) + 3 ) ] ) ) ) ); 
      map = FUNCCALL(SETUP_XfOrM76(_), map_start (map , ((unsigned char ) (regstr [((scan ) + 3 ) + 1 ] ) ) ) ); 
      break ; 
      case 7 : map = FUNCCALL(SETUP_XfOrM76(_), map_range (map , regstr , ((scan ) + 3 ) , 0 ) ); 
      break ; 
      case 8 : map = FUNCCALL(SETUP_XfOrM76(_), map_range (map , regstr , ((scan ) + 3 ) , 1 ) ); 
      break ; 
      case 1 : if (_anch )
        * _anch = 1 ; 
      break ; 
      case 9 : next = FUNCCALL(SETUP_XfOrM76(_), regnext (scan ) ); 
      if (! next || ((regstr [next ] ) == 0 ) || ((regstr [next ] ) == 27 ) ) {
        scan = ((scan ) + 3 ) ; 
        retry = 1 ; 
      }
      break ; 
      default : if ((the_op == 20 ) || (the_op >= 44 && the_op < 78 ) ) {
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        retry = 1 ; 
      }
      break ; 
    }
  }
  while (retry ) ; 
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * reg_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  int * flagp = (int * ) p -> ku . k . p1 ; 
  int res ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  res = reg (p -> ku . k . i1 , flagp , p -> ku . k . i2 , p -> ku . k . i3 , p -> ku . k . i4 ) ; 
  return ((Scheme_Object * ) (void * ) (long ) ((((long ) (res ) ) << 1 ) | 0x1 ) ) ; 
}
static rxpos reg (int paren , int * flagp , int paren_set , int lookahead , int parse_flags ) {
  rxpos ret ; 
  rxpos br ; 
  rxpos ender ; 
  int parno = 0 ; 
  int flags , matchmin , matchmax , brcount ; 
  Scheme_Hash_Table * backdepends ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(backdepends, 0), PUSH(flagp, 1)));
# define XfOrM82_COUNT (2)
# define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  backdepends = NULLED_OUT ; 
  {
    unsigned long _stk_pos ; 
#   define XfOrM134_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM134(x) SETUP_XfOrM82(x)
    _stk_pos = (unsigned long ) & _stk_pos ; 
    if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
      Scheme_Thread * p = scheme_current_thread ; 
      Scheme_Object * ov ; 
      BLOCK_SETUP((PUSH(ov, 0+XfOrM134_COUNT)));
#     define XfOrM135_COUNT (1+XfOrM134_COUNT)
#     define SETUP_XfOrM135(x) SETUP(XfOrM135_COUNT)
      ov = NULLED_OUT ; 
      p -> ku . k . i1 = paren ; 
      p -> ku . k . p1 = (void * ) flagp ; 
      p -> ku . k . i2 = paren_set ; 
      p -> ku . k . i3 = lookahead ; 
      p -> ku . k . i4 = parse_flags ; 
      ov = FUNCCALL(SETUP_XfOrM135(_), scheme_handle_stack_overflow (reg_k ) ); 
      RET_VALUE_START ((((long ) (ov ) ) >> 1 ) ) RET_VALUE_END ; 
    }
  }
  * flagp = 0x01 ; 
  if (paren ) {
#   define XfOrM128_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM128(x) SETUP_XfOrM82(x)
    if (lookahead ) {
#     define XfOrM132_COUNT (0+XfOrM128_COUNT)
#     define SETUP_XfOrM132(x) SETUP_XfOrM128(x)
      parno = 0 ; 
      ret = FUNCCALL(SETUP_XfOrM132(_), regnode (lookahead ) ); 
      FUNCCALL_AGAIN(regarg (0 ) ); 
      if ((lookahead == 25 ) || (lookahead == 26 ) ) {
#       define XfOrM133_COUNT (0+XfOrM132_COUNT)
#       define SETUP_XfOrM133(x) SETUP_XfOrM132(x)
        FUNCCALL(SETUP_XfOrM133(_), regarg (0 ) ); 
        FUNCCALL(SETUP_XfOrM133(_), regarg (0 ) ); 
      }
    }
    else if (paren_set ) {
#     define XfOrM129_COUNT (0+XfOrM128_COUNT)
#     define SETUP_XfOrM129(x) SETUP_XfOrM128(x)
      parno = regnpar ; 
      regnpar ++ ; 
      if (44 + parno >= 78 ) {
#       define XfOrM131_COUNT (0+XfOrM129_COUNT)
#       define SETUP_XfOrM131(x) SETUP_XfOrM129(x)
        ret = FUNCCALL(SETUP_XfOrM131(_), regnode (20 ) ); 
        FUNCCALL(SETUP_XfOrM131(_), regarg (parno ) ); 
      }
      else {
#       define XfOrM130_COUNT (0+XfOrM129_COUNT)
#       define SETUP_XfOrM130(x) SETUP_XfOrM129(x)
        ret = FUNCCALL(SETUP_XfOrM130(_), regnode (44 + parno ) ); 
      }
    }
    else ret = 0 ; 
  }
  else ret = 0 ; 
  br = FUNCCALL(SETUP_XfOrM82(_), regbranch (& flags , parse_flags , 0 ) ); 
  if (br == 0 ) {
#   define XfOrM127_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM127(x) SETUP_XfOrM82(x)
    FUNCCALL(SETUP_XfOrM127(_), regcomperror ("branch failed!?" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  if (ret != 0 )
    FUNCCALL(SETUP_XfOrM82(_), regtail (ret , br ) ); 
  else ret = br ; 
  if (! (flags & 0x01 ) ) {
    * flagp &= ~ 0x01 ; 
    backdepends = ((void * ) 0 ) ; 
  }
  else if (regbackdepends ) {
    backdepends = regbackdepends ; 
    regbackdepends = ((void * ) 0 ) ; 
  }
  else backdepends = ((void * ) 0 ) ; 
  * flagp |= flags & (0x04 | 0x08 ) ; 
  matchmin = regmatchmin ; 
  matchmax = regmatchmax ; 
  brcount = 1 ; 
  while (regparsestr [regparse ] == '|' ) {
    brcount ++ ; 
    regparse ++ ; 
#   define XfOrM120_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM120(x) SETUP_XfOrM82(x)
    br = FUNCCALL(SETUP_XfOrM120(_), regbranch (& flags , parse_flags , 0 ) ); 
    if (br == 0 ) {
#     define XfOrM124_COUNT (0+XfOrM120_COUNT)
#     define SETUP_XfOrM124(x) SETUP_XfOrM120(x)
      FUNCCALL(SETUP_XfOrM124(_), regcomperror ("next branch failed!?" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
    FUNCCALL(SETUP_XfOrM120(_), regtail (ret , br ) ); 
    if (! (flags & 0x01 ) )
      * flagp &= ~ 0x01 ; 
    else if ((* flagp ) & 0x01 ) {
#     define XfOrM122_COUNT (0+XfOrM120_COUNT)
#     define SETUP_XfOrM122(x) SETUP_XfOrM120(x)
      if (regbackdepends ) {
#       define XfOrM123_COUNT (0+XfOrM122_COUNT)
#       define SETUP_XfOrM123(x) SETUP_XfOrM122(x)
        if (backdepends )
          FUNCCALL(SETUP_XfOrM123(_), merge_tables (backdepends , regbackdepends ) ); 
        else backdepends = regbackdepends ; 
        regbackdepends = ((void * ) 0 ) ; 
      }
      else backdepends = ((void * ) 0 ) ; 
    }
    * flagp |= flags & 0x04 ; 
    if (! (flags & 0x08 ) )
      * flagp &= ~ 0x08 ; 
    else {
      if (regmatchmin < matchmin )
        matchmin = regmatchmin ; 
      if (regmatchmax > matchmax )
        matchmax = regmatchmax ; 
    }
  }
  regbackdepends = backdepends ; 
  regmatchmin = matchmin ; 
  regmatchmax = matchmax ; 
  if (paren && paren_set ) {
    Scheme_Object * assumed ; 
    BLOCK_SETUP((PUSH(assumed, 0+XfOrM82_COUNT)));
#   define XfOrM108_COUNT (1+XfOrM82_COUNT)
#   define SETUP_XfOrM108(x) SETUP(XfOrM108_COUNT)
    assumed = NULLED_OUT ; 
    if (! regbackknown )
      regbackknown = FUNCCALL(SETUP_XfOrM108(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    assumed = FUNCCALL(SETUP_XfOrM108(_), scheme_hash_get (regbackknown , ((Scheme_Object * ) (void * ) (long ) ((((long ) (parno ) ) << 1 ) | 0x1 ) ) ) ); 
    if (! ((* flagp ) & 0x01 ) ) {
#     define XfOrM112_COUNT (0+XfOrM108_COUNT)
#     define SETUP_XfOrM112(x) SETUP_XfOrM108(x)
      if (assumed && ! (((assumed ) ) == (scheme_false ) ) ) {
#       define XfOrM113_COUNT (0+XfOrM112_COUNT)
#       define SETUP_XfOrM113(x) SETUP_XfOrM112(x)
        {
#         define XfOrM114_COUNT (0+XfOrM113_COUNT)
#         define SETUP_XfOrM114(x) SETUP_XfOrM113(x)
          FUNCCALL(SETUP_XfOrM114(_), regcomperror ("`*', `+', or `{...,}' operand can be empty due to backreference" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
      }
      FUNCCALL(SETUP_XfOrM112(_), scheme_hash_set (regbackknown , ((Scheme_Object * ) (void * ) (long ) ((((long ) (parno ) ) << 1 ) | 0x1 ) ) , scheme_false ) ); 
    }
    else {
#     define XfOrM109_COUNT (0+XfOrM108_COUNT)
#     define SETUP_XfOrM109(x) SETUP_XfOrM108(x)
      if (! backdepends )
        FUNCCALL(SETUP_XfOrM109(_), scheme_hash_set (regbackknown , ((Scheme_Object * ) (void * ) (long ) ((((long ) (parno ) ) << 1 ) | 0x1 ) ) , scheme_true ) ); 
      else {
#       define XfOrM110_COUNT (0+XfOrM109_COUNT)
#       define SETUP_XfOrM110(x) SETUP_XfOrM109(x)
        if (assumed ) {
#         define XfOrM111_COUNT (0+XfOrM110_COUNT)
#         define SETUP_XfOrM111(x) SETUP_XfOrM110(x)
          FUNCCALL(SETUP_XfOrM111(_), check_and_propagate_depends () ); 
        }
        else FUNCCALL(SETUP_XfOrM110(_), scheme_hash_set (regbackknown , ((Scheme_Object * ) (void * ) (long ) ((((long ) (parno ) ) << 1 ) | 0x1 ) ) , (Scheme_Object * ) backdepends ) ); 
      }
    }
  }
  if ((brcount == 1 ) && paren && (! paren_set || ((flags & 0x08 ) && (regmatchmin == regmatchmax ) && (regmatchmax < 0x7FFFF ) ) ) && ! lookahead ) {
#   define XfOrM105_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM105(x) SETUP_XfOrM82(x)
    if (br + 3 < regcodesize ) {
      int top ; 
#     define XfOrM107_COUNT (0+XfOrM105_COUNT)
#     define SETUP_XfOrM107(x) SETUP_XfOrM105(x)
      if (regcode <= regcodesize )
        top = regcode ; 
      else top = regcodesize ; 
      (memmove (regstr + ret , regstr + br + 3 , top - (br + 3 ) ) ) ; 
    }
    * flagp = flags ; 
    regcode -= (br + 3 - ret ) ; 
    if (paren_set ) {
      * flagp |= 0x10 ; 
      * flagp &= ~ 0x20 ; 
      regsavepos = parno ; 
    }
  }
  else {
#   define XfOrM89_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM89(x) SETUP_XfOrM82(x)
    if (lookahead ) {
#     define XfOrM100_COUNT (0+XfOrM89_COUNT)
#     define SETUP_XfOrM100(x) SETUP_XfOrM89(x)
      if ((lookahead == 25 ) || (lookahead == 26 ) ) {
#       define XfOrM101_COUNT (0+XfOrM100_COUNT)
#       define SETUP_XfOrM101(x) SETUP_XfOrM100(x)
        if (! ((* flagp ) & 0x08 ) ) {
#         define XfOrM104_COUNT (0+XfOrM101_COUNT)
#         define SETUP_XfOrM104(x) SETUP_XfOrM101(x)
          FUNCCALL_EMPTY(regcomperror ("lookbehind pattern does not match a bounded byte width" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
        if (matchmax > 0x7FFF ) {
#         define XfOrM103_COUNT (0+XfOrM101_COUNT)
#         define SETUP_XfOrM103(x) SETUP_XfOrM101(x)
          FUNCCALL_EMPTY(regcomperror ("lookbehind match is potentially too long (more than 32767 bytes)" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
        if (matchmax > regmaxlookback )
          regmaxlookback = matchmax ; 
        if (ret + 8 < regcodesize ) {
          regstr [ret + 5 ] = (matchmin >> 8 ) ; 
          regstr [ret + 6 ] = (matchmin & 255 ) ; 
          regstr [ret + 7 ] = (matchmax >> 8 ) ; 
          regstr [ret + 8 ] = (matchmax & 255 ) ; 
        }
      }
    }
    if (paren ) {
#     define XfOrM94_COUNT (0+XfOrM89_COUNT)
#     define SETUP_XfOrM94(x) SETUP_XfOrM89(x)
      if (lookahead ) {
#       define XfOrM98_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM98(x) SETUP_XfOrM94(x)
        ender = FUNCCALL_EMPTY(regnode (27 ) ); 
        if (ret + 4 < regcodesize ) {
          int delta = (ender - ret ) ; 
          regstr [ret + 3 ] = (delta >> 8 ) ; 
          regstr [ret + 4 ] = (delta & 255 ) ; 
        }
      }
      else if (paren_set ) {
#       define XfOrM96_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM96(x) SETUP_XfOrM94(x)
        if (44 + parno >= 78 ) {
#         define XfOrM97_COUNT (0+XfOrM96_COUNT)
#         define SETUP_XfOrM97(x) SETUP_XfOrM96(x)
          ender = regcode ; 
          FUNCCALL_EMPTY(regarg (parno ) ); 
          FUNCCALL_EMPTY(reginsert (21 , ender ) ); 
        }
        else ender = FUNCCALL_EMPTY(regnode (78 + parno ) ); 
      }
      else {
#       define XfOrM95_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
        ender = FUNCCALL_EMPTY(regnode (13 ) ); 
      }
    }
    else {
#     define XfOrM93_COUNT (0+XfOrM89_COUNT)
#     define SETUP_XfOrM93(x) SETUP_XfOrM89(x)
      ender = FUNCCALL_EMPTY(regnode (0 ) ); 
    }
    FUNCCALL_EMPTY(regtail (ret , ender ) ); 
    if (regcodesize ) {
#     define XfOrM90_COUNT (0+XfOrM89_COUNT)
#     define SETUP_XfOrM90(x) SETUP_XfOrM89(x)
      for (br = ret ; br != 0 ; br = FUNCCALL_EMPTY(regnext (br ) )) {
#       define XfOrM92_COUNT (0+XfOrM90_COUNT)
#       define SETUP_XfOrM92(x) SETUP_XfOrM90(x)
        FUNCCALL_EMPTY(regoptail (br , ender ) ); 
      }
    }
  }
  if (paren && regparsestr [regparse ++ ] != ')' ) {
#   define XfOrM87_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM87(x) SETUP_XfOrM82(x)
    {
#     define XfOrM88_COUNT (0+XfOrM87_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM87(x)
      FUNCCALL_EMPTY(regcomperror ("missing closing parenthesis in pattern" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
  }
  else if (! paren && regparse != regparse_end ) {
#   define XfOrM83_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM82(x)
    if (regparsestr [regparse ] == ')' ) {
#     define XfOrM85_COUNT (0+XfOrM83_COUNT)
#     define SETUP_XfOrM85(x) SETUP_XfOrM83(x)
      {
#       define XfOrM86_COUNT (0+XfOrM85_COUNT)
#       define SETUP_XfOrM86(x) SETUP_XfOrM85(x)
        FUNCCALL_EMPTY(regcomperror ("extra closing parenthesis in pattern" ) ); 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      ; 
    }
    else {
#     define XfOrM84_COUNT (0+XfOrM83_COUNT)
#     define SETUP_XfOrM84(x) SETUP_XfOrM83(x)
      FUNCCALL_EMPTY(regcomperror ("junk on end" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
  }
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static rxpos regbranch (int * flagp , int parse_flags , int without_branch_node ) {
  rxpos ret ; 
  rxpos chain , latest ; 
  int flags = 0 , matchmin = 0 , matchmax = 0 , pcount = 0 , save_flags ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(flagp, 0)));
# define XfOrM136_COUNT (1)
# define SETUP_XfOrM136(x) SETUP(XfOrM136_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  * flagp = (0 | 0x08 ) ; 
  if (! without_branch_node )
    ret = FUNCCALL(SETUP_XfOrM136(_), regnode (9 ) ); 
  else ret = 0 ; 
  chain = 0 ; 
  while (regparse != regparse_end && regparsestr [regparse ] != '|' && regparsestr [regparse ] != ')' ) {
#   define XfOrM144_COUNT (0+XfOrM136_COUNT)
#   define SETUP_XfOrM144(x) SETUP_XfOrM136(x)
    save_flags = flags ; 
    latest = FUNCCALL(SETUP_XfOrM144(_), regpiece (& flags , parse_flags , ! chain && ! without_branch_node ) ); 
    if (latest == 0 ) {
#     define XfOrM148_COUNT (0+XfOrM144_COUNT)
#     define SETUP_XfOrM148(x) SETUP_XfOrM144(x)
      FUNCCALL(SETUP_XfOrM148(_), regcomperror ("piece failed!?" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
    if (flags & 0x20 ) {
      regcode = latest ; 
      flags = save_flags ; 
    }
    else {
      pcount ++ ; 
#     define XfOrM145_COUNT (0+XfOrM144_COUNT)
#     define SETUP_XfOrM145(x) SETUP_XfOrM144(x)
      * flagp |= flags & 0x01 ; 
      if (chain == 0 ) {
        * flagp |= flags & 0x04 ; 
        if (without_branch_node )
          ret = latest ; 
      }
      else FUNCCALL(SETUP_XfOrM145(_), regtail (chain , latest ) ); 
      if (! (flags & 0x08 ) )
        * flagp &= ~ 0x08 ; 
      matchmin += regmatchmin ; 
      matchmax += regmatchmax ; 
      if (matchmax > 0x7FFF )
        matchmax = 0x10000 ; 
      chain = latest ; 
    }
  }
  regmatchmin = matchmin ; 
  regmatchmax = matchmax ; 
  if (chain == 0 ) {
#   define XfOrM138_COUNT (0+XfOrM136_COUNT)
#   define SETUP_XfOrM138(x) SETUP_XfOrM136(x)
    latest = FUNCCALL(SETUP_XfOrM138(_), regnode (13 ) ); 
    if (without_branch_node )
      ret = latest ; 
    * flagp = 0x02 | 0x20 | 0x08 ; 
    regmatchmin = regmatchmax = 0 ; 
  }
  if (pcount == 1 ) {
    * flagp = flags ; 
  }
  RET_VALUE_START ((ret ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static rxpos regpiece (int * flagp , int parse_flags , int at_start ) {
  rxpos ret ; 
  char op ; 
  rxpos next ; 
  int flags , greedy ; 
  int minreps = 0 , maxreps = 0 , counter ; 
  int origsavepos , origmatchmin , origmatchmax ; 
  rxpos __funcarg20 ; 
  rxpos __funcarg19 ; 
  rxpos __funcarg18 ; 
  rxpos __funcarg17 ; 
  rxpos __funcarg16 ; 
  rxpos __funcarg15 ; 
  rxpos __funcarg14 ; 
  rxpos __funcarg13 ; 
  rxpos __funcarg12 ; 
  rxpos __funcarg11 ; 
  rxpos __funcarg10 ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(flagp, 0)));
# define XfOrM149_COUNT (1)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ret = FUNCCALL(SETUP_XfOrM149(_), regatom (& flags , parse_flags , at_start ) ); 
  if (ret == 0 ) {
#   define XfOrM203_COUNT (0+XfOrM149_COUNT)
#   define SETUP_XfOrM203(x) SETUP_XfOrM149(x)
    FUNCCALL(SETUP_XfOrM203(_), regcomperror ("atom failed!?" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  origsavepos = regsavepos ; 
  origmatchmin = regmatchmin ; 
  origmatchmax = regmatchmax ; 
  op = regparsestr [regparse ] ; 
  if (! ((op ) == '*' || (op ) == '+' || (op ) == '?' || ((parse_flags & 0x2 ) && ((op ) == '{' ) ) ) ) {
    * flagp = (flags & ~ 0x10 ) ; 
  }
  else {
#   define XfOrM152_COUNT (0+XfOrM149_COUNT)
#   define SETUP_XfOrM152(x) SETUP_XfOrM149(x)
    if (op == '{' ) {
      int ch , maxspec = 0 ; 
#     define XfOrM175_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM175(x) SETUP_XfOrM152(x)
      minreps = maxreps = 0 ; 
      regparse ++ ; 
      do {
#       define XfOrM197_COUNT (0+XfOrM175_COUNT)
#       define SETUP_XfOrM197(x) SETUP_XfOrM175(x)
        ch = regparsestr [regparse ] ; 
        if ((ch >= '0' ) && (ch <= '9' ) ) {
#         define XfOrM200_COUNT (0+XfOrM197_COUNT)
#         define SETUP_XfOrM200(x) SETUP_XfOrM197(x)
          minreps = (minreps * 10 ) + (ch - '0' ) ; 
          if (minreps > 0x7FFF ) {
#           define XfOrM201_COUNT (0+XfOrM200_COUNT)
#           define SETUP_XfOrM201(x) SETUP_XfOrM200(x)
            FUNCCALL(SETUP_XfOrM201(_), regcomperror ("minimum repetition count too large" ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          ; 
          regparse ++ ; 
        }
        else if (ch == ',' || ch == '}' )
          break ; 
        else {
#         define XfOrM198_COUNT (0+XfOrM197_COUNT)
#         define SETUP_XfOrM198(x) SETUP_XfOrM197(x)
          {
#           define XfOrM199_COUNT (0+XfOrM198_COUNT)
#           define SETUP_XfOrM199(x) SETUP_XfOrM198(x)
            FUNCCALL(SETUP_XfOrM199(_), regcomperror ("expected digit, comma, or `}' to end repetition specification started with `{'" ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          ; 
        }
      }
      while (1 ) ; 
      if (ch == ',' ) {
        regparse ++ ; 
#       define XfOrM181_COUNT (0+XfOrM175_COUNT)
#       define SETUP_XfOrM181(x) SETUP_XfOrM175(x)
        do {
#         define XfOrM187_COUNT (0+XfOrM181_COUNT)
#         define SETUP_XfOrM187(x) SETUP_XfOrM181(x)
          ch = regparsestr [regparse ] ; 
          if ((ch >= '0' ) && (ch <= '9' ) ) {
#           define XfOrM190_COUNT (0+XfOrM187_COUNT)
#           define SETUP_XfOrM190(x) SETUP_XfOrM187(x)
            maxspec = 1 ; 
            maxreps = (maxreps * 10 ) + (ch - '0' ) ; 
            if (maxreps > 0x7FFF ) {
#             define XfOrM191_COUNT (0+XfOrM190_COUNT)
#             define SETUP_XfOrM191(x) SETUP_XfOrM190(x)
              FUNCCALL(SETUP_XfOrM191(_), regcomperror ("maximum repetition count too large" ) ); 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            ; 
            regparse ++ ; 
          }
          else if (ch == '}' )
            break ; 
          else {
#           define XfOrM188_COUNT (0+XfOrM187_COUNT)
#           define SETUP_XfOrM188(x) SETUP_XfOrM187(x)
            {
#             define XfOrM189_COUNT (0+XfOrM188_COUNT)
#             define SETUP_XfOrM189(x) SETUP_XfOrM188(x)
              FUNCCALL(SETUP_XfOrM189(_), regcomperror ("expected digit or `}' to end repetition specification started with `{'" ) ); 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            ; 
          }
        }
        while (1 ) ; 
      }
      else {
        maxspec = 1 ; 
        maxreps = minreps ; 
      }
      if (maxspec && (maxreps < minreps ) ) {
#       define XfOrM178_COUNT (0+XfOrM175_COUNT)
#       define SETUP_XfOrM178(x) SETUP_XfOrM175(x)
        {
#         define XfOrM179_COUNT (0+XfOrM178_COUNT)
#         define SETUP_XfOrM179(x) SETUP_XfOrM178(x)
          FUNCCALL(SETUP_XfOrM179(_), regcomperror ("maximum repetition count is less than maximum repetition count" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
      }
      if (maxspec && ! maxreps ) {
        regparse ++ ; 
#       define XfOrM176_COUNT (0+XfOrM175_COUNT)
#       define SETUP_XfOrM176(x) SETUP_XfOrM175(x)
        if (regparsestr [regparse ] == '?' )
          regparse ++ ; 
        if (((regparsestr [regparse ] ) == '*' || (regparsestr [regparse ] ) == '+' || (regparsestr [regparse ] ) == '?' || ((parse_flags & 0x2 ) && ((regparsestr [regparse ] ) == '{' ) ) ) ) {
#         define XfOrM177_COUNT (0+XfOrM176_COUNT)
#         define SETUP_XfOrM177(x) SETUP_XfOrM176(x)
          FUNCCALL(SETUP_XfOrM177(_), regcomperror ("nested `*', `?', `+', or `{...}' in pattern" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
        regcode = ret ; 
        * flagp = 0x08 | 0x20 ; 
        regmatchmin = regmatchmax = 0 ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regnode (13 ) )) RET_VALUE_EMPTY_END ; 
      }
      op = '*' ; 
      if (maxreps || minreps )
        counter = regncounter ++ ; 
      else counter = 0 ; 
    }
    else counter = 0 ; 
    if (! (flags & 0x01 ) && (op != '?' ) ) {
#     define XfOrM173_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM173(x) SETUP_XfOrM152(x)
      {
#       define XfOrM174_COUNT (0+XfOrM173_COUNT)
#       define SETUP_XfOrM174(x) SETUP_XfOrM173(x)
        FUNCCALL(SETUP_XfOrM174(_), regcomperror ("`*', `+', or `{...}' operand could be empty" ) ); 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      ; 
    }
    if (regbackdepends ) {
#     define XfOrM172_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM172(x) SETUP_XfOrM152(x)
      FUNCCALL(SETUP_XfOrM172(_), check_and_propagate_depends () ); 
      regbackdepends = ((void * ) 0 ) ; 
    }
    if (maxreps || minreps ) {
      if (minreps > 0 )
        * flagp = 0x01 ; 
      if ((flags & 0x08 ) && maxreps ) {
        regmatchmin = (origmatchmin * minreps ) ; 
        regmatchmax = (origmatchmax * maxreps ) ; 
        if (regmatchmax > 0x7FFF )
          regmatchmax = 0x10000 ; 
        * flagp |= 0x08 ; 
      }
    }
    else * flagp = (op != '+' ) ? 0 : 0x01 ; 
    * flagp |= 0x04 ; 
    if ((op == '?' ) && (flags & 0x08 ) ) {
      * flagp |= 0x08 ; 
      regmatchmin = 0 ; 
    }
    if (regparsestr [regparse + 1 ] == '?' ) {
      greedy = 0 ; 
      regparse ++ ; 
    }
    else greedy = 1 ; 
    if (op == '*' && (flags & 0x02 ) ) {
#     define XfOrM167_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM167(x) SETUP_XfOrM152(x)
      if (! minreps && ! maxreps )
        FUNCCALL(SETUP_XfOrM167(_), reginsert (greedy ? 14 : 16 , ret ) ); 
      else FUNCCALL(SETUP_XfOrM167(_), reginsertwithopop (greedy ? 18 : 19 , ret , minreps , maxreps ) ); 
    }
    else if (op == '*' && greedy ) {
      rxpos br , nothing ; 
#     define XfOrM162_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM162(x) SETUP_XfOrM152(x)
      if (minreps || maxreps ) {
        rxpos x ; 
#       define XfOrM166_COUNT (0+XfOrM162_COUNT)
#       define SETUP_XfOrM166(x) SETUP_XfOrM162(x)
        x = FUNCCALL(SETUP_XfOrM166(_), reginsertwithopop (32 , ret , counter , maxreps ) ); 
        FUNCCALL(SETUP_XfOrM166(_), regtail (ret , x ) ); 
      }
      FUNCCALL(SETUP_XfOrM162(_), reginsert (9 , ret ) ); 
      if (minreps || maxreps ) {
#       define XfOrM165_COUNT (0+XfOrM162_COUNT)
#       define SETUP_XfOrM165(x) SETUP_XfOrM162(x)
        br = FUNCCALL(SETUP_XfOrM165(_), reginsertwithop (30 , ret , counter ) ); 
        FUNCCALL(SETUP_XfOrM165(_), regtail (ret , br ) ); 
      }
      else br = ret ; 
      (__funcarg20 = FUNCCALL(SETUP_XfOrM162(_), regnode (10 ) ), FUNCCALL_AGAIN(regoptail (br , __funcarg20 ) )) ; 
      FUNCCALL_AGAIN(regoptail (br , br ) ); 
      (__funcarg19 = FUNCCALL(SETUP_XfOrM162(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (br , __funcarg19 ) )) ; 
      nothing = FUNCCALL_AGAIN(regnode (13 ) ); 
      if (minreps ) {
        rxpos n ; 
#       define XfOrM164_COUNT (0+XfOrM162_COUNT)
#       define SETUP_XfOrM164(x) SETUP_XfOrM162(x)
        n = FUNCCALL(SETUP_XfOrM164(_), reginsertwithopop (31 , nothing , counter , minreps ) ); 
        FUNCCALL(SETUP_XfOrM164(_), regtail (nothing , n ) ); 
      }
      if (minreps || maxreps ) {
        rxpos n ; 
#       define XfOrM163_COUNT (0+XfOrM162_COUNT)
#       define SETUP_XfOrM163(x) SETUP_XfOrM162(x)
        n = FUNCCALL(SETUP_XfOrM163(_), reginsertwithop (33 , nothing , counter ) ); 
        FUNCCALL(SETUP_XfOrM163(_), regtail (nothing , n ) ); 
      }
      FUNCCALL(SETUP_XfOrM162(_), regtail (br , nothing ) ); 
    }
    else if (op == '*' ) {
      rxpos br , nothing , x , next_to_x ; 
#     define XfOrM158_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM158(x) SETUP_XfOrM152(x)
      if (minreps || maxreps ) {
        rxpos fail ; 
#       define XfOrM161_COUNT (0+XfOrM158_COUNT)
#       define SETUP_XfOrM161(x) SETUP_XfOrM158(x)
        x = FUNCCALL(SETUP_XfOrM161(_), reginsertwithopop (32 , ret , counter , maxreps ) ); 
        FUNCCALL(SETUP_XfOrM161(_), regtail (ret , x ) ); 
        fail = FUNCCALL_AGAIN(regnode (9 ) ); 
        FUNCCALL_AGAIN(regnode (34 ) ); 
        FUNCCALL_AGAIN(regarg (counter ) ); 
        FUNCCALL_AGAIN(reginsert (9 , ret ) ); 
        fail += 3 ; 
        FUNCCALL(SETUP_XfOrM161(_), regtail (ret , fail ) ); 
        x += 3 ; 
      }
      else x = ret ; 
      FUNCCALL(SETUP_XfOrM158(_), reginsert (9 , ret ) ); 
      next = ret ; 
      next_to_x = (x - next ) + 3 ; 
      FUNCCALL(SETUP_XfOrM158(_), reginsert (13 , ret ) ); 
      next += 3 ; 
      nothing = ret ; 
      if (minreps ) {
#       define XfOrM160_COUNT (0+XfOrM158_COUNT)
#       define SETUP_XfOrM160(x) SETUP_XfOrM158(x)
        nothing = FUNCCALL(SETUP_XfOrM160(_), reginsertwithopop (31 , ret , counter , minreps ) ); 
        FUNCCALL(SETUP_XfOrM160(_), regtail (ret , nothing ) ); 
        next += (nothing - ret ) ; 
      }
      FUNCCALL(SETUP_XfOrM158(_), reginsert (9 , ret ) ); 
      next += 3 ; 
      nothing += 3 ; 
      if (minreps || maxreps ) {
#       define XfOrM159_COUNT (0+XfOrM158_COUNT)
#       define SETUP_XfOrM159(x) SETUP_XfOrM158(x)
        br = FUNCCALL(SETUP_XfOrM159(_), reginsertwithop (30 , ret , counter ) ); 
        FUNCCALL(SETUP_XfOrM159(_), regtail (ret , br ) ); 
        next += (br - ret ) ; 
        nothing += (br - ret ) ; 
      }
      else br = ret ; 
      FUNCCALL(SETUP_XfOrM158(_), regtail (br , next ) ); 
      x = next + next_to_x ; 
      (__funcarg18 = FUNCCALL(SETUP_XfOrM158(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (x , __funcarg18 ) )) ; 
      FUNCCALL_AGAIN(regtail (x , br ) ); 
      (__funcarg17 = FUNCCALL(SETUP_XfOrM158(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg17 ) )) ; 
      FUNCCALL_AGAIN(regtail (next , nothing ) ); 
    }
    else if (op == '+' && (flags & 0x02 ) )
      FUNCCALL(SETUP_XfOrM152(_), reginsert (greedy ? 15 : 17 , ret ) ); 
    else if (op == '+' && greedy ) {
#     define XfOrM157_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM157(x) SETUP_XfOrM152(x)
      next = FUNCCALL(SETUP_XfOrM157(_), regnode (9 ) ); 
      FUNCCALL(SETUP_XfOrM157(_), regtail (ret , next ) ); 
      (__funcarg16 = FUNCCALL(SETUP_XfOrM157(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (__funcarg16 , ret ) )) ; 
      (__funcarg15 = FUNCCALL(SETUP_XfOrM157(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg15 ) )) ; 
      (__funcarg14 = FUNCCALL(SETUP_XfOrM157(_), regnode (13 ) ), FUNCCALL_AGAIN(regtail (ret , __funcarg14 ) )) ; 
    }
    else if (op == '+' ) {
#     define XfOrM156_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM156(x) SETUP_XfOrM152(x)
      next = FUNCCALL(SETUP_XfOrM156(_), regnode (9 ) ); 
      FUNCCALL(SETUP_XfOrM156(_), regtail (ret , next ) ); 
      FUNCCALL_AGAIN(regnode (13 ) ); 
      (__funcarg13 = FUNCCALL(SETUP_XfOrM156(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg13 ) )) ; 
      (__funcarg12 = FUNCCALL(SETUP_XfOrM156(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (__funcarg12 , ret ) )) ; 
      (__funcarg11 = FUNCCALL(SETUP_XfOrM156(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg11 ) )) ; 
      FUNCCALL_AGAIN(regtail (next , next + 3 ) ); 
    }
    else if (op == '?' && greedy ) {
#     define XfOrM155_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM155(x) SETUP_XfOrM152(x)
      FUNCCALL(SETUP_XfOrM155(_), reginsert (9 , ret ) ); 
      (__funcarg10 = FUNCCALL(SETUP_XfOrM155(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (ret , __funcarg10 ) )) ; 
      next = FUNCCALL_AGAIN(regnode (13 ) ); 
      FUNCCALL_AGAIN(regtail (ret , next ) ); 
      FUNCCALL_AGAIN(regoptail (ret , next ) ); 
    }
    else if (op == '?' ) {
#     define XfOrM154_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM154(x) SETUP_XfOrM152(x)
      FUNCCALL(SETUP_XfOrM154(_), reginsert (9 , ret ) ); 
      FUNCCALL(SETUP_XfOrM154(_), reginsert (13 , ret ) ); 
      FUNCCALL_AGAIN(reginsert (9 , ret ) ); 
      FUNCCALL_AGAIN(regtail (ret , ret + 6 ) ); 
      next = FUNCCALL_AGAIN(regnode (10 ) ); 
      FUNCCALL_AGAIN(regtail (ret + 6 , next ) ); 
      FUNCCALL_AGAIN(regoptail (ret + 6 , next ) ); 
      FUNCCALL_AGAIN(regoptail (ret + 6 , ret + 3 ) ); 
    }
    regparse ++ ; 
    if (((regparsestr [regparse ] ) == '*' || (regparsestr [regparse ] ) == '+' || (regparsestr [regparse ] ) == '?' || ((parse_flags & 0x2 ) && ((regparsestr [regparse ] ) == '{' ) ) ) ) {
#     define XfOrM153_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM153(x) SETUP_XfOrM152(x)
      FUNCCALL(SETUP_XfOrM153(_), regcomperror ("nested `*', `?', `+', or `{...}' in pattern" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
  }
  if (flags & 0x10 ) {
    rxpos sv ; 
#   define XfOrM150_COUNT (0+XfOrM149_COUNT)
#   define SETUP_XfOrM150(x) SETUP_XfOrM149(x)
    sv = FUNCCALL(SETUP_XfOrM150(_), regnode (35 ) ); 
    FUNCCALL(SETUP_XfOrM150(_), regarg (origsavepos ) ); 
    FUNCCALL_AGAIN(regarg (origmatchmax ) ); 
    FUNCCALL_AGAIN(regtail (ret , sv ) ); 
    if (origmatchmax ) {
#     define XfOrM151_COUNT (0+XfOrM150_COUNT)
#     define SETUP_XfOrM151(x) SETUP_XfOrM150(x)
      sv = FUNCCALL(SETUP_XfOrM151(_), reginsertwithop (36 , ret , origsavepos ) ); 
      FUNCCALL(SETUP_XfOrM151(_), regtail (ret , sv ) ); 
    }
    * flagp &= ~ 0x02 ; 
  }
  RET_VALUE_START ((ret ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static rxpos regatom (int * flagp , int parse_flags , int at_start ) {
  rxpos ret ; 
  int flags ; 
  rxpos __funcarg21 ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(flagp, 0)));
# define XfOrM204_COUNT (1)
# define SETUP_XfOrM204(x) SETUP(XfOrM204_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  * flagp = (0 | 0x08 ) ; 
  regmatchmin = regmatchmax = 1 ; 
  switch (regparsestr [regparse ++ ] ) {
#   define XfOrM206_COUNT (0+XfOrM204_COUNT)
#   define SETUP_XfOrM206(x) SETUP_XfOrM204(x)
    case '^' : if (parse_flags & 0x4 )
      ret = FUNCCALL(SETUP_XfOrM206(_), regnode (1 ) ); 
    else ret = FUNCCALL(SETUP_XfOrM206(_), regnode (39 ) ); 
    regmatchmin = regmatchmax = 0 ; 
    break ; 
    case '$' : if (parse_flags & 0x4 )
      ret = FUNCCALL(SETUP_XfOrM206(_), regnode (2 ) ); 
    else ret = FUNCCALL(SETUP_XfOrM206(_), regnode (40 ) ); 
    regmatchmin = regmatchmax = 0 ; 
    break ; 
    case '.' : -- regparse ; 
    ret = FUNCCALL(SETUP_XfOrM206(_), regranges (parse_flags , at_start ) ); 
    * flagp |= 0x01 | 0x02 ; 
    break ; 
    case '[' : -- regparse ; 
    ret = FUNCCALL(SETUP_XfOrM206(_), regranges (parse_flags , at_start ) ); 
    * flagp |= 0x01 | 0x02 ; 
    break ; 
    case '(' : {
#     define XfOrM242_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM242(x) SETUP_XfOrM206(x)
      if (regparsestr [regparse ] == '?' ) {
        int moded = 0 ; 
#       define XfOrM247_COUNT (0+XfOrM242_COUNT)
#       define SETUP_XfOrM247(x) SETUP_XfOrM242(x)
        while (1 ) {
          if (regparsestr [regparse + 1 ] == 'i' ) {
            parse_flags &= ~ 0x1 ; 
            regparse ++ ; 
            moded = 1 ; 
          }
          else if (regparsestr [regparse + 1 ] == 'm' ) {
            parse_flags &= ~ 0x4 ; 
            regparse ++ ; 
            moded = 1 ; 
          }
          else if (regparsestr [regparse + 1 ] == 's' ) {
            parse_flags |= 0x4 ; 
            regparse ++ ; 
            moded = 1 ; 
          }
          else if ((regparsestr [regparse + 1 ] == '-' ) && (regparsestr [regparse + 2 ] == 'i' ) ) {
            parse_flags |= 0x1 ; 
            regparse += 2 ; 
            moded = 1 ; 
          }
          else if ((regparsestr [regparse + 1 ] == '-' ) && (regparsestr [regparse + 2 ] == 'm' ) ) {
            parse_flags |= 0x4 ; 
            regparse += 2 ; 
            moded = 1 ; 
          }
          else if ((regparsestr [regparse + 1 ] == '-' ) && (regparsestr [regparse + 2 ] == 's' ) ) {
            parse_flags &= ~ 0x4 ; 
            regparse += 2 ; 
            moded = 1 ; 
          }
          else {
            break ; 
          }
        }
        if (regparsestr [regparse + 1 ] == ':' ) {
#         define XfOrM282_COUNT (0+XfOrM247_COUNT)
#         define SETUP_XfOrM282(x) SETUP_XfOrM247(x)
          regparse += 2 ; 
          ret = FUNCCALL(SETUP_XfOrM282(_), reg (1 , & flags , 0 , 0 , parse_flags ) ); 
          * flagp = flags ; 
        }
        else if (moded ) {
#         define XfOrM280_COUNT (0+XfOrM247_COUNT)
#         define SETUP_XfOrM280(x) SETUP_XfOrM247(x)
          {
#           define XfOrM281_COUNT (0+XfOrM280_COUNT)
#           define SETUP_XfOrM281(x) SETUP_XfOrM280(x)
            FUNCCALL(SETUP_XfOrM281(_), regcomperror ("expected `:' or another mode after `(?' and a mode sequence (where a mode is `i', `-i', `m', `-m', `s', or `-s')" ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          ; 
        }
        else if (regparsestr [regparse + 1 ] == '(' ) {
#         define XfOrM256_COUNT (0+XfOrM247_COUNT)
#         define SETUP_XfOrM256(x) SETUP_XfOrM247(x)
          if (((regparsestr [regparse + 2 ] >= '0' ) && (regparsestr [regparse + 2 ] <= '9' ) ) || ((regparsestr [regparse + 2 ] == '?' ) && ((regparsestr [regparse + 3 ] == '=' ) || (regparsestr [regparse + 3 ] == '!' ) || (regparsestr [regparse + 3 ] == '<' ) ) ) ) {
            rxpos test , tbr , fbr , ender ; 
            int flags , matchmin , matchmax ; 
            Scheme_Hash_Table * backdepends ; 
            regparse ++ ; 
            BLOCK_SETUP((PUSH(backdepends, 0+XfOrM256_COUNT)));
#           define XfOrM258_COUNT (1+XfOrM256_COUNT)
#           define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
            backdepends = NULLED_OUT ; 
            ret = FUNCCALL(SETUP_XfOrM258(_), regnode (42 ) ); 
            FUNCCALL_AGAIN(regarg (0 ) ); 
            FUNCCALL_AGAIN(regarg (0 ) ); 
            if (regparsestr [regparse + 1 ] != '?' ) {
              int posn ; 
              regparse ++ ; 
#             define XfOrM276_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM276(x) SETUP_XfOrM258(x)
              posn = FUNCCALL(SETUP_XfOrM276(_), regdigit () ); 
              test = FUNCCALL(SETUP_XfOrM276(_), regnode (28 ) ); 
              FUNCCALL_AGAIN(regarg (posn ) ); 
              if (regparsestr [regparse ] == ')' ) {
                regparse ++ ; 
              }
              else {
#               define XfOrM277_COUNT (0+XfOrM276_COUNT)
#               define SETUP_XfOrM277(x) SETUP_XfOrM276(x)
                {
#                 define XfOrM278_COUNT (0+XfOrM277_COUNT)
#                 define SETUP_XfOrM278(x) SETUP_XfOrM277(x)
                  FUNCCALL(SETUP_XfOrM278(_), regcomperror ("expected `)' after `(?(' followed by a digit" ) ); 
                  RET_VALUE_START (0 ) RET_VALUE_END ; 
                }
                ; 
              }
            }
            else {
#             define XfOrM275_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM275(x) SETUP_XfOrM258(x)
              test = FUNCCALL(SETUP_XfOrM275(_), regatom (& flags , parse_flags , 1 ) ); 
            }
            if (test != ((ret ) + 7 ) ) {
#             define XfOrM273_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM273(x) SETUP_XfOrM258(x)
              {
#               define XfOrM274_COUNT (0+XfOrM273_COUNT)
#               define SETUP_XfOrM274(x) SETUP_XfOrM273(x)
                FUNCCALL(SETUP_XfOrM274(_), regcomperror ("test went to wrong place!?" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
            (__funcarg21 = FUNCCALL(SETUP_XfOrM258(_), regnode (0 ) ), FUNCCALL_AGAIN(regtail (test , __funcarg21 ) )) ; 
            if (regparsestr [regparse ] == ')' ) {
#             define XfOrM271_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM271(x) SETUP_XfOrM258(x)
              {
#               define XfOrM272_COUNT (0+XfOrM271_COUNT)
#               define SETUP_XfOrM272(x) SETUP_XfOrM271(x)
                FUNCCALL(SETUP_XfOrM272(_), regcomperror ("expected an expression after test in `(?(...))'" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
            regbackdepends = ((void * ) 0 ) ; 
            * flagp |= 0x01 ; 
            tbr = FUNCCALL(SETUP_XfOrM258(_), regbranch (& flags , parse_flags , 1 ) ); 
            if (! (flags & 0x01 ) ) {
              * flagp &= ~ 0x01 ; 
              backdepends = ((void * ) 0 ) ; 
            }
            else if (regbackdepends ) {
              backdepends = regbackdepends ; 
              regbackdepends = ((void * ) 0 ) ; 
            }
            else backdepends = ((void * ) 0 ) ; 
            if (! (flags & 0x08 ) )
              * flagp &= ~ 0x08 ; 
            matchmin = regmatchmin ; 
            matchmax = regmatchmax ; 
            if (regparsestr [regparse ] == ')' ) {
#             define XfOrM268_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM268(x) SETUP_XfOrM258(x)
              fbr = FUNCCALL(SETUP_XfOrM268(_), regnode (13 ) ); 
              * flagp &= ~ 0x01 ; 
              matchmin = 0 ; 
            }
            else if (regparsestr [regparse ] != '|' ) {
#             define XfOrM266_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM266(x) SETUP_XfOrM258(x)
              {
#               define XfOrM267_COUNT (0+XfOrM266_COUNT)
#               define SETUP_XfOrM267(x) SETUP_XfOrM266(x)
                FUNCCALL(SETUP_XfOrM267(_), regcomperror ("expected `)' or `|' after first branch of `(?(...)...)'" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
            else {
              regparse ++ ; 
#             define XfOrM260_COUNT (0+XfOrM258_COUNT)
#             define SETUP_XfOrM260(x) SETUP_XfOrM258(x)
              fbr = FUNCCALL(SETUP_XfOrM260(_), regbranch (& flags , parse_flags , 1 ) ); 
              if (regparsestr [regparse ] != ')' ) {
#               define XfOrM264_COUNT (0+XfOrM260_COUNT)
#               define SETUP_XfOrM264(x) SETUP_XfOrM260(x)
                {
#                 define XfOrM265_COUNT (0+XfOrM264_COUNT)
#                 define SETUP_XfOrM265(x) SETUP_XfOrM264(x)
                  FUNCCALL(SETUP_XfOrM265(_), regcomperror ("expected `)' to close `(?(...)...' after second branch" ) ); 
                  RET_VALUE_START (0 ) RET_VALUE_END ; 
                }
                ; 
              }
              if (! (flags & 0x01 ) ) {
                * flagp &= ~ 0x01 ; 
                backdepends = ((void * ) 0 ) ; 
              }
              else if (regbackdepends ) {
#               define XfOrM262_COUNT (0+XfOrM260_COUNT)
#               define SETUP_XfOrM262(x) SETUP_XfOrM260(x)
                if (backdepends )
                  FUNCCALL(SETUP_XfOrM262(_), merge_tables (backdepends , regbackdepends ) ); 
                else backdepends = regbackdepends ; 
              }
              if (! (flags & 0x08 ) )
                * flagp &= ~ 0x08 ; 
              else {
                if (regmatchmin < matchmin )
                  matchmin = regmatchmin ; 
                if (regmatchmax > matchmax )
                  matchmax = regmatchmax ; 
              }
            }
            regmatchmax = matchmax ; 
            regmatchmin = matchmin ; 
            regbackdepends = backdepends ; 
            if (((ret ) + 5 ) + 1 < regcodesize ) {
              int delta ; 
              delta = tbr - ret ; 
              regstr [((ret ) + 3 ) ] = delta >> 8 ; 
              regstr [((ret ) + 3 ) + 1 ] = delta & 255 ; 
              delta = fbr - ret ; 
              regstr [((ret ) + 5 ) ] = delta >> 8 ; 
              regstr [((ret ) + 5 ) + 1 ] = delta & 255 ; 
            }
            ender = FUNCCALL(SETUP_XfOrM258(_), regnode (13 ) ); 
            FUNCCALL(SETUP_XfOrM258(_), regtail (tbr , ender ) ); 
            FUNCCALL_AGAIN(regtail (fbr , ender ) ); 
            FUNCCALL_AGAIN(regtail (ret , ender ) ); 
            regparse ++ ; 
          }
          else {
#           define XfOrM257_COUNT (0+XfOrM256_COUNT)
#           define SETUP_XfOrM257(x) SETUP_XfOrM256(x)
            FUNCCALL(SETUP_XfOrM257(_), regcomperror ("expected `(?=', `(?!', `(?<', or digit after `(?('" ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          ; 
        }
        else if (regparsestr [regparse + 1 ] == '>' ) {
#         define XfOrM255_COUNT (0+XfOrM247_COUNT)
#         define SETUP_XfOrM255(x) SETUP_XfOrM247(x)
          regparse += 2 ; 
          ret = FUNCCALL(SETUP_XfOrM255(_), reg (1 , & flags , 0 , 24 , parse_flags ) ); 
          * flagp = flags ; 
        }
        else {
#         define XfOrM248_COUNT (0+XfOrM247_COUNT)
#         define SETUP_XfOrM248(x) SETUP_XfOrM247(x)
          if (regparsestr [regparse + 1 ] == '=' ) {
#           define XfOrM254_COUNT (0+XfOrM248_COUNT)
#           define SETUP_XfOrM254(x) SETUP_XfOrM248(x)
            regparse += 2 ; 
            ret = FUNCCALL(SETUP_XfOrM254(_), reg (1 , & flags , 0 , 22 , parse_flags ) ); 
          }
          else if (regparsestr [regparse + 1 ] == '!' ) {
#           define XfOrM253_COUNT (0+XfOrM248_COUNT)
#           define SETUP_XfOrM253(x) SETUP_XfOrM248(x)
            regparse += 2 ; 
            ret = FUNCCALL(SETUP_XfOrM253(_), reg (1 , & flags , 0 , 23 , parse_flags ) ); 
          }
          else if ((regparsestr [regparse + 1 ] == '<' ) && (regparsestr [regparse + 2 ] == '=' ) ) {
#           define XfOrM252_COUNT (0+XfOrM248_COUNT)
#           define SETUP_XfOrM252(x) SETUP_XfOrM248(x)
            regparse += 3 ; 
            ret = FUNCCALL(SETUP_XfOrM252(_), reg (1 , & flags , 0 , 25 , parse_flags ) ); 
          }
          else if ((regparsestr [regparse + 1 ] == '<' ) && (regparsestr [regparse + 2 ] == '!' ) ) {
#           define XfOrM251_COUNT (0+XfOrM248_COUNT)
#           define SETUP_XfOrM251(x) SETUP_XfOrM248(x)
            regparse += 3 ; 
            ret = FUNCCALL(SETUP_XfOrM251(_), reg (1 , & flags , 0 , 26 , parse_flags ) ); 
          }
          else {
#           define XfOrM249_COUNT (0+XfOrM248_COUNT)
#           define SETUP_XfOrM249(x) SETUP_XfOrM248(x)
            {
#             define XfOrM250_COUNT (0+XfOrM249_COUNT)
#             define SETUP_XfOrM250(x) SETUP_XfOrM249(x)
              FUNCCALL(SETUP_XfOrM250(_), regcomperror ("expected `:', `=', `!', `<=', `<!', `i', `-i', `m', `-m', `s', or `-s' after `(?'" ) ); 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            ; 
          }
          regmatchmin = regmatchmax = 0 ; 
          * flagp = 0x08 ; 
          regbackdepends = ((void * ) 0 ) ; 
        }
      }
      else {
#       define XfOrM244_COUNT (0+XfOrM242_COUNT)
#       define SETUP_XfOrM244(x) SETUP_XfOrM242(x)
        ret = FUNCCALL(SETUP_XfOrM244(_), reg (1 , & flags , 1 , 0 , parse_flags ) ); 
        if (flags & 0x10 ) {
          * flagp = flags ; 
        }
        else {
          * flagp |= flags & (0x01 | 0x04 ) ; 
          if (! (flags & 0x08 ) )
            * flagp &= ~ 0x08 ; 
        }
      }
      if (ret == 0 ) {
#       define XfOrM243_COUNT (0+XfOrM242_COUNT)
#       define SETUP_XfOrM243(x) SETUP_XfOrM242(x)
        FUNCCALL(SETUP_XfOrM243(_), regcomperror ("cluster failed!?" ) ); 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      ; 
    }
    break ; 
    case '|' : case ')' : {
#     define XfOrM241_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM241(x) SETUP_XfOrM206(x)
      FUNCCALL(SETUP_XfOrM241(_), regcomperror ("internal urp" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
    break ; 
    case '?' : {
#     define XfOrM240_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM240(x) SETUP_XfOrM206(x)
      FUNCCALL(SETUP_XfOrM240(_), regcomperror ("`?' follows nothing in pattern" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
    break ; 
    case '+' : {
#     define XfOrM239_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM239(x) SETUP_XfOrM206(x)
      FUNCCALL(SETUP_XfOrM239(_), regcomperror ("`+' follows nothing in pattern" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
    break ; 
    case '*' : {
#     define XfOrM238_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM238(x) SETUP_XfOrM206(x)
      FUNCCALL(SETUP_XfOrM238(_), regcomperror ("`*' follows nothing in pattern" ) ); 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
    ; 
    break ; 
    case '\\' : {
      int c ; 
#     define XfOrM227_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM227(x) SETUP_XfOrM206(x)
      if (regparse == regparse_end ) {
#       define XfOrM237_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM237(x) SETUP_XfOrM227(x)
        FUNCCALL(SETUP_XfOrM237(_), regcomperror ("trailing backslash in pattern" ) ); 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      ; 
      c = regparsestr [regparse ++ ] ; 
      if ((parse_flags & 0x2 ) && (c == 'b' ) ) {
#       define XfOrM236_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM236(x) SETUP_XfOrM227(x)
        ret = FUNCCALL(SETUP_XfOrM236(_), regnode (37 ) ); 
        regmatchmin = regmatchmax = 0 ; 
        if (! regmaxlookback )
          regmaxlookback = 1 ; 
      }
      else if ((parse_flags & 0x2 ) && (c == 'B' ) ) {
#       define XfOrM235_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM235(x) SETUP_XfOrM227(x)
        ret = FUNCCALL(SETUP_XfOrM235(_), regnode (38 ) ); 
        regmatchmin = regmatchmax = 0 ; 
        if (! regmaxlookback )
          regmaxlookback = 1 ; 
      }
      else if ((parse_flags & 0x2 ) && (c == 'p' ) ) {
#       define XfOrM234_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM234(x) SETUP_XfOrM227(x)
        ret = FUNCCALL(SETUP_XfOrM234(_), regunicode (0 ) ); 
        regmatchmax = 6 ; 
        * flagp |= 0x01 ; 
      }
      else if ((parse_flags & 0x2 ) && (c == 'P' ) ) {
#       define XfOrM233_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM233(x) SETUP_XfOrM227(x)
        ret = FUNCCALL(SETUP_XfOrM233(_), regunicode (1 ) ); 
        regmatchmax = 6 ; 
        * flagp |= 0x01 ; 
      }
      else if ((parse_flags & 0x2 ) && (c >= '0' ) && (c <= '9' ) ) {
        int posn ; 
#       define XfOrM229_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM229(x) SETUP_XfOrM227(x)
        -- regparse ; 
        posn = FUNCCALL(SETUP_XfOrM229(_), regdigit () ); 
        if (parse_flags & 0x1 )
          ret = FUNCCALL(SETUP_XfOrM229(_), regnode (28 ) ); 
        else ret = FUNCCALL(SETUP_XfOrM229(_), regnode (29 ) ); 
        FUNCCALL(SETUP_XfOrM229(_), regarg (posn ) ); 
        * flagp &= ~ 0x08 ; 
        {
          Scheme_Object * f ; 
          BLOCK_SETUP((PUSH(f, 0+XfOrM229_COUNT)));
#         define XfOrM230_COUNT (1+XfOrM229_COUNT)
#         define SETUP_XfOrM230(x) SETUP(XfOrM230_COUNT)
          f = NULLED_OUT ; 
          if (regbackknown )
            f = FUNCCALL(SETUP_XfOrM230(_), scheme_hash_get (regbackknown , ((Scheme_Object * ) (void * ) (long ) ((((long ) (posn ) ) << 1 ) | 0x1 ) ) ) ); 
          else f = ((void * ) 0 ) ; 
          if (f ) {
            if ((! (((f ) ) == (scheme_false ) ) ) )
              * flagp |= 0x01 ; 
          }
          else {
#           define XfOrM231_COUNT (0+XfOrM230_COUNT)
#           define SETUP_XfOrM231(x) SETUP_XfOrM230(x)
            * flagp |= 0x01 ; 
            if (! regbackdepends )
              regbackdepends = FUNCCALL(SETUP_XfOrM231(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            FUNCCALL(SETUP_XfOrM231(_), scheme_hash_set (regbackdepends , ((Scheme_Object * ) (void * ) (long ) ((((long ) (posn ) ) << 1 ) | 0x1 ) ) , scheme_true ) ); 
          }
        }
      }
      else {
#       define XfOrM228_COUNT (0+XfOrM227_COUNT)
#       define SETUP_XfOrM228(x) SETUP_XfOrM227(x)
        regparse -= 2 ; 
        ret = FUNCCALL(SETUP_XfOrM228(_), regranges (parse_flags , at_start ) ); 
        * flagp |= 0x01 | 0x02 ; 
      }
    }
    break ; 
    default : {
      int len , ilen , c ; 
      char ender ; 
      regparse -- ; 
#     define XfOrM207_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM207(x) SETUP_XfOrM206(x)
      if (parse_flags & 0x2 ) {
#       define XfOrM223_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM223(x) SETUP_XfOrM207(x)
        if (regparsestr [regparse ] == '{' ) {
#         define XfOrM226_COUNT (0+XfOrM223_COUNT)
#         define SETUP_XfOrM226(x) SETUP_XfOrM223(x)
          FUNCCALL(SETUP_XfOrM226(_), regcomperror ("`{' follows nothing in pattern" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
        if (regparsestr [regparse ] == '}' ) {
#         define XfOrM225_COUNT (0+XfOrM223_COUNT)
#         define SETUP_XfOrM225(x) SETUP_XfOrM223(x)
          FUNCCALL(SETUP_XfOrM225(_), regcomperror ("unmatched `}' in pattern" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
        if (regparsestr [regparse ] == ']' ) {
#         define XfOrM224_COUNT (0+XfOrM223_COUNT)
#         define SETUP_XfOrM224(x) SETUP_XfOrM223(x)
          FUNCCALL(SETUP_XfOrM224(_), regcomperror ("unmatched `]' in pattern" ) ); 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        ; 
      }
      for (len = ilen = 0 ; regparse + ilen < regparse_end ; len ++ , ilen ++ ) {
#       define XfOrM221_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM221(x) SETUP_XfOrM207(x)
        if (regparsestr [regparse + ilen ] == '\\' ) {
          if (regparse + ilen + 1 >= regparse_end )
            break ; 
          c = regparsestr [regparse + ilen + 1 ] ; 
          if (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) )
            break ; 
          ilen ++ ; 
        }
        else if (FUNCCALL(SETUP_XfOrM221(_), regstrcspn (regparsestr + regparse + ilen , regparsestr + regparse + ilen + 1 , (parse_flags & 0x2 ) ? "^$.[()|?+*\\{}]" : "^$.[()|?+*\\" ) )< 1 )
          break ; 
      }
      if (len <= 0 ) {
#       define XfOrM218_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM218(x) SETUP_XfOrM207(x)
        FUNCCALL(SETUP_XfOrM218(_), regcomperror ("internal disaster" ) ); 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      ; 
      if ((len == 1 ) && at_start ) {
#       define XfOrM217_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM217(x) SETUP_XfOrM207(x)
        ret = FUNCCALL(SETUP_XfOrM217(_), regranges (parse_flags , at_start ) ); 
        * flagp |= 0x01 | 0x02 ; 
      }
      else {
#       define XfOrM208_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM208(x) SETUP_XfOrM207(x)
        if (! (parse_flags & 0x1 ) ) {
          int i ; 
          for (i = 0 ; i < ilen ; i ++ ) {
            c = regparsestr [regparse + i ] ; 
            if (((((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) != c ) || ((((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) != c ) ) {
              break ; 
            }
          }
          if (i >= ilen )
            parse_flags |= 0x1 ; 
        }
        ender = regparsestr [regparse + ilen ] ; 
        if (len > 1 && ((ender ) == '*' || (ender ) == '+' || (ender ) == '?' || ((parse_flags & 0x2 ) && ((ender ) == '{' ) ) ) ) {
          len -- ; 
          ilen -- ; 
          if (regparsestr [regparse + ilen ] == '\\' )
            -- ilen ; 
        }
        * flagp |= 0x01 ; 
        if (len == 1 )
          * flagp |= 0x02 ; 
        regmatchmin = regmatchmax = len ; 
        ret = FUNCCALL_EMPTY(regnode ((parse_flags & 0x1 ) ? 11 : 12 ) ); 
        FUNCCALL_EMPTY(regarg (len ) ); 
        while (len > 0 ) {
#         define XfOrM210_COUNT (0+XfOrM208_COUNT)
#         define SETUP_XfOrM210(x) SETUP_XfOrM208(x)
          c = regparsestr [regparse ++ ] ; 
          if (c == '\\' )
            c = regparsestr [regparse ++ ] ; 
          if (! (parse_flags & 0x1 ) )
            c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
          FUNCCALL_EMPTY(regc (c ) ); 
          len -- ; 
        }
      }
    }
    break ; 
  }
  if (! ret ) {
#   define XfOrM205_COUNT (0+XfOrM204_COUNT)
#   define SETUP_XfOrM205(x) SETUP_XfOrM204(x)
    FUNCCALL_EMPTY(regcomperror ("failed!?" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int regcharclass (int c , char * map ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM299_COUNT (1)
# define SETUP_XfOrM299(x) SETUP(XfOrM299_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  switch (c ) {
#   define XfOrM300_COUNT (0+XfOrM299_COUNT)
#   define SETUP_XfOrM300(x) SETUP_XfOrM299(x)
    case 'd' : for (c = 0 ; c < 10 ; c ++ ) {
      map ['0' + c ] = 1 ; 
    }
    break ; 
    case 'D' : for (c = 0 ; c < '0' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = '9' + 1 ; c < 256 ; c ++ ) {
      map [c ] = 1 ; 
    }
    break ; 
    case 'w' : for (c = 0 ; c < 26 ; c ++ ) {
      map ['a' + c ] = 1 ; 
      map ['A' + c ] = 1 ; 
    }
    for (c = 0 ; c < 10 ; c ++ ) {
      map ['0' + c ] = 1 ; 
    }
    map ['_' ] = 1 ; 
    break ; 
    case 'W' : for (c = 0 ; c < '0' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = '9' + 1 ; c < 'A' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = 'Z' + 1 ; c < '_' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = 'z' + 1 ; c < 256 ; c ++ ) {
      map [c ] = 1 ; 
    }
    break ; 
    case 's' : map ['\t' ] = 1 ; 
    map ['\n' ] = 1 ; 
    map ['\f' ] = 1 ; 
    map ['\r' ] = 1 ; 
    map [' ' ] = 1 ; 
    break ; 
    case 'S' : for (c = 0 ; c < 256 ; c ++ ) {
      switch (c ) {
        case '\t' : case '\n' : case '\f' : case '\r' : case ' ' : break ; 
        default : map [c ] = 1 ; 
        break ; 
      }
    }
    break ; 
    default : if (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#     define XfOrM301_COUNT (0+XfOrM300_COUNT)
#     define SETUP_XfOrM301(x) SETUP_XfOrM300(x)
      {
#       define XfOrM302_COUNT (0+XfOrM301_COUNT)
#       define SETUP_XfOrM302(x) SETUP_XfOrM301(x)
        FUNCCALL(SETUP_XfOrM302(_), regcomperror ("illegal alphabetic escape" ) ); 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      ; 
    }
    map [c ] = 1 ; 
    break ; 
  }
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int is_posix_char_class (char * str , int pos , int len , char * map ) {
  int c ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(map, 0), PUSH(str, 1)));
# define XfOrM325_COUNT (2)
# define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (pos + 8 <= len ) {
#   define XfOrM332_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM332(x) SETUP_XfOrM325(x)
    if (! (scheme_strncmp (":alnum:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
#     define XfOrM367_COUNT (0+XfOrM332_COUNT)
#     define SETUP_XfOrM367(x) SETUP_XfOrM332(x)
      if (map ) {
#       define XfOrM368_COUNT (0+XfOrM367_COUNT)
#       define SETUP_XfOrM368(x) SETUP_XfOrM367(x)
        FUNCCALL(SETUP_XfOrM368(_), regcharclass ('d' , map ) ); 
        for (c = 'a' ; c <= 'z' ; c ++ ) {
          map [c ] = 1 ; 
          map [c - ('a' - 'A' ) ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":alpha:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 'a' ; c <= 'z' ; c ++ ) {
          map [c ] = 1 ; 
          map [c - ('a' - 'A' ) ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":ascii:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 127 ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":blank:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        map [' ' ] = 1 ; 
        map ['\t' ] = 1 ; 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":cntrl:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 31 ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":digit:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
#     define XfOrM351_COUNT (0+XfOrM332_COUNT)
#     define SETUP_XfOrM351(x) SETUP_XfOrM332(x)
      if (map ) {
#       define XfOrM352_COUNT (0+XfOrM351_COUNT)
#       define SETUP_XfOrM352(x) SETUP_XfOrM351(x)
        FUNCCALL(SETUP_XfOrM352(_), regcharclass ('d' , map ) ); 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":graph:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 127 ; c ++ ) {
          if ((((scheme_uchar_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ) & 0x800 ) )
            map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":lower:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 'a' ; c <= 'z' ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":print:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 127 ; c ++ ) {
          if ((((scheme_uchar_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ) & 0x800 ) )
            map [c ] = 1 ; 
        }
        map [' ' ] = 1 ; 
        map ['\t' ] = 1 ; 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":space:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
#     define XfOrM337_COUNT (0+XfOrM332_COUNT)
#     define SETUP_XfOrM337(x) SETUP_XfOrM332(x)
      if (map ) {
#       define XfOrM338_COUNT (0+XfOrM337_COUNT)
#       define SETUP_XfOrM338(x) SETUP_XfOrM337(x)
        FUNCCALL(SETUP_XfOrM338(_), regcharclass ('s' , map ) ); 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (! (scheme_strncmp (":upper:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 'A' ; c <= 'Z' ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }
  if ((pos + 7 <= len ) && ! (scheme_strncmp (":word:]" , str XFORM_OK_PLUS pos , 7 ) ) ) {
#   define XfOrM330_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM330(x) SETUP_XfOrM325(x)
    if (map ) {
#     define XfOrM331_COUNT (0+XfOrM330_COUNT)
#     define SETUP_XfOrM331(x) SETUP_XfOrM330(x)
      FUNCCALL(SETUP_XfOrM331(_), regcharclass ('w' , map ) ); 
    }
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  if ((pos + 9 <= len ) && ! (scheme_strncmp (":xdigit:]" , str XFORM_OK_PLUS pos , 9 ) ) ) {
#   define XfOrM326_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM326(x) SETUP_XfOrM325(x)
    if (map ) {
#     define XfOrM327_COUNT (0+XfOrM326_COUNT)
#     define SETUP_XfOrM327(x) SETUP_XfOrM326(x)
      FUNCCALL(SETUP_XfOrM327(_), regcharclass ('d' , map ) ); 
      for (c = 'a' ; c <= 'f' ; c ++ ) {
        map [c ] = 1 ; 
        map [c - ('a' - 'A' ) ] = 1 ; 
      }
    }
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int is_posix_char_class_in_unicode (mzchar * str , int pos , int len , char * map ) {
  /* No conversion */
  int ulen ; 
  int i ; 
  char buf [10 ] ; 
  if (pos + 7 > len )
    return 0 ; 
  ulen = len - pos ; 
  if (ulen > 9 )
    ulen = 9 ; 
  for (i = 0 ; i < ulen ; i ++ ) {
    if (str [pos + i ] > 127 )
      return 0 ; 
    buf [i ] = (char ) str [pos + i ] ; 
  }
  return is_posix_char_class (buf , 0 , ulen , map ) ; 
}
static char * regrange (int parse_flags , char * map ) {
  int xclass , c ; 
  int classend , can_range = 0 ; 
  int exclude = 0 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM374_COUNT (1)
# define SETUP_XfOrM374(x) SETUP(XfOrM374_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (regparsestr [regparse ] == '^' ) {
    exclude = 1 ; 
    regparse ++ ; 
  }
  if (regparsestr [regparse ] == ']' || regparsestr [regparse ] == '-' ) {
    c = regparsestr [regparse ] ; 
    map [c ] = 1 ; 
    regparse ++ ; 
  }
  while (regparse != regparse_end && regparsestr [regparse ] != ']' ) {
#   define XfOrM406_COUNT (0+XfOrM374_COUNT)
#   define SETUP_XfOrM406(x) SETUP_XfOrM374(x)
    if (regparsestr [regparse ] == '-' ) {
      regparse ++ ; 
#     define XfOrM415_COUNT (0+XfOrM406_COUNT)
#     define SETUP_XfOrM415(x) SETUP_XfOrM406(x)
      if (regparsestr [regparse ] == ']' || regparse == regparse_end ) {
        map ['-' ] = 1 ; 
      }
      else {
#       define XfOrM416_COUNT (0+XfOrM415_COUNT)
#       define SETUP_XfOrM416(x) SETUP_XfOrM415(x)
        if (! can_range ) {
#         define XfOrM430_COUNT (0+XfOrM416_COUNT)
#         define SETUP_XfOrM430(x) SETUP_XfOrM416(x)
          {
#           define XfOrM431_COUNT (0+XfOrM430_COUNT)
#           define SETUP_XfOrM431(x) SETUP_XfOrM430(x)
            FUNCCALL(SETUP_XfOrM431(_), regcomperror ("misplaced hypen within square brackets in pattern" ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          ; 
        }
        else {
#         define XfOrM417_COUNT (0+XfOrM416_COUNT)
#         define SETUP_XfOrM417(x) SETUP_XfOrM416(x)
          xclass = ((unsigned char ) (regparsestr [regparse - 2 ] ) ) + 1 ; 
          classend = ((unsigned char ) (regparsestr [regparse ] ) ) ; 
          if (classend == '-' ) {
#           define XfOrM428_COUNT (0+XfOrM417_COUNT)
#           define SETUP_XfOrM428(x) SETUP_XfOrM417(x)
            {
#             define XfOrM429_COUNT (0+XfOrM428_COUNT)
#             define SETUP_XfOrM429(x) SETUP_XfOrM428(x)
              FUNCCALL(SETUP_XfOrM429(_), regcomperror ("misplaced hypen within square brackets in pattern" ) ); 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            ; 
          }
          if ((classend == '\\' ) && (parse_flags & 0x2 ) ) {
#           define XfOrM423_COUNT (0+XfOrM417_COUNT)
#           define SETUP_XfOrM423(x) SETUP_XfOrM417(x)
            if (regparse + 1 == regparse_end ) {
#             define XfOrM426_COUNT (0+XfOrM423_COUNT)
#             define SETUP_XfOrM426(x) SETUP_XfOrM423(x)
              {
#               define XfOrM427_COUNT (0+XfOrM426_COUNT)
#               define SETUP_XfOrM427(x) SETUP_XfOrM426(x)
                FUNCCALL(SETUP_XfOrM427(_), regcomperror ("escaping backslash at end pattern (within square brackets)" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
            regparse ++ ; 
            classend = ((unsigned char ) (regparsestr [regparse ] ) ) ; 
            if (((classend >= 'a' ) && (classend <= 'z' ) ) || ((classend >= 'A' ) && (classend <= 'Z' ) ) ) {
#             define XfOrM424_COUNT (0+XfOrM423_COUNT)
#             define SETUP_XfOrM424(x) SETUP_XfOrM423(x)
              {
#               define XfOrM425_COUNT (0+XfOrM424_COUNT)
#               define SETUP_XfOrM425(x) SETUP_XfOrM424(x)
                FUNCCALL(SETUP_XfOrM425(_), regcomperror ("misplaced hypen within square brackets in pattern" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
          }
          if (xclass > classend + 1 ) {
#           define XfOrM422_COUNT (0+XfOrM417_COUNT)
#           define SETUP_XfOrM422(x) SETUP_XfOrM417(x)
            FUNCCALL(SETUP_XfOrM422(_), regcomperror ("invalid range within square brackets in pattern" ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          ; 
          for (; xclass <= classend ; xclass ++ ) {
            c = xclass ; 
            map [c ] = 1 ; 
            if (! (parse_flags & 0x1 ) ) {
              c = (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ; 
              map [c ] = 1 ; 
              c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
              map [c ] = 1 ; 
            }
          }
          regparse ++ ; 
        }
      }
      can_range = 0 ; 
    }
    else if ((regparsestr [regparse ] == '\\' ) && (parse_flags & 0x2 ) ) {
#     define XfOrM412_COUNT (0+XfOrM406_COUNT)
#     define SETUP_XfOrM412(x) SETUP_XfOrM406(x)
      c = ((unsigned char ) (regparsestr [regparse + 1 ] ) ) ; 
      if (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#       define XfOrM414_COUNT (0+XfOrM412_COUNT)
#       define SETUP_XfOrM414(x) SETUP_XfOrM412(x)
        FUNCCALL(SETUP_XfOrM414(_), regcharclass (c , map ) ); 
        can_range = 0 ; 
      }
      else {
        map [c ] = 1 ; 
        can_range = 1 ; 
      }
      regparse += 2 ; 
    }
    else if ((regparsestr [regparse ] == '[' ) && (parse_flags & 0x2 ) && (regparsestr [regparse + 1 ] == ':' ) && FUNCCALL(SETUP_XfOrM406(_), is_posix_char_class (regparsestr , regparse + 1 , regparse_end , map ) )) {
      regparse += 2 ; 
      while (regparsestr [regparse ] != ']' ) {
        regparse ++ ; 
      }
      regparse ++ ; 
      can_range = 0 ; 
    }
    else {
      c = ((unsigned char ) (regparsestr [regparse ++ ] ) ) ; 
      map [c ] = 1 ; 
      if (! (parse_flags & 0x1 ) ) {
        c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
        map [c ] = 1 ; 
        c = (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ; 
        map [c ] = 1 ; 
      }
      can_range = 1 ; 
    }
  }
  if (exclude ) {
    for (c = 0 ; c < 256 ; c ++ ) {
      map [c ] = ! map [c ] ; 
    }
  }
  if (regparsestr [regparse ] != ']' ) {
#   define XfOrM375_COUNT (0+XfOrM374_COUNT)
#   define SETUP_XfOrM375(x) SETUP_XfOrM374(x)
    FUNCCALL(SETUP_XfOrM375(_), regcomperror ("missing closing square bracket in pattern" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  regparse ++ ; 
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static rxpos regranges (int parse_flags , int at_start ) {
  int c ; 
  rxpos ret , save_regparse = 0 ; 
  int count , all_ci , num_ci , off_ranges , on_ranges , now_on , last_on , prev_last_on , use_ci ; 
  char * new_map = ((void * ) 0 ) , * accum_map = ((void * ) 0 ) ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(accum_map, 0), PUSH(new_map, 1)));
# define XfOrM435_COUNT (2)
# define SETUP_XfOrM435(x) SETUP(XfOrM435_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  count = 0 ; 
  while (1 ) {
#   define XfOrM516_COUNT (0+XfOrM435_COUNT)
#   define SETUP_XfOrM516(x) SETUP_XfOrM435(x)
    if (! new_map )
      new_map = (char * ) FUNCCALL(SETUP_XfOrM516(_), GC_malloc_atomic (256 ) ); 
    (memset (new_map , 0 , 256 ) ) ; 
    if (regparsestr [regparse ] == '\\' && (regparse + 1 < regparse_end ) ) {
#     define XfOrM527_COUNT (0+XfOrM516_COUNT)
#     define SETUP_XfOrM527(x) SETUP_XfOrM516(x)
      c = ((unsigned char ) (regparsestr [++ regparse ] ) ) ; 
      if (parse_flags & 0x2 ) {
#       define XfOrM528_COUNT (0+XfOrM527_COUNT)
#       define SETUP_XfOrM528(x) SETUP_XfOrM527(x)
        if ((c >= '0' ) && (c <= '9' ) )
          break ; 
        if (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#         define XfOrM529_COUNT (0+XfOrM528_COUNT)
#         define SETUP_XfOrM529(x) SETUP_XfOrM528(x)
          if ((c == 'p' ) || (c == 'P' ) ) {
            break ; 
          }
          FUNCCALL(SETUP_XfOrM529(_), regcharclass (regparsestr [regparse ] , new_map ) ); 
        }
        else new_map [c ] = 1 ; 
      }
      else new_map [c ] = 1 ; 
      regparse ++ ; 
    }
    else if (FUNCCALL(SETUP_XfOrM516(_), regstrcspn (regparsestr + regparse , regparsestr + regparse + 1 , (parse_flags & 0x2 ) ? "^$.[()|?+*\\{}]" : "^$.[()|?+*\\" ) )) {
      c = ((unsigned char ) (regparsestr [regparse ] ) ) ; 
      new_map [c ] = 1 ; 
      if (! (parse_flags & 0x1 ) ) {
        c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
        new_map [c ] = 1 ; 
        c = (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ; 
        new_map [c ] = 1 ; 
      }
      regparse ++ ; 
    }
    else if (regparsestr [regparse ] == '.' ) {
      for (c = 0 ; c < 256 ; c ++ ) {
        new_map [c ] = 1 ; 
      }
      if (! (parse_flags & 0x4 ) )
        new_map ['\n' ] = 0 ; 
      regparse ++ ; 
    }
    else if (regparsestr [regparse ] == '[' ) {
      regparse ++ ; 
#     define XfOrM521_COUNT (0+XfOrM516_COUNT)
#     define SETUP_XfOrM521(x) SETUP_XfOrM516(x)
      FUNCCALL(SETUP_XfOrM521(_), regrange (parse_flags , new_map ) ); 
    }
    else break ; 
    if (accum_map && (regparse < regparse_end ) && (regparsestr [regparse ] != '|' ) && (regparsestr [regparse ] != ')' ) )
      break ; 
    if (accum_map ) {
      for (c = 0 ; c < 256 ; c ++ ) {
        accum_map [c ] |= new_map [c ] ; 
      }
    }
    else {
      accum_map = new_map ; 
      new_map = ((void * ) 0 ) ; 
    }
    save_regparse = regparse ; 
    if (! at_start || (regparsestr [regparse ] != '|' ) || (regparse >= regparse_end ) || (regparsestr [regparse ] == ')' ) )
      break ; 
    regparse ++ ; 
    if (regparse == regparse_end )
      break ; 
  }
  regparse = save_regparse ; 
  if (! accum_map ) {
#   define XfOrM500_COUNT (0+XfOrM435_COUNT)
#   define SETUP_XfOrM500(x) SETUP_XfOrM435(x)
    FUNCCALL(SETUP_XfOrM500(_), regcomperror ("should have found one range!" ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  ; 
  use_ci = 0 ; 
  while (1 ) {
#   define XfOrM468_COUNT (0+XfOrM435_COUNT)
#   define SETUP_XfOrM468(x) SETUP_XfOrM435(x)
    count = 0 ; 
    num_ci = 0 ; 
    all_ci = 1 ; 
    on_ranges = 0 ; 
    off_ranges = 0 ; 
    now_on = 0 ; 
    last_on = - 1 ; 
    prev_last_on = - 1 ; 
    for (c = 0 ; c < 256 ; c ++ ) {
      if (accum_map [c ] ) {
        if (now_on < 0 )
          off_ranges ++ ; 
        now_on = 1 ; 
        count ++ ; 
        prev_last_on = last_on ; 
        last_on = c ; 
        if (c != (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ) {
          if (accum_map [(((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ] != accum_map [c ] )
            all_ci = 0 ; 
          num_ci ++ ; 
        }
        else if (c != (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ) {
          if (accum_map [(((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ] != accum_map [c ] )
            all_ci = 0 ; 
          num_ci ++ ; 
        }
      }
      else {
        if (now_on > 0 )
          on_ranges ++ ; 
        now_on = - 1 ; 
      }
    }
    if (now_on > 0 )
      on_ranges ++ ; 
    else off_ranges ++ ; 
    if (count == 256 ) {
#     define XfOrM489_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM489(x) SETUP_XfOrM468(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regnode (3 ) )) RET_VALUE_EMPTY_END ; 
    }
    else if ((count == 255 ) && ! accum_map ['\n' ] ) {
#     define XfOrM488_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM488(x) SETUP_XfOrM468(x)
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regnode (4 ) )) RET_VALUE_EMPTY_END ; 
    }
    else if (count == 1 ) {
#     define XfOrM487_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM487(x) SETUP_XfOrM468(x)
      ret = FUNCCALL(SETUP_XfOrM487(_), regnode (6 ) ); 
      FUNCCALL(SETUP_XfOrM487(_), regc (last_on ) ); 
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }
    else if (count == 2 ) {
#     define XfOrM486_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM486(x) SETUP_XfOrM468(x)
      ret = FUNCCALL(SETUP_XfOrM486(_), regnode (43 ) ); 
      FUNCCALL(SETUP_XfOrM486(_), regc (last_on ) ); 
      FUNCCALL_AGAIN(regc (prev_last_on ) ); 
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }
    else if ((on_ranges == 1 ) || (off_ranges == 1 ) ) {
      int rs = 255 , re = 255 , on ; 
#     define XfOrM477_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM477(x) SETUP_XfOrM468(x)
      if (on_ranges == 1 )
        on = 1 ; 
      else on = 0 ; 
      for (c = 0 ; c < 256 ; c ++ ) {
        if (! ! accum_map [c ] == on ) {
          rs = c ; 
          break ; 
        }
      }
      for (c ++ ; c < 256 ; c ++ ) {
        if (! accum_map [c ] == on ) {
          re = c - 1 ; 
          break ; 
        }
      }
      if (on )
        ret = FUNCCALL(SETUP_XfOrM477(_), regnode (7 ) ); 
      else ret = FUNCCALL(SETUP_XfOrM477(_), regnode (8 ) ); 
      FUNCCALL(SETUP_XfOrM477(_), regc (rs ) ); 
      FUNCCALL_AGAIN(regc (re ) ); 
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }
    else {
      rxpos a ; 
#     define XfOrM469_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM469(x) SETUP_XfOrM468(x)
      ret = FUNCCALL(SETUP_XfOrM469(_), regnode (5 ) ); 
      a = regcode ; 
      for (c = 0 ; c < 32 ; c ++ ) {
#       define XfOrM476_COUNT (0+XfOrM469_COUNT)
#       define SETUP_XfOrM476(x) SETUP_XfOrM469(x)
        FUNCCALL(SETUP_XfOrM476(_), regc (0 ) ); 
      }
      if (regcode <= regcodesize ) {
        for (c = 0 ; c < 256 ; c ++ ) {
          if (accum_map [c ] ) {
            regstr [a + (c >> 3 ) ] |= (1 << (c & 0x7 ) ) ; 
          }
        }
      }
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static char * prop_names [] = {
  "Cn" , "Cc" , "Cf" , "Cs" , "Co" , "Ll" , "Lu" , "Lt" , "Lm" , "Lo" , "Nd" , "Nl" , "No" , "Ps" , "Pe" , "Pi" , "Pf" , "Pc" , "Pd" , "Po" , "Mn" , "Mc" , "Me" , "Sc" , "Sk" , "Sm" , "So" , "Zl" , "Zp" , "Zs" , ((void * ) 0 ) }
; 
static rxpos regunicode (int negate ) {
  /* No conversion */
  rxpos ret ; 
  int len , bottom , top , i ; 
  if (regparsestr [regparse ] != '{' ) {
    {
      regcomperror ("expected { after \\p or \\P" ) ; 
      return 0 ; 
    }
    ; 
  }
  regparse ++ ; 
  if (regparsestr [regparse ] == '^' ) {
    negate = ! negate ; 
    regparse ++ ; 
  }
  len = 0 ; 
  while ((regparsestr [regparse + len ] != '}' ) && (regparse + len < regparse_end ) ) {
    len ++ ; 
  }
  if (regparse + len >= regparse_end ) {
    {
      regcomperror ("missing } to close \\p{ or \\P{" ) ; 
      return 0 ; 
    }
    ; 
  }
  bottom = top = - 1 ; 
  if (len == 2 ) {
    for (i = 0 ; prop_names [i ] ; i ++ ) {
      if ((regparsestr [regparse ] == prop_names [i ] [0 ] ) && (regparsestr [regparse + 1 ] == prop_names [i ] [1 ] ) ) {
        bottom = top = i ; 
        break ; 
      }
    }
    if (bottom == - 1 ) {
      if ((regparsestr [regparse ] == 'L' ) && (regparsestr [regparse + 1 ] == '&' ) ) {
        bottom = mzu_Ll ; 
        top = mzu_Lm ; 
      }
    }
  }
  else if (len == 1 ) {
    if (regparsestr [regparse ] == '.' ) {
      bottom = 0 ; 
      top = mzu_Zs ; 
    }
    else {
      for (i = 0 ; prop_names [i ] ; i ++ ) {
        if (regparsestr [regparse ] == prop_names [i ] [0 ] ) {
          bottom = i ; 
          while (prop_names [i + 1 ] ) {
            if (regparsestr [regparse ] != prop_names [i + 1 ] [0 ] )
              break ; 
            i ++ ; 
          }
          top = i ; 
          break ; 
        }
      }
    }
  }
  if (bottom < 0 ) {
    {
      regcomperror ("unrecognized property name in \\p{} or \\P{}" ) ; 
      return 0 ; 
    }
    ; 
  }
  regparse += len + 1 ; 
  ret = regnode (41 ) ; 
  regarg ((negate << 13 ) | (bottom << 6 ) | top ) ; 
  return ret ; 
}
static int regdigit () {
  /* No conversion */
  int posn , c ; 
  c = regparsestr [regparse ++ ] ; 
  posn = c - '0' ; 
  while (regparse < regparse_end ) {
    c = regparsestr [regparse ] ; 
    if ((c >= '0' ) && (c <= '9' ) ) {
      posn = (posn * 10 ) + (c - '0' ) ; 
      if (posn > 0x7FFF ) {
        regcomperror ("backreference number is too large" ) ; 
        return 0 ; 
      }
      ; 
      regparse ++ ; 
    }
    else break ; 
  }
  if (posn > regmaxbackposn )
    regmaxbackposn = posn ; 
  return posn ; 
}
static rxpos regnode (char op ) {
  /* No conversion */
  rxpos ret ; 
  rxpos ptr ; 
  ret = regcode ; 
  if (regcode + 3 >= regcodesize ) {
    regcode += 3 ; 
    if (regcode > regcodemax )
      regcodemax = regcode ; 
    return ret ; 
  }
  ptr = ret ; 
  regstr [ptr ++ ] = op ; 
  regstr [ptr ++ ] = '\0' ; 
  regstr [ptr ++ ] = '\0' ; 
  regcode = ptr ; 
  if (regcode > regcodemax )
    regcodemax = regcode ; 
  return ret ; 
}
static void regc (char b ) {
  /* No conversion */
  if (regcode + 1 < regcodesize )
    regstr [regcode ] = b ; 
  regcode ++ ; 
  if (regcode > regcodemax )
    regcodemax = regcode ; 
}
static void regarg (int v ) {
  /* No conversion */
  regc (v >> 8 ) ; 
  regc (v & 255 ) ; 
}
static void regshift (int amt , rxpos opnd ) {
  /* No conversion */
  if (regcode + amt < regcodesize ) {
    memmove (regstr XFORM_OK_PLUS opnd + amt , regstr XFORM_OK_PLUS opnd , regcode - opnd ) ; 
  }
  regcode += amt ; 
  if (regcode > regcodemax )
    regcodemax = regcode ; 
}
static void reginsert (char op , rxpos opnd ) {
  /* No conversion */
  regshift (3 , opnd ) ; 
  if (opnd + 3 >= regcodesize ) {
    return ; 
  }
  regstr [opnd ++ ] = op ; 
  regstr [opnd ++ ] = '\0' ; 
  regstr [opnd ++ ] = '\0' ; 
}
static rxpos reginsertwithop (char op , rxpos opnd , int arg ) {
  /* No conversion */
  regshift (5 , opnd ) ; 
  if (opnd + 5 >= regcodesize ) {
    return opnd + 5 ; 
  }
  regstr [opnd ++ ] = op ; 
  regstr [opnd ++ ] = '\0' ; 
  regstr [opnd ++ ] = '\0' ; 
  regstr [opnd ++ ] = (arg >> 8 ) ; 
  regstr [opnd ++ ] = (arg & 255 ) ; 
  return opnd ; 
}
static rxpos reginsertwithopop (char op , rxpos opnd , int arg , int arg2 ) {
  /* No conversion */
  regshift (7 , opnd ) ; 
  if (opnd + 7 >= regcodesize ) {
    return opnd + 7 ; 
  }
  regstr [opnd ++ ] = op ; 
  regstr [opnd ++ ] = '\0' ; 
  regstr [opnd ++ ] = '\0' ; 
  regstr [opnd ++ ] = (arg >> 8 ) ; 
  regstr [opnd ++ ] = (arg & 255 ) ; 
  regstr [opnd ++ ] = (arg2 >> 8 ) ; 
  regstr [opnd ++ ] = (arg2 & 255 ) ; 
  return opnd ; 
}
static void regtail (rxpos p , rxpos val ) {
  /* No conversion */
  rxpos scan ; 
  rxpos temp ; 
  int offset ; 
  scan = p ; 
  for (; ; ) {
    if (scan + 2 >= regcodesize ) {
      return ; 
    }
    temp = regnext (scan ) ; 
    if (temp == 0 )
      break ; 
    scan = temp ; 
  }
  if (scan + 2 >= regcodesize ) {
    return ; 
  }
  if ((regstr [scan ] ) == 10 )
    offset = scan - val ; 
  else offset = val - scan ; 
  regstr [scan + 1 ] = (offset >> 8 ) & 255 ; 
  regstr [scan + 2 ] = offset & 255 ; 
}
static void regoptail (rxpos p , rxpos val ) {
  /* No conversion */
  if (p == 0 || (p >= regcodesize ) || (regstr [p ] ) != 9 ) {
    return ; 
  }
  regtail (((p ) + 3 ) , val ) ; 
}
static int merge_tables (Scheme_Hash_Table * dest , Scheme_Hash_Table * src ) {
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(dest, 0), PUSH(src, 1)));
# define XfOrM586_COUNT (2)
# define SETUP_XfOrM586(x) SETUP(XfOrM586_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  for (i = src -> size ; i -- ; ) {
#   define XfOrM589_COUNT (0+XfOrM586_COUNT)
#   define SETUP_XfOrM589(x) SETUP_XfOrM586(x)
    if (src -> vals [i ] ) {
#     define XfOrM590_COUNT (0+XfOrM589_COUNT)
#     define SETUP_XfOrM590(x) SETUP_XfOrM589(x)
      FUNCCALL(SETUP_XfOrM590(_), scheme_hash_set (dest , src -> keys [i ] , src -> vals [i ] ) ); 
    }
  }
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int check_and_propagate_depends (void ) {
  int i , j ; 
  Scheme_Hash_Table * backdepends = regbackdepends , * ht , * next_ht = ((void * ) 0 ) ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(backdepends, 0), PUSH(next_ht, 1), PUSH(v, 2), PUSH(ht, 3)));
# define XfOrM591_COUNT (4)
# define SETUP_XfOrM591(x) SETUP(XfOrM591_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 
  v = NULLED_OUT ; 
  while (backdepends ) {
#   define XfOrM615_COUNT (0+XfOrM591_COUNT)
#   define SETUP_XfOrM615(x) SETUP_XfOrM591(x)
    for (i = backdepends -> size ; i -- ; ) {
#     define XfOrM627_COUNT (0+XfOrM615_COUNT)
#     define SETUP_XfOrM627(x) SETUP_XfOrM615(x)
      if (backdepends -> vals [i ] ) {
#       define XfOrM628_COUNT (0+XfOrM627_COUNT)
#       define SETUP_XfOrM628(x) SETUP_XfOrM627(x)
        if (regbackknown )
          v = FUNCCALL(SETUP_XfOrM628(_), scheme_hash_get (regbackknown , backdepends -> keys [i ] ) ); 
        else v = ((void * ) 0 ) ; 
        if (v ) {
#         define XfOrM630_COUNT (0+XfOrM628_COUNT)
#         define SETUP_XfOrM630(x) SETUP_XfOrM628(x)
          if ((((v ) ) == (scheme_false ) ) ) {
#           define XfOrM636_COUNT (0+XfOrM630_COUNT)
#           define SETUP_XfOrM636(x) SETUP_XfOrM630(x)
            {
#             define XfOrM637_COUNT (0+XfOrM636_COUNT)
#             define SETUP_XfOrM637(x) SETUP_XfOrM636(x)
              FUNCCALL(SETUP_XfOrM637(_), regcomperror ("*, +, or {...,} operand could be empty (via empty backreference)" ) ); 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            ; 
          }
          if (((Scheme_Type ) (((((long ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
#           define XfOrM631_COUNT (0+XfOrM630_COUNT)
#           define SETUP_XfOrM631(x) SETUP_XfOrM630(x)
            FUNCCALL(SETUP_XfOrM631(_), scheme_hash_set (regbackknown , backdepends -> keys [i ] , scheme_true ) ); 
            if (! next_ht )
              next_ht = FUNCCALL(SETUP_XfOrM631(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            ht = (Scheme_Hash_Table * ) v ; 
            for (j = ht -> size ; j -- ; ) {
#             define XfOrM634_COUNT (0+XfOrM631_COUNT)
#             define SETUP_XfOrM634(x) SETUP_XfOrM631(x)
              if (ht -> vals [j ] ) {
#               define XfOrM635_COUNT (0+XfOrM634_COUNT)
#               define SETUP_XfOrM635(x) SETUP_XfOrM634(x)
                FUNCCALL(SETUP_XfOrM635(_), scheme_hash_set (next_ht , ht -> keys [j ] , ht -> vals [j ] ) ); 
              }
            }
          }
        }
        else {
#         define XfOrM629_COUNT (0+XfOrM628_COUNT)
#         define SETUP_XfOrM629(x) SETUP_XfOrM628(x)
          if (! regbackknown )
            regbackknown = FUNCCALL(SETUP_XfOrM629(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          FUNCCALL(SETUP_XfOrM629(_), scheme_hash_set (regbackknown , backdepends -> keys [i ] , scheme_true ) ); 
        }
      }
    }
    backdepends = next_ht ; 
    next_ht = ((void * ) 0 ) ; 
  }
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static inline rxpos l_strchr (char * str , rxpos a , int l , int c ) {
  /* No conversion */
  int i ; 
  for (i = 0 ; i < l ; i ++ ) {
    if (str [a + i ] == c )
      return a + i ; 
  }
  return - 1 ; 
}
static inline rxpos l_strchr_ci (char * str , rxpos a , int l , int c ) {
  /* No conversion */
  int i , ch ; 
  for (i = 0 ; i < l ; i ++ ) {
    ch = str [a + i ] ; 
    ch = (((ch >= 'A' ) && (ch <= 'Z' ) ) ? (ch + ('a' - 'A' ) ) : ch ) ; 
    if (ch == c )
      return a + i ; 
  }
  return - 1 ; 
}
static inline int in_ranges (char * str , rxpos a , int l , int c ) {
  /* No conversion */
  int i ; 
  l *= 2 ; 
  for (i = 0 ; i < l ; i += 2 ) {
    if ((((unsigned char ) (str [a + i ] ) ) <= c ) && (((unsigned char ) (str [a + i + 1 ] ) ) >= c ) )
      return 1 ; 
  }
  return 0 ; 
}
static inline int in_ranges_ci (char * str , rxpos a , int l , int c ) {
  /* No conversion */
  int i ; 
  l *= 2 ; 
  c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
  for (i = 0 ; i < l ; i += 2 ) {
    if ((((unsigned char ) (str [a + i ] ) ) <= c ) && (((unsigned char ) (str [a + i + 1 ] ) ) >= c ) )
      return 1 ; 
  }
  return 0 ; 
}
static int regtry (regexp * , char * , int , int , rxpos * , rxpos * , rxpos * , int * , Regwork * rw , rxpos , int , int , int ) ; 
static int regtry_port (regexp * , Scheme_Object * , Scheme_Object * , int nonblock , rxpos * , rxpos * , rxpos * , int * , char * * , rxpos * , rxpos * , rxpos , Scheme_Object * , Scheme_Object * , rxpos , int , int , int ) ; 
static int regmatch (Regwork * rw , rxpos ) ; 
static int regrepeat (Regwork * rw , rxpos , int ) ; 
/* this far 2615 */
/* this far 2615 */
static int regexec (const char * who , regexp * prog , char * string , int stringpos , int stringlen , rxpos * startp , rxpos * maybep , rxpos * endp , Scheme_Object * port , Scheme_Object * unless_evt , int nonblock , char * * stringp , int peek , int get_offsets , Scheme_Object * discard_oport , Scheme_Object * portstart , Scheme_Object * portend , Scheme_Object * * _dropped ) {
  int spos ; 
  int * counters ; 
  Scheme_Object * dropped = ((void * ) 0 ) , * peekskip = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg22 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(18);
  BLOCK_SETUP_TOP((PUSH(unless_evt, 0), PUSH(counters, 1), PUSH(endp, 2), PUSH(who, 3), PUSH(peekskip, 4), PUSH(string, 5), PUSH(startp, 6), PUSH(discard_oport, 7), PUSH(prog, 8), PUSH(_dropped, 9), PUSH(stringp, 10), PUSH(portstart, 11), PUSH(port, 12), PUSH(dropped, 13), PUSH(portend, 14), PUSH(maybep, 15)));
# define XfOrM650_COUNT (16)
# define SETUP_XfOrM650(x) SETUP(XfOrM650_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  counters = NULLED_OUT ; 
  if (((unsigned char ) (prog -> program [0 ] ) ) != 156 ) {
#   define XfOrM709_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM709(x) SETUP_XfOrM650(x)
    FUNCCALL(SETUP_XfOrM709(_), regerror ("corrupted program" ) ); 
    RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
  }
  if (! port && (prog -> regmust >= 0 ) ) {
#   define XfOrM692_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM692(x) SETUP_XfOrM650(x)
    spos = stringpos ; 
    while (1 ) {
      int i , l = prog -> regmlen , ch , pos ; 
      GC_CAN_IGNORE char * p ; 
#     define XfOrM701_COUNT (0+XfOrM692_COUNT)
#     define SETUP_XfOrM701(x) SETUP_XfOrM692(x)
      if ((spos - stringpos ) + l <= stringlen ) {
#       define XfOrM708_COUNT (0+XfOrM701_COUNT)
#       define SETUP_XfOrM708(x) SETUP_XfOrM701(x)
        if (prog -> flags & 0x08 )
          pos = FUNCCALL(SETUP_XfOrM708(_), l_strchr_ci (string , spos , stringlen - (spos - stringpos ) - (l - 1 ) , ((char * ) prog XFORM_OK_PLUS prog -> regmust ) [0 ] ) ); 
        else pos = FUNCCALL(SETUP_XfOrM708(_), l_strchr (string , spos , stringlen - (spos - stringpos ) - (l - 1 ) , ((char * ) prog XFORM_OK_PLUS prog -> regmust ) [0 ] ) ); 
        if (pos == - 1 )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      else RET_VALUE_START (0 ) RET_VALUE_END ; 
      p = ((char * ) prog XFORM_OK_PLUS prog -> regmust ) ; 
      if (prog -> flags & 0x08 ) {
        for (i = 0 ; i < l ; i ++ ) {
          ch = string [pos + i ] ; 
          ch = (((ch >= 'A' ) && (ch <= 'Z' ) ) ? (ch + ('a' - 'A' ) ) : ch ) ; 
          if (ch != p [i ] )
            break ; 
        }
      }
      else {
        for (i = 0 ; i < l ; i ++ ) {
          if (string [pos + i ] != p [i ] )
            break ; 
        }
      }
      if (i >= l )
        break ; 
      spos = pos + 1 ; 
    }
  }
  if (prog -> ncounter ) {
#   define XfOrM691_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM691(x) SETUP_XfOrM650(x)
    counters = (int * ) FUNCCALL(SETUP_XfOrM691(_), GC_malloc_atomic (sizeof (int ) * prog -> ncounter ) ); 
  }
  else counters = ((void * ) 0 ) ; 
  if (port ) {
#   define XfOrM680_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM680(x) SETUP_XfOrM650(x)
    if (peek ) {
#     define XfOrM688_COUNT (0+XfOrM680_COUNT)
#     define SETUP_XfOrM688(x) SETUP_XfOrM680(x)
      peekskip = portstart ; 
      dropped = portstart ; 
      if (! ((peekskip ) == (((Scheme_Object * ) (void * ) (long ) ((((long ) (0 ) ) << 1 ) | 0x1 ) ) ) ) ) {
        char tmp [1 ] ; 
        long got ; 
#       define XfOrM689_COUNT (0+XfOrM688_COUNT)
#       define SETUP_XfOrM689(x) SETUP_XfOrM688(x)
        got = (__funcarg22 = FUNCCALL(SETUP_XfOrM689(_), scheme_bin_minus (peekskip , ((Scheme_Object * ) (void * ) (long ) ((((long ) (1 ) ) << 1 ) | 0x1 ) ) ) ), FUNCCALL_AGAIN(scheme_get_byte_string_unless ("regexp-match" , port , tmp , 0 , 1 , 1 , 1 , __funcarg22 , unless_evt ) )) ; 
        if (got == (- 1 ) ) {
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
      }
    }
    else {
      long amt , got ; 
#     define XfOrM681_COUNT (0+XfOrM680_COUNT)
#     define SETUP_XfOrM681(x) SETUP_XfOrM680(x)
      if ((((long ) (portstart ) ) & 0x1 ) ) {
        amt = (((long ) (portstart ) ) >> 1 ) ; 
        if (amt > 4096 )
          amt = 4096 ; 
      }
      else amt = 4096 ; 
      dropped = ((Scheme_Object * ) (void * ) (long ) ((((long ) (0 ) ) << 1 ) | 0x1 ) ) ; 
      if (amt ) {
        char * drain ; 
        BLOCK_SETUP((PUSH(drain, 0+XfOrM681_COUNT)));
#       define XfOrM682_COUNT (1+XfOrM681_COUNT)
#       define SETUP_XfOrM682(x) SETUP(XfOrM682_COUNT)
        drain = NULLED_OUT ; 
        drain = (char * ) FUNCCALL(SETUP_XfOrM682(_), GC_malloc_atomic (amt ) ); 
        do {
#         define XfOrM685_COUNT (0+XfOrM682_COUNT)
#         define SETUP_XfOrM685(x) SETUP_XfOrM682(x)
          got = FUNCCALL(SETUP_XfOrM685(_), scheme_get_byte_string (who , port , drain , 0 , amt , 0 , 0 , 0 ) ); 
          if (got != (- 1 ) ) {
            Scheme_Object * delta ; 
            BLOCK_SETUP((PUSH(delta, 0+XfOrM685_COUNT)));
#           define XfOrM686_COUNT (1+XfOrM685_COUNT)
#           define SETUP_XfOrM686(x) SETUP(XfOrM686_COUNT)
            delta = NULLED_OUT ; 
            if (discard_oport )
              FUNCCALL(SETUP_XfOrM686(_), scheme_put_byte_string (who , discard_oport , drain , 0 , got , 0 ) ); 
            dropped = FUNCCALL(SETUP_XfOrM686(_), scheme_bin_plus (dropped , ((Scheme_Object * ) (void * ) (long ) ((((long ) (got ) ) << 1 ) | 0x1 ) ) ) ); 
            delta = FUNCCALL_AGAIN(scheme_bin_minus (portstart , dropped ) ); 
            if (FUNCCALL(SETUP_XfOrM686(_), scheme_bin_gt (((Scheme_Object * ) (void * ) (long ) ((((long ) (amt ) ) << 1 ) | 0x1 ) ) , delta ) ))
              amt = (((long ) (delta ) ) >> 1 ) ; 
          }
        }
        while ((got != (- 1 ) ) && amt ) ; 
        if (amt )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }
    if (portend )
      portend = FUNCCALL(SETUP_XfOrM680(_), scheme_bin_minus (portend , dropped ) ); 
  }
  if (prog -> flags & 0x04 ) {
#   define XfOrM667_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM667(x) SETUP_XfOrM650(x)
    if (port ) {
      rxpos len = 0 , space = 0 ; 
#     define XfOrM668_COUNT (0+XfOrM667_COUNT)
#     define SETUP_XfOrM668(x) SETUP_XfOrM667(x)
      * stringp = ((void * ) 0 ) ; 
      if (FUNCCALL(SETUP_XfOrM668(_), regtry_port (prog , port , unless_evt , nonblock , startp , maybep , endp , counters , stringp , & len , & space , 0 , portend , peekskip , 0 , 1 , 1 , 0 ) )) {
#       define XfOrM678_COUNT (0+XfOrM668_COUNT)
#       define SETUP_XfOrM678(x) SETUP_XfOrM668(x)
        if (! peek ) {
          char * drain ; 
          long got ; 
          BLOCK_SETUP((PUSH(drain, 0+XfOrM678_COUNT)));
#         define XfOrM679_COUNT (1+XfOrM678_COUNT)
#         define SETUP_XfOrM679(x) SETUP(XfOrM679_COUNT)
          drain = NULLED_OUT ; 
          if (discard_oport && * startp )
            FUNCCALL(SETUP_XfOrM679(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , * startp , 0 ) ); 
          if (get_offsets )
            drain = * stringp ; 
          else drain = (char * ) FUNCCALL(SETUP_XfOrM679(_), GC_malloc_atomic (* endp ) ); 
          got = FUNCCALL(SETUP_XfOrM679(_), scheme_get_byte_string (who , port , drain , 0 , * endp , 0 , 0 , 0 ) ); 
        }
        * _dropped = dropped ; 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
      else {
#       define XfOrM669_COUNT (0+XfOrM668_COUNT)
#       define SETUP_XfOrM669(x) SETUP_XfOrM668(x)
        if (! peek ) {
          char * drain ; 
          long got ; 
          BLOCK_SETUP((PUSH(drain, 0+XfOrM669_COUNT)));
#         define XfOrM670_COUNT (1+XfOrM669_COUNT)
#         define SETUP_XfOrM670(x) SETUP(XfOrM670_COUNT)
          drain = NULLED_OUT ; 
          if (portend && (((long ) (portend ) ) & 0x1 ) && (((long ) (portend ) ) >> 1 ) < 4096 ) {
            got = (((long ) (portend ) ) >> 1 ) ; 
          }
          else got = 4096 ; 
          drain = (char * ) FUNCCALL(SETUP_XfOrM670(_), GC_malloc_atomic (got ) ); 
          while ((got = FUNCCALL(SETUP_XfOrM670(_), scheme_get_byte_string (who , port , drain , 0 , got , 0 , 0 , 0 ) )) != (- 1 ) ) {
#           define XfOrM674_COUNT (0+XfOrM670_COUNT)
#           define SETUP_XfOrM674(x) SETUP_XfOrM670(x)
            if (discard_oport )
              FUNCCALL(SETUP_XfOrM674(_), scheme_put_byte_string (who , discard_oport , drain , 0 , got , 0 ) ); 
            if (portend ) {
#             define XfOrM675_COUNT (0+XfOrM674_COUNT)
#             define SETUP_XfOrM675(x) SETUP_XfOrM674(x)
              portend = FUNCCALL(SETUP_XfOrM675(_), scheme_bin_minus (portend , ((Scheme_Object * ) (void * ) (long ) ((((long ) (got ) ) << 1 ) | 0x1 ) ) ) ); 
              if ((((long ) (portend ) ) & 0x1 ) ) {
                got = (((long ) (portend ) ) >> 1 ) ; 
                if (! got )
                  break ; 
                else if (got > 4096 )
                  got = 4096 ; 
              }
            }
            else got = 4096 ; 
          }
        }
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }
    else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regtry (prog , string , stringpos , stringlen , startp , maybep , endp , counters , 0 , stringpos , 1 , 1 , 0 ) )) RET_VALUE_EMPTY_END ; 
  }
  spos = stringpos ; 
  if (port ) {
    int at_line_start = 1 ; 
    rxpos len = 0 , skip = 0 , space = 0 ; 
#   define XfOrM652_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM652(x) SETUP_XfOrM650(x)
    * stringp = ((void * ) 0 ) ; 
    do {
      int discard = skip - prog -> maxlookback ; 
#     define XfOrM661_COUNT (0+XfOrM652_COUNT)
#     define SETUP_XfOrM661(x) SETUP_XfOrM652(x)
      if (discard >= 256 ) {
#       define XfOrM664_COUNT (0+XfOrM661_COUNT)
#       define SETUP_XfOrM664(x) SETUP_XfOrM661(x)
        if (! peek ) {
#         define XfOrM666_COUNT (0+XfOrM664_COUNT)
#         define SETUP_XfOrM666(x) SETUP_XfOrM664(x)
          if (discard_oport )
            FUNCCALL(SETUP_XfOrM666(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , discard , 0 ) ); 
          FUNCCALL(SETUP_XfOrM666(_), scheme_get_byte_string (who , port , * stringp , 0 , discard , 0 , 0 , 0 ) ); 
          if (portend )
            portend = FUNCCALL(SETUP_XfOrM666(_), scheme_bin_minus (portend , ((Scheme_Object * ) (void * ) (long ) ((((long ) (discard ) ) << 1 ) | 0x1 ) ) ) ); 
        }
        else {
#         define XfOrM665_COUNT (0+XfOrM664_COUNT)
#         define SETUP_XfOrM665(x) SETUP_XfOrM664(x)
          peekskip = FUNCCALL(SETUP_XfOrM665(_), scheme_bin_plus (peekskip , ((Scheme_Object * ) (void * ) (long ) ((((long ) (discard ) ) << 1 ) | 0x1 ) ) ) ); 
        }
        dropped = FUNCCALL(SETUP_XfOrM664(_), scheme_bin_plus (dropped , ((Scheme_Object * ) (void * ) (long ) ((((long ) (discard ) ) << 1 ) | 0x1 ) ) ) ); 
        len -= discard ; 
        skip -= discard ; 
        (memmove (* stringp , * stringp + discard , len ) ) ; 
      }
      if (FUNCCALL(SETUP_XfOrM661(_), regtry_port (prog , port , unless_evt , nonblock , startp , maybep , endp , counters , stringp , & len , & space , skip , portend , peekskip , 0 , ! space , at_line_start , 1 ) )) {
#       define XfOrM662_COUNT (0+XfOrM661_COUNT)
#       define SETUP_XfOrM662(x) SETUP_XfOrM661(x)
        if (! peek ) {
          char * drain ; 
          BLOCK_SETUP((PUSH(drain, 0+XfOrM662_COUNT)));
#         define XfOrM663_COUNT (1+XfOrM662_COUNT)
#         define SETUP_XfOrM663(x) SETUP(XfOrM663_COUNT)
          drain = NULLED_OUT ; 
          if (discard_oport && * startp )
            FUNCCALL(SETUP_XfOrM663(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , * startp , 0 ) ); 
          if (get_offsets )
            drain = * stringp ; 
          else drain = (char * ) FUNCCALL(SETUP_XfOrM663(_), GC_malloc_atomic (* endp ) ); 
          FUNCCALL(SETUP_XfOrM663(_), scheme_get_byte_string (who , port , drain , 0 , * endp , 0 , 0 , 0 ) ); 
        }
        * _dropped = dropped ; 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
      at_line_start = ((skip < len ) && ((* stringp ) [skip ] == '\n' ) ) ; 
      skip ++ ; 
    }
    while (len >= skip ) ; 
    if (! peek ) {
#     define XfOrM653_COUNT (0+XfOrM652_COUNT)
#     define SETUP_XfOrM653(x) SETUP_XfOrM652(x)
      if (len > 0 ) {
#       define XfOrM654_COUNT (0+XfOrM653_COUNT)
#       define SETUP_XfOrM654(x) SETUP_XfOrM653(x)
        if (discard_oport )
          FUNCCALL(SETUP_XfOrM654(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , len , 0 ) ); 
        FUNCCALL(SETUP_XfOrM654(_), scheme_get_byte_string (who , port , * stringp , 0 , len , 0 , 0 , 0 ) ); 
      }
    }
  }
  else {
#   define XfOrM651_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM651(x) SETUP_XfOrM650(x)
    if (FUNCCALL_EMPTY(regtry (prog , string , spos , stringlen - (spos - stringpos ) , startp , maybep , endp , counters , 0 , stringpos , 1 , 1 , 1 ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int regtry (regexp * prog , char * string , int stringpos , int stringlen , rxpos * startp , rxpos * maybep , rxpos * endp , int * counters , Regwork * rw , rxpos stringorigin , int atstart , int atlinestart , int unanchored ) {
  int i ; 
  Regwork _rw ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(14);
  BLOCK_SETUP_TOP((PUSH(prog, 0), PUSH(string, 1), PUSH(endp, 2), PUSH(startp, 3), PUSH(rw, 4), PUSH(_rw.str, 5), PUSH(_rw.instr, 6), PUSH(_rw.port, 7), PUSH(_rw.unless_evt, 8), PUSH(_rw.startp, 9), PUSH(_rw.maybep, 10), PUSH(_rw.endp, 11), PUSH(_rw.counters, 12), PUSH(_rw.peekskip, 13)));
# define XfOrM710_COUNT (14)
# define SETUP_XfOrM710(x) SETUP(XfOrM710_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  _rw.str = NULLED_OUT ; 
  _rw.instr = NULLED_OUT ; 
  _rw.port = NULLED_OUT ; 
  _rw.unless_evt = NULLED_OUT ; 
  _rw.startp = NULLED_OUT ; 
  _rw.maybep = NULLED_OUT ; 
  _rw.endp = NULLED_OUT ; 
  _rw.counters = NULLED_OUT ; 
  _rw.peekskip = NULLED_OUT ; 
  if (! rw ) {
    rw = & _rw ; 
    rw -> port = ((void * ) 0 ) ; 
  }
  rw -> instr = string ; 
  rw -> input = stringpos ; 
  rw -> input_end = stringpos + stringlen ; 
  rw -> input_start = stringorigin ; 
  rw -> startp = startp ; 
  rw -> maybep = maybep ; 
  rw -> endp = endp ; 
  rw -> counters = counters ; 
  if (atstart )
    rw -> boi = stringpos ; 
  else rw -> boi = - 1 ; 
  if (atlinestart )
    rw -> bol = stringpos ; 
  else rw -> bol = - 1 ; 
  for (i = prog -> nsubexp ; i -- ; ) {
    startp [i ] = - 1 ; 
    endp [i ] = - 1 ; 
  }
  regstr = (char * ) prog ; 
  while (1 ) {
    int found ; 
#   define XfOrM719_COUNT (0+XfOrM710_COUNT)
#   define SETUP_XfOrM719(x) SETUP_XfOrM710(x)
    found = FUNCCALL(SETUP_XfOrM719(_), regmatch (rw , ((prog -> program + 1 ) - (char * ) prog ) ) ); 
    if (found ) {
      startp [0 ] = stringpos ; 
      endp [0 ] = rw -> input ; 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
    else if (unanchored ) {
      if (! stringlen )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      stringpos ++ ; 
      -- stringlen ; 
      if (prog -> regstart ) {
        unsigned char * rs = prog -> regstart ; 
        int c ; 
        while (1 ) {
          if (! stringlen )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          c = ((unsigned char ) (string [stringpos ] ) ) ; 
          if (rs [c >> 3 ] & (1 << (c & 0x7 ) ) )
            break ; 
          stringpos ++ ; 
          -- stringlen ; 
        }
      }
      if (string [stringpos - 1 ] == '\n' )
        rw -> bol = stringpos ; 
      else rw -> bol = - 1 ; 
      rw -> boi = - 1 ; 
      rw -> input = stringpos ; 
      for (i = prog -> nsubexp ; i -- ; ) {
        startp [i ] = - 1 ; 
        endp [i ] = - 1 ; 
      }
    }
    else RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static void read_more_from_regport (Regwork * rw , rxpos need_total ) {
  long got ; 
  Scheme_Object * peekskip ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(rw, 0), PUSH(peekskip, 1)));
# define XfOrM730_COUNT (2)
# define SETUP_XfOrM730(x) SETUP(XfOrM730_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  peekskip = NULLED_OUT ; 
  if (need_total > rw -> input_maxend ) {
    need_total = rw -> input_maxend ; 
    if (need_total <= rw -> input_end ) {
      rw -> port = ((void * ) 0 ) ; 
      RET_NOTHING ; 
    }
  }
  if (rw -> instr_size < need_total ) {
    char * naya ; 
    long size = rw -> instr_size ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM730_COUNT)));
#   define XfOrM737_COUNT (1+XfOrM730_COUNT)
#   define SETUP_XfOrM737(x) SETUP(XfOrM737_COUNT)
    naya = NULLED_OUT ; 
    size = size * 2 ; 
    if (size < need_total )
      size += need_total ; 
    if (size < 16 )
      size = 16 ; 
    naya = (char * ) FUNCCALL(SETUP_XfOrM737(_), GC_malloc_atomic (size ) ); 
    (memcpy (naya , rw -> instr , rw -> input_end ) ) ; 
    rw -> instr = naya ; 
    rw -> instr_size = size ; 
  }
  rw -> str = regstr ; 
  if (rw -> input_maxend < rw -> instr_size )
    got = rw -> input_maxend - rw -> input_end ; 
  else got = rw -> instr_size - rw -> input_end ; 
  if (rw -> peekskip )
    peekskip = FUNCCALL(SETUP_XfOrM730(_), scheme_bin_plus (((Scheme_Object * ) (void * ) (long ) ((((long ) (rw -> input_end ) ) << 1 ) | 0x1 ) ) , rw -> peekskip ) ); 
  else peekskip = ((Scheme_Object * ) (void * ) (long ) ((((long ) (rw -> input_end ) ) << 1 ) | 0x1 ) ) ; 
  got = FUNCCALL(SETUP_XfOrM730(_), scheme_get_byte_string_unless ("regexp-match" , rw -> port , rw -> instr , rw -> input_end , got , (rw -> nonblock ? 2 : 1 ) , 1 , peekskip , rw -> unless_evt ) ); 
  regstr = rw -> str ; 
  if (got < 1 ) {
    if (! got )
      rw -> aborted = 1 ; 
    rw -> port = ((void * ) 0 ) ; 
    rw -> unless_evt = ((void * ) 0 ) ; 
  }
  else {
#   define XfOrM731_COUNT (0+XfOrM730_COUNT)
#   define SETUP_XfOrM731(x) SETUP_XfOrM730(x)
    rw -> input_end += got ; 
    if (need_total > rw -> input_end ) {
#     define XfOrM732_COUNT (0+XfOrM731_COUNT)
#     define SETUP_XfOrM732(x) SETUP_XfOrM731(x)
      if (rw -> nonblock ) {
        rw -> port = ((void * ) 0 ) ; 
        rw -> unless_evt = ((void * ) 0 ) ; 
        rw -> aborted = 1 ; 
      }
      else {
#       define XfOrM733_COUNT (0+XfOrM732_COUNT)
#       define SETUP_XfOrM733(x) SETUP_XfOrM732(x)
        if (rw -> peekskip )
          peekskip = FUNCCALL(SETUP_XfOrM733(_), scheme_bin_plus (((Scheme_Object * ) (void * ) (long ) ((((long ) (rw -> input_end ) ) << 1 ) | 0x1 ) ) , rw -> peekskip ) ); 
        else peekskip = ((Scheme_Object * ) (void * ) (long ) ((((long ) (rw -> input_end ) ) << 1 ) | 0x1 ) ) ; 
        rw -> str = regstr ; 
        got = FUNCCALL(SETUP_XfOrM733(_), scheme_get_byte_string_unless ("regexp-match" , rw -> port , rw -> instr , rw -> input_end , need_total - rw -> input_end , 0 , 1 , peekskip , rw -> unless_evt ) ); 
        regstr = rw -> str ; 
        if (got == (- 1 ) ) {
          rw -> port = ((void * ) 0 ) ; 
          rw -> unless_evt = ((void * ) 0 ) ; 
        }
        else rw -> input_end += got ; 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
/* this far 2872 */
static int regtry_port (regexp * prog , Scheme_Object * port , Scheme_Object * unless_evt , int nonblock , rxpos * startp , rxpos * maybep , rxpos * endp , int * counters , char * * work_string , rxpos * len , rxpos * size , rxpos skip , Scheme_Object * maxlen , Scheme_Object * peekskip , rxpos origin , int atstart , int atlinestart , int read_at_least_one ) {
  int m ; 
  Regwork rw ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(13);
  BLOCK_SETUP_TOP((PUSH(size, 0), PUSH(len, 1), PUSH(work_string, 2), PUSH(rw.str, 3), PUSH(rw.instr, 4), PUSH(rw.port, 5), PUSH(rw.unless_evt, 6), PUSH(rw.startp, 7), PUSH(rw.maybep, 8), PUSH(rw.endp, 9), PUSH(rw.counters, 10), PUSH(rw.peekskip, 11), PUSH(port, 12)));
# define XfOrM740_COUNT (13)
# define SETUP_XfOrM740(x) SETUP(XfOrM740_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rw.str = NULLED_OUT ; 
  rw.instr = NULLED_OUT ; 
  rw.port = NULLED_OUT ; 
  rw.unless_evt = NULLED_OUT ; 
  rw.startp = NULLED_OUT ; 
  rw.maybep = NULLED_OUT ; 
  rw.endp = NULLED_OUT ; 
  rw.counters = NULLED_OUT ; 
  rw.peekskip = NULLED_OUT ; 
  rw . port = port ; 
  rw . unless_evt = unless_evt ; 
  rw . nonblock = (short ) nonblock ; 
  rw . aborted = 0 ; 
  rw . instr_size = * size ; 
  if (maxlen && (((long ) (maxlen ) ) & 0x1 ) )
    rw . input_maxend = (((long ) (maxlen ) ) >> 1 ) ; 
  else rw . input_maxend = 0x7FFFFFFFFFFFFFFF ; 
  rw . peekskip = peekskip ; 
  m = FUNCCALL(SETUP_XfOrM740(_), regtry (prog , * work_string , skip , (* len ) - skip , startp , maybep , endp , counters , & rw , origin , atstart , atlinestart , 0 ) ); 
  if (read_at_least_one && ! rw . aborted && (rw . input_end == skip ) && rw . port ) {
#   define XfOrM741_COUNT (0+XfOrM740_COUNT)
#   define SETUP_XfOrM741(x) SETUP_XfOrM740(x)
    FUNCCALL(SETUP_XfOrM741(_), read_more_from_regport (& rw , rw . input_end + 1 ) ); 
  }
  * work_string = rw . instr ; 
  * len = rw . input_end ; 
  * size = rw . instr_size ; 
  if (rw . aborted )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  else RET_VALUE_START (m ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * regmatch_k (void ) {
  /* No conversion */
  Scheme_Thread * p = scheme_current_thread ; 
  Regwork * rw = (Regwork * ) p -> ku . k . p1 ; 
  int res ; 
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  regstr = rw -> str ; 
  res = regmatch (rw , p -> ku . k . i1 ) ; 
  return (res ? scheme_true : scheme_false ) ; 
}
static int regmatch (Regwork * rw , rxpos prog ) {
  rxpos scan ; 
  rxpos is ; 
  int the_op ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM743_COUNT (1)
# define SETUP_XfOrM743(x) SETUP(XfOrM743_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  {
    unsigned long _stk_pos ; 
#   define XfOrM977_COUNT (0+XfOrM743_COUNT)
#   define SETUP_XfOrM977(x) SETUP_XfOrM743(x)
    _stk_pos = (unsigned long ) & _stk_pos ; 
    if (((_stk_pos ) < (scheme_stack_boundary ) ) ) {
      Scheme_Thread * p = scheme_current_thread ; 
      Regwork * rw2 ; 
      Scheme_Object * res ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM977_COUNT), PUSH(res, 1+XfOrM977_COUNT), PUSH(rw2, 2+XfOrM977_COUNT)));
#     define XfOrM978_COUNT (3+XfOrM977_COUNT)
#     define SETUP_XfOrM978(x) SETUP(XfOrM978_COUNT)
      rw2 = NULLED_OUT ; 
      res = NULLED_OUT ; 
      rw2 = ((Regwork * ) FUNCCALL(SETUP_XfOrM978(_), GC_malloc_one_small_tagged ((((sizeof (Regwork ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      (memcpy (rw2 , rw , sizeof (Regwork ) ) ) ; 
      rw2 -> type = scheme_rt_regwork ; 
      rw2 -> str = regstr ; 
      p -> ku . k . p1 = rw2 ; 
      p -> ku . k . i1 = prog ; 
      res = FUNCCALL(SETUP_XfOrM978(_), scheme_handle_stack_overflow (regmatch_k ) ); 
      (memcpy (rw , rw2 , sizeof (Regwork ) ) ) ; 
      RET_VALUE_START ((! (((res ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
    }
  }
  if ((scheme_fuel_counter ) <= 0 ) {
    char * rs ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM743_COUNT)));
#   define XfOrM976_COUNT (1+XfOrM743_COUNT)
#   define SETUP_XfOrM976(x) SETUP(XfOrM976_COUNT)
    rs = NULLED_OUT ; 
    rs = regstr ; 
    FUNCCALL(SETUP_XfOrM976(_), scheme_out_of_fuel () ); 
    regstr = rs ; 
  }
  is = rw -> input ; 
  scan = prog ; 
  while (scan != 0 ) {
#   define XfOrM860_COUNT (0+XfOrM743_COUNT)
#   define SETUP_XfOrM860(x) SETUP_XfOrM743(x)
    the_op = (regstr [scan ] ) ; 
    switch (the_op ) {
#     define XfOrM861_COUNT (0+XfOrM860_COUNT)
#     define SETUP_XfOrM861(x) SETUP_XfOrM860(x)
      case 1 : if (is != rw -> boi )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 2 : if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM861(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
      if (is != rw -> input_end )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 39 : if ((is != rw -> bol ) && ((is <= rw -> input_start ) || (rw -> instr [is - 1 ] != '\n' ) ) )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 40 : if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM861(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
      if (is != rw -> input_end ) {
        if (rw -> instr [is ] != '\n' )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      }
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 3 : if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM861(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
      if (is == rw -> input_end )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 4 : if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM861(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
      if (is == rw -> input_end )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      if (rw -> instr [is ] == '\n' )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 11 : {
        int len , i ; 
        rxpos opnd ; 
#       define XfOrM968_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM968(x) SETUP_XfOrM861(x)
        opnd = (((scan ) + 3 ) + 2 ) ; 
        len = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> port ) {
#         define XfOrM972_COUNT (0+XfOrM968_COUNT)
#         define SETUP_XfOrM972(x) SETUP_XfOrM968(x)
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM974_COUNT (0+XfOrM972_COUNT)
#           define SETUP_XfOrM974(x) SETUP_XfOrM972(x)
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM974(_), read_more_from_regport (rw , (is + i ) + (1 ) ) ); 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            if (regstr [opnd + i ] != rw -> instr [is + i ] )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        else {
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          for (i = 0 ; i < len ; i ++ ) {
            if (regstr [opnd + i ] != rw -> instr [is + i ] )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
      }
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 12 : {
        int len , i ; 
        char c ; 
        rxpos opnd ; 
#       define XfOrM961_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM961(x) SETUP_XfOrM861(x)
        opnd = (((scan ) + 3 ) + 2 ) ; 
        len = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> port ) {
#         define XfOrM965_COUNT (0+XfOrM961_COUNT)
#         define SETUP_XfOrM965(x) SETUP_XfOrM961(x)
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM967_COUNT (0+XfOrM965_COUNT)
#           define SETUP_XfOrM967(x) SETUP_XfOrM965(x)
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM967(_), read_more_from_regport (rw , (is + i ) + (1 ) ) ); 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            c = rw -> instr [is + i ] ; 
            c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
            if (regstr [opnd + i ] != c )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        else {
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          for (i = 0 ; i < len ; i ++ ) {
            c = rw -> instr [is + i ] ; 
            c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
            if (regstr [opnd + i ] != c )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
      }
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 5 : {
        int c ; 
#       define XfOrM960_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM960(x) SETUP_XfOrM861(x)
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM960(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
        if (is == rw -> input_end )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        c = ((unsigned char ) (rw -> instr [is ] ) ) ; 
        if (! (regstr [((scan ) + 3 ) + (c >> 3 ) ] & (1 << (c & 0x7 ) ) ) )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
        is ++ ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 6 : if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM861(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
      if (is == rw -> input_end )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      if (rw -> instr [is ] != regstr [((scan ) + 3 ) ] )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 43 : if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM861(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
      if (is == rw -> input_end )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      if (rw -> instr [is ] != regstr [((scan ) + 3 ) ] )
        if (rw -> instr [is ] != regstr [((scan ) + 3 ) + 1 ] )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 7 : {
        int c ; 
#       define XfOrM959_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM959(x) SETUP_XfOrM861(x)
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM959(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
        if (is == rw -> input_end )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        c = ((unsigned char ) (rw -> instr [is ] ) ) ; 
        if ((c < ((unsigned char ) (regstr [((scan ) + 3 ) ] ) ) ) || (c > ((unsigned char ) (regstr [((scan ) + 3 ) + 1 ] ) ) ) )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
        is ++ ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 8 : {
        int c ; 
#       define XfOrM958_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM958(x) SETUP_XfOrM861(x)
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM958(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
        if (is == rw -> input_end )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        c = ((unsigned char ) (rw -> instr [is ] ) ) ; 
        if ((c >= ((unsigned char ) (regstr [((scan ) + 3 ) ] ) ) ) && (c <= ((unsigned char ) (regstr [((scan ) + 3 ) + 1 ] ) ) ) )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
        is ++ ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 13 : scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 10 : scan = scan - (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ; 
      break ; 
      case 9 : {
        rxpos delta ; 
        rxpos next ; 
#       define XfOrM954_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM954(x) SETUP_XfOrM861(x)
        next = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        if ((regstr [next ] ) != 9 )
          scan = ((scan ) + 3 ) ; 
        else {
#         define XfOrM955_COUNT (0+XfOrM954_COUNT)
#         define SETUP_XfOrM955(x) SETUP_XfOrM954(x)
          do {
#           define XfOrM957_COUNT (0+XfOrM955_COUNT)
#           define SETUP_XfOrM957(x) SETUP_XfOrM955(x)
            rw -> input = is ; 
            if (FUNCCALL(SETUP_XfOrM957(_), regmatch (rw , ((scan ) + 3 ) ) ))
              RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
            scan = next ; 
            delta = (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ; 
            if (! delta )
              break ; 
            next = scan + delta ; 
          }
          while ((regstr [next ] ) == 9 ) ; 
          scan = ((scan ) + 3 ) ; 
        }
      }
      break ; 
      case 14 : case 15 : case 16 : case 17 : case 18 : case 19 : {
        char nextch ; 
        int no ; 
        rxpos save , body ; 
        int min , maxc ; 
        int nongreedy = (the_op == 16 || the_op == 17 || the_op == 19 ) ; 
        rxpos next ; 
#       define XfOrM934_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM934(x) SETUP_XfOrM861(x)
        nextch = '\0' ; 
        next = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        if ((regstr [next ] ) == 11 )
          nextch = regstr [(((next ) + 3 ) + 2 ) ] ; 
        if ((the_op == 18 ) || (the_op == 19 ) ) {
          min = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
          maxc = ((int ) (((unsigned char * ) regstr ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 5 ) + 1 ] ) ) ; 
          body = ((scan ) + 7 ) ; 
        }
        else {
          body = ((scan ) + 3 ) ; 
          min = ((the_op == 14 ) || (the_op == 16 ) ) ? 0 : 1 ; 
          maxc = 0 ; 
        }
        save = is ; 
        rw -> input = is ; 
        if (nongreedy && rw -> port ) {
          Scheme_Object * saveport ; 
          BLOCK_SETUP((PUSH(saveport, 0+XfOrM934_COUNT)));
#         define XfOrM951_COUNT (1+XfOrM934_COUNT)
#         define SETUP_XfOrM951(x) SETUP(XfOrM951_COUNT)
          saveport = NULLED_OUT ; 
          if (rw -> port && (((save ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM951(_), read_more_from_regport (rw , (save ) + (1 ) ) ); 
          saveport = rw -> port ; 
          rw -> port = ((void * ) 0 ) ; 
          no = FUNCCALL(SETUP_XfOrM951(_), regrepeat (rw , body , maxc ) ); 
          rw -> port = saveport ; 
          nongreedy = 2 ; 
        }
        else no = FUNCCALL(SETUP_XfOrM934(_), regrepeat (rw , body , maxc ) ); 
        if (! nongreedy ) {
#         define XfOrM946_COUNT (0+XfOrM934_COUNT)
#         define SETUP_XfOrM946(x) SETUP_XfOrM934(x)
          if (nextch )
            if (rw -> port && (((save + no ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM946(_), read_more_from_regport (rw , (save + no ) + (1 ) ) ); 
          while (no >= min ) {
#           define XfOrM949_COUNT (0+XfOrM946_COUNT)
#           define SETUP_XfOrM949(x) SETUP_XfOrM946(x)
            if (nextch == '\0' || ((save + no < rw -> input_end ) && (rw -> instr [save + no ] == nextch ) ) ) {
#             define XfOrM950_COUNT (0+XfOrM949_COUNT)
#             define SETUP_XfOrM950(x) SETUP_XfOrM949(x)
              rw -> input = is + no ; 
              if (FUNCCALL(SETUP_XfOrM950(_), regmatch (rw , next ) ))
                RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
            }
            no -- ; 
          }
        }
        else {
          int i ; 
#         define XfOrM935_COUNT (0+XfOrM934_COUNT)
#         define SETUP_XfOrM935(x) SETUP_XfOrM934(x)
          for (i = min ; i <= no ; i ++ ) {
#           define XfOrM941_COUNT (0+XfOrM935_COUNT)
#           define SETUP_XfOrM941(x) SETUP_XfOrM935(x)
            if (nextch )
              if (rw -> port && (((save + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM941(_), read_more_from_regport (rw , (save + i ) + (1 ) ) ); 
            if (nextch == '\0' || ((save + i < rw -> input_end ) && (rw -> instr [save + i ] == nextch ) ) ) {
#             define XfOrM944_COUNT (0+XfOrM941_COUNT)
#             define SETUP_XfOrM944(x) SETUP_XfOrM941(x)
              rw -> input = save + i ; 
              if (FUNCCALL(SETUP_XfOrM944(_), regmatch (rw , next ) )) {
                RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
              }
            }
            if ((i == no ) && (nongreedy == 2 ) ) {
#             define XfOrM942_COUNT (0+XfOrM941_COUNT)
#             define SETUP_XfOrM942(x) SETUP_XfOrM941(x)
              if ((rw -> input_end - save ) > no ) {
                int moreno ; 
                Scheme_Object * saveport ; 
                BLOCK_SETUP((PUSH(saveport, 0+XfOrM942_COUNT)));
#               define XfOrM943_COUNT (1+XfOrM942_COUNT)
#               define SETUP_XfOrM943(x) SETUP(XfOrM943_COUNT)
                saveport = NULLED_OUT ; 
                saveport = rw -> port ; 
                rw -> port = ((void * ) 0 ) ; 
                is = save + no ; 
                rw -> input = is ; 
                moreno = FUNCCALL(SETUP_XfOrM943(_), regrepeat (rw , body , maxc ? maxc - no : 0 ) ); 
                rw -> port = saveport ; 
                if (! moreno )
                  nongreedy = 1 ; 
                else no += moreno ; 
              }
            }
          }
        }
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      }
      break ; 
      case 0 : case 27 : rw -> input = is ; 
      RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
      break ; 
      case 28 : {
        int no , len , start , i ; 
#       define XfOrM927_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM927(x) SETUP_XfOrM861(x)
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> endp [no ] == - 1 )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        start = rw -> startp [no ] ; 
        len = rw -> endp [no ] - start ; 
        if (rw -> port ) {
#         define XfOrM931_COUNT (0+XfOrM927_COUNT)
#         define SETUP_XfOrM931(x) SETUP_XfOrM927(x)
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM933_COUNT (0+XfOrM931_COUNT)
#           define SETUP_XfOrM933(x) SETUP_XfOrM931(x)
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM933(_), read_more_from_regport (rw , (is + i ) + (1 ) ) ); 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            if (rw -> instr [start + i ] != rw -> instr [is + i ] )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        else {
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          for (i = 0 ; i < len ; i ++ ) {
            if (rw -> instr [start + i ] != rw -> instr [is + i ] )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        break ; 
      }
      case 29 : {
        int no , len , start , i , c1 , c2 ; 
#       define XfOrM920_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM920(x) SETUP_XfOrM861(x)
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> endp [no ] == - 1 )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        start = rw -> startp [no ] ; 
        len = rw -> endp [no ] - start ; 
        if (rw -> port ) {
#         define XfOrM924_COUNT (0+XfOrM920_COUNT)
#         define SETUP_XfOrM924(x) SETUP_XfOrM920(x)
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM926_COUNT (0+XfOrM924_COUNT)
#           define SETUP_XfOrM926(x) SETUP_XfOrM924(x)
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM926(_), read_more_from_regport (rw , (is + i ) + (1 ) ) ); 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            c1 = rw -> instr [start + i ] ; 
            c1 = (((c1 >= 'A' ) && (c1 <= 'Z' ) ) ? (c1 + ('a' - 'A' ) ) : c1 ) ; 
            c2 = rw -> instr [is + i ] ; 
            c2 = (((c2 >= 'A' ) && (c2 <= 'Z' ) ) ? (c2 + ('a' - 'A' ) ) : c2 ) ; 
            if (c1 != c2 )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        else {
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          for (i = 0 ; i < len ; i ++ ) {
            c1 = rw -> instr [start + i ] ; 
            c1 = (((c1 >= 'A' ) && (c1 <= 'Z' ) ) ? (c1 + ('a' - 'A' ) ) : c1 ) ; 
            c2 = rw -> instr [is + i ] ; 
            c2 = (((c2 >= 'A' ) && (c2 <= 'Z' ) ) ? (c2 + ('a' - 'A' ) ) : c2 ) ; 
            if (c1 != c2 )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        break ; 
      }
      case 22 : case 23 : case 24 : case 25 : case 26 : {
        int t , no , no_start , no_end ; 
        rxpos save , next ; 
#       define XfOrM903_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM903(x) SETUP_XfOrM861(x)
        next = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        t = ((the_op != 23 ) && (the_op != 26 ) ) ; 
        if ((the_op == 25 ) || (the_op == 26 ) ) {
          no_start = ((int ) (((unsigned char * ) regstr ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 5 ) + 1 ] ) ) ; 
          no_end = ((int ) (((unsigned char * ) regstr ) [((scan ) + 7 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 7 ) + 1 ] ) ) ; 
        }
        else no_start = no_end = 0 ; 
        save = is ; 
        if (no_end ) {
#         define XfOrM907_COUNT (0+XfOrM903_COUNT)
#         define SETUP_XfOrM907(x) SETUP_XfOrM903(x)
          for (no = no_start ; no <= no_end ; no ++ ) {
#           define XfOrM914_COUNT (0+XfOrM907_COUNT)
#           define SETUP_XfOrM914(x) SETUP_XfOrM907(x)
            if (is - rw -> input_start >= no ) {
#             define XfOrM916_COUNT (0+XfOrM914_COUNT)
#             define SETUP_XfOrM916(x) SETUP_XfOrM914(x)
              rw -> input = save - no ; 
              if (FUNCCALL(SETUP_XfOrM916(_), regmatch (rw , next ) )) {
                if (is == save ) {
                  if (! t )
                    RET_VALUE_START (0 ) RET_VALUE_END ; 
                  break ; 
                }
              }
            }
            else {
              no = no_end + 1 ; 
              break ; 
            }
          }
          if (no > no_end ) {
            if (t )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        else {
#         define XfOrM904_COUNT (0+XfOrM903_COUNT)
#         define SETUP_XfOrM904(x) SETUP_XfOrM903(x)
          rw -> input = is ; 
          if (FUNCCALL(SETUP_XfOrM904(_), regmatch (rw , next ) )) {
            if (! t )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          else {
            if (t )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          if (the_op == 24 )
            is = rw -> input ; 
        }
        scan = scan + ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 30 : {
        int no ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> counters [no ] = 0 ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 33 : {
        int no ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> counters [no ] -= 1 ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 34 : {
        int no ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> counters [no ] -= 1 ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      break ; 
      case 32 : {
        int no , maxreps ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        maxreps = ((int ) (((unsigned char * ) regstr ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 5 ) + 1 ] ) ) ; 
        rw -> counters [no ] ++ ; 
        if (maxreps && (rw -> counters [no ] > maxreps ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 31 : {
        int no , minreps ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        minreps = ((int ) (((unsigned char * ) regstr ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 5 ) + 1 ] ) ) ; 
        if (rw -> counters [no ] < minreps )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 35 : {
        int no , len ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        len = ((int ) (((unsigned char * ) regstr ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 5 ) + 1 ] ) ) ; 
        if (! len || (is > rw -> maybep [no ] ) ) {
          rw -> startp [no ] = is - len ; 
          rw -> endp [no ] = is ; 
        }
        else {
          rw -> startp [no ] = - 1 ; 
          rw -> endp [no ] = - 1 ; 
        }
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 36 : {
        int no ; 
        no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> maybep [no ] = is ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 37 : {
        int c , w1 , w2 ; 
#       define XfOrM891_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM891(x) SETUP_XfOrM861(x)
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
        if (is > rw -> input_start ) {
          c = rw -> instr [is - 1 ] ; 
          w1 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }
        else w1 = 0 ; 
        if (is < rw -> input_end ) {
          c = rw -> instr [is ] ; 
          w2 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }
        else w2 = 0 ; 
        if (w1 == w2 )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 38 : {
        int c , w1 , w2 ; 
#       define XfOrM888_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM888(x) SETUP_XfOrM861(x)
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM888(_), read_more_from_regport (rw , (is ) + (1 ) ) ); 
        if (is > rw -> input_start ) {
          c = rw -> instr [is - 1 ] ; 
          w1 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }
        else w1 = 0 ; 
        if (is < rw -> input_end ) {
          c = rw -> instr [is ] ; 
          w2 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }
        else w2 = 0 ; 
        if (w1 != w2 )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 41 : {
        unsigned char buf [6 ] ; 
        mzchar us [1 ] ; 
        int c , data ; 
        int v , pos ; 
        int negate , bottom , top ; 
#       define XfOrM876_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM876(x) SETUP_XfOrM861(x)
        data = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        negate = data >> 13 ; 
        bottom = (data >> 6 ) & 0x3F ; 
        top = data & 0x3F ; 
        if (rw -> port && (((rw -> input ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM876(_), read_more_from_regport (rw , (rw -> input ) + (1 ) ) ); 
        if (rw -> input < rw -> input_end ) {
#         define XfOrM879_COUNT (0+XfOrM876_COUNT)
#         define SETUP_XfOrM879(x) SETUP_XfOrM876(x)
          c = ((unsigned char ) (rw -> instr [rw -> input ] ) ) ; 
          if (c < 128 ) {
            v = c ; 
            pos = 1 ; 
          }
          else {
#           define XfOrM880_COUNT (0+XfOrM879_COUNT)
#           define SETUP_XfOrM880(x) SETUP_XfOrM879(x)
            pos = 1 ; 
            buf [0 ] = c ; 
            while (1 ) {
#             define XfOrM884_COUNT (0+XfOrM880_COUNT)
#             define SETUP_XfOrM884(x) SETUP_XfOrM880(x)
              v = FUNCCALL(SETUP_XfOrM884(_), scheme_utf8_decode_prefix (buf , pos , us , 0 ) ); 
              if (v == 1 ) {
                v = us [0 ] ; 
                break ; 
              }
              else if (v < - 1 )
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              if (rw -> port && (((rw -> input ) + (pos + 1 ) ) > rw -> input_end ) )
                FUNCCALL(SETUP_XfOrM884(_), read_more_from_regport (rw , (rw -> input ) + (pos + 1 ) ) ); 
              if (rw -> input + pos < rw -> input_end ) {
                buf [pos ] = rw -> instr [rw -> input + pos ] ; 
                pos ++ ; 
              }
              else RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
          }
        }
        else RET_VALUE_START (0 ) RET_VALUE_END ; 
        is += pos ; 
        v = (((scheme_uchar_cats_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1F ) ; 
        if (negate ) {
          if ((v >= bottom ) && (v <= top ) )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        else {
          if ((v < bottom ) || (v > top ) )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 42 : {
        rxpos test = ((scan ) + 7 ) ; 
        int t ; 
#       define XfOrM873_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM873(x) SETUP_XfOrM861(x)
        if ((regstr [test ] ) == 28 ) {
          int no ; 
          no = ((int ) (((unsigned char * ) regstr ) [((test ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((test ) + 3 ) + 1 ] ) ) ; 
          t = (rw -> endp [no ] > - 1 ) ; 
        }
        else {
#         define XfOrM874_COUNT (0+XfOrM873_COUNT)
#         define SETUP_XfOrM874(x) SETUP_XfOrM873(x)
          rw -> input = is ; 
          t = FUNCCALL(SETUP_XfOrM874(_), regmatch (rw , test ) ); 
        }
        if (t )
          scan = scan + ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
        else scan = scan + ((int ) (((unsigned char * ) regstr ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 5 ) + 1 ] ) ) ; 
      }
      break ; 
      default : {
        int isopen ; 
        int no ; 
#       define XfOrM862_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM862(x) SETUP_XfOrM861(x)
        switch (the_op ) {
          case 20 : isopen = 1 ; 
          no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
          if (! no )
            no = - 1 ; 
          break ; 
          case 21 : isopen = 0 ; 
          no = ((int ) (((unsigned char * ) regstr ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) regstr ) [((scan ) + 3 ) + 1 ] ) ) ; 
          if (! no )
            no = - 1 ; 
          break ; 
          default : if (the_op < 78 ) {
            isopen = 1 ; 
            no = the_op - 44 ; 
          }
          else {
            isopen = 0 ; 
            no = the_op - 78 ; 
          }
        }
        if (no < 0 ) {
          scan = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
        }
        else {
          rxpos next ; 
#         define XfOrM863_COUNT (0+XfOrM862_COUNT)
#         define SETUP_XfOrM863(x) SETUP_XfOrM862(x)
          next = (scan + (((((unsigned char * ) regstr ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(scan ) + 2 ] & 255 ) ) ) ; 
          rw -> input = is ; 
          if (isopen ) {
            int oldmaybe ; 
#           define XfOrM867_COUNT (0+XfOrM863_COUNT)
#           define SETUP_XfOrM867(x) SETUP_XfOrM863(x)
            oldmaybe = rw -> maybep [no ] ; 
            rw -> maybep [no ] = is ; 
            if (FUNCCALL(SETUP_XfOrM867(_), regmatch (rw , next ) ))
              RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
            else {
              rw -> maybep [no ] = oldmaybe ; 
              RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
            }
          }
          else {
            int oldstart , oldend ; 
#           define XfOrM864_COUNT (0+XfOrM863_COUNT)
#           define SETUP_XfOrM864(x) SETUP_XfOrM863(x)
            oldstart = rw -> startp [no ] ; 
            oldend = rw -> endp [no ] ; 
            rw -> startp [no ] = rw -> maybep [no ] ; 
            rw -> endp [no ] = is ; 
            if (FUNCCALL(SETUP_XfOrM864(_), regmatch (rw , next ) )) {
              RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
            }
            else {
              rw -> startp [no ] = oldstart ; 
              rw -> endp [no ] = oldend ; 
              RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
            }
          }
        }
      }
      break ; 
    }
  }
  FUNCCALL_EMPTY(regerror ("corrupted pointers" ) ); 
  RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int regrepeat (Regwork * rw , rxpos p , int maxc ) {
  int count = 0 ; 
  rxpos scan ; 
  rxpos opnd ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM979_COUNT (1)
# define SETUP_XfOrM979(x) SETUP(XfOrM979_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  scan = rw -> input ; 
  opnd = ((p ) + 3 ) ; 
  switch ((regstr [p ] ) ) {
#   define XfOrM980_COUNT (0+XfOrM979_COUNT)
#   define SETUP_XfOrM980(x) SETUP_XfOrM979(x)
    case 3 : if (rw -> port ) {
#     define XfOrM1041_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM1041(x) SETUP_XfOrM980(x)
      if (maxc ) {
#       define XfOrM1045_COUNT (0+XfOrM1041_COUNT)
#       define SETUP_XfOrM1045(x) SETUP_XfOrM1041(x)
        while (rw -> port && (rw -> input_end < scan + maxc ) ) {
#         define XfOrM1047_COUNT (0+XfOrM1045_COUNT)
#         define SETUP_XfOrM1047(x) SETUP_XfOrM1045(x)
          FUNCCALL(SETUP_XfOrM1047(_), read_more_from_regport (rw , scan + maxc ) ); 
        }
      }
      else {
#       define XfOrM1042_COUNT (0+XfOrM1041_COUNT)
#       define SETUP_XfOrM1042(x) SETUP_XfOrM1041(x)
        while (rw -> port ) {
#         define XfOrM1044_COUNT (0+XfOrM1042_COUNT)
#         define SETUP_XfOrM1044(x) SETUP_XfOrM1042(x)
          FUNCCALL(SETUP_XfOrM1044(_), read_more_from_regport (rw , rw -> input_end + 4096 ) ); 
        }
      }
    }
    count = rw -> input_end - scan ; 
    if (maxc && (count > maxc ) )
      count = maxc ; 
    scan += count ; 
    break ; 
    case 4 : {
#     define XfOrM1036_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM1036(x) SETUP_XfOrM980(x)
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1036(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      while (scan != rw -> input_end && (rw -> instr [scan ] != '\n' ) ) {
        count ++ ; 
        scan ++ ; 
#       define XfOrM1039_COUNT (0+XfOrM1036_COUNT)
#       define SETUP_XfOrM1039(x) SETUP_XfOrM1036(x)
        if (maxc ) {
          maxc -- ; 
          if (! maxc )
            break ; 
        }
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1039(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      }
    }
    break ; 
    case 11 : {
      rxpos opnd2 = (opnd + 2 ) ; 
#     define XfOrM1031_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM1031(x) SETUP_XfOrM980(x)
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1031(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      while (scan != rw -> input_end && (regstr [opnd2 ] == rw -> instr [scan ] ) ) {
        count ++ ; 
        scan ++ ; 
#       define XfOrM1034_COUNT (0+XfOrM1031_COUNT)
#       define SETUP_XfOrM1034(x) SETUP_XfOrM1031(x)
        if (maxc ) {
          maxc -- ; 
          if (! maxc )
            break ; 
        }
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1034(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      }
    }
    break ; 
    case 12 : {
      char c ; 
      rxpos opnd2 = (opnd + 2 ) ; 
#     define XfOrM1026_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM1026(x) SETUP_XfOrM980(x)
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1026(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      while (scan != rw -> input_end ) {
#       define XfOrM1029_COUNT (0+XfOrM1026_COUNT)
#       define SETUP_XfOrM1029(x) SETUP_XfOrM1026(x)
        c = rw -> instr [scan ] ; 
        c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
        if (regstr [opnd2 ] != c )
          break ; 
        count ++ ; 
        scan ++ ; 
        if (maxc ) {
          maxc -- ; 
          if (! maxc )
            break ; 
        }
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1029(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      }
    }
    break ; 
    case 5 : {
      int c ; 
      rxpos init = scan ; 
#     define XfOrM1017_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM1017(x) SETUP_XfOrM980(x)
      if (rw -> port || maxc ) {
#       define XfOrM1021_COUNT (0+XfOrM1017_COUNT)
#       define SETUP_XfOrM1021(x) SETUP_XfOrM1017(x)
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1021(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        while (scan != rw -> input_end ) {
#         define XfOrM1024_COUNT (0+XfOrM1021_COUNT)
#         define SETUP_XfOrM1024(x) SETUP_XfOrM1021(x)
          c = ((unsigned char ) (rw -> instr [scan ] ) ) ; 
          if (! (regstr [opnd + (c >> 3 ) ] & (1 << (c & 0x7 ) ) ) )
            break ; 
          scan ++ ; 
          if (maxc ) {
            maxc -- ; 
            if (! maxc )
              break ; 
          }
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1024(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        }
      }
      else {
        int e = rw -> input_end ; 
        while (scan != e ) {
          c = ((unsigned char ) (rw -> instr [scan ] ) ) ; 
          if (! (regstr [opnd + (c >> 3 ) ] & (1 << (c & 0x7 ) ) ) )
            break ; 
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 6 : {
      rxpos init = scan ; 
      char c ; 
#     define XfOrM1008_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM1008(x) SETUP_XfOrM980(x)
      c = regstr [opnd ] ; 
      if (rw -> port || maxc ) {
#       define XfOrM1012_COUNT (0+XfOrM1008_COUNT)
#       define SETUP_XfOrM1012(x) SETUP_XfOrM1008(x)
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1012(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        while ((scan != rw -> input_end ) && (rw -> instr [scan ] == c ) ) {
          scan ++ ; 
#         define XfOrM1015_COUNT (0+XfOrM1012_COUNT)
#         define SETUP_XfOrM1015(x) SETUP_XfOrM1012(x)
          if (maxc ) {
            maxc -- ; 
            if (! maxc )
              break ; 
          }
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1015(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        }
      }
      else {
        int e = rw -> input_end ; 
        while ((scan != e ) && (rw -> instr [scan ] == c ) ) {
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 43 : {
      rxpos init = scan ; 
      char c1 , c2 ; 
#     define XfOrM999_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM999(x) SETUP_XfOrM980(x)
      c1 = regstr [opnd ] ; 
      c2 = regstr [opnd + 1 ] ; 
      if (rw -> port || maxc ) {
#       define XfOrM1003_COUNT (0+XfOrM999_COUNT)
#       define SETUP_XfOrM1003(x) SETUP_XfOrM999(x)
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1003(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        while ((scan != rw -> input_end ) && ((rw -> instr [scan ] == c1 ) || (rw -> instr [scan ] == c2 ) ) ) {
          scan ++ ; 
#         define XfOrM1006_COUNT (0+XfOrM1003_COUNT)
#         define SETUP_XfOrM1006(x) SETUP_XfOrM1003(x)
          if (maxc ) {
            maxc -- ; 
            if (! maxc )
              break ; 
          }
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1006(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        }
      }
      else {
        int e = rw -> input_end ; 
        while ((scan != e ) && ((rw -> instr [scan ] == c1 ) || (rw -> instr [scan ] == c2 ) ) ) {
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 7 : {
      rxpos init = scan ; 
      int c , sr , er ; 
#     define XfOrM990_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM990(x) SETUP_XfOrM980(x)
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM990(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      sr = ((unsigned char ) (regstr [opnd ] ) ) ; 
      er = ((unsigned char ) (regstr [opnd + 1 ] ) ) ; 
      if (rw -> port || maxc ) {
#       define XfOrM994_COUNT (0+XfOrM990_COUNT)
#       define SETUP_XfOrM994(x) SETUP_XfOrM990(x)
        while (scan != rw -> input_end ) {
#         define XfOrM997_COUNT (0+XfOrM994_COUNT)
#         define SETUP_XfOrM997(x) SETUP_XfOrM994(x)
          c = ((unsigned char ) (rw -> instr [scan ] ) ) ; 
          if ((c < sr ) || (c > er ) )
            break ; 
          scan ++ ; 
          if (maxc ) {
            maxc -- ; 
            if (! maxc )
              break ; 
          }
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM997(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        }
      }
      else {
        int e = rw -> input_end ; 
        while (scan != e ) {
          c = ((unsigned char ) (rw -> instr [scan ] ) ) ; 
          if ((c < sr ) || (c > er ) )
            break ; 
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 8 : {
      rxpos init = scan ; 
      int c , sr , er ; 
#     define XfOrM981_COUNT (0+XfOrM980_COUNT)
#     define SETUP_XfOrM981(x) SETUP_XfOrM980(x)
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM981(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
      sr = ((unsigned char ) (regstr [opnd ] ) ) ; 
      er = ((unsigned char ) (regstr [opnd + 1 ] ) ) ; 
      if (rw -> port || maxc ) {
#       define XfOrM985_COUNT (0+XfOrM981_COUNT)
#       define SETUP_XfOrM985(x) SETUP_XfOrM981(x)
        while (scan != rw -> input_end ) {
#         define XfOrM988_COUNT (0+XfOrM985_COUNT)
#         define SETUP_XfOrM988(x) SETUP_XfOrM985(x)
          c = ((unsigned char ) (rw -> instr [scan ] ) ) ; 
          if ((c >= sr ) && (c <= er ) )
            break ; 
          scan ++ ; 
          if (maxc ) {
            maxc -- ; 
            if (! maxc )
              break ; 
          }
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM988(_), read_more_from_regport (rw , (scan ) + (1 ) ) ); 
        }
      }
      else {
        int e = rw -> input_end ; 
        while (scan != e ) {
          c = ((unsigned char ) (rw -> instr [scan ] ) ) ; 
          if ((c >= sr ) && (c <= er ) )
            break ; 
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    default : FUNCCALL(SETUP_XfOrM980(_), regerror ("internal foulup" ) ); 
    count = 0 ; 
    break ; 
  }
  rw -> input = scan ; 
  RET_VALUE_START ((count ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static rxpos regnext (rxpos p ) {
  /* No conversion */
  int offset ; 
  if (p + 2 >= regcodesize )
    return 0 ; 
  offset = (((((unsigned char * ) regstr ) [(p ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) regstr ) [(p ) + 2 ] & 255 ) ) ; 
  if (offset == 0 )
    return 0 ; 
  if ((regstr [p ] ) == 10 )
    return (p - offset ) ; 
  else return (p + offset ) ; 
}
static int regstrcspn (char * s1 , char * e1 , char * s2 ) {
  /* No conversion */
  char * scan1 ; 
  char * scan2 ; 
  int count ; 
  count = 0 ; 
  for (scan1 = s1 ; scan1 != e1 ; scan1 ++ ) {
    for (scan2 = s2 ; * scan2 != '\0' ; ) {
      if (* scan1 == * scan2 ++ )
        return (count ) ; 
    }
    count ++ ; 
  }
  return (count ) ; 
}
extern char * strncpy () ; 
static char * regsub (regexp * prog , char * src , int sourcelen , long * lenout , char * insrc , rxpos * startp , rxpos * endp ) {
  char * dest ; 
  char c ; 
  long no ; 
  long len ; 
  long destalloc , destlen , srcpos ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(prog, 0), PUSH(insrc, 1), PUSH(endp, 2), PUSH(src, 3), PUSH(dest, 4), PUSH(startp, 5), PUSH(lenout, 6)));
# define XfOrM1056_COUNT (7)
# define SETUP_XfOrM1056(x) SETUP(XfOrM1056_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  dest = NULLED_OUT ; 
  destalloc = 2 * sourcelen ; 
  destlen = 0 ; 
  dest = (char * ) FUNCCALL(SETUP_XfOrM1056(_), GC_malloc_atomic (destalloc + 1 ) ); 
  srcpos = 0 ; 
  while (srcpos < sourcelen ) {
#   define XfOrM1068_COUNT (0+XfOrM1056_COUNT)
#   define SETUP_XfOrM1068(x) SETUP_XfOrM1056(x)
    c = src [srcpos ++ ] ; 
    if (c == '&' )
      no = 0 ; 
    else if (c == '\\' ) {
      if (src [srcpos ] == '\\' || src [srcpos ] == '&' )
        no = - 1 ; 
      else if (src [srcpos ] == '$' ) {
        no = prog -> nsubexp + 1 ; 
        srcpos ++ ; 
      }
      else {
        no = 0 ; 
        while ('0' <= src [srcpos ] && src [srcpos ] <= '9' ) {
          no = (no * 10 ) + (src [srcpos ++ ] - '0' ) ; 
        }
      }
    }
    else no = - 1 ; 
    if (no < 0 ) {
#     define XfOrM1072_COUNT (0+XfOrM1068_COUNT)
#     define SETUP_XfOrM1072(x) SETUP_XfOrM1068(x)
      if (c == '\\' && (src [srcpos ] == '\\' || src [srcpos ] == '&' ) )
        c = src [srcpos ++ ] ; 
      if (destlen + 1 >= destalloc ) {
        char * old = dest ; 
        destalloc *= 2 ; 
        BLOCK_SETUP((PUSH(old, 0+XfOrM1072_COUNT)));
#       define XfOrM1073_COUNT (1+XfOrM1072_COUNT)
#       define SETUP_XfOrM1073(x) SETUP(XfOrM1073_COUNT)
        dest = (char * ) FUNCCALL(SETUP_XfOrM1073(_), GC_malloc_atomic (destalloc + 1 ) ); 
        (memcpy (dest , old , destlen ) ) ; 
      }
      dest [destlen ++ ] = c ; 
    }
    else if (no >= prog -> nsubexp ) {
    }
    else if (startp [no ] != - 1 && endp [no ] != - 1 ) {
#     define XfOrM1069_COUNT (0+XfOrM1068_COUNT)
#     define SETUP_XfOrM1069(x) SETUP_XfOrM1068(x)
      len = endp [no ] - startp [no ] ; 
      if (len + destlen >= destalloc ) {
        char * old = dest ; 
        BLOCK_SETUP((PUSH(old, 0+XfOrM1069_COUNT)));
#       define XfOrM1070_COUNT (1+XfOrM1069_COUNT)
#       define SETUP_XfOrM1070(x) SETUP(XfOrM1070_COUNT)
        destalloc = 2 * destalloc + len + destlen ; 
        dest = (char * ) FUNCCALL(SETUP_XfOrM1070(_), GC_malloc_atomic (destalloc + 1 ) ); 
        (memcpy (dest , old , destlen ) ) ; 
      }
      (memcpy (dest + destlen , insrc + startp [no ] , len ) ) ; 
      destlen += len ; 
    }
  }
  dest [destlen ] = '\0' ; 
  if (lenout )
    * lenout = destlen ; 
  RET_VALUE_START (dest ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int compare_ranges (const void * a , const void * b ) {
  /* No conversion */
  unsigned int av , bv ; 
  av = * (unsigned int * ) a ; 
  bv = * (unsigned int * ) b ; 
  if (av == bv )
    return 0 ; 
  else if (av < bv )
    return - 1 ; 
  else return 1 ; 
}
typedef struct {
  int i ; 
  int orig_len ; 
  int size ; 
}
RoomState ; 
static unsigned char * make_room (unsigned char * r , int j , int need_extra , RoomState * rs ) {
  int nrs ; 
  unsigned char * nr ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(nr, 0), PUSH(rs, 1), PUSH(r, 2)));
# define XfOrM1080_COUNT (3)
# define SETUP_XfOrM1080(x) SETUP(XfOrM1080_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  nr = NULLED_OUT ; 
  if ((rs -> size - j - (rs -> orig_len - rs -> i ) ) < need_extra ) {
#   define XfOrM1081_COUNT (0+XfOrM1080_COUNT)
#   define SETUP_XfOrM1081(x) SETUP_XfOrM1080(x)
    nrs = ((rs -> size ) * 2 ) + need_extra ; 
    nr = (unsigned char * ) FUNCCALL(SETUP_XfOrM1081(_), GC_malloc_atomic (nrs + 1 ) ); 
    (memcpy (nr , r , j ) ) ; 
    r = nr ; 
    rs -> size = nrs ; 
  }
  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * add_byte_range (const unsigned char * lo , const unsigned char * hi , int count , unsigned char * r , int * _j , RoomState * rs , int did_alt , int wrap_alts ) {
  int same_chars , j , i ; 
  const unsigned char * lowest = (unsigned char * ) "\200\200\200\200\200" ; 
  const unsigned char * highest = (unsigned char * ) "\277\277\277\277\277" ; 
  unsigned char p , q ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(rs, 0), PUSH(_j, 1), PUSH(hi, 2), PUSH(highest, 3), PUSH(lowest, 4), PUSH(r, 5), PUSH(lo, 6)));
# define XfOrM1082_COUNT (7)
# define SETUP_XfOrM1082(x) SETUP(XfOrM1082_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  for (same_chars = 0 ; same_chars < count ; same_chars ++ ) {
    if (lo [same_chars ] != hi [same_chars ] )
      break ; 
  }
  j = * _j ; 
  if (same_chars ) {
#   define XfOrM1103_COUNT (0+XfOrM1082_COUNT)
#   define SETUP_XfOrM1103(x) SETUP_XfOrM1082(x)
    r = FUNCCALL(SETUP_XfOrM1103(_), make_room (r , j , 4 + same_chars , rs ) ); 
    if (! did_alt ) {
      r [j ++ ] = '|' ; 
      did_alt = 1 ; 
    }
    for (i = 0 ; i < same_chars ; i ++ ) {
      r [j ++ ] = lo [i ] ; 
    }
  }
  if (same_chars < count ) {
    int choices = 0 ; 
#   define XfOrM1083_COUNT (0+XfOrM1082_COUNT)
#   define SETUP_XfOrM1083(x) SETUP_XfOrM1082(x)
    for (i = same_chars + 1 ; i < count ; i ++ ) {
      if (lo [i ] != 128 )
        break ; 
    }
    if (i == count )
      p = lo [same_chars ] ; 
    else {
      p = lo [same_chars ] + 1 ; 
      choices ++ ; 
    }
    for (i = same_chars + 1 ; i < count ; i ++ ) {
      if (hi [i ] != 191 )
        break ; 
    }
    if (i == count )
      q = hi [same_chars ] ; 
    else {
      q = hi [same_chars ] - 1 ; 
      choices ++ ; 
    }
    if (p <= q )
      choices ++ ; 
    if ((wrap_alts || same_chars ) && (choices > 1 ) ) {
#     define XfOrM1095_COUNT (0+XfOrM1083_COUNT)
#     define SETUP_XfOrM1095(x) SETUP_XfOrM1083(x)
      r = FUNCCALL(SETUP_XfOrM1095(_), make_room (r , j , 4 , rs ) ); 
      if (! did_alt ) {
        r [j ++ ] = '|' ; 
        did_alt = 1 ; 
      }
      r [j ++ ] = '(' ; 
      r [j ++ ] = '?' ; 
      r [j ++ ] = ':' ; 
    }
    if (p > lo [same_chars ] ) {
#     define XfOrM1093_COUNT (0+XfOrM1083_COUNT)
#     define SETUP_XfOrM1093(x) SETUP_XfOrM1083(x)
      r = FUNCCALL(SETUP_XfOrM1093(_), make_room (r , j , 2 , rs ) ); 
      if (! did_alt ) {
        r [j ++ ] = '|' ; 
        did_alt = 1 ; 
      }
      r [j ++ ] = lo [same_chars ] ; 
      * _j = j ; 
      r = FUNCCALL(SETUP_XfOrM1093(_), add_byte_range (lo XFORM_OK_PLUS same_chars + 1 , highest , count - same_chars - 1 , r , _j , rs , 1 , 1 ) ); 
      j = * _j ; 
      p = lo [same_chars ] + 1 ; 
      did_alt = 0 ; 
    }
    if (q < hi [same_chars ] ) {
#     define XfOrM1091_COUNT (0+XfOrM1083_COUNT)
#     define SETUP_XfOrM1091(x) SETUP_XfOrM1083(x)
      r = FUNCCALL(SETUP_XfOrM1091(_), make_room (r , j , 2 , rs ) ); 
      if (! did_alt ) {
        r [j ++ ] = '|' ; 
        did_alt = 1 ; 
      }
      r [j ++ ] = hi [same_chars ] ; 
      * _j = j ; 
      r = FUNCCALL(SETUP_XfOrM1091(_), add_byte_range (lowest , hi XFORM_OK_PLUS same_chars + 1 , count - same_chars - 1 , r , _j , rs , 1 , 1 ) ); 
      j = * _j ; 
      did_alt = 0 ; 
      q = hi [same_chars ] - 1 ; 
    }
    if (p <= q ) {
      const char * any_str = "[\200-\277]" ; 
      const int any_len = 5 ; 
      BLOCK_SETUP((PUSH(any_str, 0+XfOrM1083_COUNT)));
#     define XfOrM1085_COUNT (1+XfOrM1083_COUNT)
#     define SETUP_XfOrM1085(x) SETUP(XfOrM1085_COUNT)
      r = FUNCCALL(SETUP_XfOrM1085(_), make_room (r , j , 6 + ((count - same_chars - 1 ) * any_len ) , rs ) ); 
      if (! did_alt ) {
        r [j ++ ] = '|' ; 
        did_alt = 1 ; 
      }
      if (p == q ) {
        r [j ++ ] = p ; 
      }
      else {
        r [j ++ ] = '[' ; 
        r [j ++ ] = p ; 
        r [j ++ ] = '-' ; 
        r [j ++ ] = q ; 
        r [j ++ ] = ']' ; 
      }
      for (i = same_chars + 1 ; i < count ; i ++ ) {
#       define XfOrM1087_COUNT (0+XfOrM1085_COUNT)
#       define SETUP_XfOrM1087(x) SETUP_XfOrM1085(x)
        (memcpy (r + j , any_str , any_len ) ) ; 
        j += any_len ; 
      }
    }
    if ((wrap_alts || same_chars ) && (choices > 1 ) ) {
#     define XfOrM1084_COUNT (0+XfOrM1083_COUNT)
#     define SETUP_XfOrM1084(x) SETUP_XfOrM1083(x)
      r = FUNCCALL(SETUP_XfOrM1084(_), make_room (r , j , 1 , rs ) ); 
      r [j ++ ] = ')' ; 
    }
  }
  * _j = j ; 
  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static unsigned char * add_range (unsigned char * r , int * _j , RoomState * rs , unsigned int start , unsigned int end , int did_alt ) {
  unsigned int top ; 
  int count ; 
  unsigned char lo [6 ] , hi [6 ] ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(_j, 1), PUSH(rs, 2)));
# define XfOrM1109_COUNT (3)
# define SETUP_XfOrM1109(x) SETUP(XfOrM1109_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (start <= 0x7FF ) {
    top = 0x7FF ; 
    count = 2 ; 
  }
  else if (start <= 0xFFFF ) {
    top = 0xFFFF ; 
    count = 3 ; 
  }
  else if (start <= 0x1FFFFF ) {
    top = 0x1FFFFF ; 
    count = 4 ; 
  }
  else if (start <= 0x3FFFFFF ) {
    top = 0x3FFFFFF ; 
    count = 5 ; 
  }
  else {
    top = 0x7FFFFFFF ; 
    count = 6 ; 
  }
  if (end > top ) {
#   define XfOrM1110_COUNT (0+XfOrM1109_COUNT)
#   define SETUP_XfOrM1110(x) SETUP_XfOrM1109(x)
    r = FUNCCALL(SETUP_XfOrM1110(_), add_range (r , _j , rs , top + 1 , end , did_alt ) ); 
    end = top ; 
    did_alt = 0 ; 
  }
  FUNCCALL(SETUP_XfOrM1109(_), scheme_utf8_encode_all (& start , 1 , lo ) ); 
  FUNCCALL(SETUP_XfOrM1109(_), scheme_utf8_encode_all (& end , 1 , hi ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(add_byte_range (lo , hi , count , r , _j , rs , did_alt , 0 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int need_ci_alternates (unsigned char * s , int delta , int len ) {
  /* No conversion */
  mzchar us [1 ] , c ; 
  scheme_utf8_decode (s , delta , len , us , 0 , 1 , ((void * ) 0 ) , 0 , 0 ) ; 
  c = us [0 ] ; 
  return ((c != (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) || (c != (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) || (c != (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) || (c != (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) ) ; 
}
/* this far 4567 */
/* this far 4567 */
/* this far 4327 */
/* this far 4325 */
/* this far 4567 */
/* this far 4567 */
/* this far 4327 */
/* this far 4325 */
static int translate (unsigned char * s , int len , char * * result , int pcre ) {
  int j , parse_flags = 0x1 | 0x4 ; 
  RoomState rs ; 
  unsigned char * r ; 
  Scheme_Object * parse_params = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg119 = NULLED_OUT ; 
  Scheme_Object * __funcarg118 = NULLED_OUT ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(__funcarg115, 0), PUSH(__funcarg118, 1), PUSH(parse_params, 2), PUSH(__funcarg100, 3), PUSH(__funcarg103, 4), PUSH(result, 5), PUSH(s, 6), PUSH(r, 7)));
# define XfOrM1117_COUNT (8)
# define SETUP_XfOrM1117(x) SETUP(XfOrM1117_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 
  rs . orig_len = len ; 
  rs . size = len ; 
  r = (unsigned char * ) FUNCCALL(SETUP_XfOrM1117(_), GC_malloc_atomic (rs . size + 1 ) ); 
  for (rs . i = j = 0 ; rs . i < len ; ) {
#   define XfOrM1348_COUNT (0+XfOrM1117_COUNT)
#   define SETUP_XfOrM1348(x) SETUP_XfOrM1117(x)
    if (s [rs . i ] == '[' ) {
      int k = rs . i + 1 , saw_big = 0 ; 
      int not_mode = 0 ; 
#     define XfOrM1403_COUNT (0+XfOrM1348_COUNT)
#     define SETUP_XfOrM1403(x) SETUP_XfOrM1348(x)
      if ((k < len ) && (s [k ] == '^' ) ) {
        not_mode = 1 ; 
        k ++ ; 
      }
      if ((k < len ) && (s [k ] == ']' ) )
        k ++ ; 
      while ((k < len ) && (s [k ] != ']' ) ) {
#       define XfOrM1573_COUNT (0+XfOrM1403_COUNT)
#       define SETUP_XfOrM1573(x) SETUP_XfOrM1403(x)
        if (s [k ] > 127 )
          saw_big = 1 ; 
        else if (pcre && (s [k ] == '\\' ) && (k + 1 < len ) )
          k ++ ; 
        else if (pcre && (s [k ] == '[' ) && (k + 1 < len ) && (s [k + 1 ] == ':' ) && FUNCCALL(SETUP_XfOrM1573(_), is_posix_char_class ((char * ) s , k + 1 , len , ((void * ) 0 ) ) )) {
          while (s [k ] != ']' ) {
            k ++ ; 
          }
        }
        k ++ ; 
      }
      if ((k >= len ) || (! saw_big && ! not_mode ) ) {
        while (rs . i <= k ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
      }
      else {
        char * simple_on ; 
        Scheme_Object * ranges ; 
        unsigned int * us , * range_array ; 
        int ulen , on_count , range_len , rp , p ; 
        BLOCK_SETUP((PUSH(range_array, 0+XfOrM1403_COUNT), PUSH(simple_on, 1+XfOrM1403_COUNT), PUSH(ranges, 2+XfOrM1403_COUNT), PUSH(us, 3+XfOrM1403_COUNT)));
#       define XfOrM1404_COUNT (4+XfOrM1403_COUNT)
#       define SETUP_XfOrM1404(x) SETUP(XfOrM1404_COUNT)
        simple_on = NULLED_OUT ; 
        ranges = NULLED_OUT ; 
        us = NULLED_OUT ; 
        range_array = NULLED_OUT ; 
        ulen = FUNCCALL(SETUP_XfOrM1404(_), scheme_utf8_decode (s , rs . i + 1 , k , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) ); 
        us = (unsigned int * ) FUNCCALL(SETUP_XfOrM1404(_), GC_malloc_atomic (ulen * sizeof (unsigned int ) ) ); 
        FUNCCALL(SETUP_XfOrM1404(_), scheme_utf8_decode (s , rs . i + 1 , k , us , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) ); 
        simple_on = (char * ) FUNCCALL(SETUP_XfOrM1404(_), GC_malloc_atomic (128 ) ); 
        (memset (simple_on , 0 , 128 ) ) ; 
        ranges = scheme_null ; 
        p = 0 ; 
        if (not_mode )
          p ++ ; 
        if (us [p ] == '-' ) {
          simple_on ['-' ] = 1 ; 
          p ++ ; 
        }
        while (p < ulen ) {
#         define XfOrM1504_COUNT (0+XfOrM1404_COUNT)
#         define SETUP_XfOrM1504(x) SETUP_XfOrM1404(x)
          if (((p + 2 ) < ulen ) && us [p + 1 ] == '-' && (! pcre || ((us [p ] != '\\' ) && (us [p + 2 ] != '\\' ) ) ) ) {
            int beg = us [p ] , end = us [p + 2 ] ; 
#           define XfOrM1525_COUNT (0+XfOrM1504_COUNT)
#           define SETUP_XfOrM1525(x) SETUP_XfOrM1504(x)
            if (end == '-' ) {
#             define XfOrM1563_COUNT (0+XfOrM1525_COUNT)
#             define SETUP_XfOrM1563(x) SETUP_XfOrM1525(x)
              {
#               define XfOrM1564_COUNT (0+XfOrM1563_COUNT)
#               define SETUP_XfOrM1564(x) SETUP_XfOrM1563(x)
                FUNCCALL(SETUP_XfOrM1564(_), regcomperror ("misplaced hypen within square brackets in pattern" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
            if (end < beg ) {
#             define XfOrM1561_COUNT (0+XfOrM1525_COUNT)
#             define SETUP_XfOrM1561(x) SETUP_XfOrM1525(x)
              {
#               define XfOrM1562_COUNT (0+XfOrM1561_COUNT)
#               define SETUP_XfOrM1562(x) SETUP_XfOrM1561(x)
                FUNCCALL(SETUP_XfOrM1562(_), regcomperror ("invalid range within square brackets in pattern" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
            }
            if ((beg > 127 ) || (end > 127 ) ) {
#             define XfOrM1529_COUNT (0+XfOrM1525_COUNT)
#             define SETUP_XfOrM1529(x) SETUP_XfOrM1525(x)
              ranges = (__funcarg117 = (__funcarg118 = FUNCCALL(SETUP_XfOrM1529(_), scheme_make_integer_value_from_unsigned (beg ) ), __funcarg119 = FUNCCALL(SETUP_XfOrM1529(_), scheme_make_integer_value_from_unsigned (end ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg118 , __funcarg119 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg117 , ranges ) )) ; 
              if (! (parse_flags & 0x1 ) ) {
                int c , beg2 , end2 , c2 , mode ; 
#               define XfOrM1530_COUNT (0+XfOrM1529_COUNT)
#               define SETUP_XfOrM1530(x) SETUP_XfOrM1529(x)
                for (mode = 0 ; mode < 4 ; mode ++ ) {
#                 define XfOrM1546_COUNT (0+XfOrM1530_COUNT)
#                 define SETUP_XfOrM1546(x) SETUP_XfOrM1530(x)
                  for (c = beg ; c <= end ; c ++ ) {
#                   define XfOrM1554_COUNT (0+XfOrM1546_COUNT)
#                   define SETUP_XfOrM1554(x) SETUP_XfOrM1546(x)
                    switch (mode ) {
                      case 0 : beg2 = (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                      case 1 : beg2 = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                      case 2 : beg2 = (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                      case 3 : default : beg2 = (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                    }
                    if (c != beg2 ) {
#                     define XfOrM1555_COUNT (0+XfOrM1554_COUNT)
#                     define SETUP_XfOrM1555(x) SETUP_XfOrM1554(x)
                      end2 = beg2 ; 
                      for (; c <= end ; c ++ ) {
                        switch (mode ) {
                          case 0 : c2 = (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                          case 1 : c2 = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                          case 2 : c2 = (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                          case 3 : default : c2 = (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                        }
                        if ((c2 == c ) || (c2 != end2 + 1 ) )
                          break ; 
                      }
                      ranges = (__funcarg114 = (__funcarg115 = FUNCCALL(SETUP_XfOrM1555(_), scheme_make_integer_value_from_unsigned (beg2 ) ), __funcarg116 = FUNCCALL(SETUP_XfOrM1555(_), scheme_make_integer_value_from_unsigned (end2 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg115 , __funcarg116 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg114 , ranges ) )) ; 
                    }
                  }
                }
              }
            }
            else {
              int w ; 
              for (w = beg ; w <= end ; w ++ ) {
                simple_on [w ] = 1 ; 
              }
            }
            p += 3 ; 
          }
          else if (pcre && (us [p ] == '\\' ) ) {
#           define XfOrM1519_COUNT (0+XfOrM1504_COUNT)
#           define SETUP_XfOrM1519(x) SETUP_XfOrM1504(x)
            if ((p + 1 ) < ulen ) {
              int c = us [p + 1 ] ; 
#             define XfOrM1521_COUNT (0+XfOrM1519_COUNT)
#             define SETUP_XfOrM1521(x) SETUP_XfOrM1519(x)
              if (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#               define XfOrM1524_COUNT (0+XfOrM1521_COUNT)
#               define SETUP_XfOrM1524(x) SETUP_XfOrM1521(x)
                FUNCCALL(SETUP_XfOrM1524(_), regcharclass (c , simple_on ) ); 
                p += 2 ; 
              }
              else if (c < 128 ) {
                simple_on [c ] = 1 ; 
                p += 2 ; 
              }
              else {
                p ++ ; 
              }
            }
            else {
#             define XfOrM1520_COUNT (0+XfOrM1519_COUNT)
#             define SETUP_XfOrM1520(x) SETUP_XfOrM1519(x)
              FUNCCALL(SETUP_XfOrM1520(_), regcomperror ("trailing \\ in pattern" ) ); 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            ; 
          }
          else if (us [p ] > 127 ) {
            int c = us [p ] ; 
#           define XfOrM1511_COUNT (0+XfOrM1504_COUNT)
#           define SETUP_XfOrM1511(x) SETUP_XfOrM1504(x)
            ranges = (__funcarg102 = (__funcarg103 = FUNCCALL(SETUP_XfOrM1511(_), scheme_make_integer_value_from_unsigned (c ) ), __funcarg104 = FUNCCALL(SETUP_XfOrM1511(_), scheme_make_integer_value_from_unsigned (c ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg103 , __funcarg104 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg102 , ranges ) )) ; 
            if (! (parse_flags & 0x1 ) ) {
              int mode , c2 ; 
#             define XfOrM1512_COUNT (0+XfOrM1511_COUNT)
#             define SETUP_XfOrM1512(x) SETUP_XfOrM1511(x)
              for (mode = 0 ; mode < 4 ; mode ++ ) {
#               define XfOrM1516_COUNT (0+XfOrM1512_COUNT)
#               define SETUP_XfOrM1516(x) SETUP_XfOrM1512(x)
                switch (mode ) {
                  case 0 : c2 = (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                  case 1 : c2 = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                  case 2 : c2 = (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                  case 3 : default : c2 = (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                }
                if (c2 != c ) {
#                 define XfOrM1517_COUNT (0+XfOrM1516_COUNT)
#                 define SETUP_XfOrM1517(x) SETUP_XfOrM1516(x)
                  ranges = (__funcarg99 = (__funcarg100 = FUNCCALL(SETUP_XfOrM1517(_), scheme_make_integer_value_from_unsigned (c2 ) ), __funcarg101 = FUNCCALL(SETUP_XfOrM1517(_), scheme_make_integer_value_from_unsigned (c2 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg100 , __funcarg101 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg99 , ranges ) )) ; 
                }
              }
            }
            p ++ ; 
          }
          else if (pcre && (us [p ] == '[' ) && ((p + 1 ) < ulen ) && (us [p + 1 ] == ':' ) && FUNCCALL(SETUP_XfOrM1504(_), is_posix_char_class_in_unicode (us , p + 1 , ulen , simple_on ) )) {
            while (us [p ] != ']' ) {
              p ++ ; 
            }
            p ++ ; 
          }
          else {
#           define XfOrM1505_COUNT (0+XfOrM1504_COUNT)
#           define SETUP_XfOrM1505(x) SETUP_XfOrM1504(x)
            if (((p + 1 ) < ulen ) && (us [p ] == '-' ) ) {
#             define XfOrM1506_COUNT (0+XfOrM1505_COUNT)
#             define SETUP_XfOrM1506(x) SETUP_XfOrM1505(x)
              {
#               define XfOrM1507_COUNT (0+XfOrM1506_COUNT)
#               define SETUP_XfOrM1507(x) SETUP_XfOrM1506(x)
                FUNCCALL(SETUP_XfOrM1507(_), regcomperror ("misplaced hypen within square brackets in pattern" ) ); 
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }
              ; 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            simple_on [us [p ] ] = 1 ; 
            p ++ ; 
          }
        }
        range_len = FUNCCALL(SETUP_XfOrM1404(_), scheme_list_length (ranges ) ); 
        range_array = (unsigned int * ) FUNCCALL(SETUP_XfOrM1404(_), GC_malloc_atomic (2 * range_len * sizeof (unsigned int ) ) ); 
        for (rp = 0 ; ((Scheme_Type ) (((((long ) (ranges ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ranges ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ranges = (((Scheme_Simple_Object * ) (ranges ) ) -> u . pair_val . cdr ) , rp += 2 ) {
          unsigned long hi , lo ; 
#         define XfOrM1442_COUNT (0+XfOrM1404_COUNT)
#         define SETUP_XfOrM1442(x) SETUP_XfOrM1404(x)
          (scheme_get_unsigned_int_val (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (ranges ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) , & lo ) ) ; 
          (scheme_get_unsigned_int_val ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (ranges ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) , & hi ) ) ; 
          range_array [rp ] = (unsigned int ) lo ; 
          range_array [rp + 1 ] = (unsigned int ) hi ; 
        }
        range_len *= 2 ; 
        FUNCCALL(SETUP_XfOrM1404(_), qsort (range_array , range_len >> 1 , 2 * sizeof (unsigned int ) , compare_ranges ) ); 
        for (rp = 0 ; rp < range_len ; rp += 2 ) {
          if (range_array [rp ] < 128 ) {
            for (p = range_array [rp ] ; p < 128 ; p ++ ) {
              simple_on [p ] = 1 ; 
            }
            range_array [rp ] = 128 ; 
          }
        }
        if (! (parse_flags & 0x1 ) ) {
          for (p = 'a' ; p <= 'z' ; p ++ ) {
            if (simple_on [p ] )
              simple_on [(((p >= 'a' ) && (p <= 'z' ) ) ? (p - ('a' - 'A' ) ) : p ) ] = 1 ; 
            if (simple_on [(((p >= 'a' ) && (p <= 'z' ) ) ? (p - ('a' - 'A' ) ) : p ) ] )
              simple_on [p ] = 1 ; 
          }
        }
        on_count = 0 ; 
        for (p = 0 ; p < 128 ; p ++ ) {
          if (simple_on [p ] )
            on_count ++ ; 
        }
        if (not_mode ) {
          unsigned int last_end ; 
          int did_alt ; 
#         define XfOrM1414_COUNT (0+XfOrM1404_COUNT)
#         define SETUP_XfOrM1414(x) SETUP_XfOrM1404(x)
          r = FUNCCALL(SETUP_XfOrM1414(_), make_room (r , j , 6 + (128 - on_count ) + ((pcre && ! simple_on ['\\' ] ) ? 1 : 0 ) , & rs ) ); 
          r [j ++ ] = '(' ; 
          r [j ++ ] = '?' ; 
          r [j ++ ] = ':' ; 
          if (on_count < 128 ) {
            if (! on_count ) {
              r [j ++ ] = '[' ; 
              r [j ++ ] = 0 ; 
              r [j ++ ] = '-' ; 
              r [j ++ ] = 127 ; 
              r [j ++ ] = ']' ; 
            }
            else {
              r [j ++ ] = '[' ; 
              if (! simple_on [']' ] )
                r [j ++ ] = ']' ; 
              for (p = 0 ; p < 128 ; p ++ ) {
                if ((p != '-' ) && (p != ']' ) && (! pcre || (p != '\\' ) ) )
                  if (! simple_on [p ] )
                  r [j ++ ] = p ; 
              }
              if (pcre && ! simple_on ['\\' ] ) {
                r [j ++ ] = '\\' ; 
                r [j ++ ] = '\\' ; 
              }
              if (! simple_on ['-' ] )
                r [j ++ ] = '-' ; 
              r [j ++ ] = ']' ; 
            }
            did_alt = 0 ; 
          }
          else did_alt = 1 ; 
          last_end = 128 ; 
          for (rp = 0 ; rp < range_len ; rp += 2 ) {
#           define XfOrM1420_COUNT (0+XfOrM1414_COUNT)
#           define SETUP_XfOrM1420(x) SETUP_XfOrM1414(x)
            if (range_array [rp ] > last_end ) {
#             define XfOrM1421_COUNT (0+XfOrM1420_COUNT)
#             define SETUP_XfOrM1421(x) SETUP_XfOrM1420(x)
              r = FUNCCALL(SETUP_XfOrM1421(_), add_range (r , & j , & rs , last_end , range_array [rp ] - 1 , did_alt ) ); 
              did_alt = 0 ; 
            }
            if ((range_array [rp + 1 ] + 1 ) > last_end )
              last_end = range_array [rp + 1 ] + 1 ; 
          }
          if (last_end <= 0x10FFFF ) {
#           define XfOrM1415_COUNT (0+XfOrM1414_COUNT)
#           define SETUP_XfOrM1415(x) SETUP_XfOrM1414(x)
            if (last_end < 0xD800 ) {
#             define XfOrM1417_COUNT (0+XfOrM1415_COUNT)
#             define SETUP_XfOrM1417(x) SETUP_XfOrM1415(x)
              r = FUNCCALL(SETUP_XfOrM1417(_), add_range (r , & j , & rs , last_end , 0xD7FF , did_alt ) ); 
              did_alt = 0 ; 
              r = FUNCCALL(SETUP_XfOrM1417(_), add_range (r , & j , & rs , 0xE000 , 0x10FFFF , did_alt ) ); 
            }
            else {
#             define XfOrM1416_COUNT (0+XfOrM1415_COUNT)
#             define SETUP_XfOrM1416(x) SETUP_XfOrM1415(x)
              r = FUNCCALL(SETUP_XfOrM1416(_), add_range (r , & j , & rs , last_end , 0x10FFFF , did_alt ) ); 
              did_alt = 0 ; 
            }
          }
          r = FUNCCALL(SETUP_XfOrM1414(_), make_room (r , j , 1 , & rs ) ); 
          r [j ++ ] = ')' ; 
        }
        else {
          int p , did_alt ; 
#         define XfOrM1405_COUNT (0+XfOrM1404_COUNT)
#         define SETUP_XfOrM1405(x) SETUP_XfOrM1404(x)
          r = FUNCCALL(SETUP_XfOrM1405(_), make_room (r , j , 5 + on_count + ((pcre && simple_on ['\\' ] ) ? 1 : 0 ) , & rs ) ); 
          r [j ++ ] = '(' ; 
          r [j ++ ] = '?' ; 
          r [j ++ ] = ':' ; 
          if (on_count ) {
            if (on_count == 128 ) {
              r [j ++ ] = '[' ; 
              r [j ++ ] = 0 ; 
              r [j ++ ] = '-' ; 
              r [j ++ ] = 127 ; 
              r [j ++ ] = ']' ; 
            }
            else {
              r [j ++ ] = '[' ; 
              if (simple_on [']' ] )
                r [j ++ ] = ']' ; 
              for (p = 0 ; p < 128 ; p ++ ) {
                if ((p != '-' ) && (p != ']' ) && (! pcre || (p != '\\' ) ) )
                  if (simple_on [p ] )
                  r [j ++ ] = p ; 
              }
              if (pcre && simple_on ['\\' ] ) {
                r [j ++ ] = '\\' ; 
                r [j ++ ] = '\\' ; 
              }
              if (simple_on ['-' ] )
                r [j ++ ] = '-' ; 
              r [j ++ ] = ']' ; 
            }
            did_alt = 0 ; 
          }
          else did_alt = 1 ; 
          for (rp = 0 ; rp < range_len ; rp += 2 ) {
#           define XfOrM1407_COUNT (0+XfOrM1405_COUNT)
#           define SETUP_XfOrM1407(x) SETUP_XfOrM1405(x)
            r = FUNCCALL(SETUP_XfOrM1407(_), add_range (r , & j , & rs , range_array [rp ] , range_array [rp + 1 ] , did_alt ) ); 
            did_alt = 0 ; 
          }
          r = FUNCCALL(SETUP_XfOrM1405(_), make_room (r , j , 1 , & rs ) ); 
          r [j ++ ] = ')' ; 
        }
      }
      rs . i = k + 1 ; 
    }
    else if (s [rs . i ] == '\\' ) {
      r [j ++ ] = s [rs . i ++ ] ; 
      if ((rs . i < len ) && (s [rs . i ] > 127 ) ) {
        r [j ++ ] = s [rs . i ++ ] ; 
        while ((rs . i < len ) && ((s [rs . i ] & 0xC0 ) == 0x80 ) ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
      }
      else r [j ++ ] = s [rs . i ++ ] ; 
    }
    else if ((s [rs . i ] == '.' ) && (! pcre || (rs . i < 3 ) || (s [rs . i - 1 ] != '{' ) || ((s [rs . i - 2 ] == 'p' ) && (s [rs . i - 2 ] == 'P' ) ) || (s [rs . i - 3 ] != '\\' ) ) ) {
#     define XfOrM1397_COUNT (0+XfOrM1348_COUNT)
#     define SETUP_XfOrM1397(x) SETUP_XfOrM1348(x)
      r = FUNCCALL(SETUP_XfOrM1397(_), make_room (r , j , (parse_flags & 0x4 ) ? 9 : 8 , & rs ) ); 
      r [j ++ ] = '(' ; 
      r [j ++ ] = '?' ; 
      r [j ++ ] = ':' ; 
      r [j ++ ] = '[' ; 
      r [j ++ ] = '\00' ; 
      r [j ++ ] = '-' ; 
      if (! (parse_flags & 0x4 ) ) {
        r [j ++ ] = '\n' - 1 ; 
        r [j ++ ] = '\n' + 1 ; 
        r [j ++ ] = '-' ; 
      }
      r [j ++ ] = '\177' ; 
      r [j ++ ] = ']' ; 
      r = FUNCCALL(SETUP_XfOrM1397(_), add_range (r , & j , & rs , 128 , 0xD7FF , 0 ) ); 
      r = FUNCCALL_AGAIN(add_range (r , & j , & rs , 0xE000 , 0x10FFFF , 0 ) ); 
      r = FUNCCALL_AGAIN(make_room (r , j , 1 , & rs ) ); 
      r [j ++ ] = ')' ; 
      rs . i ++ ; 
    }
    else if (s [rs . i ] > 127 ) {
      int k = rs . i + 1 ; 
#     define XfOrM1373_COUNT (0+XfOrM1348_COUNT)
#     define SETUP_XfOrM1373(x) SETUP_XfOrM1348(x)
      while ((k < len ) && ((s [k ] & 0xC0 ) == 0x80 ) ) {
        k ++ ; 
      }
      if ((k < len ) && ((s [k ] == '+' ) || (s [k ] == '*' ) || (s [k ] == '?' ) || (! (parse_flags & 0x1 ) && FUNCCALL(SETUP_XfOrM1373(_), need_ci_alternates (s , rs . i , k ) )) ) ) {
        int orig_i ; 
#       define XfOrM1377_COUNT (0+XfOrM1373_COUNT)
#       define SETUP_XfOrM1377(x) SETUP_XfOrM1373(x)
        r = FUNCCALL(SETUP_XfOrM1377(_), make_room (r , j , 4 , & rs ) ); 
        r [j ++ ] = '(' ; 
        r [j ++ ] = '?' ; 
        r [j ++ ] = ':' ; 
        orig_i = rs . i ; 
        while (rs . i < k ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
        if (! (parse_flags & 0x1 ) ) {
          mzchar us [1 ] , c0 , c1 , wrote [4 ] ; 
          int clen , ci , num_wrote = 1 , mode ; 
          unsigned char s2 [6 ] ; 
#         define XfOrM1378_COUNT (0+XfOrM1377_COUNT)
#         define SETUP_XfOrM1378(x) SETUP_XfOrM1377(x)
          FUNCCALL(SETUP_XfOrM1378(_), scheme_utf8_decode (s , orig_i , k , us , 0 , 1 , ((void * ) 0 ) , 0 , 0 ) ); 
          c0 = us [0 ] ; 
          wrote [0 ] = c0 ; 
          for (mode = 0 ; mode < 4 ; mode ++ ) {
#           define XfOrM1386_COUNT (0+XfOrM1378_COUNT)
#           define SETUP_XfOrM1386(x) SETUP_XfOrM1378(x)
            switch (mode ) {
              case 0 : c1 = (c0 + scheme_uchar_folds [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
              case 1 : c1 = (c0 + scheme_uchar_downs [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
              case 2 : c1 = (c0 + scheme_uchar_ups [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
              case 3 : default : c1 = (c0 + scheme_uchar_titles [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
            }
            for (ci = 0 ; ci < num_wrote ; ci ++ ) {
              if (c1 == wrote [ci ] )
                break ; 
            }
            if (ci >= num_wrote ) {
#             define XfOrM1387_COUNT (0+XfOrM1386_COUNT)
#             define SETUP_XfOrM1387(x) SETUP_XfOrM1386(x)
              wrote [num_wrote ++ ] = c1 ; 
              us [0 ] = c1 ; 
              clen = FUNCCALL(SETUP_XfOrM1387(_), scheme_utf8_encode (us , 0 , 1 , s2 , 0 , 0 ) ); 
              r = FUNCCALL_AGAIN(make_room (r , j , clen + 1 , & rs ) ); 
              r [j ++ ] = '|' ; 
              for (ci = 0 ; ci < clen ; ci ++ ) {
                r [j ++ ] = s2 [ci ] ; 
              }
            }
          }
        }
        r [j ++ ] = ')' ; 
      }
      else {
        while (rs . i < k ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
      }
    }
    else {
#     define XfOrM1349_COUNT (0+XfOrM1348_COUNT)
#     define SETUP_XfOrM1349(x) SETUP_XfOrM1348(x)
      if (s [rs . i ] == '(' ) {
        int old_flags = parse_flags ; 
#       define XfOrM1352_COUNT (0+XfOrM1349_COUNT)
#       define SETUP_XfOrM1352(x) SETUP_XfOrM1349(x)
        if ((rs . i + 1 < len ) && (s [rs . i + 1 ] == '?' ) ) {
          int k ; 
          for (k = rs . i + 2 ; k < len ; k ++ ) {
            if ((s [k ] == ':' ) || (s [k ] == '<' ) || (s [k ] == '>' ) || (s [k ] == '=' ) || (s [k ] == '!' ) )
              break ; 
            if (s [k ] == 'i' ) {
              parse_flags &= ~ 0x1 ; 
            }
            else if (s [k ] == 's' ) {
              parse_flags |= 0x4 ; 
            }
            else if (s [k ] == 'm' ) {
              parse_flags &= ~ 0x4 ; 
            }
            else if (s [k ] == '-' ) {
              if (k + 1 < len ) {
                k ++ ; 
                if (s [k ] == 'i' ) {
                  parse_flags |= 0x1 ; 
                }
                else if (s [k ] == 's' ) {
                  parse_flags &= ~ 0x4 ; 
                }
                else if (s [k ] == 'm' ) {
                  parse_flags |= 0x4 ; 
                }
              }
            }
          }
        }
        if (parse_params || (parse_flags != old_flags ) ) {
#         define XfOrM1353_COUNT (0+XfOrM1352_COUNT)
#         define SETUP_XfOrM1353(x) SETUP_XfOrM1352(x)
          parse_params = FUNCCALL(SETUP_XfOrM1353(_), scheme_make_raw_pair (((Scheme_Object * ) (void * ) (long ) ((((long ) (old_flags ) ) << 1 ) | 0x1 ) ) , parse_params ) ); 
        }
      }
      else if (s [rs . i ] == ')' ) {
        if (parse_params ) {
          parse_flags = (((long ) ((((Scheme_Simple_Object * ) (parse_params ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
          parse_params = (((Scheme_Simple_Object * ) (parse_params ) ) -> u . pair_val . cdr ) ; 
        }
      }
      r [j ++ ] = s [rs . i ++ ] ; 
    }
  }
  r [j ] = 0 ; 
  * result = (char * ) r ; 
  RET_VALUE_START (j ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_is_pregexp (Scheme_Object * o ) {
  /* No conversion */
  return ! ! (((regexp * ) o ) -> flags & 0x02 ) ; 
}
static Scheme_Object * do_make_regexp (const char * who , int is_byte , int pcre , int argc , Scheme_Object * argv [] ) {
  Scheme_Object * re , * bs ; 
  char * s ; 
  int slen ; 
  Scheme_Config * __funcarg120 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(bs, 1), PUSH(argv, 2), PUSH(re, 3), PUSH(who, 4)));
# define XfOrM1579_COUNT (5)
# define SETUP_XfOrM1579(x) SETUP(XfOrM1579_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  re = NULLED_OUT ; 
  bs = NULLED_OUT ; 
  s = NULLED_OUT ; 
  if (is_byte ) {
#   define XfOrM1585_COUNT (0+XfOrM1579_COUNT)
#   define SETUP_XfOrM1585(x) SETUP_XfOrM1579(x)
    if (! ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
      FUNCCALL(SETUP_XfOrM1585(_), scheme_wrong_type (who , "byte string" , 0 , argc , argv ) ); 
    bs = argv [0 ] ; 
  }
  else {
#   define XfOrM1584_COUNT (0+XfOrM1579_COUNT)
#   define SETUP_XfOrM1584(x) SETUP_XfOrM1579(x)
    if (! ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL(SETUP_XfOrM1584(_), scheme_wrong_type (who , "string" , 0 , argc , argv ) ); 
    bs = FUNCCALL(SETUP_XfOrM1584(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 
  }
  s = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
  slen = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 
  if (! is_byte ) {
#   define XfOrM1583_COUNT (0+XfOrM1579_COUNT)
#   define SETUP_XfOrM1583(x) SETUP_XfOrM1579(x)
    slen = FUNCCALL(SETUP_XfOrM1583(_), translate ((unsigned char * ) s , slen , & s , pcre ) ); 
  }
  re = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1579(_), regcomp (s , 0 , slen , pcre ) ); 
  if (! is_byte )
    ((regexp * ) re ) -> flags |= 0x01 ; 
  if (pcre )
    ((regexp * ) re ) -> flags |= 0x02 ; 
  if ((((Scheme_Inclhash_Object * ) (argv [0 ] ) ) -> so . keyex & 0x1 ) )
    ((regexp * ) re ) -> source = argv [0 ] ; 
  else if (is_byte ) {
    Scheme_Object * src ; 
    BLOCK_SETUP((PUSH(src, 0+XfOrM1579_COUNT)));
#   define XfOrM1582_COUNT (1+XfOrM1579_COUNT)
#   define SETUP_XfOrM1582(x) SETUP(XfOrM1582_COUNT)
    src = NULLED_OUT ; 
    src = FUNCCALL(SETUP_XfOrM1582(_), scheme_make_immutable_sized_byte_string ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . tag_val ) , 1 ) ); 
    ((regexp * ) re ) -> source = src ; 
  }
  else {
    Scheme_Object * src ; 
    BLOCK_SETUP((PUSH(src, 0+XfOrM1579_COUNT)));
#   define XfOrM1581_COUNT (1+XfOrM1579_COUNT)
#   define SETUP_XfOrM1581(x) SETUP(XfOrM1581_COUNT)
    src = NULLED_OUT ; 
    src = FUNCCALL(SETUP_XfOrM1581(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) , 1 ) ); 
    ((regexp * ) re ) -> source = src ; 
  }
  {
    Scheme_Object * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM1579_COUNT)));
#   define XfOrM1580_COUNT (1+XfOrM1579_COUNT)
#   define SETUP_XfOrM1580(x) SETUP(XfOrM1580_COUNT)
    b = NULLED_OUT ; 
    b = (__funcarg120 = FUNCCALL(SETUP_XfOrM1580(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg120 , MZCONFIG_USE_JIT ) )) ; 
    if ((! (((b ) ) == (scheme_false ) ) ) )
      ((regexp * ) re ) -> flags |= 0x10 ; 
  }
  RET_VALUE_START (re ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * make_regexp (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return do_make_regexp ("byte-regexp" , 1 , 0 , argc , argv ) ; 
}
static Scheme_Object * make_utf8_regexp (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return do_make_regexp ("regexp" , 0 , 0 , argc , argv ) ; 
}
static Scheme_Object * make_pregexp (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return do_make_regexp ("byte-pregexp" , 1 , 1 , argc , argv ) ; 
}
static Scheme_Object * make_utf8_pregexp (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return do_make_regexp ("pregexp" , 0 , 1 , argc , argv ) ; 
}
Scheme_Object * scheme_make_regexp (Scheme_Object * str , int is_byte , int pcre , int * volatile result_is_err_string ) {
  mz_jmp_buf * volatile save , newbuf ; 
  Scheme_Object * volatile result ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(save, 0), PUSH(str, 1), PUSH(result, 2), PUSH(result_is_err_string, 3)));
# define XfOrM1590_COUNT (4)
# define SETUP_XfOrM1590(x) SETUP(XfOrM1590_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  save = NULLED_OUT ; 
  result = NULLED_OUT ; 
  * result_is_err_string = 0 ; 
  save = scheme_current_thread -> error_buf ; 
  scheme_current_thread -> error_buf = & newbuf ; 
  failure_msg_for_read = "yes" ; 
  if (! ((newbuf ) . gcvs = (long ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = (long ) (__gc_var_stack__ [1 ] ) , (scheme_jit_setjmp_prepare ((newbuf ) . jb ) , (_setjmp (((newbuf ) . jb ) -> jb ) ) ) ) ) {
#   define XfOrM1592_COUNT (0+XfOrM1590_COUNT)
#   define SETUP_XfOrM1592(x) SETUP_XfOrM1590(x)
    if (is_byte ) {
#     define XfOrM1594_COUNT (0+XfOrM1592_COUNT)
#     define SETUP_XfOrM1594(x) SETUP_XfOrM1592(x)
      if (pcre )
        result = FUNCCALL(SETUP_XfOrM1594(_), make_pregexp (1 , & str ) ); 
      else result = FUNCCALL(SETUP_XfOrM1594(_), make_regexp (1 , & str ) ); 
    }
    else {
#     define XfOrM1593_COUNT (0+XfOrM1592_COUNT)
#     define SETUP_XfOrM1593(x) SETUP_XfOrM1592(x)
      if (pcre )
        result = FUNCCALL(SETUP_XfOrM1593(_), make_utf8_pregexp (1 , & str ) ); 
      else result = FUNCCALL(SETUP_XfOrM1593(_), make_utf8_regexp (1 , & str ) ); 
    }
  }
  else {
    result = (Scheme_Object * ) failure_msg_for_read ; 
    * result_is_err_string = 1 ; 
  }
  failure_msg_for_read = ((void * ) 0 ) ; 
  scheme_current_thread -> error_buf = save ; 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static regexp * regcomp_object (Scheme_Object * str ) {
  DECL_RET_SAVE (regexp * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(str, 0)));
# define XfOrM1595_COUNT (1)
# define SETUP_XfOrM1595(x) SETUP(XfOrM1595_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  if (((Scheme_Type ) (((((long ) (str ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (str ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
    RET_VALUE_START ((regexp * ) FUNCCALL(SETUP_XfOrM1595(_), make_regexp (1 , & str ) )) RET_VALUE_END ; 
  else RET_VALUE_START ((regexp * ) FUNCCALL(SETUP_XfOrM1595(_), make_utf8_regexp (1 , & str ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_clear_rx_buffers (void ) {
  /* No conversion */
  startp_buffer_cache = ((void * ) 0 ) ; 
  endp_buffer_cache = ((void * ) 0 ) ; 
  maybep_buffer_cache = ((void * ) 0 ) ; 
}
static Scheme_Object * gen_compare (char * name , int pos , int argc , Scheme_Object * argv [] , int peek , int nonblock ) {
  regexp * r ; 
  char * full_s ; 
  rxpos * startp , * maybep , * endp ; 
  int offset = 0 , orig_offset , endset , m , was_non_byte ; 
  Scheme_Object * iport , * oport = ((void * ) 0 ) , * startv = ((void * ) 0 ) , * endv = ((void * ) 0 ) , * dropped , * unless_evt = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg122 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(17);
  BLOCK_SETUP_TOP((PUSH(unless_evt, 0), PUSH(endp, 1), PUSH(argv, 2), PUSH(oport, 3), PUSH(startv, 4), PUSH(r, 5), PUSH(startp, 6), PUSH(name, 7), PUSH(full_s, 8), PUSH(dropped, 9), PUSH(iport, 10), PUSH(maybep, 11), PUSH(endv, 12)));
# define XfOrM1597_COUNT (13)
# define SETUP_XfOrM1597(x) SETUP(XfOrM1597_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 
  full_s = NULLED_OUT ; 
  startp = NULLED_OUT ; 
  maybep = NULLED_OUT ; 
  endp = NULLED_OUT ; 
  iport = NULLED_OUT ; 
  dropped = NULLED_OUT ; 
  if (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) != scheme_regexp_type && ! ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && ! ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL(SETUP_XfOrM1597(_), scheme_wrong_type (name , "regexp, byte-regexp, string, or byte string" , 0 , argc , argv ) ); 
  if ((peek || (! ((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && ! ((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) ) && ! (scheme_is_input_port (argv [1 ] ) ) )
    FUNCCALL(SETUP_XfOrM1597(_), scheme_wrong_type (name , peek ? "input-port" : "string, byte string, or input port" , 1 , argc , argv ) ); 
  if (((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
    iport = ((void * ) 0 ) ; 
    endset = (((Scheme_Simple_Object * ) (argv [1 ] ) ) -> u . char_str_val . tag_val ) ; 
  }
  else if ((scheme_is_input_port (argv [1 ] ) ) ) {
    iport = argv [1 ] ; 
    endset = - 2 ; 
  }
  else {
    iport = ((void * ) 0 ) ; 
    endset = (((Scheme_Simple_Object * ) (argv [1 ] ) ) -> u . byte_str_val . tag_val ) ; 
  }
  if (argc > 2 ) {
    int len = endset ; 
#   define XfOrM1627_COUNT (0+XfOrM1597_COUNT)
#   define SETUP_XfOrM1627(x) SETUP_XfOrM1597(x)
    offset = FUNCCALL(SETUP_XfOrM1627(_), scheme_extract_index (name , 2 , argc , argv , len + 1 , 0 ) ); 
    if (! iport && (offset > len ) ) {
#     define XfOrM1643_COUNT (0+XfOrM1627_COUNT)
#     define SETUP_XfOrM1643(x) SETUP_XfOrM1627(x)
      FUNCCALL(SETUP_XfOrM1643(_), scheme_out_of_string_range (name , "offset " , argv [2 ] , argv [1 ] , 0 , len ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    else if (offset < 0 ) {
      offset = 0x7FFFFFFF ; 
    }
    startv = argv [2 ] ; 
    if (argc > 3 ) {
#     define XfOrM1628_COUNT (0+XfOrM1627_COUNT)
#     define SETUP_XfOrM1628(x) SETUP_XfOrM1627(x)
      if (! (((argv [3 ] ) ) == (scheme_false ) ) ) {
#       define XfOrM1637_COUNT (0+XfOrM1628_COUNT)
#       define SETUP_XfOrM1637(x) SETUP_XfOrM1628(x)
        endset = FUNCCALL(SETUP_XfOrM1637(_), scheme_extract_index (name , 3 , argc , argv , len + 1 , 1 ) ); 
        if (iport ) {
#         define XfOrM1639_COUNT (0+XfOrM1637_COUNT)
#         define SETUP_XfOrM1639(x) SETUP_XfOrM1637(x)
          if (endset < 0 ) {
            endset = 0x7FFFFFFF ; 
          }
          if (FUNCCALL(SETUP_XfOrM1639(_), scheme_bin_lt (argv [3 ] , argv [2 ] ) )) {
#           define XfOrM1640_COUNT (0+XfOrM1639_COUNT)
#           define SETUP_XfOrM1640(x) SETUP_XfOrM1639(x)
            FUNCCALL(SETUP_XfOrM1640(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: ending index %V is smaller than starting index %V for port" , name , argv [3 ] , argv [2 ] ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }
        else if (endset < offset || endset > len ) {
#         define XfOrM1638_COUNT (0+XfOrM1637_COUNT)
#         define SETUP_XfOrM1638(x) SETUP_XfOrM1637(x)
          FUNCCALL(SETUP_XfOrM1638(_), scheme_out_of_string_range (name , "ending " , argv [3 ] , argv [1 ] , offset , len ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        endv = argv [3 ] ; 
      }
      if (argc > 4 ) {
#       define XfOrM1629_COUNT (0+XfOrM1628_COUNT)
#       define SETUP_XfOrM1629(x) SETUP_XfOrM1628(x)
        if (peek ) {
#         define XfOrM1632_COUNT (0+XfOrM1629_COUNT)
#         define SETUP_XfOrM1632(x) SETUP_XfOrM1629(x)
          if (! (((argv [4 ] ) ) == (scheme_false ) ) ) {
#           define XfOrM1633_COUNT (0+XfOrM1632_COUNT)
#           define SETUP_XfOrM1633(x) SETUP_XfOrM1632(x)
            unless_evt = argv [4 ] ; 
            if (! ((Scheme_Type ) (((((long ) (unless_evt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (unless_evt ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) ) {
#             define XfOrM1636_COUNT (0+XfOrM1633_COUNT)
#             define SETUP_XfOrM1636(x) SETUP_XfOrM1633(x)
              FUNCCALL(SETUP_XfOrM1636(_), scheme_wrong_type (name , "progress evt or #f" , 4 , argc , argv ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            if (! iport ) {
#             define XfOrM1635_COUNT (0+XfOrM1633_COUNT)
#             define SETUP_XfOrM1635(x) SETUP_XfOrM1633(x)
              FUNCCALL(SETUP_XfOrM1635(_), scheme_arg_mismatch (name , "progress evt cannot be used with string input: " , unless_evt ) ); 
            }
            else if (! ((iport ) == ((((Scheme_Simple_Object * ) (unless_evt ) ) -> u . two_ptr_val . ptr1 ) ) ) ) {
#             define XfOrM1634_COUNT (0+XfOrM1633_COUNT)
#             define SETUP_XfOrM1634(x) SETUP_XfOrM1633(x)
              FUNCCALL(SETUP_XfOrM1634(_), scheme_arg_mismatch (name , "evt is not a progress evt for the given port:" , unless_evt ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }
        }
        else {
#         define XfOrM1630_COUNT (0+XfOrM1629_COUNT)
#         define SETUP_XfOrM1630(x) SETUP_XfOrM1629(x)
          if ((! (((argv [4 ] ) ) == (scheme_false ) ) ) ) {
#           define XfOrM1631_COUNT (0+XfOrM1630_COUNT)
#           define SETUP_XfOrM1631(x) SETUP_XfOrM1630(x)
            if (! (scheme_is_output_port (argv [4 ] ) ) )
              FUNCCALL(SETUP_XfOrM1631(_), scheme_wrong_type (name , "output port or #f" , 4 , argc , argv ) ); 
            oport = argv [4 ] ; 
          }
        }
      }
    }
  }
  if (iport && ! startv )
    startv = ((Scheme_Object * ) (void * ) (long ) ((((long ) (0 ) ) << 1 ) | 0x1 ) ) ; 
  if (((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    r = FUNCCALL(SETUP_XfOrM1597(_), regcomp_object (argv [0 ] ) ); 
  else r = (regexp * ) argv [0 ] ; 
  was_non_byte = 0 ; 
  orig_offset = 0 ; 
  if (! iport ) {
#   define XfOrM1624_COUNT (0+XfOrM1597_COUNT)
#   define SETUP_XfOrM1624(x) SETUP_XfOrM1597(x)
    if (((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
      full_s = (((Scheme_Simple_Object * ) (argv [1 ] ) ) -> u . byte_str_val . string_val ) ; 
    else {
      int blen ; 
#     define XfOrM1625_COUNT (0+XfOrM1624_COUNT)
#     define SETUP_XfOrM1625(x) SETUP_XfOrM1624(x)
      blen = FUNCCALL(SETUP_XfOrM1625(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (argv [1 ] ) ) -> u . char_str_val . string_val ) , offset , endset , ((void * ) 0 ) , 0 , 0 ) ); 
      full_s = (char * ) FUNCCALL(SETUP_XfOrM1625(_), GC_malloc_atomic (blen ) ); 
      FUNCCALL(SETUP_XfOrM1625(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (argv [1 ] ) ) -> u . char_str_val . string_val ) , offset , endset , (unsigned char * ) full_s , 0 , 0 ) ); 
      orig_offset = offset ; 
      offset = 0 ; 
      endset = blen ; 
      if (r -> flags & 0x01 )
        was_non_byte = 1 ; 
      else {
#       define XfOrM1626_COUNT (0+XfOrM1625_COUNT)
#       define SETUP_XfOrM1626(x) SETUP_XfOrM1625(x)
        orig_offset = FUNCCALL(SETUP_XfOrM1626(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (argv [1 ] ) ) -> u . char_str_val . string_val ) , 0 , orig_offset , ((void * ) 0 ) , 0 , 0 ) ); 
      }
    }
  }
  else full_s = ((void * ) 0 ) ; 
  if (startp_buffer_cache && (r -> nsubexp <= rx_buffer_size ) ) {
    startp = startp_buffer_cache ; 
    maybep = maybep_buffer_cache ; 
    endp = endp_buffer_cache ; 
    startp_buffer_cache = ((void * ) 0 ) ; 
  }
  else {
#   define XfOrM1622_COUNT (0+XfOrM1597_COUNT)
#   define SETUP_XfOrM1622(x) SETUP_XfOrM1597(x)
    startp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1622(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
    maybep = ((void * ) 0 ) ; 
    endp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1622(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  }
  if ((r -> nsubexp > 1 ) && ! maybep )
    maybep = ((rxpos * ) FUNCCALL(SETUP_XfOrM1597(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  dropped = ((Scheme_Object * ) (void * ) (long ) ((((long ) (0 ) ) << 1 ) | 0x1 ) ) ; 
  m = FUNCCALL(SETUP_XfOrM1597(_), regexec (name , r , full_s , offset , endset - offset , startp , maybep , endp , iport , unless_evt , nonblock , & full_s , peek , pos , oport , startv , endv , & dropped ) ); 
  if (m ) {
    int i ; 
    Scheme_Object * l = scheme_null , * rs ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM1597_COUNT), PUSH(l, 1+XfOrM1597_COUNT)));
#   define XfOrM1601_COUNT (2+XfOrM1597_COUNT)
#   define SETUP_XfOrM1601(x) SETUP(XfOrM1601_COUNT)
    rs = NULLED_OUT ; 
    if (oport && ! iport )
      FUNCCALL(SETUP_XfOrM1601(_), scheme_put_byte_string (name , oport , full_s , 0 , * startp , 0 ) ); 
    if (pos > 1 ) {
      dropped = scheme_true ; 
    }
    else {
#     define XfOrM1602_COUNT (0+XfOrM1601_COUNT)
#     define SETUP_XfOrM1602(x) SETUP_XfOrM1601(x)
      for (i = r -> nsubexp ; i -- ; ) {
#       define XfOrM1612_COUNT (0+XfOrM1602_COUNT)
#       define SETUP_XfOrM1612(x) SETUP_XfOrM1602(x)
        if (startp [i ] != - 1 ) {
#         define XfOrM1613_COUNT (0+XfOrM1612_COUNT)
#         define SETUP_XfOrM1613(x) SETUP_XfOrM1612(x)
          if (pos ) {
            Scheme_Object * startpd , * endpd ; 
            BLOCK_SETUP((PUSH(endpd, 0+XfOrM1613_COUNT), PUSH(startpd, 1+XfOrM1613_COUNT)));
#           define XfOrM1617_COUNT (2+XfOrM1613_COUNT)
#           define SETUP_XfOrM1617(x) SETUP(XfOrM1617_COUNT)
            startpd = NULLED_OUT ; 
            endpd = NULLED_OUT ; 
            if (was_non_byte ) {
              int uspd , uepd ; 
#             define XfOrM1620_COUNT (0+XfOrM1617_COUNT)
#             define SETUP_XfOrM1620(x) SETUP_XfOrM1617(x)
              uspd = FUNCCALL(SETUP_XfOrM1620(_), scheme_utf8_decode ((const unsigned char * ) full_s , offset , startp [i ] , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) ); 
              uspd += orig_offset ; 
              startpd = ((Scheme_Object * ) (void * ) (long ) ((((long ) (uspd ) ) << 1 ) | 0x1 ) ) ; 
              uepd = FUNCCALL(SETUP_XfOrM1620(_), scheme_utf8_decode ((const unsigned char * ) full_s , startp [i ] , endp [i ] , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) ); 
              uepd += uspd ; 
              endpd = ((Scheme_Object * ) (void * ) (long ) ((((long ) (uepd ) ) << 1 ) | 0x1 ) ) ; 
            }
            else {
              int v ; 
#             define XfOrM1618_COUNT (0+XfOrM1617_COUNT)
#             define SETUP_XfOrM1618(x) SETUP_XfOrM1617(x)
              v = startp [i ] + orig_offset ; 
              startpd = ((Scheme_Object * ) (void * ) (long ) ((((long ) (v ) ) << 1 ) | 0x1 ) ) ; 
              v = endp [i ] + orig_offset ; 
              endpd = ((Scheme_Object * ) (void * ) (long ) ((((long ) (v ) ) << 1 ) | 0x1 ) ) ; 
              if (iport ) {
#               define XfOrM1619_COUNT (0+XfOrM1618_COUNT)
#               define SETUP_XfOrM1619(x) SETUP_XfOrM1618(x)
                startpd = FUNCCALL(SETUP_XfOrM1619(_), scheme_bin_plus (startpd , dropped ) ); 
                endpd = FUNCCALL(SETUP_XfOrM1619(_), scheme_bin_plus (endpd , dropped ) ); 
              }
            }
            l = (__funcarg122 = FUNCCALL(SETUP_XfOrM1617(_), scheme_make_pair (startpd , endpd ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg122 , l ) )) ; 
          }
          else {
            long len ; 
#           define XfOrM1614_COUNT (0+XfOrM1613_COUNT)
#           define SETUP_XfOrM1614(x) SETUP_XfOrM1613(x)
            len = endp [i ] - startp [i ] ; 
            if (was_non_byte ) {
#             define XfOrM1616_COUNT (0+XfOrM1614_COUNT)
#             define SETUP_XfOrM1616(x) SETUP_XfOrM1614(x)
              rs = FUNCCALL(SETUP_XfOrM1616(_), scheme_make_sized_offset_utf8_string (full_s , startp [i ] , len ) ); 
            }
            else {
#             define XfOrM1615_COUNT (0+XfOrM1614_COUNT)
#             define SETUP_XfOrM1615(x) SETUP_XfOrM1614(x)
              rs = FUNCCALL(SETUP_XfOrM1615(_), scheme_make_sized_offset_byte_string (full_s , startp [i ] , len , 1 ) ); 
            }
            l = FUNCCALL(SETUP_XfOrM1614(_), scheme_make_pair (rs , l ) ); 
          }
        }
        else l = FUNCCALL(SETUP_XfOrM1612(_), scheme_make_pair (scheme_false , l ) ); 
      }
      dropped = l ; 
    }
  }
  else {
#   define XfOrM1600_COUNT (0+XfOrM1597_COUNT)
#   define SETUP_XfOrM1600(x) SETUP_XfOrM1597(x)
    if (oport && ! iport )
      FUNCCALL(SETUP_XfOrM1600(_), scheme_put_byte_string (name , oport , full_s , 0 , endset , 0 ) ); 
    dropped = scheme_false ; 
  }
  if (! startp_buffer_cache || (r -> nsubexp > rx_buffer_size ) ) {
    rx_buffer_size = r -> nsubexp ; 
    startp_buffer_cache = startp ; 
    maybep_buffer_cache = maybep ; 
    endp_buffer_cache = endp ; 
  }
  else if (maybep && ! maybep_buffer_cache && (r -> nsubexp == rx_buffer_size ) ) {
    maybep_buffer_cache = maybep ; 
  }
  RET_VALUE_START (dropped ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * compare (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match" , 0 , argc , argv , 0 , 0 ) ; 
}
static Scheme_Object * positions (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match-positions" , 1 , argc , argv , 0 , 0 ) ; 
}
static Scheme_Object * compare_bool (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match?" , 2 , argc , argv , 0 , 0 ) ; 
}
static Scheme_Object * compare_peek (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match-peek" , 0 , argc , argv , 1 , 0 ) ; 
}
static Scheme_Object * positions_peek (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match-peek-positions" , 1 , argc , argv , 1 , 0 ) ; 
}
static Scheme_Object * compare_peek_nonblock (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match-peek-immediate" , 0 , argc , argv , 1 , 1 ) ; 
}
static Scheme_Object * positions_peek_nonblock (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_compare ("regexp-match-peek-positions-immediate" , 1 , argc , argv , 1 , 1 ) ; 
}
static char * build_call_name (const char * n ) {
  char * m ; 
  int l ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(n, 1)));
# define XfOrM1654_COUNT (2)
# define SETUP_XfOrM1654(x) SETUP(XfOrM1654_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 
  l = strlen (n ) ; 
  m = (char * ) FUNCCALL(SETUP_XfOrM1654(_), GC_malloc_atomic (l + 42 ) ); 
  (memcpy (m , n , l ) ) ; 
  (strcpy (m XFORM_OK_PLUS l , " (calling given filter procedure)" ) ) ; 
  RET_VALUE_START (m ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int initial_char_len (unsigned char * source , long start , long end ) {
  /* No conversion */
  long i ; 
  for (i = start + 1 ; i <= end ; i ++ ) {
    if (scheme_utf8_decode_count (source , start , i , ((void * ) 0 ) , 1 , 1 ) ) {
      return i - start ; 
    }
  }
  return 1 ; 
}
/* this far 5444 */
/* this far 5418 */
/* this far 5444 */
/* this far 5418 */
static Scheme_Object * gen_replace (const char * name , int argc , Scheme_Object * argv [] , int all ) {
  Scheme_Object * orig ; 
  regexp * r ; 
  char * source , * prefix = ((void * ) 0 ) , * deststr ; 
  rxpos * startp , * maybep , * endp ; 
  int prefix_len = 0 , sourcelen , srcoffset = 0 , was_non_byte , destlen ; 
  char * __funcarg126 = NULLED_OUT ; 
  char * __funcarg125 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(endp, 0), PUSH(r, 1), PUSH(name, 2), PUSH(source, 3), PUSH(prefix, 4), PUSH(startp, 5), PUSH(deststr, 6), PUSH(orig, 7), PUSH(argv, 8), PUSH(maybep, 9)));
# define XfOrM1660_COUNT (10)
# define SETUP_XfOrM1660(x) SETUP(XfOrM1660_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  orig = NULLED_OUT ; 
  r = NULLED_OUT ; 
  source = NULLED_OUT ; 
  deststr = NULLED_OUT ; 
  startp = NULLED_OUT ; 
  maybep = NULLED_OUT ; 
  endp = NULLED_OUT ; 
  if (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) != scheme_regexp_type && ! ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && ! ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_type (name , "regexp, byte-regexp, string, or byte string" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && ! ((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_type (name , "string or byte string" , 1 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((long ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && ! ((Scheme_Type ) (((((long ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) && ! (! (((long ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_native_closure_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_type (name , "string, byte string, or procedure" , 2 , argc , argv ) ); 
  if (((Scheme_Type ) (((((long ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ) {
#   define XfOrM1745_COUNT (0+XfOrM1660_COUNT)
#   define SETUP_XfOrM1745(x) SETUP_XfOrM1660(x)
    if (((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) && (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) ) {
#     define XfOrM1746_COUNT (0+XfOrM1745_COUNT)
#     define SETUP_XfOrM1746(x) SETUP_XfOrM1745(x)
      if (((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
#       define XfOrM1747_COUNT (0+XfOrM1746_COUNT)
#       define SETUP_XfOrM1747(x) SETUP_XfOrM1746(x)
        FUNCCALL(SETUP_XfOrM1747(_), scheme_arg_mismatch (name , "cannot replace a string with a byte string: " , argv [2 ] ) ); 
      }
    }
  }
  if (((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    r = FUNCCALL(SETUP_XfOrM1660(_), regcomp_object (argv [0 ] ) ); 
  else r = (regexp * ) argv [0 ] ; 
  if ((! (((long ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_native_closure_type ) ) ) ) {
#   define XfOrM1743_COUNT (0+XfOrM1660_COUNT)
#   define SETUP_XfOrM1743(x) SETUP_XfOrM1660(x)
    if (! FUNCCALL(SETUP_XfOrM1743(_), scheme_check_proc_arity (((void * ) 0 ) , r -> nsubexp , 2 , argc , argv ) )) {
#     define XfOrM1744_COUNT (0+XfOrM1743_COUNT)
#     define SETUP_XfOrM1744(x) SETUP_XfOrM1743(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: regexp produces %d matches: %V; procedure does not accept %d arguments: %V" , name , r -> nsubexp , (Scheme_Object * ) r , r -> nsubexp , argv [2 ] ) ); 
    }
  }
  if (((Scheme_Type ) (((((long ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
#   define XfOrM1742_COUNT (0+XfOrM1660_COUNT)
#   define SETUP_XfOrM1742(x) SETUP_XfOrM1660(x)
    orig = FUNCCALL(SETUP_XfOrM1742(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    if (r -> flags & 0x01 )
      was_non_byte = 1 ; 
    else was_non_byte = 0 ; 
  }
  else {
    orig = argv [1 ] ; 
    was_non_byte = 0 ; 
  }
  source = (((Scheme_Simple_Object * ) (orig ) ) -> u . byte_str_val . string_val ) ; 
  sourcelen = (((Scheme_Simple_Object * ) (orig ) ) -> u . byte_str_val . tag_val ) ; 
  deststr = ((void * ) 0 ) ; 
  destlen = 0 ; 
  startp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1660(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  if (r -> nsubexp > 1 )
    maybep = ((rxpos * ) FUNCCALL(SETUP_XfOrM1660(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  else maybep = ((void * ) 0 ) ; 
  endp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1660(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  while (1 ) {
    int m ; 
#   define XfOrM1701_COUNT (0+XfOrM1660_COUNT)
#   define SETUP_XfOrM1701(x) SETUP_XfOrM1660(x)
    do {
#     define XfOrM1737_COUNT (0+XfOrM1701_COUNT)
#     define SETUP_XfOrM1737(x) SETUP_XfOrM1701(x)
      m = FUNCCALL(SETUP_XfOrM1737(_), regexec (name , r , source , srcoffset , sourcelen - srcoffset , startp , maybep , endp , ((void * ) 0 ) , ((void * ) 0 ) , 0 , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      if (m && all && (startp [0 ] == endp [0 ] ) ) {
#       define XfOrM1738_COUNT (0+XfOrM1737_COUNT)
#       define SETUP_XfOrM1738(x) SETUP_XfOrM1737(x)
        if (! startp [0 ] && sourcelen ) {
          int amt ; 
#         define XfOrM1740_COUNT (0+XfOrM1738_COUNT)
#         define SETUP_XfOrM1740(x) SETUP_XfOrM1738(x)
          if (was_non_byte )
            amt = FUNCCALL(SETUP_XfOrM1740(_), initial_char_len ((unsigned char * ) source , 0 , sourcelen ) ); 
          else amt = 1 ; 
          prefix = FUNCCALL(SETUP_XfOrM1740(_), GC_malloc_atomic (amt + 1 ) ); 
          prefix_len = amt ; 
          (memcpy (prefix , source , amt ) ) ; 
          srcoffset += amt ; 
        }
        else {
          if (startp [0 ] == sourcelen )
            m = 0 ; 
          break ; 
        }
      }
      else break ; 
    }
    while (1 ) ; 
    if (m ) {
      char * insert ; 
      long len , end , startpd , endpd ; 
      BLOCK_SETUP((PUSH(insert, 0+XfOrM1701_COUNT)));
#     define XfOrM1706_COUNT (1+XfOrM1701_COUNT)
#     define SETUP_XfOrM1706(x) SETUP(XfOrM1706_COUNT)
      insert = NULLED_OUT ; 
      if ((! (((long ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_native_closure_type ) ) ) ) {
        int i ; 
        Scheme_Object * m , * * args , * quick_args [5 ] ; 
        BLOCK_SETUP((PUSH(args, 0+XfOrM1706_COUNT), PUSH(m, 1+XfOrM1706_COUNT), PUSHARRAY(quick_args, 5, 2+XfOrM1706_COUNT)));
#       define XfOrM1716_COUNT (5+XfOrM1706_COUNT)
#       define SETUP_XfOrM1716(x) SETUP(XfOrM1716_COUNT)
        m = NULLED_OUT ; 
        args = NULLED_OUT ; 
        NULL_OUT_ARRAY (quick_args ) ; 
        if (r -> nsubexp <= 5 ) {
          args = quick_args ; 
        }
        else {
#         define XfOrM1731_COUNT (0+XfOrM1716_COUNT)
#         define SETUP_XfOrM1731(x) SETUP_XfOrM1716(x)
          args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1731(_), GC_malloc (sizeof (Scheme_Object * ) * (r -> nsubexp ) ) )) ; 
        }
        for (i = r -> nsubexp ; i -- ; ) {
#         define XfOrM1726_COUNT (0+XfOrM1716_COUNT)
#         define SETUP_XfOrM1726(x) SETUP_XfOrM1716(x)
          if (startp [i ] == - 1 ) {
            args [i ] = scheme_false ; 
          }
          else {
            long len ; 
#           define XfOrM1727_COUNT (0+XfOrM1726_COUNT)
#           define SETUP_XfOrM1727(x) SETUP_XfOrM1726(x)
            len = endp [i ] - startp [i ] ; 
            if (was_non_byte ) {
#             define XfOrM1729_COUNT (0+XfOrM1727_COUNT)
#             define SETUP_XfOrM1729(x) SETUP_XfOrM1727(x)
              m = FUNCCALL(SETUP_XfOrM1729(_), scheme_make_sized_offset_utf8_string (source , startp [i ] , len ) ); 
              args [i ] = m ; 
            }
            else {
#             define XfOrM1728_COUNT (0+XfOrM1727_COUNT)
#             define SETUP_XfOrM1728(x) SETUP_XfOrM1727(x)
              m = FUNCCALL(SETUP_XfOrM1728(_), scheme_make_sized_offset_byte_string (source , startp [i ] , len , 1 ) ); 
              args [i ] = m ; 
            }
          }
        }
        m = FUNCCALL(SETUP_XfOrM1716(_), scheme_do_eval (argv [2 ] , r -> nsubexp , args , 1 ) ); 
        if (! was_non_byte ) {
#         define XfOrM1719_COUNT (0+XfOrM1716_COUNT)
#         define SETUP_XfOrM1719(x) SETUP_XfOrM1716(x)
          if (! ((Scheme_Type ) (((((long ) (m ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (m ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ) {
#           define XfOrM1720_COUNT (0+XfOrM1719_COUNT)
#           define SETUP_XfOrM1720(x) SETUP_XfOrM1719(x)
            args [0 ] = m ; 
            (__funcarg126 = FUNCCALL(SETUP_XfOrM1720(_), build_call_name (name ) ), FUNCCALL_AGAIN(scheme_wrong_type (__funcarg126 , "byte string" , - 1 , - 1 , args ) )) ; 
          }
          insert = (((Scheme_Simple_Object * ) (m ) ) -> u . byte_str_val . string_val ) ; 
          len = (((Scheme_Simple_Object * ) (m ) ) -> u . byte_str_val . tag_val ) ; 
        }
        else {
#         define XfOrM1717_COUNT (0+XfOrM1716_COUNT)
#         define SETUP_XfOrM1717(x) SETUP_XfOrM1716(x)
          if (! ((Scheme_Type ) (((((long ) (m ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (m ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
#           define XfOrM1718_COUNT (0+XfOrM1717_COUNT)
#           define SETUP_XfOrM1718(x) SETUP_XfOrM1717(x)
            args [0 ] = m ; 
            (__funcarg125 = FUNCCALL(SETUP_XfOrM1718(_), build_call_name (name ) ), FUNCCALL_AGAIN(scheme_wrong_type (__funcarg125 , "string" , - 1 , - 1 , args ) )) ; 
          }
          len = FUNCCALL(SETUP_XfOrM1717(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . tag_val ) , ((void * ) 0 ) , 0 , 0 ) ); 
          insert = (char * ) FUNCCALL(SETUP_XfOrM1717(_), GC_malloc_atomic (len ) ); 
          FUNCCALL(SETUP_XfOrM1717(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . tag_val ) , (unsigned char * ) insert , 0 , 0 ) ); 
        }
      }
      else {
#       define XfOrM1712_COUNT (0+XfOrM1706_COUNT)
#       define SETUP_XfOrM1712(x) SETUP_XfOrM1706(x)
        if (! deststr ) {
#         define XfOrM1713_COUNT (0+XfOrM1712_COUNT)
#         define SETUP_XfOrM1713(x) SETUP_XfOrM1712(x)
          if (((Scheme_Type ) (((((long ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
            Scheme_Object * bs ; 
            BLOCK_SETUP((PUSH(bs, 0+XfOrM1713_COUNT)));
#           define XfOrM1715_COUNT (1+XfOrM1713_COUNT)
#           define SETUP_XfOrM1715(x) SETUP(XfOrM1715_COUNT)
            bs = NULLED_OUT ; 
            bs = FUNCCALL(SETUP_XfOrM1715(_), scheme_char_string_to_byte_string (argv [2 ] ) ); 
            deststr = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
            destlen = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 
          }
          else {
            deststr = (((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . byte_str_val . string_val ) ; 
            destlen = (((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . byte_str_val . tag_val ) ; 
          }
        }
        insert = FUNCCALL(SETUP_XfOrM1712(_), regsub (r , deststr , destlen , & len , source , startp , endp ) ); 
      }
      end = sourcelen ; 
      startpd = startp [0 ] ; 
      endpd = endp [0 ] ; 
      if (! startpd && (endpd == end ) && ! prefix ) {
#       define XfOrM1711_COUNT (0+XfOrM1706_COUNT)
#       define SETUP_XfOrM1711(x) SETUP_XfOrM1706(x)
        if (was_non_byte )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (insert , len ) )) RET_VALUE_EMPTY_END ; 
        else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (insert , len , 0 ) )) RET_VALUE_EMPTY_END ; 
      }
      else if (! all ) {
        char * result ; 
        long total ; 
        BLOCK_SETUP((PUSH(result, 0+XfOrM1706_COUNT)));
#       define XfOrM1710_COUNT (1+XfOrM1706_COUNT)
#       define SETUP_XfOrM1710(x) SETUP(XfOrM1710_COUNT)
        result = NULLED_OUT ; 
        total = len + (startpd - srcoffset ) + (end - endpd ) ; 
        result = (char * ) FUNCCALL(SETUP_XfOrM1710(_), GC_malloc_atomic (total + 1 ) ); 
        (memcpy (result , source + srcoffset , startpd - srcoffset ) ) ; 
        (memcpy (result + (startpd - srcoffset ) , insert , len ) ) ; 
        (memcpy (result + (startpd - srcoffset ) + len , source + endpd , (end - endpd ) + 1 ) ) ; 
        if (was_non_byte )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (result , total ) )) RET_VALUE_EMPTY_END ; 
        else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (result , total , 0 ) )) RET_VALUE_EMPTY_END ; 
      }
      else {
        char * naya ; 
        long total ; 
        int more ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM1706_COUNT)));
#       define XfOrM1707_COUNT (1+XfOrM1706_COUNT)
#       define SETUP_XfOrM1707(x) SETUP(XfOrM1707_COUNT)
        naya = NULLED_OUT ; 
        if (startpd == endpd ) {
#         define XfOrM1709_COUNT (0+XfOrM1707_COUNT)
#         define SETUP_XfOrM1709(x) SETUP_XfOrM1707(x)
          if (was_non_byte )
            more = FUNCCALL(SETUP_XfOrM1709(_), initial_char_len ((unsigned char * ) source , startpd , sourcelen ) ); 
          else more = 1 ; 
        }
        else more = 0 ; 
        total = len + prefix_len + (startpd - srcoffset ) ; 
        naya = (char * ) FUNCCALL(SETUP_XfOrM1707(_), GC_malloc_atomic (total + more + 1 ) ); 
        (memcpy (naya , prefix , prefix_len ) ) ; 
        (memcpy (naya + prefix_len , source + srcoffset , startpd - srcoffset ) ) ; 
        (memcpy (naya + prefix_len + (startpd - srcoffset ) , insert , len ) ) ; 
        if (more ) {
#         define XfOrM1708_COUNT (0+XfOrM1707_COUNT)
#         define SETUP_XfOrM1708(x) SETUP_XfOrM1707(x)
          (memcpy (naya + prefix_len + (endpd - srcoffset ) + len , source + startpd , more ) ) ; 
          total += more ; 
        }
        prefix = naya ; 
        prefix_len = total ; 
        srcoffset = endpd + more ; 
      }
    }
    else if (! prefix ) {
      if (was_non_byte )
        RET_VALUE_START (argv [1 ] ) RET_VALUE_END ; 
      else RET_VALUE_START (orig ) RET_VALUE_END ; 
    }
    else {
      char * result ; 
      long total , slen ; 
      BLOCK_SETUP((PUSH(result, 0+XfOrM1701_COUNT)));
#     define XfOrM1704_COUNT (1+XfOrM1701_COUNT)
#     define SETUP_XfOrM1704(x) SETUP(XfOrM1704_COUNT)
      result = NULLED_OUT ; 
      slen = sourcelen - srcoffset ; 
      total = prefix_len + slen ; 
      result = (char * ) FUNCCALL(SETUP_XfOrM1704(_), GC_malloc_atomic (total + 1 ) ); 
      (memcpy (result , prefix , prefix_len ) ) ; 
      (memcpy (result + prefix_len , source + srcoffset , slen ) ) ; 
      result [prefix_len + slen ] = 0 ; 
      if (was_non_byte )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (result , total ) )) RET_VALUE_EMPTY_END ; 
      else RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (result , total , 0 ) )) RET_VALUE_EMPTY_END ; 
    }
    {
#     define XfOrM1702_COUNT (0+XfOrM1701_COUNT)
#     define SETUP_XfOrM1702(x) SETUP_XfOrM1701(x)
      if ((scheme_fuel_counter ) <= 0 ) {
#       define XfOrM1703_COUNT (0+XfOrM1702_COUNT)
#       define SETUP_XfOrM1703(x) SETUP_XfOrM1702(x)
        FUNCCALL(SETUP_XfOrM1703(_), scheme_out_of_fuel () ); 
      }
    }
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * replace (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_replace ("regexp-replace" , argc , argv , 0 ) ; 
}
static Scheme_Object * replace_star (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return gen_replace ("regexp-replace*" , argc , argv , 1 ) ; 
}
static Scheme_Object * regexp_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (((((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) && (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * byte_regexp_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (((((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) && ! (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * pregexp_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (((((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) && (((regexp * ) argv [0 ] ) -> flags & 0x01 ) && (((regexp * ) argv [0 ] ) -> flags & 0x02 ) ) ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * byte_pregexp_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */
  return (((((((long ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) && ! (((regexp * ) argv [0 ] ) -> flags & 0x01 ) && (((regexp * ) argv [0 ] ) -> flags & 0x02 ) ) ? scheme_true : scheme_false ) ; 
}
Scheme_Object * scheme_regexp_source (Scheme_Object * re ) {
  /* No conversion */
  return ((regexp * ) re ) -> source ; 
}
int scheme_regexp_is_byte (Scheme_Object * re ) {
  /* No conversion */
  return ! (((regexp * ) re ) -> flags & 0x01 ) ; 
}
static int mark_regexp_SIZE (void * p ) {
  regexp * r = (regexp * ) p ; 
  return (((sizeof (regexp ) + r -> regsize ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_regexp_MARK (void * p ) {
  regexp * r = (regexp * ) p ; 
  GC_mark (r -> source ) ; 
  GC_mark (r -> regstart ) ; 
  return (((sizeof (regexp ) + r -> regsize ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_regexp_FIXUP (void * p ) {
  regexp * r = (regexp * ) p ; 
  GC_fixup (& (r -> source ) ) ; 
  GC_fixup (& (r -> regstart ) ) ; 
  return (((sizeof (regexp ) + r -> regsize ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_regwork_SIZE (void * p ) {
  return ((sizeof (Regwork ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_regwork_MARK (void * p ) {
  Regwork * r = (Regwork * ) p ; 
  GC_mark (r -> str ) ; 
  GC_mark (r -> instr ) ; 
  GC_mark (r -> port ) ; 
  GC_mark (r -> unless_evt ) ; 
  GC_mark (r -> startp ) ; 
  GC_mark (r -> maybep ) ; 
  GC_mark (r -> endp ) ; 
  GC_mark (r -> counters ) ; 
  GC_mark (r -> peekskip ) ; 
  return ((sizeof (Regwork ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
static int mark_regwork_FIXUP (void * p ) {
  Regwork * r = (Regwork * ) p ; 
  GC_fixup (& (r -> str ) ) ; 
  GC_fixup (& (r -> instr ) ) ; 
  GC_fixup (& (r -> port ) ) ; 
  GC_fixup (& (r -> unless_evt ) ) ; 
  GC_fixup (& (r -> startp ) ) ; 
  GC_fixup (& (r -> maybep ) ) ; 
  GC_fixup (& (r -> endp ) ) ; 
  GC_fixup (& (r -> counters ) ) ; 
  GC_fixup (& (r -> peekskip ) ) ; 
  return ((sizeof (Regwork ) + (1 << 3 ) - 1 ) >> 3 ) ; 
}
void scheme_regexp_initialize (Scheme_Env * env ) {
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 
  Scheme_Object * __funcarg141 = NULLED_OUT ; 
  Scheme_Object * __funcarg140 = NULLED_OUT ; 
  Scheme_Object * __funcarg139 = NULLED_OUT ; 
  Scheme_Object * __funcarg138 = NULLED_OUT ; 
  Scheme_Object * __funcarg137 = NULLED_OUT ; 
  Scheme_Object * __funcarg136 = NULLED_OUT ; 
  Scheme_Object * __funcarg135 = NULLED_OUT ; 
  Scheme_Object * __funcarg134 = NULLED_OUT ; 
  Scheme_Object * __funcarg133 = NULLED_OUT ; 
  Scheme_Object * __funcarg132 = NULLED_OUT ; 
  Scheme_Object * __funcarg131 = NULLED_OUT ; 
  Scheme_Object * __funcarg130 = NULLED_OUT ; 
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  Scheme_Object * __funcarg128 = NULLED_OUT ; 
  Scheme_Object * __funcarg127 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM1756_COUNT (1)
# define SETUP_XfOrM1756(x) SETUP(XfOrM1756_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1756(_), GC_register_traversers (scheme_regexp_type , mark_regexp_SIZE , mark_regexp_MARK , mark_regexp_FIXUP , 0 , 0 ) ); 
  FUNCCALL(SETUP_XfOrM1756(_), GC_register_traversers (scheme_rt_regwork , mark_regwork_SIZE , mark_regwork_MARK , mark_regwork_FIXUP , 1 , 0 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & regparsestr , sizeof (regparsestr ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & regstr , sizeof (regstr ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & regbackknown , sizeof (regbackknown ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & regbackdepends , sizeof (regbackdepends ) ) ); 
  (__funcarg143 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (make_regexp , "byte-regexp" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("byte-regexp" , __funcarg143 , env ) )) ; 
  (__funcarg142 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (make_utf8_regexp , "regexp" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp" , __funcarg142 , env ) )) ; 
  (__funcarg141 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (make_pregexp , "byte-pregexp" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("byte-pregexp" , __funcarg141 , env ) )) ; 
  (__funcarg140 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (make_utf8_pregexp , "pregexp" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("pregexp" , __funcarg140 , env ) )) ; 
  (__funcarg139 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (compare , "regexp-match" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match" , __funcarg139 , env ) )) ; 
  (__funcarg138 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (positions , "regexp-match-positions" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match-positions" , __funcarg138 , env ) )) ; 
  (__funcarg137 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (compare_bool , "regexp-match?" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match?" , __funcarg137 , env ) )) ; 
  (__funcarg136 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (compare_peek , "regexp-match-peek" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match-peek" , __funcarg136 , env ) )) ; 
  (__funcarg135 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (positions_peek , "regexp-match-peek-positions" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match-peek-positions" , __funcarg135 , env ) )) ; 
  (__funcarg134 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (compare_peek_nonblock , "regexp-match-peek-immediate" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match-peek-immediate" , __funcarg134 , env ) )) ; 
  (__funcarg133 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (positions_peek_nonblock , "regexp-match-peek-positions-immediate" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-match-peek-positions-immediate" , __funcarg133 , env ) )) ; 
  (__funcarg132 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (replace , "regexp-replace" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-replace" , __funcarg132 , env ) )) ; 
  (__funcarg131 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_prim_w_arity (replace_star , "regexp-replace*" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp-replace*" , __funcarg131 , env ) )) ; 
  (__funcarg130 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_folding_prim (regexp_p , "regexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("regexp?" , __funcarg130 , env ) )) ; 
  (__funcarg129 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_folding_prim (byte_regexp_p , "byte-regexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("byte-regexp?" , __funcarg129 , env ) )) ; 
  (__funcarg128 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_folding_prim (pregexp_p , "pregexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("pregexp?" , __funcarg128 , env ) )) ; 
  (__funcarg127 = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_folding_prim (byte_pregexp_p , "byte-pregexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_add_global_constant ("byte-pregexp?" , __funcarg127 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
